Dagaz.Controller.persistense = "none";
Dagaz.Controller.UNDO_ONCE   = true;
Dagaz.Model.NO_SOUND         = true;

Dagaz.Model.WIDTH  = 12;
Dagaz.Model.HEIGHT = 8;

ZRF = {
    JUMP:          0,
    IF:            1,
    FORK:          2,
    FUNCTION:      3,
    IN_ZONE:       4,
    FLAG:          5,
    SET_FLAG:      6,
    POS_FLAG:      7,
    SET_POS_FLAG:  8,
    ATTR:          9,
    SET_ATTR:      10,
    PROMOTE:       11,
    MODE:          12,
    ON_BOARD_DIR:  13,
    ON_BOARD_POS:  14,
    PARAM:         15,
    LITERAL:       16,
    VERIFY:        20
};

Dagaz.Model.BuildDesign = function(design) {
    design.checkVersion("z2j", "2");
    design.checkVersion("animate-drops", "false");
    design.checkVersion("animate-captures", "false");
    design.checkVersion("show-blink", "false");
    design.checkVersion("progressive-levels", "true");
    design.checkVersion("animate-redo", "false");

    design.addDirection("s"); // 0
    design.addDirection("e"); // 1
    design.addDirection("w"); // 2
    design.addDirection("n"); // 3

    design.addPlayer("You", [3, 2, 1, 0]);

    design.addPosition("a8a", [12, 1, 0, 0]);
    design.addPosition("b8a", [12, 1, -1, 0]);
    design.addPosition("c8a", [12, 1, -1, 0]);
    design.addPosition("d8a", [12, 1, -1, 0]);
    design.addPosition("e8a", [12, 1, -1, 0]);
    design.addPosition("f8a", [12, 1, -1, 0]);
    design.addPosition("g8a", [12, 1, -1, 0]);
    design.addPosition("h8a", [12, 1, -1, 0]);
    design.addPosition("i8a", [12, 1, -1, 0]);
    design.addPosition("j8a", [12, 1, -1, 0]);
    design.addPosition("k8a", [12, 1, -1, 0]);
    design.addPosition("l8a", [12, 0, -1, 0]);
    design.addPosition("a7a", [12, 1, 0, -12]);
    design.addPosition("b7a", [12, 1, -1, -12]);
    design.addPosition("c7a", [12, 1, -1, -12]);
    design.addPosition("d7a", [12, 1, -1, -12]);
    design.addPosition("e7a", [12, 1, -1, -12]);
    design.addPosition("f7a", [12, 1, -1, -12]);
    design.addPosition("g7a", [12, 1, -1, -12]);
    design.addPosition("h7a", [12, 1, -1, -12]);
    design.addPosition("i7a", [12, 1, -1, -12]);
    design.addPosition("j7a", [12, 1, -1, -12]);
    design.addPosition("k7a", [12, 1, -1, -12]);
    design.addPosition("l7a", [12, 0, -1, -12]);
    design.addPosition("a6a", [12, 1, 0, -12]);
    design.addPosition("b6a", [12, 1, -1, -12]);
    design.addPosition("c6a", [12, 1, -1, -12]);
    design.addPosition("d6a", [12, 1, -1, -12]);
    design.addPosition("e6a", [12, 1, -1, -12]);
    design.addPosition("f6a", [12, 1, -1, -12]);
    design.addPosition("g6a", [12, 1, -1, -12]);
    design.addPosition("h6a", [12, 1, -1, -12]);
    design.addPosition("i6a", [12, 1, -1, -12]);
    design.addPosition("j6a", [12, 1, -1, -12]);
    design.addPosition("k6a", [12, 1, -1, -12]);
    design.addPosition("l6a", [12, 0, -1, -12]);
    design.addPosition("a5a", [12, 1, 0, -12]);
    design.addPosition("b5a", [12, 1, -1, -12]);
    design.addPosition("c5a", [12, 1, -1, -12]);
    design.addPosition("d5a", [12, 1, -1, -12]);
    design.addPosition("e5a", [12, 1, -1, -12]);
    design.addPosition("f5a", [12, 1, -1, -12]);
    design.addPosition("g5a", [12, 1, -1, -12]);
    design.addPosition("h5a", [12, 1, -1, -12]);
    design.addPosition("i5a", [12, 1, -1, -12]);
    design.addPosition("j5a", [12, 1, -1, -12]);
    design.addPosition("k5a", [12, 1, -1, -12]);
    design.addPosition("l5a", [12, 0, -1, -12]);
    design.addPosition("a4a", [12, 1, 0, -12]);
    design.addPosition("b4a", [12, 1, -1, -12]);
    design.addPosition("c4a", [12, 1, -1, -12]);
    design.addPosition("d4a", [12, 1, -1, -12]);
    design.addPosition("e4a", [12, 1, -1, -12]);
    design.addPosition("f4a", [12, 1, -1, -12]);
    design.addPosition("g4a", [12, 1, -1, -12]);
    design.addPosition("h4a", [12, 1, -1, -12]);
    design.addPosition("i4a", [12, 1, -1, -12]);
    design.addPosition("j4a", [12, 1, -1, -12]);
    design.addPosition("k4a", [12, 1, -1, -12]);
    design.addPosition("l4a", [12, 0, -1, -12]);
    design.addPosition("a3a", [12, 1, 0, -12]);
    design.addPosition("b3a", [12, 1, -1, -12]);
    design.addPosition("c3a", [12, 1, -1, -12]);
    design.addPosition("d3a", [12, 1, -1, -12]);
    design.addPosition("e3a", [12, 1, -1, -12]);
    design.addPosition("f3a", [12, 1, -1, -12]);
    design.addPosition("g3a", [12, 1, -1, -12]);
    design.addPosition("h3a", [12, 1, -1, -12]);
    design.addPosition("i3a", [12, 1, -1, -12]);
    design.addPosition("j3a", [12, 1, -1, -12]);
    design.addPosition("k3a", [12, 1, -1, -12]);
    design.addPosition("l3a", [12, 0, -1, -12]);
    design.addPosition("a2a", [12, 1, 0, -12]);
    design.addPosition("b2a", [12, 1, -1, -12]);
    design.addPosition("c2a", [12, 1, -1, -12]);
    design.addPosition("d2a", [12, 1, -1, -12]);
    design.addPosition("e2a", [12, 1, -1, -12]);
    design.addPosition("f2a", [12, 1, -1, -12]);
    design.addPosition("g2a", [12, 1, -1, -12]);
    design.addPosition("h2a", [12, 1, -1, -12]);
    design.addPosition("i2a", [12, 1, -1, -12]);
    design.addPosition("j2a", [12, 1, -1, -12]);
    design.addPosition("k2a", [12, 1, -1, -12]);
    design.addPosition("l2a", [12, 0, -1, -12]);
    design.addPosition("a1a", [0, 1, 0, -12]);
    design.addPosition("b1a", [0, 1, -1, -12]);
    design.addPosition("c1a", [0, 1, -1, -12]);
    design.addPosition("d1a", [0, 1, -1, -12]);
    design.addPosition("e1a", [0, 1, -1, -12]);
    design.addPosition("f1a", [0, 1, -1, -12]);
    design.addPosition("g1a", [0, 1, -1, -12]);
    design.addPosition("h1a", [0, 1, -1, -12]);
    design.addPosition("i1a", [0, 1, -1, -12]);
    design.addPosition("j1a", [0, 1, -1, -12]);
    design.addPosition("k1a", [0, 1, -1, -12]);
    design.addPosition("l1a", [0, 0, -1, -12]);
    design.addPosition("a8b", [12, 1, 0, 0]);
    design.addPosition("b8b", [12, 1, -1, 0]);
    design.addPosition("c8b", [12, 1, -1, 0]);
    design.addPosition("d8b", [12, 1, -1, 0]);
    design.addPosition("e8b", [12, 1, -1, 0]);
    design.addPosition("f8b", [12, 1, -1, 0]);
    design.addPosition("g8b", [12, 1, -1, 0]);
    design.addPosition("h8b", [12, 1, -1, 0]);
    design.addPosition("i8b", [12, 1, -1, 0]);
    design.addPosition("j8b", [12, 1, -1, 0]);
    design.addPosition("k8b", [12, 1, -1, 0]);
    design.addPosition("l8b", [12, 0, -1, 0]);
    design.addPosition("a7b", [12, 1, 0, -12]);
    design.addPosition("b7b", [12, 1, -1, -12]);
    design.addPosition("c7b", [12, 1, -1, -12]);
    design.addPosition("d7b", [12, 1, -1, -12]);
    design.addPosition("e7b", [12, 1, -1, -12]);
    design.addPosition("f7b", [12, 1, -1, -12]);
    design.addPosition("g7b", [12, 1, -1, -12]);
    design.addPosition("h7b", [12, 1, -1, -12]);
    design.addPosition("i7b", [12, 1, -1, -12]);
    design.addPosition("j7b", [12, 1, -1, -12]);
    design.addPosition("k7b", [12, 1, -1, -12]);
    design.addPosition("l7b", [12, 0, -1, -12]);
    design.addPosition("a6b", [12, 1, 0, -12]);
    design.addPosition("b6b", [12, 1, -1, -12]);
    design.addPosition("c6b", [12, 1, -1, -12]);
    design.addPosition("d6b", [12, 1, -1, -12]);
    design.addPosition("e6b", [12, 1, -1, -12]);
    design.addPosition("f6b", [12, 1, -1, -12]);
    design.addPosition("g6b", [12, 1, -1, -12]);
    design.addPosition("h6b", [12, 1, -1, -12]);
    design.addPosition("i6b", [12, 1, -1, -12]);
    design.addPosition("j6b", [12, 1, -1, -12]);
    design.addPosition("k6b", [12, 1, -1, -12]);
    design.addPosition("l6b", [12, 0, -1, -12]);
    design.addPosition("a5b", [12, 1, 0, -12]);
    design.addPosition("b5b", [12, 1, -1, -12]);
    design.addPosition("c5b", [12, 1, -1, -12]);
    design.addPosition("d5b", [12, 1, -1, -12]);
    design.addPosition("e5b", [12, 1, -1, -12]);
    design.addPosition("f5b", [12, 1, -1, -12]);
    design.addPosition("g5b", [12, 1, -1, -12]);
    design.addPosition("h5b", [12, 1, -1, -12]);
    design.addPosition("i5b", [12, 1, -1, -12]);
    design.addPosition("j5b", [12, 1, -1, -12]);
    design.addPosition("k5b", [12, 1, -1, -12]);
    design.addPosition("l5b", [12, 0, -1, -12]);
    design.addPosition("a4b", [12, 1, 0, -12]);
    design.addPosition("b4b", [12, 1, -1, -12]);
    design.addPosition("c4b", [12, 1, -1, -12]);
    design.addPosition("d4b", [12, 1, -1, -12]);
    design.addPosition("e4b", [12, 1, -1, -12]);
    design.addPosition("f4b", [12, 1, -1, -12]);
    design.addPosition("g4b", [12, 1, -1, -12]);
    design.addPosition("h4b", [12, 1, -1, -12]);
    design.addPosition("i4b", [12, 1, -1, -12]);
    design.addPosition("j4b", [12, 1, -1, -12]);
    design.addPosition("k4b", [12, 1, -1, -12]);
    design.addPosition("l4b", [12, 0, -1, -12]);
    design.addPosition("a3b", [12, 1, 0, -12]);
    design.addPosition("b3b", [12, 1, -1, -12]);
    design.addPosition("c3b", [12, 1, -1, -12]);
    design.addPosition("d3b", [12, 1, -1, -12]);
    design.addPosition("e3b", [12, 1, -1, -12]);
    design.addPosition("f3b", [12, 1, -1, -12]);
    design.addPosition("g3b", [12, 1, -1, -12]);
    design.addPosition("h3b", [12, 1, -1, -12]);
    design.addPosition("i3b", [12, 1, -1, -12]);
    design.addPosition("j3b", [12, 1, -1, -12]);
    design.addPosition("k3b", [12, 1, -1, -12]);
    design.addPosition("l3b", [12, 0, -1, -12]);
    design.addPosition("a2b", [12, 1, 0, -12]);
    design.addPosition("b2b", [12, 1, -1, -12]);
    design.addPosition("c2b", [12, 1, -1, -12]);
    design.addPosition("d2b", [12, 1, -1, -12]);
    design.addPosition("e2b", [12, 1, -1, -12]);
    design.addPosition("f2b", [12, 1, -1, -12]);
    design.addPosition("g2b", [12, 1, -1, -12]);
    design.addPosition("h2b", [12, 1, -1, -12]);
    design.addPosition("i2b", [12, 1, -1, -12]);
    design.addPosition("j2b", [12, 1, -1, -12]);
    design.addPosition("k2b", [12, 1, -1, -12]);
    design.addPosition("l2b", [12, 0, -1, -12]);
    design.addPosition("a1b", [0, 1, 0, -12]);
    design.addPosition("b1b", [0, 1, -1, -12]);
    design.addPosition("c1b", [0, 1, -1, -12]);
    design.addPosition("d1b", [0, 1, -1, -12]);
    design.addPosition("e1b", [0, 1, -1, -12]);
    design.addPosition("f1b", [0, 1, -1, -12]);
    design.addPosition("g1b", [0, 1, -1, -12]);
    design.addPosition("h1b", [0, 1, -1, -12]);
    design.addPosition("i1b", [0, 1, -1, -12]);
    design.addPosition("j1b", [0, 1, -1, -12]);
    design.addPosition("k1b", [0, 1, -1, -12]);
    design.addPosition("l1b", [0, 0, -1, -12]);
    design.addPosition("a8c", [12, 1, 0, 0]);
    design.addPosition("b8c", [12, 1, -1, 0]);
    design.addPosition("c8c", [12, 1, -1, 0]);
    design.addPosition("d8c", [12, 1, -1, 0]);
    design.addPosition("e8c", [12, 1, -1, 0]);
    design.addPosition("f8c", [12, 1, -1, 0]);
    design.addPosition("g8c", [12, 1, -1, 0]);
    design.addPosition("h8c", [12, 1, -1, 0]);
    design.addPosition("i8c", [12, 1, -1, 0]);
    design.addPosition("j8c", [12, 1, -1, 0]);
    design.addPosition("k8c", [12, 1, -1, 0]);
    design.addPosition("l8c", [12, 0, -1, 0]);
    design.addPosition("a7c", [12, 1, 0, -12]);
    design.addPosition("b7c", [12, 1, -1, -12]);
    design.addPosition("c7c", [12, 1, -1, -12]);
    design.addPosition("d7c", [12, 1, -1, -12]);
    design.addPosition("e7c", [12, 1, -1, -12]);
    design.addPosition("f7c", [12, 1, -1, -12]);
    design.addPosition("g7c", [12, 1, -1, -12]);
    design.addPosition("h7c", [12, 1, -1, -12]);
    design.addPosition("i7c", [12, 1, -1, -12]);
    design.addPosition("j7c", [12, 1, -1, -12]);
    design.addPosition("k7c", [12, 1, -1, -12]);
    design.addPosition("l7c", [12, 0, -1, -12]);
    design.addPosition("a6c", [12, 1, 0, -12]);
    design.addPosition("b6c", [12, 1, -1, -12]);
    design.addPosition("c6c", [12, 1, -1, -12]);
    design.addPosition("d6c", [12, 1, -1, -12]);
    design.addPosition("e6c", [12, 1, -1, -12]);
    design.addPosition("f6c", [12, 1, -1, -12]);
    design.addPosition("g6c", [12, 1, -1, -12]);
    design.addPosition("h6c", [12, 1, -1, -12]);
    design.addPosition("i6c", [12, 1, -1, -12]);
    design.addPosition("j6c", [12, 1, -1, -12]);
    design.addPosition("k6c", [12, 1, -1, -12]);
    design.addPosition("l6c", [12, 0, -1, -12]);
    design.addPosition("a5c", [12, 1, 0, -12]);
    design.addPosition("b5c", [12, 1, -1, -12]);
    design.addPosition("c5c", [12, 1, -1, -12]);
    design.addPosition("d5c", [12, 1, -1, -12]);
    design.addPosition("e5c", [12, 1, -1, -12]);
    design.addPosition("f5c", [12, 1, -1, -12]);
    design.addPosition("g5c", [12, 1, -1, -12]);
    design.addPosition("h5c", [12, 1, -1, -12]);
    design.addPosition("i5c", [12, 1, -1, -12]);
    design.addPosition("j5c", [12, 1, -1, -12]);
    design.addPosition("k5c", [12, 1, -1, -12]);
    design.addPosition("l5c", [12, 0, -1, -12]);
    design.addPosition("a4c", [12, 1, 0, -12]);
    design.addPosition("b4c", [12, 1, -1, -12]);
    design.addPosition("c4c", [12, 1, -1, -12]);
    design.addPosition("d4c", [12, 1, -1, -12]);
    design.addPosition("e4c", [12, 1, -1, -12]);
    design.addPosition("f4c", [12, 1, -1, -12]);
    design.addPosition("g4c", [12, 1, -1, -12]);
    design.addPosition("h4c", [12, 1, -1, -12]);
    design.addPosition("i4c", [12, 1, -1, -12]);
    design.addPosition("j4c", [12, 1, -1, -12]);
    design.addPosition("k4c", [12, 1, -1, -12]);
    design.addPosition("l4c", [12, 0, -1, -12]);
    design.addPosition("a3c", [12, 1, 0, -12]);
    design.addPosition("b3c", [12, 1, -1, -12]);
    design.addPosition("c3c", [12, 1, -1, -12]);
    design.addPosition("d3c", [12, 1, -1, -12]);
    design.addPosition("e3c", [12, 1, -1, -12]);
    design.addPosition("f3c", [12, 1, -1, -12]);
    design.addPosition("g3c", [12, 1, -1, -12]);
    design.addPosition("h3c", [12, 1, -1, -12]);
    design.addPosition("i3c", [12, 1, -1, -12]);
    design.addPosition("j3c", [12, 1, -1, -12]);
    design.addPosition("k3c", [12, 1, -1, -12]);
    design.addPosition("l3c", [12, 0, -1, -12]);
    design.addPosition("a2c", [12, 1, 0, -12]);
    design.addPosition("b2c", [12, 1, -1, -12]);
    design.addPosition("c2c", [12, 1, -1, -12]);
    design.addPosition("d2c", [12, 1, -1, -12]);
    design.addPosition("e2c", [12, 1, -1, -12]);
    design.addPosition("f2c", [12, 1, -1, -12]);
    design.addPosition("g2c", [12, 1, -1, -12]);
    design.addPosition("h2c", [12, 1, -1, -12]);
    design.addPosition("i2c", [12, 1, -1, -12]);
    design.addPosition("j2c", [12, 1, -1, -12]);
    design.addPosition("k2c", [12, 1, -1, -12]);
    design.addPosition("l2c", [12, 0, -1, -12]);
    design.addPosition("a1c", [0, 1, 0, -12]);
    design.addPosition("b1c", [0, 1, -1, -12]);
    design.addPosition("c1c", [0, 1, -1, -12]);
    design.addPosition("d1c", [0, 1, -1, -12]);
    design.addPosition("e1c", [0, 1, -1, -12]);
    design.addPosition("f1c", [0, 1, -1, -12]);
    design.addPosition("g1c", [0, 1, -1, -12]);
    design.addPosition("h1c", [0, 1, -1, -12]);
    design.addPosition("i1c", [0, 1, -1, -12]);
    design.addPosition("j1c", [0, 1, -1, -12]);
    design.addPosition("k1c", [0, 1, -1, -12]);
    design.addPosition("l1c", [0, 0, -1, -12]);
    design.addPosition("a8d", [12, 1, 0, 0]);
    design.addPosition("b8d", [12, 1, -1, 0]);
    design.addPosition("c8d", [12, 1, -1, 0]);
    design.addPosition("d8d", [12, 1, -1, 0]);
    design.addPosition("e8d", [12, 1, -1, 0]);
    design.addPosition("f8d", [12, 1, -1, 0]);
    design.addPosition("g8d", [12, 1, -1, 0]);
    design.addPosition("h8d", [12, 1, -1, 0]);
    design.addPosition("i8d", [12, 1, -1, 0]);
    design.addPosition("j8d", [12, 1, -1, 0]);
    design.addPosition("k8d", [12, 1, -1, 0]);
    design.addPosition("l8d", [12, 0, -1, 0]);
    design.addPosition("a7d", [12, 1, 0, -12]);
    design.addPosition("b7d", [12, 1, -1, -12]);
    design.addPosition("c7d", [12, 1, -1, -12]);
    design.addPosition("d7d", [12, 1, -1, -12]);
    design.addPosition("e7d", [12, 1, -1, -12]);
    design.addPosition("f7d", [12, 1, -1, -12]);
    design.addPosition("g7d", [12, 1, -1, -12]);
    design.addPosition("h7d", [12, 1, -1, -12]);
    design.addPosition("i7d", [12, 1, -1, -12]);
    design.addPosition("j7d", [12, 1, -1, -12]);
    design.addPosition("k7d", [12, 1, -1, -12]);
    design.addPosition("l7d", [12, 0, -1, -12]);
    design.addPosition("a6d", [12, 1, 0, -12]);
    design.addPosition("b6d", [12, 1, -1, -12]);
    design.addPosition("c6d", [12, 1, -1, -12]);
    design.addPosition("d6d", [12, 1, -1, -12]);
    design.addPosition("e6d", [12, 1, -1, -12]);
    design.addPosition("f6d", [12, 1, -1, -12]);
    design.addPosition("g6d", [12, 1, -1, -12]);
    design.addPosition("h6d", [12, 1, -1, -12]);
    design.addPosition("i6d", [12, 1, -1, -12]);
    design.addPosition("j6d", [12, 1, -1, -12]);
    design.addPosition("k6d", [12, 1, -1, -12]);
    design.addPosition("l6d", [12, 0, -1, -12]);
    design.addPosition("a5d", [12, 1, 0, -12]);
    design.addPosition("b5d", [12, 1, -1, -12]);
    design.addPosition("c5d", [12, 1, -1, -12]);
    design.addPosition("d5d", [12, 1, -1, -12]);
    design.addPosition("e5d", [12, 1, -1, -12]);
    design.addPosition("f5d", [12, 1, -1, -12]);
    design.addPosition("g5d", [12, 1, -1, -12]);
    design.addPosition("h5d", [12, 1, -1, -12]);
    design.addPosition("i5d", [12, 1, -1, -12]);
    design.addPosition("j5d", [12, 1, -1, -12]);
    design.addPosition("k5d", [12, 1, -1, -12]);
    design.addPosition("l5d", [12, 0, -1, -12]);
    design.addPosition("a4d", [12, 1, 0, -12]);
    design.addPosition("b4d", [12, 1, -1, -12]);
    design.addPosition("c4d", [12, 1, -1, -12]);
    design.addPosition("d4d", [12, 1, -1, -12]);
    design.addPosition("e4d", [12, 1, -1, -12]);
    design.addPosition("f4d", [12, 1, -1, -12]);
    design.addPosition("g4d", [12, 1, -1, -12]);
    design.addPosition("h4d", [12, 1, -1, -12]);
    design.addPosition("i4d", [12, 1, -1, -12]);
    design.addPosition("j4d", [12, 1, -1, -12]);
    design.addPosition("k4d", [12, 1, -1, -12]);
    design.addPosition("l4d", [12, 0, -1, -12]);
    design.addPosition("a3d", [12, 1, 0, -12]);
    design.addPosition("b3d", [12, 1, -1, -12]);
    design.addPosition("c3d", [12, 1, -1, -12]);
    design.addPosition("d3d", [12, 1, -1, -12]);
    design.addPosition("e3d", [12, 1, -1, -12]);
    design.addPosition("f3d", [12, 1, -1, -12]);
    design.addPosition("g3d", [12, 1, -1, -12]);
    design.addPosition("h3d", [12, 1, -1, -12]);
    design.addPosition("i3d", [12, 1, -1, -12]);
    design.addPosition("j3d", [12, 1, -1, -12]);
    design.addPosition("k3d", [12, 1, -1, -12]);
    design.addPosition("l3d", [12, 0, -1, -12]);
    design.addPosition("a2d", [12, 1, 0, -12]);
    design.addPosition("b2d", [12, 1, -1, -12]);
    design.addPosition("c2d", [12, 1, -1, -12]);
    design.addPosition("d2d", [12, 1, -1, -12]);
    design.addPosition("e2d", [12, 1, -1, -12]);
    design.addPosition("f2d", [12, 1, -1, -12]);
    design.addPosition("g2d", [12, 1, -1, -12]);
    design.addPosition("h2d", [12, 1, -1, -12]);
    design.addPosition("i2d", [12, 1, -1, -12]);
    design.addPosition("j2d", [12, 1, -1, -12]);
    design.addPosition("k2d", [12, 1, -1, -12]);
    design.addPosition("l2d", [12, 0, -1, -12]);
    design.addPosition("a1d", [0, 1, 0, -12]);
    design.addPosition("b1d", [0, 1, -1, -12]);
    design.addPosition("c1d", [0, 1, -1, -12]);
    design.addPosition("d1d", [0, 1, -1, -12]);
    design.addPosition("e1d", [0, 1, -1, -12]);
    design.addPosition("f1d", [0, 1, -1, -12]);
    design.addPosition("g1d", [0, 1, -1, -12]);
    design.addPosition("h1d", [0, 1, -1, -12]);
    design.addPosition("i1d", [0, 1, -1, -12]);
    design.addPosition("j1d", [0, 1, -1, -12]);
    design.addPosition("k1d", [0, 1, -1, -12]);
    design.addPosition("l1d", [0, 0, -1, -12]);

    design.setupSelector(2);

    design.addZone("board-zone", 1, [84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 74, 75, 76, 77, 78, 79, 80, 81, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 14, 15, 16, 17, 18, 19, 20, 21, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 171, 172, 173, 174, 175, 176, 159, 160, 161, 162, 163, 164, 147, 148, 149, 150, 151, 152, 135, 136, 137, 138, 139, 140, 123, 124, 125, 126, 127, 128, 111, 112, 113, 114, 115, 116, 256, 257, 258, 259, 244, 245, 246, 247, 232, 233, 234, 235, 220, 221, 222, 223, 341, 342, 329, 330], 1);
    design.addZone("board-zone", 1, [88, 91, 74, 75, 76, 79, 80, 81, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 51, 52, 55, 56, 39, 40, 43, 44, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 14, 15, 16, 19, 20, 21, 4, 7, 184, 187, 170, 171, 172, 175, 176, 177, 157, 158, 159, 160, 161, 162, 163, 164, 165, 166, 147, 148, 151, 152, 135, 136, 139, 140, 121, 122, 123, 124, 125, 126, 127, 128, 129, 130, 110, 111, 112, 115, 116, 117, 100, 103, 254, 255, 256, 257, 258, 259, 260, 261, 218, 219, 220, 221, 222, 223, 224, 225, 350, 351, 352, 353, 354, 355, 356, 357, 314, 315, 316, 317, 318, 319, 320, 321], 2);

    design.addCommand(0, ZRF.FUNCTION,	24);	// from
    design.addCommand(0, ZRF.FUNCTION,	26);	// capture
    design.addCommand(0, ZRF.FUNCTION,	25);	// to
    design.addCommand(0, ZRF.FUNCTION,	28);	// end

    design.addPiece("B1", 0);
    design.addMove(0, 0, [], 0);

    design.addPiece("B2", 1);
    design.addMove(1, 0, [], 0);

    design.addPiece("B3", 2);
    design.addMove(2, 0, [], 0);

    design.addPiece("B4", 3);
    design.addMove(3, 0, [], 0);

    design.addPiece("B5", 4);
    design.addMove(4, 0, [], 0);

    design.addPiece("B6", 5);
    design.addMove(5, 0, [], 0);

    design.addPiece("B7", 6);
    design.addMove(6, 0, [], 0);

    design.addPiece("B8", 7);
    design.addMove(7, 0, [], 0);

    design.addPiece("B9", 8);
    design.addMove(8, 0, [], 0);

    design.addPiece("C1", 9);
    design.addMove(9, 0, [], 0);

    design.addPiece("C2", 10);
    design.addMove(10, 0, [], 0);

    design.addPiece("C3", 11);
    design.addMove(11, 0, [], 0);

    design.addPiece("C4", 12);
    design.addMove(12, 0, [], 0);

    design.addPiece("C5", 13);
    design.addMove(13, 0, [], 0);

    design.addPiece("C6", 14);
    design.addMove(14, 0, [], 0);

    design.addPiece("C7", 15);
    design.addMove(15, 0, [], 0);

    design.addPiece("C8", 16);
    design.addMove(16, 0, [], 0);

    design.addPiece("C9", 17);
    design.addMove(17, 0, [], 0);

    design.addPiece("P1", 18);
    design.addMove(18, 0, [], 0);

    design.addPiece("P2", 19);
    design.addMove(19, 0, [], 0);

    design.addPiece("P3", 20);
    design.addMove(20, 0, [], 0);

    design.addPiece("P4", 21);
    design.addMove(21, 0, [], 0);

    design.addPiece("P5", 22);
    design.addMove(22, 0, [], 0);

    design.addPiece("P6", 23);
    design.addMove(23, 0, [], 0);

    design.addPiece("P7", 24);
    design.addMove(24, 0, [], 0);

    design.addPiece("P8", 25);
    design.addMove(25, 0, [], 0);

    design.addPiece("P9", 26);
    design.addMove(26, 0, [], 0);

    design.addPiece("P10", 27);
    design.addMove(27, 0, [], 0);

    design.addPiece("P11", 28);
    design.addMove(28, 0, [], 0);

    design.addPiece("P12", 29);
    design.addMove(29, 0, [], 0);

    design.addPiece("P13", 30);
    design.addMove(30, 0, [], 0);

    design.addPiece("P14", 31);
    design.addMove(31, 0, [], 0);

    design.addPiece("P15", 32);
    design.addMove(32, 0, [], 0);

    design.addPiece("F1", 33);
    design.addMove(33, 0, [], 0);

    design.addPiece("F2", 34);
    design.addMove(34, 0, [], 0);

    design.addPiece("F3", 35);
    design.addMove(35, 0, [], 0);

    design.addPiece("F4", 36);
    design.addMove(36, 0, [], 0);
}

Dagaz.View.configure = function(view) {
    view.defBoard("Board");
    view.defPiece("YouB1", "You B1");
    view.defPiece("YouB2", "You B2");
    view.defPiece("YouB3", "You B3");
    view.defPiece("YouB4", "You B4");
    view.defPiece("YouB5", "You B5");
    view.defPiece("YouB6", "You B6");
    view.defPiece("YouB7", "You B7");
    view.defPiece("YouB8", "You B8");
    view.defPiece("YouB9", "You B9");
    view.defPiece("YouC1", "You C1");
    view.defPiece("YouC2", "You C2");
    view.defPiece("YouC3", "You C3");
    view.defPiece("YouC4", "You C4");
    view.defPiece("YouC5", "You C5");
    view.defPiece("YouC6", "You C6");
    view.defPiece("YouC7", "You C7");
    view.defPiece("YouC8", "You C8");
    view.defPiece("YouC9", "You C9");
    view.defPiece("YouP1", "You P1");
    view.defPiece("YouP2", "You P2");
    view.defPiece("YouP3", "You P3");
    view.defPiece("YouP4", "You P4");
    view.defPiece("YouP5", "You P5");
    view.defPiece("YouP6", "You P6");
    view.defPiece("YouP7", "You P7");
    view.defPiece("YouP8", "You P8");
    view.defPiece("YouP9", "You P9");
    view.defPiece("YouP10", "You P10");
    view.defPiece("YouP11", "You P11");
    view.defPiece("YouP12", "You P12");
    view.defPiece("YouP13", "You P13");
    view.defPiece("YouP14", "You P14");
    view.defPiece("YouP15", "You P15");
    view.defPiece("YouF1", "You F1");
    view.defPiece("YouF2", "You F2");
    view.defPiece("YouF3", "You F3");
    view.defPiece("YouF4", "You F4");
 
    view.defPosition("a8a", 624, 10, 74, 89);
    view.defPosition("b8a", 568, 10, 74, 89);
    view.defPosition("c8a", 512, 10, 74, 89);
    view.defPosition("d8a", 456, 10, 74, 89);
    view.defPosition("e8a", 400, 10, 74, 89);
    view.defPosition("f8a", 344, 10, 74, 89);
    view.defPosition("g8a", 288, 10, 74, 89);
    view.defPosition("h8a", 232, 10, 74, 89);
    view.defPosition("i8a", 176, 10, 74, 89);
    view.defPosition("j8a", 120, 10, 74, 89);
    view.defPosition("k8a", 64, 10, 74, 89);
    view.defPosition("l8a", 8, 10, 74, 89);
    view.defPosition("a7a", 624, 91, 74, 89);
    view.defPosition("b7a", 568, 91, 74, 89);
    view.defPosition("c7a", 512, 91, 74, 89);
    view.defPosition("d7a", 456, 91, 74, 89);
    view.defPosition("e7a", 400, 91, 74, 89);
    view.defPosition("f7a", 344, 91, 74, 89);
    view.defPosition("g7a", 288, 91, 74, 89);
    view.defPosition("h7a", 232, 91, 74, 89);
    view.defPosition("i7a", 176, 91, 74, 89);
    view.defPosition("j7a", 120, 91, 74, 89);
    view.defPosition("k7a", 64, 91, 74, 89);
    view.defPosition("l7a", 8, 91, 74, 89);
    view.defPosition("a6a", 624, 172, 74, 89);
    view.defPosition("b6a", 568, 172, 74, 89);
    view.defPosition("c6a", 512, 172, 74, 89);
    view.defPosition("d6a", 456, 172, 74, 89);
    view.defPosition("e6a", 400, 172, 74, 89);
    view.defPosition("f6a", 344, 172, 74, 89);
    view.defPosition("g6a", 288, 172, 74, 89);
    view.defPosition("h6a", 232, 172, 74, 89);
    view.defPosition("i6a", 176, 172, 74, 89);
    view.defPosition("j6a", 120, 172, 74, 89);
    view.defPosition("k6a", 64, 172, 74, 89);
    view.defPosition("l6a", 8, 172, 74, 89);
    view.defPosition("a5a", 624, 253, 74, 89);
    view.defPosition("b5a", 568, 253, 74, 89);
    view.defPosition("c5a", 512, 253, 74, 89);
    view.defPosition("d5a", 456, 253, 74, 89);
    view.defPosition("e5a", 400, 253, 74, 89);
    view.defPosition("f5a", 344, 253, 74, 89);
    view.defPosition("g5a", 288, 253, 74, 89);
    view.defPosition("h5a", 232, 253, 74, 89);
    view.defPosition("i5a", 176, 253, 74, 89);
    view.defPosition("j5a", 120, 253, 74, 89);
    view.defPosition("k5a", 64, 253, 74, 89);
    view.defPosition("l5a", 8, 253, 74, 89);
    view.defPosition("a4a", 624, 334, 74, 89);
    view.defPosition("b4a", 568, 334, 74, 89);
    view.defPosition("c4a", 512, 334, 74, 89);
    view.defPosition("d4a", 456, 334, 74, 89);
    view.defPosition("e4a", 400, 334, 74, 89);
    view.defPosition("f4a", 344, 334, 74, 89);
    view.defPosition("g4a", 288, 334, 74, 89);
    view.defPosition("h4a", 232, 334, 74, 89);
    view.defPosition("i4a", 176, 334, 74, 89);
    view.defPosition("j4a", 120, 334, 74, 89);
    view.defPosition("k4a", 64, 334, 74, 89);
    view.defPosition("l4a", 8, 334, 74, 89);
    view.defPosition("a3a", 624, 415, 74, 89);
    view.defPosition("b3a", 568, 415, 74, 89);
    view.defPosition("c3a", 512, 415, 74, 89);
    view.defPosition("d3a", 456, 415, 74, 89);
    view.defPosition("e3a", 400, 415, 74, 89);
    view.defPosition("f3a", 344, 415, 74, 89);
    view.defPosition("g3a", 288, 415, 74, 89);
    view.defPosition("h3a", 232, 415, 74, 89);
    view.defPosition("i3a", 176, 415, 74, 89);
    view.defPosition("j3a", 120, 415, 74, 89);
    view.defPosition("k3a", 64, 415, 74, 89);
    view.defPosition("l3a", 8, 415, 74, 89);
    view.defPosition("a2a", 624, 496, 74, 89);
    view.defPosition("b2a", 568, 496, 74, 89);
    view.defPosition("c2a", 512, 496, 74, 89);
    view.defPosition("d2a", 456, 496, 74, 89);
    view.defPosition("e2a", 400, 496, 74, 89);
    view.defPosition("f2a", 344, 496, 74, 89);
    view.defPosition("g2a", 288, 496, 74, 89);
    view.defPosition("h2a", 232, 496, 74, 89);
    view.defPosition("i2a", 176, 496, 74, 89);
    view.defPosition("j2a", 120, 496, 74, 89);
    view.defPosition("k2a", 64, 496, 74, 89);
    view.defPosition("l2a", 8, 496, 74, 89);
    view.defPosition("a1a", 624, 577, 74, 89);
    view.defPosition("b1a", 568, 577, 74, 89);
    view.defPosition("c1a", 512, 577, 74, 89);
    view.defPosition("d1a", 456, 577, 74, 89);
    view.defPosition("e1a", 400, 577, 74, 89);
    view.defPosition("f1a", 344, 577, 74, 89);
    view.defPosition("g1a", 288, 577, 74, 89);
    view.defPosition("h1a", 232, 577, 74, 89);
    view.defPosition("i1a", 176, 577, 74, 89);
    view.defPosition("j1a", 120, 577, 74, 89);
    view.defPosition("k1a", 64, 577, 74, 89);
    view.defPosition("l1a", 8, 577, 74, 89);
    view.defPosition("a8b", 632, 2, 74, 89);
    view.defPosition("b8b", 576, 2, 74, 89);
    view.defPosition("c8b", 520, 2, 74, 89);
    view.defPosition("d8b", 464, 2, 74, 89);
    view.defPosition("e8b", 408, 2, 74, 89);
    view.defPosition("f8b", 352, 2, 74, 89);
    view.defPosition("g8b", 296, 2, 74, 89);
    view.defPosition("h8b", 240, 2, 74, 89);
    view.defPosition("i8b", 184, 2, 74, 89);
    view.defPosition("j8b", 128, 2, 74, 89);
    view.defPosition("k8b", 72, 2, 74, 89);
    view.defPosition("l8b", 16, 2, 74, 89);
    view.defPosition("a7b", 632, 83, 74, 89);
    view.defPosition("b7b", 576, 83, 74, 89);
    view.defPosition("c7b", 520, 83, 74, 89);
    view.defPosition("d7b", 464, 83, 74, 89);
    view.defPosition("e7b", 408, 83, 74, 89);
    view.defPosition("f7b", 352, 83, 74, 89);
    view.defPosition("g7b", 296, 83, 74, 89);
    view.defPosition("h7b", 240, 83, 74, 89);
    view.defPosition("i7b", 184, 83, 74, 89);
    view.defPosition("j7b", 128, 83, 74, 89);
    view.defPosition("k7b", 72, 83, 74, 89);
    view.defPosition("l7b", 16, 83, 74, 89);
    view.defPosition("a6b", 632, 164, 74, 89);
    view.defPosition("b6b", 576, 164, 74, 89);
    view.defPosition("c6b", 520, 164, 74, 89);
    view.defPosition("d6b", 464, 164, 74, 89);
    view.defPosition("e6b", 408, 164, 74, 89);
    view.defPosition("f6b", 352, 164, 74, 89);
    view.defPosition("g6b", 296, 164, 74, 89);
    view.defPosition("h6b", 240, 164, 74, 89);
    view.defPosition("i6b", 184, 164, 74, 89);
    view.defPosition("j6b", 128, 164, 74, 89);
    view.defPosition("k6b", 72, 164, 74, 89);
    view.defPosition("l6b", 16, 164, 74, 89);
    view.defPosition("a5b", 632, 245, 74, 89);
    view.defPosition("b5b", 576, 245, 74, 89);
    view.defPosition("c5b", 520, 245, 74, 89);
    view.defPosition("d5b", 464, 245, 74, 89);
    view.defPosition("e5b", 408, 245, 74, 89);
    view.defPosition("f5b", 352, 245, 74, 89);
    view.defPosition("g5b", 296, 245, 74, 89);
    view.defPosition("h5b", 240, 245, 74, 89);
    view.defPosition("i5b", 184, 245, 74, 89);
    view.defPosition("j5b", 128, 245, 74, 89);
    view.defPosition("k5b", 72, 245, 74, 89);
    view.defPosition("l5b", 16, 245, 74, 89);
    view.defPosition("a4b", 632, 326, 74, 89);
    view.defPosition("b4b", 576, 326, 74, 89);
    view.defPosition("c4b", 520, 326, 74, 89);
    view.defPosition("d4b", 464, 326, 74, 89);
    view.defPosition("e4b", 408, 326, 74, 89);
    view.defPosition("f4b", 352, 326, 74, 89);
    view.defPosition("g4b", 296, 326, 74, 89);
    view.defPosition("h4b", 240, 326, 74, 89);
    view.defPosition("i4b", 184, 326, 74, 89);
    view.defPosition("j4b", 128, 326, 74, 89);
    view.defPosition("k4b", 72, 326, 74, 89);
    view.defPosition("l4b", 16, 326, 74, 89);
    view.defPosition("a3b", 632, 407, 74, 89);
    view.defPosition("b3b", 576, 407, 74, 89);
    view.defPosition("c3b", 520, 407, 74, 89);
    view.defPosition("d3b", 464, 407, 74, 89);
    view.defPosition("e3b", 408, 407, 74, 89);
    view.defPosition("f3b", 352, 407, 74, 89);
    view.defPosition("g3b", 296, 407, 74, 89);
    view.defPosition("h3b", 240, 407, 74, 89);
    view.defPosition("i3b", 184, 407, 74, 89);
    view.defPosition("j3b", 128, 407, 74, 89);
    view.defPosition("k3b", 72, 407, 74, 89);
    view.defPosition("l3b", 16, 407, 74, 89);
    view.defPosition("a2b", 632, 488, 74, 89);
    view.defPosition("b2b", 576, 488, 74, 89);
    view.defPosition("c2b", 520, 488, 74, 89);
    view.defPosition("d2b", 464, 488, 74, 89);
    view.defPosition("e2b", 408, 488, 74, 89);
    view.defPosition("f2b", 352, 488, 74, 89);
    view.defPosition("g2b", 296, 488, 74, 89);
    view.defPosition("h2b", 240, 488, 74, 89);
    view.defPosition("i2b", 184, 488, 74, 89);
    view.defPosition("j2b", 128, 488, 74, 89);
    view.defPosition("k2b", 72, 488, 74, 89);
    view.defPosition("l2b", 16, 488, 74, 89);
    view.defPosition("a1b", 632, 569, 74, 89);
    view.defPosition("b1b", 576, 569, 74, 89);
    view.defPosition("c1b", 520, 569, 74, 89);
    view.defPosition("d1b", 464, 569, 74, 89);
    view.defPosition("e1b", 408, 569, 74, 89);
    view.defPosition("f1b", 352, 569, 74, 89);
    view.defPosition("g1b", 296, 569, 74, 89);
    view.defPosition("h1b", 240, 569, 74, 89);
    view.defPosition("i1b", 184, 569, 74, 89);
    view.defPosition("j1b", 128, 569, 74, 89);
    view.defPosition("k1b", 72, 569, 74, 89);
    view.defPosition("l1b", 16, 569, 74, 89);
    view.defPosition("a8c", 640, -6, 74, 89);
    view.defPosition("b8c", 584, -6, 74, 89);
    view.defPosition("c8c", 528, -6, 74, 89);
    view.defPosition("d8c", 472, -6, 74, 89);
    view.defPosition("e8c", 416, -6, 74, 89);
    view.defPosition("f8c", 360, -6, 74, 89);
    view.defPosition("g8c", 304, -6, 74, 89);
    view.defPosition("h8c", 248, -6, 74, 89);
    view.defPosition("i8c", 192, -6, 74, 89);
    view.defPosition("j8c", 136, -6, 74, 89);
    view.defPosition("k8c", 80, -6, 74, 89);
    view.defPosition("l8c", 24, -6, 74, 89);
    view.defPosition("a7c", 640, 75, 74, 89);
    view.defPosition("b7c", 584, 75, 74, 89);
    view.defPosition("c7c", 528, 75, 74, 89);
    view.defPosition("d7c", 472, 75, 74, 89);
    view.defPosition("e7c", 416, 75, 74, 89);
    view.defPosition("f7c", 360, 75, 74, 89);
    view.defPosition("g7c", 304, 75, 74, 89);
    view.defPosition("h7c", 248, 75, 74, 89);
    view.defPosition("i7c", 192, 75, 74, 89);
    view.defPosition("j7c", 136, 75, 74, 89);
    view.defPosition("k7c", 80, 75, 74, 89);
    view.defPosition("l7c", 24, 75, 74, 89);
    view.defPosition("a6c", 640, 156, 74, 89);
    view.defPosition("b6c", 584, 156, 74, 89);
    view.defPosition("c6c", 528, 156, 74, 89);
    view.defPosition("d6c", 472, 156, 74, 89);
    view.defPosition("e6c", 416, 156, 74, 89);
    view.defPosition("f6c", 360, 156, 74, 89);
    view.defPosition("g6c", 304, 156, 74, 89);
    view.defPosition("h6c", 248, 156, 74, 89);
    view.defPosition("i6c", 192, 156, 74, 89);
    view.defPosition("j6c", 136, 156, 74, 89);
    view.defPosition("k6c", 80, 156, 74, 89);
    view.defPosition("l6c", 24, 156, 74, 89);
    view.defPosition("a5c", 640, 237, 74, 89);
    view.defPosition("b5c", 584, 237, 74, 89);
    view.defPosition("c5c", 528, 237, 74, 89);
    view.defPosition("d5c", 472, 237, 74, 89);
    view.defPosition("e5c", 416, 237, 74, 89);
    view.defPosition("f5c", 360, 237, 74, 89);
    view.defPosition("g5c", 304, 237, 74, 89);
    view.defPosition("h5c", 248, 237, 74, 89);
    view.defPosition("i5c", 192, 237, 74, 89);
    view.defPosition("j5c", 136, 237, 74, 89);
    view.defPosition("k5c", 80, 237, 74, 89);
    view.defPosition("l5c", 24, 237, 74, 89);
    view.defPosition("a4c", 640, 318, 74, 89);
    view.defPosition("b4c", 584, 318, 74, 89);
    view.defPosition("c4c", 528, 318, 74, 89);
    view.defPosition("d4c", 472, 318, 74, 89);
    view.defPosition("e4c", 416, 318, 74, 89);
    view.defPosition("f4c", 360, 318, 74, 89);
    view.defPosition("g4c", 304, 318, 74, 89);
    view.defPosition("h4c", 248, 318, 74, 89);
    view.defPosition("i4c", 192, 318, 74, 89);
    view.defPosition("j4c", 136, 318, 74, 89);
    view.defPosition("k4c", 80, 318, 74, 89);
    view.defPosition("l4c", 24, 318, 74, 89);
    view.defPosition("a3c", 640, 399, 74, 89);
    view.defPosition("b3c", 584, 399, 74, 89);
    view.defPosition("c3c", 528, 399, 74, 89);
    view.defPosition("d3c", 472, 399, 74, 89);
    view.defPosition("e3c", 416, 399, 74, 89);
    view.defPosition("f3c", 360, 399, 74, 89);
    view.defPosition("g3c", 304, 399, 74, 89);
    view.defPosition("h3c", 248, 399, 74, 89);
    view.defPosition("i3c", 192, 399, 74, 89);
    view.defPosition("j3c", 136, 399, 74, 89);
    view.defPosition("k3c", 80, 399, 74, 89);
    view.defPosition("l3c", 24, 399, 74, 89);
    view.defPosition("a2c", 640, 480, 74, 89);
    view.defPosition("b2c", 584, 480, 74, 89);
    view.defPosition("c2c", 528, 480, 74, 89);
    view.defPosition("d2c", 472, 480, 74, 89);
    view.defPosition("e2c", 416, 480, 74, 89);
    view.defPosition("f2c", 360, 480, 74, 89);
    view.defPosition("g2c", 304, 480, 74, 89);
    view.defPosition("h2c", 248, 480, 74, 89);
    view.defPosition("i2c", 192, 480, 74, 89);
    view.defPosition("j2c", 136, 480, 74, 89);
    view.defPosition("k2c", 80, 480, 74, 89);
    view.defPosition("l2c", 24, 480, 74, 89);
    view.defPosition("a1c", 640, 561, 74, 89);
    view.defPosition("b1c", 584, 561, 74, 89);
    view.defPosition("c1c", 528, 561, 74, 89);
    view.defPosition("d1c", 472, 561, 74, 89);
    view.defPosition("e1c", 416, 561, 74, 89);
    view.defPosition("f1c", 360, 561, 74, 89);
    view.defPosition("g1c", 304, 561, 74, 89);
    view.defPosition("h1c", 248, 561, 74, 89);
    view.defPosition("i1c", 192, 561, 74, 89);
    view.defPosition("j1c", 136, 561, 74, 89);
    view.defPosition("k1c", 80, 561, 74, 89);
    view.defPosition("l1c", 24, 561, 74, 89);
    view.defPosition("a8d", 648, -14, 74, 89);
    view.defPosition("b8d", 592, -14, 74, 89);
    view.defPosition("c8d", 536, -14, 74, 89);
    view.defPosition("d8d", 480, -14, 74, 89);
    view.defPosition("e8d", 424, -14, 74, 89);
    view.defPosition("f8d", 368, -14, 74, 89);
    view.defPosition("g8d", 312, -14, 74, 89);
    view.defPosition("h8d", 256, -14, 74, 89);
    view.defPosition("i8d", 200, -14, 74, 89);
    view.defPosition("j8d", 144, -14, 74, 89);
    view.defPosition("k8d", 88, -14, 74, 89);
    view.defPosition("l8d", 32, -14, 74, 89);
    view.defPosition("a7d", 648, 67, 74, 89);
    view.defPosition("b7d", 592, 67, 74, 89);
    view.defPosition("c7d", 536, 67, 74, 89);
    view.defPosition("d7d", 480, 67, 74, 89);
    view.defPosition("e7d", 424, 67, 74, 89);
    view.defPosition("f7d", 368, 67, 74, 89);
    view.defPosition("g7d", 312, 67, 74, 89);
    view.defPosition("h7d", 256, 67, 74, 89);
    view.defPosition("i7d", 200, 67, 74, 89);
    view.defPosition("j7d", 144, 67, 74, 89);
    view.defPosition("k7d", 88, 67, 74, 89);
    view.defPosition("l7d", 32, 67, 74, 89);
    view.defPosition("a6d", 648, 148, 74, 89);
    view.defPosition("b6d", 592, 148, 74, 89);
    view.defPosition("c6d", 536, 148, 74, 89);
    view.defPosition("d6d", 480, 148, 74, 89);
    view.defPosition("e6d", 424, 148, 74, 89);
    view.defPosition("f6d", 368, 148, 74, 89);
    view.defPosition("g6d", 312, 148, 74, 89);
    view.defPosition("h6d", 256, 148, 74, 89);
    view.defPosition("i6d", 200, 148, 74, 89);
    view.defPosition("j6d", 144, 148, 74, 89);
    view.defPosition("k6d", 88, 148, 74, 89);
    view.defPosition("l6d", 32, 148, 74, 89);
    view.defPosition("a5d", 648, 229, 74, 89);
    view.defPosition("b5d", 592, 229, 74, 89);
    view.defPosition("c5d", 536, 229, 74, 89);
    view.defPosition("d5d", 480, 229, 74, 89);
    view.defPosition("e5d", 424, 229, 74, 89);
    view.defPosition("f5d", 368, 229, 74, 89);
    view.defPosition("g5d", 312, 229, 74, 89);
    view.defPosition("h5d", 256, 229, 74, 89);
    view.defPosition("i5d", 200, 229, 74, 89);
    view.defPosition("j5d", 144, 229, 74, 89);
    view.defPosition("k5d", 88, 229, 74, 89);
    view.defPosition("l5d", 32, 229, 74, 89);
    view.defPosition("a4d", 648, 310, 74, 89);
    view.defPosition("b4d", 592, 310, 74, 89);
    view.defPosition("c4d", 536, 310, 74, 89);
    view.defPosition("d4d", 480, 310, 74, 89);
    view.defPosition("e4d", 424, 310, 74, 89);
    view.defPosition("f4d", 368, 310, 74, 89);
    view.defPosition("g4d", 312, 310, 74, 89);
    view.defPosition("h4d", 256, 310, 74, 89);
    view.defPosition("i4d", 200, 310, 74, 89);
    view.defPosition("j4d", 144, 310, 74, 89);
    view.defPosition("k4d", 88, 310, 74, 89);
    view.defPosition("l4d", 32, 310, 74, 89);
    view.defPosition("a3d", 648, 391, 74, 89);
    view.defPosition("b3d", 592, 391, 74, 89);
    view.defPosition("c3d", 536, 391, 74, 89);
    view.defPosition("d3d", 480, 391, 74, 89);
    view.defPosition("e3d", 424, 391, 74, 89);
    view.defPosition("f3d", 368, 391, 74, 89);
    view.defPosition("g3d", 312, 391, 74, 89);
    view.defPosition("h3d", 256, 391, 74, 89);
    view.defPosition("i3d", 200, 391, 74, 89);
    view.defPosition("j3d", 144, 391, 74, 89);
    view.defPosition("k3d", 88, 391, 74, 89);
    view.defPosition("l3d", 32, 391, 74, 89);
    view.defPosition("a2d", 648, 472, 74, 89);
    view.defPosition("b2d", 592, 472, 74, 89);
    view.defPosition("c2d", 536, 472, 74, 89);
    view.defPosition("d2d", 480, 472, 74, 89);
    view.defPosition("e2d", 424, 472, 74, 89);
    view.defPosition("f2d", 368, 472, 74, 89);
    view.defPosition("g2d", 312, 472, 74, 89);
    view.defPosition("h2d", 256, 472, 74, 89);
    view.defPosition("i2d", 200, 472, 74, 89);
    view.defPosition("j2d", 144, 472, 74, 89);
    view.defPosition("k2d", 88, 472, 74, 89);
    view.defPosition("l2d", 32, 472, 74, 89);
    view.defPosition("a1d", 648, 553, 74, 89);
    view.defPosition("b1d", 592, 553, 74, 89);
    view.defPosition("c1d", 536, 553, 74, 89);
    view.defPosition("d1d", 480, 553, 74, 89);
    view.defPosition("e1d", 424, 553, 74, 89);
    view.defPosition("f1d", 368, 553, 74, 89);
    view.defPosition("g1d", 312, 553, 74, 89);
    view.defPosition("h1d", 256, 553, 74, 89);
    view.defPosition("i1d", 200, 553, 74, 89);
    view.defPosition("j1d", 144, 553, 74, 89);
    view.defPosition("k1d", 88, 553, 74, 89);
    view.defPosition("l1d", 32, 553, 74, 89);
}
