(function() {

Dagaz.AI.AI_FRAME = 100;

var bonus = [
  -500, -500,   10,   10,   30,   30,   30,   30,   30,   30,   30,   30,   30,   10,   10, -200, -500,
  -500, -500,   20,   20,   40,   40,   40,   40,   40,   40,   40,   40,   40,   20,   20, -200, -500,
  -500, -500,   30,   30,   50,   50,   70,   70,   70,   70,   70,   40,   50,   30,   30, -200, -500,
  -500, -500,   40,   40,   60,   60,   70, 1000, 1000, 1000,   70,   60,   60,   40,   40, -200, -500,
  -500,   50,   50,   50,   60,   60,   70, 1000, 1000, 1000,   70,   60,   60,   50,   50, -200, -500,
  -500,   40,   40,   40,   50,   50,   70,   70,   70,   70,   70,   50,   50,   40,   40, -200, -500,
  -500,   30,   30,   30,   40,   40,   40,   50,   50,   50,   40,   40,   40,   30,   30,   30, -500,
  -500,   20,   20,   20,   30,   30,   30,   40,   40,   40,   30,   30,   30,   20,   20,   20, -500,
  -500,   10,   10,   10,   20,   20,   20,   20,   20,   20,   20,   20,   20,   10,   10,   10, -500,
  -500,    0,    0,    0,   10,   10,   10,   10,   10,   10,   10,   10,   10,    0,    0,    0, -500,
  -500,  -10,  -10,  -10,    0,    0,    0,    0,    0,    0,    0,    0,    0,  -10,  -10,  -10, -500,  
  -500, -200,  -20,  -20,  -10,    0,   10,   10,   10,   10,   10,    0,  -10,  -20,  -20,  -20, -500,
  -500, -200,  -30,  -30,  -20,    0,   10,    0,    0,    0,   10,    0,  -20,  -30,  -30,  -30, -500,
  -500, -200,  -40,  -40,  -30,    0,   10,    0,    0,    0,   10,    0,  -30,  -40,  -40, -500, -500,
  -500, -200,  -50,  -50,  -40,  -10,   10,   10,   10,   10,   10,  -10,  -40,  -50,  -50, -500, -500,
  -500, -200,  -60,  -60,  -50,  -20,  -20,  -20,  -20,  -20,  -20,  -20,  -50,  -60,  -60, -500, -500,
  -500, -200,  -70,  -70,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -70,  -70, -500, -500
];

Dagaz.AI.getPrice = function(design, piece, pos) {
  if (pos > 288) return 0;
  var r = design.price[piece.type];
  if (piece.player == 1) {
      r += bonus[pos];
  } else {
      r += bonus[288 - pos];
  }
  return r;
}

Dagaz.AI.eval = function(ai, design, board, player) {
  if (_.isUndefined(board.completeEval)) {
      board.completeEval = 0;
      _.each(design.allPositions(), function(pos) {
           var piece = board.getPiece(pos);
           if (piece === null) return;
           var v = Dagaz.AI.getPrice(design, piece, pos);
           if (piece.player == board.player) {
               board.completeEval += v;
           } else {
               board.completeEval -= v;
           }
      });
  }
  if (board.player == player) {
      return board.completeEval;
  } else {
      return -board.completeEval;
  }
}

})();
