Dagaz.Controller.persistense = "session";

Dagaz.Model.WIDTH = 17;

ZRF = {
    JUMP:          0,
    IF:            1,
    FORK:          2,
    FUNCTION:      3,
    IN_ZONE:       4,
    FLAG:          5,
    SET_FLAG:      6,
    POS_FLAG:      7,
    SET_POS_FLAG:  8,
    ATTR:          9,
    SET_ATTR:      10,
    PROMOTE:       11,
    MODE:          12,
    ON_BOARD_DIR:  13,
    ON_BOARD_POS:  14,
    PARAM:         15,
    LITERAL:       16,
    VERIFY:        20
};

Dagaz.Model.BuildDesign = function(design) {
    design.checkVersion("z2j", "2");
    design.checkVersion("animate-captures", "false");
    design.checkVersion("smart-moves", "false");
    design.checkVersion("pass-partial", "true");
    design.checkVersion("detect-loops", "true");
    design.checkVersion("advisor-wait", "30");

    design.addDirection("se"); // 0
    design.addDirection("s");  // 1
    design.addDirection("sw"); // 2
    design.addDirection("e");  // 3
    design.addDirection("w");  // 4
    design.addDirection("ne"); // 5
    design.addDirection("nw"); // 6
    design.addDirection("n");  // 7
    design.addDirection("gr"); // 8
    design.addDirection("br"); // 9
    design.addDirection("nx"); // 10

    design.addPlayer("Green", [6, 7, 5, 4, 3, 2, 0, 1, 8, 9, 10]);
    design.addPlayer("Blue", [0, 1, 2, 3, 4, 5, 6, 7, 9, 8, 10]);

    design.addPosition("a17", [18, 17, 0, 1, 0, 0, 0, 0, 16, 272, 273]);
    design.addPosition("b17", [18, 17, 16, 1, -1, 0, 0, 0, 0, -1, 272]);
    design.addPosition("c17", [18, 17, 16, 1, -1, 0, 0, 0, 0, 0, 0]);
    design.addPosition("d17", [18, 17, 16, 1, -1, 0, 0, 0, 0, 0, 0]);
    design.addPosition("e17", [18, 17, 16, 1, -1, 0, 0, 0, 0, 0, 0]);
    design.addPosition("f17", [18, 17, 16, 1, -1, 0, 0, 0, 0, 0, 0]);
    design.addPosition("g17", [18, 17, 16, 1, -1, 0, 0, 0, 0, 0, 0]);
    design.addPosition("h17", [18, 17, 16, 1, -1, 0, 0, 0, 0, 0, 0]);
    design.addPosition("i17", [18, 17, 16, 1, -1, 0, 0, 0, 0, 0, 0]);
    design.addPosition("j17", [18, 17, 16, 1, -1, 0, 0, 0, 0, 0, 0]);
    design.addPosition("k17", [18, 17, 16, 1, -1, 0, 0, 0, 0, 0, 0]);
    design.addPosition("l17", [18, 17, 16, 1, -1, 0, 0, 0, 0, 0, 0]);
    design.addPosition("m17", [18, 17, 16, 1, -1, 0, 0, 0, 0, 0, 0]);
    design.addPosition("n17", [18, 17, 16, 1, -1, 0, 0, 0, 0, 0, 0]);
    design.addPosition("o17", [18, 17, 16, 1, -1, 0, 0, 0, 0, 0, 0]);
    design.addPosition("p17", [18, 17, 16, 1, -1, 0, 0, 0, 0, 0, 17]);
    design.addPosition("q17", [0, 17, 16, 0, -1, 0, 0, 0, 17, 0, -1]);
    design.addPosition("a16", [18, 17, 0, 1, 0, -16, 0, -17, 0, -16, 256]);
    design.addPosition("b16", [18, 17, 16, 1, -1, -16, -18, -17, 0, -1, 255]);
    design.addPosition("c16", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("d16", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("e16", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("f16", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("g16", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("h16", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("i16", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("j16", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("k16", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("l16", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("m16", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("n16", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("o16", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("p16", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 17]);
    design.addPosition("q16", [0, 17, 16, 0, -1, 0, -18, -17, 17, 0, -18]);
    design.addPosition("a15", [18, 17, 0, 1, 0, -16, 0, -17, 0, -16, 239]);
    design.addPosition("b15", [18, 17, 16, 1, -1, -16, -18, -17, 0, -1, 238]);
    design.addPosition("c15", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("d15", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("e15", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("f15", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("g15", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("h15", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("i15", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("j15", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("k15", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("l15", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("m15", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("n15", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("o15", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("p15", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 17]);
    design.addPosition("q15", [0, 17, 16, 0, -1, 0, -18, -17, 17, 0, -35]);
    design.addPosition("a14", [18, 17, 0, 1, 0, -16, 0, -17, 0, -16, 222]);
    design.addPosition("b14", [18, 17, 16, 1, -1, -16, -18, -17, 0, -1, 221]);
    design.addPosition("c14", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("d14", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("e14", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("f14", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("g14", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("h14", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("i14", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("j14", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("k14", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("l14", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("m14", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("n14", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("o14", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("p14", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 17]);
    design.addPosition("q14", [0, 17, 16, 0, -1, 0, -18, -17, 17, 0, -52]);
    design.addPosition("a13", [18, 17, 0, 1, 0, -16, 0, -17, 0, -16, 205]);
    design.addPosition("b13", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("c13", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("d13", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("e13", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("f13", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("g13", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("h13", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("i13", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("j13", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("k13", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("l13", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("m13", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("n13", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("o13", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("p13", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 17]);
    design.addPosition("q13", [0, 17, 16, 0, -1, 0, -18, -17, 17, 0, -69]);
    design.addPosition("a12", [18, 17, 0, 1, 0, -16, 0, -17, 0, -17, 188]);
    design.addPosition("b12", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("c12", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("d12", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("e12", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("f12", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("g12", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("h12", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("i12", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("j12", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("k12", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("l12", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("m12", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("n12", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("o12", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("p12", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("q12", [0, 17, 16, 0, -1, 0, -18, -17, 17, 0, -86]);
    design.addPosition("a11", [18, 17, 0, 1, 0, -16, 0, -17, 0, -17, 171]);
    design.addPosition("b11", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("c11", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("d11", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("e11", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("f11", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("g11", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("h11", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("i11", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("j11", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("k11", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("l11", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("m11", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("n11", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("o11", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("p11", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("q11", [0, 17, 16, 0, -1, 0, -18, -17, 17, 0, -103]);
    design.addPosition("a10", [18, 17, 0, 1, 0, -16, 0, -17, 0, -17, 154]);
    design.addPosition("b10", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("c10", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("d10", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("e10", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("f10", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("g10", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("h10", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("i10", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("j10", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("k10", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("l10", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("m10", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("n10", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("o10", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("p10", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("q10", [0, 17, 16, 0, -1, 0, -18, -17, 17, 0, -120]);
    design.addPosition("a9", [18, 17, 0, 1, 0, -16, 0, -17, 0, -17, 137]);
    design.addPosition("b9", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("c9", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("d9", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("e9", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("f9", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("g9", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("h9", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("i9", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("j9", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("k9", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("l9", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("m9", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("n9", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("o9", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("p9", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("q9", [0, 17, 16, 0, -1, 0, -18, -17, 17, 0, -137]);
    design.addPosition("a8", [18, 17, 0, 1, 0, -16, 0, -17, 0, -17, 120]);
    design.addPosition("b8", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("c8", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("d8", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("e8", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("f8", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("g8", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("h8", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("i8", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("j8", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("k8", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("l8", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("m8", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("n8", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("o8", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("p8", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("q8", [0, 17, 16, 0, -1, 0, -18, -17, 17, 0, -154]);
    design.addPosition("a7", [18, 17, 0, 1, 0, -16, 0, -17, 0, -17, 103]);
    design.addPosition("b7", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("c7", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("d7", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("e7", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("f7", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("g7", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("h7", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("i7", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("j7", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("k7", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("l7", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("m7", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("n7", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("o7", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("p7", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("q7", [0, 17, 16, 0, -1, 0, -18, -17, 17, 0, -171]);
    design.addPosition("a6", [18, 17, 0, 1, 0, -16, 0, -17, 0, -17, 86]);
    design.addPosition("b6", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("c6", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("d6", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("e6", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("f6", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("g6", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("h6", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("i6", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("j6", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("k6", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("l6", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("m6", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("n6", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("o6", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("p6", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("q6", [0, 17, 16, 0, -1, 0, -18, -17, 17, 0, -188]);
    design.addPosition("a5", [18, 17, 0, 1, 0, -16, 0, -17, 0, -17, 69]);
    design.addPosition("b5", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, -17]);
    design.addPosition("c5", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("d5", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("e5", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("f5", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("g5", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("h5", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("i5", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("j5", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("k5", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("l5", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("m5", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("n5", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("o5", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("p5", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("q5", [0, 17, 16, 0, -1, 0, -18, -17, 16, 0, -205]);
    design.addPosition("a4", [18, 17, 0, 1, 0, -16, 0, -17, 0, -17, 52]);
    design.addPosition("b4", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, -17]);
    design.addPosition("c4", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("d4", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("e4", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("f4", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("g4", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("h4", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("i4", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("j4", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("k4", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("l4", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("m4", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("n4", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("o4", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("p4", [18, 17, 16, 1, -1, -16, -18, -17, 1, 0, -221]);
    design.addPosition("q4", [0, 17, 16, 0, -1, 0, -18, -17, 16, 0, -222]);
    design.addPosition("a3", [18, 17, 0, 1, 0, -16, 0, -17, 0, -17, 35]);
    design.addPosition("b3", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, -17]);
    design.addPosition("c3", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("d3", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("e3", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("f3", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("g3", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("h3", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("i3", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("j3", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("k3", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("l3", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("m3", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("n3", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("o3", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("p3", [18, 17, 16, 1, -1, -16, -18, -17, 1, 0, -238]);
    design.addPosition("q3", [0, 17, 16, 0, -1, 0, -18, -17, 16, 0, -239]);
    design.addPosition("a2", [18, 17, 0, 1, 0, -16, 0, -17, 0, -17, 18]);
    design.addPosition("b2", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, -17]);
    design.addPosition("c2", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("d2", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("e2", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("f2", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("g2", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("h2", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("i2", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("j2", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("k2", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("l2", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("m2", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("n2", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("o2", [18, 17, 16, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("p2", [18, 17, 16, 1, -1, -16, -18, -17, 1, 0, -255]);
    design.addPosition("q2", [0, 17, 16, 0, -1, 0, -18, -17, 16, 0, -256]);
    design.addPosition("a1", [0, 0, 0, 1, 0, -16, 0, -17, 0, -17, 1]);
    design.addPosition("b1", [0, 0, 0, 1, -1, -16, -18, -17, 0, 0, -17]);
    design.addPosition("c1", [0, 0, 0, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("d1", [0, 0, 0, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("e1", [0, 0, 0, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("f1", [0, 0, 0, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("g1", [0, 0, 0, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("h1", [0, 0, 0, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("i1", [0, 0, 0, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("j1", [0, 0, 0, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("k1", [0, 0, 0, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("l1", [0, 0, 0, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("m1", [0, 0, 0, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("n1", [0, 0, 0, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("o1", [0, 0, 0, 1, -1, -16, -18, -17, 0, 0, 0]);
    design.addPosition("p1", [0, 0, 0, 1, -1, -16, -18, -17, 1, 0, -272]);
    design.addPosition("q1", [0, 0, 0, 0, -1, 0, -18, -17, 0, 0, -273]);

    design.addZone("arena-zone", 2, [276, 259, 242, 225, 208, 191, 174, 157, 140, 123, 106, 89, 72, 55, 38, 21, 4, 277, 260, 243, 226, 209, 192, 175, 158, 141, 124, 107, 90, 73, 56, 39, 22, 5, 278, 261, 244, 227, 210, 193, 176, 159, 142, 125, 108, 91, 74, 57, 40, 23, 6, 279, 262, 245, 194, 177, 160, 143, 126, 109, 92, 41, 24, 7, 280, 263, 246, 195, 178, 161, 144, 127, 110, 93, 42, 25, 8, 281, 264, 247, 196, 179, 162, 145, 128, 111, 94, 43, 26, 9, 282, 265, 248, 231, 214, 197, 180, 163, 146, 129, 112, 95, 78, 61, 44, 27, 10, 283, 266, 249, 232, 215, 198, 181, 164, 147, 130, 113, 96, 79, 62, 45, 28, 11, 284, 267, 250, 233, 216, 199, 182, 165, 148, 131, 114, 97, 80, 63, 46, 29, 12]);
    design.addZone("arena-zone", 1, [276, 259, 242, 225, 208, 191, 174, 157, 140, 123, 106, 89, 72, 55, 38, 21, 4, 277, 260, 243, 226, 209, 192, 175, 158, 141, 124, 107, 90, 73, 56, 39, 22, 5, 278, 261, 244, 227, 210, 193, 176, 159, 142, 125, 108, 91, 74, 57, 40, 23, 6, 279, 262, 245, 194, 177, 160, 143, 126, 109, 92, 41, 24, 7, 280, 263, 246, 195, 178, 161, 144, 127, 110, 93, 42, 25, 8, 281, 264, 247, 196, 179, 162, 145, 128, 111, 94, 43, 26, 9, 282, 265, 248, 231, 214, 197, 180, 163, 146, 129, 112, 95, 78, 61, 44, 27, 10, 283, 266, 249, 232, 215, 198, 181, 164, 147, 130, 113, 96, 79, 62, 45, 28, 11, 284, 267, 250, 233, 216, 199, 182, 165, 148, 131, 114, 97, 80, 63, 46, 29, 12]);
    design.addZone("board-zone", 2, [274, 257, 240, 223, 206, 189, 172, 155, 138, 121, 104, 87, 70, 53, 36, 19, 2, 275, 258, 241, 224, 207, 190, 173, 156, 139, 122, 105, 88, 71, 54, 37, 20, 3, 276, 259, 242, 225, 208, 191, 174, 157, 140, 123, 106, 89, 72, 55, 38, 21, 4, 277, 260, 243, 226, 209, 192, 175, 158, 141, 124, 107, 90, 73, 56, 39, 22, 5, 278, 261, 244, 227, 210, 193, 176, 159, 142, 125, 108, 91, 74, 57, 40, 23, 6, 279, 262, 245, 228, 211, 194, 177, 160, 143, 126, 109, 92, 75, 58, 41, 24, 7, 280, 263, 246, 229, 212, 195, 178, 161, 144, 127, 110, 93, 76, 59, 42, 25, 8, 281, 264, 247, 230, 213, 196, 179, 162, 145, 128, 111, 94, 77, 60, 43, 26, 9, 282, 265, 248, 231, 214, 197, 180, 163, 146, 129, 112, 95, 78, 61, 44, 27, 10, 283, 266, 249, 232, 215, 198, 181, 164, 147, 130, 113, 96, 79, 62, 45, 28, 11, 284, 267, 250, 233, 216, 199, 182, 165, 148, 131, 114, 97, 80, 63, 46, 29, 12, 285, 268, 251, 234, 217, 200, 183, 166, 149, 132, 115, 98, 81, 64, 47, 30, 13, 286, 269, 252, 235, 218, 201, 184, 167, 150, 133, 116, 99, 82, 65, 48, 31, 14, 171, 154, 137, 120, 103, 86, 69, 219, 202, 185, 168, 151, 134, 117]);
    design.addZone("board-zone", 1, [274, 257, 240, 223, 206, 189, 172, 155, 138, 121, 104, 87, 70, 53, 36, 19, 2, 275, 258, 241, 224, 207, 190, 173, 156, 139, 122, 105, 88, 71, 54, 37, 20, 3, 276, 259, 242, 225, 208, 191, 174, 157, 140, 123, 106, 89, 72, 55, 38, 21, 4, 277, 260, 243, 226, 209, 192, 175, 158, 141, 124, 107, 90, 73, 56, 39, 22, 5, 278, 261, 244, 227, 210, 193, 176, 159, 142, 125, 108, 91, 74, 57, 40, 23, 6, 279, 262, 245, 228, 211, 194, 177, 160, 143, 126, 109, 92, 75, 58, 41, 24, 7, 280, 263, 246, 229, 212, 195, 178, 161, 144, 127, 110, 93, 76, 59, 42, 25, 8, 281, 264, 247, 230, 213, 196, 179, 162, 145, 128, 111, 94, 77, 60, 43, 26, 9, 282, 265, 248, 231, 214, 197, 180, 163, 146, 129, 112, 95, 78, 61, 44, 27, 10, 283, 266, 249, 232, 215, 198, 181, 164, 147, 130, 113, 96, 79, 62, 45, 28, 11, 284, 267, 250, 233, 216, 199, 182, 165, 148, 131, 114, 97, 80, 63, 46, 29, 12, 285, 268, 251, 234, 217, 200, 183, 166, 149, 132, 115, 98, 81, 64, 47, 30, 13, 286, 269, 252, 235, 218, 201, 184, 167, 150, 133, 116, 99, 82, 65, 48, 31, 14, 171, 154, 137, 120, 103, 86, 69, 219, 202, 185, 168, 151, 134, 117]);
    design.addZone("yard-zone", 2, [100, 83, 66, 49, 32, 15, 273, 256, 239, 222, 205, 188]);
    design.addZone("yard-zone", 1, [100, 83, 66, 49, 32, 15, 273, 256, 239, 222, 205, 188]);
    design.addZone("goal-zone", 2, [228, 211, 229, 212, 230, 213]);
    design.addZone("goal-zone", 1, [75, 58, 76, 59, 77, 60]);

    design.addCommand(0, ZRF.FUNCTION,	24);	// from
    design.addCommand(0, ZRF.PARAM,	0);	// $1
    design.addCommand(0, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(0, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(0, ZRF.FUNCTION,	20);	// verify
    design.addCommand(0, ZRF.FUNCTION,	25);	// to
    design.addCommand(0, ZRF.FUNCTION,	28);	// end

    design.addCommand(1, ZRF.FUNCTION,	24);	// from
    design.addCommand(1, ZRF.PARAM,	0);	// $1
    design.addCommand(1, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(1, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(1, ZRF.FUNCTION,	0);	// not
    design.addCommand(1, ZRF.FUNCTION,	20);	// verify
    design.addCommand(1, ZRF.PARAM,	1);	// $2
    design.addCommand(1, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(1, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(1, ZRF.FUNCTION,	20);	// verify
    design.addCommand(1, ZRF.MODE,	1);	// jump-type
    design.addCommand(1, ZRF.FUNCTION,	25);	// to
    design.addCommand(1, ZRF.FUNCTION,	28);	// end

    design.addPiece("Small", 0, 100);
    design.addMove(0, 0, [7], 0);
    design.addMove(0, 0, [6], 0);
    design.addMove(0, 0, [3], 0);
    design.addMove(0, 0, [5], 0);
    design.addMove(0, 0, [4], 0);
    design.addMove(0, 0, [2], 0);
    design.addMove(0, 0, [1], 0);
    design.addMove(0, 0, [0], 0);
    design.addMove(0, 1, [7, 7], 1);
    design.addMove(0, 1, [6, 6], 1);
    design.addMove(0, 1, [3, 3], 1);
    design.addMove(0, 1, [5, 5], 1);
    design.addMove(0, 1, [4, 4], 1);
    design.addMove(0, 1, [2, 2], 1);
    design.addMove(0, 1, [1, 1], 1);
    design.addMove(0, 1, [0, 0], 1);
    design.addMove(0, 0, [10], 2);

    design.addPiece("Big", 1, 300);
    design.addMove(1, 0, [7], 0);
    design.addMove(1, 0, [6], 0);
    design.addMove(1, 0, [3], 0);
    design.addMove(1, 0, [5], 0);
    design.addMove(1, 0, [4], 0);
    design.addMove(1, 0, [2], 0);
    design.addMove(1, 0, [1], 0);
    design.addMove(1, 0, [0], 0);
    design.addMove(1, 1, [7, 7], 1);
    design.addMove(1, 1, [6, 6], 1);
    design.addMove(1, 1, [3, 3], 1);
    design.addMove(1, 1, [5, 5], 1);
    design.addMove(1, 1, [4, 4], 1);
    design.addMove(1, 1, [2, 2], 1);
    design.addMove(1, 1, [1, 1], 1);
    design.addMove(1, 1, [0, 0], 1);
    design.addMove(1, 0, [10], 2);

    design.setup("Green", "Big", 208);
    design.setup("Green", "Big", 189);
    design.setup("Green", "Big", 195);
    design.setup("Green", "Big", 201);
    design.setup("Green", "Big", 216);
    design.setup("Green", "Small", 227);
    design.setup("Green", "Small", 190);
    design.setup("Green", "Small", 191);
    design.setup("Green", "Small", 192);
    design.setup("Green", "Small", 193);
    design.setup("Green", "Small", 194);
    design.setup("Green", "Small", 196);
    design.setup("Green", "Small", 197);
    design.setup("Green", "Small", 198);
    design.setup("Green", "Small", 199);
    design.setup("Green", "Small", 200);
    design.setup("Green", "Small", 231);
    design.setup("Green", "Small", 209);
    design.setup("Green", "Small", 210);
    design.setup("Green", "Small", 214);
    design.setup("Green", "Small", 215);
    design.setup("Blue", "Big", 72);
    design.setup("Blue", "Big", 87);
    design.setup("Blue", "Big", 93);
    design.setup("Blue", "Big", 99);
    design.setup("Blue", "Big", 80);
    design.setup("Blue", "Small", 57);
    design.setup("Blue", "Small", 88);
    design.setup("Blue", "Small", 89);
    design.setup("Blue", "Small", 90);
    design.setup("Blue", "Small", 91);
    design.setup("Blue", "Small", 92);
    design.setup("Blue", "Small", 94);
    design.setup("Blue", "Small", 95);
    design.setup("Blue", "Small", 96);
    design.setup("Blue", "Small", 97);
    design.setup("Blue", "Small", 98);
    design.setup("Blue", "Small", 61);
    design.setup("Blue", "Small", 73);
    design.setup("Blue", "Small", 74);
    design.setup("Blue", "Small", 78);
    design.setup("Blue", "Small", 79);
}

Dagaz.View.configure = function(view) {
    view.defBoard("Board");
    view.defPiece("GreenSmall", "Green Small");
    view.defPiece("BlueSmall", "Blue Small");
    view.defPiece("GreenBig", "Green Big");
    view.defPiece("BlueBig", "Blue Big");
 
    view.defPosition("a17", 4, 4, 38, 39);
    view.defPosition("b17", 45, 4, 38, 39);
    view.defPosition("c17", 86, 4, 38, 39);
    view.defPosition("d17", 127, 4, 38, 39);
    view.defPosition("e17", 168, 4, 38, 39);
    view.defPosition("f17", 209, 4, 38, 39);
    view.defPosition("g17", 250, 4, 38, 39);
    view.defPosition("h17", 291, 4, 38, 39);
    view.defPosition("i17", 332, 4, 38, 39);
    view.defPosition("j17", 373, 4, 38, 39);
    view.defPosition("k17", 414, 4, 38, 39);
    view.defPosition("l17", 455, 4, 38, 39);
    view.defPosition("m17", 496, 4, 38, 39);
    view.defPosition("n17", 537, 4, 38, 39);
    view.defPosition("o17", 578, 4, 38, 39);
    view.defPosition("p17", 619, 4, 38, 39);
    view.defPosition("q17", 660, 4, 38, 39);
    view.defPosition("a16", 4, 45, 38, 39);
    view.defPosition("b16", 45, 45, 38, 39);
    view.defPosition("c16", 86, 45, 38, 39);
    view.defPosition("d16", 127, 45, 38, 39);
    view.defPosition("e16", 168, 45, 38, 39);
    view.defPosition("f16", 209, 45, 38, 39);
    view.defPosition("g16", 250, 45, 38, 39);
    view.defPosition("h16", 291, 45, 38, 39);
    view.defPosition("i16", 332, 45, 38, 39);
    view.defPosition("j16", 373, 45, 38, 39);
    view.defPosition("k16", 414, 45, 38, 39);
    view.defPosition("l16", 455, 45, 38, 39);
    view.defPosition("m16", 496, 45, 38, 39);
    view.defPosition("n16", 537, 45, 38, 39);
    view.defPosition("o16", 578, 45, 38, 39);
    view.defPosition("p16", 619, 45, 38, 39);
    view.defPosition("q16", 660, 45, 38, 39);
    view.defPosition("a15", 4, 86, 38, 39);
    view.defPosition("b15", 45, 86, 38, 39);
    view.defPosition("c15", 86, 86, 38, 39);
    view.defPosition("d15", 127, 86, 38, 39);
    view.defPosition("e15", 168, 86, 38, 39);
    view.defPosition("f15", 209, 86, 38, 39);
    view.defPosition("g15", 250, 86, 38, 39);
    view.defPosition("h15", 291, 86, 38, 39);
    view.defPosition("i15", 332, 86, 38, 39);
    view.defPosition("j15", 373, 86, 38, 39);
    view.defPosition("k15", 414, 86, 38, 39);
    view.defPosition("l15", 455, 86, 38, 39);
    view.defPosition("m15", 496, 86, 38, 39);
    view.defPosition("n15", 537, 86, 38, 39);
    view.defPosition("o15", 578, 86, 38, 39);
    view.defPosition("p15", 619, 86, 38, 39);
    view.defPosition("q15", 660, 86, 38, 39);
    view.defPosition("a14", 4, 127, 38, 39);
    view.defPosition("b14", 45, 127, 38, 39);
    view.defPosition("c14", 86, 127, 38, 39);
    view.defPosition("d14", 127, 127, 38, 39);
    view.defPosition("e14", 168, 127, 38, 39);
    view.defPosition("f14", 209, 127, 38, 39);
    view.defPosition("g14", 250, 127, 38, 39);
    view.defPosition("h14", 291, 127, 38, 39);
    view.defPosition("i14", 332, 127, 38, 39);
    view.defPosition("j14", 373, 127, 38, 39);
    view.defPosition("k14", 414, 127, 38, 39);
    view.defPosition("l14", 455, 127, 38, 39);
    view.defPosition("m14", 496, 127, 38, 39);
    view.defPosition("n14", 537, 127, 38, 39);
    view.defPosition("o14", 578, 127, 38, 39);
    view.defPosition("p14", 619, 127, 38, 39);
    view.defPosition("q14", 660, 127, 38, 39);
    view.defPosition("a13", 4, 168, 38, 39);
    view.defPosition("b13", 45, 168, 38, 39);
    view.defPosition("c13", 86, 168, 38, 39);
    view.defPosition("d13", 127, 168, 38, 39);
    view.defPosition("e13", 168, 168, 38, 39);
    view.defPosition("f13", 209, 168, 38, 39);
    view.defPosition("g13", 250, 168, 38, 39);
    view.defPosition("h13", 291, 168, 38, 39);
    view.defPosition("i13", 332, 168, 38, 39);
    view.defPosition("j13", 373, 168, 38, 39);
    view.defPosition("k13", 414, 168, 38, 39);
    view.defPosition("l13", 455, 168, 38, 39);
    view.defPosition("m13", 496, 168, 38, 39);
    view.defPosition("n13", 537, 168, 38, 39);
    view.defPosition("o13", 578, 168, 38, 39);
    view.defPosition("p13", 619, 168, 38, 39);
    view.defPosition("q13", 660, 168, 38, 39);
    view.defPosition("a12", 4, 209, 38, 39);
    view.defPosition("b12", 45, 209, 38, 39);
    view.defPosition("c12", 86, 209, 38, 39);
    view.defPosition("d12", 127, 209, 38, 39);
    view.defPosition("e12", 168, 209, 38, 39);
    view.defPosition("f12", 209, 209, 38, 39);
    view.defPosition("g12", 250, 209, 38, 39);
    view.defPosition("h12", 291, 209, 38, 39);
    view.defPosition("i12", 332, 209, 38, 39);
    view.defPosition("j12", 373, 209, 38, 39);
    view.defPosition("k12", 414, 209, 38, 39);
    view.defPosition("l12", 455, 209, 38, 39);
    view.defPosition("m12", 496, 209, 38, 39);
    view.defPosition("n12", 537, 209, 38, 39);
    view.defPosition("o12", 578, 209, 38, 39);
    view.defPosition("p12", 619, 209, 38, 39);
    view.defPosition("q12", 660, 209, 38, 39);
    view.defPosition("a11", 4, 250, 38, 39);
    view.defPosition("b11", 45, 250, 38, 39);
    view.defPosition("c11", 86, 250, 38, 39);
    view.defPosition("d11", 127, 250, 38, 39);
    view.defPosition("e11", 168, 250, 38, 39);
    view.defPosition("f11", 209, 250, 38, 39);
    view.defPosition("g11", 250, 250, 38, 39);
    view.defPosition("h11", 291, 250, 38, 39);
    view.defPosition("i11", 332, 250, 38, 39);
    view.defPosition("j11", 373, 250, 38, 39);
    view.defPosition("k11", 414, 250, 38, 39);
    view.defPosition("l11", 455, 250, 38, 39);
    view.defPosition("m11", 496, 250, 38, 39);
    view.defPosition("n11", 537, 250, 38, 39);
    view.defPosition("o11", 578, 250, 38, 39);
    view.defPosition("p11", 619, 250, 38, 39);
    view.defPosition("q11", 660, 250, 38, 39);
    view.defPosition("a10", 4, 291, 38, 39);
    view.defPosition("b10", 45, 291, 38, 39);
    view.defPosition("c10", 86, 291, 38, 39);
    view.defPosition("d10", 127, 291, 38, 39);
    view.defPosition("e10", 168, 291, 38, 39);
    view.defPosition("f10", 209, 291, 38, 39);
    view.defPosition("g10", 250, 291, 38, 39);
    view.defPosition("h10", 291, 291, 38, 39);
    view.defPosition("i10", 332, 291, 38, 39);
    view.defPosition("j10", 373, 291, 38, 39);
    view.defPosition("k10", 414, 291, 38, 39);
    view.defPosition("l10", 455, 291, 38, 39);
    view.defPosition("m10", 496, 291, 38, 39);
    view.defPosition("n10", 537, 291, 38, 39);
    view.defPosition("o10", 578, 291, 38, 39);
    view.defPosition("p10", 619, 291, 38, 39);
    view.defPosition("q10", 660, 291, 38, 39);
    view.defPosition("a9", 4, 332, 38, 39);
    view.defPosition("b9", 45, 332, 38, 39);
    view.defPosition("c9", 86, 332, 38, 39);
    view.defPosition("d9", 127, 332, 38, 39);
    view.defPosition("e9", 168, 332, 38, 39);
    view.defPosition("f9", 209, 332, 38, 39);
    view.defPosition("g9", 250, 332, 38, 39);
    view.defPosition("h9", 291, 332, 38, 39);
    view.defPosition("i9", 332, 332, 38, 39);
    view.defPosition("j9", 373, 332, 38, 39);
    view.defPosition("k9", 414, 332, 38, 39);
    view.defPosition("l9", 455, 332, 38, 39);
    view.defPosition("m9", 496, 332, 38, 39);
    view.defPosition("n9", 537, 332, 38, 39);
    view.defPosition("o9", 578, 332, 38, 39);
    view.defPosition("p9", 619, 332, 38, 39);
    view.defPosition("q9", 660, 332, 38, 39);
    view.defPosition("a8", 4, 373, 38, 39);
    view.defPosition("b8", 45, 373, 38, 39);
    view.defPosition("c8", 86, 373, 38, 39);
    view.defPosition("d8", 127, 373, 38, 39);
    view.defPosition("e8", 168, 373, 38, 39);
    view.defPosition("f8", 209, 373, 38, 39);
    view.defPosition("g8", 250, 373, 38, 39);
    view.defPosition("h8", 291, 373, 38, 39);
    view.defPosition("i8", 332, 373, 38, 39);
    view.defPosition("j8", 373, 373, 38, 39);
    view.defPosition("k8", 414, 373, 38, 39);
    view.defPosition("l8", 455, 373, 38, 39);
    view.defPosition("m8", 496, 373, 38, 39);
    view.defPosition("n8", 537, 373, 38, 39);
    view.defPosition("o8", 578, 373, 38, 39);
    view.defPosition("p8", 619, 373, 38, 39);
    view.defPosition("q8", 660, 373, 38, 39);
    view.defPosition("a7", 4, 414, 38, 39);
    view.defPosition("b7", 45, 414, 38, 39);
    view.defPosition("c7", 86, 414, 38, 39);
    view.defPosition("d7", 127, 414, 38, 39);
    view.defPosition("e7", 168, 414, 38, 39);
    view.defPosition("f7", 209, 414, 38, 39);
    view.defPosition("g7", 250, 414, 38, 39);
    view.defPosition("h7", 291, 414, 38, 39);
    view.defPosition("i7", 332, 414, 38, 39);
    view.defPosition("j7", 373, 414, 38, 39);
    view.defPosition("k7", 414, 414, 38, 39);
    view.defPosition("l7", 455, 414, 38, 39);
    view.defPosition("m7", 496, 414, 38, 39);
    view.defPosition("n7", 537, 414, 38, 39);
    view.defPosition("o7", 578, 414, 38, 39);
    view.defPosition("p7", 619, 414, 38, 39);
    view.defPosition("q7", 660, 414, 38, 39);
    view.defPosition("a6", 4, 455, 38, 39);
    view.defPosition("b6", 45, 455, 38, 39);
    view.defPosition("c6", 86, 455, 38, 39);
    view.defPosition("d6", 127, 455, 38, 39);
    view.defPosition("e6", 168, 455, 38, 39);
    view.defPosition("f6", 209, 455, 38, 39);
    view.defPosition("g6", 250, 455, 38, 39);
    view.defPosition("h6", 291, 455, 38, 39);
    view.defPosition("i6", 332, 455, 38, 39);
    view.defPosition("j6", 373, 455, 38, 39);
    view.defPosition("k6", 414, 455, 38, 39);
    view.defPosition("l6", 455, 455, 38, 39);
    view.defPosition("m6", 496, 455, 38, 39);
    view.defPosition("n6", 537, 455, 38, 39);
    view.defPosition("o6", 578, 455, 38, 39);
    view.defPosition("p6", 619, 455, 38, 39);
    view.defPosition("q6", 660, 455, 38, 39);
    view.defPosition("a5", 4, 496, 38, 39);
    view.defPosition("b5", 45, 496, 38, 39);
    view.defPosition("c5", 86, 496, 38, 39);
    view.defPosition("d5", 127, 496, 38, 39);
    view.defPosition("e5", 168, 496, 38, 39);
    view.defPosition("f5", 209, 496, 38, 39);
    view.defPosition("g5", 250, 496, 38, 39);
    view.defPosition("h5", 291, 496, 38, 39);
    view.defPosition("i5", 332, 496, 38, 39);
    view.defPosition("j5", 373, 496, 38, 39);
    view.defPosition("k5", 414, 496, 38, 39);
    view.defPosition("l5", 455, 496, 38, 39);
    view.defPosition("m5", 496, 496, 38, 39);
    view.defPosition("n5", 537, 496, 38, 39);
    view.defPosition("o5", 578, 496, 38, 39);
    view.defPosition("p5", 619, 496, 38, 39);
    view.defPosition("q5", 660, 496, 38, 39);
    view.defPosition("a4", 4, 537, 38, 39);
    view.defPosition("b4", 45, 537, 38, 39);
    view.defPosition("c4", 86, 537, 38, 39);
    view.defPosition("d4", 127, 537, 38, 39);
    view.defPosition("e4", 168, 537, 38, 39);
    view.defPosition("f4", 209, 537, 38, 39);
    view.defPosition("g4", 250, 537, 38, 39);
    view.defPosition("h4", 291, 537, 38, 39);
    view.defPosition("i4", 332, 537, 38, 39);
    view.defPosition("j4", 373, 537, 38, 39);
    view.defPosition("k4", 414, 537, 38, 39);
    view.defPosition("l4", 455, 537, 38, 39);
    view.defPosition("m4", 496, 537, 38, 39);
    view.defPosition("n4", 537, 537, 38, 39);
    view.defPosition("o4", 578, 537, 38, 39);
    view.defPosition("p4", 619, 537, 38, 39);
    view.defPosition("q4", 660, 537, 38, 39);
    view.defPosition("a3", 4, 578, 38, 39);
    view.defPosition("b3", 45, 578, 38, 39);
    view.defPosition("c3", 86, 578, 38, 39);
    view.defPosition("d3", 127, 578, 38, 39);
    view.defPosition("e3", 168, 578, 38, 39);
    view.defPosition("f3", 209, 578, 38, 39);
    view.defPosition("g3", 250, 578, 38, 39);
    view.defPosition("h3", 291, 578, 38, 39);
    view.defPosition("i3", 332, 578, 38, 39);
    view.defPosition("j3", 373, 578, 38, 39);
    view.defPosition("k3", 414, 578, 38, 39);
    view.defPosition("l3", 455, 578, 38, 39);
    view.defPosition("m3", 496, 578, 38, 39);
    view.defPosition("n3", 537, 578, 38, 39);
    view.defPosition("o3", 578, 578, 38, 39);
    view.defPosition("p3", 619, 578, 38, 39);
    view.defPosition("q3", 660, 578, 38, 39);
    view.defPosition("a2", 4, 619, 38, 39);
    view.defPosition("b2", 45, 619, 38, 39);
    view.defPosition("c2", 86, 619, 38, 39);
    view.defPosition("d2", 127, 619, 38, 39);
    view.defPosition("e2", 168, 619, 38, 39);
    view.defPosition("f2", 209, 619, 38, 39);
    view.defPosition("g2", 250, 619, 38, 39);
    view.defPosition("h2", 291, 619, 38, 39);
    view.defPosition("i2", 332, 619, 38, 39);
    view.defPosition("j2", 373, 619, 38, 39);
    view.defPosition("k2", 414, 619, 38, 39);
    view.defPosition("l2", 455, 619, 38, 39);
    view.defPosition("m2", 496, 619, 38, 39);
    view.defPosition("n2", 537, 619, 38, 39);
    view.defPosition("o2", 578, 619, 38, 39);
    view.defPosition("p2", 619, 619, 38, 39);
    view.defPosition("q2", 660, 619, 38, 39);
    view.defPosition("a1", 4, 660, 38, 39);
    view.defPosition("b1", 45, 660, 38, 39);
    view.defPosition("c1", 86, 660, 38, 39);
    view.defPosition("d1", 127, 660, 38, 39);
    view.defPosition("e1", 168, 660, 38, 39);
    view.defPosition("f1", 209, 660, 38, 39);
    view.defPosition("g1", 250, 660, 38, 39);
    view.defPosition("h1", 291, 660, 38, 39);
    view.defPosition("i1", 332, 660, 38, 39);
    view.defPosition("j1", 373, 660, 38, 39);
    view.defPosition("k1", 414, 660, 38, 39);
    view.defPosition("l1", 455, 660, 38, 39);
    view.defPosition("m1", 496, 660, 38, 39);
    view.defPosition("n1", 537, 660, 38, 39);
    view.defPosition("o1", 578, 660, 38, 39);
    view.defPosition("p1", 619, 660, 38, 39);
    view.defPosition("q1", 660, 660, 38, 39);
}
