Dagaz.Controller.persistense = "setup";

ZRF = {
    JUMP:          0,
    IF:            1,
    FORK:          2,
    FUNCTION:      3,
    IN_ZONE:       4,
    FLAG:          5,
    SET_FLAG:      6,
    POS_FLAG:      7,
    SET_POS_FLAG:  8,
    ATTR:          9,
    SET_ATTR:      10,
    PROMOTE:       11,
    MODE:          12,
    ON_BOARD_DIR:  13,
    ON_BOARD_POS:  14,
    PARAM:         15,
    LITERAL:       16,
    VERIFY:        20
};

Dagaz.Model.BuildDesign = function(design) {
    design.checkVersion("z2j", "2");
    design.checkVersion("animate-captures", "false");
    design.checkVersion("smart-moves", "false");
    design.checkVersion("show-blink", "false");
    design.checkVersion("show-hints", "false");
    design.checkVersion("advisor-wait", "25");
    design.checkVersion("shatranj-invariant", "true");

    design.addDirection("w");
    design.addDirection("e");
    design.addDirection("s");
    design.addDirection("ne");
    design.addDirection("n");
    design.addDirection("se");
    design.addDirection("sw");
    design.addDirection("nw");

    design.addPlayer("White", [1, 0, 4, 6, 2, 7, 3, 5]);
    design.addPlayer("Black", [0, 1, 4, 5, 2, 3, 7, 6]);

    design.addPosition("a8", [0, 1, 8, 0, 0, 9, 0, 0]);
    design.addPosition("b8", [-1, 1, 8, 0, 0, 9, 7, 0]);
    design.addPosition("c8", [-1, 1, 8, 0, 0, 9, 7, 0]);
    design.addPosition("d8", [-1, 1, 8, 0, 0, 9, 7, 0]);
    design.addPosition("e8", [-1, 1, 8, 0, 0, 9, 7, 0]);
    design.addPosition("f8", [-1, 1, 8, 0, 0, 9, 7, 0]);
    design.addPosition("g8", [-1, 1, 8, 0, 0, 9, 7, 0]);
    design.addPosition("h8", [-1, 0, 8, 0, 0, 0, 7, 0]);
    design.addPosition("a7", [0, 1, 8, -7, -8, 9, 0, 0]);
    design.addPosition("b7", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("c7", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("d7", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("e7", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("f7", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("g7", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("h7", [-1, 0, 8, 0, -8, 0, 7, -9]);
    design.addPosition("a6", [0, 1, 8, -7, -8, 9, 0, 0]);
    design.addPosition("b6", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("c6", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("d6", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("e6", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("f6", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("g6", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("h6", [-1, 0, 8, 0, -8, 0, 7, -9]);
    design.addPosition("a5", [0, 1, 8, -7, -8, 9, 0, 0]);
    design.addPosition("b5", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("c5", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("d5", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("e5", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("f5", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("g5", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("h5", [-1, 0, 8, 0, -8, 0, 7, -9]);
    design.addPosition("a4", [0, 1, 8, -7, -8, 9, 0, 0]);
    design.addPosition("b4", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("c4", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("d4", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("e4", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("f4", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("g4", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("h4", [-1, 0, 8, 0, -8, 0, 7, -9]);
    design.addPosition("a3", [0, 1, 8, -7, -8, 9, 0, 0]);
    design.addPosition("b3", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("c3", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("d3", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("e3", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("f3", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("g3", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("h3", [-1, 0, 8, 0, -8, 0, 7, -9]);
    design.addPosition("a2", [0, 1, 8, -7, -8, 9, 0, 0]);
    design.addPosition("b2", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("c2", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("d2", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("e2", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("f2", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("g2", [-1, 1, 8, -7, -8, 9, 7, -9]);
    design.addPosition("h2", [-1, 0, 8, 0, -8, 0, 7, -9]);
    design.addPosition("a1", [0, 1, 0, -7, -8, 0, 0, 0]);
    design.addPosition("b1", [-1, 1, 0, -7, -8, 0, 0, -9]);
    design.addPosition("c1", [-1, 1, 0, -7, -8, 0, 0, -9]);
    design.addPosition("d1", [-1, 1, 0, -7, -8, 0, 0, -9]);
    design.addPosition("e1", [-1, 1, 0, -7, -8, 0, 0, -9]);
    design.addPosition("f1", [-1, 1, 0, -7, -8, 0, 0, -9]);
    design.addPosition("g1", [-1, 1, 0, -7, -8, 0, 0, -9]);
    design.addPosition("h1", [-1, 0, 0, 0, -8, 0, 0, -9]);

    design.addZone("promotion", 1, [0, 1, 2, 3, 4, 5, 6, 7]);
    design.addZone("promotion", 2, [56, 57, 58, 59, 60, 61, 62, 63]);

    design.addCommand(0, ZRF.FUNCTION,	24);	// from
    design.addCommand(0, ZRF.PARAM,	0);	// $1
    design.addCommand(0, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(0, ZRF.FUNCTION,	3);	// friend?
    design.addCommand(0, ZRF.FUNCTION,	0);	// not
    design.addCommand(0, ZRF.FUNCTION,	20);	// verify
    design.addCommand(0, ZRF.FUNCTION,	25);	// to
    design.addCommand(0, ZRF.FUNCTION,	28);	// end

    design.addCommand(1, ZRF.FUNCTION,	24);	// from
    design.addCommand(1, ZRF.PARAM,	0);	// $1
    design.addCommand(1, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(1, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(1, ZRF.FUNCTION,	0);	// not
    design.addCommand(1, ZRF.IF,	7);
    design.addCommand(1, ZRF.FORK,	3);
    design.addCommand(1, ZRF.FUNCTION,	25);	// to
    design.addCommand(1, ZRF.FUNCTION,	28);	// end
    design.addCommand(1, ZRF.PARAM,	1);	// $2
    design.addCommand(1, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(1, ZRF.JUMP,	-8);
    design.addCommand(1, ZRF.FUNCTION,	3);	// friend?
    design.addCommand(1, ZRF.FUNCTION,	0);	// not
    design.addCommand(1, ZRF.FUNCTION,	20);	// verify
    design.addCommand(1, ZRF.FUNCTION,	25);	// to
    design.addCommand(1, ZRF.FUNCTION,	28);	// end

    design.addCommand(2, ZRF.FUNCTION,	24);	// from
    design.addCommand(2, ZRF.PARAM,	0);	// $1
    design.addCommand(2, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(2, ZRF.PARAM,	1);	// $2
    design.addCommand(2, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(2, ZRF.FUNCTION,	3);	// friend?
    design.addCommand(2, ZRF.FUNCTION,	0);	// not
    design.addCommand(2, ZRF.FUNCTION,	20);	// verify
    design.addCommand(2, ZRF.FUNCTION,	25);	// to
    design.addCommand(2, ZRF.FUNCTION,	28);	// end

    design.addCommand(3, ZRF.FUNCTION,	24);	// from
    design.addCommand(3, ZRF.PARAM,	0);	// $1
    design.addCommand(3, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(3, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(3, ZRF.FUNCTION,	20);	// verify
    design.addCommand(3, ZRF.IN_ZONE,	0);	// promotion
    design.addCommand(3, ZRF.FUNCTION,	0);	// not
    design.addCommand(3, ZRF.IF,	4);
    design.addCommand(3, ZRF.PROMOTE,	1);	// Fers
    design.addCommand(3, ZRF.FUNCTION,	25);	// to
    design.addCommand(3, ZRF.JUMP,	2);
    design.addCommand(3, ZRF.FUNCTION,	25);	// to
    design.addCommand(3, ZRF.FUNCTION,	28);	// end

    design.addCommand(4, ZRF.FUNCTION,	24);	// from
    design.addCommand(4, ZRF.PARAM,	0);	// $1
    design.addCommand(4, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(4, ZRF.FUNCTION,	2);	// enemy?
    design.addCommand(4, ZRF.FUNCTION,	20);	// verify
    design.addCommand(4, ZRF.IN_ZONE,	0);	// promotion
    design.addCommand(4, ZRF.FUNCTION,	0);	// not
    design.addCommand(4, ZRF.IF,	4);
    design.addCommand(4, ZRF.PROMOTE,	1);	// Fers
    design.addCommand(4, ZRF.FUNCTION,	25);	// to
    design.addCommand(4, ZRF.JUMP,	2);
    design.addCommand(4, ZRF.FUNCTION,	25);	// to
    design.addCommand(4, ZRF.FUNCTION,	28);	// end

    design.addPiece("Shah", 0, 1000);
    design.addMove(0, 0, [4], 0);
    design.addMove(0, 0, [2], 0);
    design.addMove(0, 0, [0], 0);
    design.addMove(0, 0, [1], 0);
    design.addMove(0, 0, [7], 0);
    design.addMove(0, 0, [6], 0);
    design.addMove(0, 0, [3], 0);
    design.addMove(0, 0, [5], 0);

    design.addPiece("Fers", 1, 4);
    design.addMove(1, 0, [7], 0);
    design.addMove(1, 0, [6], 0);
    design.addMove(1, 0, [3], 0);
    design.addMove(1, 0, [5], 0);

    design.addPiece("Rokh", 2, 20);
    design.addMove(2, 1, [4, 4], 0);
    design.addMove(2, 1, [2, 2], 0);
    design.addMove(2, 1, [0, 0], 0);
    design.addMove(2, 1, [1, 1], 0);

    design.addPiece("Alfil", 3, 3);
    design.addMove(3, 2, [7, 7], 0);
    design.addMove(3, 2, [3, 3], 0);
    design.addMove(3, 2, [6, 6], 0);
    design.addMove(3, 2, [5, 5], 0);

    design.addPiece("Asb", 4, 8);
    design.addMove(4, 2, [4, 7], 0);
    design.addMove(4, 2, [4, 3], 0);
    design.addMove(4, 2, [2, 6], 0);
    design.addMove(4, 2, [2, 5], 0);
    design.addMove(4, 2, [0, 7], 0);
    design.addMove(4, 2, [0, 6], 0);
    design.addMove(4, 2, [1, 3], 0);
    design.addMove(4, 2, [1, 5], 0);

    design.addPiece("Sarbaz", 5, 2);
    design.addMove(5, 3, [4], 0);
    design.addMove(5, 4, [7], 0);
    design.addMove(5, 4, [3], 0);

    design.setupSelector(93);

    design.setup("White", "Sarbaz", 48, 1);
    design.setup("White", "Sarbaz", 49, 1);
    design.setup("White", "Sarbaz", 50, 1);
    design.setup("White", "Sarbaz", 51, 1);
    design.setup("White", "Sarbaz", 52, 1);
    design.setup("White", "Sarbaz", 53, 1);
    design.setup("White", "Sarbaz", 54, 1);
    design.setup("White", "Sarbaz", 55, 1);
    design.setup("White", "Rokh", 56, 1);
    design.setup("White", "Rokh", 63, 1);
    design.setup("White", "Asb", 57, 1);
    design.setup("White", "Asb", 62, 1);
    design.setup("White", "Alfil", 58, 1);
    design.setup("White", "Alfil", 61, 1);
    design.setup("White", "Fers", 60, 1);
    design.setup("White", "Shah", 59, 1);
    design.setup("Black", "Sarbaz", 8, 1);
    design.setup("Black", "Sarbaz", 9, 1);
    design.setup("Black", "Sarbaz", 10, 1);
    design.setup("Black", "Sarbaz", 11, 1);
    design.setup("Black", "Sarbaz", 12, 1);
    design.setup("Black", "Sarbaz", 13, 1);
    design.setup("Black", "Sarbaz", 14, 1);
    design.setup("Black", "Sarbaz", 15, 1);
    design.setup("Black", "Rokh", 0, 1);
    design.setup("Black", "Rokh", 7, 1);
    design.setup("Black", "Asb", 1, 1);
    design.setup("Black", "Asb", 6, 1);
    design.setup("Black", "Alfil", 2, 1);
    design.setup("Black", "Alfil", 5, 1);
    design.setup("Black", "Fers", 4, 1);
    design.setup("Black", "Shah", 3, 1);

    design.setup("Black", "Sarbaz", 8, 2);
    design.setup("Black", "Sarbaz", 17, 2);
    design.setup("Black", "Sarbaz", 26, 2);
    design.setup("Black", "Sarbaz", 19, 2);
    design.setup("Black", "Sarbaz", 20, 2);
    design.setup("Black", "Sarbaz", 29, 2);
    design.setup("Black", "Sarbaz", 22, 2);
    design.setup("Black", "Sarbaz", 15, 2);
    design.setup("Black", "Rokh", 1, 2);
    design.setup("Black", "Rokh", 6, 2);
    design.setup("Black", "Asb", 18, 2);
    design.setup("Black", "Asb", 21, 2);
    design.setup("Black", "Alfil", 2, 2);
    design.setup("Black", "Alfil", 5, 2);
    design.setup("Black", "Fers", 4, 2);
    design.setup("Black", "Shah", 3, 2);
    design.setup("White", "Sarbaz", 32, 2);
    design.setup("White", "Sarbaz", 41, 2);
    design.setup("White", "Sarbaz", 42, 2);
    design.setup("White", "Sarbaz", 43, 2);
    design.setup("White", "Sarbaz", 36, 2);
    design.setup("White", "Sarbaz", 45, 2);
    design.setup("White", "Sarbaz", 54, 2);
    design.setup("White", "Sarbaz", 39, 2);
    design.setup("White", "Rokh", 57, 2);
    design.setup("White", "Rokh", 58, 2);
    design.setup("White", "Asb", 51, 2);
    design.setup("White", "Asb", 52, 2);
    design.setup("White", "Alfil", 40, 2);
    design.setup("White", "Alfil", 47, 2);
    design.setup("White", "Fers", 61, 2);
    design.setup("White", "Shah", 62, 2);

    design.setup("Black", "Sarbaz", 8, 3);
    design.setup("Black", "Sarbaz", 17, 3);
    design.setup("Black", "Sarbaz", 18, 3);
    design.setup("Black", "Sarbaz", 27, 3);
    design.setup("Black", "Sarbaz", 28, 3);
    design.setup("Black", "Sarbaz", 21, 3);
    design.setup("Black", "Sarbaz", 14, 3);
    design.setup("Black", "Sarbaz", 23, 3);
    design.setup("Black", "Rokh", 0, 3);
    design.setup("Black", "Rokh", 7, 3);
    design.setup("Black", "Asb", 11, 3);
    design.setup("Black", "Asb", 12, 3);
    design.setup("Black", "Alfil", 2, 3);
    design.setup("Black", "Alfil", 5, 3);
    design.setup("Black", "Fers", 19, 3);
    design.setup("Black", "Shah", 4, 3);
    design.setup("White", "Sarbaz", 32, 3);
    design.setup("White", "Sarbaz", 41, 3);
    design.setup("White", "Sarbaz", 42, 3);
    design.setup("White", "Sarbaz", 43, 3);
    design.setup("White", "Sarbaz", 36, 3);
    design.setup("White", "Sarbaz", 45, 3);
    design.setup("White", "Sarbaz", 54, 3);
    design.setup("White", "Sarbaz", 39, 3);
    design.setup("White", "Rokh", 57, 3);
    design.setup("White", "Rokh", 58, 3);
    design.setup("White", "Asb", 51, 3);
    design.setup("White", "Asb", 52, 3);
    design.setup("White", "Alfil", 40, 3);
    design.setup("White", "Alfil", 47, 3);
    design.setup("White", "Fers", 61, 3);
    design.setup("White", "Shah", 62, 3);

    design.setup("Black", "Sarbaz", 8, 4);
    design.setup("Black", "Sarbaz", 25, 4);
    design.setup("Black", "Sarbaz", 34, 4);
    design.setup("Black", "Sarbaz", 19, 4);
    design.setup("Black", "Sarbaz", 28, 4);
    design.setup("Black", "Sarbaz", 21, 4);
    design.setup("Black", "Sarbaz", 22, 4);
    design.setup("Black", "Sarbaz", 23, 4);
    design.setup("Black", "Rokh", 1, 4);
    design.setup("Black", "Rokh", 6, 4);
    design.setup("Black", "Asb", 18, 4);
    design.setup("Black", "Asb", 12, 4);
    design.setup("Black", "Alfil", 2, 4);
    design.setup("Black", "Alfil", 5, 4);
    design.setup("Black", "Fers", 20, 4);
    design.setup("Black", "Shah", 3, 4);
    design.setup("White", "Sarbaz", 32, 4);
    design.setup("White", "Sarbaz", 41, 4);
    design.setup("White", "Sarbaz", 42, 4);
    design.setup("White", "Sarbaz", 43, 4);
    design.setup("White", "Sarbaz", 36, 4);
    design.setup("White", "Sarbaz", 45, 4);
    design.setup("White", "Sarbaz", 54, 4);
    design.setup("White", "Sarbaz", 39, 4);
    design.setup("White", "Rokh", 57, 4);
    design.setup("White", "Rokh", 58, 4);
    design.setup("White", "Asb", 51, 4);
    design.setup("White", "Asb", 52, 4);
    design.setup("White", "Alfil", 40, 4);
    design.setup("White", "Alfil", 47, 4);
    design.setup("White", "Fers", 61, 4);
    design.setup("White", "Shah", 62, 4);

    design.setup("Black", "Sarbaz", 8, 5);
    design.setup("Black", "Sarbaz", 25, 5);
    design.setup("Black", "Sarbaz", 18, 5);
    design.setup("Black", "Sarbaz", 19, 5);
    design.setup("Black", "Sarbaz", 20, 5);
    design.setup("Black", "Sarbaz", 21, 5);
    design.setup("Black", "Sarbaz", 22, 5);
    design.setup("Black", "Sarbaz", 23, 5);
    design.setup("Black", "Rokh", 1, 5);
    design.setup("Black", "Rokh", 10, 5);
    design.setup("Black", "Asb", 11, 5);
    design.setup("Black", "Asb", 6, 5);
    design.setup("Black", "Alfil", 2, 5);
    design.setup("Black", "Alfil", 5, 5);
    design.setup("Black", "Fers", 4, 5);
    design.setup("Black", "Shah", 3, 5);
    design.setup("White", "Sarbaz", 32, 5);
    design.setup("White", "Sarbaz", 41, 5);
    design.setup("White", "Sarbaz", 42, 5);
    design.setup("White", "Sarbaz", 43, 5);
    design.setup("White", "Sarbaz", 36, 5);
    design.setup("White", "Sarbaz", 45, 5);
    design.setup("White", "Sarbaz", 54, 5);
    design.setup("White", "Sarbaz", 39, 5);
    design.setup("White", "Rokh", 57, 5);
    design.setup("White", "Rokh", 58, 5);
    design.setup("White", "Asb", 51, 5);
    design.setup("White", "Asb", 52, 5);
    design.setup("White", "Alfil", 40, 5);
    design.setup("White", "Alfil", 47, 5);
    design.setup("White", "Fers", 61, 5);
    design.setup("White", "Shah", 62, 5);

    design.setup("Black", "Sarbaz", 24, 6);
    design.setup("Black", "Sarbaz", 17, 6);
    design.setup("Black", "Sarbaz", 18, 6);
    design.setup("Black", "Sarbaz", 27, 6);
    design.setup("Black", "Sarbaz", 28, 6);
    design.setup("Black", "Sarbaz", 21, 6);
    design.setup("Black", "Sarbaz", 22, 6);
    design.setup("Black", "Sarbaz", 31, 6);
    design.setup("Black", "Rokh", 1, 6);
    design.setup("Black", "Rokh", 6, 6);
    design.setup("Black", "Asb", 11, 6);
    design.setup("Black", "Asb", 12, 6);
    design.setup("Black", "Alfil", 19, 6);
    design.setup("Black", "Alfil", 20, 6);
    design.setup("Black", "Fers", 10, 6);
    design.setup("Black", "Shah", 13, 6);
    design.setup("White", "Sarbaz", 32, 6);
    design.setup("White", "Sarbaz", 41, 6);
    design.setup("White", "Sarbaz", 42, 6);
    design.setup("White", "Sarbaz", 43, 6);
    design.setup("White", "Sarbaz", 36, 6);
    design.setup("White", "Sarbaz", 45, 6);
    design.setup("White", "Sarbaz", 54, 6);
    design.setup("White", "Sarbaz", 39, 6);
    design.setup("White", "Rokh", 57, 6);
    design.setup("White", "Rokh", 58, 6);
    design.setup("White", "Asb", 51, 6);
    design.setup("White", "Asb", 52, 6);
    design.setup("White", "Alfil", 40, 6);
    design.setup("White", "Alfil", 47, 6);
    design.setup("White", "Fers", 61, 6);
    design.setup("White", "Shah", 62, 6);

    design.setup("Black", "Sarbaz", 24, 7);
    design.setup("Black", "Sarbaz", 17, 7);
    design.setup("Black", "Sarbaz", 18, 7);
    design.setup("Black", "Sarbaz", 19, 7);
    design.setup("Black", "Sarbaz", 28, 7);
    design.setup("Black", "Sarbaz", 37, 7);
    design.setup("Black", "Sarbaz", 30, 7);
    design.setup("Black", "Rokh", 14, 7);
    design.setup("Black", "Rokh", 7, 7);
    design.setup("Black", "Asb", 11, 7);
    design.setup("Black", "Asb", 22, 7);
    design.setup("Black", "Alfil", 20, 7);
    design.setup("Black", "Alfil", 23, 7);
    design.setup("Black", "Fers", 21, 7);
    design.setup("Black", "Shah", 13, 7);
    design.setup("White", "Sarbaz", 32, 7);
    design.setup("White", "Sarbaz", 41, 7);
    design.setup("White", "Sarbaz", 42, 7);
    design.setup("White", "Sarbaz", 43, 7);
    design.setup("White", "Sarbaz", 36, 7);
    design.setup("White", "Sarbaz", 45, 7);
    design.setup("White", "Sarbaz", 54, 7);
    design.setup("White", "Sarbaz", 39, 7);
    design.setup("White", "Rokh", 57, 7);
    design.setup("White", "Rokh", 58, 7);
    design.setup("White", "Asb", 51, 7);
    design.setup("White", "Asb", 52, 7);
    design.setup("White", "Alfil", 40, 7);
    design.setup("White", "Alfil", 47, 7);
    design.setup("White", "Fers", 61, 7);
    design.setup("White", "Shah", 62, 7);

    design.setup("Black", "Sarbaz", 24, 8);
    design.setup("Black", "Sarbaz", 17, 8);
    design.setup("Black", "Sarbaz", 26, 8);
    design.setup("Black", "Sarbaz", 11, 8);
    design.setup("Black", "Sarbaz", 12, 8);
    design.setup("Black", "Sarbaz", 29, 8);
    design.setup("Black", "Sarbaz", 22, 8);
    design.setup("Black", "Sarbaz", 31, 8);
    design.setup("Black", "Rokh", 2, 8);
    design.setup("Black", "Rokh", 7, 8);
    design.setup("Black", "Asb", 18, 8);
    design.setup("Black", "Asb", 21, 8);
    design.setup("Black", "Alfil", 16, 8);
    design.setup("Black", "Alfil", 19, 8);
    design.setup("Black", "Fers", 20, 8);
    design.setup("Black", "Shah", 13, 8);
    design.setup("White", "Sarbaz", 32, 8);
    design.setup("White", "Sarbaz", 41, 8);
    design.setup("White", "Sarbaz", 42, 8);
    design.setup("White", "Sarbaz", 43, 8);
    design.setup("White", "Sarbaz", 36, 8);
    design.setup("White", "Sarbaz", 45, 8);
    design.setup("White", "Sarbaz", 54, 8);
    design.setup("White", "Sarbaz", 39, 8);
    design.setup("White", "Rokh", 57, 8);
    design.setup("White", "Rokh", 58, 8);
    design.setup("White", "Asb", 51, 8);
    design.setup("White", "Asb", 52, 8);
    design.setup("White", "Alfil", 40, 8);
    design.setup("White", "Alfil", 47, 8);
    design.setup("White", "Fers", 61, 8);
    design.setup("White", "Shah", 62, 8);

    design.setup("Black", "Sarbaz", 16, 9);
    design.setup("Black", "Sarbaz", 17, 9);
    design.setup("Black", "Sarbaz", 18, 9);
    design.setup("Black", "Sarbaz", 19, 9);
    design.setup("Black", "Sarbaz", 20, 9);
    design.setup("Black", "Sarbaz", 21, 9);
    design.setup("Black", "Sarbaz", 30, 9);
    design.setup("Black", "Sarbaz", 23, 9);
    design.setup("Black", "Rokh", 13, 9);
    design.setup("Black", "Rokh", 6, 9);
    design.setup("Black", "Asb", 11, 9);
    design.setup("Black", "Asb", 12, 9);
    design.setup("Black", "Alfil", 2, 9);
    design.setup("Black", "Alfil", 5, 9);
    design.setup("Black", "Fers", 4, 9);
    design.setup("Black", "Shah", 3, 9);
    design.setup("White", "Sarbaz", 32, 9);
    design.setup("White", "Sarbaz", 41, 9);
    design.setup("White", "Sarbaz", 42, 9);
    design.setup("White", "Sarbaz", 43, 9);
    design.setup("White", "Sarbaz", 36, 9);
    design.setup("White", "Sarbaz", 45, 9);
    design.setup("White", "Sarbaz", 54, 9);
    design.setup("White", "Sarbaz", 39, 9);
    design.setup("White", "Rokh", 57, 9);
    design.setup("White", "Rokh", 58, 9);
    design.setup("White", "Asb", 51, 9);
    design.setup("White", "Asb", 52, 9);
    design.setup("White", "Alfil", 40, 9);
    design.setup("White", "Alfil", 47, 9);
    design.setup("White", "Fers", 61, 9);
    design.setup("White", "Shah", 62, 9);

    design.setup("Black", "Sarbaz", 16, 10);
    design.setup("Black", "Sarbaz", 25, 10);
    design.setup("Black", "Sarbaz", 18, 10);
    design.setup("Black", "Sarbaz", 27, 10);
    design.setup("Black", "Sarbaz", 28, 10);
    design.setup("Black", "Sarbaz", 21, 10);
    design.setup("Black", "Sarbaz", 22, 10);
    design.setup("Black", "Sarbaz", 23, 10);
    design.setup("Black", "Rokh", 1, 10);
    design.setup("Black", "Rokh", 7, 10);
    design.setup("Black", "Asb", 10, 10);
    design.setup("Black", "Asb", 13, 10);
    design.setup("Black", "Alfil", 2, 10);
    design.setup("Black", "Alfil", 19, 10);
    design.setup("Black", "Fers", 20, 10);
    design.setup("Black", "Shah", 3, 10);
    design.setup("White", "Sarbaz", 32, 10);
    design.setup("White", "Sarbaz", 41, 10);
    design.setup("White", "Sarbaz", 42, 10);
    design.setup("White", "Sarbaz", 43, 10);
    design.setup("White", "Sarbaz", 36, 10);
    design.setup("White", "Sarbaz", 45, 10);
    design.setup("White", "Sarbaz", 54, 10);
    design.setup("White", "Sarbaz", 39, 10);
    design.setup("White", "Rokh", 57, 10);
    design.setup("White", "Rokh", 58, 10);
    design.setup("White", "Asb", 51, 10);
    design.setup("White", "Asb", 52, 10);
    design.setup("White", "Alfil", 40, 10);
    design.setup("White", "Alfil", 47, 10);
    design.setup("White", "Fers", 61, 10);
    design.setup("White", "Shah", 62, 10);

    design.setup("Black", "Sarbaz", 16, 11);
    design.setup("Black", "Sarbaz", 17, 11);
    design.setup("Black", "Sarbaz", 18, 11);
    design.setup("Black", "Sarbaz", 27, 11);
    design.setup("Black", "Sarbaz", 28, 11);
    design.setup("Black", "Sarbaz", 21, 11);
    design.setup("Black", "Sarbaz", 22, 11);
    design.setup("Black", "Sarbaz", 23, 11);
    design.setup("Black", "Rokh", 10, 11);
    design.setup("Black", "Rokh", 13, 11);
    design.setup("Black", "Asb", 11, 11);
    design.setup("Black", "Asb", 12, 11);
    design.setup("Black", "Alfil", 2, 11);
    design.setup("Black", "Alfil", 19, 11);
    design.setup("Black", "Fers", 20, 11);
    design.setup("Black", "Shah", 3, 11);
    design.setup("White", "Sarbaz", 32, 11);
    design.setup("White", "Sarbaz", 41, 11);
    design.setup("White", "Sarbaz", 42, 11);
    design.setup("White", "Sarbaz", 43, 11);
    design.setup("White", "Sarbaz", 36, 11);
    design.setup("White", "Sarbaz", 45, 11);
    design.setup("White", "Sarbaz", 54, 11);
    design.setup("White", "Sarbaz", 39, 11);
    design.setup("White", "Rokh", 57, 11);
    design.setup("White", "Rokh", 58, 11);
    design.setup("White", "Asb", 51, 11);
    design.setup("White", "Asb", 52, 11);
    design.setup("White", "Alfil", 40, 11);
    design.setup("White", "Alfil", 47, 11);
    design.setup("White", "Fers", 61, 11);
    design.setup("White", "Shah", 62, 11);

    design.setup("Black", "Sarbaz", 8, 12);
    design.setup("Black", "Sarbaz", 25, 12);
    design.setup("Black", "Sarbaz", 26, 12);
    design.setup("Black", "Sarbaz", 19, 12);
    design.setup("Black", "Sarbaz", 20, 12);
    design.setup("Black", "Sarbaz", 21, 12);
    design.setup("Black", "Sarbaz", 22, 12);
    design.setup("Black", "Sarbaz", 23, 12);
    design.setup("Black", "Rokh", 1, 12);
    design.setup("Black", "Rokh", 10, 12);
    design.setup("Black", "Asb", 11, 12);
    design.setup("Black", "Asb", 12, 12);
    design.setup("Black", "Alfil", 2, 12);
    design.setup("Black", "Alfil", 5, 12);
    design.setup("Black", "Fers", 18, 12);
    design.setup("Black", "Shah", 3, 12);
    design.setup("White", "Sarbaz", 32, 12);
    design.setup("White", "Sarbaz", 41, 12);
    design.setup("White", "Sarbaz", 42, 12);
    design.setup("White", "Sarbaz", 43, 12);
    design.setup("White", "Sarbaz", 36, 12);
    design.setup("White", "Sarbaz", 45, 12);
    design.setup("White", "Sarbaz", 54, 12);
    design.setup("White", "Sarbaz", 39, 12);
    design.setup("White", "Rokh", 57, 12);
    design.setup("White", "Rokh", 58, 12);
    design.setup("White", "Asb", 51, 12);
    design.setup("White", "Asb", 52, 12);
    design.setup("White", "Alfil", 40, 12);
    design.setup("White", "Alfil", 47, 12);
    design.setup("White", "Fers", 61, 12);
    design.setup("White", "Shah", 62, 12);

    design.setup("Black", "Sarbaz", 24, 13);
    design.setup("Black", "Sarbaz", 17, 13);
    design.setup("Black", "Sarbaz", 18, 13);
    design.setup("Black", "Sarbaz", 19, 13);
    design.setup("Black", "Sarbaz", 28, 13);
    design.setup("Black", "Sarbaz", 37, 13);
    design.setup("Black", "Sarbaz", 14, 13);
    design.setup("Black", "Sarbaz", 31, 13);
    design.setup("Black", "Rokh", 1, 13);
    design.setup("Black", "Rokh", 2, 13);
    design.setup("Black", "Asb", 11, 13);
    design.setup("Black", "Asb", 21, 13);
    design.setup("Black", "Alfil", 20, 13);
    design.setup("Black", "Alfil", 23, 13);
    design.setup("Black", "Fers", 5, 13);
    design.setup("Black", "Shah", 6, 13);
    design.setup("White", "Sarbaz", 32, 13);
    design.setup("White", "Sarbaz", 41, 13);
    design.setup("White", "Sarbaz", 42, 13);
    design.setup("White", "Sarbaz", 43, 13);
    design.setup("White", "Sarbaz", 36, 13);
    design.setup("White", "Sarbaz", 45, 13);
    design.setup("White", "Sarbaz", 54, 13);
    design.setup("White", "Sarbaz", 39, 13);
    design.setup("White", "Rokh", 57, 13);
    design.setup("White", "Rokh", 58, 13);
    design.setup("White", "Asb", 51, 13);
    design.setup("White", "Asb", 52, 13);
    design.setup("White", "Alfil", 40, 13);
    design.setup("White", "Alfil", 47, 13);
    design.setup("White", "Fers", 61, 13);
    design.setup("White", "Shah", 62, 13);

    design.setup("Black", "Sarbaz", 8, 14);
    design.setup("Black", "Sarbaz", 17, 14);
    design.setup("Black", "Sarbaz", 26, 14);
    design.setup("Black", "Sarbaz", 19, 14);
    design.setup("Black", "Sarbaz", 20, 14);
    design.setup("Black", "Sarbaz", 29, 14);
    design.setup("Black", "Sarbaz", 22, 14);
    design.setup("Black", "Sarbaz", 15, 14);
    design.setup("Black", "Rokh", 1, 14);
    design.setup("Black", "Rokh", 6, 14);
    design.setup("Black", "Asb", 18, 14);
    design.setup("Black", "Asb", 21, 14);
    design.setup("Black", "Alfil", 2, 14);
    design.setup("Black", "Alfil", 5, 14);
    design.setup("Black", "Fers", 4, 14);
    design.setup("Black", "Shah", 3, 14);
    design.setup("White", "Sarbaz", 32, 14);
    design.setup("White", "Sarbaz", 41, 14);
    design.setup("White", "Sarbaz", 42, 14);
    design.setup("White", "Sarbaz", 43, 14);
    design.setup("White", "Sarbaz", 36, 14);
    design.setup("White", "Sarbaz", 45, 14);
    design.setup("White", "Sarbaz", 54, 14);
    design.setup("White", "Sarbaz", 39, 14);
    design.setup("White", "Rokh", 57, 14);
    design.setup("White", "Rokh", 58, 14);
    design.setup("White", "Asb", 51, 14);
    design.setup("White", "Asb", 52, 14);
    design.setup("White", "Alfil", 40, 14);
    design.setup("White", "Alfil", 47, 14);
    design.setup("White", "Fers", 61, 14);
    design.setup("White", "Shah", 62, 14);

    design.setup("Black", "Sarbaz", 8, 15);
    design.setup("Black", "Sarbaz", 17, 15);
    design.setup("Black", "Sarbaz", 18, 15);
    design.setup("Black", "Sarbaz", 27, 15);
    design.setup("Black", "Sarbaz", 28, 15);
    design.setup("Black", "Sarbaz", 21, 15);
    design.setup("Black", "Sarbaz", 14, 15);
    design.setup("Black", "Sarbaz", 23, 15);
    design.setup("Black", "Rokh", 0, 15);
    design.setup("Black", "Rokh", 7, 15);
    design.setup("Black", "Asb", 11, 15);
    design.setup("Black", "Asb", 12, 15);
    design.setup("Black", "Alfil", 2, 15);
    design.setup("Black", "Alfil", 5, 15);
    design.setup("Black", "Fers", 19, 15);
    design.setup("Black", "Shah", 4, 15);
    design.setup("White", "Sarbaz", 32, 15);
    design.setup("White", "Sarbaz", 41, 15);
    design.setup("White", "Sarbaz", 42, 15);
    design.setup("White", "Sarbaz", 43, 15);
    design.setup("White", "Sarbaz", 36, 15);
    design.setup("White", "Sarbaz", 45, 15);
    design.setup("White", "Sarbaz", 54, 15);
    design.setup("White", "Sarbaz", 39, 15);
    design.setup("White", "Rokh", 57, 15);
    design.setup("White", "Rokh", 58, 15);
    design.setup("White", "Asb", 51, 15);
    design.setup("White", "Asb", 52, 15);
    design.setup("White", "Alfil", 40, 15);
    design.setup("White", "Alfil", 47, 15);
    design.setup("White", "Fers", 61, 15);
    design.setup("White", "Shah", 62, 15);

    design.setup("Black", "Sarbaz", 8, 16);
    design.setup("Black", "Sarbaz", 25, 16);
    design.setup("Black", "Sarbaz", 34, 16);
    design.setup("Black", "Sarbaz", 19, 16);
    design.setup("Black", "Sarbaz", 28, 16);
    design.setup("Black", "Sarbaz", 21, 16);
    design.setup("Black", "Sarbaz", 22, 16);
    design.setup("Black", "Sarbaz", 23, 16);
    design.setup("Black", "Rokh", 1, 16);
    design.setup("Black", "Rokh", 6, 16);
    design.setup("Black", "Asb", 18, 16);
    design.setup("Black", "Asb", 12, 16);
    design.setup("Black", "Alfil", 2, 16);
    design.setup("Black", "Alfil", 5, 16);
    design.setup("Black", "Fers", 20, 16);
    design.setup("Black", "Shah", 3, 16);
    design.setup("White", "Sarbaz", 32, 16);
    design.setup("White", "Sarbaz", 41, 16);
    design.setup("White", "Sarbaz", 42, 16);
    design.setup("White", "Sarbaz", 43, 16);
    design.setup("White", "Sarbaz", 36, 16);
    design.setup("White", "Sarbaz", 45, 16);
    design.setup("White", "Sarbaz", 54, 16);
    design.setup("White", "Sarbaz", 39, 16);
    design.setup("White", "Rokh", 57, 16);
    design.setup("White", "Rokh", 58, 16);
    design.setup("White", "Asb", 51, 16);
    design.setup("White", "Asb", 52, 16);
    design.setup("White", "Alfil", 40, 16);
    design.setup("White", "Alfil", 47, 16);
    design.setup("White", "Fers", 61, 16);
    design.setup("White", "Shah", 62, 16);

    design.setup("Black", "Sarbaz", 8, 17);
    design.setup("Black", "Sarbaz", 25, 17);
    design.setup("Black", "Sarbaz", 18, 17);
    design.setup("Black", "Sarbaz", 19, 17);
    design.setup("Black", "Sarbaz", 20, 17);
    design.setup("Black", "Sarbaz", 21, 17);
    design.setup("Black", "Sarbaz", 22, 17);
    design.setup("Black", "Sarbaz", 23, 17);
    design.setup("Black", "Rokh", 1, 17);
    design.setup("Black", "Rokh", 10, 17);
    design.setup("Black", "Asb", 11, 17);
    design.setup("Black", "Asb", 6, 17);
    design.setup("Black", "Alfil", 2, 17);
    design.setup("Black", "Alfil", 5, 17);
    design.setup("Black", "Fers", 4, 17);
    design.setup("Black", "Shah", 3, 17);
    design.setup("White", "Sarbaz", 32, 17);
    design.setup("White", "Sarbaz", 41, 17);
    design.setup("White", "Sarbaz", 42, 17);
    design.setup("White", "Sarbaz", 43, 17);
    design.setup("White", "Sarbaz", 36, 17);
    design.setup("White", "Sarbaz", 45, 17);
    design.setup("White", "Sarbaz", 54, 17);
    design.setup("White", "Sarbaz", 39, 17);
    design.setup("White", "Rokh", 57, 17);
    design.setup("White", "Rokh", 58, 17);
    design.setup("White", "Asb", 51, 17);
    design.setup("White", "Asb", 52, 17);
    design.setup("White", "Alfil", 40, 17);
    design.setup("White", "Alfil", 47, 17);
    design.setup("White", "Fers", 61, 17);
    design.setup("White", "Shah", 62, 17);

    design.setup("Black", "Sarbaz", 24, 18);
    design.setup("Black", "Sarbaz", 17, 18);
    design.setup("Black", "Sarbaz", 18, 18);
    design.setup("Black", "Sarbaz", 27, 18);
    design.setup("Black", "Sarbaz", 28, 18);
    design.setup("Black", "Sarbaz", 21, 18);
    design.setup("Black", "Sarbaz", 22, 18);
    design.setup("Black", "Sarbaz", 31, 18);
    design.setup("Black", "Rokh", 1, 18);
    design.setup("Black", "Rokh", 6, 18);
    design.setup("Black", "Asb", 11, 18);
    design.setup("Black", "Asb", 12, 18);
    design.setup("Black", "Alfil", 19, 18);
    design.setup("Black", "Alfil", 20, 18);
    design.setup("Black", "Fers", 10, 18);
    design.setup("Black", "Shah", 13, 18);
    design.setup("White", "Sarbaz", 32, 18);
    design.setup("White", "Sarbaz", 41, 18);
    design.setup("White", "Sarbaz", 42, 18);
    design.setup("White", "Sarbaz", 43, 18);
    design.setup("White", "Sarbaz", 36, 18);
    design.setup("White", "Sarbaz", 45, 18);
    design.setup("White", "Sarbaz", 54, 18);
    design.setup("White", "Sarbaz", 39, 18);
    design.setup("White", "Rokh", 57, 18);
    design.setup("White", "Rokh", 58, 18);
    design.setup("White", "Asb", 51, 18);
    design.setup("White", "Asb", 52, 18);
    design.setup("White", "Alfil", 40, 18);
    design.setup("White", "Alfil", 47, 18);
    design.setup("White", "Fers", 61, 18);
    design.setup("White", "Shah", 62, 18);

    design.setup("Black", "Sarbaz", 24, 19);
    design.setup("Black", "Sarbaz", 17, 19);
    design.setup("Black", "Sarbaz", 18, 19);
    design.setup("Black", "Sarbaz", 19, 19);
    design.setup("Black", "Sarbaz", 28, 19);
    design.setup("Black", "Sarbaz", 37, 19);
    design.setup("Black", "Sarbaz", 30, 19);
    design.setup("Black", "Rokh", 14, 19);
    design.setup("Black", "Rokh", 7, 19);
    design.setup("Black", "Asb", 11, 19);
    design.setup("Black", "Asb", 22, 19);
    design.setup("Black", "Alfil", 20, 19);
    design.setup("Black", "Alfil", 23, 19);
    design.setup("Black", "Fers", 21, 19);
    design.setup("Black", "Shah", 13, 19);
    design.setup("White", "Sarbaz", 32, 19);
    design.setup("White", "Sarbaz", 41, 19);
    design.setup("White", "Sarbaz", 42, 19);
    design.setup("White", "Sarbaz", 43, 19);
    design.setup("White", "Sarbaz", 36, 19);
    design.setup("White", "Sarbaz", 45, 19);
    design.setup("White", "Sarbaz", 54, 19);
    design.setup("White", "Sarbaz", 39, 19);
    design.setup("White", "Rokh", 57, 19);
    design.setup("White", "Rokh", 58, 19);
    design.setup("White", "Asb", 51, 19);
    design.setup("White", "Asb", 52, 19);
    design.setup("White", "Alfil", 40, 19);
    design.setup("White", "Alfil", 47, 19);
    design.setup("White", "Fers", 61, 19);
    design.setup("White", "Shah", 62, 19);

    design.setup("Black", "Sarbaz", 24, 20);
    design.setup("Black", "Sarbaz", 17, 20);
    design.setup("Black", "Sarbaz", 26, 20);
    design.setup("Black", "Sarbaz", 11, 20);
    design.setup("Black", "Sarbaz", 12, 20);
    design.setup("Black", "Sarbaz", 29, 20);
    design.setup("Black", "Sarbaz", 22, 20);
    design.setup("Black", "Sarbaz", 31, 20);
    design.setup("Black", "Rokh", 2, 20);
    design.setup("Black", "Rokh", 7, 20);
    design.setup("Black", "Asb", 18, 20);
    design.setup("Black", "Asb", 21, 20);
    design.setup("Black", "Alfil", 16, 20);
    design.setup("Black", "Alfil", 19, 20);
    design.setup("Black", "Fers", 20, 20);
    design.setup("Black", "Shah", 13, 20);
    design.setup("White", "Sarbaz", 32, 20);
    design.setup("White", "Sarbaz", 41, 20);
    design.setup("White", "Sarbaz", 42, 20);
    design.setup("White", "Sarbaz", 43, 20);
    design.setup("White", "Sarbaz", 36, 20);
    design.setup("White", "Sarbaz", 45, 20);
    design.setup("White", "Sarbaz", 54, 20);
    design.setup("White", "Sarbaz", 39, 20);
    design.setup("White", "Rokh", 57, 20);
    design.setup("White", "Rokh", 58, 20);
    design.setup("White", "Asb", 51, 20);
    design.setup("White", "Asb", 52, 20);
    design.setup("White", "Alfil", 40, 20);
    design.setup("White", "Alfil", 47, 20);
    design.setup("White", "Fers", 61, 20);
    design.setup("White", "Shah", 62, 20);

    design.setup("Black", "Sarbaz", 16, 21);
    design.setup("Black", "Sarbaz", 17, 21);
    design.setup("Black", "Sarbaz", 18, 21);
    design.setup("Black", "Sarbaz", 19, 21);
    design.setup("Black", "Sarbaz", 20, 21);
    design.setup("Black", "Sarbaz", 21, 21);
    design.setup("Black", "Sarbaz", 30, 21);
    design.setup("Black", "Sarbaz", 23, 21);
    design.setup("Black", "Rokh", 13, 21);
    design.setup("Black", "Rokh", 6, 21);
    design.setup("Black", "Asb", 11, 21);
    design.setup("Black", "Asb", 12, 21);
    design.setup("Black", "Alfil", 2, 21);
    design.setup("Black", "Alfil", 5, 21);
    design.setup("Black", "Fers", 4, 21);
    design.setup("Black", "Shah", 3, 21);
    design.setup("White", "Sarbaz", 32, 21);
    design.setup("White", "Sarbaz", 41, 21);
    design.setup("White", "Sarbaz", 42, 21);
    design.setup("White", "Sarbaz", 43, 21);
    design.setup("White", "Sarbaz", 36, 21);
    design.setup("White", "Sarbaz", 45, 21);
    design.setup("White", "Sarbaz", 54, 21);
    design.setup("White", "Sarbaz", 39, 21);
    design.setup("White", "Rokh", 57, 21);
    design.setup("White", "Rokh", 58, 21);
    design.setup("White", "Asb", 51, 21);
    design.setup("White", "Asb", 52, 21);
    design.setup("White", "Alfil", 40, 21);
    design.setup("White", "Alfil", 47, 21);
    design.setup("White", "Fers", 61, 21);
    design.setup("White", "Shah", 62, 21);

    design.setup("Black", "Sarbaz", 16, 22);
    design.setup("Black", "Sarbaz", 25, 22);
    design.setup("Black", "Sarbaz", 18, 22);
    design.setup("Black", "Sarbaz", 27, 22);
    design.setup("Black", "Sarbaz", 28, 22);
    design.setup("Black", "Sarbaz", 21, 22);
    design.setup("Black", "Sarbaz", 22, 22);
    design.setup("Black", "Sarbaz", 23, 22);
    design.setup("Black", "Rokh", 1, 22);
    design.setup("Black", "Rokh", 7, 22);
    design.setup("Black", "Asb", 10, 22);
    design.setup("Black", "Asb", 13, 22);
    design.setup("Black", "Alfil", 2, 22);
    design.setup("Black", "Alfil", 19, 22);
    design.setup("Black", "Fers", 20, 22);
    design.setup("Black", "Shah", 3, 22);
    design.setup("White", "Sarbaz", 32, 22);
    design.setup("White", "Sarbaz", 41, 22);
    design.setup("White", "Sarbaz", 42, 22);
    design.setup("White", "Sarbaz", 43, 22);
    design.setup("White", "Sarbaz", 36, 22);
    design.setup("White", "Sarbaz", 45, 22);
    design.setup("White", "Sarbaz", 54, 22);
    design.setup("White", "Sarbaz", 39, 22);
    design.setup("White", "Rokh", 57, 22);
    design.setup("White", "Rokh", 58, 22);
    design.setup("White", "Asb", 51, 22);
    design.setup("White", "Asb", 52, 22);
    design.setup("White", "Alfil", 40, 22);
    design.setup("White", "Alfil", 47, 22);
    design.setup("White", "Fers", 61, 22);
    design.setup("White", "Shah", 62, 22);

    design.setup("Black", "Sarbaz", 16, 23);
    design.setup("Black", "Sarbaz", 17, 23);
    design.setup("Black", "Sarbaz", 18, 23);
    design.setup("Black", "Sarbaz", 27, 23);
    design.setup("Black", "Sarbaz", 28, 23);
    design.setup("Black", "Sarbaz", 21, 23);
    design.setup("Black", "Sarbaz", 22, 23);
    design.setup("Black", "Sarbaz", 23, 23);
    design.setup("Black", "Rokh", 10, 23);
    design.setup("Black", "Rokh", 13, 23);
    design.setup("Black", "Asb", 11, 23);
    design.setup("Black", "Asb", 12, 23);
    design.setup("Black", "Alfil", 2, 23);
    design.setup("Black", "Alfil", 19, 23);
    design.setup("Black", "Fers", 20, 23);
    design.setup("Black", "Shah", 3, 23);
    design.setup("White", "Sarbaz", 32, 23);
    design.setup("White", "Sarbaz", 41, 23);
    design.setup("White", "Sarbaz", 42, 23);
    design.setup("White", "Sarbaz", 43, 23);
    design.setup("White", "Sarbaz", 36, 23);
    design.setup("White", "Sarbaz", 45, 23);
    design.setup("White", "Sarbaz", 54, 23);
    design.setup("White", "Sarbaz", 39, 23);
    design.setup("White", "Rokh", 57, 23);
    design.setup("White", "Rokh", 58, 23);
    design.setup("White", "Asb", 51, 23);
    design.setup("White", "Asb", 52, 23);
    design.setup("White", "Alfil", 40, 23);
    design.setup("White", "Alfil", 47, 23);
    design.setup("White", "Fers", 61, 23);
    design.setup("White", "Shah", 62, 23);

    design.setup("Black", "Sarbaz", 8, 24);
    design.setup("Black", "Sarbaz", 25, 24);
    design.setup("Black", "Sarbaz", 26, 24);
    design.setup("Black", "Sarbaz", 19, 24);
    design.setup("Black", "Sarbaz", 20, 24);
    design.setup("Black", "Sarbaz", 21, 24);
    design.setup("Black", "Sarbaz", 22, 24);
    design.setup("Black", "Sarbaz", 23, 24);
    design.setup("Black", "Rokh", 1, 24);
    design.setup("Black", "Rokh", 10, 24);
    design.setup("Black", "Asb", 11, 24);
    design.setup("Black", "Asb", 12, 24);
    design.setup("Black", "Alfil", 2, 24);
    design.setup("Black", "Alfil", 5, 24);
    design.setup("Black", "Fers", 18, 24);
    design.setup("Black", "Shah", 3, 24);
    design.setup("White", "Sarbaz", 32, 24);
    design.setup("White", "Sarbaz", 41, 24);
    design.setup("White", "Sarbaz", 42, 24);
    design.setup("White", "Sarbaz", 43, 24);
    design.setup("White", "Sarbaz", 36, 24);
    design.setup("White", "Sarbaz", 45, 24);
    design.setup("White", "Sarbaz", 54, 24);
    design.setup("White", "Sarbaz", 39, 24);
    design.setup("White", "Rokh", 57, 24);
    design.setup("White", "Rokh", 58, 24);
    design.setup("White", "Asb", 51, 24);
    design.setup("White", "Asb", 52, 24);
    design.setup("White", "Alfil", 40, 24);
    design.setup("White", "Alfil", 47, 24);
    design.setup("White", "Fers", 61, 24);
    design.setup("White", "Shah", 62, 24);

    design.setup("Black", "Sarbaz", 24, 25);
    design.setup("Black", "Sarbaz", 17, 25);
    design.setup("Black", "Sarbaz", 18, 25);
    design.setup("Black", "Sarbaz", 27, 25);
    design.setup("Black", "Sarbaz", 28, 25);
    design.setup("Black", "Sarbaz", 21, 25);
    design.setup("Black", "Sarbaz", 22, 25);
    design.setup("Black", "Sarbaz", 31, 25);
    design.setup("Black", "Rokh", 1, 25);
    design.setup("Black", "Rokh", 6, 25);
    design.setup("Black", "Asb", 11, 25);
    design.setup("Black", "Asb", 12, 25);
    design.setup("Black", "Alfil", 19, 25);
    design.setup("Black", "Alfil", 20, 25);
    design.setup("Black", "Fers", 10, 25);
    design.setup("Black", "Shah", 13, 25);
    design.setup("White", "Sarbaz", 32, 25);
    design.setup("White", "Sarbaz", 41, 25);
    design.setup("White", "Sarbaz", 34, 25);
    design.setup("White", "Sarbaz", 51, 25);
    design.setup("White", "Sarbaz", 52, 25);
    design.setup("White", "Sarbaz", 37, 25);
    design.setup("White", "Sarbaz", 46, 25);
    design.setup("White", "Sarbaz", 39, 25);
    design.setup("White", "Rokh", 58, 25);
    design.setup("White", "Rokh", 63, 25);
    design.setup("White", "Asb", 42, 25);
    design.setup("White", "Asb", 45, 25);
    design.setup("White", "Alfil", 40, 25);
    design.setup("White", "Alfil", 43, 25);
    design.setup("White", "Fers", 44, 25);
    design.setup("White", "Shah", 53, 25);

    design.setup("Black", "Sarbaz", 8, 26);
    design.setup("Black", "Sarbaz", 17, 26);
    design.setup("Black", "Sarbaz", 26, 26);
    design.setup("Black", "Sarbaz", 19, 26);
    design.setup("Black", "Sarbaz", 20, 26);
    design.setup("Black", "Sarbaz", 29, 26);
    design.setup("Black", "Sarbaz", 22, 26);
    design.setup("Black", "Sarbaz", 15, 26);
    design.setup("Black", "Rokh", 1, 26);
    design.setup("Black", "Rokh", 6, 26);
    design.setup("Black", "Asb", 18, 26);
    design.setup("Black", "Asb", 21, 26);
    design.setup("Black", "Alfil", 2, 26);
    design.setup("Black", "Alfil", 5, 26);
    design.setup("Black", "Fers", 4, 26);
    design.setup("Black", "Shah", 3, 26);
    design.setup("White", "Sarbaz", 32, 26);
    design.setup("White", "Sarbaz", 41, 26);
    design.setup("White", "Sarbaz", 34, 26);
    design.setup("White", "Sarbaz", 51, 26);
    design.setup("White", "Sarbaz", 52, 26);
    design.setup("White", "Sarbaz", 37, 26);
    design.setup("White", "Sarbaz", 46, 26);
    design.setup("White", "Sarbaz", 39, 26);
    design.setup("White", "Rokh", 58, 26);
    design.setup("White", "Rokh", 63, 26);
    design.setup("White", "Asb", 42, 26);
    design.setup("White", "Asb", 45, 26);
    design.setup("White", "Alfil", 40, 26);
    design.setup("White", "Alfil", 43, 26);
    design.setup("White", "Fers", 44, 26);
    design.setup("White", "Shah", 53, 26);

    design.setup("Black", "Sarbaz", 8, 27);
    design.setup("Black", "Sarbaz", 17, 27);
    design.setup("Black", "Sarbaz", 18, 27);
    design.setup("Black", "Sarbaz", 27, 27);
    design.setup("Black", "Sarbaz", 28, 27);
    design.setup("Black", "Sarbaz", 21, 27);
    design.setup("Black", "Sarbaz", 14, 27);
    design.setup("Black", "Sarbaz", 23, 27);
    design.setup("Black", "Rokh", 0, 27);
    design.setup("Black", "Rokh", 7, 27);
    design.setup("Black", "Asb", 11, 27);
    design.setup("Black", "Asb", 12, 27);
    design.setup("Black", "Alfil", 2, 27);
    design.setup("Black", "Alfil", 5, 27);
    design.setup("Black", "Fers", 19, 27);
    design.setup("Black", "Shah", 4, 27);
    design.setup("White", "Sarbaz", 32, 27);
    design.setup("White", "Sarbaz", 41, 27);
    design.setup("White", "Sarbaz", 34, 27);
    design.setup("White", "Sarbaz", 51, 27);
    design.setup("White", "Sarbaz", 52, 27);
    design.setup("White", "Sarbaz", 37, 27);
    design.setup("White", "Sarbaz", 46, 27);
    design.setup("White", "Sarbaz", 39, 27);
    design.setup("White", "Rokh", 58, 27);
    design.setup("White", "Rokh", 63, 27);
    design.setup("White", "Asb", 42, 27);
    design.setup("White", "Asb", 45, 27);
    design.setup("White", "Alfil", 40, 27);
    design.setup("White", "Alfil", 43, 27);
    design.setup("White", "Fers", 44, 27);
    design.setup("White", "Shah", 53, 27);

    design.setup("Black", "Sarbaz", 8, 28);
    design.setup("Black", "Sarbaz", 25, 28);
    design.setup("Black", "Sarbaz", 26, 28);
    design.setup("Black", "Sarbaz", 19, 28);
    design.setup("Black", "Sarbaz", 20, 28);
    design.setup("Black", "Sarbaz", 21, 28);
    design.setup("Black", "Sarbaz", 22, 28);
    design.setup("Black", "Sarbaz", 23, 28);
    design.setup("Black", "Rokh", 1, 28);
    design.setup("Black", "Rokh", 10, 28);
    design.setup("Black", "Asb", 11, 28);
    design.setup("Black", "Asb", 12, 28);
    design.setup("Black", "Alfil", 2, 28);
    design.setup("Black", "Alfil", 5, 28);
    design.setup("Black", "Fers", 18, 28);
    design.setup("Black", "Shah", 3, 28);
    design.setup("White", "Sarbaz", 32, 28);
    design.setup("White", "Sarbaz", 41, 28);
    design.setup("White", "Sarbaz", 34, 28);
    design.setup("White", "Sarbaz", 51, 28);
    design.setup("White", "Sarbaz", 52, 28);
    design.setup("White", "Sarbaz", 37, 28);
    design.setup("White", "Sarbaz", 46, 28);
    design.setup("White", "Sarbaz", 39, 28);
    design.setup("White", "Rokh", 58, 28);
    design.setup("White", "Rokh", 63, 28);
    design.setup("White", "Asb", 42, 28);
    design.setup("White", "Asb", 45, 28);
    design.setup("White", "Alfil", 40, 28);
    design.setup("White", "Alfil", 43, 28);
    design.setup("White", "Fers", 44, 28);
    design.setup("White", "Shah", 53, 28);

    design.setup("Black", "Sarbaz", 8, 29);
    design.setup("Black", "Sarbaz", 25, 29);
    design.setup("Black", "Sarbaz", 18, 29);
    design.setup("Black", "Sarbaz", 19, 29);
    design.setup("Black", "Sarbaz", 20, 29);
    design.setup("Black", "Sarbaz", 21, 29);
    design.setup("Black", "Sarbaz", 22, 29);
    design.setup("Black", "Sarbaz", 23, 29);
    design.setup("Black", "Rokh", 1, 29);
    design.setup("Black", "Rokh", 10, 29);
    design.setup("Black", "Asb", 11, 29);
    design.setup("Black", "Asb", 6, 29);
    design.setup("Black", "Alfil", 2, 29);
    design.setup("Black", "Alfil", 5, 29);
    design.setup("Black", "Fers", 4, 29);
    design.setup("Black", "Shah", 3, 29);
    design.setup("White", "Sarbaz", 32, 29);
    design.setup("White", "Sarbaz", 41, 29);
    design.setup("White", "Sarbaz", 34, 29);
    design.setup("White", "Sarbaz", 51, 29);
    design.setup("White", "Sarbaz", 52, 29);
    design.setup("White", "Sarbaz", 37, 29);
    design.setup("White", "Sarbaz", 46, 29);
    design.setup("White", "Sarbaz", 39, 29);
    design.setup("White", "Rokh", 58, 29);
    design.setup("White", "Rokh", 63, 29);
    design.setup("White", "Asb", 42, 29);
    design.setup("White", "Asb", 45, 29);
    design.setup("White", "Alfil", 40, 29);
    design.setup("White", "Alfil", 43, 29);
    design.setup("White", "Fers", 44, 29);
    design.setup("White", "Shah", 53, 29);

    design.setup("Black", "Sarbaz", 16, 30);
    design.setup("Black", "Sarbaz", 25, 30);
    design.setup("Black", "Sarbaz", 18, 30);
    design.setup("Black", "Sarbaz", 27, 30);
    design.setup("Black", "Sarbaz", 28, 30);
    design.setup("Black", "Sarbaz", 21, 30);
    design.setup("Black", "Sarbaz", 22, 30);
    design.setup("Black", "Sarbaz", 23, 30);
    design.setup("Black", "Rokh", 1, 30);
    design.setup("Black", "Rokh", 7, 30);
    design.setup("Black", "Asb", 10, 30);
    design.setup("Black", "Asb", 13, 30);
    design.setup("Black", "Alfil", 2, 30);
    design.setup("Black", "Alfil", 19, 30);
    design.setup("Black", "Fers", 20, 30);
    design.setup("Black", "Shah", 3, 30);
    design.setup("White", "Sarbaz", 32, 30);
    design.setup("White", "Sarbaz", 41, 30);
    design.setup("White", "Sarbaz", 34, 30);
    design.setup("White", "Sarbaz", 51, 30);
    design.setup("White", "Sarbaz", 52, 30);
    design.setup("White", "Sarbaz", 37, 30);
    design.setup("White", "Sarbaz", 46, 30);
    design.setup("White", "Sarbaz", 39, 30);
    design.setup("White", "Rokh", 58, 30);
    design.setup("White", "Rokh", 63, 30);
    design.setup("White", "Asb", 42, 30);
    design.setup("White", "Asb", 45, 30);
    design.setup("White", "Alfil", 40, 30);
    design.setup("White", "Alfil", 43, 30);
    design.setup("White", "Fers", 44, 30);
    design.setup("White", "Shah", 53, 30);

    design.setup("Black", "Sarbaz", 16, 31);
    design.setup("Black", "Sarbaz", 17, 31);
    design.setup("Black", "Sarbaz", 18, 31);
    design.setup("Black", "Sarbaz", 27, 31);
    design.setup("Black", "Sarbaz", 28, 31);
    design.setup("Black", "Sarbaz", 21, 31);
    design.setup("Black", "Sarbaz", 22, 31);
    design.setup("Black", "Sarbaz", 23, 31);
    design.setup("Black", "Rokh", 10, 31);
    design.setup("Black", "Rokh", 13, 31);
    design.setup("Black", "Asb", 11, 31);
    design.setup("Black", "Asb", 12, 31);
    design.setup("Black", "Alfil", 2, 31);
    design.setup("Black", "Alfil", 19, 31);
    design.setup("Black", "Fers", 20, 31);
    design.setup("Black", "Shah", 3, 31);
    design.setup("White", "Sarbaz", 32, 31);
    design.setup("White", "Sarbaz", 41, 31);
    design.setup("White", "Sarbaz", 34, 31);
    design.setup("White", "Sarbaz", 51, 31);
    design.setup("White", "Sarbaz", 52, 31);
    design.setup("White", "Sarbaz", 37, 31);
    design.setup("White", "Sarbaz", 46, 31);
    design.setup("White", "Sarbaz", 39, 31);
    design.setup("White", "Rokh", 58, 31);
    design.setup("White", "Rokh", 63, 31);
    design.setup("White", "Asb", 42, 31);
    design.setup("White", "Asb", 45, 31);
    design.setup("White", "Alfil", 40, 31);
    design.setup("White", "Alfil", 43, 31);
    design.setup("White", "Fers", 44, 31);
    design.setup("White", "Shah", 53, 31);

    design.setup("Black", "Sarbaz", 24, 32);
    design.setup("Black", "Sarbaz", 17, 32);
    design.setup("Black", "Sarbaz", 26, 32);
    design.setup("Black", "Sarbaz", 11, 32);
    design.setup("Black", "Sarbaz", 12, 32);
    design.setup("Black", "Sarbaz", 29, 32);
    design.setup("Black", "Sarbaz", 22, 32);
    design.setup("Black", "Sarbaz", 31, 32);
    design.setup("Black", "Rokh", 2, 32);
    design.setup("Black", "Rokh", 7, 32);
    design.setup("Black", "Asb", 18, 32);
    design.setup("Black", "Asb", 21, 32);
    design.setup("Black", "Alfil", 16, 32);
    design.setup("Black", "Alfil", 19, 32);
    design.setup("Black", "Fers", 20, 32);
    design.setup("Black", "Shah", 13, 32);
    design.setup("White", "Sarbaz", 32, 32);
    design.setup("White", "Sarbaz", 41, 32);
    design.setup("White", "Sarbaz", 34, 32);
    design.setup("White", "Sarbaz", 51, 32);
    design.setup("White", "Sarbaz", 52, 32);
    design.setup("White", "Sarbaz", 37, 32);
    design.setup("White", "Sarbaz", 46, 32);
    design.setup("White", "Sarbaz", 39, 32);
    design.setup("White", "Rokh", 58, 32);
    design.setup("White", "Rokh", 63, 32);
    design.setup("White", "Asb", 42, 32);
    design.setup("White", "Asb", 45, 32);
    design.setup("White", "Alfil", 40, 32);
    design.setup("White", "Alfil", 43, 32);
    design.setup("White", "Fers", 44, 32);
    design.setup("White", "Shah", 53, 32);

    design.setup("Black", "Sarbaz", 16, 33);
    design.setup("Black", "Sarbaz", 17, 33);
    design.setup("Black", "Sarbaz", 18, 33);
    design.setup("Black", "Sarbaz", 19, 33);
    design.setup("Black", "Sarbaz", 20, 33);
    design.setup("Black", "Sarbaz", 21, 33);
    design.setup("Black", "Sarbaz", 30, 33);
    design.setup("Black", "Sarbaz", 23, 33);
    design.setup("Black", "Rokh", 13, 33);
    design.setup("Black", "Rokh", 6, 33);
    design.setup("Black", "Asb", 11, 33);
    design.setup("Black", "Asb", 12, 33);
    design.setup("Black", "Alfil", 2, 33);
    design.setup("Black", "Alfil", 5, 33);
    design.setup("Black", "Fers", 4, 33);
    design.setup("Black", "Shah", 3, 33);
    design.setup("White", "Sarbaz", 32, 33);
    design.setup("White", "Sarbaz", 41, 33);
    design.setup("White", "Sarbaz", 34, 33);
    design.setup("White", "Sarbaz", 51, 33);
    design.setup("White", "Sarbaz", 52, 33);
    design.setup("White", "Sarbaz", 37, 33);
    design.setup("White", "Sarbaz", 46, 33);
    design.setup("White", "Sarbaz", 39, 33);
    design.setup("White", "Rokh", 58, 33);
    design.setup("White", "Rokh", 63, 33);
    design.setup("White", "Asb", 42, 33);
    design.setup("White", "Asb", 45, 33);
    design.setup("White", "Alfil", 40, 33);
    design.setup("White", "Alfil", 43, 33);
    design.setup("White", "Fers", 44, 33);
    design.setup("White", "Shah", 53, 33);

    design.setup("Black", "Sarbaz", 24, 34);
    design.setup("Black", "Sarbaz", 17, 34);
    design.setup("Black", "Sarbaz", 18, 34);
    design.setup("Black", "Sarbaz", 27, 34);
    design.setup("Black", "Sarbaz", 28, 34);
    design.setup("Black", "Sarbaz", 21, 34);
    design.setup("Black", "Sarbaz", 22, 34);
    design.setup("Black", "Sarbaz", 31, 34);
    design.setup("Black", "Rokh", 1, 34);
    design.setup("Black", "Rokh", 6, 34);
    design.setup("Black", "Asb", 11, 34);
    design.setup("Black", "Asb", 12, 34);
    design.setup("Black", "Alfil", 19, 34);
    design.setup("Black", "Alfil", 20, 34);
    design.setup("Black", "Fers", 10, 34);
    design.setup("Black", "Shah", 13, 34);
    design.setup("White", "Sarbaz", 40, 34);
    design.setup("White", "Sarbaz", 41, 34);
    design.setup("White", "Sarbaz", 42, 34);
    design.setup("White", "Sarbaz", 43, 34);
    design.setup("White", "Sarbaz", 44, 34);
    design.setup("White", "Sarbaz", 45, 34);
    design.setup("White", "Sarbaz", 38, 34);
    design.setup("White", "Sarbaz", 47, 34);
    design.setup("White", "Rokh", 53, 34);
    design.setup("White", "Rokh", 62, 34);
    design.setup("White", "Asb", 51, 34);
    design.setup("White", "Asb", 52, 34);
    design.setup("White", "Alfil", 58, 34);
    design.setup("White", "Alfil", 61, 34);
    design.setup("White", "Fers", 60, 34);
    design.setup("White", "Shah", 59, 34);

    design.setup("Black", "Sarbaz", 8, 35);
    design.setup("Black", "Sarbaz", 17, 35);
    design.setup("Black", "Sarbaz", 26, 35);
    design.setup("Black", "Sarbaz", 19, 35);
    design.setup("Black", "Sarbaz", 20, 35);
    design.setup("Black", "Sarbaz", 29, 35);
    design.setup("Black", "Sarbaz", 22, 35);
    design.setup("Black", "Sarbaz", 15, 35);
    design.setup("Black", "Rokh", 1, 35);
    design.setup("Black", "Rokh", 6, 35);
    design.setup("Black", "Asb", 18, 35);
    design.setup("Black", "Asb", 21, 35);
    design.setup("Black", "Alfil", 2, 35);
    design.setup("Black", "Alfil", 5, 35);
    design.setup("Black", "Fers", 4, 35);
    design.setup("Black", "Shah", 3, 35);
    design.setup("White", "Sarbaz", 40, 35);
    design.setup("White", "Sarbaz", 41, 35);
    design.setup("White", "Sarbaz", 42, 35);
    design.setup("White", "Sarbaz", 43, 35);
    design.setup("White", "Sarbaz", 44, 35);
    design.setup("White", "Sarbaz", 45, 35);
    design.setup("White", "Sarbaz", 38, 35);
    design.setup("White", "Sarbaz", 47, 35);
    design.setup("White", "Rokh", 53, 35);
    design.setup("White", "Rokh", 62, 35);
    design.setup("White", "Asb", 51, 35);
    design.setup("White", "Asb", 52, 35);
    design.setup("White", "Alfil", 58, 35);
    design.setup("White", "Alfil", 61, 35);
    design.setup("White", "Fers", 60, 35);
    design.setup("White", "Shah", 59, 35);

    design.setup("Black", "Sarbaz", 8, 36);
    design.setup("Black", "Sarbaz", 17, 36);
    design.setup("Black", "Sarbaz", 18, 36);
    design.setup("Black", "Sarbaz", 27, 36);
    design.setup("Black", "Sarbaz", 28, 36);
    design.setup("Black", "Sarbaz", 21, 36);
    design.setup("Black", "Sarbaz", 14, 36);
    design.setup("Black", "Sarbaz", 23, 36);
    design.setup("Black", "Rokh", 0, 36);
    design.setup("Black", "Rokh", 7, 36);
    design.setup("Black", "Asb", 11, 36);
    design.setup("Black", "Asb", 12, 36);
    design.setup("Black", "Alfil", 2, 36);
    design.setup("Black", "Alfil", 5, 36);
    design.setup("Black", "Fers", 19, 36);
    design.setup("Black", "Shah", 4, 36);
    design.setup("White", "Sarbaz", 40, 36);
    design.setup("White", "Sarbaz", 41, 36);
    design.setup("White", "Sarbaz", 42, 36);
    design.setup("White", "Sarbaz", 43, 36);
    design.setup("White", "Sarbaz", 44, 36);
    design.setup("White", "Sarbaz", 45, 36);
    design.setup("White", "Sarbaz", 38, 36);
    design.setup("White", "Sarbaz", 47, 36);
    design.setup("White", "Rokh", 53, 36);
    design.setup("White", "Rokh", 62, 36);
    design.setup("White", "Asb", 51, 36);
    design.setup("White", "Asb", 52, 36);
    design.setup("White", "Alfil", 58, 36);
    design.setup("White", "Alfil", 61, 36);
    design.setup("White", "Fers", 60, 36);
    design.setup("White", "Shah", 59, 36);

    design.setup("Black", "Sarbaz", 8, 37);
    design.setup("Black", "Sarbaz", 25, 37);
    design.setup("Black", "Sarbaz", 34, 37);
    design.setup("Black", "Sarbaz", 19, 37);
    design.setup("Black", "Sarbaz", 28, 37);
    design.setup("Black", "Sarbaz", 21, 37);
    design.setup("Black", "Sarbaz", 22, 37);
    design.setup("Black", "Sarbaz", 23, 37);
    design.setup("Black", "Rokh", 1, 37);
    design.setup("Black", "Rokh", 6, 37);
    design.setup("Black", "Asb", 18, 37);
    design.setup("Black", "Asb", 12, 37);
    design.setup("Black", "Alfil", 2, 37);
    design.setup("Black", "Alfil", 5, 37);
    design.setup("Black", "Fers", 20, 37);
    design.setup("Black", "Shah", 3, 37);
    design.setup("White", "Sarbaz", 40, 37);
    design.setup("White", "Sarbaz", 41, 37);
    design.setup("White", "Sarbaz", 42, 37);
    design.setup("White", "Sarbaz", 43, 37);
    design.setup("White", "Sarbaz", 44, 37);
    design.setup("White", "Sarbaz", 45, 37);
    design.setup("White", "Sarbaz", 38, 37);
    design.setup("White", "Sarbaz", 47, 37);
    design.setup("White", "Rokh", 53, 37);
    design.setup("White", "Rokh", 62, 37);
    design.setup("White", "Asb", 51, 37);
    design.setup("White", "Asb", 52, 37);
    design.setup("White", "Alfil", 58, 37);
    design.setup("White", "Alfil", 61, 37);
    design.setup("White", "Fers", 60, 37);
    design.setup("White", "Shah", 59, 37);

    design.setup("Black", "Sarbaz", 8, 38);
    design.setup("Black", "Sarbaz", 25, 38);
    design.setup("Black", "Sarbaz", 18, 38);
    design.setup("Black", "Sarbaz", 19, 38);
    design.setup("Black", "Sarbaz", 20, 38);
    design.setup("Black", "Sarbaz", 21, 38);
    design.setup("Black", "Sarbaz", 22, 38);
    design.setup("Black", "Sarbaz", 23, 38);
    design.setup("Black", "Rokh", 1, 38);
    design.setup("Black", "Rokh", 10, 38);
    design.setup("Black", "Asb", 11, 38);
    design.setup("Black", "Asb", 6, 38);
    design.setup("Black", "Alfil", 2, 38);
    design.setup("Black", "Alfil", 5, 38);
    design.setup("Black", "Fers", 4, 38);
    design.setup("Black", "Shah", 3, 38);
    design.setup("White", "Sarbaz", 40, 38);
    design.setup("White", "Sarbaz", 41, 38);
    design.setup("White", "Sarbaz", 42, 38);
    design.setup("White", "Sarbaz", 43, 38);
    design.setup("White", "Sarbaz", 44, 38);
    design.setup("White", "Sarbaz", 45, 38);
    design.setup("White", "Sarbaz", 38, 38);
    design.setup("White", "Sarbaz", 47, 38);
    design.setup("White", "Rokh", 53, 38);
    design.setup("White", "Rokh", 62, 38);
    design.setup("White", "Asb", 51, 38);
    design.setup("White", "Asb", 52, 38);
    design.setup("White", "Alfil", 58, 38);
    design.setup("White", "Alfil", 61, 38);
    design.setup("White", "Fers", 60, 38);
    design.setup("White", "Shah", 59, 38);

    design.setup("Black", "Sarbaz", 24, 39);
    design.setup("Black", "Sarbaz", 17, 39);
    design.setup("Black", "Sarbaz", 18, 39);
    design.setup("Black", "Sarbaz", 19, 39);
    design.setup("Black", "Sarbaz", 28, 39);
    design.setup("Black", "Sarbaz", 37, 39);
    design.setup("Black", "Sarbaz", 14, 39);
    design.setup("Black", "Sarbaz", 31, 39);
    design.setup("Black", "Rokh", 1, 39);
    design.setup("Black", "Rokh", 2, 39);
    design.setup("Black", "Asb", 11, 39);
    design.setup("Black", "Asb", 21, 39);
    design.setup("Black", "Alfil", 20, 39);
    design.setup("Black", "Alfil", 23, 39);
    design.setup("Black", "Fers", 5, 39);
    design.setup("Black", "Shah", 6, 39);
    design.setup("White", "Sarbaz", 40, 39);
    design.setup("White", "Sarbaz", 41, 39);
    design.setup("White", "Sarbaz", 42, 39);
    design.setup("White", "Sarbaz", 43, 39);
    design.setup("White", "Sarbaz", 44, 39);
    design.setup("White", "Sarbaz", 45, 39);
    design.setup("White", "Sarbaz", 38, 39);
    design.setup("White", "Sarbaz", 47, 39);
    design.setup("White", "Rokh", 53, 39);
    design.setup("White", "Rokh", 62, 39);
    design.setup("White", "Asb", 51, 39);
    design.setup("White", "Asb", 52, 39);
    design.setup("White", "Alfil", 58, 39);
    design.setup("White", "Alfil", 61, 39);
    design.setup("White", "Fers", 60, 39);
    design.setup("White", "Shah", 59, 39);

    design.setup("Black", "Sarbaz", 24, 40);
    design.setup("Black", "Sarbaz", 17, 40);
    design.setup("Black", "Sarbaz", 18, 40);
    design.setup("Black", "Sarbaz", 19, 40);
    design.setup("Black", "Sarbaz", 28, 40);
    design.setup("Black", "Sarbaz", 37, 40);
    design.setup("Black", "Sarbaz", 30, 40);
    design.setup("Black", "Rokh", 14, 40);
    design.setup("Black", "Rokh", 7, 40);
    design.setup("Black", "Asb", 11, 40);
    design.setup("Black", "Asb", 22, 40);
    design.setup("Black", "Alfil", 20, 40);
    design.setup("Black", "Alfil", 23, 40);
    design.setup("Black", "Fers", 21, 40);
    design.setup("Black", "Shah", 13, 40);
    design.setup("White", "Sarbaz", 40, 40);
    design.setup("White", "Sarbaz", 41, 40);
    design.setup("White", "Sarbaz", 42, 40);
    design.setup("White", "Sarbaz", 43, 40);
    design.setup("White", "Sarbaz", 44, 40);
    design.setup("White", "Sarbaz", 45, 40);
    design.setup("White", "Sarbaz", 38, 40);
    design.setup("White", "Sarbaz", 47, 40);
    design.setup("White", "Rokh", 53, 40);
    design.setup("White", "Rokh", 62, 40);
    design.setup("White", "Asb", 51, 40);
    design.setup("White", "Asb", 52, 40);
    design.setup("White", "Alfil", 58, 40);
    design.setup("White", "Alfil", 61, 40);
    design.setup("White", "Fers", 60, 40);
    design.setup("White", "Shah", 59, 40);

    design.setup("Black", "Sarbaz", 24, 41);
    design.setup("Black", "Sarbaz", 17, 41);
    design.setup("Black", "Sarbaz", 26, 41);
    design.setup("Black", "Sarbaz", 11, 41);
    design.setup("Black", "Sarbaz", 12, 41);
    design.setup("Black", "Sarbaz", 29, 41);
    design.setup("Black", "Sarbaz", 22, 41);
    design.setup("Black", "Sarbaz", 31, 41);
    design.setup("Black", "Rokh", 2, 41);
    design.setup("Black", "Rokh", 7, 41);
    design.setup("Black", "Asb", 18, 41);
    design.setup("Black", "Asb", 21, 41);
    design.setup("Black", "Alfil", 16, 41);
    design.setup("Black", "Alfil", 19, 41);
    design.setup("Black", "Fers", 20, 41);
    design.setup("Black", "Shah", 13, 41);
    design.setup("White", "Sarbaz", 40, 41);
    design.setup("White", "Sarbaz", 41, 41);
    design.setup("White", "Sarbaz", 42, 41);
    design.setup("White", "Sarbaz", 43, 41);
    design.setup("White", "Sarbaz", 44, 41);
    design.setup("White", "Sarbaz", 45, 41);
    design.setup("White", "Sarbaz", 38, 41);
    design.setup("White", "Sarbaz", 47, 41);
    design.setup("White", "Rokh", 53, 41);
    design.setup("White", "Rokh", 62, 41);
    design.setup("White", "Asb", 51, 41);
    design.setup("White", "Asb", 52, 41);
    design.setup("White", "Alfil", 58, 41);
    design.setup("White", "Alfil", 61, 41);
    design.setup("White", "Fers", 60, 41);
    design.setup("White", "Shah", 59, 41);

    design.setup("Black", "Sarbaz", 16, 42);
    design.setup("Black", "Sarbaz", 17, 42);
    design.setup("Black", "Sarbaz", 18, 42);
    design.setup("Black", "Sarbaz", 19, 42);
    design.setup("Black", "Sarbaz", 20, 42);
    design.setup("Black", "Sarbaz", 21, 42);
    design.setup("Black", "Sarbaz", 30, 42);
    design.setup("Black", "Sarbaz", 23, 42);
    design.setup("Black", "Rokh", 13, 42);
    design.setup("Black", "Rokh", 6, 42);
    design.setup("Black", "Asb", 11, 42);
    design.setup("Black", "Asb", 12, 42);
    design.setup("Black", "Alfil", 2, 42);
    design.setup("Black", "Alfil", 5, 42);
    design.setup("Black", "Fers", 4, 42);
    design.setup("Black", "Shah", 3, 42);
    design.setup("White", "Sarbaz", 40, 42);
    design.setup("White", "Sarbaz", 41, 42);
    design.setup("White", "Sarbaz", 42, 42);
    design.setup("White", "Sarbaz", 43, 42);
    design.setup("White", "Sarbaz", 44, 42);
    design.setup("White", "Sarbaz", 45, 42);
    design.setup("White", "Sarbaz", 38, 42);
    design.setup("White", "Sarbaz", 47, 42);
    design.setup("White", "Rokh", 53, 42);
    design.setup("White", "Rokh", 62, 42);
    design.setup("White", "Asb", 51, 42);
    design.setup("White", "Asb", 52, 42);
    design.setup("White", "Alfil", 58, 42);
    design.setup("White", "Alfil", 61, 42);
    design.setup("White", "Fers", 60, 42);
    design.setup("White", "Shah", 59, 42);

    design.setup("Black", "Sarbaz", 16, 43);
    design.setup("Black", "Sarbaz", 25, 43);
    design.setup("Black", "Sarbaz", 18, 43);
    design.setup("Black", "Sarbaz", 27, 43);
    design.setup("Black", "Sarbaz", 28, 43);
    design.setup("Black", "Sarbaz", 21, 43);
    design.setup("Black", "Sarbaz", 22, 43);
    design.setup("Black", "Sarbaz", 23, 43);
    design.setup("Black", "Rokh", 1, 43);
    design.setup("Black", "Rokh", 7, 43);
    design.setup("Black", "Asb", 10, 43);
    design.setup("Black", "Asb", 13, 43);
    design.setup("Black", "Alfil", 2, 43);
    design.setup("Black", "Alfil", 19, 43);
    design.setup("Black", "Fers", 20, 43);
    design.setup("Black", "Shah", 3, 43);
    design.setup("White", "Sarbaz", 40, 43);
    design.setup("White", "Sarbaz", 41, 43);
    design.setup("White", "Sarbaz", 42, 43);
    design.setup("White", "Sarbaz", 43, 43);
    design.setup("White", "Sarbaz", 44, 43);
    design.setup("White", "Sarbaz", 45, 43);
    design.setup("White", "Sarbaz", 38, 43);
    design.setup("White", "Sarbaz", 47, 43);
    design.setup("White", "Rokh", 53, 43);
    design.setup("White", "Rokh", 62, 43);
    design.setup("White", "Asb", 51, 43);
    design.setup("White", "Asb", 52, 43);
    design.setup("White", "Alfil", 58, 43);
    design.setup("White", "Alfil", 61, 43);
    design.setup("White", "Fers", 60, 43);
    design.setup("White", "Shah", 59, 43);

    design.setup("Black", "Sarbaz", 16, 44);
    design.setup("Black", "Sarbaz", 17, 44);
    design.setup("Black", "Sarbaz", 18, 44);
    design.setup("Black", "Sarbaz", 27, 44);
    design.setup("Black", "Sarbaz", 28, 44);
    design.setup("Black", "Sarbaz", 21, 44);
    design.setup("Black", "Sarbaz", 22, 44);
    design.setup("Black", "Sarbaz", 23, 44);
    design.setup("Black", "Rokh", 10, 44);
    design.setup("Black", "Rokh", 13, 44);
    design.setup("Black", "Asb", 11, 44);
    design.setup("Black", "Asb", 12, 44);
    design.setup("Black", "Alfil", 2, 44);
    design.setup("Black", "Alfil", 19, 44);
    design.setup("Black", "Fers", 20, 44);
    design.setup("Black", "Shah", 3, 44);
    design.setup("White", "Sarbaz", 40, 44);
    design.setup("White", "Sarbaz", 41, 44);
    design.setup("White", "Sarbaz", 42, 44);
    design.setup("White", "Sarbaz", 43, 44);
    design.setup("White", "Sarbaz", 44, 44);
    design.setup("White", "Sarbaz", 45, 44);
    design.setup("White", "Sarbaz", 38, 44);
    design.setup("White", "Sarbaz", 47, 44);
    design.setup("White", "Rokh", 53, 44);
    design.setup("White", "Rokh", 62, 44);
    design.setup("White", "Asb", 51, 44);
    design.setup("White", "Asb", 52, 44);
    design.setup("White", "Alfil", 58, 44);
    design.setup("White", "Alfil", 61, 44);
    design.setup("White", "Fers", 60, 44);
    design.setup("White", "Shah", 59, 44);

    design.setup("Black", "Sarbaz", 8, 45);
    design.setup("Black", "Sarbaz", 25, 45);
    design.setup("Black", "Sarbaz", 26, 45);
    design.setup("Black", "Sarbaz", 19, 45);
    design.setup("Black", "Sarbaz", 20, 45);
    design.setup("Black", "Sarbaz", 21, 45);
    design.setup("Black", "Sarbaz", 22, 45);
    design.setup("Black", "Sarbaz", 23, 45);
    design.setup("Black", "Rokh", 1, 45);
    design.setup("Black", "Rokh", 10, 45);
    design.setup("Black", "Asb", 11, 45);
    design.setup("Black", "Asb", 12, 45);
    design.setup("Black", "Alfil", 2, 45);
    design.setup("Black", "Alfil", 5, 45);
    design.setup("Black", "Fers", 18, 45);
    design.setup("Black", "Shah", 3, 45);
    design.setup("White", "Sarbaz", 40, 45);
    design.setup("White", "Sarbaz", 41, 45);
    design.setup("White", "Sarbaz", 42, 45);
    design.setup("White", "Sarbaz", 43, 45);
    design.setup("White", "Sarbaz", 44, 45);
    design.setup("White", "Sarbaz", 45, 45);
    design.setup("White", "Sarbaz", 38, 45);
    design.setup("White", "Sarbaz", 47, 45);
    design.setup("White", "Rokh", 53, 45);
    design.setup("White", "Rokh", 62, 45);
    design.setup("White", "Asb", 51, 45);
    design.setup("White", "Asb", 52, 45);
    design.setup("White", "Alfil", 58, 45);
    design.setup("White", "Alfil", 61, 45);
    design.setup("White", "Fers", 60, 45);
    design.setup("White", "Shah", 59, 45);

    design.setup("Black", "Sarbaz", 24, 46);
    design.setup("Black", "Sarbaz", 17, 46);
    design.setup("Black", "Sarbaz", 18, 46);
    design.setup("Black", "Sarbaz", 27, 46);
    design.setup("Black", "Sarbaz", 28, 46);
    design.setup("Black", "Sarbaz", 21, 46);
    design.setup("Black", "Sarbaz", 22, 46);
    design.setup("Black", "Sarbaz", 31, 46);
    design.setup("Black", "Rokh", 1, 46);
    design.setup("Black", "Rokh", 6, 46);
    design.setup("Black", "Asb", 11, 46);
    design.setup("Black", "Asb", 12, 46);
    design.setup("Black", "Alfil", 19, 46);
    design.setup("Black", "Alfil", 20, 46);
    design.setup("Black", "Fers", 10, 46);
    design.setup("Black", "Shah", 13, 46);
    design.setup("White", "Sarbaz", 40, 46);
    design.setup("White", "Sarbaz", 33, 46);
    design.setup("White", "Sarbaz", 42, 46);
    design.setup("White", "Sarbaz", 35, 46);
    design.setup("White", "Sarbaz", 36, 46);
    design.setup("White", "Sarbaz", 45, 46);
    design.setup("White", "Sarbaz", 46, 46);
    design.setup("White", "Sarbaz", 47, 46);
    design.setup("White", "Rokh", 57, 46);
    design.setup("White", "Rokh", 63, 46);
    design.setup("White", "Asb", 50, 46);
    design.setup("White", "Asb", 53, 46);
    design.setup("White", "Alfil", 58, 46);
    design.setup("White", "Alfil", 43, 46);
    design.setup("White", "Fers", 44, 46);
    design.setup("White", "Shah", 59, 46);

    design.setup("Black", "Sarbaz", 8, 47);
    design.setup("Black", "Sarbaz", 17, 47);
    design.setup("Black", "Sarbaz", 26, 47);
    design.setup("Black", "Sarbaz", 19, 47);
    design.setup("Black", "Sarbaz", 20, 47);
    design.setup("Black", "Sarbaz", 29, 47);
    design.setup("Black", "Sarbaz", 22, 47);
    design.setup("Black", "Sarbaz", 15, 47);
    design.setup("Black", "Rokh", 1, 47);
    design.setup("Black", "Rokh", 6, 47);
    design.setup("Black", "Asb", 18, 47);
    design.setup("Black", "Asb", 21, 47);
    design.setup("Black", "Alfil", 2, 47);
    design.setup("Black", "Alfil", 5, 47);
    design.setup("Black", "Fers", 4, 47);
    design.setup("Black", "Shah", 3, 47);
    design.setup("White", "Sarbaz", 40, 47);
    design.setup("White", "Sarbaz", 33, 47);
    design.setup("White", "Sarbaz", 42, 47);
    design.setup("White", "Sarbaz", 35, 47);
    design.setup("White", "Sarbaz", 36, 47);
    design.setup("White", "Sarbaz", 45, 47);
    design.setup("White", "Sarbaz", 46, 47);
    design.setup("White", "Sarbaz", 47, 47);
    design.setup("White", "Rokh", 57, 47);
    design.setup("White", "Rokh", 63, 47);
    design.setup("White", "Asb", 50, 47);
    design.setup("White", "Asb", 53, 47);
    design.setup("White", "Alfil", 58, 47);
    design.setup("White", "Alfil", 43, 47);
    design.setup("White", "Fers", 44, 47);
    design.setup("White", "Shah", 59, 47);

    design.setup("Black", "Sarbaz", 8, 48);
    design.setup("Black", "Sarbaz", 17, 48);
    design.setup("Black", "Sarbaz", 18, 48);
    design.setup("Black", "Sarbaz", 27, 48);
    design.setup("Black", "Sarbaz", 28, 48);
    design.setup("Black", "Sarbaz", 21, 48);
    design.setup("Black", "Sarbaz", 14, 48);
    design.setup("Black", "Sarbaz", 23, 48);
    design.setup("Black", "Rokh", 0, 48);
    design.setup("Black", "Rokh", 7, 48);
    design.setup("Black", "Asb", 11, 48);
    design.setup("Black", "Asb", 12, 48);
    design.setup("Black", "Alfil", 2, 48);
    design.setup("Black", "Alfil", 5, 48);
    design.setup("Black", "Fers", 19, 48);
    design.setup("Black", "Shah", 4, 48);
    design.setup("White", "Sarbaz", 40, 48);
    design.setup("White", "Sarbaz", 33, 48);
    design.setup("White", "Sarbaz", 42, 48);
    design.setup("White", "Sarbaz", 35, 48);
    design.setup("White", "Sarbaz", 36, 48);
    design.setup("White", "Sarbaz", 45, 48);
    design.setup("White", "Sarbaz", 46, 48);
    design.setup("White", "Sarbaz", 47, 48);
    design.setup("White", "Rokh", 57, 48);
    design.setup("White", "Rokh", 63, 48);
    design.setup("White", "Asb", 50, 48);
    design.setup("White", "Asb", 53, 48);
    design.setup("White", "Alfil", 58, 48);
    design.setup("White", "Alfil", 43, 48);
    design.setup("White", "Fers", 44, 48);
    design.setup("White", "Shah", 59, 48);

    design.setup("Black", "Sarbaz", 8, 49);
    design.setup("Black", "Sarbaz", 25, 49);
    design.setup("Black", "Sarbaz", 34, 49);
    design.setup("Black", "Sarbaz", 19, 49);
    design.setup("Black", "Sarbaz", 28, 49);
    design.setup("Black", "Sarbaz", 21, 49);
    design.setup("Black", "Sarbaz", 22, 49);
    design.setup("Black", "Sarbaz", 23, 49);
    design.setup("Black", "Rokh", 1, 49);
    design.setup("Black", "Rokh", 6, 49);
    design.setup("Black", "Asb", 18, 49);
    design.setup("Black", "Asb", 12, 49);
    design.setup("Black", "Alfil", 2, 49);
    design.setup("Black", "Alfil", 5, 49);
    design.setup("Black", "Fers", 20, 49);
    design.setup("Black", "Shah", 3, 49);
    design.setup("White", "Sarbaz", 40, 49);
    design.setup("White", "Sarbaz", 33, 49);
    design.setup("White", "Sarbaz", 42, 49);
    design.setup("White", "Sarbaz", 35, 49);
    design.setup("White", "Sarbaz", 36, 49);
    design.setup("White", "Sarbaz", 45, 49);
    design.setup("White", "Sarbaz", 46, 49);
    design.setup("White", "Sarbaz", 47, 49);
    design.setup("White", "Rokh", 57, 49);
    design.setup("White", "Rokh", 63, 49);
    design.setup("White", "Asb", 50, 49);
    design.setup("White", "Asb", 53, 49);
    design.setup("White", "Alfil", 58, 49);
    design.setup("White", "Alfil", 43, 49);
    design.setup("White", "Fers", 44, 49);
    design.setup("White", "Shah", 59, 49);

    design.setup("Black", "Sarbaz", 8, 50);
    design.setup("Black", "Sarbaz", 25, 50);
    design.setup("Black", "Sarbaz", 18, 50);
    design.setup("Black", "Sarbaz", 19, 50);
    design.setup("Black", "Sarbaz", 20, 50);
    design.setup("Black", "Sarbaz", 21, 50);
    design.setup("Black", "Sarbaz", 22, 50);
    design.setup("Black", "Sarbaz", 23, 50);
    design.setup("Black", "Rokh", 1, 50);
    design.setup("Black", "Rokh", 10, 50);
    design.setup("Black", "Asb", 11, 50);
    design.setup("Black", "Asb", 6, 50);
    design.setup("Black", "Alfil", 2, 50);
    design.setup("Black", "Alfil", 5, 50);
    design.setup("Black", "Fers", 4, 50);
    design.setup("Black", "Shah", 3, 50);
    design.setup("White", "Sarbaz", 40, 50);
    design.setup("White", "Sarbaz", 33, 50);
    design.setup("White", "Sarbaz", 42, 50);
    design.setup("White", "Sarbaz", 35, 50);
    design.setup("White", "Sarbaz", 36, 50);
    design.setup("White", "Sarbaz", 45, 50);
    design.setup("White", "Sarbaz", 46, 50);
    design.setup("White", "Sarbaz", 47, 50);
    design.setup("White", "Rokh", 57, 50);
    design.setup("White", "Rokh", 63, 50);
    design.setup("White", "Asb", 50, 50);
    design.setup("White", "Asb", 53, 50);
    design.setup("White", "Alfil", 58, 50);
    design.setup("White", "Alfil", 43, 50);
    design.setup("White", "Fers", 44, 50);
    design.setup("White", "Shah", 59, 50);

    design.setup("Black", "Sarbaz", 24, 51);
    design.setup("Black", "Sarbaz", 17, 51);
    design.setup("Black", "Sarbaz", 18, 51);
    design.setup("Black", "Sarbaz", 19, 51);
    design.setup("Black", "Sarbaz", 28, 51);
    design.setup("Black", "Sarbaz", 37, 51);
    design.setup("Black", "Sarbaz", 14, 51);
    design.setup("Black", "Sarbaz", 31, 51);
    design.setup("Black", "Rokh", 1, 51);
    design.setup("Black", "Rokh", 2, 51);
    design.setup("Black", "Asb", 11, 51);
    design.setup("Black", "Asb", 21, 51);
    design.setup("Black", "Alfil", 20, 51);
    design.setup("Black", "Alfil", 23, 51);
    design.setup("Black", "Fers", 5, 51);
    design.setup("Black", "Shah", 6, 51);
    design.setup("White", "Sarbaz", 40, 51);
    design.setup("White", "Sarbaz", 33, 51);
    design.setup("White", "Sarbaz", 42, 51);
    design.setup("White", "Sarbaz", 35, 51);
    design.setup("White", "Sarbaz", 36, 51);
    design.setup("White", "Sarbaz", 45, 51);
    design.setup("White", "Sarbaz", 46, 51);
    design.setup("White", "Sarbaz", 47, 51);
    design.setup("White", "Rokh", 57, 51);
    design.setup("White", "Rokh", 63, 51);
    design.setup("White", "Asb", 50, 51);
    design.setup("White", "Asb", 53, 51);
    design.setup("White", "Alfil", 58, 51);
    design.setup("White", "Alfil", 43, 51);
    design.setup("White", "Fers", 44, 51);
    design.setup("White", "Shah", 59, 51);

    design.setup("Black", "Sarbaz", 24, 52);
    design.setup("Black", "Sarbaz", 17, 52);
    design.setup("Black", "Sarbaz", 18, 52);
    design.setup("Black", "Sarbaz", 19, 52);
    design.setup("Black", "Sarbaz", 28, 52);
    design.setup("Black", "Sarbaz", 37, 52);
    design.setup("Black", "Sarbaz", 30, 52);
    design.setup("Black", "Rokh", 14, 52);
    design.setup("Black", "Rokh", 7, 52);
    design.setup("Black", "Asb", 11, 52);
    design.setup("Black", "Asb", 22, 52);
    design.setup("Black", "Alfil", 20, 52);
    design.setup("Black", "Alfil", 23, 52);
    design.setup("Black", "Fers", 21, 52);
    design.setup("Black", "Shah", 13, 52);
    design.setup("White", "Sarbaz", 40, 52);
    design.setup("White", "Sarbaz", 33, 52);
    design.setup("White", "Sarbaz", 42, 52);
    design.setup("White", "Sarbaz", 35, 52);
    design.setup("White", "Sarbaz", 36, 52);
    design.setup("White", "Sarbaz", 45, 52);
    design.setup("White", "Sarbaz", 46, 52);
    design.setup("White", "Sarbaz", 47, 52);
    design.setup("White", "Rokh", 57, 52);
    design.setup("White", "Rokh", 63, 52);
    design.setup("White", "Asb", 50, 52);
    design.setup("White", "Asb", 53, 52);
    design.setup("White", "Alfil", 58, 52);
    design.setup("White", "Alfil", 43, 52);
    design.setup("White", "Fers", 44, 52);
    design.setup("White", "Shah", 59, 52);

    design.setup("Black", "Sarbaz", 24, 53);
    design.setup("Black", "Sarbaz", 17, 53);
    design.setup("Black", "Sarbaz", 26, 53);
    design.setup("Black", "Sarbaz", 11, 53);
    design.setup("Black", "Sarbaz", 12, 53);
    design.setup("Black", "Sarbaz", 29, 53);
    design.setup("Black", "Sarbaz", 22, 53);
    design.setup("Black", "Sarbaz", 31, 53);
    design.setup("Black", "Rokh", 2, 53);
    design.setup("Black", "Rokh", 7, 53);
    design.setup("Black", "Asb", 18, 53);
    design.setup("Black", "Asb", 21, 53);
    design.setup("Black", "Alfil", 16, 53);
    design.setup("Black", "Alfil", 19, 53);
    design.setup("Black", "Fers", 20, 53);
    design.setup("Black", "Shah", 13, 53);
    design.setup("White", "Sarbaz", 40, 53);
    design.setup("White", "Sarbaz", 33, 53);
    design.setup("White", "Sarbaz", 42, 53);
    design.setup("White", "Sarbaz", 35, 53);
    design.setup("White", "Sarbaz", 36, 53);
    design.setup("White", "Sarbaz", 45, 53);
    design.setup("White", "Sarbaz", 46, 53);
    design.setup("White", "Sarbaz", 47, 53);
    design.setup("White", "Rokh", 57, 53);
    design.setup("White", "Rokh", 63, 53);
    design.setup("White", "Asb", 50, 53);
    design.setup("White", "Asb", 53, 53);
    design.setup("White", "Alfil", 58, 53);
    design.setup("White", "Alfil", 43, 53);
    design.setup("White", "Fers", 44, 53);
    design.setup("White", "Shah", 59, 53);

    design.setup("Black", "Sarbaz", 16, 54);
    design.setup("Black", "Sarbaz", 17, 54);
    design.setup("Black", "Sarbaz", 18, 54);
    design.setup("Black", "Sarbaz", 19, 54);
    design.setup("Black", "Sarbaz", 20, 54);
    design.setup("Black", "Sarbaz", 21, 54);
    design.setup("Black", "Sarbaz", 30, 54);
    design.setup("Black", "Sarbaz", 23, 54);
    design.setup("Black", "Rokh", 13, 54);
    design.setup("Black", "Rokh", 6, 54);
    design.setup("Black", "Asb", 11, 54);
    design.setup("Black", "Asb", 12, 54);
    design.setup("Black", "Alfil", 2, 54);
    design.setup("Black", "Alfil", 5, 54);
    design.setup("Black", "Fers", 4, 54);
    design.setup("Black", "Shah", 3, 54);
    design.setup("White", "Sarbaz", 40, 54);
    design.setup("White", "Sarbaz", 33, 54);
    design.setup("White", "Sarbaz", 42, 54);
    design.setup("White", "Sarbaz", 35, 54);
    design.setup("White", "Sarbaz", 36, 54);
    design.setup("White", "Sarbaz", 45, 54);
    design.setup("White", "Sarbaz", 46, 54);
    design.setup("White", "Sarbaz", 47, 54);
    design.setup("White", "Rokh", 57, 54);
    design.setup("White", "Rokh", 63, 54);
    design.setup("White", "Asb", 50, 54);
    design.setup("White", "Asb", 53, 54);
    design.setup("White", "Alfil", 58, 54);
    design.setup("White", "Alfil", 43, 54);
    design.setup("White", "Fers", 44, 54);
    design.setup("White", "Shah", 59, 54);

    design.setup("Black", "Sarbaz", 16, 55);
    design.setup("Black", "Sarbaz", 25, 55);
    design.setup("Black", "Sarbaz", 18, 55);
    design.setup("Black", "Sarbaz", 27, 55);
    design.setup("Black", "Sarbaz", 28, 55);
    design.setup("Black", "Sarbaz", 21, 55);
    design.setup("Black", "Sarbaz", 22, 55);
    design.setup("Black", "Sarbaz", 23, 55);
    design.setup("Black", "Rokh", 1, 55);
    design.setup("Black", "Rokh", 7, 55);
    design.setup("Black", "Asb", 10, 55);
    design.setup("Black", "Asb", 13, 55);
    design.setup("Black", "Alfil", 2, 55);
    design.setup("Black", "Alfil", 19, 55);
    design.setup("Black", "Fers", 20, 55);
    design.setup("Black", "Shah", 3, 55);
    design.setup("White", "Sarbaz", 40, 55);
    design.setup("White", "Sarbaz", 33, 55);
    design.setup("White", "Sarbaz", 42, 55);
    design.setup("White", "Sarbaz", 35, 55);
    design.setup("White", "Sarbaz", 36, 55);
    design.setup("White", "Sarbaz", 45, 55);
    design.setup("White", "Sarbaz", 46, 55);
    design.setup("White", "Sarbaz", 47, 55);
    design.setup("White", "Rokh", 57, 55);
    design.setup("White", "Rokh", 63, 55);
    design.setup("White", "Asb", 50, 55);
    design.setup("White", "Asb", 53, 55);
    design.setup("White", "Alfil", 58, 55);
    design.setup("White", "Alfil", 43, 55);
    design.setup("White", "Fers", 44, 55);
    design.setup("White", "Shah", 59, 55);

    design.setup("Black", "Sarbaz", 16, 56);
    design.setup("Black", "Sarbaz", 17, 56);
    design.setup("Black", "Sarbaz", 18, 56);
    design.setup("Black", "Sarbaz", 27, 56);
    design.setup("Black", "Sarbaz", 28, 56);
    design.setup("Black", "Sarbaz", 21, 56);
    design.setup("Black", "Sarbaz", 22, 56);
    design.setup("Black", "Sarbaz", 23, 56);
    design.setup("Black", "Rokh", 10, 56);
    design.setup("Black", "Rokh", 13, 56);
    design.setup("Black", "Asb", 11, 56);
    design.setup("Black", "Asb", 12, 56);
    design.setup("Black", "Alfil", 2, 56);
    design.setup("Black", "Alfil", 19, 56);
    design.setup("Black", "Fers", 20, 56);
    design.setup("Black", "Shah", 3, 56);
    design.setup("White", "Sarbaz", 40, 56);
    design.setup("White", "Sarbaz", 33, 56);
    design.setup("White", "Sarbaz", 42, 56);
    design.setup("White", "Sarbaz", 35, 56);
    design.setup("White", "Sarbaz", 36, 56);
    design.setup("White", "Sarbaz", 45, 56);
    design.setup("White", "Sarbaz", 46, 56);
    design.setup("White", "Sarbaz", 47, 56);
    design.setup("White", "Rokh", 57, 56);
    design.setup("White", "Rokh", 63, 56);
    design.setup("White", "Asb", 50, 56);
    design.setup("White", "Asb", 53, 56);
    design.setup("White", "Alfil", 58, 56);
    design.setup("White", "Alfil", 43, 56);
    design.setup("White", "Fers", 44, 56);
    design.setup("White", "Shah", 59, 56);

    design.setup("Black", "Sarbaz", 8, 57);
    design.setup("Black", "Sarbaz", 25, 57);
    design.setup("Black", "Sarbaz", 26, 57);
    design.setup("Black", "Sarbaz", 19, 57);
    design.setup("Black", "Sarbaz", 20, 57);
    design.setup("Black", "Sarbaz", 21, 57);
    design.setup("Black", "Sarbaz", 22, 57);
    design.setup("Black", "Sarbaz", 23, 57);
    design.setup("Black", "Rokh", 1, 57);
    design.setup("Black", "Rokh", 10, 57);
    design.setup("Black", "Asb", 11, 57);
    design.setup("Black", "Asb", 12, 57);
    design.setup("Black", "Alfil", 2, 57);
    design.setup("Black", "Alfil", 5, 57);
    design.setup("Black", "Fers", 18, 57);
    design.setup("Black", "Shah", 3, 57);
    design.setup("White", "Sarbaz", 40, 57);
    design.setup("White", "Sarbaz", 33, 57);
    design.setup("White", "Sarbaz", 42, 57);
    design.setup("White", "Sarbaz", 35, 57);
    design.setup("White", "Sarbaz", 36, 57);
    design.setup("White", "Sarbaz", 45, 57);
    design.setup("White", "Sarbaz", 46, 57);
    design.setup("White", "Sarbaz", 47, 57);
    design.setup("White", "Rokh", 57, 57);
    design.setup("White", "Rokh", 63, 57);
    design.setup("White", "Asb", 50, 57);
    design.setup("White", "Asb", 53, 57);
    design.setup("White", "Alfil", 58, 57);
    design.setup("White", "Alfil", 43, 57);
    design.setup("White", "Fers", 44, 57);
    design.setup("White", "Shah", 59, 57);

    design.setup("Black", "Sarbaz", 24, 58);
    design.setup("Black", "Sarbaz", 17, 58);
    design.setup("Black", "Sarbaz", 18, 58);
    design.setup("Black", "Sarbaz", 27, 58);
    design.setup("Black", "Sarbaz", 28, 58);
    design.setup("Black", "Sarbaz", 21, 58);
    design.setup("Black", "Sarbaz", 22, 58);
    design.setup("Black", "Sarbaz", 31, 58);
    design.setup("Black", "Rokh", 1, 58);
    design.setup("Black", "Rokh", 6, 58);
    design.setup("Black", "Asb", 11, 58);
    design.setup("Black", "Asb", 12, 58);
    design.setup("Black", "Alfil", 19, 58);
    design.setup("Black", "Alfil", 20, 58);
    design.setup("Black", "Fers", 10, 58);
    design.setup("Black", "Shah", 13, 58);
    design.setup("White", "Sarbaz", 40, 58);
    design.setup("White", "Sarbaz", 41, 58);
    design.setup("White", "Sarbaz", 42, 58);
    design.setup("White", "Sarbaz", 35, 58);
    design.setup("White", "Sarbaz", 36, 58);
    design.setup("White", "Sarbaz", 45, 58);
    design.setup("White", "Sarbaz", 46, 58);
    design.setup("White", "Sarbaz", 47, 58);
    design.setup("White", "Rokh", 50, 58);
    design.setup("White", "Rokh", 53, 58);
    design.setup("White", "Asb", 51, 58);
    design.setup("White", "Asb", 52, 58);
    design.setup("White", "Alfil", 58, 58);
    design.setup("White", "Alfil", 43, 58);
    design.setup("White", "Fers", 44, 58);
    design.setup("White", "Shah", 59, 58);

    design.setup("Black", "Sarbaz", 8, 59);
    design.setup("Black", "Sarbaz", 17, 59);
    design.setup("Black", "Sarbaz", 26, 59);
    design.setup("Black", "Sarbaz", 19, 59);
    design.setup("Black", "Sarbaz", 20, 59);
    design.setup("Black", "Sarbaz", 29, 59);
    design.setup("Black", "Sarbaz", 22, 59);
    design.setup("Black", "Sarbaz", 15, 59);
    design.setup("Black", "Rokh", 1, 59);
    design.setup("Black", "Rokh", 6, 59);
    design.setup("Black", "Asb", 18, 59);
    design.setup("Black", "Asb", 21, 59);
    design.setup("Black", "Alfil", 2, 59);
    design.setup("Black", "Alfil", 5, 59);
    design.setup("Black", "Fers", 4, 59);
    design.setup("Black", "Shah", 3, 59);
    design.setup("White", "Sarbaz", 40, 59);
    design.setup("White", "Sarbaz", 41, 59);
    design.setup("White", "Sarbaz", 42, 59);
    design.setup("White", "Sarbaz", 35, 59);
    design.setup("White", "Sarbaz", 36, 59);
    design.setup("White", "Sarbaz", 45, 59);
    design.setup("White", "Sarbaz", 46, 59);
    design.setup("White", "Sarbaz", 47, 59);
    design.setup("White", "Rokh", 50, 59);
    design.setup("White", "Rokh", 53, 59);
    design.setup("White", "Asb", 51, 59);
    design.setup("White", "Asb", 52, 59);
    design.setup("White", "Alfil", 58, 59);
    design.setup("White", "Alfil", 43, 59);
    design.setup("White", "Fers", 44, 59);
    design.setup("White", "Shah", 59, 59);

    design.setup("Black", "Sarbaz", 8, 60);
    design.setup("Black", "Sarbaz", 17, 60);
    design.setup("Black", "Sarbaz", 18, 60);
    design.setup("Black", "Sarbaz", 27, 60);
    design.setup("Black", "Sarbaz", 28, 60);
    design.setup("Black", "Sarbaz", 21, 60);
    design.setup("Black", "Sarbaz", 14, 60);
    design.setup("Black", "Sarbaz", 23, 60);
    design.setup("Black", "Rokh", 0, 60);
    design.setup("Black", "Rokh", 7, 60);
    design.setup("Black", "Asb", 11, 60);
    design.setup("Black", "Asb", 12, 60);
    design.setup("Black", "Alfil", 2, 60);
    design.setup("Black", "Alfil", 5, 60);
    design.setup("Black", "Fers", 19, 60);
    design.setup("Black", "Shah", 4, 60);
    design.setup("White", "Sarbaz", 40, 60);
    design.setup("White", "Sarbaz", 41, 60);
    design.setup("White", "Sarbaz", 42, 60);
    design.setup("White", "Sarbaz", 35, 60);
    design.setup("White", "Sarbaz", 36, 60);
    design.setup("White", "Sarbaz", 45, 60);
    design.setup("White", "Sarbaz", 46, 60);
    design.setup("White", "Sarbaz", 47, 60);
    design.setup("White", "Rokh", 50, 60);
    design.setup("White", "Rokh", 53, 60);
    design.setup("White", "Asb", 51, 60);
    design.setup("White", "Asb", 52, 60);
    design.setup("White", "Alfil", 58, 60);
    design.setup("White", "Alfil", 43, 60);
    design.setup("White", "Fers", 44, 60);
    design.setup("White", "Shah", 59, 60);

    design.setup("Black", "Sarbaz", 8, 61);
    design.setup("Black", "Sarbaz", 25, 61);
    design.setup("Black", "Sarbaz", 34, 61);
    design.setup("Black", "Sarbaz", 19, 61);
    design.setup("Black", "Sarbaz", 28, 61);
    design.setup("Black", "Sarbaz", 21, 61);
    design.setup("Black", "Sarbaz", 22, 61);
    design.setup("Black", "Sarbaz", 23, 61);
    design.setup("Black", "Rokh", 1, 61);
    design.setup("Black", "Rokh", 6, 61);
    design.setup("Black", "Asb", 18, 61);
    design.setup("Black", "Asb", 12, 61);
    design.setup("Black", "Alfil", 2, 61);
    design.setup("Black", "Alfil", 5, 61);
    design.setup("Black", "Fers", 20, 61);
    design.setup("Black", "Shah", 3, 61);
    design.setup("White", "Sarbaz", 40, 61);
    design.setup("White", "Sarbaz", 41, 61);
    design.setup("White", "Sarbaz", 42, 61);
    design.setup("White", "Sarbaz", 35, 61);
    design.setup("White", "Sarbaz", 36, 61);
    design.setup("White", "Sarbaz", 45, 61);
    design.setup("White", "Sarbaz", 46, 61);
    design.setup("White", "Sarbaz", 47, 61);
    design.setup("White", "Rokh", 50, 61);
    design.setup("White", "Rokh", 53, 61);
    design.setup("White", "Asb", 51, 61);
    design.setup("White", "Asb", 52, 61);
    design.setup("White", "Alfil", 58, 61);
    design.setup("White", "Alfil", 43, 61);
    design.setup("White", "Fers", 44, 61);
    design.setup("White", "Shah", 59, 61);

    design.setup("Black", "Sarbaz", 8, 62);
    design.setup("Black", "Sarbaz", 25, 62);
    design.setup("Black", "Sarbaz", 18, 62);
    design.setup("Black", "Sarbaz", 19, 62);
    design.setup("Black", "Sarbaz", 20, 62);
    design.setup("Black", "Sarbaz", 21, 62);
    design.setup("Black", "Sarbaz", 22, 62);
    design.setup("Black", "Sarbaz", 23, 62);
    design.setup("Black", "Rokh", 1, 62);
    design.setup("Black", "Rokh", 10, 62);
    design.setup("Black", "Asb", 11, 62);
    design.setup("Black", "Asb", 6, 62);
    design.setup("Black", "Alfil", 2, 62);
    design.setup("Black", "Alfil", 5, 62);
    design.setup("Black", "Fers", 4, 62);
    design.setup("Black", "Shah", 3, 62);
    design.setup("White", "Sarbaz", 40, 62);
    design.setup("White", "Sarbaz", 41, 62);
    design.setup("White", "Sarbaz", 42, 62);
    design.setup("White", "Sarbaz", 35, 62);
    design.setup("White", "Sarbaz", 36, 62);
    design.setup("White", "Sarbaz", 45, 62);
    design.setup("White", "Sarbaz", 46, 62);
    design.setup("White", "Sarbaz", 47, 62);
    design.setup("White", "Rokh", 50, 62);
    design.setup("White", "Rokh", 53, 62);
    design.setup("White", "Asb", 51, 62);
    design.setup("White", "Asb", 52, 62);
    design.setup("White", "Alfil", 58, 62);
    design.setup("White", "Alfil", 43, 62);
    design.setup("White", "Fers", 44, 62);
    design.setup("White", "Shah", 59, 62);

    design.setup("Black", "Sarbaz", 24, 63);
    design.setup("Black", "Sarbaz", 17, 63);
    design.setup("Black", "Sarbaz", 18, 63);
    design.setup("Black", "Sarbaz", 19, 63);
    design.setup("Black", "Sarbaz", 28, 63);
    design.setup("Black", "Sarbaz", 37, 63);
    design.setup("Black", "Sarbaz", 14, 63);
    design.setup("Black", "Sarbaz", 31, 63);
    design.setup("Black", "Rokh", 1, 63);
    design.setup("Black", "Rokh", 2, 63);
    design.setup("Black", "Asb", 11, 63);
    design.setup("Black", "Asb", 21, 63);
    design.setup("Black", "Alfil", 20, 63);
    design.setup("Black", "Alfil", 23, 63);
    design.setup("Black", "Fers", 5, 63);
    design.setup("Black", "Shah", 6, 63);
    design.setup("White", "Sarbaz", 40, 63);
    design.setup("White", "Sarbaz", 41, 63);
    design.setup("White", "Sarbaz", 42, 63);
    design.setup("White", "Sarbaz", 35, 63);
    design.setup("White", "Sarbaz", 36, 63);
    design.setup("White", "Sarbaz", 45, 63);
    design.setup("White", "Sarbaz", 46, 63);
    design.setup("White", "Sarbaz", 47, 63);
    design.setup("White", "Rokh", 50, 63);
    design.setup("White", "Rokh", 53, 63);
    design.setup("White", "Asb", 51, 63);
    design.setup("White", "Asb", 52, 63);
    design.setup("White", "Alfil", 58, 63);
    design.setup("White", "Alfil", 43, 63);
    design.setup("White", "Fers", 44, 63);
    design.setup("White", "Shah", 59, 63);

    design.setup("Black", "Sarbaz", 24, 64);
    design.setup("Black", "Sarbaz", 17, 64);
    design.setup("Black", "Sarbaz", 18, 64);
    design.setup("Black", "Sarbaz", 19, 64);
    design.setup("Black", "Sarbaz", 28, 64);
    design.setup("Black", "Sarbaz", 37, 64);
    design.setup("Black", "Sarbaz", 30, 64);
    design.setup("Black", "Rokh", 14, 64);
    design.setup("Black", "Rokh", 7, 64);
    design.setup("Black", "Asb", 11, 64);
    design.setup("Black", "Asb", 22, 64);
    design.setup("Black", "Alfil", 20, 64);
    design.setup("Black", "Alfil", 23, 64);
    design.setup("Black", "Fers", 21, 64);
    design.setup("Black", "Shah", 13, 64);
    design.setup("White", "Sarbaz", 40, 64);
    design.setup("White", "Sarbaz", 41, 64);
    design.setup("White", "Sarbaz", 42, 64);
    design.setup("White", "Sarbaz", 35, 64);
    design.setup("White", "Sarbaz", 36, 64);
    design.setup("White", "Sarbaz", 45, 64);
    design.setup("White", "Sarbaz", 46, 64);
    design.setup("White", "Sarbaz", 47, 64);
    design.setup("White", "Rokh", 50, 64);
    design.setup("White", "Rokh", 53, 64);
    design.setup("White", "Asb", 51, 64);
    design.setup("White", "Asb", 52, 64);
    design.setup("White", "Alfil", 58, 64);
    design.setup("White", "Alfil", 43, 64);
    design.setup("White", "Fers", 44, 64);
    design.setup("White", "Shah", 59, 64);

    design.setup("Black", "Sarbaz", 24, 65);
    design.setup("Black", "Sarbaz", 17, 65);
    design.setup("Black", "Sarbaz", 26, 65);
    design.setup("Black", "Sarbaz", 11, 65);
    design.setup("Black", "Sarbaz", 12, 65);
    design.setup("Black", "Sarbaz", 29, 65);
    design.setup("Black", "Sarbaz", 22, 65);
    design.setup("Black", "Sarbaz", 31, 65);
    design.setup("Black", "Rokh", 2, 65);
    design.setup("Black", "Rokh", 7, 65);
    design.setup("Black", "Asb", 18, 65);
    design.setup("Black", "Asb", 21, 65);
    design.setup("Black", "Alfil", 16, 65);
    design.setup("Black", "Alfil", 19, 65);
    design.setup("Black", "Fers", 20, 65);
    design.setup("Black", "Shah", 13, 65);
    design.setup("White", "Sarbaz", 40, 65);
    design.setup("White", "Sarbaz", 41, 65);
    design.setup("White", "Sarbaz", 42, 65);
    design.setup("White", "Sarbaz", 35, 65);
    design.setup("White", "Sarbaz", 36, 65);
    design.setup("White", "Sarbaz", 45, 65);
    design.setup("White", "Sarbaz", 46, 65);
    design.setup("White", "Sarbaz", 47, 65);
    design.setup("White", "Rokh", 50, 65);
    design.setup("White", "Rokh", 53, 65);
    design.setup("White", "Asb", 51, 65);
    design.setup("White", "Asb", 52, 65);
    design.setup("White", "Alfil", 58, 65);
    design.setup("White", "Alfil", 43, 65);
    design.setup("White", "Fers", 44, 65);
    design.setup("White", "Shah", 59, 65);

    design.setup("Black", "Sarbaz", 16, 66);
    design.setup("Black", "Sarbaz", 17, 66);
    design.setup("Black", "Sarbaz", 18, 66);
    design.setup("Black", "Sarbaz", 19, 66);
    design.setup("Black", "Sarbaz", 20, 66);
    design.setup("Black", "Sarbaz", 21, 66);
    design.setup("Black", "Sarbaz", 30, 66);
    design.setup("Black", "Sarbaz", 23, 66);
    design.setup("Black", "Rokh", 13, 66);
    design.setup("Black", "Rokh", 6, 66);
    design.setup("Black", "Asb", 11, 66);
    design.setup("Black", "Asb", 12, 66);
    design.setup("Black", "Alfil", 2, 66);
    design.setup("Black", "Alfil", 5, 66);
    design.setup("Black", "Fers", 4, 66);
    design.setup("Black", "Shah", 3, 66);
    design.setup("White", "Sarbaz", 40, 66);
    design.setup("White", "Sarbaz", 41, 66);
    design.setup("White", "Sarbaz", 42, 66);
    design.setup("White", "Sarbaz", 35, 66);
    design.setup("White", "Sarbaz", 36, 66);
    design.setup("White", "Sarbaz", 45, 66);
    design.setup("White", "Sarbaz", 46, 66);
    design.setup("White", "Sarbaz", 47, 66);
    design.setup("White", "Rokh", 50, 66);
    design.setup("White", "Rokh", 53, 66);
    design.setup("White", "Asb", 51, 66);
    design.setup("White", "Asb", 52, 66);
    design.setup("White", "Alfil", 58, 66);
    design.setup("White", "Alfil", 43, 66);
    design.setup("White", "Fers", 44, 66);
    design.setup("White", "Shah", 59, 66);

    design.setup("Black", "Sarbaz", 16, 67);
    design.setup("Black", "Sarbaz", 25, 67);
    design.setup("Black", "Sarbaz", 18, 67);
    design.setup("Black", "Sarbaz", 27, 67);
    design.setup("Black", "Sarbaz", 28, 67);
    design.setup("Black", "Sarbaz", 21, 67);
    design.setup("Black", "Sarbaz", 22, 67);
    design.setup("Black", "Sarbaz", 23, 67);
    design.setup("Black", "Rokh", 1, 67);
    design.setup("Black", "Rokh", 7, 67);
    design.setup("Black", "Asb", 10, 67);
    design.setup("Black", "Asb", 13, 67);
    design.setup("Black", "Alfil", 2, 67);
    design.setup("Black", "Alfil", 19, 67);
    design.setup("Black", "Fers", 20, 67);
    design.setup("Black", "Shah", 3, 67);
    design.setup("White", "Sarbaz", 40, 67);
    design.setup("White", "Sarbaz", 41, 67);
    design.setup("White", "Sarbaz", 42, 67);
    design.setup("White", "Sarbaz", 35, 67);
    design.setup("White", "Sarbaz", 36, 67);
    design.setup("White", "Sarbaz", 45, 67);
    design.setup("White", "Sarbaz", 46, 67);
    design.setup("White", "Sarbaz", 47, 67);
    design.setup("White", "Rokh", 50, 67);
    design.setup("White", "Rokh", 53, 67);
    design.setup("White", "Asb", 51, 67);
    design.setup("White", "Asb", 52, 67);
    design.setup("White", "Alfil", 58, 67);
    design.setup("White", "Alfil", 43, 67);
    design.setup("White", "Fers", 44, 67);
    design.setup("White", "Shah", 59, 67);

    design.setup("Black", "Sarbaz", 16, 68);
    design.setup("Black", "Sarbaz", 17, 68);
    design.setup("Black", "Sarbaz", 18, 68);
    design.setup("Black", "Sarbaz", 27, 68);
    design.setup("Black", "Sarbaz", 28, 68);
    design.setup("Black", "Sarbaz", 21, 68);
    design.setup("Black", "Sarbaz", 22, 68);
    design.setup("Black", "Sarbaz", 23, 68);
    design.setup("Black", "Rokh", 10, 68);
    design.setup("Black", "Rokh", 13, 68);
    design.setup("Black", "Asb", 11, 68);
    design.setup("Black", "Asb", 12, 68);
    design.setup("Black", "Alfil", 2, 68);
    design.setup("Black", "Alfil", 19, 68);
    design.setup("Black", "Fers", 20, 68);
    design.setup("Black", "Shah", 3, 68);
    design.setup("White", "Sarbaz", 40, 68);
    design.setup("White", "Sarbaz", 41, 68);
    design.setup("White", "Sarbaz", 42, 68);
    design.setup("White", "Sarbaz", 35, 68);
    design.setup("White", "Sarbaz", 36, 68);
    design.setup("White", "Sarbaz", 45, 68);
    design.setup("White", "Sarbaz", 46, 68);
    design.setup("White", "Sarbaz", 47, 68);
    design.setup("White", "Rokh", 50, 68);
    design.setup("White", "Rokh", 53, 68);
    design.setup("White", "Asb", 51, 68);
    design.setup("White", "Asb", 52, 68);
    design.setup("White", "Alfil", 58, 68);
    design.setup("White", "Alfil", 43, 68);
    design.setup("White", "Fers", 44, 68);
    design.setup("White", "Shah", 59, 68);

    design.setup("Black", "Sarbaz", 8, 69);
    design.setup("Black", "Sarbaz", 25, 69);
    design.setup("Black", "Sarbaz", 26, 69);
    design.setup("Black", "Sarbaz", 19, 69);
    design.setup("Black", "Sarbaz", 20, 69);
    design.setup("Black", "Sarbaz", 21, 69);
    design.setup("Black", "Sarbaz", 22, 69);
    design.setup("Black", "Sarbaz", 23, 69);
    design.setup("Black", "Rokh", 1, 69);
    design.setup("Black", "Rokh", 10, 69);
    design.setup("Black", "Asb", 11, 69);
    design.setup("Black", "Asb", 12, 69);
    design.setup("Black", "Alfil", 2, 69);
    design.setup("Black", "Alfil", 5, 69);
    design.setup("Black", "Fers", 18, 69);
    design.setup("Black", "Shah", 3, 69);
    design.setup("White", "Sarbaz", 40, 69);
    design.setup("White", "Sarbaz", 41, 69);
    design.setup("White", "Sarbaz", 42, 69);
    design.setup("White", "Sarbaz", 35, 69);
    design.setup("White", "Sarbaz", 36, 69);
    design.setup("White", "Sarbaz", 45, 69);
    design.setup("White", "Sarbaz", 46, 69);
    design.setup("White", "Sarbaz", 47, 69);
    design.setup("White", "Rokh", 50, 69);
    design.setup("White", "Rokh", 53, 69);
    design.setup("White", "Asb", 51, 69);
    design.setup("White", "Asb", 52, 69);
    design.setup("White", "Alfil", 58, 69);
    design.setup("White", "Alfil", 43, 69);
    design.setup("White", "Fers", 44, 69);
    design.setup("White", "Shah", 59, 69);

    design.setup("Black", "Sarbaz", 24, 70);
    design.setup("Black", "Sarbaz", 17, 70);
    design.setup("Black", "Sarbaz", 18, 70);
    design.setup("Black", "Sarbaz", 27, 70);
    design.setup("Black", "Sarbaz", 28, 70);
    design.setup("Black", "Sarbaz", 21, 70);
    design.setup("Black", "Sarbaz", 22, 70);
    design.setup("Black", "Sarbaz", 31, 70);
    design.setup("Black", "Rokh", 1, 70);
    design.setup("Black", "Rokh", 6, 70);
    design.setup("Black", "Asb", 11, 70);
    design.setup("Black", "Asb", 12, 70);
    design.setup("Black", "Alfil", 19, 70);
    design.setup("Black", "Alfil", 20, 70);
    design.setup("Black", "Fers", 10, 70);
    design.setup("Black", "Shah", 13, 70);
    design.setup("White", "Sarbaz", 48, 70);
    design.setup("White", "Sarbaz", 33, 70);
    design.setup("White", "Sarbaz", 34, 70);
    design.setup("White", "Sarbaz", 43, 70);
    design.setup("White", "Sarbaz", 44, 70);
    design.setup("White", "Sarbaz", 45, 70);
    design.setup("White", "Sarbaz", 46, 70);
    design.setup("White", "Sarbaz", 47, 70);
    design.setup("White", "Rokh", 57, 70);
    design.setup("White", "Rokh", 50, 70);
    design.setup("White", "Asb", 51, 70);
    design.setup("White", "Asb", 52, 70);
    design.setup("White", "Alfil", 58, 70);
    design.setup("White", "Alfil", 61, 70);
    design.setup("White", "Fers", 42, 70);
    design.setup("White", "Shah", 59, 70);

    design.setup("Black", "Sarbaz", 8, 71);
    design.setup("Black", "Sarbaz", 17, 71);
    design.setup("Black", "Sarbaz", 26, 71);
    design.setup("Black", "Sarbaz", 19, 71);
    design.setup("Black", "Sarbaz", 20, 71);
    design.setup("Black", "Sarbaz", 29, 71);
    design.setup("Black", "Sarbaz", 22, 71);
    design.setup("Black", "Sarbaz", 15, 71);
    design.setup("Black", "Rokh", 1, 71);
    design.setup("Black", "Rokh", 6, 71);
    design.setup("Black", "Asb", 18, 71);
    design.setup("Black", "Asb", 21, 71);
    design.setup("Black", "Alfil", 2, 71);
    design.setup("Black", "Alfil", 5, 71);
    design.setup("Black", "Fers", 4, 71);
    design.setup("Black", "Shah", 3, 71);
    design.setup("White", "Sarbaz", 48, 71);
    design.setup("White", "Sarbaz", 33, 71);
    design.setup("White", "Sarbaz", 34, 71);
    design.setup("White", "Sarbaz", 43, 71);
    design.setup("White", "Sarbaz", 44, 71);
    design.setup("White", "Sarbaz", 45, 71);
    design.setup("White", "Sarbaz", 46, 71);
    design.setup("White", "Sarbaz", 47, 71);
    design.setup("White", "Rokh", 57, 71);
    design.setup("White", "Rokh", 50, 71);
    design.setup("White", "Asb", 51, 71);
    design.setup("White", "Asb", 52, 71);
    design.setup("White", "Alfil", 58, 71);
    design.setup("White", "Alfil", 61, 71);
    design.setup("White", "Fers", 42, 71);
    design.setup("White", "Shah", 59, 71);

    design.setup("Black", "Sarbaz", 8, 72);
    design.setup("Black", "Sarbaz", 17, 72);
    design.setup("Black", "Sarbaz", 18, 72);
    design.setup("Black", "Sarbaz", 27, 72);
    design.setup("Black", "Sarbaz", 28, 72);
    design.setup("Black", "Sarbaz", 21, 72);
    design.setup("Black", "Sarbaz", 14, 72);
    design.setup("Black", "Sarbaz", 23, 72);
    design.setup("Black", "Rokh", 0, 72);
    design.setup("Black", "Rokh", 7, 72);
    design.setup("Black", "Asb", 11, 72);
    design.setup("Black", "Asb", 12, 72);
    design.setup("Black", "Alfil", 2, 72);
    design.setup("Black", "Alfil", 5, 72);
    design.setup("Black", "Fers", 19, 72);
    design.setup("Black", "Shah", 4, 72);
    design.setup("White", "Sarbaz", 48, 72);
    design.setup("White", "Sarbaz", 33, 72);
    design.setup("White", "Sarbaz", 34, 72);
    design.setup("White", "Sarbaz", 43, 72);
    design.setup("White", "Sarbaz", 44, 72);
    design.setup("White", "Sarbaz", 45, 72);
    design.setup("White", "Sarbaz", 46, 72);
    design.setup("White", "Sarbaz", 47, 72);
    design.setup("White", "Rokh", 57, 72);
    design.setup("White", "Rokh", 50, 72);
    design.setup("White", "Asb", 51, 72);
    design.setup("White", "Asb", 52, 72);
    design.setup("White", "Alfil", 58, 72);
    design.setup("White", "Alfil", 61, 72);
    design.setup("White", "Fers", 42, 72);
    design.setup("White", "Shah", 59, 72);

    design.setup("Black", "Sarbaz", 8, 73);
    design.setup("Black", "Sarbaz", 25, 73);
    design.setup("Black", "Sarbaz", 26, 73);
    design.setup("Black", "Sarbaz", 19, 73);
    design.setup("Black", "Sarbaz", 20, 73);
    design.setup("Black", "Sarbaz", 21, 73);
    design.setup("Black", "Sarbaz", 22, 73);
    design.setup("Black", "Sarbaz", 23, 73);
    design.setup("Black", "Rokh", 1, 73);
    design.setup("Black", "Rokh", 10, 73);
    design.setup("Black", "Asb", 11, 73);
    design.setup("Black", "Asb", 12, 73);
    design.setup("Black", "Alfil", 2, 73);
    design.setup("Black", "Alfil", 5, 73);
    design.setup("Black", "Fers", 18, 73);
    design.setup("Black", "Shah", 3, 73);
    design.setup("White", "Sarbaz", 48, 73);
    design.setup("White", "Sarbaz", 33, 73);
    design.setup("White", "Sarbaz", 34, 73);
    design.setup("White", "Sarbaz", 43, 73);
    design.setup("White", "Sarbaz", 44, 73);
    design.setup("White", "Sarbaz", 45, 73);
    design.setup("White", "Sarbaz", 46, 73);
    design.setup("White", "Sarbaz", 47, 73);
    design.setup("White", "Rokh", 57, 73);
    design.setup("White", "Rokh", 50, 73);
    design.setup("White", "Asb", 51, 73);
    design.setup("White", "Asb", 52, 73);
    design.setup("White", "Alfil", 58, 73);
    design.setup("White", "Alfil", 61, 73);
    design.setup("White", "Fers", 42, 73);
    design.setup("White", "Shah", 59, 73);

    design.setup("Black", "Sarbaz", 8, 74);
    design.setup("Black", "Sarbaz", 25, 74);
    design.setup("Black", "Sarbaz", 18, 74);
    design.setup("Black", "Sarbaz", 19, 74);
    design.setup("Black", "Sarbaz", 20, 74);
    design.setup("Black", "Sarbaz", 21, 74);
    design.setup("Black", "Sarbaz", 22, 74);
    design.setup("Black", "Sarbaz", 23, 74);
    design.setup("Black", "Rokh", 1, 74);
    design.setup("Black", "Rokh", 10, 74);
    design.setup("Black", "Asb", 11, 74);
    design.setup("Black", "Asb", 6, 74);
    design.setup("Black", "Alfil", 2, 74);
    design.setup("Black", "Alfil", 5, 74);
    design.setup("Black", "Fers", 4, 74);
    design.setup("Black", "Shah", 3, 74);
    design.setup("White", "Sarbaz", 48, 74);
    design.setup("White", "Sarbaz", 33, 74);
    design.setup("White", "Sarbaz", 34, 74);
    design.setup("White", "Sarbaz", 43, 74);
    design.setup("White", "Sarbaz", 44, 74);
    design.setup("White", "Sarbaz", 45, 74);
    design.setup("White", "Sarbaz", 46, 74);
    design.setup("White", "Sarbaz", 47, 74);
    design.setup("White", "Rokh", 57, 74);
    design.setup("White", "Rokh", 50, 74);
    design.setup("White", "Asb", 51, 74);
    design.setup("White", "Asb", 52, 74);
    design.setup("White", "Alfil", 58, 74);
    design.setup("White", "Alfil", 61, 74);
    design.setup("White", "Fers", 42, 74);
    design.setup("White", "Shah", 59, 74);

    design.setup("Black", "Sarbaz", 24, 75);
    design.setup("Black", "Sarbaz", 17, 75);
    design.setup("Black", "Sarbaz", 18, 75);
    design.setup("Black", "Sarbaz", 19, 75);
    design.setup("Black", "Sarbaz", 28, 75);
    design.setup("Black", "Sarbaz", 37, 75);
    design.setup("Black", "Sarbaz", 14, 75);
    design.setup("Black", "Sarbaz", 31, 75);
    design.setup("Black", "Rokh", 1, 75);
    design.setup("Black", "Rokh", 2, 75);
    design.setup("Black", "Asb", 11, 75);
    design.setup("Black", "Asb", 21, 75);
    design.setup("Black", "Alfil", 20, 75);
    design.setup("Black", "Alfil", 23, 75);
    design.setup("Black", "Fers", 5, 75);
    design.setup("Black", "Shah", 6, 75);
    design.setup("White", "Sarbaz", 48, 75);
    design.setup("White", "Sarbaz", 33, 75);
    design.setup("White", "Sarbaz", 34, 75);
    design.setup("White", "Sarbaz", 43, 75);
    design.setup("White", "Sarbaz", 44, 75);
    design.setup("White", "Sarbaz", 45, 75);
    design.setup("White", "Sarbaz", 46, 75);
    design.setup("White", "Sarbaz", 47, 75);
    design.setup("White", "Rokh", 57, 75);
    design.setup("White", "Rokh", 50, 75);
    design.setup("White", "Asb", 51, 75);
    design.setup("White", "Asb", 52, 75);
    design.setup("White", "Alfil", 58, 75);
    design.setup("White", "Alfil", 61, 75);
    design.setup("White", "Fers", 42, 75);
    design.setup("White", "Shah", 59, 75);

    design.setup("Black", "Sarbaz", 24, 76);
    design.setup("Black", "Sarbaz", 17, 76);
    design.setup("Black", "Sarbaz", 18, 76);
    design.setup("Black", "Sarbaz", 19, 76);
    design.setup("Black", "Sarbaz", 28, 76);
    design.setup("Black", "Sarbaz", 37, 76);
    design.setup("Black", "Sarbaz", 30, 76);
    design.setup("Black", "Rokh", 14, 76);
    design.setup("Black", "Rokh", 7, 76);
    design.setup("Black", "Asb", 11, 76);
    design.setup("Black", "Asb", 22, 76);
    design.setup("Black", "Alfil", 20, 76);
    design.setup("Black", "Alfil", 23, 76);
    design.setup("Black", "Fers", 21, 76);
    design.setup("Black", "Shah", 13, 76);
    design.setup("White", "Sarbaz", 48, 76);
    design.setup("White", "Sarbaz", 33, 76);
    design.setup("White", "Sarbaz", 34, 76);
    design.setup("White", "Sarbaz", 43, 76);
    design.setup("White", "Sarbaz", 44, 76);
    design.setup("White", "Sarbaz", 45, 76);
    design.setup("White", "Sarbaz", 46, 76);
    design.setup("White", "Sarbaz", 47, 76);
    design.setup("White", "Rokh", 57, 76);
    design.setup("White", "Rokh", 50, 76);
    design.setup("White", "Asb", 51, 76);
    design.setup("White", "Asb", 52, 76);
    design.setup("White", "Alfil", 58, 76);
    design.setup("White", "Alfil", 61, 76);
    design.setup("White", "Fers", 42, 76);
    design.setup("White", "Shah", 59, 76);

    design.setup("Black", "Sarbaz", 24, 77);
    design.setup("Black", "Sarbaz", 17, 77);
    design.setup("Black", "Sarbaz", 26, 77);
    design.setup("Black", "Sarbaz", 11, 77);
    design.setup("Black", "Sarbaz", 12, 77);
    design.setup("Black", "Sarbaz", 29, 77);
    design.setup("Black", "Sarbaz", 22, 77);
    design.setup("Black", "Sarbaz", 31, 77);
    design.setup("Black", "Rokh", 2, 77);
    design.setup("Black", "Rokh", 7, 77);
    design.setup("Black", "Asb", 18, 77);
    design.setup("Black", "Asb", 21, 77);
    design.setup("Black", "Alfil", 16, 77);
    design.setup("Black", "Alfil", 19, 77);
    design.setup("Black", "Fers", 20, 77);
    design.setup("Black", "Shah", 13, 77);
    design.setup("White", "Sarbaz", 48, 77);
    design.setup("White", "Sarbaz", 33, 77);
    design.setup("White", "Sarbaz", 34, 77);
    design.setup("White", "Sarbaz", 43, 77);
    design.setup("White", "Sarbaz", 44, 77);
    design.setup("White", "Sarbaz", 45, 77);
    design.setup("White", "Sarbaz", 46, 77);
    design.setup("White", "Sarbaz", 47, 77);
    design.setup("White", "Rokh", 57, 77);
    design.setup("White", "Rokh", 50, 77);
    design.setup("White", "Asb", 51, 77);
    design.setup("White", "Asb", 52, 77);
    design.setup("White", "Alfil", 58, 77);
    design.setup("White", "Alfil", 61, 77);
    design.setup("White", "Fers", 42, 77);
    design.setup("White", "Shah", 59, 77);

    design.setup("Black", "Sarbaz", 16, 78);
    design.setup("Black", "Sarbaz", 17, 78);
    design.setup("Black", "Sarbaz", 18, 78);
    design.setup("Black", "Sarbaz", 19, 78);
    design.setup("Black", "Sarbaz", 20, 78);
    design.setup("Black", "Sarbaz", 21, 78);
    design.setup("Black", "Sarbaz", 30, 78);
    design.setup("Black", "Sarbaz", 23, 78);
    design.setup("Black", "Rokh", 13, 78);
    design.setup("Black", "Rokh", 6, 78);
    design.setup("Black", "Asb", 11, 78);
    design.setup("Black", "Asb", 12, 78);
    design.setup("Black", "Alfil", 2, 78);
    design.setup("Black", "Alfil", 5, 78);
    design.setup("Black", "Fers", 4, 78);
    design.setup("Black", "Shah", 3, 78);
    design.setup("White", "Sarbaz", 48, 78);
    design.setup("White", "Sarbaz", 33, 78);
    design.setup("White", "Sarbaz", 34, 78);
    design.setup("White", "Sarbaz", 43, 78);
    design.setup("White", "Sarbaz", 44, 78);
    design.setup("White", "Sarbaz", 45, 78);
    design.setup("White", "Sarbaz", 46, 78);
    design.setup("White", "Sarbaz", 47, 78);
    design.setup("White", "Rokh", 57, 78);
    design.setup("White", "Rokh", 50, 78);
    design.setup("White", "Asb", 51, 78);
    design.setup("White", "Asb", 52, 78);
    design.setup("White", "Alfil", 58, 78);
    design.setup("White", "Alfil", 61, 78);
    design.setup("White", "Fers", 42, 78);
    design.setup("White", "Shah", 59, 78);

    design.setup("Black", "Sarbaz", 16, 79);
    design.setup("Black", "Sarbaz", 25, 79);
    design.setup("Black", "Sarbaz", 18, 79);
    design.setup("Black", "Sarbaz", 27, 79);
    design.setup("Black", "Sarbaz", 28, 79);
    design.setup("Black", "Sarbaz", 21, 79);
    design.setup("Black", "Sarbaz", 22, 79);
    design.setup("Black", "Sarbaz", 23, 79);
    design.setup("Black", "Rokh", 1, 79);
    design.setup("Black", "Rokh", 7, 79);
    design.setup("Black", "Asb", 10, 79);
    design.setup("Black", "Asb", 13, 79);
    design.setup("Black", "Alfil", 2, 79);
    design.setup("Black", "Alfil", 19, 79);
    design.setup("Black", "Fers", 20, 79);
    design.setup("Black", "Shah", 3, 79);
    design.setup("White", "Sarbaz", 48, 79);
    design.setup("White", "Sarbaz", 33, 79);
    design.setup("White", "Sarbaz", 34, 79);
    design.setup("White", "Sarbaz", 43, 79);
    design.setup("White", "Sarbaz", 44, 79);
    design.setup("White", "Sarbaz", 45, 79);
    design.setup("White", "Sarbaz", 46, 79);
    design.setup("White", "Sarbaz", 47, 79);
    design.setup("White", "Rokh", 57, 79);
    design.setup("White", "Rokh", 50, 79);
    design.setup("White", "Asb", 51, 79);
    design.setup("White", "Asb", 52, 79);
    design.setup("White", "Alfil", 58, 79);
    design.setup("White", "Alfil", 61, 79);
    design.setup("White", "Fers", 42, 79);
    design.setup("White", "Shah", 59, 79);

    design.setup("Black", "Sarbaz", 16, 80);
    design.setup("Black", "Sarbaz", 17, 80);
    design.setup("Black", "Sarbaz", 18, 80);
    design.setup("Black", "Sarbaz", 27, 80);
    design.setup("Black", "Sarbaz", 28, 80);
    design.setup("Black", "Sarbaz", 21, 80);
    design.setup("Black", "Sarbaz", 22, 80);
    design.setup("Black", "Sarbaz", 23, 80);
    design.setup("Black", "Rokh", 10, 80);
    design.setup("Black", "Rokh", 13, 80);
    design.setup("Black", "Asb", 11, 80);
    design.setup("Black", "Asb", 12, 80);
    design.setup("Black", "Alfil", 2, 80);
    design.setup("Black", "Alfil", 19, 80);
    design.setup("Black", "Fers", 20, 80);
    design.setup("Black", "Shah", 3, 80);
    design.setup("White", "Sarbaz", 48, 80);
    design.setup("White", "Sarbaz", 33, 80);
    design.setup("White", "Sarbaz", 34, 80);
    design.setup("White", "Sarbaz", 43, 80);
    design.setup("White", "Sarbaz", 44, 80);
    design.setup("White", "Sarbaz", 45, 80);
    design.setup("White", "Sarbaz", 46, 80);
    design.setup("White", "Sarbaz", 47, 80);
    design.setup("White", "Rokh", 57, 80);
    design.setup("White", "Rokh", 50, 80);
    design.setup("White", "Asb", 51, 80);
    design.setup("White", "Asb", 52, 80);
    design.setup("White", "Alfil", 58, 80);
    design.setup("White", "Alfil", 61, 80);
    design.setup("White", "Fers", 42, 80);
    design.setup("White", "Shah", 59, 80);

    design.setup("Black", "Sarbaz", 24, 81);
    design.setup("Black", "Sarbaz", 17, 81);
    design.setup("Black", "Sarbaz", 18, 81);
    design.setup("Black", "Sarbaz", 27, 81);
    design.setup("Black", "Sarbaz", 28, 81);
    design.setup("Black", "Sarbaz", 21, 81);
    design.setup("Black", "Sarbaz", 22, 81);
    design.setup("Black", "Sarbaz", 31, 81);
    design.setup("Black", "Rokh", 1, 81);
    design.setup("Black", "Rokh", 6, 81);
    design.setup("Black", "Asb", 11, 81);
    design.setup("Black", "Asb", 12, 81);
    design.setup("Black", "Alfil", 19, 81);
    design.setup("Black", "Alfil", 20, 81);
    design.setup("Black", "Fers", 10, 81);
    design.setup("Black", "Shah", 13, 81);
    design.setup("White", "Sarbaz", 32, 81);
    design.setup("White", "Sarbaz", 41, 81);
    design.setup("White", "Sarbaz", 42, 81);
    design.setup("White", "Sarbaz", 35, 81);
    design.setup("White", "Sarbaz", 36, 81);
    design.setup("White", "Sarbaz", 45, 81);
    design.setup("White", "Sarbaz", 46, 81);
    design.setup("White", "Sarbaz", 39, 81);
    design.setup("White", "Rokh", 57, 81);
    design.setup("White", "Rokh", 62, 81);
    design.setup("White", "Asb", 51, 81);
    design.setup("White", "Asb", 52, 81);
    design.setup("White", "Alfil", 43, 81);
    design.setup("White", "Alfil", 44, 81);
    design.setup("White", "Fers", 53, 81);
    design.setup("White", "Shah", 50, 81);

    design.setup("Black", "Sarbaz", 8, 82);
    design.setup("Black", "Sarbaz", 17, 82);
    design.setup("Black", "Sarbaz", 26, 82);
    design.setup("Black", "Sarbaz", 19, 82);
    design.setup("Black", "Sarbaz", 20, 82);
    design.setup("Black", "Sarbaz", 29, 82);
    design.setup("Black", "Sarbaz", 22, 82);
    design.setup("Black", "Sarbaz", 15, 82);
    design.setup("Black", "Rokh", 1, 82);
    design.setup("Black", "Rokh", 6, 82);
    design.setup("Black", "Asb", 18, 82);
    design.setup("Black", "Asb", 21, 82);
    design.setup("Black", "Alfil", 2, 82);
    design.setup("Black", "Alfil", 5, 82);
    design.setup("Black", "Fers", 4, 82);
    design.setup("Black", "Shah", 3, 82);
    design.setup("White", "Sarbaz", 32, 82);
    design.setup("White", "Sarbaz", 41, 82);
    design.setup("White", "Sarbaz", 42, 82);
    design.setup("White", "Sarbaz", 35, 82);
    design.setup("White", "Sarbaz", 36, 82);
    design.setup("White", "Sarbaz", 45, 82);
    design.setup("White", "Sarbaz", 46, 82);
    design.setup("White", "Sarbaz", 39, 82);
    design.setup("White", "Rokh", 57, 82);
    design.setup("White", "Rokh", 62, 82);
    design.setup("White", "Asb", 51, 82);
    design.setup("White", "Asb", 52, 82);
    design.setup("White", "Alfil", 43, 82);
    design.setup("White", "Alfil", 44, 82);
    design.setup("White", "Fers", 53, 82);
    design.setup("White", "Shah", 50, 82);

    design.setup("Black", "Sarbaz", 8, 83);
    design.setup("Black", "Sarbaz", 17, 83);
    design.setup("Black", "Sarbaz", 18, 83);
    design.setup("Black", "Sarbaz", 27, 83);
    design.setup("Black", "Sarbaz", 28, 83);
    design.setup("Black", "Sarbaz", 21, 83);
    design.setup("Black", "Sarbaz", 14, 83);
    design.setup("Black", "Sarbaz", 23, 83);
    design.setup("Black", "Rokh", 0, 83);
    design.setup("Black", "Rokh", 7, 83);
    design.setup("Black", "Asb", 11, 83);
    design.setup("Black", "Asb", 12, 83);
    design.setup("Black", "Alfil", 2, 83);
    design.setup("Black", "Alfil", 5, 83);
    design.setup("Black", "Fers", 19, 83);
    design.setup("Black", "Shah", 4, 83);
    design.setup("White", "Sarbaz", 32, 83);
    design.setup("White", "Sarbaz", 41, 83);
    design.setup("White", "Sarbaz", 42, 83);
    design.setup("White", "Sarbaz", 35, 83);
    design.setup("White", "Sarbaz", 36, 83);
    design.setup("White", "Sarbaz", 45, 83);
    design.setup("White", "Sarbaz", 46, 83);
    design.setup("White", "Sarbaz", 39, 83);
    design.setup("White", "Rokh", 57, 83);
    design.setup("White", "Rokh", 62, 83);
    design.setup("White", "Asb", 51, 83);
    design.setup("White", "Asb", 52, 83);
    design.setup("White", "Alfil", 43, 83);
    design.setup("White", "Alfil", 44, 83);
    design.setup("White", "Fers", 53, 83);
    design.setup("White", "Shah", 50, 83);

    design.setup("Black", "Sarbaz", 8, 84);
    design.setup("Black", "Sarbaz", 25, 84);
    design.setup("Black", "Sarbaz", 34, 84);
    design.setup("Black", "Sarbaz", 19, 84);
    design.setup("Black", "Sarbaz", 28, 84);
    design.setup("Black", "Sarbaz", 21, 84);
    design.setup("Black", "Sarbaz", 22, 84);
    design.setup("Black", "Sarbaz", 23, 84);
    design.setup("Black", "Rokh", 1, 84);
    design.setup("Black", "Rokh", 6, 84);
    design.setup("Black", "Asb", 18, 84);
    design.setup("Black", "Asb", 12, 84);
    design.setup("Black", "Alfil", 2, 84);
    design.setup("Black", "Alfil", 5, 84);
    design.setup("Black", "Fers", 20, 84);
    design.setup("Black", "Shah", 3, 84);
    design.setup("White", "Sarbaz", 32, 84);
    design.setup("White", "Sarbaz", 41, 84);
    design.setup("White", "Sarbaz", 42, 84);
    design.setup("White", "Sarbaz", 35, 84);
    design.setup("White", "Sarbaz", 36, 84);
    design.setup("White", "Sarbaz", 45, 84);
    design.setup("White", "Sarbaz", 46, 84);
    design.setup("White", "Sarbaz", 39, 84);
    design.setup("White", "Rokh", 57, 84);
    design.setup("White", "Rokh", 62, 84);
    design.setup("White", "Asb", 51, 84);
    design.setup("White", "Asb", 52, 84);
    design.setup("White", "Alfil", 43, 84);
    design.setup("White", "Alfil", 44, 84);
    design.setup("White", "Fers", 53, 84);
    design.setup("White", "Shah", 50, 84);

    design.setup("Black", "Sarbaz", 8, 85);
    design.setup("Black", "Sarbaz", 25, 85);
    design.setup("Black", "Sarbaz", 18, 85);
    design.setup("Black", "Sarbaz", 19, 85);
    design.setup("Black", "Sarbaz", 20, 85);
    design.setup("Black", "Sarbaz", 21, 85);
    design.setup("Black", "Sarbaz", 22, 85);
    design.setup("Black", "Sarbaz", 23, 85);
    design.setup("Black", "Rokh", 1, 85);
    design.setup("Black", "Rokh", 10, 85);
    design.setup("Black", "Asb", 11, 85);
    design.setup("Black", "Asb", 6, 85);
    design.setup("Black", "Alfil", 2, 85);
    design.setup("Black", "Alfil", 5, 85);
    design.setup("Black", "Fers", 4, 85);
    design.setup("Black", "Shah", 3, 85);
    design.setup("White", "Sarbaz", 32, 85);
    design.setup("White", "Sarbaz", 41, 85);
    design.setup("White", "Sarbaz", 42, 85);
    design.setup("White", "Sarbaz", 35, 85);
    design.setup("White", "Sarbaz", 36, 85);
    design.setup("White", "Sarbaz", 45, 85);
    design.setup("White", "Sarbaz", 46, 85);
    design.setup("White", "Sarbaz", 39, 85);
    design.setup("White", "Rokh", 57, 85);
    design.setup("White", "Rokh", 62, 85);
    design.setup("White", "Asb", 51, 85);
    design.setup("White", "Asb", 52, 85);
    design.setup("White", "Alfil", 43, 85);
    design.setup("White", "Alfil", 44, 85);
    design.setup("White", "Fers", 53, 85);
    design.setup("White", "Shah", 50, 85);

    design.setup("Black", "Sarbaz", 24, 86);
    design.setup("Black", "Sarbaz", 17, 86);
    design.setup("Black", "Sarbaz", 18, 86);
    design.setup("Black", "Sarbaz", 19, 86);
    design.setup("Black", "Sarbaz", 28, 86);
    design.setup("Black", "Sarbaz", 37, 86);
    design.setup("Black", "Sarbaz", 14, 86);
    design.setup("Black", "Sarbaz", 31, 86);
    design.setup("Black", "Rokh", 1, 86);
    design.setup("Black", "Rokh", 2, 86);
    design.setup("Black", "Asb", 11, 86);
    design.setup("Black", "Asb", 21, 86);
    design.setup("Black", "Alfil", 20, 86);
    design.setup("Black", "Alfil", 23, 86);
    design.setup("Black", "Fers", 5, 86);
    design.setup("Black", "Shah", 6, 86);
    design.setup("White", "Sarbaz", 32, 86);
    design.setup("White", "Sarbaz", 41, 86);
    design.setup("White", "Sarbaz", 42, 86);
    design.setup("White", "Sarbaz", 35, 86);
    design.setup("White", "Sarbaz", 36, 86);
    design.setup("White", "Sarbaz", 45, 86);
    design.setup("White", "Sarbaz", 46, 86);
    design.setup("White", "Sarbaz", 39, 86);
    design.setup("White", "Rokh", 57, 86);
    design.setup("White", "Rokh", 62, 86);
    design.setup("White", "Asb", 51, 86);
    design.setup("White", "Asb", 52, 86);
    design.setup("White", "Alfil", 43, 86);
    design.setup("White", "Alfil", 44, 86);
    design.setup("White", "Fers", 53, 86);
    design.setup("White", "Shah", 50, 86);

    design.setup("Black", "Sarbaz", 24, 87);
    design.setup("Black", "Sarbaz", 17, 87);
    design.setup("Black", "Sarbaz", 18, 87);
    design.setup("Black", "Sarbaz", 19, 87);
    design.setup("Black", "Sarbaz", 28, 87);
    design.setup("Black", "Sarbaz", 37, 87);
    design.setup("Black", "Sarbaz", 30, 87);
    design.setup("Black", "Rokh", 14, 87);
    design.setup("Black", "Rokh", 7, 87);
    design.setup("Black", "Asb", 11, 87);
    design.setup("Black", "Asb", 22, 87);
    design.setup("Black", "Alfil", 20, 87);
    design.setup("Black", "Alfil", 23, 87);
    design.setup("Black", "Fers", 21, 87);
    design.setup("Black", "Shah", 13, 87);
    design.setup("White", "Sarbaz", 32, 87);
    design.setup("White", "Sarbaz", 41, 87);
    design.setup("White", "Sarbaz", 42, 87);
    design.setup("White", "Sarbaz", 35, 87);
    design.setup("White", "Sarbaz", 36, 87);
    design.setup("White", "Sarbaz", 45, 87);
    design.setup("White", "Sarbaz", 46, 87);
    design.setup("White", "Sarbaz", 39, 87);
    design.setup("White", "Rokh", 57, 87);
    design.setup("White", "Rokh", 62, 87);
    design.setup("White", "Asb", 51, 87);
    design.setup("White", "Asb", 52, 87);
    design.setup("White", "Alfil", 43, 87);
    design.setup("White", "Alfil", 44, 87);
    design.setup("White", "Fers", 53, 87);
    design.setup("White", "Shah", 50, 87);

    design.setup("Black", "Sarbaz", 24, 88);
    design.setup("Black", "Sarbaz", 17, 88);
    design.setup("Black", "Sarbaz", 26, 88);
    design.setup("Black", "Sarbaz", 11, 88);
    design.setup("Black", "Sarbaz", 12, 88);
    design.setup("Black", "Sarbaz", 29, 88);
    design.setup("Black", "Sarbaz", 22, 88);
    design.setup("Black", "Sarbaz", 31, 88);
    design.setup("Black", "Rokh", 2, 88);
    design.setup("Black", "Rokh", 7, 88);
    design.setup("Black", "Asb", 18, 88);
    design.setup("Black", "Asb", 21, 88);
    design.setup("Black", "Alfil", 16, 88);
    design.setup("Black", "Alfil", 19, 88);
    design.setup("Black", "Fers", 20, 88);
    design.setup("Black", "Shah", 13, 88);
    design.setup("White", "Sarbaz", 32, 88);
    design.setup("White", "Sarbaz", 41, 88);
    design.setup("White", "Sarbaz", 42, 88);
    design.setup("White", "Sarbaz", 35, 88);
    design.setup("White", "Sarbaz", 36, 88);
    design.setup("White", "Sarbaz", 45, 88);
    design.setup("White", "Sarbaz", 46, 88);
    design.setup("White", "Sarbaz", 39, 88);
    design.setup("White", "Rokh", 57, 88);
    design.setup("White", "Rokh", 62, 88);
    design.setup("White", "Asb", 51, 88);
    design.setup("White", "Asb", 52, 88);
    design.setup("White", "Alfil", 43, 88);
    design.setup("White", "Alfil", 44, 88);
    design.setup("White", "Fers", 53, 88);
    design.setup("White", "Shah", 50, 88);

    design.setup("Black", "Sarbaz", 16, 89);
    design.setup("Black", "Sarbaz", 17, 89);
    design.setup("Black", "Sarbaz", 18, 89);
    design.setup("Black", "Sarbaz", 19, 89);
    design.setup("Black", "Sarbaz", 20, 89);
    design.setup("Black", "Sarbaz", 21, 89);
    design.setup("Black", "Sarbaz", 30, 89);
    design.setup("Black", "Sarbaz", 23, 89);
    design.setup("Black", "Rokh", 13, 89);
    design.setup("Black", "Rokh", 6, 89);
    design.setup("Black", "Asb", 11, 89);
    design.setup("Black", "Asb", 12, 89);
    design.setup("Black", "Alfil", 2, 89);
    design.setup("Black", "Alfil", 5, 89);
    design.setup("Black", "Fers", 4, 89);
    design.setup("Black", "Shah", 3, 89);
    design.setup("White", "Sarbaz", 32, 89);
    design.setup("White", "Sarbaz", 41, 89);
    design.setup("White", "Sarbaz", 42, 89);
    design.setup("White", "Sarbaz", 35, 89);
    design.setup("White", "Sarbaz", 36, 89);
    design.setup("White", "Sarbaz", 45, 89);
    design.setup("White", "Sarbaz", 46, 89);
    design.setup("White", "Sarbaz", 39, 89);
    design.setup("White", "Rokh", 57, 89);
    design.setup("White", "Rokh", 62, 89);
    design.setup("White", "Asb", 51, 89);
    design.setup("White", "Asb", 52, 89);
    design.setup("White", "Alfil", 43, 89);
    design.setup("White", "Alfil", 44, 89);
    design.setup("White", "Fers", 53, 89);
    design.setup("White", "Shah", 50, 89);

    design.setup("Black", "Sarbaz", 16, 90);
    design.setup("Black", "Sarbaz", 25, 90);
    design.setup("Black", "Sarbaz", 18, 90);
    design.setup("Black", "Sarbaz", 27, 90);
    design.setup("Black", "Sarbaz", 28, 90);
    design.setup("Black", "Sarbaz", 21, 90);
    design.setup("Black", "Sarbaz", 22, 90);
    design.setup("Black", "Sarbaz", 23, 90);
    design.setup("Black", "Rokh", 1, 90);
    design.setup("Black", "Rokh", 7, 90);
    design.setup("Black", "Asb", 10, 90);
    design.setup("Black", "Asb", 13, 90);
    design.setup("Black", "Alfil", 2, 90);
    design.setup("Black", "Alfil", 19, 90);
    design.setup("Black", "Fers", 20, 90);
    design.setup("Black", "Shah", 3, 90);
    design.setup("White", "Sarbaz", 32, 90);
    design.setup("White", "Sarbaz", 41, 90);
    design.setup("White", "Sarbaz", 42, 90);
    design.setup("White", "Sarbaz", 35, 90);
    design.setup("White", "Sarbaz", 36, 90);
    design.setup("White", "Sarbaz", 45, 90);
    design.setup("White", "Sarbaz", 46, 90);
    design.setup("White", "Sarbaz", 39, 90);
    design.setup("White", "Rokh", 57, 90);
    design.setup("White", "Rokh", 62, 90);
    design.setup("White", "Asb", 51, 90);
    design.setup("White", "Asb", 52, 90);
    design.setup("White", "Alfil", 43, 90);
    design.setup("White", "Alfil", 44, 90);
    design.setup("White", "Fers", 53, 90);
    design.setup("White", "Shah", 50, 90);

    design.setup("Black", "Sarbaz", 8, 91);
    design.setup("Black", "Sarbaz", 25, 91);
    design.setup("Black", "Sarbaz", 26, 91);
    design.setup("Black", "Sarbaz", 19, 91);
    design.setup("Black", "Sarbaz", 20, 91);
    design.setup("Black", "Sarbaz", 21, 91);
    design.setup("Black", "Sarbaz", 22, 91);
    design.setup("Black", "Sarbaz", 23, 91);
    design.setup("Black", "Rokh", 1, 91);
    design.setup("Black", "Rokh", 10, 91);
    design.setup("Black", "Asb", 11, 91);
    design.setup("Black", "Asb", 12, 91);
    design.setup("Black", "Alfil", 2, 91);
    design.setup("Black", "Alfil", 5, 91);
    design.setup("Black", "Fers", 18, 91);
    design.setup("Black", "Shah", 3, 91);
    design.setup("White", "Sarbaz", 32, 91);
    design.setup("White", "Sarbaz", 41, 91);
    design.setup("White", "Sarbaz", 42, 91);
    design.setup("White", "Sarbaz", 35, 91);
    design.setup("White", "Sarbaz", 36, 91);
    design.setup("White", "Sarbaz", 45, 91);
    design.setup("White", "Sarbaz", 46, 91);
    design.setup("White", "Sarbaz", 39, 91);
    design.setup("White", "Rokh", 57, 91);
    design.setup("White", "Rokh", 62, 91);
    design.setup("White", "Asb", 51, 91);
    design.setup("White", "Asb", 52, 91);
    design.setup("White", "Alfil", 43, 91);
    design.setup("White", "Alfil", 44, 91);
    design.setup("White", "Fers", 53, 91);
    design.setup("White", "Shah", 50, 91);

    design.setup("Black", "Sarbaz", 16, 92);
    design.setup("Black", "Sarbaz", 17, 92);
    design.setup("Black", "Sarbaz", 18, 92);
    design.setup("Black", "Sarbaz", 27, 92);
    design.setup("Black", "Sarbaz", 28, 92);
    design.setup("Black", "Sarbaz", 21, 92);
    design.setup("Black", "Sarbaz", 22, 92);
    design.setup("Black", "Sarbaz", 23, 92);
    design.setup("Black", "Rokh", 10, 92);
    design.setup("Black", "Rokh", 13, 92);
    design.setup("Black", "Asb", 11, 92);
    design.setup("Black", "Asb", 12, 92);
    design.setup("Black", "Alfil", 2, 92);
    design.setup("Black", "Alfil", 19, 92);
    design.setup("Black", "Fers", 20, 92);
    design.setup("Black", "Shah", 3, 92);
    design.setup("White", "Sarbaz", 32, 92);
    design.setup("White", "Sarbaz", 41, 92);
    design.setup("White", "Sarbaz", 42, 92);
    design.setup("White", "Sarbaz", 35, 92);
    design.setup("White", "Sarbaz", 36, 92);
    design.setup("White", "Sarbaz", 45, 92);
    design.setup("White", "Sarbaz", 46, 92);
    design.setup("White", "Sarbaz", 39, 92);
    design.setup("White", "Rokh", 57, 92);
    design.setup("White", "Rokh", 62, 92);
    design.setup("White", "Asb", 51, 92);
    design.setup("White", "Asb", 52, 92);
    design.setup("White", "Alfil", 43, 92);
    design.setup("White", "Alfil", 44, 92);
    design.setup("White", "Fers", 53, 92);
    design.setup("White", "Shah", 50, 92);

    design.setup("Black", "Sarbaz", 24, 93);
    design.setup("Black", "Sarbaz", 17, 93);
    design.setup("Black", "Sarbaz", 18, 93);
    design.setup("Black", "Sarbaz", 19, 93);
    design.setup("Black", "Sarbaz", 28, 93);
    design.setup("Black", "Sarbaz", 37, 93);
    design.setup("Black", "Sarbaz", 14, 93);
    design.setup("Black", "Sarbaz", 31, 93);
    design.setup("Black", "Rokh", 1, 93);
    design.setup("Black", "Rokh", 2, 93);
    design.setup("Black", "Asb", 11, 93);
    design.setup("Black", "Asb", 21, 93);
    design.setup("Black", "Alfil", 20, 93);
    design.setup("Black", "Alfil", 23, 93);
    design.setup("Black", "Fers", 5, 93);
    design.setup("Black", "Shah", 6, 93);
    design.setup("White", "Sarbaz", 32, 93);
    design.setup("White", "Sarbaz", 41, 93);
    design.setup("White", "Sarbaz", 42, 93);
    design.setup("White", "Sarbaz", 43, 93);
    design.setup("White", "Sarbaz", 36, 93);
    design.setup("White", "Sarbaz", 45, 93);
    design.setup("White", "Sarbaz", 54, 93);
    design.setup("White", "Sarbaz", 39, 93);
    design.setup("White", "Rokh", 57, 93);
    design.setup("White", "Rokh", 58, 93);
    design.setup("White", "Asb", 51, 93);
    design.setup("White", "Asb", 52, 93);
    design.setup("White", "Alfil", 40, 93);
    design.setup("White", "Alfil", 47, 93);
    design.setup("White", "Fers", 61, 93);
    design.setup("White", "Shah", 62, 93);
}

Dagaz.View.configure = function(view) {
    view.defBoard("Board");
    view.defPiece("WhiteShah", "White Shah");
    view.defPiece("BlackShah", "Black Shah");
    view.defPiece("WhiteFers", "White Fers");
    view.defPiece("BlackFers", "Black Fers");
    view.defPiece("WhiteRokh", "White Rokh");
    view.defPiece("BlackRokh", "Black Rokh");
    view.defPiece("WhiteAlfil", "White Alfil");
    view.defPiece("BlackAlfil", "Black Alfil");
    view.defPiece("WhiteAsb", "White Asb");
    view.defPiece("BlackAsb", "Black Asb");
    view.defPiece("WhiteSarbaz", "White Sarbaz");
    view.defPiece("BlackSarbaz", "Black Sarbaz");
 
    view.defPosition("a8", 2, 2, 50, 50);
    view.defPosition("b8", 52, 2, 50, 50);
    view.defPosition("c8", 102, 2, 50, 50);
    view.defPosition("d8", 152, 2, 50, 50);
    view.defPosition("e8", 202, 2, 50, 50);
    view.defPosition("f8", 252, 2, 50, 50);
    view.defPosition("g8", 302, 2, 50, 50);
    view.defPosition("h8", 352, 2, 50, 50);
    view.defPosition("a7", 2, 52, 50, 50);
    view.defPosition("b7", 52, 52, 50, 50);
    view.defPosition("c7", 102, 52, 50, 50);
    view.defPosition("d7", 152, 52, 50, 50);
    view.defPosition("e7", 202, 52, 50, 50);
    view.defPosition("f7", 252, 52, 50, 50);
    view.defPosition("g7", 302, 52, 50, 50);
    view.defPosition("h7", 352, 52, 50, 50);
    view.defPosition("a6", 2, 102, 50, 50);
    view.defPosition("b6", 52, 102, 50, 50);
    view.defPosition("c6", 102, 102, 50, 50);
    view.defPosition("d6", 152, 102, 50, 50);
    view.defPosition("e6", 202, 102, 50, 50);
    view.defPosition("f6", 252, 102, 50, 50);
    view.defPosition("g6", 302, 102, 50, 50);
    view.defPosition("h6", 352, 102, 50, 50);
    view.defPosition("a5", 2, 152, 50, 50);
    view.defPosition("b5", 52, 152, 50, 50);
    view.defPosition("c5", 102, 152, 50, 50);
    view.defPosition("d5", 152, 152, 50, 50);
    view.defPosition("e5", 202, 152, 50, 50);
    view.defPosition("f5", 252, 152, 50, 50);
    view.defPosition("g5", 302, 152, 50, 50);
    view.defPosition("h5", 352, 152, 50, 50);
    view.defPosition("a4", 2, 202, 50, 50);
    view.defPosition("b4", 52, 202, 50, 50);
    view.defPosition("c4", 102, 202, 50, 50);
    view.defPosition("d4", 152, 202, 50, 50);
    view.defPosition("e4", 202, 202, 50, 50);
    view.defPosition("f4", 252, 202, 50, 50);
    view.defPosition("g4", 302, 202, 50, 50);
    view.defPosition("h4", 352, 202, 50, 50);
    view.defPosition("a3", 2, 252, 50, 50);
    view.defPosition("b3", 52, 252, 50, 50);
    view.defPosition("c3", 102, 252, 50, 50);
    view.defPosition("d3", 152, 252, 50, 50);
    view.defPosition("e3", 202, 252, 50, 50);
    view.defPosition("f3", 252, 252, 50, 50);
    view.defPosition("g3", 302, 252, 50, 50);
    view.defPosition("h3", 352, 252, 50, 50);
    view.defPosition("a2", 2, 302, 50, 50);
    view.defPosition("b2", 52, 302, 50, 50);
    view.defPosition("c2", 102, 302, 50, 50);
    view.defPosition("d2", 152, 302, 50, 50);
    view.defPosition("e2", 202, 302, 50, 50);
    view.defPosition("f2", 252, 302, 50, 50);
    view.defPosition("g2", 302, 302, 50, 50);
    view.defPosition("h2", 352, 302, 50, 50);
    view.defPosition("a1", 2, 352, 50, 50);
    view.defPosition("b1", 52, 352, 50, 50);
    view.defPosition("c1", 102, 352, 50, 50);
    view.defPosition("d1", 152, 352, 50, 50);
    view.defPosition("e1", 202, 352, 50, 50);
    view.defPosition("f1", 252, 352, 50, 50);
    view.defPosition("g1", 302, 352, 50, 50);
    view.defPosition("h1", 352, 352, 50, 50);
}
