Dagaz.Model.NO_SOUND = true;
Dagaz.Model.WEST_POS = 33;
Dagaz.Model.EAST_POS = 794;

ZRF = {
    JUMP:          0,
    IF:            1,
    FORK:          2,
    FUNCTION:      3,
    IN_ZONE:       4,
    FLAG:          5,
    SET_FLAG:      6,
    POS_FLAG:      7,
    SET_POS_FLAG:  8,
    ATTR:          9,
    SET_ATTR:      10,
    PROMOTE:       11,
    MODE:          12,
    ON_BOARD_DIR:  13,
    ON_BOARD_POS:  14,
    PARAM:         15,
    LITERAL:       16,
    VERIFY:        20
};

Dagaz.Model.BuildDesign = function(design) {
    design.checkVersion("z2j", "2");
    design.checkVersion("animate-drops", "false");
    design.checkVersion("animate-captures", "false");
    design.checkVersion("show-blink", "false");
    design.checkVersion("show-hints", "false");
    design.checkVersion("show-drops", "true");
    design.checkVersion("show-captures", "false");
    design.checkVersion("animate-redo", "false");
    design.checkVersion("smart-moves", "to");

    design.addDirection("s");
    design.addDirection("e");
    design.addDirection("w");
    design.addDirection("n");

    design.addPlayer("West", [3, 2, 1, 0]);
    design.addPlayer("East", [0, 1, 2, 3]);
    design.addPlayer("None", [0, 1, 2, 3]);
    design.addTurn(1);
    design.addTurn(2);

    design.addPosition("AX", [0, 0, 0, 0]);
    design.addPosition("BX", [0, 0, 0, 0]);
    design.addPosition("CX", [0, 0, 0, 0]);
    design.addPosition("DX", [0, 0, 0, 0]);
    design.addPosition("EX", [0, 0, 0, 0]);
    design.addPosition("FX", [0, 0, 0, 0]);
    design.addPosition("GX", [0, 0, 0, 0]);
    design.addPosition("AY", [0, 0, 0, 0]);
    design.addPosition("BY", [0, 0, 0, 0]);
    design.addPosition("CY", [0, 0, 0, 0]);
    design.addPosition("DY", [0, 0, 0, 0]);
    design.addPosition("EY", [0, 0, 0, 0]);
    design.addPosition("FY", [0, 0, 0, 0]);
    design.addPosition("GY", [0, 0, 0, 0]);
    design.addPosition("a1", [20, 1, 0, 0]);
    design.addPosition("b1", [20, 1, -1, 0]);
    design.addPosition("c1", [20, 1, -1, 0]);
    design.addPosition("d1", [20, 1, -1, 0]);
    design.addPosition("e1", [20, 1, -1, 0]);
    design.addPosition("f1", [20, 1, -1, 0]);
    design.addPosition("g1", [20, 1, -1, 0]);
    design.addPosition("h1", [20, 1, -1, 0]);
    design.addPosition("i1", [20, 1, -1, 0]);
    design.addPosition("j1", [20, 1, -1, 0]);
    design.addPosition("k1", [20, 1, -1, 0]);
    design.addPosition("l1", [20, 1, -1, 0]);
    design.addPosition("m1", [20, 1, -1, 0]);
    design.addPosition("n1", [20, 1, -1, 0]);
    design.addPosition("o1", [20, 1, -1, 0]);
    design.addPosition("p1", [20, 1, -1, 0]);
    design.addPosition("q1", [20, 1, -1, 0]);
    design.addPosition("r1", [20, 1, -1, 0]);
    design.addPosition("s1", [20, 1, -1, 0]);
    design.addPosition("t1", [20, 0, -1, 0]);
    design.addPosition("a2", [20, 1, 0, -20]);
    design.addPosition("b2", [20, 1, -1, -20]);
    design.addPosition("c2", [20, 1, -1, -20]);
    design.addPosition("d2", [20, 1, -1, -20]);
    design.addPosition("e2", [20, 1, -1, -20]);
    design.addPosition("f2", [20, 1, -1, -20]);
    design.addPosition("g2", [20, 1, -1, -20]);
    design.addPosition("h2", [20, 1, -1, -20]);
    design.addPosition("i2", [20, 1, -1, -20]);
    design.addPosition("j2", [20, 1, -1, -20]);
    design.addPosition("k2", [20, 1, -1, -20]);
    design.addPosition("l2", [20, 1, -1, -20]);
    design.addPosition("m2", [20, 1, -1, -20]);
    design.addPosition("n2", [20, 1, -1, -20]);
    design.addPosition("o2", [20, 1, -1, -20]);
    design.addPosition("p2", [20, 1, -1, -20]);
    design.addPosition("q2", [20, 1, -1, -20]);
    design.addPosition("r2", [20, 1, -1, -20]);
    design.addPosition("s2", [20, 1, -1, -20]);
    design.addPosition("t2", [20, 0, -1, -20]);
    design.addPosition("a3", [20, 1, 0, -20]);
    design.addPosition("b3", [20, 1, -1, -20]);
    design.addPosition("c3", [20, 1, -1, -20]);
    design.addPosition("d3", [20, 1, -1, -20]);
    design.addPosition("e3", [20, 1, -1, -20]);
    design.addPosition("f3", [20, 1, -1, -20]);
    design.addPosition("g3", [20, 1, -1, -20]);
    design.addPosition("h3", [20, 1, -1, -20]);
    design.addPosition("i3", [20, 1, -1, -20]);
    design.addPosition("j3", [20, 1, -1, -20]);
    design.addPosition("k3", [20, 1, -1, -20]);
    design.addPosition("l3", [20, 1, -1, -20]);
    design.addPosition("m3", [20, 1, -1, -20]);
    design.addPosition("n3", [20, 1, -1, -20]);
    design.addPosition("o3", [20, 1, -1, -20]);
    design.addPosition("p3", [20, 1, -1, -20]);
    design.addPosition("q3", [20, 1, -1, -20]);
    design.addPosition("r3", [20, 1, -1, -20]);
    design.addPosition("s3", [20, 1, -1, -20]);
    design.addPosition("t3", [20, 0, -1, -20]);
    design.addPosition("a4", [20, 1, 0, -20]);
    design.addPosition("b4", [20, 1, -1, -20]);
    design.addPosition("c4", [20, 1, -1, -20]);
    design.addPosition("d4", [20, 1, -1, -20]);
    design.addPosition("e4", [20, 1, -1, -20]);
    design.addPosition("f4", [20, 1, -1, -20]);
    design.addPosition("g4", [20, 1, -1, -20]);
    design.addPosition("h4", [20, 1, -1, -20]);
    design.addPosition("i4", [20, 1, -1, -20]);
    design.addPosition("j4", [20, 1, -1, -20]);
    design.addPosition("k4", [20, 1, -1, -20]);
    design.addPosition("l4", [20, 1, -1, -20]);
    design.addPosition("m4", [20, 1, -1, -20]);
    design.addPosition("n4", [20, 1, -1, -20]);
    design.addPosition("o4", [20, 1, -1, -20]);
    design.addPosition("p4", [20, 1, -1, -20]);
    design.addPosition("q4", [20, 1, -1, -20]);
    design.addPosition("r4", [20, 1, -1, -20]);
    design.addPosition("s4", [20, 1, -1, -20]);
    design.addPosition("t4", [20, 0, -1, -20]);
    design.addPosition("a5", [20, 1, 0, -20]);
    design.addPosition("b5", [20, 1, -1, -20]);
    design.addPosition("c5", [20, 1, -1, -20]);
    design.addPosition("d5", [20, 1, -1, -20]);
    design.addPosition("e5", [20, 1, -1, -20]);
    design.addPosition("f5", [20, 1, -1, -20]);
    design.addPosition("g5", [20, 1, -1, -20]);
    design.addPosition("h5", [20, 1, -1, -20]);
    design.addPosition("i5", [20, 1, -1, -20]);
    design.addPosition("j5", [20, 1, -1, -20]);
    design.addPosition("k5", [20, 1, -1, -20]);
    design.addPosition("l5", [20, 1, -1, -20]);
    design.addPosition("m5", [20, 1, -1, -20]);
    design.addPosition("n5", [20, 1, -1, -20]);
    design.addPosition("o5", [20, 1, -1, -20]);
    design.addPosition("p5", [20, 1, -1, -20]);
    design.addPosition("q5", [20, 1, -1, -20]);
    design.addPosition("r5", [20, 1, -1, -20]);
    design.addPosition("s5", [20, 1, -1, -20]);
    design.addPosition("t5", [20, 0, -1, -20]);
    design.addPosition("a6", [20, 1, 0, -20]);
    design.addPosition("b6", [20, 1, -1, -20]);
    design.addPosition("c6", [20, 1, -1, -20]);
    design.addPosition("d6", [20, 1, -1, -20]);
    design.addPosition("e6", [20, 1, -1, -20]);
    design.addPosition("f6", [20, 1, -1, -20]);
    design.addPosition("g6", [20, 1, -1, -20]);
    design.addPosition("h6", [20, 1, -1, -20]);
    design.addPosition("i6", [20, 1, -1, -20]);
    design.addPosition("j6", [20, 1, -1, -20]);
    design.addPosition("k6", [20, 1, -1, -20]);
    design.addPosition("l6", [20, 1, -1, -20]);
    design.addPosition("m6", [20, 1, -1, -20]);
    design.addPosition("n6", [20, 1, -1, -20]);
    design.addPosition("o6", [20, 1, -1, -20]);
    design.addPosition("p6", [20, 1, -1, -20]);
    design.addPosition("q6", [20, 1, -1, -20]);
    design.addPosition("r6", [20, 1, -1, -20]);
    design.addPosition("s6", [20, 1, -1, -20]);
    design.addPosition("t6", [20, 0, -1, -20]);
    design.addPosition("a7", [20, 1, 0, -20]);
    design.addPosition("b7", [20, 1, -1, -20]);
    design.addPosition("c7", [20, 1, -1, -20]);
    design.addPosition("d7", [20, 1, -1, -20]);
    design.addPosition("e7", [20, 1, -1, -20]);
    design.addPosition("f7", [20, 1, -1, -20]);
    design.addPosition("g7", [20, 1, -1, -20]);
    design.addPosition("h7", [20, 1, -1, -20]);
    design.addPosition("i7", [20, 1, -1, -20]);
    design.addPosition("j7", [20, 1, -1, -20]);
    design.addPosition("k7", [20, 1, -1, -20]);
    design.addPosition("l7", [20, 1, -1, -20]);
    design.addPosition("m7", [20, 1, -1, -20]);
    design.addPosition("n7", [20, 1, -1, -20]);
    design.addPosition("o7", [20, 1, -1, -20]);
    design.addPosition("p7", [20, 1, -1, -20]);
    design.addPosition("q7", [20, 1, -1, -20]);
    design.addPosition("r7", [20, 1, -1, -20]);
    design.addPosition("s7", [20, 1, -1, -20]);
    design.addPosition("t7", [20, 0, -1, -20]);
    design.addPosition("a8", [20, 1, 0, -20]);
    design.addPosition("b8", [20, 1, -1, -20]);
    design.addPosition("c8", [20, 1, -1, -20]);
    design.addPosition("d8", [20, 1, -1, -20]);
    design.addPosition("e8", [20, 1, -1, -20]);
    design.addPosition("f8", [20, 1, -1, -20]);
    design.addPosition("g8", [20, 1, -1, -20]);
    design.addPosition("h8", [20, 1, -1, -20]);
    design.addPosition("i8", [20, 1, -1, -20]);
    design.addPosition("j8", [20, 1, -1, -20]);
    design.addPosition("k8", [20, 1, -1, -20]);
    design.addPosition("l8", [20, 1, -1, -20]);
    design.addPosition("m8", [20, 1, -1, -20]);
    design.addPosition("n8", [20, 1, -1, -20]);
    design.addPosition("o8", [20, 1, -1, -20]);
    design.addPosition("p8", [20, 1, -1, -20]);
    design.addPosition("q8", [20, 1, -1, -20]);
    design.addPosition("r8", [20, 1, -1, -20]);
    design.addPosition("s8", [20, 1, -1, -20]);
    design.addPosition("t8", [20, 0, -1, -20]);
    design.addPosition("a9", [20, 1, 0, -20]);
    design.addPosition("b9", [20, 1, -1, -20]);
    design.addPosition("c9", [20, 1, -1, -20]);
    design.addPosition("d9", [20, 1, -1, -20]);
    design.addPosition("e9", [20, 1, -1, -20]);
    design.addPosition("f9", [20, 1, -1, -20]);
    design.addPosition("g9", [20, 1, -1, -20]);
    design.addPosition("h9", [20, 1, -1, -20]);
    design.addPosition("i9", [20, 1, -1, -20]);
    design.addPosition("j9", [20, 1, -1, -20]);
    design.addPosition("k9", [20, 1, -1, -20]);
    design.addPosition("l9", [20, 1, -1, -20]);
    design.addPosition("m9", [20, 1, -1, -20]);
    design.addPosition("n9", [20, 1, -1, -20]);
    design.addPosition("o9", [20, 1, -1, -20]);
    design.addPosition("p9", [20, 1, -1, -20]);
    design.addPosition("q9", [20, 1, -1, -20]);
    design.addPosition("r9", [20, 1, -1, -20]);
    design.addPosition("s9", [20, 1, -1, -20]);
    design.addPosition("t9", [20, 0, -1, -20]);
    design.addPosition("a10", [20, 1, 0, -20]);
    design.addPosition("b10", [20, 1, -1, -20]);
    design.addPosition("c10", [20, 1, -1, -20]);
    design.addPosition("d10", [20, 1, -1, -20]);
    design.addPosition("e10", [20, 1, -1, -20]);
    design.addPosition("f10", [20, 1, -1, -20]);
    design.addPosition("g10", [20, 1, -1, -20]);
    design.addPosition("h10", [20, 1, -1, -20]);
    design.addPosition("i10", [20, 1, -1, -20]);
    design.addPosition("j10", [20, 1, -1, -20]);
    design.addPosition("k10", [20, 1, -1, -20]);
    design.addPosition("l10", [20, 1, -1, -20]);
    design.addPosition("m10", [20, 1, -1, -20]);
    design.addPosition("n10", [20, 1, -1, -20]);
    design.addPosition("o10", [20, 1, -1, -20]);
    design.addPosition("p10", [20, 1, -1, -20]);
    design.addPosition("q10", [20, 1, -1, -20]);
    design.addPosition("r10", [20, 1, -1, -20]);
    design.addPosition("s10", [20, 1, -1, -20]);
    design.addPosition("t10", [20, 0, -1, -20]);
    design.addPosition("a11", [20, 1, 0, -20]);
    design.addPosition("b11", [20, 1, -1, -20]);
    design.addPosition("c11", [20, 1, -1, -20]);
    design.addPosition("d11", [20, 1, -1, -20]);
    design.addPosition("e11", [20, 1, -1, -20]);
    design.addPosition("f11", [20, 1, -1, -20]);
    design.addPosition("g11", [20, 1, -1, -20]);
    design.addPosition("h11", [20, 1, -1, -20]);
    design.addPosition("i11", [20, 1, -1, -20]);
    design.addPosition("j11", [20, 1, -1, -20]);
    design.addPosition("k11", [20, 1, -1, -20]);
    design.addPosition("l11", [20, 1, -1, -20]);
    design.addPosition("m11", [20, 1, -1, -20]);
    design.addPosition("n11", [20, 1, -1, -20]);
    design.addPosition("o11", [20, 1, -1, -20]);
    design.addPosition("p11", [20, 1, -1, -20]);
    design.addPosition("q11", [20, 1, -1, -20]);
    design.addPosition("r11", [20, 1, -1, -20]);
    design.addPosition("s11", [20, 1, -1, -20]);
    design.addPosition("t11", [20, 0, -1, -20]);
    design.addPosition("a12", [20, 1, 0, -20]);
    design.addPosition("b12", [20, 1, -1, -20]);
    design.addPosition("c12", [20, 1, -1, -20]);
    design.addPosition("d12", [20, 1, -1, -20]);
    design.addPosition("e12", [20, 1, -1, -20]);
    design.addPosition("f12", [20, 1, -1, -20]);
    design.addPosition("g12", [20, 1, -1, -20]);
    design.addPosition("h12", [20, 1, -1, -20]);
    design.addPosition("i12", [20, 1, -1, -20]);
    design.addPosition("j12", [20, 1, -1, -20]);
    design.addPosition("k12", [20, 1, -1, -20]);
    design.addPosition("l12", [20, 1, -1, -20]);
    design.addPosition("m12", [20, 1, -1, -20]);
    design.addPosition("n12", [20, 1, -1, -20]);
    design.addPosition("o12", [20, 1, -1, -20]);
    design.addPosition("p12", [20, 1, -1, -20]);
    design.addPosition("q12", [20, 1, -1, -20]);
    design.addPosition("r12", [20, 1, -1, -20]);
    design.addPosition("s12", [20, 1, -1, -20]);
    design.addPosition("t12", [20, 0, -1, -20]);
    design.addPosition("a13", [20, 1, 0, -20]);
    design.addPosition("b13", [20, 1, -1, -20]);
    design.addPosition("c13", [20, 1, -1, -20]);
    design.addPosition("d13", [20, 1, -1, -20]);
    design.addPosition("e13", [20, 1, -1, -20]);
    design.addPosition("f13", [20, 1, -1, -20]);
    design.addPosition("g13", [20, 1, -1, -20]);
    design.addPosition("h13", [20, 1, -1, -20]);
    design.addPosition("i13", [20, 1, -1, -20]);
    design.addPosition("j13", [20, 1, -1, -20]);
    design.addPosition("k13", [20, 1, -1, -20]);
    design.addPosition("l13", [20, 1, -1, -20]);
    design.addPosition("m13", [20, 1, -1, -20]);
    design.addPosition("n13", [20, 1, -1, -20]);
    design.addPosition("o13", [20, 1, -1, -20]);
    design.addPosition("p13", [20, 1, -1, -20]);
    design.addPosition("q13", [20, 1, -1, -20]);
    design.addPosition("r13", [20, 1, -1, -20]);
    design.addPosition("s13", [20, 1, -1, -20]);
    design.addPosition("t13", [20, 0, -1, -20]);
    design.addPosition("a14", [20, 1, 0, -20]);
    design.addPosition("b14", [20, 1, -1, -20]);
    design.addPosition("c14", [20, 1, -1, -20]);
    design.addPosition("d14", [20, 1, -1, -20]);
    design.addPosition("e14", [20, 1, -1, -20]);
    design.addPosition("f14", [20, 1, -1, -20]);
    design.addPosition("g14", [20, 1, -1, -20]);
    design.addPosition("h14", [20, 1, -1, -20]);
    design.addPosition("i14", [20, 1, -1, -20]);
    design.addPosition("j14", [20, 1, -1, -20]);
    design.addPosition("k14", [20, 1, -1, -20]);
    design.addPosition("l14", [20, 1, -1, -20]);
    design.addPosition("m14", [20, 1, -1, -20]);
    design.addPosition("n14", [20, 1, -1, -20]);
    design.addPosition("o14", [20, 1, -1, -20]);
    design.addPosition("p14", [20, 1, -1, -20]);
    design.addPosition("q14", [20, 1, -1, -20]);
    design.addPosition("r14", [20, 1, -1, -20]);
    design.addPosition("s14", [20, 1, -1, -20]);
    design.addPosition("t14", [20, 0, -1, -20]);
    design.addPosition("a15", [20, 1, 0, -20]);
    design.addPosition("b15", [20, 1, -1, -20]);
    design.addPosition("c15", [20, 1, -1, -20]);
    design.addPosition("d15", [20, 1, -1, -20]);
    design.addPosition("e15", [20, 1, -1, -20]);
    design.addPosition("f15", [20, 1, -1, -20]);
    design.addPosition("g15", [20, 1, -1, -20]);
    design.addPosition("h15", [20, 1, -1, -20]);
    design.addPosition("i15", [20, 1, -1, -20]);
    design.addPosition("j15", [20, 1, -1, -20]);
    design.addPosition("k15", [20, 1, -1, -20]);
    design.addPosition("l15", [20, 1, -1, -20]);
    design.addPosition("m15", [20, 1, -1, -20]);
    design.addPosition("n15", [20, 1, -1, -20]);
    design.addPosition("o15", [20, 1, -1, -20]);
    design.addPosition("p15", [20, 1, -1, -20]);
    design.addPosition("q15", [20, 1, -1, -20]);
    design.addPosition("r15", [20, 1, -1, -20]);
    design.addPosition("s15", [20, 1, -1, -20]);
    design.addPosition("t15", [20, 0, -1, -20]);
    design.addPosition("a16", [20, 1, 0, -20]);
    design.addPosition("b16", [20, 1, -1, -20]);
    design.addPosition("c16", [20, 1, -1, -20]);
    design.addPosition("d16", [20, 1, -1, -20]);
    design.addPosition("e16", [20, 1, -1, -20]);
    design.addPosition("f16", [20, 1, -1, -20]);
    design.addPosition("g16", [20, 1, -1, -20]);
    design.addPosition("h16", [20, 1, -1, -20]);
    design.addPosition("i16", [20, 1, -1, -20]);
    design.addPosition("j16", [20, 1, -1, -20]);
    design.addPosition("k16", [20, 1, -1, -20]);
    design.addPosition("l16", [20, 1, -1, -20]);
    design.addPosition("m16", [20, 1, -1, -20]);
    design.addPosition("n16", [20, 1, -1, -20]);
    design.addPosition("o16", [20, 1, -1, -20]);
    design.addPosition("p16", [20, 1, -1, -20]);
    design.addPosition("q16", [20, 1, -1, -20]);
    design.addPosition("r16", [20, 1, -1, -20]);
    design.addPosition("s16", [20, 1, -1, -20]);
    design.addPosition("t16", [20, 0, -1, -20]);
    design.addPosition("a17", [20, 1, 0, -20]);
    design.addPosition("b17", [20, 1, -1, -20]);
    design.addPosition("c17", [20, 1, -1, -20]);
    design.addPosition("d17", [20, 1, -1, -20]);
    design.addPosition("e17", [20, 1, -1, -20]);
    design.addPosition("f17", [20, 1, -1, -20]);
    design.addPosition("g17", [20, 1, -1, -20]);
    design.addPosition("h17", [20, 1, -1, -20]);
    design.addPosition("i17", [20, 1, -1, -20]);
    design.addPosition("j17", [20, 1, -1, -20]);
    design.addPosition("k17", [20, 1, -1, -20]);
    design.addPosition("l17", [20, 1, -1, -20]);
    design.addPosition("m17", [20, 1, -1, -20]);
    design.addPosition("n17", [20, 1, -1, -20]);
    design.addPosition("o17", [20, 1, -1, -20]);
    design.addPosition("p17", [20, 1, -1, -20]);
    design.addPosition("q17", [20, 1, -1, -20]);
    design.addPosition("r17", [20, 1, -1, -20]);
    design.addPosition("s17", [20, 1, -1, -20]);
    design.addPosition("t17", [20, 0, -1, -20]);
    design.addPosition("a18", [20, 1, 0, -20]);
    design.addPosition("b18", [20, 1, -1, -20]);
    design.addPosition("c18", [20, 1, -1, -20]);
    design.addPosition("d18", [20, 1, -1, -20]);
    design.addPosition("e18", [20, 1, -1, -20]);
    design.addPosition("f18", [20, 1, -1, -20]);
    design.addPosition("g18", [20, 1, -1, -20]);
    design.addPosition("h18", [20, 1, -1, -20]);
    design.addPosition("i18", [20, 1, -1, -20]);
    design.addPosition("j18", [20, 1, -1, -20]);
    design.addPosition("k18", [20, 1, -1, -20]);
    design.addPosition("l18", [20, 1, -1, -20]);
    design.addPosition("m18", [20, 1, -1, -20]);
    design.addPosition("n18", [20, 1, -1, -20]);
    design.addPosition("o18", [20, 1, -1, -20]);
    design.addPosition("p18", [20, 1, -1, -20]);
    design.addPosition("q18", [20, 1, -1, -20]);
    design.addPosition("r18", [20, 1, -1, -20]);
    design.addPosition("s18", [20, 1, -1, -20]);
    design.addPosition("t18", [20, 0, -1, -20]);
    design.addPosition("a19", [20, 1, 0, -20]);
    design.addPosition("b19", [20, 1, -1, -20]);
    design.addPosition("c19", [20, 1, -1, -20]);
    design.addPosition("d19", [20, 1, -1, -20]);
    design.addPosition("e19", [20, 1, -1, -20]);
    design.addPosition("f19", [20, 1, -1, -20]);
    design.addPosition("g19", [20, 1, -1, -20]);
    design.addPosition("h19", [20, 1, -1, -20]);
    design.addPosition("i19", [20, 1, -1, -20]);
    design.addPosition("j19", [20, 1, -1, -20]);
    design.addPosition("k19", [20, 1, -1, -20]);
    design.addPosition("l19", [20, 1, -1, -20]);
    design.addPosition("m19", [20, 1, -1, -20]);
    design.addPosition("n19", [20, 1, -1, -20]);
    design.addPosition("o19", [20, 1, -1, -20]);
    design.addPosition("p19", [20, 1, -1, -20]);
    design.addPosition("q19", [20, 1, -1, -20]);
    design.addPosition("r19", [20, 1, -1, -20]);
    design.addPosition("s19", [20, 1, -1, -20]);
    design.addPosition("t19", [20, 0, -1, -20]);
    design.addPosition("a20", [20, 1, 0, -20]);
    design.addPosition("b20", [20, 1, -1, -20]);
    design.addPosition("c20", [20, 1, -1, -20]);
    design.addPosition("d20", [20, 1, -1, -20]);
    design.addPosition("e20", [20, 1, -1, -20]);
    design.addPosition("f20", [20, 1, -1, -20]);
    design.addPosition("g20", [20, 1, -1, -20]);
    design.addPosition("h20", [20, 1, -1, -20]);
    design.addPosition("i20", [20, 1, -1, -20]);
    design.addPosition("j20", [20, 1, -1, -20]);
    design.addPosition("k20", [20, 1, -1, -20]);
    design.addPosition("l20", [20, 1, -1, -20]);
    design.addPosition("m20", [20, 1, -1, -20]);
    design.addPosition("n20", [20, 1, -1, -20]);
    design.addPosition("o20", [20, 1, -1, -20]);
    design.addPosition("p20", [20, 1, -1, -20]);
    design.addPosition("q20", [20, 1, -1, -20]);
    design.addPosition("r20", [20, 1, -1, -20]);
    design.addPosition("s20", [20, 1, -1, -20]);
    design.addPosition("t20", [20, 0, -1, -20]);
    design.addPosition("a21", [20, 1, 0, -20]);
    design.addPosition("b21", [20, 1, -1, -20]);
    design.addPosition("c21", [20, 1, -1, -20]);
    design.addPosition("d21", [20, 1, -1, -20]);
    design.addPosition("e21", [20, 1, -1, -20]);
    design.addPosition("f21", [20, 1, -1, -20]);
    design.addPosition("g21", [20, 1, -1, -20]);
    design.addPosition("h21", [20, 1, -1, -20]);
    design.addPosition("i21", [20, 1, -1, -20]);
    design.addPosition("j21", [20, 1, -1, -20]);
    design.addPosition("k21", [20, 1, -1, -20]);
    design.addPosition("l21", [20, 1, -1, -20]);
    design.addPosition("m21", [20, 1, -1, -20]);
    design.addPosition("n21", [20, 1, -1, -20]);
    design.addPosition("o21", [20, 1, -1, -20]);
    design.addPosition("p21", [20, 1, -1, -20]);
    design.addPosition("q21", [20, 1, -1, -20]);
    design.addPosition("r21", [20, 1, -1, -20]);
    design.addPosition("s21", [20, 1, -1, -20]);
    design.addPosition("t21", [20, 0, -1, -20]);
    design.addPosition("a22", [20, 1, 0, -20]);
    design.addPosition("b22", [20, 1, -1, -20]);
    design.addPosition("c22", [20, 1, -1, -20]);
    design.addPosition("d22", [20, 1, -1, -20]);
    design.addPosition("e22", [20, 1, -1, -20]);
    design.addPosition("f22", [20, 1, -1, -20]);
    design.addPosition("g22", [20, 1, -1, -20]);
    design.addPosition("h22", [20, 1, -1, -20]);
    design.addPosition("i22", [20, 1, -1, -20]);
    design.addPosition("j22", [20, 1, -1, -20]);
    design.addPosition("k22", [20, 1, -1, -20]);
    design.addPosition("l22", [20, 1, -1, -20]);
    design.addPosition("m22", [20, 1, -1, -20]);
    design.addPosition("n22", [20, 1, -1, -20]);
    design.addPosition("o22", [20, 1, -1, -20]);
    design.addPosition("p22", [20, 1, -1, -20]);
    design.addPosition("q22", [20, 1, -1, -20]);
    design.addPosition("r22", [20, 1, -1, -20]);
    design.addPosition("s22", [20, 1, -1, -20]);
    design.addPosition("t22", [20, 0, -1, -20]);
    design.addPosition("a23", [20, 1, 0, -20]);
    design.addPosition("b23", [20, 1, -1, -20]);
    design.addPosition("c23", [20, 1, -1, -20]);
    design.addPosition("d23", [20, 1, -1, -20]);
    design.addPosition("e23", [20, 1, -1, -20]);
    design.addPosition("f23", [20, 1, -1, -20]);
    design.addPosition("g23", [20, 1, -1, -20]);
    design.addPosition("h23", [20, 1, -1, -20]);
    design.addPosition("i23", [20, 1, -1, -20]);
    design.addPosition("j23", [20, 1, -1, -20]);
    design.addPosition("k23", [20, 1, -1, -20]);
    design.addPosition("l23", [20, 1, -1, -20]);
    design.addPosition("m23", [20, 1, -1, -20]);
    design.addPosition("n23", [20, 1, -1, -20]);
    design.addPosition("o23", [20, 1, -1, -20]);
    design.addPosition("p23", [20, 1, -1, -20]);
    design.addPosition("q23", [20, 1, -1, -20]);
    design.addPosition("r23", [20, 1, -1, -20]);
    design.addPosition("s23", [20, 1, -1, -20]);
    design.addPosition("t23", [20, 0, -1, -20]);
    design.addPosition("a24", [20, 1, 0, -20]);
    design.addPosition("b24", [20, 1, -1, -20]);
    design.addPosition("c24", [20, 1, -1, -20]);
    design.addPosition("d24", [20, 1, -1, -20]);
    design.addPosition("e24", [20, 1, -1, -20]);
    design.addPosition("f24", [20, 1, -1, -20]);
    design.addPosition("g24", [20, 1, -1, -20]);
    design.addPosition("h24", [20, 1, -1, -20]);
    design.addPosition("i24", [20, 1, -1, -20]);
    design.addPosition("j24", [20, 1, -1, -20]);
    design.addPosition("k24", [20, 1, -1, -20]);
    design.addPosition("l24", [20, 1, -1, -20]);
    design.addPosition("m24", [20, 1, -1, -20]);
    design.addPosition("n24", [20, 1, -1, -20]);
    design.addPosition("o24", [20, 1, -1, -20]);
    design.addPosition("p24", [20, 1, -1, -20]);
    design.addPosition("q24", [20, 1, -1, -20]);
    design.addPosition("r24", [20, 1, -1, -20]);
    design.addPosition("s24", [20, 1, -1, -20]);
    design.addPosition("t24", [20, 0, -1, -20]);
    design.addPosition("a25", [20, 1, 0, -20]);
    design.addPosition("b25", [20, 1, -1, -20]);
    design.addPosition("c25", [20, 1, -1, -20]);
    design.addPosition("d25", [20, 1, -1, -20]);
    design.addPosition("e25", [20, 1, -1, -20]);
    design.addPosition("f25", [20, 1, -1, -20]);
    design.addPosition("g25", [20, 1, -1, -20]);
    design.addPosition("h25", [20, 1, -1, -20]);
    design.addPosition("i25", [20, 1, -1, -20]);
    design.addPosition("j25", [20, 1, -1, -20]);
    design.addPosition("k25", [20, 1, -1, -20]);
    design.addPosition("l25", [20, 1, -1, -20]);
    design.addPosition("m25", [20, 1, -1, -20]);
    design.addPosition("n25", [20, 1, -1, -20]);
    design.addPosition("o25", [20, 1, -1, -20]);
    design.addPosition("p25", [20, 1, -1, -20]);
    design.addPosition("q25", [20, 1, -1, -20]);
    design.addPosition("r25", [20, 1, -1, -20]);
    design.addPosition("s25", [20, 1, -1, -20]);
    design.addPosition("t25", [20, 0, -1, -20]);
    design.addPosition("a26", [20, 1, 0, -20]);
    design.addPosition("b26", [20, 1, -1, -20]);
    design.addPosition("c26", [20, 1, -1, -20]);
    design.addPosition("d26", [20, 1, -1, -20]);
    design.addPosition("e26", [20, 1, -1, -20]);
    design.addPosition("f26", [20, 1, -1, -20]);
    design.addPosition("g26", [20, 1, -1, -20]);
    design.addPosition("h26", [20, 1, -1, -20]);
    design.addPosition("i26", [20, 1, -1, -20]);
    design.addPosition("j26", [20, 1, -1, -20]);
    design.addPosition("k26", [20, 1, -1, -20]);
    design.addPosition("l26", [20, 1, -1, -20]);
    design.addPosition("m26", [20, 1, -1, -20]);
    design.addPosition("n26", [20, 1, -1, -20]);
    design.addPosition("o26", [20, 1, -1, -20]);
    design.addPosition("p26", [20, 1, -1, -20]);
    design.addPosition("q26", [20, 1, -1, -20]);
    design.addPosition("r26", [20, 1, -1, -20]);
    design.addPosition("s26", [20, 1, -1, -20]);
    design.addPosition("t26", [20, 0, -1, -20]);
    design.addPosition("a27", [20, 1, 0, -20]);
    design.addPosition("b27", [20, 1, -1, -20]);
    design.addPosition("c27", [20, 1, -1, -20]);
    design.addPosition("d27", [20, 1, -1, -20]);
    design.addPosition("e27", [20, 1, -1, -20]);
    design.addPosition("f27", [20, 1, -1, -20]);
    design.addPosition("g27", [20, 1, -1, -20]);
    design.addPosition("h27", [20, 1, -1, -20]);
    design.addPosition("i27", [20, 1, -1, -20]);
    design.addPosition("j27", [20, 1, -1, -20]);
    design.addPosition("k27", [20, 1, -1, -20]);
    design.addPosition("l27", [20, 1, -1, -20]);
    design.addPosition("m27", [20, 1, -1, -20]);
    design.addPosition("n27", [20, 1, -1, -20]);
    design.addPosition("o27", [20, 1, -1, -20]);
    design.addPosition("p27", [20, 1, -1, -20]);
    design.addPosition("q27", [20, 1, -1, -20]);
    design.addPosition("r27", [20, 1, -1, -20]);
    design.addPosition("s27", [20, 1, -1, -20]);
    design.addPosition("t27", [20, 0, -1, -20]);
    design.addPosition("a28", [20, 1, 0, -20]);
    design.addPosition("b28", [20, 1, -1, -20]);
    design.addPosition("c28", [20, 1, -1, -20]);
    design.addPosition("d28", [20, 1, -1, -20]);
    design.addPosition("e28", [20, 1, -1, -20]);
    design.addPosition("f28", [20, 1, -1, -20]);
    design.addPosition("g28", [20, 1, -1, -20]);
    design.addPosition("h28", [20, 1, -1, -20]);
    design.addPosition("i28", [20, 1, -1, -20]);
    design.addPosition("j28", [20, 1, -1, -20]);
    design.addPosition("k28", [20, 1, -1, -20]);
    design.addPosition("l28", [20, 1, -1, -20]);
    design.addPosition("m28", [20, 1, -1, -20]);
    design.addPosition("n28", [20, 1, -1, -20]);
    design.addPosition("o28", [20, 1, -1, -20]);
    design.addPosition("p28", [20, 1, -1, -20]);
    design.addPosition("q28", [20, 1, -1, -20]);
    design.addPosition("r28", [20, 1, -1, -20]);
    design.addPosition("s28", [20, 1, -1, -20]);
    design.addPosition("t28", [20, 0, -1, -20]);
    design.addPosition("a29", [20, 1, 0, -20]);
    design.addPosition("b29", [20, 1, -1, -20]);
    design.addPosition("c29", [20, 1, -1, -20]);
    design.addPosition("d29", [20, 1, -1, -20]);
    design.addPosition("e29", [20, 1, -1, -20]);
    design.addPosition("f29", [20, 1, -1, -20]);
    design.addPosition("g29", [20, 1, -1, -20]);
    design.addPosition("h29", [20, 1, -1, -20]);
    design.addPosition("i29", [20, 1, -1, -20]);
    design.addPosition("j29", [20, 1, -1, -20]);
    design.addPosition("k29", [20, 1, -1, -20]);
    design.addPosition("l29", [20, 1, -1, -20]);
    design.addPosition("m29", [20, 1, -1, -20]);
    design.addPosition("n29", [20, 1, -1, -20]);
    design.addPosition("o29", [20, 1, -1, -20]);
    design.addPosition("p29", [20, 1, -1, -20]);
    design.addPosition("q29", [20, 1, -1, -20]);
    design.addPosition("r29", [20, 1, -1, -20]);
    design.addPosition("s29", [20, 1, -1, -20]);
    design.addPosition("t29", [20, 0, -1, -20]);
    design.addPosition("a30", [20, 1, 0, -20]);
    design.addPosition("b30", [20, 1, -1, -20]);
    design.addPosition("c30", [20, 1, -1, -20]);
    design.addPosition("d30", [20, 1, -1, -20]);
    design.addPosition("e30", [20, 1, -1, -20]);
    design.addPosition("f30", [20, 1, -1, -20]);
    design.addPosition("g30", [20, 1, -1, -20]);
    design.addPosition("h30", [20, 1, -1, -20]);
    design.addPosition("i30", [20, 1, -1, -20]);
    design.addPosition("j30", [20, 1, -1, -20]);
    design.addPosition("k30", [20, 1, -1, -20]);
    design.addPosition("l30", [20, 1, -1, -20]);
    design.addPosition("m30", [20, 1, -1, -20]);
    design.addPosition("n30", [20, 1, -1, -20]);
    design.addPosition("o30", [20, 1, -1, -20]);
    design.addPosition("p30", [20, 1, -1, -20]);
    design.addPosition("q30", [20, 1, -1, -20]);
    design.addPosition("r30", [20, 1, -1, -20]);
    design.addPosition("s30", [20, 1, -1, -20]);
    design.addPosition("t30", [20, 0, -1, -20]);
    design.addPosition("a31", [20, 1, 0, -20]);
    design.addPosition("b31", [20, 1, -1, -20]);
    design.addPosition("c31", [20, 1, -1, -20]);
    design.addPosition("d31", [20, 1, -1, -20]);
    design.addPosition("e31", [20, 1, -1, -20]);
    design.addPosition("f31", [20, 1, -1, -20]);
    design.addPosition("g31", [20, 1, -1, -20]);
    design.addPosition("h31", [20, 1, -1, -20]);
    design.addPosition("i31", [20, 1, -1, -20]);
    design.addPosition("j31", [20, 1, -1, -20]);
    design.addPosition("k31", [20, 1, -1, -20]);
    design.addPosition("l31", [20, 1, -1, -20]);
    design.addPosition("m31", [20, 1, -1, -20]);
    design.addPosition("n31", [20, 1, -1, -20]);
    design.addPosition("o31", [20, 1, -1, -20]);
    design.addPosition("p31", [20, 1, -1, -20]);
    design.addPosition("q31", [20, 1, -1, -20]);
    design.addPosition("r31", [20, 1, -1, -20]);
    design.addPosition("s31", [20, 1, -1, -20]);
    design.addPosition("t31", [20, 0, -1, -20]);
    design.addPosition("a32", [20, 1, 0, -20]);
    design.addPosition("b32", [20, 1, -1, -20]);
    design.addPosition("c32", [20, 1, -1, -20]);
    design.addPosition("d32", [20, 1, -1, -20]);
    design.addPosition("e32", [20, 1, -1, -20]);
    design.addPosition("f32", [20, 1, -1, -20]);
    design.addPosition("g32", [20, 1, -1, -20]);
    design.addPosition("h32", [20, 1, -1, -20]);
    design.addPosition("i32", [20, 1, -1, -20]);
    design.addPosition("j32", [20, 1, -1, -20]);
    design.addPosition("k32", [20, 1, -1, -20]);
    design.addPosition("l32", [20, 1, -1, -20]);
    design.addPosition("m32", [20, 1, -1, -20]);
    design.addPosition("n32", [20, 1, -1, -20]);
    design.addPosition("o32", [20, 1, -1, -20]);
    design.addPosition("p32", [20, 1, -1, -20]);
    design.addPosition("q32", [20, 1, -1, -20]);
    design.addPosition("r32", [20, 1, -1, -20]);
    design.addPosition("s32", [20, 1, -1, -20]);
    design.addPosition("t32", [20, 0, -1, -20]);
    design.addPosition("a33", [20, 1, 0, -20]);
    design.addPosition("b33", [20, 1, -1, -20]);
    design.addPosition("c33", [20, 1, -1, -20]);
    design.addPosition("d33", [20, 1, -1, -20]);
    design.addPosition("e33", [20, 1, -1, -20]);
    design.addPosition("f33", [20, 1, -1, -20]);
    design.addPosition("g33", [20, 1, -1, -20]);
    design.addPosition("h33", [20, 1, -1, -20]);
    design.addPosition("i33", [20, 1, -1, -20]);
    design.addPosition("j33", [20, 1, -1, -20]);
    design.addPosition("k33", [20, 1, -1, -20]);
    design.addPosition("l33", [20, 1, -1, -20]);
    design.addPosition("m33", [20, 1, -1, -20]);
    design.addPosition("n33", [20, 1, -1, -20]);
    design.addPosition("o33", [20, 1, -1, -20]);
    design.addPosition("p33", [20, 1, -1, -20]);
    design.addPosition("q33", [20, 1, -1, -20]);
    design.addPosition("r33", [20, 1, -1, -20]);
    design.addPosition("s33", [20, 1, -1, -20]);
    design.addPosition("t33", [20, 0, -1, -20]);
    design.addPosition("a34", [20, 1, 0, -20]);
    design.addPosition("b34", [20, 1, -1, -20]);
    design.addPosition("c34", [20, 1, -1, -20]);
    design.addPosition("d34", [20, 1, -1, -20]);
    design.addPosition("e34", [20, 1, -1, -20]);
    design.addPosition("f34", [20, 1, -1, -20]);
    design.addPosition("g34", [20, 1, -1, -20]);
    design.addPosition("h34", [20, 1, -1, -20]);
    design.addPosition("i34", [20, 1, -1, -20]);
    design.addPosition("j34", [20, 1, -1, -20]);
    design.addPosition("k34", [20, 1, -1, -20]);
    design.addPosition("l34", [20, 1, -1, -20]);
    design.addPosition("m34", [20, 1, -1, -20]);
    design.addPosition("n34", [20, 1, -1, -20]);
    design.addPosition("o34", [20, 1, -1, -20]);
    design.addPosition("p34", [20, 1, -1, -20]);
    design.addPosition("q34", [20, 1, -1, -20]);
    design.addPosition("r34", [20, 1, -1, -20]);
    design.addPosition("s34", [20, 1, -1, -20]);
    design.addPosition("t34", [20, 0, -1, -20]);
    design.addPosition("a35", [20, 1, 0, -20]);
    design.addPosition("b35", [20, 1, -1, -20]);
    design.addPosition("c35", [20, 1, -1, -20]);
    design.addPosition("d35", [20, 1, -1, -20]);
    design.addPosition("e35", [20, 1, -1, -20]);
    design.addPosition("f35", [20, 1, -1, -20]);
    design.addPosition("g35", [20, 1, -1, -20]);
    design.addPosition("h35", [20, 1, -1, -20]);
    design.addPosition("i35", [20, 1, -1, -20]);
    design.addPosition("j35", [20, 1, -1, -20]);
    design.addPosition("k35", [20, 1, -1, -20]);
    design.addPosition("l35", [20, 1, -1, -20]);
    design.addPosition("m35", [20, 1, -1, -20]);
    design.addPosition("n35", [20, 1, -1, -20]);
    design.addPosition("o35", [20, 1, -1, -20]);
    design.addPosition("p35", [20, 1, -1, -20]);
    design.addPosition("q35", [20, 1, -1, -20]);
    design.addPosition("r35", [20, 1, -1, -20]);
    design.addPosition("s35", [20, 1, -1, -20]);
    design.addPosition("t35", [20, 0, -1, -20]);
    design.addPosition("a36", [20, 1, 0, -20]);
    design.addPosition("b36", [20, 1, -1, -20]);
    design.addPosition("c36", [20, 1, -1, -20]);
    design.addPosition("d36", [20, 1, -1, -20]);
    design.addPosition("e36", [20, 1, -1, -20]);
    design.addPosition("f36", [20, 1, -1, -20]);
    design.addPosition("g36", [20, 1, -1, -20]);
    design.addPosition("h36", [20, 1, -1, -20]);
    design.addPosition("i36", [20, 1, -1, -20]);
    design.addPosition("j36", [20, 1, -1, -20]);
    design.addPosition("k36", [20, 1, -1, -20]);
    design.addPosition("l36", [20, 1, -1, -20]);
    design.addPosition("m36", [20, 1, -1, -20]);
    design.addPosition("n36", [20, 1, -1, -20]);
    design.addPosition("o36", [20, 1, -1, -20]);
    design.addPosition("p36", [20, 1, -1, -20]);
    design.addPosition("q36", [20, 1, -1, -20]);
    design.addPosition("r36", [20, 1, -1, -20]);
    design.addPosition("s36", [20, 1, -1, -20]);
    design.addPosition("t36", [20, 0, -1, -20]);
    design.addPosition("a37", [20, 1, 0, -20]);
    design.addPosition("b37", [20, 1, -1, -20]);
    design.addPosition("c37", [20, 1, -1, -20]);
    design.addPosition("d37", [20, 1, -1, -20]);
    design.addPosition("e37", [20, 1, -1, -20]);
    design.addPosition("f37", [20, 1, -1, -20]);
    design.addPosition("g37", [20, 1, -1, -20]);
    design.addPosition("h37", [20, 1, -1, -20]);
    design.addPosition("i37", [20, 1, -1, -20]);
    design.addPosition("j37", [20, 1, -1, -20]);
    design.addPosition("k37", [20, 1, -1, -20]);
    design.addPosition("l37", [20, 1, -1, -20]);
    design.addPosition("m37", [20, 1, -1, -20]);
    design.addPosition("n37", [20, 1, -1, -20]);
    design.addPosition("o37", [20, 1, -1, -20]);
    design.addPosition("p37", [20, 1, -1, -20]);
    design.addPosition("q37", [20, 1, -1, -20]);
    design.addPosition("r37", [20, 1, -1, -20]);
    design.addPosition("s37", [20, 1, -1, -20]);
    design.addPosition("t37", [20, 0, -1, -20]);
    design.addPosition("a38", [20, 1, 0, -20]);
    design.addPosition("b38", [20, 1, -1, -20]);
    design.addPosition("c38", [20, 1, -1, -20]);
    design.addPosition("d38", [20, 1, -1, -20]);
    design.addPosition("e38", [20, 1, -1, -20]);
    design.addPosition("f38", [20, 1, -1, -20]);
    design.addPosition("g38", [20, 1, -1, -20]);
    design.addPosition("h38", [20, 1, -1, -20]);
    design.addPosition("i38", [20, 1, -1, -20]);
    design.addPosition("j38", [20, 1, -1, -20]);
    design.addPosition("k38", [20, 1, -1, -20]);
    design.addPosition("l38", [20, 1, -1, -20]);
    design.addPosition("m38", [20, 1, -1, -20]);
    design.addPosition("n38", [20, 1, -1, -20]);
    design.addPosition("o38", [20, 1, -1, -20]);
    design.addPosition("p38", [20, 1, -1, -20]);
    design.addPosition("q38", [20, 1, -1, -20]);
    design.addPosition("r38", [20, 1, -1, -20]);
    design.addPosition("s38", [20, 1, -1, -20]);
    design.addPosition("t38", [20, 0, -1, -20]);
    design.addPosition("a39", [20, 1, 0, -20]);
    design.addPosition("b39", [20, 1, -1, -20]);
    design.addPosition("c39", [20, 1, -1, -20]);
    design.addPosition("d39", [20, 1, -1, -20]);
    design.addPosition("e39", [20, 1, -1, -20]);
    design.addPosition("f39", [20, 1, -1, -20]);
    design.addPosition("g39", [20, 1, -1, -20]);
    design.addPosition("h39", [20, 1, -1, -20]);
    design.addPosition("i39", [20, 1, -1, -20]);
    design.addPosition("j39", [20, 1, -1, -20]);
    design.addPosition("k39", [20, 1, -1, -20]);
    design.addPosition("l39", [20, 1, -1, -20]);
    design.addPosition("m39", [20, 1, -1, -20]);
    design.addPosition("n39", [20, 1, -1, -20]);
    design.addPosition("o39", [20, 1, -1, -20]);
    design.addPosition("p39", [20, 1, -1, -20]);
    design.addPosition("q39", [20, 1, -1, -20]);
    design.addPosition("r39", [20, 1, -1, -20]);
    design.addPosition("s39", [20, 1, -1, -20]);
    design.addPosition("t39", [20, 0, -1, -20]);
    design.addPosition("a40", [0, 1, 0, -20]);
    design.addPosition("b40", [0, 1, -1, -20]);
    design.addPosition("c40", [0, 1, -1, -20]);
    design.addPosition("d40", [0, 1, -1, -20]);
    design.addPosition("e40", [0, 1, -1, -20]);
    design.addPosition("f40", [0, 1, -1, -20]);
    design.addPosition("g40", [0, 1, -1, -20]);
    design.addPosition("h40", [0, 1, -1, -20]);
    design.addPosition("i40", [0, 1, -1, -20]);
    design.addPosition("j40", [0, 1, -1, -20]);
    design.addPosition("k40", [0, 1, -1, -20]);
    design.addPosition("l40", [0, 1, -1, -20]);
    design.addPosition("m40", [0, 1, -1, -20]);
    design.addPosition("n40", [0, 1, -1, -20]);
    design.addPosition("o40", [0, 1, -1, -20]);
    design.addPosition("p40", [0, 1, -1, -20]);
    design.addPosition("q40", [0, 1, -1, -20]);
    design.addPosition("r40", [0, 1, -1, -20]);
    design.addPosition("s40", [0, 1, -1, -20]);
    design.addPosition("t40", [0, 0, -1, -20]);

    design.setupSelector(8);

    design.addZone("start", 1, [33]);
    design.addZone("start", 2, [794]);
    design.addZone("home", 1, [0, 1, 2, 3, 4, 5, 6]);
    design.addZone("home", 2, [7, 8, 9, 10, 11, 12, 13]);

    design.addZone("wall", 1, [119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,139,159,179,199,219,239,242,243,244,245,246,247,248,259,262,268,279,282,288,299,302,305,308,319,322,325,328,342,345,362,365,382,385,402,405,422,425,442,445,462,465,482,485,499,502,505,508,519,522,525,528,539,545,548,559,565,568,579,580,581,582,583,584,585,588,608,628,648,668,688,694,695,696,697,698,699,700,701,702,703,704,705,706,707,708], 1);
    design.addZone("dark", 1, [], 1);
    design.addZone("fire", 1, [], 1);
    design.addZone("ice", 1, [], 1);
    design.addZone("blue", 1, [], 1);
    design.addZone("red", 1, [], 1);
    design.addZone("gold", 1, [263,264,283,284,303,304,323,324,343,344,363,364,383,384,403,404,423,424,443,444,463,464,483,484,503,504,523,524,543,544,563,564], 1);

    design.addZone("wall", 1, [97,98,99,106,117,126,137,146,157,166,177,182,186,202,206,222,226,242,246,259,260,261,262,266,339,340,341,342,343,344,345,346,347,348,479,480,481,482,483,484,485,486,487,488,561,565,566,567,568,581,585,601,605,621,625,641,645,650,661,670,681,690,701,710,721,728,729,730], 2);
    design.addZone("dark", 1, [], 2);
    design.addZone("fire", 1, [], 2);
    design.addZone("ice", 1, [], 2);
    design.addZone("blue", 1, [118,119,120,121,138,139,140,141,158,159,160,161,178,179,180,181,198,199,200,201,218,219,220,221,238,239,240,241], 2);
    design.addZone("red", 1, [586,587,588,589,606,607,608,609,626,627,628,629,646,647,648,649,666,667,668,669,686,687,688,689,706,707,708,709], 2);
    design.addZone("gold", 1, [359,360,361,362,363,364,365,366,367,368,379,380,381,382,383,384,385,386,387,388,399,400,401,402,403,404,405,406,407,408,419,420,421,422,423,424,425,426,427,428,439,440,441,442,443,444,445,446,447,448,459,460,461,462,463,464,465,466,467,468], 2);

    design.addZone("wall", 1, [156,157,161,162,163,164,165,166,170,171,176,191,260,261,262,265,266,267,280,287,296,300,307,311,316,331,336,351,356,371,376,391,396,411,416,431,436,451,456,471,476,491,496,511,516,520,527,531,540,547,560,561,562,565,566,567,636,651,656,657,661,662,663,664,665,666,670,671], 3);
    design.addZone("dark", 1, [], 3);
    design.addZone("fire", 1, [], 3);
    design.addZone("ice", 1, [], 3);
    design.addZone("blue", 1, [177,178,197,198,629,630,649,650], 3);
    design.addZone("red", 1, [189,190,209,210,617,618,637,638], 3);
    design.addZone("gold", 1, [281,282,283,284,285,286,301,302,303,304,305,306,321,322,323,324,325,326,341,342,343,344,345,346,361,362,363,364,365,366,381,382,383,384,385,386,401,402,403,404,405,406,421,422,423,424,425,426,441,442,443,444,445,446,461,462,463,464,465,466,481,482,483,484,485,486,501,502,503,504,505,506,521,522,523,524,525,526,541,542,543,544,545,546], 3);

    design.addZone("wall", 1, [97,98,99,108,109,110,117,128,137,148,157,168,177,188,197,199,208,210,217,219,228,230,237,239,248,250,257,259,268,270,277,279,288,290,297,299,302,305,308,310,317,319,322,325,328,330,337,339,342,345,348,350,357,359,362,365,368,370,377,379,382,385,388,390,397,399,402,405,408,410,417,419,422,425,428,430,437,439,442,445,448,450,457,459,462,465,468,470,477,479,482,485,488,490,497,499,502,505,508,510,517,519,522,525,528,530,537,539,548,550,557,559,568,570,577,579,588,590,597,599,608,610,617,619,628,630,639,650,659,670,679,690,699,710,717,718,719,728,729,730], 4);
    design.addZone("dark", 1, [], 4);
    design.addZone("fire", 1, [], 4);
    design.addZone("ice", 1, [], 4);
    design.addZone("blue", 1, [118,138,158,178,198,218,238,258,278,298,318,338,358,378,398,418,438,458,478,498,518,538,558,578,598,618,638,658,678,698], 4);
    design.addZone("red", 1, [129,149,169,189,209,229,249,269,289,309,329,349,369,389,409,429,449,469,489,509,529,549,569,589,609,629,649,669,689,709], 4);
    design.addZone("gold", 1, [282,283,284,285,303,304,323,324,343,344,363,364,383,384,403,404,423,424,443,444,463,464,483,484,503,504,523,524,542,543,544,545], 4);

    design.addZone("wall", 1, [109,110,111,131,149,151,169,171,189,191,209,211,216,218,229,231,236,238,249,251,256,258,269,271,276,278,289,291,296,298,309,311,316,318,329,331,336,338,349,351,356,358,369,371,376,378,389,391,396,398,399,400,401,402,404,405,406,407,408,409,411,416,418,429,431,436,438,439,440,441,442,444,445,446,447,448,449,451,456,458,469,471,476,478,489,491,496,498,509,511,516,518,529,531,536,538,549,551,556,558,569,571,576,578,589,591,596,598,609,611,616,618,636,638,656,658,676,678,696,716,717,718], 5);
    design.addZone("dark", 1, [130,697], 5);
    design.addZone("fire", 1, [129,698], 5);
    design.addZone("ice", 1, [419,428], 5);
    design.addZone("blue", 1, [], 5);
    design.addZone("red", 1, [], 5);
    design.addZone("gold", 1, [420,421,422,423,424,425,426,427], 5);

    design.addZone("wall", 1, [256,257,258,259,260,261,262,263,264,265,266,267,268,269,271,289,291,296,297,298,299,300,301,302,303,304,305,306,307,309,311,316,327,329,331,336,338,339,340,341,342,343,344,345,347,349,351,356,358,365,367,369,371,376,378,380,381,382,383,385,387,389,391,396,398,400,405,407,409,411,416,418,420,422,427,429,431,436,438,440,442,444,445,446,447,449,451,456,458,460,462,469,471,476,478,480,482,483,484,485,486,487,488,489,491,496,498,500,511,516,518,520,521,522,523,524,525,526,527,528,529,530,531,536,538,556,558,559,560,561,562,563,564,565,566,567,568,569,570,571], 6);
    design.addZone("dark", 1, [403,404,423,424], 6);
    design.addZone("fire", 1, [402,425], 6);
    design.addZone("ice", 1, [14,813], 6);
    design.addZone("blue", 1, [236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,270,290,310,330,350,370,390,410,430,450,470,490,510], 6);
    design.addZone("red", 1, [317,337,357,377,397,417,437,457,477,497,517,537,557,576,577,578,579,580,581,582,583,584,585,586,587,588,589,590,591], 6);
    design.addZone("gold", 1, [], 6);

    design.addZone("wall", 1, [], 7);
    design.addZone("dark", 1, [], 7);
    design.addZone("fire", 1, [299,305,311,499,505,511], 7);
    design.addZone("ice", 1, [199,205,211,296,302,308,399,405,411,496,502,508,599,605,611], 7);
    design.addZone("blue", 1, [14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33], 7);
    design.addZone("red", 1, [794,795,796,797,798,799,800,801,802,803,804,805,806,807,808,809,810,811,812,813], 7);
    design.addZone("gold", 1, [197,198,200,204,206,207,210,212,217,223,224,230,577,583,584,590,597,598,600,604,606,607,610,612], 7);
    design.addZone("green", 1, [259,265,271,279,285,291,298,300,304,306,310,312,319,325,331,339,345,351,459,471,479,485,491,498,500,504,506,510,512,519,525,531,539,551], 7);
    design.addZone("purple", 1, [397,398,400,401,404,406,409,410,412], 7);
    design.addZone("orange", 1, [276,282,288,316,322,328,476,482,488,516,522,528], 7);

    design.addZone("wall", 1, [20,21,24,25,26,31,40,51,54,55,56,57,60,69,70,71,77,80,83,84,85,86,97,100,103,106,116,117,120,123,126,129,130,131,132,133,143,151,163,171,176,179,180,183,184,185,188,191,196,205,208,211,216,225,228,234,235,236,237,238,239,240,241,242,245,248,265,268,269,270,271,272,273,285,291,296,297,300,301,302,305,311,317,322,323,324,325,328,337,342,348,354,357,358,359,362,368,371,374,379,382,385,386,387,388,391,394,399,402,411,417,418,419,422,431,437,442,443,444,445,448,449,450,451,456,457,468,474,475,476,480,488,500,503,504,505,508,509,510,511,519,520,521,522,523,531,536,537,538,539,551,565,568,569,570,571,582,583,584,585,596,599,600,601,602,616,619,628,631,632,633,636,637,638,639,645,646,647,648,651,659,662,671,679,682,691,696,697,698,699,702,703,704,705,706,709,710,711,716,726,729,736,746,749,754,755,756,759,760,761,762,763,766,769,770,771,779,786,799,806], 8);

    design.addPiece("Blue", 0);
    design.addPiece("Red", 1);
    design.addPiece("Yellow", 2);
    design.addPiece("Green", 3);
    design.addPiece("Purple", 4);
    design.addPiece("Orange", 5);
    design.addPiece("Light", 6);

    design.addPiece("Mark", 7);

    design.addPiece("Wall", 8);
    design.addPiece("Dark", 9);
    design.addPiece("Fire", 10);
    design.addPiece("Ice", 11);
}

Dagaz.View.configure = function(view) {
    view.defBoard("Board");
    view.defPiece("WestBlue", "West Blue");
    view.defPiece("EastBlue", "East Blue");
    view.defPiece("NoneBlue", "None Blue");
    view.defPiece("WestRed", "West Red");
    view.defPiece("EastRed", "East Red");
    view.defPiece("NoneRed", "None Red");
    view.defPiece("WestYellow", "West Yellow");
    view.defPiece("EastYellow", "East Yellow");
    view.defPiece("NoneYellow", "None Yellow");
    view.defPiece("WestGreen", "West Green");
    view.defPiece("EastGreen", "East Green");
    view.defPiece("NoneGreen", "None Green");
    view.defPiece("WestPurple", "West Purple");
    view.defPiece("EastPurple", "East Purple");
    view.defPiece("NonePurple", "None Purple");
    view.defPiece("WestOrange", "West Orange");
    view.defPiece("EastOrange", "East Orange");
    view.defPiece("NoneOrange", "None Orange");
    view.defPiece("WestLight", "West Light");
    view.defPiece("EastLight", "East Light");
    view.defPiece("NoneLight", "None Light");
    view.defPiece("WestMark", "West Mark");
    view.defPiece("EastMark", "East Mark");
    view.defPiece("NoneWall", "None Wall");
    view.defPiece("NoneDark", "None Dark");
    view.defPiece("NoneFire", "None Fire");
    view.defPiece("NoneIce", "None Ice");
    view.defPiece("Ko", "Ko");
 
    view.defPosition("AX", 5, 358, 30, 30);
    view.defPosition("BX", 40, 358, 30, 30);
    view.defPosition("CX", 75, 358, 30, 30);
    view.defPosition("DX", 110, 358, 30, 30);
    view.defPosition("EX", 145, 358, 30, 30);
    view.defPosition("FX", 180, 358, 30, 30);
    view.defPosition("GX", 215, 358, 30, 30);
    view.defPosition("AY", 395, 358, 30, 30);
    view.defPosition("BY", 430, 358, 30, 30);
    view.defPosition("CY", 465, 358, 30, 30);
    view.defPosition("DY", 500, 358, 30, 30);
    view.defPosition("EY", 535, 358, 30, 30);
    view.defPosition("FY", 570, 358, 30, 30);
    view.defPosition("GY", 605, 358, 30, 30);
    view.defPosition("a1", 0, 33, 16, 16);
    view.defPosition("b1", 0, 49, 16, 16);
    view.defPosition("c1", 0, 65, 16, 16);
    view.defPosition("d1", 0, 81, 16, 16);
    view.defPosition("e1", 0, 97, 16, 16);
    view.defPosition("f1", 0, 113, 16, 16);
    view.defPosition("g1", 0, 129, 16, 16);
    view.defPosition("h1", 0, 145, 16, 16);
    view.defPosition("i1", 0, 161, 16, 16);
    view.defPosition("j1", 0, 177, 16, 16);
    view.defPosition("k1", 0, 193, 16, 16);
    view.defPosition("l1", 0, 209, 16, 16);
    view.defPosition("m1", 0, 225, 16, 16);
    view.defPosition("n1", 0, 241, 16, 16);
    view.defPosition("o1", 0, 257, 16, 16);
    view.defPosition("p1", 0, 273, 16, 16);
    view.defPosition("q1", 0, 289, 16, 16);
    view.defPosition("r1", 0, 305, 16, 16);
    view.defPosition("s1", 0, 321, 16, 16);
    view.defPosition("t1", 0, 337, 16, 16);
    view.defPosition("a2", 16, 33, 16, 16);
    view.defPosition("b2", 16, 49, 16, 16);
    view.defPosition("c2", 16, 65, 16, 16);
    view.defPosition("d2", 16, 81, 16, 16);
    view.defPosition("e2", 16, 97, 16, 16);
    view.defPosition("f2", 16, 113, 16, 16);
    view.defPosition("g2", 16, 129, 16, 16);
    view.defPosition("h2", 16, 145, 16, 16);
    view.defPosition("i2", 16, 161, 16, 16);
    view.defPosition("j2", 16, 177, 16, 16);
    view.defPosition("k2", 16, 193, 16, 16);
    view.defPosition("l2", 16, 209, 16, 16);
    view.defPosition("m2", 16, 225, 16, 16);
    view.defPosition("n2", 16, 241, 16, 16);
    view.defPosition("o2", 16, 257, 16, 16);
    view.defPosition("p2", 16, 273, 16, 16);
    view.defPosition("q2", 16, 289, 16, 16);
    view.defPosition("r2", 16, 305, 16, 16);
    view.defPosition("s2", 16, 321, 16, 16);
    view.defPosition("t2", 16, 337, 16, 16);
    view.defPosition("a3", 32, 33, 16, 16);
    view.defPosition("b3", 32, 49, 16, 16);
    view.defPosition("c3", 32, 65, 16, 16);
    view.defPosition("d3", 32, 81, 16, 16);
    view.defPosition("e3", 32, 97, 16, 16);
    view.defPosition("f3", 32, 113, 16, 16);
    view.defPosition("g3", 32, 129, 16, 16);
    view.defPosition("h3", 32, 145, 16, 16);
    view.defPosition("i3", 32, 161, 16, 16);
    view.defPosition("j3", 32, 177, 16, 16);
    view.defPosition("k3", 32, 193, 16, 16);
    view.defPosition("l3", 32, 209, 16, 16);
    view.defPosition("m3", 32, 225, 16, 16);
    view.defPosition("n3", 32, 241, 16, 16);
    view.defPosition("o3", 32, 257, 16, 16);
    view.defPosition("p3", 32, 273, 16, 16);
    view.defPosition("q3", 32, 289, 16, 16);
    view.defPosition("r3", 32, 305, 16, 16);
    view.defPosition("s3", 32, 321, 16, 16);
    view.defPosition("t3", 32, 337, 16, 16);
    view.defPosition("a4", 48, 33, 16, 16);
    view.defPosition("b4", 48, 49, 16, 16);
    view.defPosition("c4", 48, 65, 16, 16);
    view.defPosition("d4", 48, 81, 16, 16);
    view.defPosition("e4", 48, 97, 16, 16);
    view.defPosition("f4", 48, 113, 16, 16);
    view.defPosition("g4", 48, 129, 16, 16);
    view.defPosition("h4", 48, 145, 16, 16);
    view.defPosition("i4", 48, 161, 16, 16);
    view.defPosition("j4", 48, 177, 16, 16);
    view.defPosition("k4", 48, 193, 16, 16);
    view.defPosition("l4", 48, 209, 16, 16);
    view.defPosition("m4", 48, 225, 16, 16);
    view.defPosition("n4", 48, 241, 16, 16);
    view.defPosition("o4", 48, 257, 16, 16);
    view.defPosition("p4", 48, 273, 16, 16);
    view.defPosition("q4", 48, 289, 16, 16);
    view.defPosition("r4", 48, 305, 16, 16);
    view.defPosition("s4", 48, 321, 16, 16);
    view.defPosition("t4", 48, 337, 16, 16);
    view.defPosition("a5", 64, 33, 16, 16);
    view.defPosition("b5", 64, 49, 16, 16);
    view.defPosition("c5", 64, 65, 16, 16);
    view.defPosition("d5", 64, 81, 16, 16);
    view.defPosition("e5", 64, 97, 16, 16);
    view.defPosition("f5", 64, 113, 16, 16);
    view.defPosition("g5", 64, 129, 16, 16);
    view.defPosition("h5", 64, 145, 16, 16);
    view.defPosition("i5", 64, 161, 16, 16);
    view.defPosition("j5", 64, 177, 16, 16);
    view.defPosition("k5", 64, 193, 16, 16);
    view.defPosition("l5", 64, 209, 16, 16);
    view.defPosition("m5", 64, 225, 16, 16);
    view.defPosition("n5", 64, 241, 16, 16);
    view.defPosition("o5", 64, 257, 16, 16);
    view.defPosition("p5", 64, 273, 16, 16);
    view.defPosition("q5", 64, 289, 16, 16);
    view.defPosition("r5", 64, 305, 16, 16);
    view.defPosition("s5", 64, 321, 16, 16);
    view.defPosition("t5", 64, 337, 16, 16);
    view.defPosition("a6", 80, 33, 16, 16);
    view.defPosition("b6", 80, 49, 16, 16);
    view.defPosition("c6", 80, 65, 16, 16);
    view.defPosition("d6", 80, 81, 16, 16);
    view.defPosition("e6", 80, 97, 16, 16);
    view.defPosition("f6", 80, 113, 16, 16);
    view.defPosition("g6", 80, 129, 16, 16);
    view.defPosition("h6", 80, 145, 16, 16);
    view.defPosition("i6", 80, 161, 16, 16);
    view.defPosition("j6", 80, 177, 16, 16);
    view.defPosition("k6", 80, 193, 16, 16);
    view.defPosition("l6", 80, 209, 16, 16);
    view.defPosition("m6", 80, 225, 16, 16);
    view.defPosition("n6", 80, 241, 16, 16);
    view.defPosition("o6", 80, 257, 16, 16);
    view.defPosition("p6", 80, 273, 16, 16);
    view.defPosition("q6", 80, 289, 16, 16);
    view.defPosition("r6", 80, 305, 16, 16);
    view.defPosition("s6", 80, 321, 16, 16);
    view.defPosition("t6", 80, 337, 16, 16);
    view.defPosition("a7", 96, 33, 16, 16);
    view.defPosition("b7", 96, 49, 16, 16);
    view.defPosition("c7", 96, 65, 16, 16);
    view.defPosition("d7", 96, 81, 16, 16);
    view.defPosition("e7", 96, 97, 16, 16);
    view.defPosition("f7", 96, 113, 16, 16);
    view.defPosition("g7", 96, 129, 16, 16);
    view.defPosition("h7", 96, 145, 16, 16);
    view.defPosition("i7", 96, 161, 16, 16);
    view.defPosition("j7", 96, 177, 16, 16);
    view.defPosition("k7", 96, 193, 16, 16);
    view.defPosition("l7", 96, 209, 16, 16);
    view.defPosition("m7", 96, 225, 16, 16);
    view.defPosition("n7", 96, 241, 16, 16);
    view.defPosition("o7", 96, 257, 16, 16);
    view.defPosition("p7", 96, 273, 16, 16);
    view.defPosition("q7", 96, 289, 16, 16);
    view.defPosition("r7", 96, 305, 16, 16);
    view.defPosition("s7", 96, 321, 16, 16);
    view.defPosition("t7", 96, 337, 16, 16);
    view.defPosition("a8", 112, 33, 16, 16);
    view.defPosition("b8", 112, 49, 16, 16);
    view.defPosition("c8", 112, 65, 16, 16);
    view.defPosition("d8", 112, 81, 16, 16);
    view.defPosition("e8", 112, 97, 16, 16);
    view.defPosition("f8", 112, 113, 16, 16);
    view.defPosition("g8", 112, 129, 16, 16);
    view.defPosition("h8", 112, 145, 16, 16);
    view.defPosition("i8", 112, 161, 16, 16);
    view.defPosition("j8", 112, 177, 16, 16);
    view.defPosition("k8", 112, 193, 16, 16);
    view.defPosition("l8", 112, 209, 16, 16);
    view.defPosition("m8", 112, 225, 16, 16);
    view.defPosition("n8", 112, 241, 16, 16);
    view.defPosition("o8", 112, 257, 16, 16);
    view.defPosition("p8", 112, 273, 16, 16);
    view.defPosition("q8", 112, 289, 16, 16);
    view.defPosition("r8", 112, 305, 16, 16);
    view.defPosition("s8", 112, 321, 16, 16);
    view.defPosition("t8", 112, 337, 16, 16);
    view.defPosition("a9", 128, 33, 16, 16);
    view.defPosition("b9", 128, 49, 16, 16);
    view.defPosition("c9", 128, 65, 16, 16);
    view.defPosition("d9", 128, 81, 16, 16);
    view.defPosition("e9", 128, 97, 16, 16);
    view.defPosition("f9", 128, 113, 16, 16);
    view.defPosition("g9", 128, 129, 16, 16);
    view.defPosition("h9", 128, 145, 16, 16);
    view.defPosition("i9", 128, 161, 16, 16);
    view.defPosition("j9", 128, 177, 16, 16);
    view.defPosition("k9", 128, 193, 16, 16);
    view.defPosition("l9", 128, 209, 16, 16);
    view.defPosition("m9", 128, 225, 16, 16);
    view.defPosition("n9", 128, 241, 16, 16);
    view.defPosition("o9", 128, 257, 16, 16);
    view.defPosition("p9", 128, 273, 16, 16);
    view.defPosition("q9", 128, 289, 16, 16);
    view.defPosition("r9", 128, 305, 16, 16);
    view.defPosition("s9", 128, 321, 16, 16);
    view.defPosition("t9", 128, 337, 16, 16);
    view.defPosition("a10", 144, 33, 16, 16);
    view.defPosition("b10", 144, 49, 16, 16);
    view.defPosition("c10", 144, 65, 16, 16);
    view.defPosition("d10", 144, 81, 16, 16);
    view.defPosition("e10", 144, 97, 16, 16);
    view.defPosition("f10", 144, 113, 16, 16);
    view.defPosition("g10", 144, 129, 16, 16);
    view.defPosition("h10", 144, 145, 16, 16);
    view.defPosition("i10", 144, 161, 16, 16);
    view.defPosition("j10", 144, 177, 16, 16);
    view.defPosition("k10", 144, 193, 16, 16);
    view.defPosition("l10", 144, 209, 16, 16);
    view.defPosition("m10", 144, 225, 16, 16);
    view.defPosition("n10", 144, 241, 16, 16);
    view.defPosition("o10", 144, 257, 16, 16);
    view.defPosition("p10", 144, 273, 16, 16);
    view.defPosition("q10", 144, 289, 16, 16);
    view.defPosition("r10", 144, 305, 16, 16);
    view.defPosition("s10", 144, 321, 16, 16);
    view.defPosition("t10", 144, 337, 16, 16);
    view.defPosition("a11", 160, 33, 16, 16);
    view.defPosition("b11", 160, 49, 16, 16);
    view.defPosition("c11", 160, 65, 16, 16);
    view.defPosition("d11", 160, 81, 16, 16);
    view.defPosition("e11", 160, 97, 16, 16);
    view.defPosition("f11", 160, 113, 16, 16);
    view.defPosition("g11", 160, 129, 16, 16);
    view.defPosition("h11", 160, 145, 16, 16);
    view.defPosition("i11", 160, 161, 16, 16);
    view.defPosition("j11", 160, 177, 16, 16);
    view.defPosition("k11", 160, 193, 16, 16);
    view.defPosition("l11", 160, 209, 16, 16);
    view.defPosition("m11", 160, 225, 16, 16);
    view.defPosition("n11", 160, 241, 16, 16);
    view.defPosition("o11", 160, 257, 16, 16);
    view.defPosition("p11", 160, 273, 16, 16);
    view.defPosition("q11", 160, 289, 16, 16);
    view.defPosition("r11", 160, 305, 16, 16);
    view.defPosition("s11", 160, 321, 16, 16);
    view.defPosition("t11", 160, 337, 16, 16);
    view.defPosition("a12", 176, 33, 16, 16);
    view.defPosition("b12", 176, 49, 16, 16);
    view.defPosition("c12", 176, 65, 16, 16);
    view.defPosition("d12", 176, 81, 16, 16);
    view.defPosition("e12", 176, 97, 16, 16);
    view.defPosition("f12", 176, 113, 16, 16);
    view.defPosition("g12", 176, 129, 16, 16);
    view.defPosition("h12", 176, 145, 16, 16);
    view.defPosition("i12", 176, 161, 16, 16);
    view.defPosition("j12", 176, 177, 16, 16);
    view.defPosition("k12", 176, 193, 16, 16);
    view.defPosition("l12", 176, 209, 16, 16);
    view.defPosition("m12", 176, 225, 16, 16);
    view.defPosition("n12", 176, 241, 16, 16);
    view.defPosition("o12", 176, 257, 16, 16);
    view.defPosition("p12", 176, 273, 16, 16);
    view.defPosition("q12", 176, 289, 16, 16);
    view.defPosition("r12", 176, 305, 16, 16);
    view.defPosition("s12", 176, 321, 16, 16);
    view.defPosition("t12", 176, 337, 16, 16);
    view.defPosition("a13", 192, 33, 16, 16);
    view.defPosition("b13", 192, 49, 16, 16);
    view.defPosition("c13", 192, 65, 16, 16);
    view.defPosition("d13", 192, 81, 16, 16);
    view.defPosition("e13", 192, 97, 16, 16);
    view.defPosition("f13", 192, 113, 16, 16);
    view.defPosition("g13", 192, 129, 16, 16);
    view.defPosition("h13", 192, 145, 16, 16);
    view.defPosition("i13", 192, 161, 16, 16);
    view.defPosition("j13", 192, 177, 16, 16);
    view.defPosition("k13", 192, 193, 16, 16);
    view.defPosition("l13", 192, 209, 16, 16);
    view.defPosition("m13", 192, 225, 16, 16);
    view.defPosition("n13", 192, 241, 16, 16);
    view.defPosition("o13", 192, 257, 16, 16);
    view.defPosition("p13", 192, 273, 16, 16);
    view.defPosition("q13", 192, 289, 16, 16);
    view.defPosition("r13", 192, 305, 16, 16);
    view.defPosition("s13", 192, 321, 16, 16);
    view.defPosition("t13", 192, 337, 16, 16);
    view.defPosition("a14", 208, 33, 16, 16);
    view.defPosition("b14", 208, 49, 16, 16);
    view.defPosition("c14", 208, 65, 16, 16);
    view.defPosition("d14", 208, 81, 16, 16);
    view.defPosition("e14", 208, 97, 16, 16);
    view.defPosition("f14", 208, 113, 16, 16);
    view.defPosition("g14", 208, 129, 16, 16);
    view.defPosition("h14", 208, 145, 16, 16);
    view.defPosition("i14", 208, 161, 16, 16);
    view.defPosition("j14", 208, 177, 16, 16);
    view.defPosition("k14", 208, 193, 16, 16);
    view.defPosition("l14", 208, 209, 16, 16);
    view.defPosition("m14", 208, 225, 16, 16);
    view.defPosition("n14", 208, 241, 16, 16);
    view.defPosition("o14", 208, 257, 16, 16);
    view.defPosition("p14", 208, 273, 16, 16);
    view.defPosition("q14", 208, 289, 16, 16);
    view.defPosition("r14", 208, 305, 16, 16);
    view.defPosition("s14", 208, 321, 16, 16);
    view.defPosition("t14", 208, 337, 16, 16);
    view.defPosition("a15", 224, 33, 16, 16);
    view.defPosition("b15", 224, 49, 16, 16);
    view.defPosition("c15", 224, 65, 16, 16);
    view.defPosition("d15", 224, 81, 16, 16);
    view.defPosition("e15", 224, 97, 16, 16);
    view.defPosition("f15", 224, 113, 16, 16);
    view.defPosition("g15", 224, 129, 16, 16);
    view.defPosition("h15", 224, 145, 16, 16);
    view.defPosition("i15", 224, 161, 16, 16);
    view.defPosition("j15", 224, 177, 16, 16);
    view.defPosition("k15", 224, 193, 16, 16);
    view.defPosition("l15", 224, 209, 16, 16);
    view.defPosition("m15", 224, 225, 16, 16);
    view.defPosition("n15", 224, 241, 16, 16);
    view.defPosition("o15", 224, 257, 16, 16);
    view.defPosition("p15", 224, 273, 16, 16);
    view.defPosition("q15", 224, 289, 16, 16);
    view.defPosition("r15", 224, 305, 16, 16);
    view.defPosition("s15", 224, 321, 16, 16);
    view.defPosition("t15", 224, 337, 16, 16);
    view.defPosition("a16", 240, 33, 16, 16);
    view.defPosition("b16", 240, 49, 16, 16);
    view.defPosition("c16", 240, 65, 16, 16);
    view.defPosition("d16", 240, 81, 16, 16);
    view.defPosition("e16", 240, 97, 16, 16);
    view.defPosition("f16", 240, 113, 16, 16);
    view.defPosition("g16", 240, 129, 16, 16);
    view.defPosition("h16", 240, 145, 16, 16);
    view.defPosition("i16", 240, 161, 16, 16);
    view.defPosition("j16", 240, 177, 16, 16);
    view.defPosition("k16", 240, 193, 16, 16);
    view.defPosition("l16", 240, 209, 16, 16);
    view.defPosition("m16", 240, 225, 16, 16);
    view.defPosition("n16", 240, 241, 16, 16);
    view.defPosition("o16", 240, 257, 16, 16);
    view.defPosition("p16", 240, 273, 16, 16);
    view.defPosition("q16", 240, 289, 16, 16);
    view.defPosition("r16", 240, 305, 16, 16);
    view.defPosition("s16", 240, 321, 16, 16);
    view.defPosition("t16", 240, 337, 16, 16);
    view.defPosition("a17", 256, 33, 16, 16);
    view.defPosition("b17", 256, 49, 16, 16);
    view.defPosition("c17", 256, 65, 16, 16);
    view.defPosition("d17", 256, 81, 16, 16);
    view.defPosition("e17", 256, 97, 16, 16);
    view.defPosition("f17", 256, 113, 16, 16);
    view.defPosition("g17", 256, 129, 16, 16);
    view.defPosition("h17", 256, 145, 16, 16);
    view.defPosition("i17", 256, 161, 16, 16);
    view.defPosition("j17", 256, 177, 16, 16);
    view.defPosition("k17", 256, 193, 16, 16);
    view.defPosition("l17", 256, 209, 16, 16);
    view.defPosition("m17", 256, 225, 16, 16);
    view.defPosition("n17", 256, 241, 16, 16);
    view.defPosition("o17", 256, 257, 16, 16);
    view.defPosition("p17", 256, 273, 16, 16);
    view.defPosition("q17", 256, 289, 16, 16);
    view.defPosition("r17", 256, 305, 16, 16);
    view.defPosition("s17", 256, 321, 16, 16);
    view.defPosition("t17", 256, 337, 16, 16);
    view.defPosition("a18", 272, 33, 16, 16);
    view.defPosition("b18", 272, 49, 16, 16);
    view.defPosition("c18", 272, 65, 16, 16);
    view.defPosition("d18", 272, 81, 16, 16);
    view.defPosition("e18", 272, 97, 16, 16);
    view.defPosition("f18", 272, 113, 16, 16);
    view.defPosition("g18", 272, 129, 16, 16);
    view.defPosition("h18", 272, 145, 16, 16);
    view.defPosition("i18", 272, 161, 16, 16);
    view.defPosition("j18", 272, 177, 16, 16);
    view.defPosition("k18", 272, 193, 16, 16);
    view.defPosition("l18", 272, 209, 16, 16);
    view.defPosition("m18", 272, 225, 16, 16);
    view.defPosition("n18", 272, 241, 16, 16);
    view.defPosition("o18", 272, 257, 16, 16);
    view.defPosition("p18", 272, 273, 16, 16);
    view.defPosition("q18", 272, 289, 16, 16);
    view.defPosition("r18", 272, 305, 16, 16);
    view.defPosition("s18", 272, 321, 16, 16);
    view.defPosition("t18", 272, 337, 16, 16);
    view.defPosition("a19", 288, 33, 16, 16);
    view.defPosition("b19", 288, 49, 16, 16);
    view.defPosition("c19", 288, 65, 16, 16);
    view.defPosition("d19", 288, 81, 16, 16);
    view.defPosition("e19", 288, 97, 16, 16);
    view.defPosition("f19", 288, 113, 16, 16);
    view.defPosition("g19", 288, 129, 16, 16);
    view.defPosition("h19", 288, 145, 16, 16);
    view.defPosition("i19", 288, 161, 16, 16);
    view.defPosition("j19", 288, 177, 16, 16);
    view.defPosition("k19", 288, 193, 16, 16);
    view.defPosition("l19", 288, 209, 16, 16);
    view.defPosition("m19", 288, 225, 16, 16);
    view.defPosition("n19", 288, 241, 16, 16);
    view.defPosition("o19", 288, 257, 16, 16);
    view.defPosition("p19", 288, 273, 16, 16);
    view.defPosition("q19", 288, 289, 16, 16);
    view.defPosition("r19", 288, 305, 16, 16);
    view.defPosition("s19", 288, 321, 16, 16);
    view.defPosition("t19", 288, 337, 16, 16);
    view.defPosition("a20", 304, 33, 16, 16);
    view.defPosition("b20", 304, 49, 16, 16);
    view.defPosition("c20", 304, 65, 16, 16);
    view.defPosition("d20", 304, 81, 16, 16);
    view.defPosition("e20", 304, 97, 16, 16);
    view.defPosition("f20", 304, 113, 16, 16);
    view.defPosition("g20", 304, 129, 16, 16);
    view.defPosition("h20", 304, 145, 16, 16);
    view.defPosition("i20", 304, 161, 16, 16);
    view.defPosition("j20", 304, 177, 16, 16);
    view.defPosition("k20", 304, 193, 16, 16);
    view.defPosition("l20", 304, 209, 16, 16);
    view.defPosition("m20", 304, 225, 16, 16);
    view.defPosition("n20", 304, 241, 16, 16);
    view.defPosition("o20", 304, 257, 16, 16);
    view.defPosition("p20", 304, 273, 16, 16);
    view.defPosition("q20", 304, 289, 16, 16);
    view.defPosition("r20", 304, 305, 16, 16);
    view.defPosition("s20", 304, 321, 16, 16);
    view.defPosition("t20", 304, 337, 16, 16);
    view.defPosition("a21", 320, 33, 16, 16);
    view.defPosition("b21", 320, 49, 16, 16);
    view.defPosition("c21", 320, 65, 16, 16);
    view.defPosition("d21", 320, 81, 16, 16);
    view.defPosition("e21", 320, 97, 16, 16);
    view.defPosition("f21", 320, 113, 16, 16);
    view.defPosition("g21", 320, 129, 16, 16);
    view.defPosition("h21", 320, 145, 16, 16);
    view.defPosition("i21", 320, 161, 16, 16);
    view.defPosition("j21", 320, 177, 16, 16);
    view.defPosition("k21", 320, 193, 16, 16);
    view.defPosition("l21", 320, 209, 16, 16);
    view.defPosition("m21", 320, 225, 16, 16);
    view.defPosition("n21", 320, 241, 16, 16);
    view.defPosition("o21", 320, 257, 16, 16);
    view.defPosition("p21", 320, 273, 16, 16);
    view.defPosition("q21", 320, 289, 16, 16);
    view.defPosition("r21", 320, 305, 16, 16);
    view.defPosition("s21", 320, 321, 16, 16);
    view.defPosition("t21", 320, 337, 16, 16);
    view.defPosition("a22", 336, 33, 16, 16);
    view.defPosition("b22", 336, 49, 16, 16);
    view.defPosition("c22", 336, 65, 16, 16);
    view.defPosition("d22", 336, 81, 16, 16);
    view.defPosition("e22", 336, 97, 16, 16);
    view.defPosition("f22", 336, 113, 16, 16);
    view.defPosition("g22", 336, 129, 16, 16);
    view.defPosition("h22", 336, 145, 16, 16);
    view.defPosition("i22", 336, 161, 16, 16);
    view.defPosition("j22", 336, 177, 16, 16);
    view.defPosition("k22", 336, 193, 16, 16);
    view.defPosition("l22", 336, 209, 16, 16);
    view.defPosition("m22", 336, 225, 16, 16);
    view.defPosition("n22", 336, 241, 16, 16);
    view.defPosition("o22", 336, 257, 16, 16);
    view.defPosition("p22", 336, 273, 16, 16);
    view.defPosition("q22", 336, 289, 16, 16);
    view.defPosition("r22", 336, 305, 16, 16);
    view.defPosition("s22", 336, 321, 16, 16);
    view.defPosition("t22", 336, 337, 16, 16);
    view.defPosition("a23", 352, 33, 16, 16);
    view.defPosition("b23", 352, 49, 16, 16);
    view.defPosition("c23", 352, 65, 16, 16);
    view.defPosition("d23", 352, 81, 16, 16);
    view.defPosition("e23", 352, 97, 16, 16);
    view.defPosition("f23", 352, 113, 16, 16);
    view.defPosition("g23", 352, 129, 16, 16);
    view.defPosition("h23", 352, 145, 16, 16);
    view.defPosition("i23", 352, 161, 16, 16);
    view.defPosition("j23", 352, 177, 16, 16);
    view.defPosition("k23", 352, 193, 16, 16);
    view.defPosition("l23", 352, 209, 16, 16);
    view.defPosition("m23", 352, 225, 16, 16);
    view.defPosition("n23", 352, 241, 16, 16);
    view.defPosition("o23", 352, 257, 16, 16);
    view.defPosition("p23", 352, 273, 16, 16);
    view.defPosition("q23", 352, 289, 16, 16);
    view.defPosition("r23", 352, 305, 16, 16);
    view.defPosition("s23", 352, 321, 16, 16);
    view.defPosition("t23", 352, 337, 16, 16);
    view.defPosition("a24", 368, 33, 16, 16);
    view.defPosition("b24", 368, 49, 16, 16);
    view.defPosition("c24", 368, 65, 16, 16);
    view.defPosition("d24", 368, 81, 16, 16);
    view.defPosition("e24", 368, 97, 16, 16);
    view.defPosition("f24", 368, 113, 16, 16);
    view.defPosition("g24", 368, 129, 16, 16);
    view.defPosition("h24", 368, 145, 16, 16);
    view.defPosition("i24", 368, 161, 16, 16);
    view.defPosition("j24", 368, 177, 16, 16);
    view.defPosition("k24", 368, 193, 16, 16);
    view.defPosition("l24", 368, 209, 16, 16);
    view.defPosition("m24", 368, 225, 16, 16);
    view.defPosition("n24", 368, 241, 16, 16);
    view.defPosition("o24", 368, 257, 16, 16);
    view.defPosition("p24", 368, 273, 16, 16);
    view.defPosition("q24", 368, 289, 16, 16);
    view.defPosition("r24", 368, 305, 16, 16);
    view.defPosition("s24", 368, 321, 16, 16);
    view.defPosition("t24", 368, 337, 16, 16);
    view.defPosition("a25", 384, 33, 16, 16);
    view.defPosition("b25", 384, 49, 16, 16);
    view.defPosition("c25", 384, 65, 16, 16);
    view.defPosition("d25", 384, 81, 16, 16);
    view.defPosition("e25", 384, 97, 16, 16);
    view.defPosition("f25", 384, 113, 16, 16);
    view.defPosition("g25", 384, 129, 16, 16);
    view.defPosition("h25", 384, 145, 16, 16);
    view.defPosition("i25", 384, 161, 16, 16);
    view.defPosition("j25", 384, 177, 16, 16);
    view.defPosition("k25", 384, 193, 16, 16);
    view.defPosition("l25", 384, 209, 16, 16);
    view.defPosition("m25", 384, 225, 16, 16);
    view.defPosition("n25", 384, 241, 16, 16);
    view.defPosition("o25", 384, 257, 16, 16);
    view.defPosition("p25", 384, 273, 16, 16);
    view.defPosition("q25", 384, 289, 16, 16);
    view.defPosition("r25", 384, 305, 16, 16);
    view.defPosition("s25", 384, 321, 16, 16);
    view.defPosition("t25", 384, 337, 16, 16);
    view.defPosition("a26", 400, 33, 16, 16);
    view.defPosition("b26", 400, 49, 16, 16);
    view.defPosition("c26", 400, 65, 16, 16);
    view.defPosition("d26", 400, 81, 16, 16);
    view.defPosition("e26", 400, 97, 16, 16);
    view.defPosition("f26", 400, 113, 16, 16);
    view.defPosition("g26", 400, 129, 16, 16);
    view.defPosition("h26", 400, 145, 16, 16);
    view.defPosition("i26", 400, 161, 16, 16);
    view.defPosition("j26", 400, 177, 16, 16);
    view.defPosition("k26", 400, 193, 16, 16);
    view.defPosition("l26", 400, 209, 16, 16);
    view.defPosition("m26", 400, 225, 16, 16);
    view.defPosition("n26", 400, 241, 16, 16);
    view.defPosition("o26", 400, 257, 16, 16);
    view.defPosition("p26", 400, 273, 16, 16);
    view.defPosition("q26", 400, 289, 16, 16);
    view.defPosition("r26", 400, 305, 16, 16);
    view.defPosition("s26", 400, 321, 16, 16);
    view.defPosition("t26", 400, 337, 16, 16);
    view.defPosition("a27", 416, 33, 16, 16);
    view.defPosition("b27", 416, 49, 16, 16);
    view.defPosition("c27", 416, 65, 16, 16);
    view.defPosition("d27", 416, 81, 16, 16);
    view.defPosition("e27", 416, 97, 16, 16);
    view.defPosition("f27", 416, 113, 16, 16);
    view.defPosition("g27", 416, 129, 16, 16);
    view.defPosition("h27", 416, 145, 16, 16);
    view.defPosition("i27", 416, 161, 16, 16);
    view.defPosition("j27", 416, 177, 16, 16);
    view.defPosition("k27", 416, 193, 16, 16);
    view.defPosition("l27", 416, 209, 16, 16);
    view.defPosition("m27", 416, 225, 16, 16);
    view.defPosition("n27", 416, 241, 16, 16);
    view.defPosition("o27", 416, 257, 16, 16);
    view.defPosition("p27", 416, 273, 16, 16);
    view.defPosition("q27", 416, 289, 16, 16);
    view.defPosition("r27", 416, 305, 16, 16);
    view.defPosition("s27", 416, 321, 16, 16);
    view.defPosition("t27", 416, 337, 16, 16);
    view.defPosition("a28", 432, 33, 16, 16);
    view.defPosition("b28", 432, 49, 16, 16);
    view.defPosition("c28", 432, 65, 16, 16);
    view.defPosition("d28", 432, 81, 16, 16);
    view.defPosition("e28", 432, 97, 16, 16);
    view.defPosition("f28", 432, 113, 16, 16);
    view.defPosition("g28", 432, 129, 16, 16);
    view.defPosition("h28", 432, 145, 16, 16);
    view.defPosition("i28", 432, 161, 16, 16);
    view.defPosition("j28", 432, 177, 16, 16);
    view.defPosition("k28", 432, 193, 16, 16);
    view.defPosition("l28", 432, 209, 16, 16);
    view.defPosition("m28", 432, 225, 16, 16);
    view.defPosition("n28", 432, 241, 16, 16);
    view.defPosition("o28", 432, 257, 16, 16);
    view.defPosition("p28", 432, 273, 16, 16);
    view.defPosition("q28", 432, 289, 16, 16);
    view.defPosition("r28", 432, 305, 16, 16);
    view.defPosition("s28", 432, 321, 16, 16);
    view.defPosition("t28", 432, 337, 16, 16);
    view.defPosition("a29", 448, 33, 16, 16);
    view.defPosition("b29", 448, 49, 16, 16);
    view.defPosition("c29", 448, 65, 16, 16);
    view.defPosition("d29", 448, 81, 16, 16);
    view.defPosition("e29", 448, 97, 16, 16);
    view.defPosition("f29", 448, 113, 16, 16);
    view.defPosition("g29", 448, 129, 16, 16);
    view.defPosition("h29", 448, 145, 16, 16);
    view.defPosition("i29", 448, 161, 16, 16);
    view.defPosition("j29", 448, 177, 16, 16);
    view.defPosition("k29", 448, 193, 16, 16);
    view.defPosition("l29", 448, 209, 16, 16);
    view.defPosition("m29", 448, 225, 16, 16);
    view.defPosition("n29", 448, 241, 16, 16);
    view.defPosition("o29", 448, 257, 16, 16);
    view.defPosition("p29", 448, 273, 16, 16);
    view.defPosition("q29", 448, 289, 16, 16);
    view.defPosition("r29", 448, 305, 16, 16);
    view.defPosition("s29", 448, 321, 16, 16);
    view.defPosition("t29", 448, 337, 16, 16);
    view.defPosition("a30", 464, 33, 16, 16);
    view.defPosition("b30", 464, 49, 16, 16);
    view.defPosition("c30", 464, 65, 16, 16);
    view.defPosition("d30", 464, 81, 16, 16);
    view.defPosition("e30", 464, 97, 16, 16);
    view.defPosition("f30", 464, 113, 16, 16);
    view.defPosition("g30", 464, 129, 16, 16);
    view.defPosition("h30", 464, 145, 16, 16);
    view.defPosition("i30", 464, 161, 16, 16);
    view.defPosition("j30", 464, 177, 16, 16);
    view.defPosition("k30", 464, 193, 16, 16);
    view.defPosition("l30", 464, 209, 16, 16);
    view.defPosition("m30", 464, 225, 16, 16);
    view.defPosition("n30", 464, 241, 16, 16);
    view.defPosition("o30", 464, 257, 16, 16);
    view.defPosition("p30", 464, 273, 16, 16);
    view.defPosition("q30", 464, 289, 16, 16);
    view.defPosition("r30", 464, 305, 16, 16);
    view.defPosition("s30", 464, 321, 16, 16);
    view.defPosition("t30", 464, 337, 16, 16);
    view.defPosition("a31", 480, 33, 16, 16);
    view.defPosition("b31", 480, 49, 16, 16);
    view.defPosition("c31", 480, 65, 16, 16);
    view.defPosition("d31", 480, 81, 16, 16);
    view.defPosition("e31", 480, 97, 16, 16);
    view.defPosition("f31", 480, 113, 16, 16);
    view.defPosition("g31", 480, 129, 16, 16);
    view.defPosition("h31", 480, 145, 16, 16);
    view.defPosition("i31", 480, 161, 16, 16);
    view.defPosition("j31", 480, 177, 16, 16);
    view.defPosition("k31", 480, 193, 16, 16);
    view.defPosition("l31", 480, 209, 16, 16);
    view.defPosition("m31", 480, 225, 16, 16);
    view.defPosition("n31", 480, 241, 16, 16);
    view.defPosition("o31", 480, 257, 16, 16);
    view.defPosition("p31", 480, 273, 16, 16);
    view.defPosition("q31", 480, 289, 16, 16);
    view.defPosition("r31", 480, 305, 16, 16);
    view.defPosition("s31", 480, 321, 16, 16);
    view.defPosition("t31", 480, 337, 16, 16);
    view.defPosition("a32", 496, 33, 16, 16);
    view.defPosition("b32", 496, 49, 16, 16);
    view.defPosition("c32", 496, 65, 16, 16);
    view.defPosition("d32", 496, 81, 16, 16);
    view.defPosition("e32", 496, 97, 16, 16);
    view.defPosition("f32", 496, 113, 16, 16);
    view.defPosition("g32", 496, 129, 16, 16);
    view.defPosition("h32", 496, 145, 16, 16);
    view.defPosition("i32", 496, 161, 16, 16);
    view.defPosition("j32", 496, 177, 16, 16);
    view.defPosition("k32", 496, 193, 16, 16);
    view.defPosition("l32", 496, 209, 16, 16);
    view.defPosition("m32", 496, 225, 16, 16);
    view.defPosition("n32", 496, 241, 16, 16);
    view.defPosition("o32", 496, 257, 16, 16);
    view.defPosition("p32", 496, 273, 16, 16);
    view.defPosition("q32", 496, 289, 16, 16);
    view.defPosition("r32", 496, 305, 16, 16);
    view.defPosition("s32", 496, 321, 16, 16);
    view.defPosition("t32", 496, 337, 16, 16);
    view.defPosition("a33", 512, 33, 16, 16);
    view.defPosition("b33", 512, 49, 16, 16);
    view.defPosition("c33", 512, 65, 16, 16);
    view.defPosition("d33", 512, 81, 16, 16);
    view.defPosition("e33", 512, 97, 16, 16);
    view.defPosition("f33", 512, 113, 16, 16);
    view.defPosition("g33", 512, 129, 16, 16);
    view.defPosition("h33", 512, 145, 16, 16);
    view.defPosition("i33", 512, 161, 16, 16);
    view.defPosition("j33", 512, 177, 16, 16);
    view.defPosition("k33", 512, 193, 16, 16);
    view.defPosition("l33", 512, 209, 16, 16);
    view.defPosition("m33", 512, 225, 16, 16);
    view.defPosition("n33", 512, 241, 16, 16);
    view.defPosition("o33", 512, 257, 16, 16);
    view.defPosition("p33", 512, 273, 16, 16);
    view.defPosition("q33", 512, 289, 16, 16);
    view.defPosition("r33", 512, 305, 16, 16);
    view.defPosition("s33", 512, 321, 16, 16);
    view.defPosition("t33", 512, 337, 16, 16);
    view.defPosition("a34", 528, 33, 16, 16);
    view.defPosition("b34", 528, 49, 16, 16);
    view.defPosition("c34", 528, 65, 16, 16);
    view.defPosition("d34", 528, 81, 16, 16);
    view.defPosition("e34", 528, 97, 16, 16);
    view.defPosition("f34", 528, 113, 16, 16);
    view.defPosition("g34", 528, 129, 16, 16);
    view.defPosition("h34", 528, 145, 16, 16);
    view.defPosition("i34", 528, 161, 16, 16);
    view.defPosition("j34", 528, 177, 16, 16);
    view.defPosition("k34", 528, 193, 16, 16);
    view.defPosition("l34", 528, 209, 16, 16);
    view.defPosition("m34", 528, 225, 16, 16);
    view.defPosition("n34", 528, 241, 16, 16);
    view.defPosition("o34", 528, 257, 16, 16);
    view.defPosition("p34", 528, 273, 16, 16);
    view.defPosition("q34", 528, 289, 16, 16);
    view.defPosition("r34", 528, 305, 16, 16);
    view.defPosition("s34", 528, 321, 16, 16);
    view.defPosition("t34", 528, 337, 16, 16);
    view.defPosition("a35", 544, 33, 16, 16);
    view.defPosition("b35", 544, 49, 16, 16);
    view.defPosition("c35", 544, 65, 16, 16);
    view.defPosition("d35", 544, 81, 16, 16);
    view.defPosition("e35", 544, 97, 16, 16);
    view.defPosition("f35", 544, 113, 16, 16);
    view.defPosition("g35", 544, 129, 16, 16);
    view.defPosition("h35", 544, 145, 16, 16);
    view.defPosition("i35", 544, 161, 16, 16);
    view.defPosition("j35", 544, 177, 16, 16);
    view.defPosition("k35", 544, 193, 16, 16);
    view.defPosition("l35", 544, 209, 16, 16);
    view.defPosition("m35", 544, 225, 16, 16);
    view.defPosition("n35", 544, 241, 16, 16);
    view.defPosition("o35", 544, 257, 16, 16);
    view.defPosition("p35", 544, 273, 16, 16);
    view.defPosition("q35", 544, 289, 16, 16);
    view.defPosition("r35", 544, 305, 16, 16);
    view.defPosition("s35", 544, 321, 16, 16);
    view.defPosition("t35", 544, 337, 16, 16);
    view.defPosition("a36", 560, 33, 16, 16);
    view.defPosition("b36", 560, 49, 16, 16);
    view.defPosition("c36", 560, 65, 16, 16);
    view.defPosition("d36", 560, 81, 16, 16);
    view.defPosition("e36", 560, 97, 16, 16);
    view.defPosition("f36", 560, 113, 16, 16);
    view.defPosition("g36", 560, 129, 16, 16);
    view.defPosition("h36", 560, 145, 16, 16);
    view.defPosition("i36", 560, 161, 16, 16);
    view.defPosition("j36", 560, 177, 16, 16);
    view.defPosition("k36", 560, 193, 16, 16);
    view.defPosition("l36", 560, 209, 16, 16);
    view.defPosition("m36", 560, 225, 16, 16);
    view.defPosition("n36", 560, 241, 16, 16);
    view.defPosition("o36", 560, 257, 16, 16);
    view.defPosition("p36", 560, 273, 16, 16);
    view.defPosition("q36", 560, 289, 16, 16);
    view.defPosition("r36", 560, 305, 16, 16);
    view.defPosition("s36", 560, 321, 16, 16);
    view.defPosition("t36", 560, 337, 16, 16);
    view.defPosition("a37", 576, 33, 16, 16);
    view.defPosition("b37", 576, 49, 16, 16);
    view.defPosition("c37", 576, 65, 16, 16);
    view.defPosition("d37", 576, 81, 16, 16);
    view.defPosition("e37", 576, 97, 16, 16);
    view.defPosition("f37", 576, 113, 16, 16);
    view.defPosition("g37", 576, 129, 16, 16);
    view.defPosition("h37", 576, 145, 16, 16);
    view.defPosition("i37", 576, 161, 16, 16);
    view.defPosition("j37", 576, 177, 16, 16);
    view.defPosition("k37", 576, 193, 16, 16);
    view.defPosition("l37", 576, 209, 16, 16);
    view.defPosition("m37", 576, 225, 16, 16);
    view.defPosition("n37", 576, 241, 16, 16);
    view.defPosition("o37", 576, 257, 16, 16);
    view.defPosition("p37", 576, 273, 16, 16);
    view.defPosition("q37", 576, 289, 16, 16);
    view.defPosition("r37", 576, 305, 16, 16);
    view.defPosition("s37", 576, 321, 16, 16);
    view.defPosition("t37", 576, 337, 16, 16);
    view.defPosition("a38", 592, 33, 16, 16);
    view.defPosition("b38", 592, 49, 16, 16);
    view.defPosition("c38", 592, 65, 16, 16);
    view.defPosition("d38", 592, 81, 16, 16);
    view.defPosition("e38", 592, 97, 16, 16);
    view.defPosition("f38", 592, 113, 16, 16);
    view.defPosition("g38", 592, 129, 16, 16);
    view.defPosition("h38", 592, 145, 16, 16);
    view.defPosition("i38", 592, 161, 16, 16);
    view.defPosition("j38", 592, 177, 16, 16);
    view.defPosition("k38", 592, 193, 16, 16);
    view.defPosition("l38", 592, 209, 16, 16);
    view.defPosition("m38", 592, 225, 16, 16);
    view.defPosition("n38", 592, 241, 16, 16);
    view.defPosition("o38", 592, 257, 16, 16);
    view.defPosition("p38", 592, 273, 16, 16);
    view.defPosition("q38", 592, 289, 16, 16);
    view.defPosition("r38", 592, 305, 16, 16);
    view.defPosition("s38", 592, 321, 16, 16);
    view.defPosition("t38", 592, 337, 16, 16);
    view.defPosition("a39", 608, 33, 16, 16);
    view.defPosition("b39", 608, 49, 16, 16);
    view.defPosition("c39", 608, 65, 16, 16);
    view.defPosition("d39", 608, 81, 16, 16);
    view.defPosition("e39", 608, 97, 16, 16);
    view.defPosition("f39", 608, 113, 16, 16);
    view.defPosition("g39", 608, 129, 16, 16);
    view.defPosition("h39", 608, 145, 16, 16);
    view.defPosition("i39", 608, 161, 16, 16);
    view.defPosition("j39", 608, 177, 16, 16);
    view.defPosition("k39", 608, 193, 16, 16);
    view.defPosition("l39", 608, 209, 16, 16);
    view.defPosition("m39", 608, 225, 16, 16);
    view.defPosition("n39", 608, 241, 16, 16);
    view.defPosition("o39", 608, 257, 16, 16);
    view.defPosition("p39", 608, 273, 16, 16);
    view.defPosition("q39", 608, 289, 16, 16);
    view.defPosition("r39", 608, 305, 16, 16);
    view.defPosition("s39", 608, 321, 16, 16);
    view.defPosition("t39", 608, 337, 16, 16);
    view.defPosition("a40", 624, 33, 16, 16);
    view.defPosition("b40", 624, 49, 16, 16);
    view.defPosition("c40", 624, 65, 16, 16);
    view.defPosition("d40", 624, 81, 16, 16);
    view.defPosition("e40", 624, 97, 16, 16);
    view.defPosition("f40", 624, 113, 16, 16);
    view.defPosition("g40", 624, 129, 16, 16);
    view.defPosition("h40", 624, 145, 16, 16);
    view.defPosition("i40", 624, 161, 16, 16);
    view.defPosition("j40", 624, 177, 16, 16);
    view.defPosition("k40", 624, 193, 16, 16);
    view.defPosition("l40", 624, 209, 16, 16);
    view.defPosition("m40", 624, 225, 16, 16);
    view.defPosition("n40", 624, 241, 16, 16);
    view.defPosition("o40", 624, 257, 16, 16);
    view.defPosition("p40", 624, 273, 16, 16);
    view.defPosition("q40", 624, 289, 16, 16);
    view.defPosition("r40", 624, 305, 16, 16);
    view.defPosition("s40", 624, 321, 16, 16);
    view.defPosition("t40", 624, 337, 16, 16);
}
