ZRF = {
    JUMP:          0,
    IF:            1,
    FORK:          2,
    FUNCTION:      3,
    IN_ZONE:       4,
    FLAG:          5,
    SET_FLAG:      6,
    POS_FLAG:      7,
    SET_POS_FLAG:  8,
    ATTR:          9,
    SET_ATTR:      10,
    PROMOTE:       11,
    MODE:          12,
    ON_BOARD_DIR:  13,
    ON_BOARD_POS:  14,
    PARAM:         15,
    LITERAL:       16,
    VERIFY:        20
};

Dagaz.View.SHIFT_X = 1;
Dagaz.View.SHIFT_Y = 1;

Dagaz.Model.BuildDesign = function(design) {
    design.checkVersion("z2j", "2");
    design.checkVersion("smart-moves", "false");
    design.checkVersion("show-hints", "false");
    design.checkVersion("show-blink", "false");
    design.checkVersion("tafl-extension", "true");

    design.addDirection("w");
    design.addDirection("e");
    design.addDirection("s");
    design.addDirection("n");

    design.addPlayer("White", [1, 0, 3, 2]);
    design.addPlayer("Black", [0, 1, 2, 3]);

    design.addPosition("a19", [0, 1, 19, 0]);
    design.addPosition("b19", [-1, 1, 19, 0]);
    design.addPosition("c19", [-1, 1, 19, 0]);
    design.addPosition("d19", [-1, 1, 19, 0]);
    design.addPosition("e19", [-1, 1, 19, 0]);
    design.addPosition("f19", [-1, 1, 19, 0]);
    design.addPosition("g19", [-1, 1, 19, 0]);
    design.addPosition("h19", [-1, 1, 19, 0]);
    design.addPosition("i19", [-1, 1, 19, 0]);
    design.addPosition("j19", [-1, 1, 19, 0]);
    design.addPosition("k19", [-1, 1, 19, 0]);
    design.addPosition("l19", [-1, 1, 19, 0]);
    design.addPosition("m19", [-1, 1, 19, 0]);
    design.addPosition("n19", [-1, 1, 19, 0]);
    design.addPosition("o19", [-1, 1, 19, 0]);
    design.addPosition("p19", [-1, 1, 19, 0]);
    design.addPosition("q19", [-1, 1, 19, 0]);
    design.addPosition("r19", [-1, 1, 19, 0]);
    design.addPosition("s19", [-1, 0, 19, 0]);
    design.addPosition("a18", [0, 1, 19, -19]);
    design.addPosition("b18", [-1, 1, 19, -19]);
    design.addPosition("c18", [-1, 1, 19, -19]);
    design.addPosition("d18", [-1, 1, 19, -19]);
    design.addPosition("e18", [-1, 1, 19, -19]);
    design.addPosition("f18", [-1, 1, 19, -19]);
    design.addPosition("g18", [-1, 1, 19, -19]);
    design.addPosition("h18", [-1, 1, 19, -19]);
    design.addPosition("i18", [-1, 1, 19, -19]);
    design.addPosition("j18", [-1, 1, 19, -19]);
    design.addPosition("k18", [-1, 1, 19, -19]);
    design.addPosition("l18", [-1, 1, 19, -19]);
    design.addPosition("m18", [-1, 1, 19, -19]);
    design.addPosition("n18", [-1, 1, 19, -19]);
    design.addPosition("o18", [-1, 1, 19, -19]);
    design.addPosition("p18", [-1, 1, 19, -19]);
    design.addPosition("q18", [-1, 1, 19, -19]);
    design.addPosition("r18", [-1, 1, 19, -19]);
    design.addPosition("s18", [-1, 0, 19, -19]);
    design.addPosition("a17", [0, 1, 19, -19]);
    design.addPosition("b17", [-1, 1, 19, -19]);
    design.addPosition("c17", [-1, 1, 19, -19]);
    design.addPosition("d17", [-1, 1, 19, -19]);
    design.addPosition("e17", [-1, 1, 19, -19]);
    design.addPosition("f17", [-1, 1, 19, -19]);
    design.addPosition("g17", [-1, 1, 19, -19]);
    design.addPosition("h17", [-1, 1, 19, -19]);
    design.addPosition("i17", [-1, 1, 19, -19]);
    design.addPosition("j17", [-1, 1, 19, -19]);
    design.addPosition("k17", [-1, 1, 19, -19]);
    design.addPosition("l17", [-1, 1, 19, -19]);
    design.addPosition("m17", [-1, 1, 19, -19]);
    design.addPosition("n17", [-1, 1, 19, -19]);
    design.addPosition("o17", [-1, 1, 19, -19]);
    design.addPosition("p17", [-1, 1, 19, -19]);
    design.addPosition("q17", [-1, 1, 19, -19]);
    design.addPosition("r17", [-1, 1, 19, -19]);
    design.addPosition("s17", [-1, 0, 19, -19]);
    design.addPosition("a16", [0, 1, 19, -19]);
    design.addPosition("b16", [-1, 1, 19, -19]);
    design.addPosition("c16", [-1, 1, 19, -19]);
    design.addPosition("d16", [-1, 1, 19, -19]);
    design.addPosition("e16", [-1, 1, 19, -19]);
    design.addPosition("f16", [-1, 1, 19, -19]);
    design.addPosition("g16", [-1, 1, 19, -19]);
    design.addPosition("h16", [-1, 1, 19, -19]);
    design.addPosition("i16", [-1, 1, 19, -19]);
    design.addPosition("j16", [-1, 1, 19, -19]);
    design.addPosition("k16", [-1, 1, 19, -19]);
    design.addPosition("l16", [-1, 1, 19, -19]);
    design.addPosition("m16", [-1, 1, 19, -19]);
    design.addPosition("n16", [-1, 1, 19, -19]);
    design.addPosition("o16", [-1, 1, 19, -19]);
    design.addPosition("p16", [-1, 1, 19, -19]);
    design.addPosition("q16", [-1, 1, 19, -19]);
    design.addPosition("r16", [-1, 1, 19, -19]);
    design.addPosition("s16", [-1, 0, 19, -19]);
    design.addPosition("a15", [0, 1, 19, -19]);
    design.addPosition("b15", [-1, 1, 19, -19]);
    design.addPosition("c15", [-1, 1, 19, -19]);
    design.addPosition("d15", [-1, 1, 19, -19]);
    design.addPosition("e15", [-1, 1, 19, -19]);
    design.addPosition("f15", [-1, 1, 19, -19]);
    design.addPosition("g15", [-1, 1, 19, -19]);
    design.addPosition("h15", [-1, 1, 19, -19]);
    design.addPosition("i15", [-1, 1, 19, -19]);
    design.addPosition("j15", [-1, 1, 19, -19]);
    design.addPosition("k15", [-1, 1, 19, -19]);
    design.addPosition("l15", [-1, 1, 19, -19]);
    design.addPosition("m15", [-1, 1, 19, -19]);
    design.addPosition("n15", [-1, 1, 19, -19]);
    design.addPosition("o15", [-1, 1, 19, -19]);
    design.addPosition("p15", [-1, 1, 19, -19]);
    design.addPosition("q15", [-1, 1, 19, -19]);
    design.addPosition("r15", [-1, 1, 19, -19]);
    design.addPosition("s15", [-1, 0, 19, -19]);
    design.addPosition("a14", [0, 1, 19, -19]);
    design.addPosition("b14", [-1, 1, 19, -19]);
    design.addPosition("c14", [-1, 1, 19, -19]);
    design.addPosition("d14", [-1, 1, 19, -19]);
    design.addPosition("e14", [-1, 1, 19, -19]);
    design.addPosition("f14", [-1, 1, 19, -19]);
    design.addPosition("g14", [-1, 1, 19, -19]);
    design.addPosition("h14", [-1, 1, 19, -19]);
    design.addPosition("i14", [-1, 1, 19, -19]);
    design.addPosition("j14", [-1, 1, 19, -19]);
    design.addPosition("k14", [-1, 1, 19, -19]);
    design.addPosition("l14", [-1, 1, 19, -19]);
    design.addPosition("m14", [-1, 1, 19, -19]);
    design.addPosition("n14", [-1, 1, 19, -19]);
    design.addPosition("o14", [-1, 1, 19, -19]);
    design.addPosition("p14", [-1, 1, 19, -19]);
    design.addPosition("q14", [-1, 1, 19, -19]);
    design.addPosition("r14", [-1, 1, 19, -19]);
    design.addPosition("s14", [-1, 0, 19, -19]);
    design.addPosition("a13", [0, 1, 19, -19]);
    design.addPosition("b13", [-1, 1, 19, -19]);
    design.addPosition("c13", [-1, 1, 19, -19]);
    design.addPosition("d13", [-1, 1, 19, -19]);
    design.addPosition("e13", [-1, 1, 19, -19]);
    design.addPosition("f13", [-1, 1, 19, -19]);
    design.addPosition("g13", [-1, 1, 19, -19]);
    design.addPosition("h13", [-1, 1, 19, -19]);
    design.addPosition("i13", [-1, 1, 19, -19]);
    design.addPosition("j13", [-1, 1, 19, -19]);
    design.addPosition("k13", [-1, 1, 19, -19]);
    design.addPosition("l13", [-1, 1, 19, -19]);
    design.addPosition("m13", [-1, 1, 19, -19]);
    design.addPosition("n13", [-1, 1, 19, -19]);
    design.addPosition("o13", [-1, 1, 19, -19]);
    design.addPosition("p13", [-1, 1, 19, -19]);
    design.addPosition("q13", [-1, 1, 19, -19]);
    design.addPosition("r13", [-1, 1, 19, -19]);
    design.addPosition("s13", [-1, 0, 19, -19]);
    design.addPosition("a12", [0, 1, 19, -19]);
    design.addPosition("b12", [-1, 1, 19, -19]);
    design.addPosition("c12", [-1, 1, 19, -19]);
    design.addPosition("d12", [-1, 1, 19, -19]);
    design.addPosition("e12", [-1, 1, 19, -19]);
    design.addPosition("f12", [-1, 1, 19, -19]);
    design.addPosition("g12", [-1, 1, 19, -19]);
    design.addPosition("h12", [-1, 1, 19, -19]);
    design.addPosition("i12", [-1, 1, 19, -19]);
    design.addPosition("j12", [-1, 1, 19, -19]);
    design.addPosition("k12", [-1, 1, 19, -19]);
    design.addPosition("l12", [-1, 1, 19, -19]);
    design.addPosition("m12", [-1, 1, 19, -19]);
    design.addPosition("n12", [-1, 1, 19, -19]);
    design.addPosition("o12", [-1, 1, 19, -19]);
    design.addPosition("p12", [-1, 1, 19, -19]);
    design.addPosition("q12", [-1, 1, 19, -19]);
    design.addPosition("r12", [-1, 1, 19, -19]);
    design.addPosition("s12", [-1, 0, 19, -19]);
    design.addPosition("a11", [0, 1, 19, -19]);
    design.addPosition("b11", [-1, 1, 19, -19]);
    design.addPosition("c11", [-1, 1, 19, -19]);
    design.addPosition("d11", [-1, 1, 19, -19]);
    design.addPosition("e11", [-1, 1, 19, -19]);
    design.addPosition("f11", [-1, 1, 19, -19]);
    design.addPosition("g11", [-1, 1, 19, -19]);
    design.addPosition("h11", [-1, 1, 19, -19]);
    design.addPosition("i11", [-1, 1, 19, -19]);
    design.addPosition("j11", [-1, 1, 19, -19]);
    design.addPosition("k11", [-1, 1, 19, -19]);
    design.addPosition("l11", [-1, 1, 19, -19]);
    design.addPosition("m11", [-1, 1, 19, -19]);
    design.addPosition("n11", [-1, 1, 19, -19]);
    design.addPosition("o11", [-1, 1, 19, -19]);
    design.addPosition("p11", [-1, 1, 19, -19]);
    design.addPosition("q11", [-1, 1, 19, -19]);
    design.addPosition("r11", [-1, 1, 19, -19]);
    design.addPosition("s11", [-1, 0, 19, -19]);
    design.addPosition("a10", [0, 1, 19, -19]);
    design.addPosition("b10", [-1, 1, 19, -19]);
    design.addPosition("c10", [-1, 1, 19, -19]);
    design.addPosition("d10", [-1, 1, 19, -19]);
    design.addPosition("e10", [-1, 1, 19, -19]);
    design.addPosition("f10", [-1, 1, 19, -19]);
    design.addPosition("g10", [-1, 1, 19, -19]);
    design.addPosition("h10", [-1, 1, 19, -19]);
    design.addPosition("i10", [-1, 1, 19, -19]);
    design.addPosition("j10", [-1, 1, 19, -19]);
    design.addPosition("k10", [-1, 1, 19, -19]);
    design.addPosition("l10", [-1, 1, 19, -19]);
    design.addPosition("m10", [-1, 1, 19, -19]);
    design.addPosition("n10", [-1, 1, 19, -19]);
    design.addPosition("o10", [-1, 1, 19, -19]);
    design.addPosition("p10", [-1, 1, 19, -19]);
    design.addPosition("q10", [-1, 1, 19, -19]);
    design.addPosition("r10", [-1, 1, 19, -19]);
    design.addPosition("s10", [-1, 0, 19, -19]);
    design.addPosition("a9", [0, 1, 19, -19]);
    design.addPosition("b9", [-1, 1, 19, -19]);
    design.addPosition("c9", [-1, 1, 19, -19]);
    design.addPosition("d9", [-1, 1, 19, -19]);
    design.addPosition("e9", [-1, 1, 19, -19]);
    design.addPosition("f9", [-1, 1, 19, -19]);
    design.addPosition("g9", [-1, 1, 19, -19]);
    design.addPosition("h9", [-1, 1, 19, -19]);
    design.addPosition("i9", [-1, 1, 19, -19]);
    design.addPosition("j9", [-1, 1, 19, -19]);
    design.addPosition("k9", [-1, 1, 19, -19]);
    design.addPosition("l9", [-1, 1, 19, -19]);
    design.addPosition("m9", [-1, 1, 19, -19]);
    design.addPosition("n9", [-1, 1, 19, -19]);
    design.addPosition("o9", [-1, 1, 19, -19]);
    design.addPosition("p9", [-1, 1, 19, -19]);
    design.addPosition("q9", [-1, 1, 19, -19]);
    design.addPosition("r9", [-1, 1, 19, -19]);
    design.addPosition("s9", [-1, 0, 19, -19]);
    design.addPosition("a8", [0, 1, 19, -19]);
    design.addPosition("b8", [-1, 1, 19, -19]);
    design.addPosition("c8", [-1, 1, 19, -19]);
    design.addPosition("d8", [-1, 1, 19, -19]);
    design.addPosition("e8", [-1, 1, 19, -19]);
    design.addPosition("f8", [-1, 1, 19, -19]);
    design.addPosition("g8", [-1, 1, 19, -19]);
    design.addPosition("h8", [-1, 1, 19, -19]);
    design.addPosition("i8", [-1, 1, 19, -19]);
    design.addPosition("j8", [-1, 1, 19, -19]);
    design.addPosition("k8", [-1, 1, 19, -19]);
    design.addPosition("l8", [-1, 1, 19, -19]);
    design.addPosition("m8", [-1, 1, 19, -19]);
    design.addPosition("n8", [-1, 1, 19, -19]);
    design.addPosition("o8", [-1, 1, 19, -19]);
    design.addPosition("p8", [-1, 1, 19, -19]);
    design.addPosition("q8", [-1, 1, 19, -19]);
    design.addPosition("r8", [-1, 1, 19, -19]);
    design.addPosition("s8", [-1, 0, 19, -19]);
    design.addPosition("a7", [0, 1, 19, -19]);
    design.addPosition("b7", [-1, 1, 19, -19]);
    design.addPosition("c7", [-1, 1, 19, -19]);
    design.addPosition("d7", [-1, 1, 19, -19]);
    design.addPosition("e7", [-1, 1, 19, -19]);
    design.addPosition("f7", [-1, 1, 19, -19]);
    design.addPosition("g7", [-1, 1, 19, -19]);
    design.addPosition("h7", [-1, 1, 19, -19]);
    design.addPosition("i7", [-1, 1, 19, -19]);
    design.addPosition("j7", [-1, 1, 19, -19]);
    design.addPosition("k7", [-1, 1, 19, -19]);
    design.addPosition("l7", [-1, 1, 19, -19]);
    design.addPosition("m7", [-1, 1, 19, -19]);
    design.addPosition("n7", [-1, 1, 19, -19]);
    design.addPosition("o7", [-1, 1, 19, -19]);
    design.addPosition("p7", [-1, 1, 19, -19]);
    design.addPosition("q7", [-1, 1, 19, -19]);
    design.addPosition("r7", [-1, 1, 19, -19]);
    design.addPosition("s7", [-1, 0, 19, -19]);
    design.addPosition("a6", [0, 1, 19, -19]);
    design.addPosition("b6", [-1, 1, 19, -19]);
    design.addPosition("c6", [-1, 1, 19, -19]);
    design.addPosition("d6", [-1, 1, 19, -19]);
    design.addPosition("e6", [-1, 1, 19, -19]);
    design.addPosition("f6", [-1, 1, 19, -19]);
    design.addPosition("g6", [-1, 1, 19, -19]);
    design.addPosition("h6", [-1, 1, 19, -19]);
    design.addPosition("i6", [-1, 1, 19, -19]);
    design.addPosition("j6", [-1, 1, 19, -19]);
    design.addPosition("k6", [-1, 1, 19, -19]);
    design.addPosition("l6", [-1, 1, 19, -19]);
    design.addPosition("m6", [-1, 1, 19, -19]);
    design.addPosition("n6", [-1, 1, 19, -19]);
    design.addPosition("o6", [-1, 1, 19, -19]);
    design.addPosition("p6", [-1, 1, 19, -19]);
    design.addPosition("q6", [-1, 1, 19, -19]);
    design.addPosition("r6", [-1, 1, 19, -19]);
    design.addPosition("s6", [-1, 0, 19, -19]);
    design.addPosition("a5", [0, 1, 19, -19]);
    design.addPosition("b5", [-1, 1, 19, -19]);
    design.addPosition("c5", [-1, 1, 19, -19]);
    design.addPosition("d5", [-1, 1, 19, -19]);
    design.addPosition("e5", [-1, 1, 19, -19]);
    design.addPosition("f5", [-1, 1, 19, -19]);
    design.addPosition("g5", [-1, 1, 19, -19]);
    design.addPosition("h5", [-1, 1, 19, -19]);
    design.addPosition("i5", [-1, 1, 19, -19]);
    design.addPosition("j5", [-1, 1, 19, -19]);
    design.addPosition("k5", [-1, 1, 19, -19]);
    design.addPosition("l5", [-1, 1, 19, -19]);
    design.addPosition("m5", [-1, 1, 19, -19]);
    design.addPosition("n5", [-1, 1, 19, -19]);
    design.addPosition("o5", [-1, 1, 19, -19]);
    design.addPosition("p5", [-1, 1, 19, -19]);
    design.addPosition("q5", [-1, 1, 19, -19]);
    design.addPosition("r5", [-1, 1, 19, -19]);
    design.addPosition("s5", [-1, 0, 19, -19]);
    design.addPosition("a4", [0, 1, 19, -19]);
    design.addPosition("b4", [-1, 1, 19, -19]);
    design.addPosition("c4", [-1, 1, 19, -19]);
    design.addPosition("d4", [-1, 1, 19, -19]);
    design.addPosition("e4", [-1, 1, 19, -19]);
    design.addPosition("f4", [-1, 1, 19, -19]);
    design.addPosition("g4", [-1, 1, 19, -19]);
    design.addPosition("h4", [-1, 1, 19, -19]);
    design.addPosition("i4", [-1, 1, 19, -19]);
    design.addPosition("j4", [-1, 1, 19, -19]);
    design.addPosition("k4", [-1, 1, 19, -19]);
    design.addPosition("l4", [-1, 1, 19, -19]);
    design.addPosition("m4", [-1, 1, 19, -19]);
    design.addPosition("n4", [-1, 1, 19, -19]);
    design.addPosition("o4", [-1, 1, 19, -19]);
    design.addPosition("p4", [-1, 1, 19, -19]);
    design.addPosition("q4", [-1, 1, 19, -19]);
    design.addPosition("r4", [-1, 1, 19, -19]);
    design.addPosition("s4", [-1, 0, 19, -19]);
    design.addPosition("a3", [0, 1, 19, -19]);
    design.addPosition("b3", [-1, 1, 19, -19]);
    design.addPosition("c3", [-1, 1, 19, -19]);
    design.addPosition("d3", [-1, 1, 19, -19]);
    design.addPosition("e3", [-1, 1, 19, -19]);
    design.addPosition("f3", [-1, 1, 19, -19]);
    design.addPosition("g3", [-1, 1, 19, -19]);
    design.addPosition("h3", [-1, 1, 19, -19]);
    design.addPosition("i3", [-1, 1, 19, -19]);
    design.addPosition("j3", [-1, 1, 19, -19]);
    design.addPosition("k3", [-1, 1, 19, -19]);
    design.addPosition("l3", [-1, 1, 19, -19]);
    design.addPosition("m3", [-1, 1, 19, -19]);
    design.addPosition("n3", [-1, 1, 19, -19]);
    design.addPosition("o3", [-1, 1, 19, -19]);
    design.addPosition("p3", [-1, 1, 19, -19]);
    design.addPosition("q3", [-1, 1, 19, -19]);
    design.addPosition("r3", [-1, 1, 19, -19]);
    design.addPosition("s3", [-1, 0, 19, -19]);
    design.addPosition("a2", [0, 1, 19, -19]);
    design.addPosition("b2", [-1, 1, 19, -19]);
    design.addPosition("c2", [-1, 1, 19, -19]);
    design.addPosition("d2", [-1, 1, 19, -19]);
    design.addPosition("e2", [-1, 1, 19, -19]);
    design.addPosition("f2", [-1, 1, 19, -19]);
    design.addPosition("g2", [-1, 1, 19, -19]);
    design.addPosition("h2", [-1, 1, 19, -19]);
    design.addPosition("i2", [-1, 1, 19, -19]);
    design.addPosition("j2", [-1, 1, 19, -19]);
    design.addPosition("k2", [-1, 1, 19, -19]);
    design.addPosition("l2", [-1, 1, 19, -19]);
    design.addPosition("m2", [-1, 1, 19, -19]);
    design.addPosition("n2", [-1, 1, 19, -19]);
    design.addPosition("o2", [-1, 1, 19, -19]);
    design.addPosition("p2", [-1, 1, 19, -19]);
    design.addPosition("q2", [-1, 1, 19, -19]);
    design.addPosition("r2", [-1, 1, 19, -19]);
    design.addPosition("s2", [-1, 0, 19, -19]);
    design.addPosition("a1", [0, 1, 0, -19]);
    design.addPosition("b1", [-1, 1, 0, -19]);
    design.addPosition("c1", [-1, 1, 0, -19]);
    design.addPosition("d1", [-1, 1, 0, -19]);
    design.addPosition("e1", [-1, 1, 0, -19]);
    design.addPosition("f1", [-1, 1, 0, -19]);
    design.addPosition("g1", [-1, 1, 0, -19]);
    design.addPosition("h1", [-1, 1, 0, -19]);
    design.addPosition("i1", [-1, 1, 0, -19]);
    design.addPosition("j1", [-1, 1, 0, -19]);
    design.addPosition("k1", [-1, 1, 0, -19]);
    design.addPosition("l1", [-1, 1, 0, -19]);
    design.addPosition("m1", [-1, 1, 0, -19]);
    design.addPosition("n1", [-1, 1, 0, -19]);
    design.addPosition("o1", [-1, 1, 0, -19]);
    design.addPosition("p1", [-1, 1, 0, -19]);
    design.addPosition("q1", [-1, 1, 0, -19]);
    design.addPosition("r1", [-1, 1, 0, -19]);
    design.addPosition("s1", [-1, 0, 0, -19]);

    design.addZone("throne", 2, [180]);
    design.addZone("throne", 1, [180]);
    design.addZone("goal", 2, [342, 323, 304, 285, 266, 247, 228, 209, 190, 171, 152, 133, 114, 95, 76, 57, 38, 19, 0, 360, 341, 322, 303, 284, 265, 246, 227, 208, 189, 170, 151, 132, 113, 94, 75, 56, 37, 18, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 343, 344, 345, 346, 347, 348, 349, 350, 351, 352, 353, 354, 355, 356, 357, 358, 359]);
    design.addZone("goal", 1, [342, 323, 304, 285, 266, 247, 228, 209, 190, 171, 152, 133, 114, 95, 76, 57, 38, 19, 0, 360, 341, 322, 303, 284, 265, 246, 227, 208, 189, 170, 151, 132, 113, 94, 75, 56, 37, 18, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 343, 344, 345, 346, 347, 348, 349, 350, 351, 352, 353, 354, 355, 356, 357, 358, 359]);

    design.addCommand(0, ZRF.FUNCTION,	24);	// from
    design.addCommand(0, ZRF.PARAM,	0);	// $1
    design.addCommand(0, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(0, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(0, ZRF.FUNCTION,	0);	// not
    design.addCommand(0, ZRF.IF,	13);
    design.addCommand(0, ZRF.IN_ZONE,	0);	// throne
    design.addCommand(0, ZRF.FUNCTION,	0);	// not
    design.addCommand(0, ZRF.FUNCTION,	20);	// verify
    design.addCommand(0, ZRF.IN_ZONE,	1);	// goal
    design.addCommand(0, ZRF.FUNCTION,	0);	// not
    design.addCommand(0, ZRF.FUNCTION,	20);	// verify
    design.addCommand(0, ZRF.FORK,	3);
    design.addCommand(0, ZRF.FUNCTION,	25);	// to
    design.addCommand(0, ZRF.FUNCTION,	28);	// end
    design.addCommand(0, ZRF.PARAM,	1);	// $2
    design.addCommand(0, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(0, ZRF.JUMP,	-14);
    design.addCommand(0, ZRF.FUNCTION,	28);	// end

    design.addCommand(1, ZRF.FUNCTION,	24);	// from
    design.addCommand(1, ZRF.PARAM,	0);	// $1
    design.addCommand(1, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(1, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(1, ZRF.FUNCTION,	20);	// verify
    design.addCommand(1, ZRF.IN_ZONE,	0);	// throne
    design.addCommand(1, ZRF.FUNCTION,	0);	// not
    design.addCommand(1, ZRF.FUNCTION,	20);	// verify
    design.addCommand(1, ZRF.FUNCTION,	25);	// to
    design.addCommand(1, ZRF.FUNCTION,	28);	// end

    design.addPiece("Man", 0);
    design.addMove(0, 0, [3, 3], 0);
    design.addMove(0, 0, [2, 2], 0);
    design.addMove(0, 0, [0, 0], 0);
    design.addMove(0, 0, [1, 1], 0);

    design.addPiece("King", 1);
    design.addMove(1, 1, [3], 0);
    design.addMove(1, 1, [2], 0);
    design.addMove(1, 1, [0], 0);
    design.addMove(1, 1, [1], 0);

    design.addPiece("CapturedKing", 2);

    design.setup("Black", "Man", 304);
    design.setup("Black", "Man", 247);
    design.setup("Black", "Man", 95);
    design.setup("Black", "Man", 38);
    design.setup("Black", "Man", 344);
    design.setup("Black", "Man", 249);
    design.setup("Black", "Man", 97);
    design.setup("Black", "Man", 2);
    design.setup("Black", "Man", 212);
    design.setup("Black", "Man", 174);
    design.setup("Black", "Man", 136);
    design.setup("Black", "Man", 232);
    design.setup("Black", "Man", 118);
    design.setup("Black", "Man", 347);
    design.setup("Black", "Man", 309);
    design.setup("Black", "Man", 252);
    design.setup("Black", "Man", 100);
    design.setup("Black", "Man", 43);
    design.setup("Black", "Man", 5);
    design.setup("Black", "Man", 272);
    design.setup("Black", "Man", 82);
    design.setup("Black", "Man", 292);
    design.setup("Black", "Man", 64);
    design.setup("Black", "Man", 294);
    design.setup("Black", "Man", 66);
    design.setup("Black", "Man", 296);
    design.setup("Black", "Man", 68);
    design.setup("Black", "Man", 278);
    design.setup("Black", "Man", 88);
    design.setup("Black", "Man", 355);
    design.setup("Black", "Man", 317);
    design.setup("Black", "Man", 260);
    design.setup("Black", "Man", 108);
    design.setup("Black", "Man", 51);
    design.setup("Black", "Man", 13);
    design.setup("Black", "Man", 242);
    design.setup("Black", "Man", 128);
    design.setup("Black", "Man", 224);
    design.setup("Black", "Man", 186);
    design.setup("Black", "Man", 148);
    design.setup("Black", "Man", 358);
    design.setup("Black", "Man", 263);
    design.setup("Black", "Man", 111);
    design.setup("Black", "Man", 16);
    design.setup("Black", "Man", 322);
    design.setup("Black", "Man", 265);
    design.setup("Black", "Man", 113);
    design.setup("Black", "Man", 56);
    design.setup("White", "King", 180);
    design.setup("White", "Man", 194);
    design.setup("White", "Man", 156);
    design.setup("White", "Man", 177);
    design.setup("White", "Man", 197);
    design.setup("White", "Man", 159);
    design.setup("White", "Man", 274);
    design.setup("White", "Man", 217);
    design.setup("White", "Man", 179);
    design.setup("White", "Man", 141);
    design.setup("White", "Man", 84);
    design.setup("White", "Man", 237);
    design.setup("White", "Man", 199);
    design.setup("White", "Man", 161);
    design.setup("White", "Man", 123);
    design.setup("White", "Man", 276);
    design.setup("White", "Man", 219);
    design.setup("White", "Man", 181);
    design.setup("White", "Man", 143);
    design.setup("White", "Man", 86);
    design.setup("White", "Man", 201);
    design.setup("White", "Man", 163);
    design.setup("White", "Man", 183);
    design.setup("White", "Man", 204);
    design.setup("White", "Man", 166);

    design.goal(0, "White", "King", [342, 323, 304, 285, 266, 247, 228, 209, 190, 171, 152, 133, 114, 95, 76, 57, 38, 19, 0, 360, 341, 322, 303, 284, 265, 246, 227, 208, 189, 170, 151, 132, 113, 94, 75, 56, 37, 18, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 343, 344, 345, 346, 347, 348, 349, 350, 351, 352, 353, 354, 355, 356, 357, 358, 359]);
}

Dagaz.View.configure = function(view) {
    view.defBoard("Board");
    view.defPiece("WhiteMan", "White Man");
    view.defPiece("BlackMan", "Black Man");
    view.defPiece("WhiteKing", "White King");
    view.defPiece("WhiteKing", "White CapturedKing");
 
    view.defPosition("a19", 15, 15, 31, 31);
    view.defPosition("b19", 47, 15, 31, 31);
    view.defPosition("c19", 79, 15, 31, 31);
    view.defPosition("d19", 111, 15, 31, 31);
    view.defPosition("e19", 143, 15, 31, 31);
    view.defPosition("f19", 175, 15, 31, 31);
    view.defPosition("g19", 207, 15, 31, 31);
    view.defPosition("h19", 239, 15, 31, 31);
    view.defPosition("i19", 271, 15, 31, 31);
    view.defPosition("j19", 303, 15, 31, 31);
    view.defPosition("k19", 335, 15, 31, 31);
    view.defPosition("l19", 367, 15, 31, 31);
    view.defPosition("m19", 399, 15, 31, 31);
    view.defPosition("n19", 431, 15, 31, 31);
    view.defPosition("o19", 463, 15, 31, 31);
    view.defPosition("p19", 495, 15, 31, 31);
    view.defPosition("q19", 527, 15, 31, 31);
    view.defPosition("r19", 559, 15, 31, 31);
    view.defPosition("s19", 591, 15, 31, 31);
    view.defPosition("a18", 15, 47, 31, 31);
    view.defPosition("b18", 47, 47, 31, 31);
    view.defPosition("c18", 79, 47, 31, 31);
    view.defPosition("d18", 111, 47, 31, 31);
    view.defPosition("e18", 143, 47, 31, 31);
    view.defPosition("f18", 175, 47, 31, 31);
    view.defPosition("g18", 207, 47, 31, 31);
    view.defPosition("h18", 239, 47, 31, 31);
    view.defPosition("i18", 271, 47, 31, 31);
    view.defPosition("j18", 303, 47, 31, 31);
    view.defPosition("k18", 335, 47, 31, 31);
    view.defPosition("l18", 367, 47, 31, 31);
    view.defPosition("m18", 399, 47, 31, 31);
    view.defPosition("n18", 431, 47, 31, 31);
    view.defPosition("o18", 463, 47, 31, 31);
    view.defPosition("p18", 495, 47, 31, 31);
    view.defPosition("q18", 527, 47, 31, 31);
    view.defPosition("r18", 559, 47, 31, 31);
    view.defPosition("s18", 591, 47, 31, 31);
    view.defPosition("a17", 15, 79, 31, 31);
    view.defPosition("b17", 47, 79, 31, 31);
    view.defPosition("c17", 79, 79, 31, 31);
    view.defPosition("d17", 111, 79, 31, 31);
    view.defPosition("e17", 143, 79, 31, 31);
    view.defPosition("f17", 175, 79, 31, 31);
    view.defPosition("g17", 207, 79, 31, 31);
    view.defPosition("h17", 239, 79, 31, 31);
    view.defPosition("i17", 271, 79, 31, 31);
    view.defPosition("j17", 303, 79, 31, 31);
    view.defPosition("k17", 335, 79, 31, 31);
    view.defPosition("l17", 367, 79, 31, 31);
    view.defPosition("m17", 399, 79, 31, 31);
    view.defPosition("n17", 431, 79, 31, 31);
    view.defPosition("o17", 463, 79, 31, 31);
    view.defPosition("p17", 495, 79, 31, 31);
    view.defPosition("q17", 527, 79, 31, 31);
    view.defPosition("r17", 559, 79, 31, 31);
    view.defPosition("s17", 591, 79, 31, 31);
    view.defPosition("a16", 15, 111, 31, 31);
    view.defPosition("b16", 47, 111, 31, 31);
    view.defPosition("c16", 79, 111, 31, 31);
    view.defPosition("d16", 111, 111, 31, 31);
    view.defPosition("e16", 143, 111, 31, 31);
    view.defPosition("f16", 175, 111, 31, 31);
    view.defPosition("g16", 207, 111, 31, 31);
    view.defPosition("h16", 239, 111, 31, 31);
    view.defPosition("i16", 271, 111, 31, 31);
    view.defPosition("j16", 303, 111, 31, 31);
    view.defPosition("k16", 335, 111, 31, 31);
    view.defPosition("l16", 367, 111, 31, 31);
    view.defPosition("m16", 399, 111, 31, 31);
    view.defPosition("n16", 431, 111, 31, 31);
    view.defPosition("o16", 463, 111, 31, 31);
    view.defPosition("p16", 495, 111, 31, 31);
    view.defPosition("q16", 527, 111, 31, 31);
    view.defPosition("r16", 559, 111, 31, 31);
    view.defPosition("s16", 591, 111, 31, 31);
    view.defPosition("a15", 15, 143, 31, 31);
    view.defPosition("b15", 47, 143, 31, 31);
    view.defPosition("c15", 79, 143, 31, 31);
    view.defPosition("d15", 111, 143, 31, 31);
    view.defPosition("e15", 143, 143, 31, 31);
    view.defPosition("f15", 175, 143, 31, 31);
    view.defPosition("g15", 207, 143, 31, 31);
    view.defPosition("h15", 239, 143, 31, 31);
    view.defPosition("i15", 271, 143, 31, 31);
    view.defPosition("j15", 303, 143, 31, 31);
    view.defPosition("k15", 335, 143, 31, 31);
    view.defPosition("l15", 367, 143, 31, 31);
    view.defPosition("m15", 399, 143, 31, 31);
    view.defPosition("n15", 431, 143, 31, 31);
    view.defPosition("o15", 463, 143, 31, 31);
    view.defPosition("p15", 495, 143, 31, 31);
    view.defPosition("q15", 527, 143, 31, 31);
    view.defPosition("r15", 559, 143, 31, 31);
    view.defPosition("s15", 591, 143, 31, 31);
    view.defPosition("a14", 15, 175, 31, 31);
    view.defPosition("b14", 47, 175, 31, 31);
    view.defPosition("c14", 79, 175, 31, 31);
    view.defPosition("d14", 111, 175, 31, 31);
    view.defPosition("e14", 143, 175, 31, 31);
    view.defPosition("f14", 175, 175, 31, 31);
    view.defPosition("g14", 207, 175, 31, 31);
    view.defPosition("h14", 239, 175, 31, 31);
    view.defPosition("i14", 271, 175, 31, 31);
    view.defPosition("j14", 303, 175, 31, 31);
    view.defPosition("k14", 335, 175, 31, 31);
    view.defPosition("l14", 367, 175, 31, 31);
    view.defPosition("m14", 399, 175, 31, 31);
    view.defPosition("n14", 431, 175, 31, 31);
    view.defPosition("o14", 463, 175, 31, 31);
    view.defPosition("p14", 495, 175, 31, 31);
    view.defPosition("q14", 527, 175, 31, 31);
    view.defPosition("r14", 559, 175, 31, 31);
    view.defPosition("s14", 591, 175, 31, 31);
    view.defPosition("a13", 15, 207, 31, 31);
    view.defPosition("b13", 47, 207, 31, 31);
    view.defPosition("c13", 79, 207, 31, 31);
    view.defPosition("d13", 111, 207, 31, 31);
    view.defPosition("e13", 143, 207, 31, 31);
    view.defPosition("f13", 175, 207, 31, 31);
    view.defPosition("g13", 207, 207, 31, 31);
    view.defPosition("h13", 239, 207, 31, 31);
    view.defPosition("i13", 271, 207, 31, 31);
    view.defPosition("j13", 303, 207, 31, 31);
    view.defPosition("k13", 335, 207, 31, 31);
    view.defPosition("l13", 367, 207, 31, 31);
    view.defPosition("m13", 399, 207, 31, 31);
    view.defPosition("n13", 431, 207, 31, 31);
    view.defPosition("o13", 463, 207, 31, 31);
    view.defPosition("p13", 495, 207, 31, 31);
    view.defPosition("q13", 527, 207, 31, 31);
    view.defPosition("r13", 559, 207, 31, 31);
    view.defPosition("s13", 591, 207, 31, 31);
    view.defPosition("a12", 15, 239, 31, 31);
    view.defPosition("b12", 47, 239, 31, 31);
    view.defPosition("c12", 79, 239, 31, 31);
    view.defPosition("d12", 111, 239, 31, 31);
    view.defPosition("e12", 143, 239, 31, 31);
    view.defPosition("f12", 175, 239, 31, 31);
    view.defPosition("g12", 207, 239, 31, 31);
    view.defPosition("h12", 239, 239, 31, 31);
    view.defPosition("i12", 271, 239, 31, 31);
    view.defPosition("j12", 303, 239, 31, 31);
    view.defPosition("k12", 335, 239, 31, 31);
    view.defPosition("l12", 367, 239, 31, 31);
    view.defPosition("m12", 399, 239, 31, 31);
    view.defPosition("n12", 431, 239, 31, 31);
    view.defPosition("o12", 463, 239, 31, 31);
    view.defPosition("p12", 495, 239, 31, 31);
    view.defPosition("q12", 527, 239, 31, 31);
    view.defPosition("r12", 559, 239, 31, 31);
    view.defPosition("s12", 591, 239, 31, 31);
    view.defPosition("a11", 15, 271, 31, 31);
    view.defPosition("b11", 47, 271, 31, 31);
    view.defPosition("c11", 79, 271, 31, 31);
    view.defPosition("d11", 111, 271, 31, 31);
    view.defPosition("e11", 143, 271, 31, 31);
    view.defPosition("f11", 175, 271, 31, 31);
    view.defPosition("g11", 207, 271, 31, 31);
    view.defPosition("h11", 239, 271, 31, 31);
    view.defPosition("i11", 271, 271, 31, 31);
    view.defPosition("j11", 303, 271, 31, 31);
    view.defPosition("k11", 335, 271, 31, 31);
    view.defPosition("l11", 367, 271, 31, 31);
    view.defPosition("m11", 399, 271, 31, 31);
    view.defPosition("n11", 431, 271, 31, 31);
    view.defPosition("o11", 463, 271, 31, 31);
    view.defPosition("p11", 495, 271, 31, 31);
    view.defPosition("q11", 527, 271, 31, 31);
    view.defPosition("r11", 559, 271, 31, 31);
    view.defPosition("s11", 591, 271, 31, 31);
    view.defPosition("a10", 15, 303, 31, 31);
    view.defPosition("b10", 47, 303, 31, 31);
    view.defPosition("c10", 79, 303, 31, 31);
    view.defPosition("d10", 111, 303, 31, 31);
    view.defPosition("e10", 143, 303, 31, 31);
    view.defPosition("f10", 175, 303, 31, 31);
    view.defPosition("g10", 207, 303, 31, 31);
    view.defPosition("h10", 239, 303, 31, 31);
    view.defPosition("i10", 271, 303, 31, 31);
    view.defPosition("j10", 303, 303, 31, 31);
    view.defPosition("k10", 335, 303, 31, 31);
    view.defPosition("l10", 367, 303, 31, 31);
    view.defPosition("m10", 399, 303, 31, 31);
    view.defPosition("n10", 431, 303, 31, 31);
    view.defPosition("o10", 463, 303, 31, 31);
    view.defPosition("p10", 495, 303, 31, 31);
    view.defPosition("q10", 527, 303, 31, 31);
    view.defPosition("r10", 559, 303, 31, 31);
    view.defPosition("s10", 591, 303, 31, 31);
    view.defPosition("a9", 15, 335, 31, 31);
    view.defPosition("b9", 47, 335, 31, 31);
    view.defPosition("c9", 79, 335, 31, 31);
    view.defPosition("d9", 111, 335, 31, 31);
    view.defPosition("e9", 143, 335, 31, 31);
    view.defPosition("f9", 175, 335, 31, 31);
    view.defPosition("g9", 207, 335, 31, 31);
    view.defPosition("h9", 239, 335, 31, 31);
    view.defPosition("i9", 271, 335, 31, 31);
    view.defPosition("j9", 303, 335, 31, 31);
    view.defPosition("k9", 335, 335, 31, 31);
    view.defPosition("l9", 367, 335, 31, 31);
    view.defPosition("m9", 399, 335, 31, 31);
    view.defPosition("n9", 431, 335, 31, 31);
    view.defPosition("o9", 463, 335, 31, 31);
    view.defPosition("p9", 495, 335, 31, 31);
    view.defPosition("q9", 527, 335, 31, 31);
    view.defPosition("r9", 559, 335, 31, 31);
    view.defPosition("s9", 591, 335, 31, 31);
    view.defPosition("a8", 15, 367, 31, 31);
    view.defPosition("b8", 47, 367, 31, 31);
    view.defPosition("c8", 79, 367, 31, 31);
    view.defPosition("d8", 111, 367, 31, 31);
    view.defPosition("e8", 143, 367, 31, 31);
    view.defPosition("f8", 175, 367, 31, 31);
    view.defPosition("g8", 207, 367, 31, 31);
    view.defPosition("h8", 239, 367, 31, 31);
    view.defPosition("i8", 271, 367, 31, 31);
    view.defPosition("j8", 303, 367, 31, 31);
    view.defPosition("k8", 335, 367, 31, 31);
    view.defPosition("l8", 367, 367, 31, 31);
    view.defPosition("m8", 399, 367, 31, 31);
    view.defPosition("n8", 431, 367, 31, 31);
    view.defPosition("o8", 463, 367, 31, 31);
    view.defPosition("p8", 495, 367, 31, 31);
    view.defPosition("q8", 527, 367, 31, 31);
    view.defPosition("r8", 559, 367, 31, 31);
    view.defPosition("s8", 591, 367, 31, 31);
    view.defPosition("a7", 15, 399, 31, 31);
    view.defPosition("b7", 47, 399, 31, 31);
    view.defPosition("c7", 79, 399, 31, 31);
    view.defPosition("d7", 111, 399, 31, 31);
    view.defPosition("e7", 143, 399, 31, 31);
    view.defPosition("f7", 175, 399, 31, 31);
    view.defPosition("g7", 207, 399, 31, 31);
    view.defPosition("h7", 239, 399, 31, 31);
    view.defPosition("i7", 271, 399, 31, 31);
    view.defPosition("j7", 303, 399, 31, 31);
    view.defPosition("k7", 335, 399, 31, 31);
    view.defPosition("l7", 367, 399, 31, 31);
    view.defPosition("m7", 399, 399, 31, 31);
    view.defPosition("n7", 431, 399, 31, 31);
    view.defPosition("o7", 463, 399, 31, 31);
    view.defPosition("p7", 495, 399, 31, 31);
    view.defPosition("q7", 527, 399, 31, 31);
    view.defPosition("r7", 559, 399, 31, 31);
    view.defPosition("s7", 591, 399, 31, 31);
    view.defPosition("a6", 15, 431, 31, 31);
    view.defPosition("b6", 47, 431, 31, 31);
    view.defPosition("c6", 79, 431, 31, 31);
    view.defPosition("d6", 111, 431, 31, 31);
    view.defPosition("e6", 143, 431, 31, 31);
    view.defPosition("f6", 175, 431, 31, 31);
    view.defPosition("g6", 207, 431, 31, 31);
    view.defPosition("h6", 239, 431, 31, 31);
    view.defPosition("i6", 271, 431, 31, 31);
    view.defPosition("j6", 303, 431, 31, 31);
    view.defPosition("k6", 335, 431, 31, 31);
    view.defPosition("l6", 367, 431, 31, 31);
    view.defPosition("m6", 399, 431, 31, 31);
    view.defPosition("n6", 431, 431, 31, 31);
    view.defPosition("o6", 463, 431, 31, 31);
    view.defPosition("p6", 495, 431, 31, 31);
    view.defPosition("q6", 527, 431, 31, 31);
    view.defPosition("r6", 559, 431, 31, 31);
    view.defPosition("s6", 591, 431, 31, 31);
    view.defPosition("a5", 15, 463, 31, 31);
    view.defPosition("b5", 47, 463, 31, 31);
    view.defPosition("c5", 79, 463, 31, 31);
    view.defPosition("d5", 111, 463, 31, 31);
    view.defPosition("e5", 143, 463, 31, 31);
    view.defPosition("f5", 175, 463, 31, 31);
    view.defPosition("g5", 207, 463, 31, 31);
    view.defPosition("h5", 239, 463, 31, 31);
    view.defPosition("i5", 271, 463, 31, 31);
    view.defPosition("j5", 303, 463, 31, 31);
    view.defPosition("k5", 335, 463, 31, 31);
    view.defPosition("l5", 367, 463, 31, 31);
    view.defPosition("m5", 399, 463, 31, 31);
    view.defPosition("n5", 431, 463, 31, 31);
    view.defPosition("o5", 463, 463, 31, 31);
    view.defPosition("p5", 495, 463, 31, 31);
    view.defPosition("q5", 527, 463, 31, 31);
    view.defPosition("r5", 559, 463, 31, 31);
    view.defPosition("s5", 591, 463, 31, 31);
    view.defPosition("a4", 15, 495, 31, 31);
    view.defPosition("b4", 47, 495, 31, 31);
    view.defPosition("c4", 79, 495, 31, 31);
    view.defPosition("d4", 111, 495, 31, 31);
    view.defPosition("e4", 143, 495, 31, 31);
    view.defPosition("f4", 175, 495, 31, 31);
    view.defPosition("g4", 207, 495, 31, 31);
    view.defPosition("h4", 239, 495, 31, 31);
    view.defPosition("i4", 271, 495, 31, 31);
    view.defPosition("j4", 303, 495, 31, 31);
    view.defPosition("k4", 335, 495, 31, 31);
    view.defPosition("l4", 367, 495, 31, 31);
    view.defPosition("m4", 399, 495, 31, 31);
    view.defPosition("n4", 431, 495, 31, 31);
    view.defPosition("o4", 463, 495, 31, 31);
    view.defPosition("p4", 495, 495, 31, 31);
    view.defPosition("q4", 527, 495, 31, 31);
    view.defPosition("r4", 559, 495, 31, 31);
    view.defPosition("s4", 591, 495, 31, 31);
    view.defPosition("a3", 15, 527, 31, 31);
    view.defPosition("b3", 47, 527, 31, 31);
    view.defPosition("c3", 79, 527, 31, 31);
    view.defPosition("d3", 111, 527, 31, 31);
    view.defPosition("e3", 143, 527, 31, 31);
    view.defPosition("f3", 175, 527, 31, 31);
    view.defPosition("g3", 207, 527, 31, 31);
    view.defPosition("h3", 239, 527, 31, 31);
    view.defPosition("i3", 271, 527, 31, 31);
    view.defPosition("j3", 303, 527, 31, 31);
    view.defPosition("k3", 335, 527, 31, 31);
    view.defPosition("l3", 367, 527, 31, 31);
    view.defPosition("m3", 399, 527, 31, 31);
    view.defPosition("n3", 431, 527, 31, 31);
    view.defPosition("o3", 463, 527, 31, 31);
    view.defPosition("p3", 495, 527, 31, 31);
    view.defPosition("q3", 527, 527, 31, 31);
    view.defPosition("r3", 559, 527, 31, 31);
    view.defPosition("s3", 591, 527, 31, 31);
    view.defPosition("a2", 15, 559, 31, 31);
    view.defPosition("b2", 47, 559, 31, 31);
    view.defPosition("c2", 79, 559, 31, 31);
    view.defPosition("d2", 111, 559, 31, 31);
    view.defPosition("e2", 143, 559, 31, 31);
    view.defPosition("f2", 175, 559, 31, 31);
    view.defPosition("g2", 207, 559, 31, 31);
    view.defPosition("h2", 239, 559, 31, 31);
    view.defPosition("i2", 271, 559, 31, 31);
    view.defPosition("j2", 303, 559, 31, 31);
    view.defPosition("k2", 335, 559, 31, 31);
    view.defPosition("l2", 367, 559, 31, 31);
    view.defPosition("m2", 399, 559, 31, 31);
    view.defPosition("n2", 431, 559, 31, 31);
    view.defPosition("o2", 463, 559, 31, 31);
    view.defPosition("p2", 495, 559, 31, 31);
    view.defPosition("q2", 527, 559, 31, 31);
    view.defPosition("r2", 559, 559, 31, 31);
    view.defPosition("s2", 591, 559, 31, 31);
    view.defPosition("a1", 15, 591, 31, 31);
    view.defPosition("b1", 47, 591, 31, 31);
    view.defPosition("c1", 79, 591, 31, 31);
    view.defPosition("d1", 111, 591, 31, 31);
    view.defPosition("e1", 143, 591, 31, 31);
    view.defPosition("f1", 175, 591, 31, 31);
    view.defPosition("g1", 207, 591, 31, 31);
    view.defPosition("h1", 239, 591, 31, 31);
    view.defPosition("i1", 271, 591, 31, 31);
    view.defPosition("j1", 303, 591, 31, 31);
    view.defPosition("k1", 335, 591, 31, 31);
    view.defPosition("l1", 367, 591, 31, 31);
    view.defPosition("m1", 399, 591, 31, 31);
    view.defPosition("n1", 431, 591, 31, 31);
    view.defPosition("o1", 463, 591, 31, 31);
    view.defPosition("p1", 495, 591, 31, 31);
    view.defPosition("q1", 527, 591, 31, 31);
    view.defPosition("r1", 559, 591, 31, 31);
    view.defPosition("s1", 591, 591, 31, 31);
}
