ZRF = {
    JUMP:          0,
    IF:            1,
    FORK:          2,
    FUNCTION:      3,
    IN_ZONE:       4,
    FLAG:          5,
    SET_FLAG:      6,
    POS_FLAG:      7,
    SET_POS_FLAG:  8,
    ATTR:          9,
    SET_ATTR:      10,
    PROMOTE:       11,
    MODE:          12,
    ON_BOARD_DIR:  13,
    ON_BOARD_POS:  14,
    PARAM:         15,
    LITERAL:       16,
    VERIFY:        20
};

Dagaz.Model.BuildDesign = function(design) {
    design.checkVersion("z2j", "2");
    design.checkVersion("animate-captures", "false");
    design.checkVersion("smart-moves", "false");
    design.checkVersion("show-blink", "false");
    design.checkVersion("show-hints", "false");
    design.checkVersion("ko", "situation");
    design.checkVersion("advisor-wait", "25");
    design.checkVersion("ming-mang-extension", "true");

    design.addDirection("w");
    design.addDirection("e");
    design.addDirection("s");
    design.addDirection("n");

    design.addPlayer("Black", [1, 0, 3, 2]);
    design.addPlayer("White", [0, 1, 2, 3]);

    design.addPosition("a17", [0, 1, 17, 0]);
    design.addPosition("b17", [-1, 1, 17, 0]);
    design.addPosition("c17", [-1, 1, 17, 0]);
    design.addPosition("d17", [-1, 1, 17, 0]);
    design.addPosition("e17", [-1, 1, 17, 0]);
    design.addPosition("f17", [-1, 1, 17, 0]);
    design.addPosition("g17", [-1, 1, 17, 0]);
    design.addPosition("h17", [-1, 1, 17, 0]);
    design.addPosition("i17", [-1, 1, 17, 0]);
    design.addPosition("j17", [-1, 1, 17, 0]);
    design.addPosition("k17", [-1, 1, 17, 0]);
    design.addPosition("l17", [-1, 1, 17, 0]);
    design.addPosition("m17", [-1, 1, 17, 0]);
    design.addPosition("n17", [-1, 1, 17, 0]);
    design.addPosition("o17", [-1, 1, 17, 0]);
    design.addPosition("p17", [-1, 1, 17, 0]);
    design.addPosition("q17", [-1, 0, 17, 0]);
    design.addPosition("a16", [0, 1, 17, -17]);
    design.addPosition("b16", [-1, 1, 17, -17]);
    design.addPosition("c16", [-1, 1, 17, -17]);
    design.addPosition("d16", [-1, 1, 17, -17]);
    design.addPosition("e16", [-1, 1, 17, -17]);
    design.addPosition("f16", [-1, 1, 17, -17]);
    design.addPosition("g16", [-1, 1, 17, -17]);
    design.addPosition("h16", [-1, 1, 17, -17]);
    design.addPosition("i16", [-1, 1, 17, -17]);
    design.addPosition("j16", [-1, 1, 17, -17]);
    design.addPosition("k16", [-1, 1, 17, -17]);
    design.addPosition("l16", [-1, 1, 17, -17]);
    design.addPosition("m16", [-1, 1, 17, -17]);
    design.addPosition("n16", [-1, 1, 17, -17]);
    design.addPosition("o16", [-1, 1, 17, -17]);
    design.addPosition("p16", [-1, 1, 17, -17]);
    design.addPosition("q16", [-1, 0, 17, -17]);
    design.addPosition("a15", [0, 1, 17, -17]);
    design.addPosition("b15", [-1, 1, 17, -17]);
    design.addPosition("c15", [-1, 1, 17, -17]);
    design.addPosition("d15", [-1, 1, 17, -17]);
    design.addPosition("e15", [-1, 1, 17, -17]);
    design.addPosition("f15", [-1, 1, 17, -17]);
    design.addPosition("g15", [-1, 1, 17, -17]);
    design.addPosition("h15", [-1, 1, 17, -17]);
    design.addPosition("i15", [-1, 1, 17, -17]);
    design.addPosition("j15", [-1, 1, 17, -17]);
    design.addPosition("k15", [-1, 1, 17, -17]);
    design.addPosition("l15", [-1, 1, 17, -17]);
    design.addPosition("m15", [-1, 1, 17, -17]);
    design.addPosition("n15", [-1, 1, 17, -17]);
    design.addPosition("o15", [-1, 1, 17, -17]);
    design.addPosition("p15", [-1, 1, 17, -17]);
    design.addPosition("q15", [-1, 0, 17, -17]);
    design.addPosition("a14", [0, 1, 17, -17]);
    design.addPosition("b14", [-1, 1, 17, -17]);
    design.addPosition("c14", [-1, 1, 17, -17]);
    design.addPosition("d14", [-1, 1, 17, -17]);
    design.addPosition("e14", [-1, 1, 17, -17]);
    design.addPosition("f14", [-1, 1, 17, -17]);
    design.addPosition("g14", [-1, 1, 17, -17]);
    design.addPosition("h14", [-1, 1, 17, -17]);
    design.addPosition("i14", [-1, 1, 17, -17]);
    design.addPosition("j14", [-1, 1, 17, -17]);
    design.addPosition("k14", [-1, 1, 17, -17]);
    design.addPosition("l14", [-1, 1, 17, -17]);
    design.addPosition("m14", [-1, 1, 17, -17]);
    design.addPosition("n14", [-1, 1, 17, -17]);
    design.addPosition("o14", [-1, 1, 17, -17]);
    design.addPosition("p14", [-1, 1, 17, -17]);
    design.addPosition("q14", [-1, 0, 17, -17]);
    design.addPosition("a13", [0, 1, 17, -17]);
    design.addPosition("b13", [-1, 1, 17, -17]);
    design.addPosition("c13", [-1, 1, 17, -17]);
    design.addPosition("d13", [-1, 1, 17, -17]);
    design.addPosition("e13", [-1, 1, 17, -17]);
    design.addPosition("f13", [-1, 1, 17, -17]);
    design.addPosition("g13", [-1, 1, 17, -17]);
    design.addPosition("h13", [-1, 1, 17, -17]);
    design.addPosition("i13", [-1, 1, 17, -17]);
    design.addPosition("j13", [-1, 1, 17, -17]);
    design.addPosition("k13", [-1, 1, 17, -17]);
    design.addPosition("l13", [-1, 1, 17, -17]);
    design.addPosition("m13", [-1, 1, 17, -17]);
    design.addPosition("n13", [-1, 1, 17, -17]);
    design.addPosition("o13", [-1, 1, 17, -17]);
    design.addPosition("p13", [-1, 1, 17, -17]);
    design.addPosition("q13", [-1, 0, 17, -17]);
    design.addPosition("a12", [0, 1, 17, -17]);
    design.addPosition("b12", [-1, 1, 17, -17]);
    design.addPosition("c12", [-1, 1, 17, -17]);
    design.addPosition("d12", [-1, 1, 17, -17]);
    design.addPosition("e12", [-1, 1, 17, -17]);
    design.addPosition("f12", [-1, 1, 17, -17]);
    design.addPosition("g12", [-1, 1, 17, -17]);
    design.addPosition("h12", [-1, 1, 17, -17]);
    design.addPosition("i12", [-1, 1, 17, -17]);
    design.addPosition("j12", [-1, 1, 17, -17]);
    design.addPosition("k12", [-1, 1, 17, -17]);
    design.addPosition("l12", [-1, 1, 17, -17]);
    design.addPosition("m12", [-1, 1, 17, -17]);
    design.addPosition("n12", [-1, 1, 17, -17]);
    design.addPosition("o12", [-1, 1, 17, -17]);
    design.addPosition("p12", [-1, 1, 17, -17]);
    design.addPosition("q12", [-1, 0, 17, -17]);
    design.addPosition("a11", [0, 1, 17, -17]);
    design.addPosition("b11", [-1, 1, 17, -17]);
    design.addPosition("c11", [-1, 1, 17, -17]);
    design.addPosition("d11", [-1, 1, 17, -17]);
    design.addPosition("e11", [-1, 1, 17, -17]);
    design.addPosition("f11", [-1, 1, 17, -17]);
    design.addPosition("g11", [-1, 1, 17, -17]);
    design.addPosition("h11", [-1, 1, 17, -17]);
    design.addPosition("i11", [-1, 1, 17, -17]);
    design.addPosition("j11", [-1, 1, 17, -17]);
    design.addPosition("k11", [-1, 1, 17, -17]);
    design.addPosition("l11", [-1, 1, 17, -17]);
    design.addPosition("m11", [-1, 1, 17, -17]);
    design.addPosition("n11", [-1, 1, 17, -17]);
    design.addPosition("o11", [-1, 1, 17, -17]);
    design.addPosition("p11", [-1, 1, 17, -17]);
    design.addPosition("q11", [-1, 0, 17, -17]);
    design.addPosition("a10", [0, 1, 17, -17]);
    design.addPosition("b10", [-1, 1, 17, -17]);
    design.addPosition("c10", [-1, 1, 17, -17]);
    design.addPosition("d10", [-1, 1, 17, -17]);
    design.addPosition("e10", [-1, 1, 17, -17]);
    design.addPosition("f10", [-1, 1, 17, -17]);
    design.addPosition("g10", [-1, 1, 17, -17]);
    design.addPosition("h10", [-1, 1, 17, -17]);
    design.addPosition("i10", [-1, 1, 17, -17]);
    design.addPosition("j10", [-1, 1, 17, -17]);
    design.addPosition("k10", [-1, 1, 17, -17]);
    design.addPosition("l10", [-1, 1, 17, -17]);
    design.addPosition("m10", [-1, 1, 17, -17]);
    design.addPosition("n10", [-1, 1, 17, -17]);
    design.addPosition("o10", [-1, 1, 17, -17]);
    design.addPosition("p10", [-1, 1, 17, -17]);
    design.addPosition("q10", [-1, 0, 17, -17]);
    design.addPosition("a9", [0, 1, 17, -17]);
    design.addPosition("b9", [-1, 1, 17, -17]);
    design.addPosition("c9", [-1, 1, 17, -17]);
    design.addPosition("d9", [-1, 1, 17, -17]);
    design.addPosition("e9", [-1, 1, 17, -17]);
    design.addPosition("f9", [-1, 1, 17, -17]);
    design.addPosition("g9", [-1, 1, 17, -17]);
    design.addPosition("h9", [-1, 1, 17, -17]);
    design.addPosition("i9", [-1, 1, 17, -17]);
    design.addPosition("j9", [-1, 1, 17, -17]);
    design.addPosition("k9", [-1, 1, 17, -17]);
    design.addPosition("l9", [-1, 1, 17, -17]);
    design.addPosition("m9", [-1, 1, 17, -17]);
    design.addPosition("n9", [-1, 1, 17, -17]);
    design.addPosition("o9", [-1, 1, 17, -17]);
    design.addPosition("p9", [-1, 1, 17, -17]);
    design.addPosition("q9", [-1, 0, 17, -17]);
    design.addPosition("a8", [0, 1, 17, -17]);
    design.addPosition("b8", [-1, 1, 17, -17]);
    design.addPosition("c8", [-1, 1, 17, -17]);
    design.addPosition("d8", [-1, 1, 17, -17]);
    design.addPosition("e8", [-1, 1, 17, -17]);
    design.addPosition("f8", [-1, 1, 17, -17]);
    design.addPosition("g8", [-1, 1, 17, -17]);
    design.addPosition("h8", [-1, 1, 17, -17]);
    design.addPosition("i8", [-1, 1, 17, -17]);
    design.addPosition("j8", [-1, 1, 17, -17]);
    design.addPosition("k8", [-1, 1, 17, -17]);
    design.addPosition("l8", [-1, 1, 17, -17]);
    design.addPosition("m8", [-1, 1, 17, -17]);
    design.addPosition("n8", [-1, 1, 17, -17]);
    design.addPosition("o8", [-1, 1, 17, -17]);
    design.addPosition("p8", [-1, 1, 17, -17]);
    design.addPosition("q8", [-1, 0, 17, -17]);
    design.addPosition("a7", [0, 1, 17, -17]);
    design.addPosition("b7", [-1, 1, 17, -17]);
    design.addPosition("c7", [-1, 1, 17, -17]);
    design.addPosition("d7", [-1, 1, 17, -17]);
    design.addPosition("e7", [-1, 1, 17, -17]);
    design.addPosition("f7", [-1, 1, 17, -17]);
    design.addPosition("g7", [-1, 1, 17, -17]);
    design.addPosition("h7", [-1, 1, 17, -17]);
    design.addPosition("i7", [-1, 1, 17, -17]);
    design.addPosition("j7", [-1, 1, 17, -17]);
    design.addPosition("k7", [-1, 1, 17, -17]);
    design.addPosition("l7", [-1, 1, 17, -17]);
    design.addPosition("m7", [-1, 1, 17, -17]);
    design.addPosition("n7", [-1, 1, 17, -17]);
    design.addPosition("o7", [-1, 1, 17, -17]);
    design.addPosition("p7", [-1, 1, 17, -17]);
    design.addPosition("q7", [-1, 0, 17, -17]);
    design.addPosition("a6", [0, 1, 17, -17]);
    design.addPosition("b6", [-1, 1, 17, -17]);
    design.addPosition("c6", [-1, 1, 17, -17]);
    design.addPosition("d6", [-1, 1, 17, -17]);
    design.addPosition("e6", [-1, 1, 17, -17]);
    design.addPosition("f6", [-1, 1, 17, -17]);
    design.addPosition("g6", [-1, 1, 17, -17]);
    design.addPosition("h6", [-1, 1, 17, -17]);
    design.addPosition("i6", [-1, 1, 17, -17]);
    design.addPosition("j6", [-1, 1, 17, -17]);
    design.addPosition("k6", [-1, 1, 17, -17]);
    design.addPosition("l6", [-1, 1, 17, -17]);
    design.addPosition("m6", [-1, 1, 17, -17]);
    design.addPosition("n6", [-1, 1, 17, -17]);
    design.addPosition("o6", [-1, 1, 17, -17]);
    design.addPosition("p6", [-1, 1, 17, -17]);
    design.addPosition("q6", [-1, 0, 17, -17]);
    design.addPosition("a5", [0, 1, 17, -17]);
    design.addPosition("b5", [-1, 1, 17, -17]);
    design.addPosition("c5", [-1, 1, 17, -17]);
    design.addPosition("d5", [-1, 1, 17, -17]);
    design.addPosition("e5", [-1, 1, 17, -17]);
    design.addPosition("f5", [-1, 1, 17, -17]);
    design.addPosition("g5", [-1, 1, 17, -17]);
    design.addPosition("h5", [-1, 1, 17, -17]);
    design.addPosition("i5", [-1, 1, 17, -17]);
    design.addPosition("j5", [-1, 1, 17, -17]);
    design.addPosition("k5", [-1, 1, 17, -17]);
    design.addPosition("l5", [-1, 1, 17, -17]);
    design.addPosition("m5", [-1, 1, 17, -17]);
    design.addPosition("n5", [-1, 1, 17, -17]);
    design.addPosition("o5", [-1, 1, 17, -17]);
    design.addPosition("p5", [-1, 1, 17, -17]);
    design.addPosition("q5", [-1, 0, 17, -17]);
    design.addPosition("a4", [0, 1, 17, -17]);
    design.addPosition("b4", [-1, 1, 17, -17]);
    design.addPosition("c4", [-1, 1, 17, -17]);
    design.addPosition("d4", [-1, 1, 17, -17]);
    design.addPosition("e4", [-1, 1, 17, -17]);
    design.addPosition("f4", [-1, 1, 17, -17]);
    design.addPosition("g4", [-1, 1, 17, -17]);
    design.addPosition("h4", [-1, 1, 17, -17]);
    design.addPosition("i4", [-1, 1, 17, -17]);
    design.addPosition("j4", [-1, 1, 17, -17]);
    design.addPosition("k4", [-1, 1, 17, -17]);
    design.addPosition("l4", [-1, 1, 17, -17]);
    design.addPosition("m4", [-1, 1, 17, -17]);
    design.addPosition("n4", [-1, 1, 17, -17]);
    design.addPosition("o4", [-1, 1, 17, -17]);
    design.addPosition("p4", [-1, 1, 17, -17]);
    design.addPosition("q4", [-1, 0, 17, -17]);
    design.addPosition("a3", [0, 1, 17, -17]);
    design.addPosition("b3", [-1, 1, 17, -17]);
    design.addPosition("c3", [-1, 1, 17, -17]);
    design.addPosition("d3", [-1, 1, 17, -17]);
    design.addPosition("e3", [-1, 1, 17, -17]);
    design.addPosition("f3", [-1, 1, 17, -17]);
    design.addPosition("g3", [-1, 1, 17, -17]);
    design.addPosition("h3", [-1, 1, 17, -17]);
    design.addPosition("i3", [-1, 1, 17, -17]);
    design.addPosition("j3", [-1, 1, 17, -17]);
    design.addPosition("k3", [-1, 1, 17, -17]);
    design.addPosition("l3", [-1, 1, 17, -17]);
    design.addPosition("m3", [-1, 1, 17, -17]);
    design.addPosition("n3", [-1, 1, 17, -17]);
    design.addPosition("o3", [-1, 1, 17, -17]);
    design.addPosition("p3", [-1, 1, 17, -17]);
    design.addPosition("q3", [-1, 0, 17, -17]);
    design.addPosition("a2", [0, 1, 17, -17]);
    design.addPosition("b2", [-1, 1, 17, -17]);
    design.addPosition("c2", [-1, 1, 17, -17]);
    design.addPosition("d2", [-1, 1, 17, -17]);
    design.addPosition("e2", [-1, 1, 17, -17]);
    design.addPosition("f2", [-1, 1, 17, -17]);
    design.addPosition("g2", [-1, 1, 17, -17]);
    design.addPosition("h2", [-1, 1, 17, -17]);
    design.addPosition("i2", [-1, 1, 17, -17]);
    design.addPosition("j2", [-1, 1, 17, -17]);
    design.addPosition("k2", [-1, 1, 17, -17]);
    design.addPosition("l2", [-1, 1, 17, -17]);
    design.addPosition("m2", [-1, 1, 17, -17]);
    design.addPosition("n2", [-1, 1, 17, -17]);
    design.addPosition("o2", [-1, 1, 17, -17]);
    design.addPosition("p2", [-1, 1, 17, -17]);
    design.addPosition("q2", [-1, 0, 17, -17]);
    design.addPosition("a1", [0, 1, 0, -17]);
    design.addPosition("b1", [-1, 1, 0, -17]);
    design.addPosition("c1", [-1, 1, 0, -17]);
    design.addPosition("d1", [-1, 1, 0, -17]);
    design.addPosition("e1", [-1, 1, 0, -17]);
    design.addPosition("f1", [-1, 1, 0, -17]);
    design.addPosition("g1", [-1, 1, 0, -17]);
    design.addPosition("h1", [-1, 1, 0, -17]);
    design.addPosition("i1", [-1, 1, 0, -17]);
    design.addPosition("j1", [-1, 1, 0, -17]);
    design.addPosition("k1", [-1, 1, 0, -17]);
    design.addPosition("l1", [-1, 1, 0, -17]);
    design.addPosition("m1", [-1, 1, 0, -17]);
    design.addPosition("n1", [-1, 1, 0, -17]);
    design.addPosition("o1", [-1, 1, 0, -17]);
    design.addPosition("p1", [-1, 1, 0, -17]);
    design.addPosition("q1", [-1, 0, 0, -17]);

    design.addCommand(0, ZRF.FUNCTION,	24);	// from
    design.addCommand(0, ZRF.PARAM,	0);	// $1
    design.addCommand(0, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(0, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(0, ZRF.FUNCTION,	0);	// not
    design.addCommand(0, ZRF.IF,	7);
    design.addCommand(0, ZRF.FORK,	3);
    design.addCommand(0, ZRF.FUNCTION,	25);	// to
    design.addCommand(0, ZRF.FUNCTION,	28);	// end
    design.addCommand(0, ZRF.PARAM,	1);	// $2
    design.addCommand(0, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(0, ZRF.JUMP,	-8);
    design.addCommand(0, ZRF.FUNCTION,	28);	// end

    design.addPiece("Stone", 0, 2);
    design.addMove(0, 0, [3, 3], 0);
    design.addMove(0, 0, [2, 2], 0);
    design.addMove(0, 0, [1, 1], 0);
    design.addMove(0, 0, [0, 0], 0);

    design.setup("White", "Stone", 255);
    design.setup("White", "Stone", 238);
    design.setup("White", "Stone", 221);
    design.setup("White", "Stone", 204);
    design.setup("White", "Stone", 187);
    design.setup("White", "Stone", 170);
    design.setup("White", "Stone", 153);
    design.setup("White", "Stone", 136);
    design.setup("White", "Stone", 119);
    design.setup("White", "Stone", 102);
    design.setup("White", "Stone", 85);
    design.setup("White", "Stone", 68);
    design.setup("White", "Stone", 51);
    design.setup("White", "Stone", 34);
    design.setup("White", "Stone", 17);
    design.setup("White", "Stone", 0);
    design.setup("White", "Stone", 1);
    design.setup("White", "Stone", 2);
    design.setup("White", "Stone", 3);
    design.setup("White", "Stone", 4);
    design.setup("White", "Stone", 5);
    design.setup("White", "Stone", 6);
    design.setup("White", "Stone", 7);
    design.setup("White", "Stone", 8);
    design.setup("White", "Stone", 9);
    design.setup("White", "Stone", 10);
    design.setup("White", "Stone", 11);
    design.setup("White", "Stone", 12);
    design.setup("White", "Stone", 13);
    design.setup("White", "Stone", 14);
    design.setup("White", "Stone", 15);
    design.setup("White", "Stone", 16);
    design.setup("Black", "Stone", 272);
    design.setup("Black", "Stone", 273);
    design.setup("Black", "Stone", 274);
    design.setup("Black", "Stone", 275);
    design.setup("Black", "Stone", 276);
    design.setup("Black", "Stone", 277);
    design.setup("Black", "Stone", 278);
    design.setup("Black", "Stone", 279);
    design.setup("Black", "Stone", 280);
    design.setup("Black", "Stone", 281);
    design.setup("Black", "Stone", 282);
    design.setup("Black", "Stone", 283);
    design.setup("Black", "Stone", 284);
    design.setup("Black", "Stone", 285);
    design.setup("Black", "Stone", 286);
    design.setup("Black", "Stone", 287);
    design.setup("Black", "Stone", 288);
    design.setup("Black", "Stone", 271);
    design.setup("Black", "Stone", 254);
    design.setup("Black", "Stone", 237);
    design.setup("Black", "Stone", 220);
    design.setup("Black", "Stone", 203);
    design.setup("Black", "Stone", 186);
    design.setup("Black", "Stone", 169);
    design.setup("Black", "Stone", 152);
    design.setup("Black", "Stone", 135);
    design.setup("Black", "Stone", 118);
    design.setup("Black", "Stone", 101);
    design.setup("Black", "Stone", 84);
    design.setup("Black", "Stone", 67);
    design.setup("Black", "Stone", 50);
    design.setup("Black", "Stone", 33);
}

Dagaz.View.configure = function(view) {
    view.defBoard("Board");
    view.defPiece("WhiteStone", "White Stone");
    view.defPiece("BlackStone", "Black Stone");
 
    view.defPosition("a17", 6, 5, 31, 31);
    view.defPosition("b17", 37, 5, 31, 31);
    view.defPosition("c17", 68, 5, 31, 31);
    view.defPosition("d17", 99, 5, 31, 31);
    view.defPosition("e17", 130, 5, 31, 31);
    view.defPosition("f17", 161, 5, 31, 31);
    view.defPosition("g17", 192, 5, 31, 31);
    view.defPosition("h17", 223, 5, 31, 31);
    view.defPosition("i17", 254, 5, 31, 31);
    view.defPosition("j17", 285, 5, 31, 31);
    view.defPosition("k17", 316, 5, 31, 31);
    view.defPosition("l17", 347, 5, 31, 31);
    view.defPosition("m17", 378, 5, 31, 31);
    view.defPosition("n17", 409, 5, 31, 31);
    view.defPosition("o17", 440, 5, 31, 31);
    view.defPosition("p17", 471, 5, 31, 31);
    view.defPosition("q17", 502, 5, 31, 31);
    view.defPosition("a16", 6, 36, 31, 31);
    view.defPosition("b16", 37, 36, 31, 31);
    view.defPosition("c16", 68, 36, 31, 31);
    view.defPosition("d16", 99, 36, 31, 31);
    view.defPosition("e16", 130, 36, 31, 31);
    view.defPosition("f16", 161, 36, 31, 31);
    view.defPosition("g16", 192, 36, 31, 31);
    view.defPosition("h16", 223, 36, 31, 31);
    view.defPosition("i16", 254, 36, 31, 31);
    view.defPosition("j16", 285, 36, 31, 31);
    view.defPosition("k16", 316, 36, 31, 31);
    view.defPosition("l16", 347, 36, 31, 31);
    view.defPosition("m16", 378, 36, 31, 31);
    view.defPosition("n16", 409, 36, 31, 31);
    view.defPosition("o16", 440, 36, 31, 31);
    view.defPosition("p16", 471, 36, 31, 31);
    view.defPosition("q16", 502, 36, 31, 31);
    view.defPosition("a15", 6, 67, 31, 31);
    view.defPosition("b15", 37, 67, 31, 31);
    view.defPosition("c15", 68, 67, 31, 31);
    view.defPosition("d15", 99, 67, 31, 31);
    view.defPosition("e15", 130, 67, 31, 31);
    view.defPosition("f15", 161, 67, 31, 31);
    view.defPosition("g15", 192, 67, 31, 31);
    view.defPosition("h15", 223, 67, 31, 31);
    view.defPosition("i15", 254, 67, 31, 31);
    view.defPosition("j15", 285, 67, 31, 31);
    view.defPosition("k15", 316, 67, 31, 31);
    view.defPosition("l15", 347, 67, 31, 31);
    view.defPosition("m15", 378, 67, 31, 31);
    view.defPosition("n15", 409, 67, 31, 31);
    view.defPosition("o15", 440, 67, 31, 31);
    view.defPosition("p15", 471, 67, 31, 31);
    view.defPosition("q15", 502, 67, 31, 31);
    view.defPosition("a14", 6, 98, 31, 31);
    view.defPosition("b14", 37, 98, 31, 31);
    view.defPosition("c14", 68, 98, 31, 31);
    view.defPosition("d14", 99, 98, 31, 31);
    view.defPosition("e14", 130, 98, 31, 31);
    view.defPosition("f14", 161, 98, 31, 31);
    view.defPosition("g14", 192, 98, 31, 31);
    view.defPosition("h14", 223, 98, 31, 31);
    view.defPosition("i14", 254, 98, 31, 31);
    view.defPosition("j14", 285, 98, 31, 31);
    view.defPosition("k14", 316, 98, 31, 31);
    view.defPosition("l14", 347, 98, 31, 31);
    view.defPosition("m14", 378, 98, 31, 31);
    view.defPosition("n14", 409, 98, 31, 31);
    view.defPosition("o14", 440, 98, 31, 31);
    view.defPosition("p14", 471, 98, 31, 31);
    view.defPosition("q14", 502, 98, 31, 31);
    view.defPosition("a13", 6, 129, 31, 31);
    view.defPosition("b13", 37, 129, 31, 31);
    view.defPosition("c13", 68, 129, 31, 31);
    view.defPosition("d13", 99, 129, 31, 31);
    view.defPosition("e13", 130, 129, 31, 31);
    view.defPosition("f13", 161, 129, 31, 31);
    view.defPosition("g13", 192, 129, 31, 31);
    view.defPosition("h13", 223, 129, 31, 31);
    view.defPosition("i13", 254, 129, 31, 31);
    view.defPosition("j13", 285, 129, 31, 31);
    view.defPosition("k13", 316, 129, 31, 31);
    view.defPosition("l13", 347, 129, 31, 31);
    view.defPosition("m13", 378, 129, 31, 31);
    view.defPosition("n13", 409, 129, 31, 31);
    view.defPosition("o13", 440, 129, 31, 31);
    view.defPosition("p13", 471, 129, 31, 31);
    view.defPosition("q13", 502, 129, 31, 31);
    view.defPosition("a12", 6, 160, 31, 31);
    view.defPosition("b12", 37, 160, 31, 31);
    view.defPosition("c12", 68, 160, 31, 31);
    view.defPosition("d12", 99, 160, 31, 31);
    view.defPosition("e12", 130, 160, 31, 31);
    view.defPosition("f12", 161, 160, 31, 31);
    view.defPosition("g12", 192, 160, 31, 31);
    view.defPosition("h12", 223, 160, 31, 31);
    view.defPosition("i12", 254, 160, 31, 31);
    view.defPosition("j12", 285, 160, 31, 31);
    view.defPosition("k12", 316, 160, 31, 31);
    view.defPosition("l12", 347, 160, 31, 31);
    view.defPosition("m12", 378, 160, 31, 31);
    view.defPosition("n12", 409, 160, 31, 31);
    view.defPosition("o12", 440, 160, 31, 31);
    view.defPosition("p12", 471, 160, 31, 31);
    view.defPosition("q12", 502, 160, 31, 31);
    view.defPosition("a11", 6, 191, 31, 31);
    view.defPosition("b11", 37, 191, 31, 31);
    view.defPosition("c11", 68, 191, 31, 31);
    view.defPosition("d11", 99, 191, 31, 31);
    view.defPosition("e11", 130, 191, 31, 31);
    view.defPosition("f11", 161, 191, 31, 31);
    view.defPosition("g11", 192, 191, 31, 31);
    view.defPosition("h11", 223, 191, 31, 31);
    view.defPosition("i11", 254, 191, 31, 31);
    view.defPosition("j11", 285, 191, 31, 31);
    view.defPosition("k11", 316, 191, 31, 31);
    view.defPosition("l11", 347, 191, 31, 31);
    view.defPosition("m11", 378, 191, 31, 31);
    view.defPosition("n11", 409, 191, 31, 31);
    view.defPosition("o11", 440, 191, 31, 31);
    view.defPosition("p11", 471, 191, 31, 31);
    view.defPosition("q11", 502, 191, 31, 31);
    view.defPosition("a10", 6, 222, 31, 31);
    view.defPosition("b10", 37, 222, 31, 31);
    view.defPosition("c10", 68, 222, 31, 31);
    view.defPosition("d10", 99, 222, 31, 31);
    view.defPosition("e10", 130, 222, 31, 31);
    view.defPosition("f10", 161, 222, 31, 31);
    view.defPosition("g10", 192, 222, 31, 31);
    view.defPosition("h10", 223, 222, 31, 31);
    view.defPosition("i10", 254, 222, 31, 31);
    view.defPosition("j10", 285, 222, 31, 31);
    view.defPosition("k10", 316, 222, 31, 31);
    view.defPosition("l10", 347, 222, 31, 31);
    view.defPosition("m10", 378, 222, 31, 31);
    view.defPosition("n10", 409, 222, 31, 31);
    view.defPosition("o10", 440, 222, 31, 31);
    view.defPosition("p10", 471, 222, 31, 31);
    view.defPosition("q10", 502, 222, 31, 31);
    view.defPosition("a9", 6, 253, 31, 31);
    view.defPosition("b9", 37, 253, 31, 31);
    view.defPosition("c9", 68, 253, 31, 31);
    view.defPosition("d9", 99, 253, 31, 31);
    view.defPosition("e9", 130, 253, 31, 31);
    view.defPosition("f9", 161, 253, 31, 31);
    view.defPosition("g9", 192, 253, 31, 31);
    view.defPosition("h9", 223, 253, 31, 31);
    view.defPosition("i9", 254, 253, 31, 31);
    view.defPosition("j9", 285, 253, 31, 31);
    view.defPosition("k9", 316, 253, 31, 31);
    view.defPosition("l9", 347, 253, 31, 31);
    view.defPosition("m9", 378, 253, 31, 31);
    view.defPosition("n9", 409, 253, 31, 31);
    view.defPosition("o9", 440, 253, 31, 31);
    view.defPosition("p9", 471, 253, 31, 31);
    view.defPosition("q9", 502, 253, 31, 31);
    view.defPosition("a8", 6, 284, 31, 31);
    view.defPosition("b8", 37, 284, 31, 31);
    view.defPosition("c8", 68, 284, 31, 31);
    view.defPosition("d8", 99, 284, 31, 31);
    view.defPosition("e8", 130, 284, 31, 31);
    view.defPosition("f8", 161, 284, 31, 31);
    view.defPosition("g8", 192, 284, 31, 31);
    view.defPosition("h8", 223, 284, 31, 31);
    view.defPosition("i8", 254, 284, 31, 31);
    view.defPosition("j8", 285, 284, 31, 31);
    view.defPosition("k8", 316, 284, 31, 31);
    view.defPosition("l8", 347, 284, 31, 31);
    view.defPosition("m8", 378, 284, 31, 31);
    view.defPosition("n8", 409, 284, 31, 31);
    view.defPosition("o8", 440, 284, 31, 31);
    view.defPosition("p8", 471, 284, 31, 31);
    view.defPosition("q8", 502, 284, 31, 31);
    view.defPosition("a7", 6, 315, 31, 31);
    view.defPosition("b7", 37, 315, 31, 31);
    view.defPosition("c7", 68, 315, 31, 31);
    view.defPosition("d7", 99, 315, 31, 31);
    view.defPosition("e7", 130, 315, 31, 31);
    view.defPosition("f7", 161, 315, 31, 31);
    view.defPosition("g7", 192, 315, 31, 31);
    view.defPosition("h7", 223, 315, 31, 31);
    view.defPosition("i7", 254, 315, 31, 31);
    view.defPosition("j7", 285, 315, 31, 31);
    view.defPosition("k7", 316, 315, 31, 31);
    view.defPosition("l7", 347, 315, 31, 31);
    view.defPosition("m7", 378, 315, 31, 31);
    view.defPosition("n7", 409, 315, 31, 31);
    view.defPosition("o7", 440, 315, 31, 31);
    view.defPosition("p7", 471, 315, 31, 31);
    view.defPosition("q7", 502, 315, 31, 31);
    view.defPosition("a6", 6, 346, 31, 31);
    view.defPosition("b6", 37, 346, 31, 31);
    view.defPosition("c6", 68, 346, 31, 31);
    view.defPosition("d6", 99, 346, 31, 31);
    view.defPosition("e6", 130, 346, 31, 31);
    view.defPosition("f6", 161, 346, 31, 31);
    view.defPosition("g6", 192, 346, 31, 31);
    view.defPosition("h6", 223, 346, 31, 31);
    view.defPosition("i6", 254, 346, 31, 31);
    view.defPosition("j6", 285, 346, 31, 31);
    view.defPosition("k6", 316, 346, 31, 31);
    view.defPosition("l6", 347, 346, 31, 31);
    view.defPosition("m6", 378, 346, 31, 31);
    view.defPosition("n6", 409, 346, 31, 31);
    view.defPosition("o6", 440, 346, 31, 31);
    view.defPosition("p6", 471, 346, 31, 31);
    view.defPosition("q6", 502, 346, 31, 31);
    view.defPosition("a5", 6, 377, 31, 31);
    view.defPosition("b5", 37, 377, 31, 31);
    view.defPosition("c5", 68, 377, 31, 31);
    view.defPosition("d5", 99, 377, 31, 31);
    view.defPosition("e5", 130, 377, 31, 31);
    view.defPosition("f5", 161, 377, 31, 31);
    view.defPosition("g5", 192, 377, 31, 31);
    view.defPosition("h5", 223, 377, 31, 31);
    view.defPosition("i5", 254, 377, 31, 31);
    view.defPosition("j5", 285, 377, 31, 31);
    view.defPosition("k5", 316, 377, 31, 31);
    view.defPosition("l5", 347, 377, 31, 31);
    view.defPosition("m5", 378, 377, 31, 31);
    view.defPosition("n5", 409, 377, 31, 31);
    view.defPosition("o5", 440, 377, 31, 31);
    view.defPosition("p5", 471, 377, 31, 31);
    view.defPosition("q5", 502, 377, 31, 31);
    view.defPosition("a4", 6, 408, 31, 31);
    view.defPosition("b4", 37, 408, 31, 31);
    view.defPosition("c4", 68, 408, 31, 31);
    view.defPosition("d4", 99, 408, 31, 31);
    view.defPosition("e4", 130, 408, 31, 31);
    view.defPosition("f4", 161, 408, 31, 31);
    view.defPosition("g4", 192, 408, 31, 31);
    view.defPosition("h4", 223, 408, 31, 31);
    view.defPosition("i4", 254, 408, 31, 31);
    view.defPosition("j4", 285, 408, 31, 31);
    view.defPosition("k4", 316, 408, 31, 31);
    view.defPosition("l4", 347, 408, 31, 31);
    view.defPosition("m4", 378, 408, 31, 31);
    view.defPosition("n4", 409, 408, 31, 31);
    view.defPosition("o4", 440, 408, 31, 31);
    view.defPosition("p4", 471, 408, 31, 31);
    view.defPosition("q4", 502, 408, 31, 31);
    view.defPosition("a3", 6, 439, 31, 31);
    view.defPosition("b3", 37, 439, 31, 31);
    view.defPosition("c3", 68, 439, 31, 31);
    view.defPosition("d3", 99, 439, 31, 31);
    view.defPosition("e3", 130, 439, 31, 31);
    view.defPosition("f3", 161, 439, 31, 31);
    view.defPosition("g3", 192, 439, 31, 31);
    view.defPosition("h3", 223, 439, 31, 31);
    view.defPosition("i3", 254, 439, 31, 31);
    view.defPosition("j3", 285, 439, 31, 31);
    view.defPosition("k3", 316, 439, 31, 31);
    view.defPosition("l3", 347, 439, 31, 31);
    view.defPosition("m3", 378, 439, 31, 31);
    view.defPosition("n3", 409, 439, 31, 31);
    view.defPosition("o3", 440, 439, 31, 31);
    view.defPosition("p3", 471, 439, 31, 31);
    view.defPosition("q3", 502, 439, 31, 31);
    view.defPosition("a2", 6, 470, 31, 31);
    view.defPosition("b2", 37, 470, 31, 31);
    view.defPosition("c2", 68, 470, 31, 31);
    view.defPosition("d2", 99, 470, 31, 31);
    view.defPosition("e2", 130, 470, 31, 31);
    view.defPosition("f2", 161, 470, 31, 31);
    view.defPosition("g2", 192, 470, 31, 31);
    view.defPosition("h2", 223, 470, 31, 31);
    view.defPosition("i2", 254, 470, 31, 31);
    view.defPosition("j2", 285, 470, 31, 31);
    view.defPosition("k2", 316, 470, 31, 31);
    view.defPosition("l2", 347, 470, 31, 31);
    view.defPosition("m2", 378, 470, 31, 31);
    view.defPosition("n2", 409, 470, 31, 31);
    view.defPosition("o2", 440, 470, 31, 31);
    view.defPosition("p2", 471, 470, 31, 31);
    view.defPosition("q2", 502, 470, 31, 31);
    view.defPosition("a1", 6, 501, 31, 31);
    view.defPosition("b1", 37, 501, 31, 31);
    view.defPosition("c1", 68, 501, 31, 31);
    view.defPosition("d1", 99, 501, 31, 31);
    view.defPosition("e1", 130, 501, 31, 31);
    view.defPosition("f1", 161, 501, 31, 31);
    view.defPosition("g1", 192, 501, 31, 31);
    view.defPosition("h1", 223, 501, 31, 31);
    view.defPosition("i1", 254, 501, 31, 31);
    view.defPosition("j1", 285, 501, 31, 31);
    view.defPosition("k1", 316, 501, 31, 31);
    view.defPosition("l1", 347, 501, 31, 31);
    view.defPosition("m1", 378, 501, 31, 31);
    view.defPosition("n1", 409, 501, 31, 31);
    view.defPosition("o1", 440, 501, 31, 31);
    view.defPosition("p1", 471, 501, 31, 31);
    view.defPosition("q1", 502, 501, 31, 31);
}
