ZRF = {
    JUMP:          0,
    IF:            1,
    FORK:          2,
    FUNCTION:      3,
    IN_ZONE:       4,
    FLAG:          5,
    SET_FLAG:      6,
    POS_FLAG:      7,
    SET_POS_FLAG:  8,
    ATTR:          9,
    SET_ATTR:      10,
    PROMOTE:       11,
    MODE:          12,
    ON_BOARD_DIR:  13,
    ON_BOARD_POS:  14,
    PARAM:         15,
    LITERAL:       16,
    VERIFY:        20
};

Dagaz.Model.BuildDesign = function(design) {
    design.checkVersion("z2j", "2");
    design.checkVersion("animate-captures", "false");
    design.checkVersion("animate-drops", "false");
    design.checkVersion("smart-moves", "false");
    design.checkVersion("shared-pieces", "true");
    design.checkVersion("show-blink", "false");
    design.checkVersion("show-hints", "false");
    design.checkVersion("show-captures", "false");

    design.addDirection("w");
    design.addDirection("e");
    design.addDirection("s");
    design.addDirection("ne");
    design.addDirection("n");
    design.addDirection("se");
    design.addDirection("sw");
    design.addDirection("nw");

    design.addPlayer("Black", [1, 0, 4, 6, 2, 7, 3, 5]);
    design.addPlayer("White", [0, 1, 2, 3, 4, 5, 6, 7]);

    design.addPosition("x19", [0, 1, 20, 0, 0, 21, 0, 0]);
    design.addPosition("a19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("b19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("c19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("d19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("e19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("f19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("g19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("h19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("i19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("j19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("k19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("l19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("m19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("n19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("o19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("p19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("q19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("r19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("y19", [-1, 0, 20, 0, 0, 0, 19, 0]);
    design.addPosition("x18", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("a18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("b18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("c18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("d18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("e18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("f18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("g18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("h18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("i18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("j18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("k18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("l18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("m18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("n18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("o18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("p18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("q18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("r18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("y18", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("x17", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("a17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("b17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("c17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("d17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("e17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("f17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("g17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("h17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("i17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("j17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("k17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("l17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("m17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("n17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("o17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("p17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("q17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("r17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("y17", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("x16", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("a16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("b16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("c16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("d16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("e16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("f16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("g16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("h16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("i16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("j16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("k16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("l16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("m16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("n16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("o16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("p16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("q16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("r16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("y16", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("x15", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("a15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("b15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("c15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("d15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("e15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("f15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("g15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("h15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("i15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("j15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("k15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("l15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("m15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("n15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("o15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("p15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("q15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("r15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("y15", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("x14", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("a14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("b14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("c14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("d14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("e14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("f14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("g14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("h14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("i14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("j14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("k14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("l14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("m14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("n14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("o14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("p14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("q14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("r14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("y14", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("x13", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("a13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("b13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("c13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("d13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("e13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("f13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("g13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("h13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("i13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("j13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("k13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("l13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("m13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("n13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("o13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("p13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("q13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("r13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("y13", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("x12", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("a12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("b12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("c12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("d12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("e12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("f12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("g12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("h12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("i12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("j12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("k12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("l12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("m12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("n12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("o12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("p12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("q12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("r12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("y12", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("x11", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("a11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("b11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("c11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("d11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("e11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("f11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("g11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("h11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("i11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("j11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("k11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("l11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("m11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("n11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("o11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("p11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("q11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("r11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("y11", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("x10", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("a10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("b10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("c10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("d10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("e10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("f10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("g10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("h10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("i10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("j10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("k10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("l10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("m10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("n10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("o10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("p10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("q10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("r10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("y10", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("x9", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("a9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("b9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("c9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("d9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("e9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("f9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("g9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("h9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("i9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("j9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("k9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("l9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("m9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("n9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("o9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("p9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("q9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("r9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("y9", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("x8", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("a8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("b8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("c8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("d8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("e8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("f8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("g8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("h8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("i8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("j8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("k8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("l8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("m8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("n8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("o8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("p8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("q8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("r8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("y8", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("x7", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("a7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("b7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("c7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("d7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("e7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("f7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("g7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("h7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("i7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("j7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("k7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("l7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("m7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("n7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("o7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("p7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("q7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("r7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("y7", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("x6", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("a6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("b6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("c6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("d6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("e6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("f6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("g6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("h6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("i6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("j6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("k6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("l6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("m6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("n6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("o6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("p6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("q6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("r6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("y6", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("x5", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("a5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("b5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("c5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("d5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("e5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("f5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("g5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("h5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("i5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("j5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("k5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("l5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("m5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("n5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("o5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("p5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("q5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("r5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("y5", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("x4", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("a4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("b4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("c4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("d4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("e4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("f4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("g4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("h4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("i4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("j4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("k4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("l4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("m4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("n4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("o4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("p4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("q4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("r4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("y4", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("x3", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("a3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("b3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("c3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("d3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("e3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("f3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("g3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("h3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("i3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("j3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("k3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("l3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("m3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("n3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("o3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("p3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("q3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("r3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("y3", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("x2", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("a2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("b2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("c2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("d2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("e2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("f2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("g2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("h2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("i2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("j2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("k2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("l2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("m2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("n2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("o2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("p2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("q2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("r2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("y2", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("x1", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("a1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("b1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("c1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("d1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("e1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("f1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("g1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("h1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("i1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("j1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("k1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("l1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("m1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("n1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("o1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("p1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("q1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("r1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("y1", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("x0", [0, 1, 0, -19, -20, 0, 0, 0]);
    design.addPosition("a0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("b0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("c0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("d0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("e0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("f0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("g0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("h0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("i0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("j0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("k0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("l0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("m0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("n0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("o0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("p0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("q0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("r0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("y0", [-1, 0, 0, 0, -20, 0, 0, -21]);
    design.addPosition("X19", [0, 1, 20, 0, 0, 21, 0, 0]);
    design.addPosition("A19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("B19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("C19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("D19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("E19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("F19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("G19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("H19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("I19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("J19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("K19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("L19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("M19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("N19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("O19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("P19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("Q19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("R19", [-1, 1, 20, 0, 0, 21, 19, 0]);
    design.addPosition("Y19", [-1, 0, 20, 0, 0, 0, 19, 0]);
    design.addPosition("X18", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("A18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("B18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("C18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("D18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("E18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("F18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("G18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("H18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("I18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("J18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("K18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("L18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("M18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("N18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("O18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("P18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Q18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("R18", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Y18", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("X17", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("A17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("B17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("C17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("D17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("E17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("F17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("G17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("H17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("I17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("J17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("K17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("L17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("M17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("N17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("O17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("P17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Q17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("R17", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Y17", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("X16", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("A16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("B16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("C16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("D16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("E16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("F16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("G16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("H16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("I16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("J16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("K16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("L16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("M16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("N16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("O16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("P16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Q16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("R16", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Y16", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("X15", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("A15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("B15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("C15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("D15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("E15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("F15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("G15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("H15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("I15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("J15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("K15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("L15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("M15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("N15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("O15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("P15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Q15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("R15", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Y15", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("X14", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("A14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("B14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("C14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("D14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("E14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("F14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("G14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("H14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("I14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("J14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("K14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("L14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("M14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("N14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("O14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("P14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Q14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("R14", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Y14", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("X13", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("A13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("B13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("C13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("D13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("E13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("F13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("G13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("H13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("I13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("J13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("K13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("L13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("M13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("N13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("O13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("P13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Q13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("R13", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Y13", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("X12", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("A12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("B12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("C12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("D12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("E12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("F12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("G12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("H12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("I12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("J12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("K12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("L12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("M12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("N12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("O12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("P12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Q12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("R12", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Y12", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("X11", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("A11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("B11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("C11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("D11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("E11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("F11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("G11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("H11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("I11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("J11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("K11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("L11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("M11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("N11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("O11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("P11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Q11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("R11", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Y11", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("X10", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("A10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("B10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("C10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("D10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("E10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("F10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("G10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("H10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("I10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("J10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("K10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("L10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("M10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("N10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("O10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("P10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Q10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("R10", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Y10", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("X9", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("A9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("B9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("C9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("D9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("E9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("F9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("G9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("H9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("I9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("J9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("K9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("L9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("M9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("N9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("O9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("P9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Q9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("R9", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Y9", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("X8", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("A8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("B8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("C8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("D8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("E8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("F8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("G8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("H8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("I8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("J8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("K8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("L8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("M8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("N8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("O8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("P8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Q8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("R8", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Y8", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("X7", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("A7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("B7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("C7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("D7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("E7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("F7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("G7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("H7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("I7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("J7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("K7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("L7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("M7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("N7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("O7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("P7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Q7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("R7", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Y7", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("X6", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("A6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("B6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("C6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("D6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("E6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("F6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("G6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("H6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("I6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("J6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("K6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("L6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("M6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("N6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("O6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("P6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Q6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("R6", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Y6", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("X5", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("A5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("B5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("C5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("D5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("E5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("F5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("G5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("H5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("I5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("J5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("K5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("L5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("M5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("N5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("O5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("P5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Q5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("R5", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Y5", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("X4", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("A4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("B4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("C4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("D4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("E4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("F4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("G4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("H4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("I4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("J4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("K4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("L4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("M4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("N4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("O4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("P4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Q4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("R4", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Y4", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("X3", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("A3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("B3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("C3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("D3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("E3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("F3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("G3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("H3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("I3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("J3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("K3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("L3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("M3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("N3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("O3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("P3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Q3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("R3", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Y3", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("X2", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("A2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("B2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("C2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("D2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("E2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("F2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("G2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("H2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("I2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("J2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("K2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("L2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("M2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("N2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("O2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("P2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Q2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("R2", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Y2", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("X1", [0, 1, 20, -19, -20, 21, 0, 0]);
    design.addPosition("A1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("B1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("C1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("D1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("E1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("F1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("G1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("H1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("I1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("J1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("K1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("L1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("M1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("N1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("O1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("P1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Q1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("R1", [-1, 1, 20, -19, -20, 21, 19, -21]);
    design.addPosition("Y1", [-1, 0, 20, 0, -20, 0, 19, -21]);
    design.addPosition("X0", [0, 1, 0, -19, -20, 0, 0, 0]);
    design.addPosition("A0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("B0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("C0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("D0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("E0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("F0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("G0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("H0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("I0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("J0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("K0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("L0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("M0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("N0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("O0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("P0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("Q0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("R0", [-1, 1, 0, -19, -20, 0, 0, -21]);
    design.addPosition("Y0", [-1, 0, 0, 0, -20, 0, 0, -21]);

    design.addZone("edge", 2, [0, 20, 40, 60, 80, 100, 120, 140, 160, 180, 200, 220, 240, 260, 280, 300, 320, 340, 360, 380, 19, 39, 59, 79, 99, 119, 139, 159, 179, 199, 219, 239, 259, 279, 299, 319, 339, 359, 379, 399, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 381, 382, 383, 384, 385, 386, 387, 388, 389, 390, 391, 392, 393, 394, 395, 396, 397, 398]);
    design.addZone("edge", 1, [0, 20, 40, 60, 80, 100, 120, 140, 160, 180, 200, 220, 240, 260, 280, 300, 320, 340, 360, 380, 19, 39, 59, 79, 99, 119, 139, 159, 179, 199, 219, 239, 259, 279, 299, 319, 339, 359, 379, 399, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 381, 382, 383, 384, 385, 386, 387, 388, 389, 390, 391, 392, 393, 394, 395, 396, 397, 398]);

    design.addCommand(0, ZRF.FUNCTION,	24);	// from
    design.addCommand(0, ZRF.LITERAL,	1);	// Handle
    design.addCommand(0, ZRF.FUNCTION,	11);	// create
    design.addCommand(0, ZRF.PARAM,	0);	// $1
    design.addCommand(0, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(0, ZRF.FUNCTION,	25);	// to
    design.addCommand(0, ZRF.FUNCTION,	28);	// end

    design.addPiece("Stone", 0);

    design.addPiece("Handle", 1);
    design.addMove(1, 0, [4], 0);
    design.addMove(1, 0, [7], 0);
    design.addMove(1, 0, [0], 0);
    design.addMove(1, 0, [6], 0);
    design.addMove(1, 0, [2], 0);
    design.addMove(1, 0, [5], 0);
    design.addMove(1, 0, [1], 0);
    design.addMove(1, 0, [3], 0);

    design.setup("Black", "Stone", 341);
    design.setup("Black", "Stone", 362);
    design.setup("Black", "Stone", 342);
    design.setup("Black", "Stone", 322);
    design.setup("Black", "Stone", 262);
    design.setup("Black", "Stone", 343);
    design.setup("Black", "Stone", 364);
    design.setup("Black", "Stone", 324);
    design.setup("Black", "Stone", 345);
    design.setup("Black", "Stone", 265);
    design.setup("Black", "Stone", 366);
    design.setup("Black", "Stone", 326);
    design.setup("Black", "Stone", 367);
    design.setup("Black", "Stone", 347);
    design.setup("Black", "Stone", 327);
    design.setup("Black", "Stone", 368);
    design.setup("Black", "Stone", 348);
    design.setup("Black", "Stone", 328);
    design.setup("Black", "Stone", 268);
    design.setup("Black", "Stone", 369);
    design.setup("Black", "Stone", 349);
    design.setup("Black", "Stone", 329);
    design.setup("Black", "Stone", 370);
    design.setup("Black", "Stone", 350);
    design.setup("Black", "Stone", 330);
    design.setup("Black", "Stone", 371);
    design.setup("Black", "Stone", 331);
    design.setup("Black", "Stone", 271);
    design.setup("Black", "Stone", 372);
    design.setup("Black", "Stone", 352);
    design.setup("Black", "Stone", 332);
    design.setup("Black", "Stone", 373);
    design.setup("Black", "Stone", 333);
    design.setup("Black", "Stone", 354);
    design.setup("Black", "Stone", 274);
    design.setup("Black", "Stone", 375);
    design.setup("Black", "Stone", 335);
    design.setup("Black", "Stone", 356);
    design.setup("Black", "Stone", 377);
    design.setup("Black", "Stone", 357);
    design.setup("Black", "Stone", 337);
    design.setup("Black", "Stone", 277);
    design.setup("Black", "Stone", 358);
    design.setup("Black", "Handle", 761);
    design.setup("Black", "Handle", 762);
    design.setup("Black", "Handle", 763);
    design.setup("Black", "Handle", 764);
    design.setup("Black", "Handle", 765);
    design.setup("Black", "Handle", 766);
    design.setup("Black", "Handle", 767);
    design.setup("Black", "Handle", 768);
    design.setup("Black", "Handle", 769);
    design.setup("Black", "Handle", 770);
    design.setup("Black", "Handle", 771);
    design.setup("Black", "Handle", 772);
    design.setup("Black", "Handle", 773);
    design.setup("Black", "Handle", 774);
    design.setup("Black", "Handle", 775);
    design.setup("Black", "Handle", 776);
    design.setup("Black", "Handle", 777);
    design.setup("Black", "Handle", 778);
    design.setup("Black", "Handle", 741);
    design.setup("Black", "Handle", 742);
    design.setup("Black", "Handle", 743);
    design.setup("Black", "Handle", 744);
    design.setup("Black", "Handle", 745);
    design.setup("Black", "Handle", 746);
    design.setup("Black", "Handle", 747);
    design.setup("Black", "Handle", 748);
    design.setup("Black", "Handle", 749);
    design.setup("Black", "Handle", 750);
    design.setup("Black", "Handle", 751);
    design.setup("Black", "Handle", 752);
    design.setup("Black", "Handle", 753);
    design.setup("Black", "Handle", 754);
    design.setup("Black", "Handle", 755);
    design.setup("Black", "Handle", 756);
    design.setup("Black", "Handle", 757);
    design.setup("Black", "Handle", 758);
    design.setup("Black", "Handle", 721);
    design.setup("Black", "Handle", 722);
    design.setup("Black", "Handle", 723);
    design.setup("Black", "Handle", 724);
    design.setup("Black", "Handle", 725);
    design.setup("Black", "Handle", 726);
    design.setup("Black", "Handle", 727);
    design.setup("Black", "Handle", 728);
    design.setup("Black", "Handle", 729);
    design.setup("Black", "Handle", 730);
    design.setup("Black", "Handle", 731);
    design.setup("Black", "Handle", 732);
    design.setup("Black", "Handle", 733);
    design.setup("Black", "Handle", 734);
    design.setup("Black", "Handle", 735);
    design.setup("Black", "Handle", 736);
    design.setup("Black", "Handle", 737);
    design.setup("Black", "Handle", 738);
    design.setup("Black", "Handle", 701);
    design.setup("Black", "Handle", 702);
    design.setup("Black", "Handle", 703);
    design.setup("Black", "Handle", 704);
    design.setup("Black", "Handle", 705);
    design.setup("Black", "Handle", 706);
    design.setup("Black", "Handle", 707);
    design.setup("Black", "Handle", 708);
    design.setup("Black", "Handle", 709);
    design.setup("Black", "Handle", 710);
    design.setup("Black", "Handle", 711);
    design.setup("Black", "Handle", 712);
    design.setup("Black", "Handle", 713);
    design.setup("Black", "Handle", 714);
    design.setup("Black", "Handle", 715);
    design.setup("Black", "Handle", 716);
    design.setup("Black", "Handle", 717);
    design.setup("Black", "Handle", 718);
    design.setup("Black", "Handle", 681);
    design.setup("Black", "Handle", 682);
    design.setup("Black", "Handle", 683);
    design.setup("Black", "Handle", 684);
    design.setup("Black", "Handle", 685);
    design.setup("Black", "Handle", 686);
    design.setup("Black", "Handle", 687);
    design.setup("Black", "Handle", 688);
    design.setup("Black", "Handle", 689);
    design.setup("Black", "Handle", 690);
    design.setup("Black", "Handle", 691);
    design.setup("Black", "Handle", 692);
    design.setup("Black", "Handle", 693);
    design.setup("Black", "Handle", 694);
    design.setup("Black", "Handle", 695);
    design.setup("Black", "Handle", 696);
    design.setup("Black", "Handle", 697);
    design.setup("Black", "Handle", 698);
    design.setup("Black", "Handle", 661);
    design.setup("Black", "Handle", 662);
    design.setup("Black", "Handle", 663);
    design.setup("Black", "Handle", 664);
    design.setup("Black", "Handle", 665);
    design.setup("Black", "Handle", 666);
    design.setup("Black", "Handle", 667);
    design.setup("Black", "Handle", 668);
    design.setup("Black", "Handle", 669);
    design.setup("Black", "Handle", 670);
    design.setup("Black", "Handle", 671);
    design.setup("Black", "Handle", 672);
    design.setup("Black", "Handle", 673);
    design.setup("Black", "Handle", 674);
    design.setup("Black", "Handle", 675);
    design.setup("Black", "Handle", 676);
    design.setup("Black", "Handle", 677);
    design.setup("Black", "Handle", 678);
    design.setup("Black", "Handle", 641);
    design.setup("Black", "Handle", 642);
    design.setup("Black", "Handle", 643);
    design.setup("Black", "Handle", 644);
    design.setup("Black", "Handle", 645);
    design.setup("Black", "Handle", 646);
    design.setup("Black", "Handle", 647);
    design.setup("Black", "Handle", 648);
    design.setup("Black", "Handle", 649);
    design.setup("Black", "Handle", 650);
    design.setup("Black", "Handle", 651);
    design.setup("Black", "Handle", 652);
    design.setup("Black", "Handle", 653);
    design.setup("Black", "Handle", 654);
    design.setup("Black", "Handle", 655);
    design.setup("Black", "Handle", 656);
    design.setup("Black", "Handle", 657);
    design.setup("Black", "Handle", 658);
    design.setup("Black", "Handle", 621);
    design.setup("Black", "Handle", 622);
    design.setup("Black", "Handle", 623);
    design.setup("Black", "Handle", 624);
    design.setup("Black", "Handle", 625);
    design.setup("Black", "Handle", 626);
    design.setup("Black", "Handle", 627);
    design.setup("Black", "Handle", 628);
    design.setup("Black", "Handle", 629);
    design.setup("Black", "Handle", 630);
    design.setup("Black", "Handle", 631);
    design.setup("Black", "Handle", 632);
    design.setup("Black", "Handle", 633);
    design.setup("Black", "Handle", 634);
    design.setup("Black", "Handle", 635);
    design.setup("Black", "Handle", 636);
    design.setup("Black", "Handle", 637);
    design.setup("Black", "Handle", 638);
    design.setup("Black", "Handle", 601);
    design.setup("Black", "Handle", 602);
    design.setup("Black", "Handle", 603);
    design.setup("Black", "Handle", 604);
    design.setup("Black", "Handle", 605);
    design.setup("Black", "Handle", 606);
    design.setup("Black", "Handle", 607);
    design.setup("Black", "Handle", 608);
    design.setup("Black", "Handle", 609);
    design.setup("Black", "Handle", 610);
    design.setup("Black", "Handle", 611);
    design.setup("Black", "Handle", 612);
    design.setup("Black", "Handle", 613);
    design.setup("Black", "Handle", 614);
    design.setup("Black", "Handle", 615);
    design.setup("Black", "Handle", 616);
    design.setup("Black", "Handle", 617);
    design.setup("Black", "Handle", 618);
    design.setup("White", "Stone", 41);
    design.setup("White", "Stone", 122);
    design.setup("White", "Stone", 62);
    design.setup("White", "Stone", 42);
    design.setup("White", "Stone", 22);
    design.setup("White", "Stone", 43);
    design.setup("White", "Stone", 64);
    design.setup("White", "Stone", 24);
    design.setup("White", "Stone", 125);
    design.setup("White", "Stone", 45);
    design.setup("White", "Stone", 66);
    design.setup("White", "Stone", 26);
    design.setup("White", "Stone", 67);
    design.setup("White", "Stone", 47);
    design.setup("White", "Stone", 27);
    design.setup("White", "Stone", 128);
    design.setup("White", "Stone", 68);
    design.setup("White", "Stone", 48);
    design.setup("White", "Stone", 28);
    design.setup("White", "Stone", 69);
    design.setup("White", "Stone", 49);
    design.setup("White", "Stone", 29);
    design.setup("White", "Stone", 70);
    design.setup("White", "Stone", 50);
    design.setup("White", "Stone", 30);
    design.setup("White", "Stone", 131);
    design.setup("White", "Stone", 71);
    design.setup("White", "Stone", 31);
    design.setup("White", "Stone", 72);
    design.setup("White", "Stone", 52);
    design.setup("White", "Stone", 32);
    design.setup("White", "Stone", 73);
    design.setup("White", "Stone", 33);
    design.setup("White", "Stone", 134);
    design.setup("White", "Stone", 54);
    design.setup("White", "Stone", 75);
    design.setup("White", "Stone", 35);
    design.setup("White", "Stone", 56);
    design.setup("White", "Stone", 137);
    design.setup("White", "Stone", 77);
    design.setup("White", "Stone", 57);
    design.setup("White", "Stone", 37);
    design.setup("White", "Stone", 58);
    design.setup("White", "Handle", 421);
    design.setup("White", "Handle", 422);
    design.setup("White", "Handle", 423);
    design.setup("White", "Handle", 424);
    design.setup("White", "Handle", 425);
    design.setup("White", "Handle", 426);
    design.setup("White", "Handle", 427);
    design.setup("White", "Handle", 428);
    design.setup("White", "Handle", 429);
    design.setup("White", "Handle", 430);
    design.setup("White", "Handle", 431);
    design.setup("White", "Handle", 432);
    design.setup("White", "Handle", 433);
    design.setup("White", "Handle", 434);
    design.setup("White", "Handle", 435);
    design.setup("White", "Handle", 436);
    design.setup("White", "Handle", 437);
    design.setup("White", "Handle", 438);
    design.setup("White", "Handle", 441);
    design.setup("White", "Handle", 442);
    design.setup("White", "Handle", 443);
    design.setup("White", "Handle", 444);
    design.setup("White", "Handle", 445);
    design.setup("White", "Handle", 446);
    design.setup("White", "Handle", 447);
    design.setup("White", "Handle", 448);
    design.setup("White", "Handle", 449);
    design.setup("White", "Handle", 450);
    design.setup("White", "Handle", 451);
    design.setup("White", "Handle", 452);
    design.setup("White", "Handle", 453);
    design.setup("White", "Handle", 454);
    design.setup("White", "Handle", 455);
    design.setup("White", "Handle", 456);
    design.setup("White", "Handle", 457);
    design.setup("White", "Handle", 458);
    design.setup("White", "Handle", 461);
    design.setup("White", "Handle", 462);
    design.setup("White", "Handle", 463);
    design.setup("White", "Handle", 464);
    design.setup("White", "Handle", 465);
    design.setup("White", "Handle", 466);
    design.setup("White", "Handle", 467);
    design.setup("White", "Handle", 468);
    design.setup("White", "Handle", 469);
    design.setup("White", "Handle", 470);
    design.setup("White", "Handle", 471);
    design.setup("White", "Handle", 472);
    design.setup("White", "Handle", 473);
    design.setup("White", "Handle", 474);
    design.setup("White", "Handle", 475);
    design.setup("White", "Handle", 476);
    design.setup("White", "Handle", 477);
    design.setup("White", "Handle", 478);
    design.setup("White", "Handle", 481);
    design.setup("White", "Handle", 482);
    design.setup("White", "Handle", 483);
    design.setup("White", "Handle", 484);
    design.setup("White", "Handle", 485);
    design.setup("White", "Handle", 486);
    design.setup("White", "Handle", 487);
    design.setup("White", "Handle", 488);
    design.setup("White", "Handle", 489);
    design.setup("White", "Handle", 490);
    design.setup("White", "Handle", 491);
    design.setup("White", "Handle", 492);
    design.setup("White", "Handle", 493);
    design.setup("White", "Handle", 494);
    design.setup("White", "Handle", 495);
    design.setup("White", "Handle", 496);
    design.setup("White", "Handle", 497);
    design.setup("White", "Handle", 498);
    design.setup("White", "Handle", 501);
    design.setup("White", "Handle", 502);
    design.setup("White", "Handle", 503);
    design.setup("White", "Handle", 504);
    design.setup("White", "Handle", 505);
    design.setup("White", "Handle", 506);
    design.setup("White", "Handle", 507);
    design.setup("White", "Handle", 508);
    design.setup("White", "Handle", 509);
    design.setup("White", "Handle", 510);
    design.setup("White", "Handle", 511);
    design.setup("White", "Handle", 512);
    design.setup("White", "Handle", 513);
    design.setup("White", "Handle", 514);
    design.setup("White", "Handle", 515);
    design.setup("White", "Handle", 516);
    design.setup("White", "Handle", 517);
    design.setup("White", "Handle", 518);
    design.setup("White", "Handle", 521);
    design.setup("White", "Handle", 522);
    design.setup("White", "Handle", 523);
    design.setup("White", "Handle", 524);
    design.setup("White", "Handle", 525);
    design.setup("White", "Handle", 526);
    design.setup("White", "Handle", 527);
    design.setup("White", "Handle", 528);
    design.setup("White", "Handle", 529);
    design.setup("White", "Handle", 530);
    design.setup("White", "Handle", 531);
    design.setup("White", "Handle", 532);
    design.setup("White", "Handle", 533);
    design.setup("White", "Handle", 534);
    design.setup("White", "Handle", 535);
    design.setup("White", "Handle", 536);
    design.setup("White", "Handle", 537);
    design.setup("White", "Handle", 538);
    design.setup("White", "Handle", 541);
    design.setup("White", "Handle", 542);
    design.setup("White", "Handle", 543);
    design.setup("White", "Handle", 544);
    design.setup("White", "Handle", 545);
    design.setup("White", "Handle", 546);
    design.setup("White", "Handle", 547);
    design.setup("White", "Handle", 548);
    design.setup("White", "Handle", 549);
    design.setup("White", "Handle", 550);
    design.setup("White", "Handle", 551);
    design.setup("White", "Handle", 552);
    design.setup("White", "Handle", 553);
    design.setup("White", "Handle", 554);
    design.setup("White", "Handle", 555);
    design.setup("White", "Handle", 556);
    design.setup("White", "Handle", 557);
    design.setup("White", "Handle", 558);
    design.setup("White", "Handle", 561);
    design.setup("White", "Handle", 562);
    design.setup("White", "Handle", 563);
    design.setup("White", "Handle", 564);
    design.setup("White", "Handle", 565);
    design.setup("White", "Handle", 566);
    design.setup("White", "Handle", 567);
    design.setup("White", "Handle", 568);
    design.setup("White", "Handle", 569);
    design.setup("White", "Handle", 570);
    design.setup("White", "Handle", 571);
    design.setup("White", "Handle", 572);
    design.setup("White", "Handle", 573);
    design.setup("White", "Handle", 574);
    design.setup("White", "Handle", 575);
    design.setup("White", "Handle", 576);
    design.setup("White", "Handle", 577);
    design.setup("White", "Handle", 578);
    design.setup("White", "Handle", 581);
    design.setup("White", "Handle", 582);
    design.setup("White", "Handle", 583);
    design.setup("White", "Handle", 584);
    design.setup("White", "Handle", 585);
    design.setup("White", "Handle", 586);
    design.setup("White", "Handle", 587);
    design.setup("White", "Handle", 588);
    design.setup("White", "Handle", 589);
    design.setup("White", "Handle", 590);
    design.setup("White", "Handle", 591);
    design.setup("White", "Handle", 592);
    design.setup("White", "Handle", 593);
    design.setup("White", "Handle", 594);
    design.setup("White", "Handle", 595);
    design.setup("White", "Handle", 596);
    design.setup("White", "Handle", 597);
    design.setup("White", "Handle", 598);
    design.setup("White", "Handle", 400);
    design.setup("White", "Handle", 420);
    design.setup("White", "Handle", 440);
    design.setup("White", "Handle", 460);
    design.setup("White", "Handle", 480);
    design.setup("White", "Handle", 500);
    design.setup("White", "Handle", 520);
    design.setup("White", "Handle", 540);
    design.setup("White", "Handle", 560);
    design.setup("White", "Handle", 580);
    design.setup("White", "Handle", 600);
    design.setup("White", "Handle", 620);
    design.setup("White", "Handle", 640);
    design.setup("White", "Handle", 660);
    design.setup("White", "Handle", 680);
    design.setup("White", "Handle", 700);
    design.setup("White", "Handle", 720);
    design.setup("White", "Handle", 740);
    design.setup("White", "Handle", 760);
    design.setup("White", "Handle", 780);
    design.setup("White", "Handle", 419);
    design.setup("White", "Handle", 439);
    design.setup("White", "Handle", 459);
    design.setup("White", "Handle", 479);
    design.setup("White", "Handle", 499);
    design.setup("White", "Handle", 519);
    design.setup("White", "Handle", 539);
    design.setup("White", "Handle", 559);
    design.setup("White", "Handle", 579);
    design.setup("White", "Handle", 599);
    design.setup("White", "Handle", 619);
    design.setup("White", "Handle", 639);
    design.setup("White", "Handle", 659);
    design.setup("White", "Handle", 679);
    design.setup("White", "Handle", 699);
    design.setup("White", "Handle", 719);
    design.setup("White", "Handle", 739);
    design.setup("White", "Handle", 759);
    design.setup("White", "Handle", 779);
    design.setup("White", "Handle", 799);
    design.setup("White", "Handle", 401);
    design.setup("White", "Handle", 402);
    design.setup("White", "Handle", 403);
    design.setup("White", "Handle", 404);
    design.setup("White", "Handle", 405);
    design.setup("White", "Handle", 406);
    design.setup("White", "Handle", 407);
    design.setup("White", "Handle", 408);
    design.setup("White", "Handle", 409);
    design.setup("White", "Handle", 410);
    design.setup("White", "Handle", 411);
    design.setup("White", "Handle", 412);
    design.setup("White", "Handle", 413);
    design.setup("White", "Handle", 414);
    design.setup("White", "Handle", 415);
    design.setup("White", "Handle", 416);
    design.setup("White", "Handle", 417);
    design.setup("White", "Handle", 418);
    design.setup("White", "Handle", 781);
    design.setup("White", "Handle", 782);
    design.setup("White", "Handle", 783);
    design.setup("White", "Handle", 784);
    design.setup("White", "Handle", 785);
    design.setup("White", "Handle", 786);
    design.setup("White", "Handle", 787);
    design.setup("White", "Handle", 788);
    design.setup("White", "Handle", 789);
    design.setup("White", "Handle", 790);
    design.setup("White", "Handle", 791);
    design.setup("White", "Handle", 792);
    design.setup("White", "Handle", 793);
    design.setup("White", "Handle", 794);
    design.setup("White", "Handle", 795);
    design.setup("White", "Handle", 796);
    design.setup("White", "Handle", 797);
    design.setup("White", "Handle", 798);
}

Dagaz.View.configure = function(view) {
    view.defBoard("Board");
    view.defPiece("BlackStone", "Black Stone");
    view.defPiece("WhiteStone", "White Stone");
    view.defPiece("BlackHandle", "Black Handle");
    view.defPiece("WhiteHandle", "White Handle");
 
    view.defPosition("x19", 2, 2, 30, 30);
    view.defPosition("a19", 32, 2, 30, 30);
    view.defPosition("b19", 62, 2, 30, 30);
    view.defPosition("c19", 92, 2, 30, 30);
    view.defPosition("d19", 122, 2, 30, 30);
    view.defPosition("e19", 152, 2, 30, 30);
    view.defPosition("f19", 182, 2, 30, 30);
    view.defPosition("g19", 212, 2, 30, 30);
    view.defPosition("h19", 242, 2, 30, 30);
    view.defPosition("i19", 272, 2, 30, 30);
    view.defPosition("j19", 302, 2, 30, 30);
    view.defPosition("k19", 332, 2, 30, 30);
    view.defPosition("l19", 362, 2, 30, 30);
    view.defPosition("m19", 392, 2, 30, 30);
    view.defPosition("n19", 422, 2, 30, 30);
    view.defPosition("o19", 452, 2, 30, 30);
    view.defPosition("p19", 482, 2, 30, 30);
    view.defPosition("q19", 512, 2, 30, 30);
    view.defPosition("r19", 542, 2, 30, 30);
    view.defPosition("y19", 572, 2, 30, 30);
    view.defPosition("x18", 2, 32, 30, 30);
    view.defPosition("a18", 32, 32, 30, 30);
    view.defPosition("b18", 62, 32, 30, 30);
    view.defPosition("c18", 92, 32, 30, 30);
    view.defPosition("d18", 122, 32, 30, 30);
    view.defPosition("e18", 152, 32, 30, 30);
    view.defPosition("f18", 182, 32, 30, 30);
    view.defPosition("g18", 212, 32, 30, 30);
    view.defPosition("h18", 242, 32, 30, 30);
    view.defPosition("i18", 272, 32, 30, 30);
    view.defPosition("j18", 302, 32, 30, 30);
    view.defPosition("k18", 332, 32, 30, 30);
    view.defPosition("l18", 362, 32, 30, 30);
    view.defPosition("m18", 392, 32, 30, 30);
    view.defPosition("n18", 422, 32, 30, 30);
    view.defPosition("o18", 452, 32, 30, 30);
    view.defPosition("p18", 482, 32, 30, 30);
    view.defPosition("q18", 512, 32, 30, 30);
    view.defPosition("r18", 542, 32, 30, 30);
    view.defPosition("y18", 572, 32, 30, 30);
    view.defPosition("x17", 2, 62, 30, 30);
    view.defPosition("a17", 32, 62, 30, 30);
    view.defPosition("b17", 62, 62, 30, 30);
    view.defPosition("c17", 92, 62, 30, 30);
    view.defPosition("d17", 122, 62, 30, 30);
    view.defPosition("e17", 152, 62, 30, 30);
    view.defPosition("f17", 182, 62, 30, 30);
    view.defPosition("g17", 212, 62, 30, 30);
    view.defPosition("h17", 242, 62, 30, 30);
    view.defPosition("i17", 272, 62, 30, 30);
    view.defPosition("j17", 302, 62, 30, 30);
    view.defPosition("k17", 332, 62, 30, 30);
    view.defPosition("l17", 362, 62, 30, 30);
    view.defPosition("m17", 392, 62, 30, 30);
    view.defPosition("n17", 422, 62, 30, 30);
    view.defPosition("o17", 452, 62, 30, 30);
    view.defPosition("p17", 482, 62, 30, 30);
    view.defPosition("q17", 512, 62, 30, 30);
    view.defPosition("r17", 542, 62, 30, 30);
    view.defPosition("y17", 572, 62, 30, 30);
    view.defPosition("x16", 2, 92, 30, 30);
    view.defPosition("a16", 32, 92, 30, 30);
    view.defPosition("b16", 62, 92, 30, 30);
    view.defPosition("c16", 92, 92, 30, 30);
    view.defPosition("d16", 122, 92, 30, 30);
    view.defPosition("e16", 152, 92, 30, 30);
    view.defPosition("f16", 182, 92, 30, 30);
    view.defPosition("g16", 212, 92, 30, 30);
    view.defPosition("h16", 242, 92, 30, 30);
    view.defPosition("i16", 272, 92, 30, 30);
    view.defPosition("j16", 302, 92, 30, 30);
    view.defPosition("k16", 332, 92, 30, 30);
    view.defPosition("l16", 362, 92, 30, 30);
    view.defPosition("m16", 392, 92, 30, 30);
    view.defPosition("n16", 422, 92, 30, 30);
    view.defPosition("o16", 452, 92, 30, 30);
    view.defPosition("p16", 482, 92, 30, 30);
    view.defPosition("q16", 512, 92, 30, 30);
    view.defPosition("r16", 542, 92, 30, 30);
    view.defPosition("y16", 572, 92, 30, 30);
    view.defPosition("x15", 2, 122, 30, 30);
    view.defPosition("a15", 32, 122, 30, 30);
    view.defPosition("b15", 62, 122, 30, 30);
    view.defPosition("c15", 92, 122, 30, 30);
    view.defPosition("d15", 122, 122, 30, 30);
    view.defPosition("e15", 152, 122, 30, 30);
    view.defPosition("f15", 182, 122, 30, 30);
    view.defPosition("g15", 212, 122, 30, 30);
    view.defPosition("h15", 242, 122, 30, 30);
    view.defPosition("i15", 272, 122, 30, 30);
    view.defPosition("j15", 302, 122, 30, 30);
    view.defPosition("k15", 332, 122, 30, 30);
    view.defPosition("l15", 362, 122, 30, 30);
    view.defPosition("m15", 392, 122, 30, 30);
    view.defPosition("n15", 422, 122, 30, 30);
    view.defPosition("o15", 452, 122, 30, 30);
    view.defPosition("p15", 482, 122, 30, 30);
    view.defPosition("q15", 512, 122, 30, 30);
    view.defPosition("r15", 542, 122, 30, 30);
    view.defPosition("y15", 572, 122, 30, 30);
    view.defPosition("x14", 2, 152, 30, 30);
    view.defPosition("a14", 32, 152, 30, 30);
    view.defPosition("b14", 62, 152, 30, 30);
    view.defPosition("c14", 92, 152, 30, 30);
    view.defPosition("d14", 122, 152, 30, 30);
    view.defPosition("e14", 152, 152, 30, 30);
    view.defPosition("f14", 182, 152, 30, 30);
    view.defPosition("g14", 212, 152, 30, 30);
    view.defPosition("h14", 242, 152, 30, 30);
    view.defPosition("i14", 272, 152, 30, 30);
    view.defPosition("j14", 302, 152, 30, 30);
    view.defPosition("k14", 332, 152, 30, 30);
    view.defPosition("l14", 362, 152, 30, 30);
    view.defPosition("m14", 392, 152, 30, 30);
    view.defPosition("n14", 422, 152, 30, 30);
    view.defPosition("o14", 452, 152, 30, 30);
    view.defPosition("p14", 482, 152, 30, 30);
    view.defPosition("q14", 512, 152, 30, 30);
    view.defPosition("r14", 542, 152, 30, 30);
    view.defPosition("y14", 572, 152, 30, 30);
    view.defPosition("x13", 2, 182, 30, 30);
    view.defPosition("a13", 32, 182, 30, 30);
    view.defPosition("b13", 62, 182, 30, 30);
    view.defPosition("c13", 92, 182, 30, 30);
    view.defPosition("d13", 122, 182, 30, 30);
    view.defPosition("e13", 152, 182, 30, 30);
    view.defPosition("f13", 182, 182, 30, 30);
    view.defPosition("g13", 212, 182, 30, 30);
    view.defPosition("h13", 242, 182, 30, 30);
    view.defPosition("i13", 272, 182, 30, 30);
    view.defPosition("j13", 302, 182, 30, 30);
    view.defPosition("k13", 332, 182, 30, 30);
    view.defPosition("l13", 362, 182, 30, 30);
    view.defPosition("m13", 392, 182, 30, 30);
    view.defPosition("n13", 422, 182, 30, 30);
    view.defPosition("o13", 452, 182, 30, 30);
    view.defPosition("p13", 482, 182, 30, 30);
    view.defPosition("q13", 512, 182, 30, 30);
    view.defPosition("r13", 542, 182, 30, 30);
    view.defPosition("y13", 572, 182, 30, 30);
    view.defPosition("x12", 2, 212, 30, 30);
    view.defPosition("a12", 32, 212, 30, 30);
    view.defPosition("b12", 62, 212, 30, 30);
    view.defPosition("c12", 92, 212, 30, 30);
    view.defPosition("d12", 122, 212, 30, 30);
    view.defPosition("e12", 152, 212, 30, 30);
    view.defPosition("f12", 182, 212, 30, 30);
    view.defPosition("g12", 212, 212, 30, 30);
    view.defPosition("h12", 242, 212, 30, 30);
    view.defPosition("i12", 272, 212, 30, 30);
    view.defPosition("j12", 302, 212, 30, 30);
    view.defPosition("k12", 332, 212, 30, 30);
    view.defPosition("l12", 362, 212, 30, 30);
    view.defPosition("m12", 392, 212, 30, 30);
    view.defPosition("n12", 422, 212, 30, 30);
    view.defPosition("o12", 452, 212, 30, 30);
    view.defPosition("p12", 482, 212, 30, 30);
    view.defPosition("q12", 512, 212, 30, 30);
    view.defPosition("r12", 542, 212, 30, 30);
    view.defPosition("y12", 572, 212, 30, 30);
    view.defPosition("x11", 2, 242, 30, 30);
    view.defPosition("a11", 32, 242, 30, 30);
    view.defPosition("b11", 62, 242, 30, 30);
    view.defPosition("c11", 92, 242, 30, 30);
    view.defPosition("d11", 122, 242, 30, 30);
    view.defPosition("e11", 152, 242, 30, 30);
    view.defPosition("f11", 182, 242, 30, 30);
    view.defPosition("g11", 212, 242, 30, 30);
    view.defPosition("h11", 242, 242, 30, 30);
    view.defPosition("i11", 272, 242, 30, 30);
    view.defPosition("j11", 302, 242, 30, 30);
    view.defPosition("k11", 332, 242, 30, 30);
    view.defPosition("l11", 362, 242, 30, 30);
    view.defPosition("m11", 392, 242, 30, 30);
    view.defPosition("n11", 422, 242, 30, 30);
    view.defPosition("o11", 452, 242, 30, 30);
    view.defPosition("p11", 482, 242, 30, 30);
    view.defPosition("q11", 512, 242, 30, 30);
    view.defPosition("r11", 542, 242, 30, 30);
    view.defPosition("y11", 572, 242, 30, 30);
    view.defPosition("x10", 2, 272, 30, 30);
    view.defPosition("a10", 32, 272, 30, 30);
    view.defPosition("b10", 62, 272, 30, 30);
    view.defPosition("c10", 92, 272, 30, 30);
    view.defPosition("d10", 122, 272, 30, 30);
    view.defPosition("e10", 152, 272, 30, 30);
    view.defPosition("f10", 182, 272, 30, 30);
    view.defPosition("g10", 212, 272, 30, 30);
    view.defPosition("h10", 242, 272, 30, 30);
    view.defPosition("i10", 272, 272, 30, 30);
    view.defPosition("j10", 302, 272, 30, 30);
    view.defPosition("k10", 332, 272, 30, 30);
    view.defPosition("l10", 362, 272, 30, 30);
    view.defPosition("m10", 392, 272, 30, 30);
    view.defPosition("n10", 422, 272, 30, 30);
    view.defPosition("o10", 452, 272, 30, 30);
    view.defPosition("p10", 482, 272, 30, 30);
    view.defPosition("q10", 512, 272, 30, 30);
    view.defPosition("r10", 542, 272, 30, 30);
    view.defPosition("y10", 572, 272, 30, 30);
    view.defPosition("x9", 2, 302, 30, 30);
    view.defPosition("a9", 32, 302, 30, 30);
    view.defPosition("b9", 62, 302, 30, 30);
    view.defPosition("c9", 92, 302, 30, 30);
    view.defPosition("d9", 122, 302, 30, 30);
    view.defPosition("e9", 152, 302, 30, 30);
    view.defPosition("f9", 182, 302, 30, 30);
    view.defPosition("g9", 212, 302, 30, 30);
    view.defPosition("h9", 242, 302, 30, 30);
    view.defPosition("i9", 272, 302, 30, 30);
    view.defPosition("j9", 302, 302, 30, 30);
    view.defPosition("k9", 332, 302, 30, 30);
    view.defPosition("l9", 362, 302, 30, 30);
    view.defPosition("m9", 392, 302, 30, 30);
    view.defPosition("n9", 422, 302, 30, 30);
    view.defPosition("o9", 452, 302, 30, 30);
    view.defPosition("p9", 482, 302, 30, 30);
    view.defPosition("q9", 512, 302, 30, 30);
    view.defPosition("r9", 542, 302, 30, 30);
    view.defPosition("y9", 572, 302, 30, 30);
    view.defPosition("x8", 2, 332, 30, 30);
    view.defPosition("a8", 32, 332, 30, 30);
    view.defPosition("b8", 62, 332, 30, 30);
    view.defPosition("c8", 92, 332, 30, 30);
    view.defPosition("d8", 122, 332, 30, 30);
    view.defPosition("e8", 152, 332, 30, 30);
    view.defPosition("f8", 182, 332, 30, 30);
    view.defPosition("g8", 212, 332, 30, 30);
    view.defPosition("h8", 242, 332, 30, 30);
    view.defPosition("i8", 272, 332, 30, 30);
    view.defPosition("j8", 302, 332, 30, 30);
    view.defPosition("k8", 332, 332, 30, 30);
    view.defPosition("l8", 362, 332, 30, 30);
    view.defPosition("m8", 392, 332, 30, 30);
    view.defPosition("n8", 422, 332, 30, 30);
    view.defPosition("o8", 452, 332, 30, 30);
    view.defPosition("p8", 482, 332, 30, 30);
    view.defPosition("q8", 512, 332, 30, 30);
    view.defPosition("r8", 542, 332, 30, 30);
    view.defPosition("y8", 572, 332, 30, 30);
    view.defPosition("x7", 2, 362, 30, 30);
    view.defPosition("a7", 32, 362, 30, 30);
    view.defPosition("b7", 62, 362, 30, 30);
    view.defPosition("c7", 92, 362, 30, 30);
    view.defPosition("d7", 122, 362, 30, 30);
    view.defPosition("e7", 152, 362, 30, 30);
    view.defPosition("f7", 182, 362, 30, 30);
    view.defPosition("g7", 212, 362, 30, 30);
    view.defPosition("h7", 242, 362, 30, 30);
    view.defPosition("i7", 272, 362, 30, 30);
    view.defPosition("j7", 302, 362, 30, 30);
    view.defPosition("k7", 332, 362, 30, 30);
    view.defPosition("l7", 362, 362, 30, 30);
    view.defPosition("m7", 392, 362, 30, 30);
    view.defPosition("n7", 422, 362, 30, 30);
    view.defPosition("o7", 452, 362, 30, 30);
    view.defPosition("p7", 482, 362, 30, 30);
    view.defPosition("q7", 512, 362, 30, 30);
    view.defPosition("r7", 542, 362, 30, 30);
    view.defPosition("y7", 572, 362, 30, 30);
    view.defPosition("x6", 2, 392, 30, 30);
    view.defPosition("a6", 32, 392, 30, 30);
    view.defPosition("b6", 62, 392, 30, 30);
    view.defPosition("c6", 92, 392, 30, 30);
    view.defPosition("d6", 122, 392, 30, 30);
    view.defPosition("e6", 152, 392, 30, 30);
    view.defPosition("f6", 182, 392, 30, 30);
    view.defPosition("g6", 212, 392, 30, 30);
    view.defPosition("h6", 242, 392, 30, 30);
    view.defPosition("i6", 272, 392, 30, 30);
    view.defPosition("j6", 302, 392, 30, 30);
    view.defPosition("k6", 332, 392, 30, 30);
    view.defPosition("l6", 362, 392, 30, 30);
    view.defPosition("m6", 392, 392, 30, 30);
    view.defPosition("n6", 422, 392, 30, 30);
    view.defPosition("o6", 452, 392, 30, 30);
    view.defPosition("p6", 482, 392, 30, 30);
    view.defPosition("q6", 512, 392, 30, 30);
    view.defPosition("r6", 542, 392, 30, 30);
    view.defPosition("y6", 572, 392, 30, 30);
    view.defPosition("x5", 2, 422, 30, 30);
    view.defPosition("a5", 32, 422, 30, 30);
    view.defPosition("b5", 62, 422, 30, 30);
    view.defPosition("c5", 92, 422, 30, 30);
    view.defPosition("d5", 122, 422, 30, 30);
    view.defPosition("e5", 152, 422, 30, 30);
    view.defPosition("f5", 182, 422, 30, 30);
    view.defPosition("g5", 212, 422, 30, 30);
    view.defPosition("h5", 242, 422, 30, 30);
    view.defPosition("i5", 272, 422, 30, 30);
    view.defPosition("j5", 302, 422, 30, 30);
    view.defPosition("k5", 332, 422, 30, 30);
    view.defPosition("l5", 362, 422, 30, 30);
    view.defPosition("m5", 392, 422, 30, 30);
    view.defPosition("n5", 422, 422, 30, 30);
    view.defPosition("o5", 452, 422, 30, 30);
    view.defPosition("p5", 482, 422, 30, 30);
    view.defPosition("q5", 512, 422, 30, 30);
    view.defPosition("r5", 542, 422, 30, 30);
    view.defPosition("y5", 572, 422, 30, 30);
    view.defPosition("x4", 2, 452, 30, 30);
    view.defPosition("a4", 32, 452, 30, 30);
    view.defPosition("b4", 62, 452, 30, 30);
    view.defPosition("c4", 92, 452, 30, 30);
    view.defPosition("d4", 122, 452, 30, 30);
    view.defPosition("e4", 152, 452, 30, 30);
    view.defPosition("f4", 182, 452, 30, 30);
    view.defPosition("g4", 212, 452, 30, 30);
    view.defPosition("h4", 242, 452, 30, 30);
    view.defPosition("i4", 272, 452, 30, 30);
    view.defPosition("j4", 302, 452, 30, 30);
    view.defPosition("k4", 332, 452, 30, 30);
    view.defPosition("l4", 362, 452, 30, 30);
    view.defPosition("m4", 392, 452, 30, 30);
    view.defPosition("n4", 422, 452, 30, 30);
    view.defPosition("o4", 452, 452, 30, 30);
    view.defPosition("p4", 482, 452, 30, 30);
    view.defPosition("q4", 512, 452, 30, 30);
    view.defPosition("r4", 542, 452, 30, 30);
    view.defPosition("y4", 572, 452, 30, 30);
    view.defPosition("x3", 2, 482, 30, 30);
    view.defPosition("a3", 32, 482, 30, 30);
    view.defPosition("b3", 62, 482, 30, 30);
    view.defPosition("c3", 92, 482, 30, 30);
    view.defPosition("d3", 122, 482, 30, 30);
    view.defPosition("e3", 152, 482, 30, 30);
    view.defPosition("f3", 182, 482, 30, 30);
    view.defPosition("g3", 212, 482, 30, 30);
    view.defPosition("h3", 242, 482, 30, 30);
    view.defPosition("i3", 272, 482, 30, 30);
    view.defPosition("j3", 302, 482, 30, 30);
    view.defPosition("k3", 332, 482, 30, 30);
    view.defPosition("l3", 362, 482, 30, 30);
    view.defPosition("m3", 392, 482, 30, 30);
    view.defPosition("n3", 422, 482, 30, 30);
    view.defPosition("o3", 452, 482, 30, 30);
    view.defPosition("p3", 482, 482, 30, 30);
    view.defPosition("q3", 512, 482, 30, 30);
    view.defPosition("r3", 542, 482, 30, 30);
    view.defPosition("y3", 572, 482, 30, 30);
    view.defPosition("x2", 2, 512, 30, 30);
    view.defPosition("a2", 32, 512, 30, 30);
    view.defPosition("b2", 62, 512, 30, 30);
    view.defPosition("c2", 92, 512, 30, 30);
    view.defPosition("d2", 122, 512, 30, 30);
    view.defPosition("e2", 152, 512, 30, 30);
    view.defPosition("f2", 182, 512, 30, 30);
    view.defPosition("g2", 212, 512, 30, 30);
    view.defPosition("h2", 242, 512, 30, 30);
    view.defPosition("i2", 272, 512, 30, 30);
    view.defPosition("j2", 302, 512, 30, 30);
    view.defPosition("k2", 332, 512, 30, 30);
    view.defPosition("l2", 362, 512, 30, 30);
    view.defPosition("m2", 392, 512, 30, 30);
    view.defPosition("n2", 422, 512, 30, 30);
    view.defPosition("o2", 452, 512, 30, 30);
    view.defPosition("p2", 482, 512, 30, 30);
    view.defPosition("q2", 512, 512, 30, 30);
    view.defPosition("r2", 542, 512, 30, 30);
    view.defPosition("y2", 572, 512, 30, 30);
    view.defPosition("x1", 2, 542, 30, 30);
    view.defPosition("a1", 32, 542, 30, 30);
    view.defPosition("b1", 62, 542, 30, 30);
    view.defPosition("c1", 92, 542, 30, 30);
    view.defPosition("d1", 122, 542, 30, 30);
    view.defPosition("e1", 152, 542, 30, 30);
    view.defPosition("f1", 182, 542, 30, 30);
    view.defPosition("g1", 212, 542, 30, 30);
    view.defPosition("h1", 242, 542, 30, 30);
    view.defPosition("i1", 272, 542, 30, 30);
    view.defPosition("j1", 302, 542, 30, 30);
    view.defPosition("k1", 332, 542, 30, 30);
    view.defPosition("l1", 362, 542, 30, 30);
    view.defPosition("m1", 392, 542, 30, 30);
    view.defPosition("n1", 422, 542, 30, 30);
    view.defPosition("o1", 452, 542, 30, 30);
    view.defPosition("p1", 482, 542, 30, 30);
    view.defPosition("q1", 512, 542, 30, 30);
    view.defPosition("r1", 542, 542, 30, 30);
    view.defPosition("y1", 572, 542, 30, 30);
    view.defPosition("x0", 2, 572, 30, 30);
    view.defPosition("a0", 32, 572, 30, 30);
    view.defPosition("b0", 62, 572, 30, 30);
    view.defPosition("c0", 92, 572, 30, 30);
    view.defPosition("d0", 122, 572, 30, 30);
    view.defPosition("e0", 152, 572, 30, 30);
    view.defPosition("f0", 182, 572, 30, 30);
    view.defPosition("g0", 212, 572, 30, 30);
    view.defPosition("h0", 242, 572, 30, 30);
    view.defPosition("i0", 272, 572, 30, 30);
    view.defPosition("j0", 302, 572, 30, 30);
    view.defPosition("k0", 332, 572, 30, 30);
    view.defPosition("l0", 362, 572, 30, 30);
    view.defPosition("m0", 392, 572, 30, 30);
    view.defPosition("n0", 422, 572, 30, 30);
    view.defPosition("o0", 452, 572, 30, 30);
    view.defPosition("p0", 482, 572, 30, 30);
    view.defPosition("q0", 512, 572, 30, 30);
    view.defPosition("r0", 542, 572, 30, 30);
    view.defPosition("y0", 572, 572, 30, 30);
    view.defPosition("X19", 2, 2, 30, 30);
    view.defPosition("A19", 32, 2, 30, 30);
    view.defPosition("B19", 62, 2, 30, 30);
    view.defPosition("C19", 92, 2, 30, 30);
    view.defPosition("D19", 122, 2, 30, 30);
    view.defPosition("E19", 152, 2, 30, 30);
    view.defPosition("F19", 182, 2, 30, 30);
    view.defPosition("G19", 212, 2, 30, 30);
    view.defPosition("H19", 242, 2, 30, 30);
    view.defPosition("I19", 272, 2, 30, 30);
    view.defPosition("J19", 302, 2, 30, 30);
    view.defPosition("K19", 332, 2, 30, 30);
    view.defPosition("L19", 362, 2, 30, 30);
    view.defPosition("M19", 392, 2, 30, 30);
    view.defPosition("N19", 422, 2, 30, 30);
    view.defPosition("O19", 452, 2, 30, 30);
    view.defPosition("P19", 482, 2, 30, 30);
    view.defPosition("Q19", 512, 2, 30, 30);
    view.defPosition("R19", 542, 2, 30, 30);
    view.defPosition("Y19", 572, 2, 30, 30);
    view.defPosition("X18", 2, 32, 30, 30);
    view.defPosition("A18", 32, 32, 30, 30);
    view.defPosition("B18", 62, 32, 30, 30);
    view.defPosition("C18", 92, 32, 30, 30);
    view.defPosition("D18", 122, 32, 30, 30);
    view.defPosition("E18", 152, 32, 30, 30);
    view.defPosition("F18", 182, 32, 30, 30);
    view.defPosition("G18", 212, 32, 30, 30);
    view.defPosition("H18", 242, 32, 30, 30);
    view.defPosition("I18", 272, 32, 30, 30);
    view.defPosition("J18", 302, 32, 30, 30);
    view.defPosition("K18", 332, 32, 30, 30);
    view.defPosition("L18", 362, 32, 30, 30);
    view.defPosition("M18", 392, 32, 30, 30);
    view.defPosition("N18", 422, 32, 30, 30);
    view.defPosition("O18", 452, 32, 30, 30);
    view.defPosition("P18", 482, 32, 30, 30);
    view.defPosition("Q18", 512, 32, 30, 30);
    view.defPosition("R18", 542, 32, 30, 30);
    view.defPosition("Y18", 572, 32, 30, 30);
    view.defPosition("X17", 2, 62, 30, 30);
    view.defPosition("A17", 32, 62, 30, 30);
    view.defPosition("B17", 62, 62, 30, 30);
    view.defPosition("C17", 92, 62, 30, 30);
    view.defPosition("D17", 122, 62, 30, 30);
    view.defPosition("E17", 152, 62, 30, 30);
    view.defPosition("F17", 182, 62, 30, 30);
    view.defPosition("G17", 212, 62, 30, 30);
    view.defPosition("H17", 242, 62, 30, 30);
    view.defPosition("I17", 272, 62, 30, 30);
    view.defPosition("J17", 302, 62, 30, 30);
    view.defPosition("K17", 332, 62, 30, 30);
    view.defPosition("L17", 362, 62, 30, 30);
    view.defPosition("M17", 392, 62, 30, 30);
    view.defPosition("N17", 422, 62, 30, 30);
    view.defPosition("O17", 452, 62, 30, 30);
    view.defPosition("P17", 482, 62, 30, 30);
    view.defPosition("Q17", 512, 62, 30, 30);
    view.defPosition("R17", 542, 62, 30, 30);
    view.defPosition("Y17", 572, 62, 30, 30);
    view.defPosition("X16", 2, 92, 30, 30);
    view.defPosition("A16", 32, 92, 30, 30);
    view.defPosition("B16", 62, 92, 30, 30);
    view.defPosition("C16", 92, 92, 30, 30);
    view.defPosition("D16", 122, 92, 30, 30);
    view.defPosition("E16", 152, 92, 30, 30);
    view.defPosition("F16", 182, 92, 30, 30);
    view.defPosition("G16", 212, 92, 30, 30);
    view.defPosition("H16", 242, 92, 30, 30);
    view.defPosition("I16", 272, 92, 30, 30);
    view.defPosition("J16", 302, 92, 30, 30);
    view.defPosition("K16", 332, 92, 30, 30);
    view.defPosition("L16", 362, 92, 30, 30);
    view.defPosition("M16", 392, 92, 30, 30);
    view.defPosition("N16", 422, 92, 30, 30);
    view.defPosition("O16", 452, 92, 30, 30);
    view.defPosition("P16", 482, 92, 30, 30);
    view.defPosition("Q16", 512, 92, 30, 30);
    view.defPosition("R16", 542, 92, 30, 30);
    view.defPosition("Y16", 572, 92, 30, 30);
    view.defPosition("X15", 2, 122, 30, 30);
    view.defPosition("A15", 32, 122, 30, 30);
    view.defPosition("B15", 62, 122, 30, 30);
    view.defPosition("C15", 92, 122, 30, 30);
    view.defPosition("D15", 122, 122, 30, 30);
    view.defPosition("E15", 152, 122, 30, 30);
    view.defPosition("F15", 182, 122, 30, 30);
    view.defPosition("G15", 212, 122, 30, 30);
    view.defPosition("H15", 242, 122, 30, 30);
    view.defPosition("I15", 272, 122, 30, 30);
    view.defPosition("J15", 302, 122, 30, 30);
    view.defPosition("K15", 332, 122, 30, 30);
    view.defPosition("L15", 362, 122, 30, 30);
    view.defPosition("M15", 392, 122, 30, 30);
    view.defPosition("N15", 422, 122, 30, 30);
    view.defPosition("O15", 452, 122, 30, 30);
    view.defPosition("P15", 482, 122, 30, 30);
    view.defPosition("Q15", 512, 122, 30, 30);
    view.defPosition("R15", 542, 122, 30, 30);
    view.defPosition("Y15", 572, 122, 30, 30);
    view.defPosition("X14", 2, 152, 30, 30);
    view.defPosition("A14", 32, 152, 30, 30);
    view.defPosition("B14", 62, 152, 30, 30);
    view.defPosition("C14", 92, 152, 30, 30);
    view.defPosition("D14", 122, 152, 30, 30);
    view.defPosition("E14", 152, 152, 30, 30);
    view.defPosition("F14", 182, 152, 30, 30);
    view.defPosition("G14", 212, 152, 30, 30);
    view.defPosition("H14", 242, 152, 30, 30);
    view.defPosition("I14", 272, 152, 30, 30);
    view.defPosition("J14", 302, 152, 30, 30);
    view.defPosition("K14", 332, 152, 30, 30);
    view.defPosition("L14", 362, 152, 30, 30);
    view.defPosition("M14", 392, 152, 30, 30);
    view.defPosition("N14", 422, 152, 30, 30);
    view.defPosition("O14", 452, 152, 30, 30);
    view.defPosition("P14", 482, 152, 30, 30);
    view.defPosition("Q14", 512, 152, 30, 30);
    view.defPosition("R14", 542, 152, 30, 30);
    view.defPosition("Y14", 572, 152, 30, 30);
    view.defPosition("X13", 2, 182, 30, 30);
    view.defPosition("A13", 32, 182, 30, 30);
    view.defPosition("B13", 62, 182, 30, 30);
    view.defPosition("C13", 92, 182, 30, 30);
    view.defPosition("D13", 122, 182, 30, 30);
    view.defPosition("E13", 152, 182, 30, 30);
    view.defPosition("F13", 182, 182, 30, 30);
    view.defPosition("G13", 212, 182, 30, 30);
    view.defPosition("H13", 242, 182, 30, 30);
    view.defPosition("I13", 272, 182, 30, 30);
    view.defPosition("J13", 302, 182, 30, 30);
    view.defPosition("K13", 332, 182, 30, 30);
    view.defPosition("L13", 362, 182, 30, 30);
    view.defPosition("M13", 392, 182, 30, 30);
    view.defPosition("N13", 422, 182, 30, 30);
    view.defPosition("O13", 452, 182, 30, 30);
    view.defPosition("P13", 482, 182, 30, 30);
    view.defPosition("Q13", 512, 182, 30, 30);
    view.defPosition("R13", 542, 182, 30, 30);
    view.defPosition("Y13", 572, 182, 30, 30);
    view.defPosition("X12", 2, 212, 30, 30);
    view.defPosition("A12", 32, 212, 30, 30);
    view.defPosition("B12", 62, 212, 30, 30);
    view.defPosition("C12", 92, 212, 30, 30);
    view.defPosition("D12", 122, 212, 30, 30);
    view.defPosition("E12", 152, 212, 30, 30);
    view.defPosition("F12", 182, 212, 30, 30);
    view.defPosition("G12", 212, 212, 30, 30);
    view.defPosition("H12", 242, 212, 30, 30);
    view.defPosition("I12", 272, 212, 30, 30);
    view.defPosition("J12", 302, 212, 30, 30);
    view.defPosition("K12", 332, 212, 30, 30);
    view.defPosition("L12", 362, 212, 30, 30);
    view.defPosition("M12", 392, 212, 30, 30);
    view.defPosition("N12", 422, 212, 30, 30);
    view.defPosition("O12", 452, 212, 30, 30);
    view.defPosition("P12", 482, 212, 30, 30);
    view.defPosition("Q12", 512, 212, 30, 30);
    view.defPosition("R12", 542, 212, 30, 30);
    view.defPosition("Y12", 572, 212, 30, 30);
    view.defPosition("X11", 2, 242, 30, 30);
    view.defPosition("A11", 32, 242, 30, 30);
    view.defPosition("B11", 62, 242, 30, 30);
    view.defPosition("C11", 92, 242, 30, 30);
    view.defPosition("D11", 122, 242, 30, 30);
    view.defPosition("E11", 152, 242, 30, 30);
    view.defPosition("F11", 182, 242, 30, 30);
    view.defPosition("G11", 212, 242, 30, 30);
    view.defPosition("H11", 242, 242, 30, 30);
    view.defPosition("I11", 272, 242, 30, 30);
    view.defPosition("J11", 302, 242, 30, 30);
    view.defPosition("K11", 332, 242, 30, 30);
    view.defPosition("L11", 362, 242, 30, 30);
    view.defPosition("M11", 392, 242, 30, 30);
    view.defPosition("N11", 422, 242, 30, 30);
    view.defPosition("O11", 452, 242, 30, 30);
    view.defPosition("P11", 482, 242, 30, 30);
    view.defPosition("Q11", 512, 242, 30, 30);
    view.defPosition("R11", 542, 242, 30, 30);
    view.defPosition("Y11", 572, 242, 30, 30);
    view.defPosition("X10", 2, 272, 30, 30);
    view.defPosition("A10", 32, 272, 30, 30);
    view.defPosition("B10", 62, 272, 30, 30);
    view.defPosition("C10", 92, 272, 30, 30);
    view.defPosition("D10", 122, 272, 30, 30);
    view.defPosition("E10", 152, 272, 30, 30);
    view.defPosition("F10", 182, 272, 30, 30);
    view.defPosition("G10", 212, 272, 30, 30);
    view.defPosition("H10", 242, 272, 30, 30);
    view.defPosition("I10", 272, 272, 30, 30);
    view.defPosition("J10", 302, 272, 30, 30);
    view.defPosition("K10", 332, 272, 30, 30);
    view.defPosition("L10", 362, 272, 30, 30);
    view.defPosition("M10", 392, 272, 30, 30);
    view.defPosition("N10", 422, 272, 30, 30);
    view.defPosition("O10", 452, 272, 30, 30);
    view.defPosition("P10", 482, 272, 30, 30);
    view.defPosition("Q10", 512, 272, 30, 30);
    view.defPosition("R10", 542, 272, 30, 30);
    view.defPosition("Y10", 572, 272, 30, 30);
    view.defPosition("X9", 2, 302, 30, 30);
    view.defPosition("A9", 32, 302, 30, 30);
    view.defPosition("B9", 62, 302, 30, 30);
    view.defPosition("C9", 92, 302, 30, 30);
    view.defPosition("D9", 122, 302, 30, 30);
    view.defPosition("E9", 152, 302, 30, 30);
    view.defPosition("F9", 182, 302, 30, 30);
    view.defPosition("G9", 212, 302, 30, 30);
    view.defPosition("H9", 242, 302, 30, 30);
    view.defPosition("I9", 272, 302, 30, 30);
    view.defPosition("J9", 302, 302, 30, 30);
    view.defPosition("K9", 332, 302, 30, 30);
    view.defPosition("L9", 362, 302, 30, 30);
    view.defPosition("M9", 392, 302, 30, 30);
    view.defPosition("N9", 422, 302, 30, 30);
    view.defPosition("O9", 452, 302, 30, 30);
    view.defPosition("P9", 482, 302, 30, 30);
    view.defPosition("Q9", 512, 302, 30, 30);
    view.defPosition("R9", 542, 302, 30, 30);
    view.defPosition("Y9", 572, 302, 30, 30);
    view.defPosition("X8", 2, 332, 30, 30);
    view.defPosition("A8", 32, 332, 30, 30);
    view.defPosition("B8", 62, 332, 30, 30);
    view.defPosition("C8", 92, 332, 30, 30);
    view.defPosition("D8", 122, 332, 30, 30);
    view.defPosition("E8", 152, 332, 30, 30);
    view.defPosition("F8", 182, 332, 30, 30);
    view.defPosition("G8", 212, 332, 30, 30);
    view.defPosition("H8", 242, 332, 30, 30);
    view.defPosition("I8", 272, 332, 30, 30);
    view.defPosition("J8", 302, 332, 30, 30);
    view.defPosition("K8", 332, 332, 30, 30);
    view.defPosition("L8", 362, 332, 30, 30);
    view.defPosition("M8", 392, 332, 30, 30);
    view.defPosition("N8", 422, 332, 30, 30);
    view.defPosition("O8", 452, 332, 30, 30);
    view.defPosition("P8", 482, 332, 30, 30);
    view.defPosition("Q8", 512, 332, 30, 30);
    view.defPosition("R8", 542, 332, 30, 30);
    view.defPosition("Y8", 572, 332, 30, 30);
    view.defPosition("X7", 2, 362, 30, 30);
    view.defPosition("A7", 32, 362, 30, 30);
    view.defPosition("B7", 62, 362, 30, 30);
    view.defPosition("C7", 92, 362, 30, 30);
    view.defPosition("D7", 122, 362, 30, 30);
    view.defPosition("E7", 152, 362, 30, 30);
    view.defPosition("F7", 182, 362, 30, 30);
    view.defPosition("G7", 212, 362, 30, 30);
    view.defPosition("H7", 242, 362, 30, 30);
    view.defPosition("I7", 272, 362, 30, 30);
    view.defPosition("J7", 302, 362, 30, 30);
    view.defPosition("K7", 332, 362, 30, 30);
    view.defPosition("L7", 362, 362, 30, 30);
    view.defPosition("M7", 392, 362, 30, 30);
    view.defPosition("N7", 422, 362, 30, 30);
    view.defPosition("O7", 452, 362, 30, 30);
    view.defPosition("P7", 482, 362, 30, 30);
    view.defPosition("Q7", 512, 362, 30, 30);
    view.defPosition("R7", 542, 362, 30, 30);
    view.defPosition("Y7", 572, 362, 30, 30);
    view.defPosition("X6", 2, 392, 30, 30);
    view.defPosition("A6", 32, 392, 30, 30);
    view.defPosition("B6", 62, 392, 30, 30);
    view.defPosition("C6", 92, 392, 30, 30);
    view.defPosition("D6", 122, 392, 30, 30);
    view.defPosition("E6", 152, 392, 30, 30);
    view.defPosition("F6", 182, 392, 30, 30);
    view.defPosition("G6", 212, 392, 30, 30);
    view.defPosition("H6", 242, 392, 30, 30);
    view.defPosition("I6", 272, 392, 30, 30);
    view.defPosition("J6", 302, 392, 30, 30);
    view.defPosition("K6", 332, 392, 30, 30);
    view.defPosition("L6", 362, 392, 30, 30);
    view.defPosition("M6", 392, 392, 30, 30);
    view.defPosition("N6", 422, 392, 30, 30);
    view.defPosition("O6", 452, 392, 30, 30);
    view.defPosition("P6", 482, 392, 30, 30);
    view.defPosition("Q6", 512, 392, 30, 30);
    view.defPosition("R6", 542, 392, 30, 30);
    view.defPosition("Y6", 572, 392, 30, 30);
    view.defPosition("X5", 2, 422, 30, 30);
    view.defPosition("A5", 32, 422, 30, 30);
    view.defPosition("B5", 62, 422, 30, 30);
    view.defPosition("C5", 92, 422, 30, 30);
    view.defPosition("D5", 122, 422, 30, 30);
    view.defPosition("E5", 152, 422, 30, 30);
    view.defPosition("F5", 182, 422, 30, 30);
    view.defPosition("G5", 212, 422, 30, 30);
    view.defPosition("H5", 242, 422, 30, 30);
    view.defPosition("I5", 272, 422, 30, 30);
    view.defPosition("J5", 302, 422, 30, 30);
    view.defPosition("K5", 332, 422, 30, 30);
    view.defPosition("L5", 362, 422, 30, 30);
    view.defPosition("M5", 392, 422, 30, 30);
    view.defPosition("N5", 422, 422, 30, 30);
    view.defPosition("O5", 452, 422, 30, 30);
    view.defPosition("P5", 482, 422, 30, 30);
    view.defPosition("Q5", 512, 422, 30, 30);
    view.defPosition("R5", 542, 422, 30, 30);
    view.defPosition("Y5", 572, 422, 30, 30);
    view.defPosition("X4", 2, 452, 30, 30);
    view.defPosition("A4", 32, 452, 30, 30);
    view.defPosition("B4", 62, 452, 30, 30);
    view.defPosition("C4", 92, 452, 30, 30);
    view.defPosition("D4", 122, 452, 30, 30);
    view.defPosition("E4", 152, 452, 30, 30);
    view.defPosition("F4", 182, 452, 30, 30);
    view.defPosition("G4", 212, 452, 30, 30);
    view.defPosition("H4", 242, 452, 30, 30);
    view.defPosition("I4", 272, 452, 30, 30);
    view.defPosition("J4", 302, 452, 30, 30);
    view.defPosition("K4", 332, 452, 30, 30);
    view.defPosition("L4", 362, 452, 30, 30);
    view.defPosition("M4", 392, 452, 30, 30);
    view.defPosition("N4", 422, 452, 30, 30);
    view.defPosition("O4", 452, 452, 30, 30);
    view.defPosition("P4", 482, 452, 30, 30);
    view.defPosition("Q4", 512, 452, 30, 30);
    view.defPosition("R4", 542, 452, 30, 30);
    view.defPosition("Y4", 572, 452, 30, 30);
    view.defPosition("X3", 2, 482, 30, 30);
    view.defPosition("A3", 32, 482, 30, 30);
    view.defPosition("B3", 62, 482, 30, 30);
    view.defPosition("C3", 92, 482, 30, 30);
    view.defPosition("D3", 122, 482, 30, 30);
    view.defPosition("E3", 152, 482, 30, 30);
    view.defPosition("F3", 182, 482, 30, 30);
    view.defPosition("G3", 212, 482, 30, 30);
    view.defPosition("H3", 242, 482, 30, 30);
    view.defPosition("I3", 272, 482, 30, 30);
    view.defPosition("J3", 302, 482, 30, 30);
    view.defPosition("K3", 332, 482, 30, 30);
    view.defPosition("L3", 362, 482, 30, 30);
    view.defPosition("M3", 392, 482, 30, 30);
    view.defPosition("N3", 422, 482, 30, 30);
    view.defPosition("O3", 452, 482, 30, 30);
    view.defPosition("P3", 482, 482, 30, 30);
    view.defPosition("Q3", 512, 482, 30, 30);
    view.defPosition("R3", 542, 482, 30, 30);
    view.defPosition("Y3", 572, 482, 30, 30);
    view.defPosition("X2", 2, 512, 30, 30);
    view.defPosition("A2", 32, 512, 30, 30);
    view.defPosition("B2", 62, 512, 30, 30);
    view.defPosition("C2", 92, 512, 30, 30);
    view.defPosition("D2", 122, 512, 30, 30);
    view.defPosition("E2", 152, 512, 30, 30);
    view.defPosition("F2", 182, 512, 30, 30);
    view.defPosition("G2", 212, 512, 30, 30);
    view.defPosition("H2", 242, 512, 30, 30);
    view.defPosition("I2", 272, 512, 30, 30);
    view.defPosition("J2", 302, 512, 30, 30);
    view.defPosition("K2", 332, 512, 30, 30);
    view.defPosition("L2", 362, 512, 30, 30);
    view.defPosition("M2", 392, 512, 30, 30);
    view.defPosition("N2", 422, 512, 30, 30);
    view.defPosition("O2", 452, 512, 30, 30);
    view.defPosition("P2", 482, 512, 30, 30);
    view.defPosition("Q2", 512, 512, 30, 30);
    view.defPosition("R2", 542, 512, 30, 30);
    view.defPosition("Y2", 572, 512, 30, 30);
    view.defPosition("X1", 2, 542, 30, 30);
    view.defPosition("A1", 32, 542, 30, 30);
    view.defPosition("B1", 62, 542, 30, 30);
    view.defPosition("C1", 92, 542, 30, 30);
    view.defPosition("D1", 122, 542, 30, 30);
    view.defPosition("E1", 152, 542, 30, 30);
    view.defPosition("F1", 182, 542, 30, 30);
    view.defPosition("G1", 212, 542, 30, 30);
    view.defPosition("H1", 242, 542, 30, 30);
    view.defPosition("I1", 272, 542, 30, 30);
    view.defPosition("J1", 302, 542, 30, 30);
    view.defPosition("K1", 332, 542, 30, 30);
    view.defPosition("L1", 362, 542, 30, 30);
    view.defPosition("M1", 392, 542, 30, 30);
    view.defPosition("N1", 422, 542, 30, 30);
    view.defPosition("O1", 452, 542, 30, 30);
    view.defPosition("P1", 482, 542, 30, 30);
    view.defPosition("Q1", 512, 542, 30, 30);
    view.defPosition("R1", 542, 542, 30, 30);
    view.defPosition("Y1", 572, 542, 30, 30);
    view.defPosition("X0", 2, 572, 30, 30);
    view.defPosition("A0", 32, 572, 30, 30);
    view.defPosition("B0", 62, 572, 30, 30);
    view.defPosition("C0", 92, 572, 30, 30);
    view.defPosition("D0", 122, 572, 30, 30);
    view.defPosition("E0", 152, 572, 30, 30);
    view.defPosition("F0", 182, 572, 30, 30);
    view.defPosition("G0", 212, 572, 30, 30);
    view.defPosition("H0", 242, 572, 30, 30);
    view.defPosition("I0", 272, 572, 30, 30);
    view.defPosition("J0", 302, 572, 30, 30);
    view.defPosition("K0", 332, 572, 30, 30);
    view.defPosition("L0", 362, 572, 30, 30);
    view.defPosition("M0", 392, 572, 30, 30);
    view.defPosition("N0", 422, 572, 30, 30);
    view.defPosition("O0", 452, 572, 30, 30);
    view.defPosition("P0", 482, 572, 30, 30);
    view.defPosition("Q0", 512, 572, 30, 30);
    view.defPosition("R0", 542, 572, 30, 30);
    view.defPosition("Y0", 572, 572, 30, 30);
}
