Dagaz.Model.NO_SOUND = true;

ZRF = {
    JUMP:          0,
    IF:            1,
    FORK:          2,
    FUNCTION:      3,
    IN_ZONE:       4,
    FLAG:          5,
    SET_FLAG:      6,
    POS_FLAG:      7,
    SET_POS_FLAG:  8,
    ATTR:          9,
    SET_ATTR:      10,
    PROMOTE:       11,
    MODE:          12,
    ON_BOARD_DIR:  13,
    ON_BOARD_POS:  14,
    PARAM:         15,
    LITERAL:       16,
    VERIFY:        20
};

Dagaz.Model.BuildDesign = function(design) {
    design.checkVersion("z2j", "2");
    design.checkVersion("animate-drops", "false");
    design.checkVersion("animate-captures", "false");
    design.checkVersion("show-blink", "false");
    design.checkVersion("show-hints", "false");
    design.checkVersion("show-drops", "true");
    design.checkVersion("show-captures", "false");
    design.checkVersion("mine-setup", "46");

    design.addDirection("w");
    design.addDirection("e");
    design.addDirection("s");
    design.addDirection("ne");
    design.addDirection("n");
    design.addDirection("se");
    design.addDirection("sw");
    design.addDirection("nw");

    design.addPlayer("You", [1, 0, 4, 6, 2, 7, 3, 5]);

    design.addPosition("a16", [0, 1, 16, 0, 0, 17, 0, 0]);
    design.addPosition("b16", [-1, 1, 16, 0, 0, 17, 15, 0]);
    design.addPosition("c16", [-1, 1, 16, 0, 0, 17, 15, 0]);
    design.addPosition("d16", [-1, 1, 16, 0, 0, 17, 15, 0]);
    design.addPosition("e16", [-1, 1, 16, 0, 0, 17, 15, 0]);
    design.addPosition("f16", [-1, 1, 16, 0, 0, 17, 15, 0]);
    design.addPosition("g16", [-1, 1, 16, 0, 0, 17, 15, 0]);
    design.addPosition("h16", [-1, 1, 16, 0, 0, 17, 15, 0]);
    design.addPosition("i16", [-1, 1, 16, 0, 0, 17, 15, 0]);
    design.addPosition("j16", [-1, 1, 16, 0, 0, 17, 15, 0]);
    design.addPosition("k16", [-1, 1, 16, 0, 0, 17, 15, 0]);
    design.addPosition("l16", [-1, 1, 16, 0, 0, 17, 15, 0]);
    design.addPosition("m16", [-1, 1, 16, 0, 0, 17, 15, 0]);
    design.addPosition("n16", [-1, 1, 16, 0, 0, 17, 15, 0]);
    design.addPosition("o16", [-1, 1, 16, 0, 0, 17, 15, 0]);
    design.addPosition("p16", [-1, 0, 16, 0, 0, 0, 15, 0]);
    design.addPosition("a15", [0, 1, 16, -15, -16, 17, 0, 0]);
    design.addPosition("b15", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("c15", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("d15", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("e15", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("f15", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("g15", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("h15", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("i15", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("j15", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("k15", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("l15", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("m15", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("n15", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("o15", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("p15", [-1, 0, 16, 0, -16, 0, 15, -17]);
    design.addPosition("a14", [0, 1, 16, -15, -16, 17, 0, 0]);
    design.addPosition("b14", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("c14", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("d14", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("e14", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("f14", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("g14", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("h14", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("i14", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("j14", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("k14", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("l14", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("m14", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("n14", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("o14", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("p14", [-1, 0, 16, 0, -16, 0, 15, -17]);
    design.addPosition("a13", [0, 1, 16, -15, -16, 17, 0, 0]);
    design.addPosition("b13", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("c13", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("d13", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("e13", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("f13", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("g13", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("h13", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("i13", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("j13", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("k13", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("l13", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("m13", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("n13", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("o13", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("p13", [-1, 0, 16, 0, -16, 0, 15, -17]);
    design.addPosition("a12", [0, 1, 16, -15, -16, 17, 0, 0]);
    design.addPosition("b12", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("c12", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("d12", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("e12", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("f12", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("g12", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("h12", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("i12", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("j12", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("k12", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("l12", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("m12", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("n12", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("o12", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("p12", [-1, 0, 16, 0, -16, 0, 15, -17]);
    design.addPosition("a11", [0, 1, 16, -15, -16, 17, 0, 0]);
    design.addPosition("b11", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("c11", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("d11", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("e11", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("f11", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("g11", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("h11", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("i11", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("j11", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("k11", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("l11", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("m11", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("n11", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("o11", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("p11", [-1, 0, 16, 0, -16, 0, 15, -17]);
    design.addPosition("a10", [0, 1, 16, -15, -16, 17, 0, 0]);
    design.addPosition("b10", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("c10", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("d10", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("e10", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("f10", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("g10", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("h10", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("i10", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("j10", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("k10", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("l10", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("m10", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("n10", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("o10", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("p10", [-1, 0, 16, 0, -16, 0, 15, -17]);
    design.addPosition("a9", [0, 1, 16, -15, -16, 17, 0, 0]);
    design.addPosition("b9", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("c9", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("d9", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("e9", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("f9", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("g9", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("h9", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("i9", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("j9", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("k9", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("l9", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("m9", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("n9", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("o9", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("p9", [-1, 0, 16, 0, -16, 0, 15, -17]);
    design.addPosition("a8", [0, 1, 16, -15, -16, 17, 0, 0]);
    design.addPosition("b8", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("c8", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("d8", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("e8", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("f8", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("g8", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("h8", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("i8", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("j8", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("k8", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("l8", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("m8", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("n8", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("o8", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("p8", [-1, 0, 16, 0, -16, 0, 15, -17]);
    design.addPosition("a7", [0, 1, 16, -15, -16, 17, 0, 0]);
    design.addPosition("b7", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("c7", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("d7", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("e7", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("f7", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("g7", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("h7", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("i7", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("j7", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("k7", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("l7", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("m7", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("n7", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("o7", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("p7", [-1, 0, 16, 0, -16, 0, 15, -17]);
    design.addPosition("a6", [0, 1, 16, -15, -16, 17, 0, 0]);
    design.addPosition("b6", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("c6", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("d6", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("e6", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("f6", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("g6", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("h6", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("i6", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("j6", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("k6", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("l6", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("m6", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("n6", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("o6", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("p6", [-1, 0, 16, 0, -16, 0, 15, -17]);
    design.addPosition("a5", [0, 1, 16, -15, -16, 17, 0, 0]);
    design.addPosition("b5", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("c5", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("d5", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("e5", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("f5", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("g5", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("h5", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("i5", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("j5", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("k5", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("l5", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("m5", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("n5", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("o5", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("p5", [-1, 0, 16, 0, -16, 0, 15, -17]);
    design.addPosition("a4", [0, 1, 16, -15, -16, 17, 0, 0]);
    design.addPosition("b4", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("c4", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("d4", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("e4", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("f4", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("g4", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("h4", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("i4", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("j4", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("k4", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("l4", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("m4", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("n4", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("o4", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("p4", [-1, 0, 16, 0, -16, 0, 15, -17]);
    design.addPosition("a3", [0, 1, 16, -15, -16, 17, 0, 0]);
    design.addPosition("b3", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("c3", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("d3", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("e3", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("f3", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("g3", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("h3", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("i3", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("j3", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("k3", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("l3", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("m3", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("n3", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("o3", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("p3", [-1, 0, 16, 0, -16, 0, 15, -17]);
    design.addPosition("a2", [0, 1, 16, -15, -16, 17, 0, 0]);
    design.addPosition("b2", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("c2", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("d2", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("e2", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("f2", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("g2", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("h2", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("i2", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("j2", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("k2", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("l2", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("m2", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("n2", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("o2", [-1, 1, 16, -15, -16, 17, 15, -17]);
    design.addPosition("p2", [-1, 0, 16, 0, -16, 0, 15, -17]);
    design.addPosition("a1", [0, 1, 0, -15, -16, 0, 0, 0]);
    design.addPosition("b1", [-1, 1, 0, -15, -16, 0, 0, -17]);
    design.addPosition("c1", [-1, 1, 0, -15, -16, 0, 0, -17]);
    design.addPosition("d1", [-1, 1, 0, -15, -16, 0, 0, -17]);
    design.addPosition("e1", [-1, 1, 0, -15, -16, 0, 0, -17]);
    design.addPosition("f1", [-1, 1, 0, -15, -16, 0, 0, -17]);
    design.addPosition("g1", [-1, 1, 0, -15, -16, 0, 0, -17]);
    design.addPosition("h1", [-1, 1, 0, -15, -16, 0, 0, -17]);
    design.addPosition("i1", [-1, 1, 0, -15, -16, 0, 0, -17]);
    design.addPosition("j1", [-1, 1, 0, -15, -16, 0, 0, -17]);
    design.addPosition("k1", [-1, 1, 0, -15, -16, 0, 0, -17]);
    design.addPosition("l1", [-1, 1, 0, -15, -16, 0, 0, -17]);
    design.addPosition("m1", [-1, 1, 0, -15, -16, 0, 0, -17]);
    design.addPosition("n1", [-1, 1, 0, -15, -16, 0, 0, -17]);
    design.addPosition("o1", [-1, 1, 0, -15, -16, 0, 0, -17]);
    design.addPosition("p1", [-1, 0, 0, 0, -16, 0, 0, -17]);

    design.addCommand(0, ZRF.FUNCTION,	25);	// to
    design.addCommand(0, ZRF.FUNCTION,	28);	// end

    design.addPiece("p0", 0);
    design.addDrop(0, 0, [], 0);

    design.addPiece("p1", 1);
    design.addPiece("p2", 2);
    design.addPiece("p3", 3);
    design.addPiece("p4", 4);
    design.addPiece("p5", 5);
    design.addPiece("p6", 6);
    design.addPiece("p7", 7);
    design.addPiece("p8", 8);
    design.addPiece("invisible", 9);
    design.addPiece("boom", 10);
    design.addPiece("mine", 11);
}

Dagaz.View.configure = function(view) {
    view.defBoard("Board");
    view.defPiece("Youp0", "You p0");
    view.defPiece("Youp1", "You p1");
    view.defPiece("Youp2", "You p2");
    view.defPiece("Youp3", "You p3");
    view.defPiece("Youp4", "You p4");
    view.defPiece("Youp5", "You p5");
    view.defPiece("Youp6", "You p6");
    view.defPiece("Youp7", "You p7");
    view.defPiece("Youp8", "You p8");
    view.defPiece("Youinvisible", "You invisible");
    view.defPiece("Youboom", "You boom");
    view.defPiece("Youmine", "You mine");
    view.defPiece("Ko", "Ko");
 
    view.defPosition("a16", 0, 0, 32, 32);
    view.defPosition("b16", 32, 0, 32, 32);
    view.defPosition("c16", 64, 0, 32, 32);
    view.defPosition("d16", 96, 0, 32, 32);
    view.defPosition("e16", 128, 0, 32, 32);
    view.defPosition("f16", 160, 0, 32, 32);
    view.defPosition("g16", 192, 0, 32, 32);
    view.defPosition("h16", 224, 0, 32, 32);
    view.defPosition("i16", 256, 0, 32, 32);
    view.defPosition("j16", 288, 0, 32, 32);
    view.defPosition("k16", 320, 0, 32, 32);
    view.defPosition("l16", 352, 0, 32, 32);
    view.defPosition("m16", 384, 0, 32, 32);
    view.defPosition("n16", 416, 0, 32, 32);
    view.defPosition("o16", 448, 0, 32, 32);
    view.defPosition("p16", 480, 0, 32, 32);
    view.defPosition("a15", 0, 32, 32, 32);
    view.defPosition("b15", 32, 32, 32, 32);
    view.defPosition("c15", 64, 32, 32, 32);
    view.defPosition("d15", 96, 32, 32, 32);
    view.defPosition("e15", 128, 32, 32, 32);
    view.defPosition("f15", 160, 32, 32, 32);
    view.defPosition("g15", 192, 32, 32, 32);
    view.defPosition("h15", 224, 32, 32, 32);
    view.defPosition("i15", 256, 32, 32, 32);
    view.defPosition("j15", 288, 32, 32, 32);
    view.defPosition("k15", 320, 32, 32, 32);
    view.defPosition("l15", 352, 32, 32, 32);
    view.defPosition("m15", 384, 32, 32, 32);
    view.defPosition("n15", 416, 32, 32, 32);
    view.defPosition("o15", 448, 32, 32, 32);
    view.defPosition("p15", 480, 32, 32, 32);
    view.defPosition("a14", 0, 64, 32, 32);
    view.defPosition("b14", 32, 64, 32, 32);
    view.defPosition("c14", 64, 64, 32, 32);
    view.defPosition("d14", 96, 64, 32, 32);
    view.defPosition("e14", 128, 64, 32, 32);
    view.defPosition("f14", 160, 64, 32, 32);
    view.defPosition("g14", 192, 64, 32, 32);
    view.defPosition("h14", 224, 64, 32, 32);
    view.defPosition("i14", 256, 64, 32, 32);
    view.defPosition("j14", 288, 64, 32, 32);
    view.defPosition("k14", 320, 64, 32, 32);
    view.defPosition("l14", 352, 64, 32, 32);
    view.defPosition("m14", 384, 64, 32, 32);
    view.defPosition("n14", 416, 64, 32, 32);
    view.defPosition("o14", 448, 64, 32, 32);
    view.defPosition("p14", 480, 64, 32, 32);
    view.defPosition("a13", 0, 96, 32, 32);
    view.defPosition("b13", 32, 96, 32, 32);
    view.defPosition("c13", 64, 96, 32, 32);
    view.defPosition("d13", 96, 96, 32, 32);
    view.defPosition("e13", 128, 96, 32, 32);
    view.defPosition("f13", 160, 96, 32, 32);
    view.defPosition("g13", 192, 96, 32, 32);
    view.defPosition("h13", 224, 96, 32, 32);
    view.defPosition("i13", 256, 96, 32, 32);
    view.defPosition("j13", 288, 96, 32, 32);
    view.defPosition("k13", 320, 96, 32, 32);
    view.defPosition("l13", 352, 96, 32, 32);
    view.defPosition("m13", 384, 96, 32, 32);
    view.defPosition("n13", 416, 96, 32, 32);
    view.defPosition("o13", 448, 96, 32, 32);
    view.defPosition("p13", 480, 96, 32, 32);
    view.defPosition("a12", 0, 128, 32, 32);
    view.defPosition("b12", 32, 128, 32, 32);
    view.defPosition("c12", 64, 128, 32, 32);
    view.defPosition("d12", 96, 128, 32, 32);
    view.defPosition("e12", 128, 128, 32, 32);
    view.defPosition("f12", 160, 128, 32, 32);
    view.defPosition("g12", 192, 128, 32, 32);
    view.defPosition("h12", 224, 128, 32, 32);
    view.defPosition("i12", 256, 128, 32, 32);
    view.defPosition("j12", 288, 128, 32, 32);
    view.defPosition("k12", 320, 128, 32, 32);
    view.defPosition("l12", 352, 128, 32, 32);
    view.defPosition("m12", 384, 128, 32, 32);
    view.defPosition("n12", 416, 128, 32, 32);
    view.defPosition("o12", 448, 128, 32, 32);
    view.defPosition("p12", 480, 128, 32, 32);
    view.defPosition("a11", 0, 160, 32, 32);
    view.defPosition("b11", 32, 160, 32, 32);
    view.defPosition("c11", 64, 160, 32, 32);
    view.defPosition("d11", 96, 160, 32, 32);
    view.defPosition("e11", 128, 160, 32, 32);
    view.defPosition("f11", 160, 160, 32, 32);
    view.defPosition("g11", 192, 160, 32, 32);
    view.defPosition("h11", 224, 160, 32, 32);
    view.defPosition("i11", 256, 160, 32, 32);
    view.defPosition("j11", 288, 160, 32, 32);
    view.defPosition("k11", 320, 160, 32, 32);
    view.defPosition("l11", 352, 160, 32, 32);
    view.defPosition("m11", 384, 160, 32, 32);
    view.defPosition("n11", 416, 160, 32, 32);
    view.defPosition("o11", 448, 160, 32, 32);
    view.defPosition("p11", 480, 160, 32, 32);
    view.defPosition("a10", 0, 192, 32, 32);
    view.defPosition("b10", 32, 192, 32, 32);
    view.defPosition("c10", 64, 192, 32, 32);
    view.defPosition("d10", 96, 192, 32, 32);
    view.defPosition("e10", 128, 192, 32, 32);
    view.defPosition("f10", 160, 192, 32, 32);
    view.defPosition("g10", 192, 192, 32, 32);
    view.defPosition("h10", 224, 192, 32, 32);
    view.defPosition("i10", 256, 192, 32, 32);
    view.defPosition("j10", 288, 192, 32, 32);
    view.defPosition("k10", 320, 192, 32, 32);
    view.defPosition("l10", 352, 192, 32, 32);
    view.defPosition("m10", 384, 192, 32, 32);
    view.defPosition("n10", 416, 192, 32, 32);
    view.defPosition("o10", 448, 192, 32, 32);
    view.defPosition("p10", 480, 192, 32, 32);
    view.defPosition("a9", 0, 224, 32, 32);
    view.defPosition("b9", 32, 224, 32, 32);
    view.defPosition("c9", 64, 224, 32, 32);
    view.defPosition("d9", 96, 224, 32, 32);
    view.defPosition("e9", 128, 224, 32, 32);
    view.defPosition("f9", 160, 224, 32, 32);
    view.defPosition("g9", 192, 224, 32, 32);
    view.defPosition("h9", 224, 224, 32, 32);
    view.defPosition("i9", 256, 224, 32, 32);
    view.defPosition("j9", 288, 224, 32, 32);
    view.defPosition("k9", 320, 224, 32, 32);
    view.defPosition("l9", 352, 224, 32, 32);
    view.defPosition("m9", 384, 224, 32, 32);
    view.defPosition("n9", 416, 224, 32, 32);
    view.defPosition("o9", 448, 224, 32, 32);
    view.defPosition("p9", 480, 224, 32, 32);
    view.defPosition("a8", 0, 256, 32, 32);
    view.defPosition("b8", 32, 256, 32, 32);
    view.defPosition("c8", 64, 256, 32, 32);
    view.defPosition("d8", 96, 256, 32, 32);
    view.defPosition("e8", 128, 256, 32, 32);
    view.defPosition("f8", 160, 256, 32, 32);
    view.defPosition("g8", 192, 256, 32, 32);
    view.defPosition("h8", 224, 256, 32, 32);
    view.defPosition("i8", 256, 256, 32, 32);
    view.defPosition("j8", 288, 256, 32, 32);
    view.defPosition("k8", 320, 256, 32, 32);
    view.defPosition("l8", 352, 256, 32, 32);
    view.defPosition("m8", 384, 256, 32, 32);
    view.defPosition("n8", 416, 256, 32, 32);
    view.defPosition("o8", 448, 256, 32, 32);
    view.defPosition("p8", 480, 256, 32, 32);
    view.defPosition("a7", 0, 288, 32, 32);
    view.defPosition("b7", 32, 288, 32, 32);
    view.defPosition("c7", 64, 288, 32, 32);
    view.defPosition("d7", 96, 288, 32, 32);
    view.defPosition("e7", 128, 288, 32, 32);
    view.defPosition("f7", 160, 288, 32, 32);
    view.defPosition("g7", 192, 288, 32, 32);
    view.defPosition("h7", 224, 288, 32, 32);
    view.defPosition("i7", 256, 288, 32, 32);
    view.defPosition("j7", 288, 288, 32, 32);
    view.defPosition("k7", 320, 288, 32, 32);
    view.defPosition("l7", 352, 288, 32, 32);
    view.defPosition("m7", 384, 288, 32, 32);
    view.defPosition("n7", 416, 288, 32, 32);
    view.defPosition("o7", 448, 288, 32, 32);
    view.defPosition("p7", 480, 288, 32, 32);
    view.defPosition("a6", 0, 320, 32, 32);
    view.defPosition("b6", 32, 320, 32, 32);
    view.defPosition("c6", 64, 320, 32, 32);
    view.defPosition("d6", 96, 320, 32, 32);
    view.defPosition("e6", 128, 320, 32, 32);
    view.defPosition("f6", 160, 320, 32, 32);
    view.defPosition("g6", 192, 320, 32, 32);
    view.defPosition("h6", 224, 320, 32, 32);
    view.defPosition("i6", 256, 320, 32, 32);
    view.defPosition("j6", 288, 320, 32, 32);
    view.defPosition("k6", 320, 320, 32, 32);
    view.defPosition("l6", 352, 320, 32, 32);
    view.defPosition("m6", 384, 320, 32, 32);
    view.defPosition("n6", 416, 320, 32, 32);
    view.defPosition("o6", 448, 320, 32, 32);
    view.defPosition("p6", 480, 320, 32, 32);
    view.defPosition("a5", 0, 352, 32, 32);
    view.defPosition("b5", 32, 352, 32, 32);
    view.defPosition("c5", 64, 352, 32, 32);
    view.defPosition("d5", 96, 352, 32, 32);
    view.defPosition("e5", 128, 352, 32, 32);
    view.defPosition("f5", 160, 352, 32, 32);
    view.defPosition("g5", 192, 352, 32, 32);
    view.defPosition("h5", 224, 352, 32, 32);
    view.defPosition("i5", 256, 352, 32, 32);
    view.defPosition("j5", 288, 352, 32, 32);
    view.defPosition("k5", 320, 352, 32, 32);
    view.defPosition("l5", 352, 352, 32, 32);
    view.defPosition("m5", 384, 352, 32, 32);
    view.defPosition("n5", 416, 352, 32, 32);
    view.defPosition("o5", 448, 352, 32, 32);
    view.defPosition("p5", 480, 352, 32, 32);
    view.defPosition("a4", 0, 384, 32, 32);
    view.defPosition("b4", 32, 384, 32, 32);
    view.defPosition("c4", 64, 384, 32, 32);
    view.defPosition("d4", 96, 384, 32, 32);
    view.defPosition("e4", 128, 384, 32, 32);
    view.defPosition("f4", 160, 384, 32, 32);
    view.defPosition("g4", 192, 384, 32, 32);
    view.defPosition("h4", 224, 384, 32, 32);
    view.defPosition("i4", 256, 384, 32, 32);
    view.defPosition("j4", 288, 384, 32, 32);
    view.defPosition("k4", 320, 384, 32, 32);
    view.defPosition("l4", 352, 384, 32, 32);
    view.defPosition("m4", 384, 384, 32, 32);
    view.defPosition("n4", 416, 384, 32, 32);
    view.defPosition("o4", 448, 384, 32, 32);
    view.defPosition("p4", 480, 384, 32, 32);
    view.defPosition("a3", 0, 416, 32, 32);
    view.defPosition("b3", 32, 416, 32, 32);
    view.defPosition("c3", 64, 416, 32, 32);
    view.defPosition("d3", 96, 416, 32, 32);
    view.defPosition("e3", 128, 416, 32, 32);
    view.defPosition("f3", 160, 416, 32, 32);
    view.defPosition("g3", 192, 416, 32, 32);
    view.defPosition("h3", 224, 416, 32, 32);
    view.defPosition("i3", 256, 416, 32, 32);
    view.defPosition("j3", 288, 416, 32, 32);
    view.defPosition("k3", 320, 416, 32, 32);
    view.defPosition("l3", 352, 416, 32, 32);
    view.defPosition("m3", 384, 416, 32, 32);
    view.defPosition("n3", 416, 416, 32, 32);
    view.defPosition("o3", 448, 416, 32, 32);
    view.defPosition("p3", 480, 416, 32, 32);
    view.defPosition("a2", 0, 448, 32, 32);
    view.defPosition("b2", 32, 448, 32, 32);
    view.defPosition("c2", 64, 448, 32, 32);
    view.defPosition("d2", 96, 448, 32, 32);
    view.defPosition("e2", 128, 448, 32, 32);
    view.defPosition("f2", 160, 448, 32, 32);
    view.defPosition("g2", 192, 448, 32, 32);
    view.defPosition("h2", 224, 448, 32, 32);
    view.defPosition("i2", 256, 448, 32, 32);
    view.defPosition("j2", 288, 448, 32, 32);
    view.defPosition("k2", 320, 448, 32, 32);
    view.defPosition("l2", 352, 448, 32, 32);
    view.defPosition("m2", 384, 448, 32, 32);
    view.defPosition("n2", 416, 448, 32, 32);
    view.defPosition("o2", 448, 448, 32, 32);
    view.defPosition("p2", 480, 448, 32, 32);
    view.defPosition("a1", 0, 480, 32, 32);
    view.defPosition("b1", 32, 480, 32, 32);
    view.defPosition("c1", 64, 480, 32, 32);
    view.defPosition("d1", 96, 480, 32, 32);
    view.defPosition("e1", 128, 480, 32, 32);
    view.defPosition("f1", 160, 480, 32, 32);
    view.defPosition("g1", 192, 480, 32, 32);
    view.defPosition("h1", 224, 480, 32, 32);
    view.defPosition("i1", 256, 480, 32, 32);
    view.defPosition("j1", 288, 480, 32, 32);
    view.defPosition("k1", 320, 480, 32, 32);
    view.defPosition("l1", 352, 480, 32, 32);
    view.defPosition("m1", 384, 480, 32, 32);
    view.defPosition("n1", 416, 480, 32, 32);
    view.defPosition("o1", 448, 480, 32, 32);
    view.defPosition("p1", 480, 480, 32, 32);
}
