Dagaz.Model.WIDTH  = 13;
Dagaz.Model.HEIGHT = 13;

ZRF = {
    JUMP:          0,
    IF:            1,
    FORK:          2,
    FUNCTION:      3,
    IN_ZONE:       4,
    FLAG:          5,
    SET_FLAG:      6,
    POS_FLAG:      7,
    SET_POS_FLAG:  8,
    ATTR:          9,
    SET_ATTR:      10,
    PROMOTE:       11,
    MODE:          12,
    ON_BOARD_DIR:  13,
    ON_BOARD_POS:  14,
    PARAM:         15,
    LITERAL:       16,
    VERIFY:        20
};

Dagaz.Model.BuildDesign = function(design) {
    design.checkVersion("z2j", "2");
    design.checkVersion("animate-drops", "false");
    design.checkVersion("animate-captures", "false");
    design.checkVersion("show-blink", "false");
    design.checkVersion("show-hints", "false");
    design.checkVersion("show-drops", "true");
    design.checkVersion("show-captures", "false");
    design.checkVersion("animate-redo", "false");

    design.addDirection("s");
    design.addDirection("e");
    design.addDirection("w");
    design.addDirection("n");

    design.addPlayer("Black", [3, 2, 1, 0]);
    design.addPlayer("White", [0, 1, 2, 3]);

    design.addPosition("a13", [13, 1, 0, 0]);
    design.addPosition("b13", [13, 1, -1, 0]);
    design.addPosition("c13", [13, 1, -1, 0]);
    design.addPosition("d13", [13, 1, -1, 0]);
    design.addPosition("e13", [13, 1, -1, 0]);
    design.addPosition("f13", [13, 1, -1, 0]);
    design.addPosition("g13", [13, 1, -1, 0]);
    design.addPosition("h13", [13, 1, -1, 0]);
    design.addPosition("i13", [13, 1, -1, 0]);
    design.addPosition("j13", [13, 1, -1, 0]);
    design.addPosition("k13", [13, 1, -1, 0]);
    design.addPosition("l13", [13, 1, -1, 0]);
    design.addPosition("m13", [13, 0, -1, 0]);
    design.addPosition("a12", [13, 1, 0, -13]);
    design.addPosition("b12", [13, 1, -1, -13]);
    design.addPosition("c12", [13, 1, -1, -13]);
    design.addPosition("d12", [13, 1, -1, -13]);
    design.addPosition("e12", [13, 1, -1, -13]);
    design.addPosition("f12", [13, 1, -1, -13]);
    design.addPosition("g12", [13, 1, -1, -13]);
    design.addPosition("h12", [13, 1, -1, -13]);
    design.addPosition("i12", [13, 1, -1, -13]);
    design.addPosition("j12", [13, 1, -1, -13]);
    design.addPosition("k12", [13, 1, -1, -13]);
    design.addPosition("l12", [13, 1, -1, -13]);
    design.addPosition("m12", [13, 0, -1, -13]);
    design.addPosition("a11", [13, 1, 0, -13]);
    design.addPosition("b11", [13, 1, -1, -13]);
    design.addPosition("c11", [13, 1, -1, -13]);
    design.addPosition("d11", [13, 1, -1, -13]);
    design.addPosition("e11", [13, 1, -1, -13]);
    design.addPosition("f11", [13, 1, -1, -13]);
    design.addPosition("g11", [13, 1, -1, -13]);
    design.addPosition("h11", [13, 1, -1, -13]);
    design.addPosition("i11", [13, 1, -1, -13]);
    design.addPosition("j11", [13, 1, -1, -13]);
    design.addPosition("k11", [13, 1, -1, -13]);
    design.addPosition("l11", [13, 1, -1, -13]);
    design.addPosition("m11", [13, 0, -1, -13]);
    design.addPosition("a10", [13, 1, 0, -13]);
    design.addPosition("b10", [13, 1, -1, -13]);
    design.addPosition("c10", [13, 1, -1, -13]);
    design.addPosition("d10", [13, 1, -1, -13]);
    design.addPosition("e10", [13, 1, -1, -13]);
    design.addPosition("f10", [13, 1, -1, -13]);
    design.addPosition("g10", [13, 1, -1, -13]);
    design.addPosition("h10", [13, 1, -1, -13]);
    design.addPosition("i10", [13, 1, -1, -13]);
    design.addPosition("j10", [13, 1, -1, -13]);
    design.addPosition("k10", [13, 1, -1, -13]);
    design.addPosition("l10", [13, 1, -1, -13]);
    design.addPosition("m10", [13, 0, -1, -13]);
    design.addPosition("a9", [13, 1, 0, -13]);
    design.addPosition("b9", [13, 1, -1, -13]);
    design.addPosition("c9", [13, 1, -1, -13]);
    design.addPosition("d9", [13, 1, -1, -13]);
    design.addPosition("e9", [13, 1, -1, -13]);
    design.addPosition("f9", [13, 1, -1, -13]);
    design.addPosition("g9", [13, 1, -1, -13]);
    design.addPosition("h9", [13, 1, -1, -13]);
    design.addPosition("i9", [13, 1, -1, -13]);
    design.addPosition("j9", [13, 1, -1, -13]);
    design.addPosition("k9", [13, 1, -1, -13]);
    design.addPosition("l9", [13, 1, -1, -13]);
    design.addPosition("m9", [13, 0, -1, -13]);
    design.addPosition("a8", [13, 1, 0, -13]);
    design.addPosition("b8", [13, 1, -1, -13]);
    design.addPosition("c8", [13, 1, -1, -13]);
    design.addPosition("d8", [13, 1, -1, -13]);
    design.addPosition("e8", [13, 1, -1, -13]);
    design.addPosition("f8", [13, 1, -1, -13]);
    design.addPosition("g8", [13, 1, -1, -13]);
    design.addPosition("h8", [13, 1, -1, -13]);
    design.addPosition("i8", [13, 1, -1, -13]);
    design.addPosition("j8", [13, 1, -1, -13]);
    design.addPosition("k8", [13, 1, -1, -13]);
    design.addPosition("l8", [13, 1, -1, -13]);
    design.addPosition("m8", [13, 0, -1, -13]);
    design.addPosition("a7", [13, 1, 0, -13]);
    design.addPosition("b7", [13, 1, -1, -13]);
    design.addPosition("c7", [13, 1, -1, -13]);
    design.addPosition("d7", [13, 1, -1, -13]);
    design.addPosition("e7", [13, 1, -1, -13]);
    design.addPosition("f7", [13, 1, -1, -13]);
    design.addPosition("g7", [13, 1, -1, -13]);
    design.addPosition("h7", [13, 1, -1, -13]);
    design.addPosition("i7", [13, 1, -1, -13]);
    design.addPosition("j7", [13, 1, -1, -13]);
    design.addPosition("k7", [13, 1, -1, -13]);
    design.addPosition("l7", [13, 1, -1, -13]);
    design.addPosition("m7", [13, 0, -1, -13]);
    design.addPosition("a6", [13, 1, 0, -13]);
    design.addPosition("b6", [13, 1, -1, -13]);
    design.addPosition("c6", [13, 1, -1, -13]);
    design.addPosition("d6", [13, 1, -1, -13]);
    design.addPosition("e6", [13, 1, -1, -13]);
    design.addPosition("f6", [13, 1, -1, -13]);
    design.addPosition("g6", [13, 1, -1, -13]);
    design.addPosition("h6", [13, 1, -1, -13]);
    design.addPosition("i6", [13, 1, -1, -13]);
    design.addPosition("j6", [13, 1, -1, -13]);
    design.addPosition("k6", [13, 1, -1, -13]);
    design.addPosition("l6", [13, 1, -1, -13]);
    design.addPosition("m6", [13, 0, -1, -13]);
    design.addPosition("a5", [13, 1, 0, -13]);
    design.addPosition("b5", [13, 1, -1, -13]);
    design.addPosition("c5", [13, 1, -1, -13]);
    design.addPosition("d5", [13, 1, -1, -13]);
    design.addPosition("e5", [13, 1, -1, -13]);
    design.addPosition("f5", [13, 1, -1, -13]);
    design.addPosition("g5", [13, 1, -1, -13]);
    design.addPosition("h5", [13, 1, -1, -13]);
    design.addPosition("i5", [13, 1, -1, -13]);
    design.addPosition("j5", [13, 1, -1, -13]);
    design.addPosition("k5", [13, 1, -1, -13]);
    design.addPosition("l5", [13, 1, -1, -13]);
    design.addPosition("m5", [13, 0, -1, -13]);
    design.addPosition("a4", [13, 1, 0, -13]);
    design.addPosition("b4", [13, 1, -1, -13]);
    design.addPosition("c4", [13, 1, -1, -13]);
    design.addPosition("d4", [13, 1, -1, -13]);
    design.addPosition("e4", [13, 1, -1, -13]);
    design.addPosition("f4", [13, 1, -1, -13]);
    design.addPosition("g4", [13, 1, -1, -13]);
    design.addPosition("h4", [13, 1, -1, -13]);
    design.addPosition("i4", [13, 1, -1, -13]);
    design.addPosition("j4", [13, 1, -1, -13]);
    design.addPosition("k4", [13, 1, -1, -13]);
    design.addPosition("l4", [13, 1, -1, -13]);
    design.addPosition("m4", [13, 0, -1, -13]);
    design.addPosition("a3", [13, 1, 0, -13]);
    design.addPosition("b3", [13, 1, -1, -13]);
    design.addPosition("c3", [13, 1, -1, -13]);
    design.addPosition("d3", [13, 1, -1, -13]);
    design.addPosition("e3", [13, 1, -1, -13]);
    design.addPosition("f3", [13, 1, -1, -13]);
    design.addPosition("g3", [13, 1, -1, -13]);
    design.addPosition("h3", [13, 1, -1, -13]);
    design.addPosition("i3", [13, 1, -1, -13]);
    design.addPosition("j3", [13, 1, -1, -13]);
    design.addPosition("k3", [13, 1, -1, -13]);
    design.addPosition("l3", [13, 1, -1, -13]);
    design.addPosition("m3", [13, 0, -1, -13]);
    design.addPosition("a2", [13, 1, 0, -13]);
    design.addPosition("b2", [13, 1, -1, -13]);
    design.addPosition("c2", [13, 1, -1, -13]);
    design.addPosition("d2", [13, 1, -1, -13]);
    design.addPosition("e2", [13, 1, -1, -13]);
    design.addPosition("f2", [13, 1, -1, -13]);
    design.addPosition("g2", [13, 1, -1, -13]);
    design.addPosition("h2", [13, 1, -1, -13]);
    design.addPosition("i2", [13, 1, -1, -13]);
    design.addPosition("j2", [13, 1, -1, -13]);
    design.addPosition("k2", [13, 1, -1, -13]);
    design.addPosition("l2", [13, 1, -1, -13]);
    design.addPosition("m2", [13, 0, -1, -13]);
    design.addPosition("a1", [0, 1, 0, -13]);
    design.addPosition("b1", [0, 1, -1, -13]);
    design.addPosition("c1", [0, 1, -1, -13]);
    design.addPosition("d1", [0, 1, -1, -13]);
    design.addPosition("e1", [0, 1, -1, -13]);
    design.addPosition("f1", [0, 1, -1, -13]);
    design.addPosition("g1", [0, 1, -1, -13]);
    design.addPosition("h1", [0, 1, -1, -13]);
    design.addPosition("i1", [0, 1, -1, -13]);
    design.addPosition("j1", [0, 1, -1, -13]);
    design.addPosition("k1", [0, 1, -1, -13]);
    design.addPosition("l1", [0, 1, -1, -13]);
    design.addPosition("m1", [0, 0, -1, -13]);

    design.addZone("left", 2, [156, 143, 130, 117, 104, 91, 78, 65, 52, 39, 26, 13, 0]);
    design.addZone("left", 1, [156, 143, 130, 117, 104, 91, 78, 65, 52, 39, 26, 13, 0]);
    design.addZone("top", 2, [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12]);
    design.addZone("top", 1, [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12]);
    design.addZone("right", 2, [168, 155, 142, 129, 116, 103, 90, 77, 64, 51, 38, 25, 12]);
    design.addZone("right", 1, [168, 155, 142, 129, 116, 103, 90, 77, 64, 51, 38, 25, 12]);
    design.addZone("bottom", 2, [156, 157, 158, 159, 160, 161, 162, 163, 164, 165, 166, 167, 168]);
    design.addZone("bottom", 1, [156, 157, 158, 159, 160, 161, 162, 163, 164, 165, 166, 167, 168]);

    design.addCommand(0, ZRF.FUNCTION,	3);	// friend?
    design.addCommand(0, ZRF.FUNCTION,	0);	// not
    design.addCommand(0, ZRF.FUNCTION,	20);	// verify
    design.addCommand(0, ZRF.FUNCTION,	25);	// to
    design.addCommand(0, ZRF.FUNCTION,	28);	// end

    design.addPiece("Stone", 0);
    design.addDrop(0, 0, [], 0);
}

Dagaz.View.configure = function(view) {
    view.defBoard("Board");
    view.defPiece("BlackStone", "Black Stone");
    view.defPiece("WhiteStone", "White Stone");
    view.defPiece("Ko", "Ko");
 
    view.defPosition("a13", 8, 8, 28, 28);
    view.defPosition("b13", 36, 8, 28, 28);
    view.defPosition("c13", 64, 8, 28, 28);
    view.defPosition("d13", 92, 8, 28, 28);
    view.defPosition("e13", 120, 8, 28, 28);
    view.defPosition("f13", 148, 8, 28, 28);
    view.defPosition("g13", 176, 8, 28, 28);
    view.defPosition("h13", 204, 8, 28, 28);
    view.defPosition("i13", 232, 8, 28, 28);
    view.defPosition("j13", 260, 8, 28, 28);
    view.defPosition("k13", 288, 8, 28, 28);
    view.defPosition("l13", 316, 8, 28, 28);
    view.defPosition("m13", 344, 8, 28, 28);
    view.defPosition("a12", 8, 36, 28, 28);
    view.defPosition("b12", 36, 36, 28, 28);
    view.defPosition("c12", 64, 36, 28, 28);
    view.defPosition("d12", 92, 36, 28, 28);
    view.defPosition("e12", 120, 36, 28, 28);
    view.defPosition("f12", 148, 36, 28, 28);
    view.defPosition("g12", 176, 36, 28, 28);
    view.defPosition("h12", 204, 36, 28, 28);
    view.defPosition("i12", 232, 36, 28, 28);
    view.defPosition("j12", 260, 36, 28, 28);
    view.defPosition("k12", 288, 36, 28, 28);
    view.defPosition("l12", 316, 36, 28, 28);
    view.defPosition("m12", 344, 36, 28, 28);
    view.defPosition("a11", 8, 64, 28, 28);
    view.defPosition("b11", 36, 64, 28, 28);
    view.defPosition("c11", 64, 64, 28, 28);
    view.defPosition("d11", 92, 64, 28, 28);
    view.defPosition("e11", 120, 64, 28, 28);
    view.defPosition("f11", 148, 64, 28, 28);
    view.defPosition("g11", 176, 64, 28, 28);
    view.defPosition("h11", 204, 64, 28, 28);
    view.defPosition("i11", 232, 64, 28, 28);
    view.defPosition("j11", 260, 64, 28, 28);
    view.defPosition("k11", 288, 64, 28, 28);
    view.defPosition("l11", 316, 64, 28, 28);
    view.defPosition("m11", 344, 64, 28, 28);
    view.defPosition("a10", 8, 92, 28, 28);
    view.defPosition("b10", 36, 92, 28, 28);
    view.defPosition("c10", 64, 92, 28, 28);
    view.defPosition("d10", 92, 92, 28, 28);
    view.defPosition("e10", 120, 92, 28, 28);
    view.defPosition("f10", 148, 92, 28, 28);
    view.defPosition("g10", 176, 92, 28, 28);
    view.defPosition("h10", 204, 92, 28, 28);
    view.defPosition("i10", 232, 92, 28, 28);
    view.defPosition("j10", 260, 92, 28, 28);
    view.defPosition("k10", 288, 92, 28, 28);
    view.defPosition("l10", 316, 92, 28, 28);
    view.defPosition("m10", 344, 92, 28, 28);
    view.defPosition("a9", 8, 120, 28, 28);
    view.defPosition("b9", 36, 120, 28, 28);
    view.defPosition("c9", 64, 120, 28, 28);
    view.defPosition("d9", 92, 120, 28, 28);
    view.defPosition("e9", 120, 120, 28, 28);
    view.defPosition("f9", 148, 120, 28, 28);
    view.defPosition("g9", 176, 120, 28, 28);
    view.defPosition("h9", 204, 120, 28, 28);
    view.defPosition("i9", 232, 120, 28, 28);
    view.defPosition("j9", 260, 120, 28, 28);
    view.defPosition("k9", 288, 120, 28, 28);
    view.defPosition("l9", 316, 120, 28, 28);
    view.defPosition("m9", 344, 120, 28, 28);
    view.defPosition("a8", 8, 148, 28, 28);
    view.defPosition("b8", 36, 148, 28, 28);
    view.defPosition("c8", 64, 148, 28, 28);
    view.defPosition("d8", 92, 148, 28, 28);
    view.defPosition("e8", 120, 148, 28, 28);
    view.defPosition("f8", 148, 148, 28, 28);
    view.defPosition("g8", 176, 148, 28, 28);
    view.defPosition("h8", 204, 148, 28, 28);
    view.defPosition("i8", 232, 148, 28, 28);
    view.defPosition("j8", 260, 148, 28, 28);
    view.defPosition("k8", 288, 148, 28, 28);
    view.defPosition("l8", 316, 148, 28, 28);
    view.defPosition("m8", 344, 148, 28, 28);
    view.defPosition("a7", 8, 176, 28, 28);
    view.defPosition("b7", 36, 176, 28, 28);
    view.defPosition("c7", 64, 176, 28, 28);
    view.defPosition("d7", 92, 176, 28, 28);
    view.defPosition("e7", 120, 176, 28, 28);
    view.defPosition("f7", 148, 176, 28, 28);
    view.defPosition("g7", 176, 176, 28, 28);
    view.defPosition("h7", 204, 176, 28, 28);
    view.defPosition("i7", 232, 176, 28, 28);
    view.defPosition("j7", 260, 176, 28, 28);
    view.defPosition("k7", 288, 176, 28, 28);
    view.defPosition("l7", 316, 176, 28, 28);
    view.defPosition("m7", 344, 176, 28, 28);
    view.defPosition("a6", 8, 204, 28, 28);
    view.defPosition("b6", 36, 204, 28, 28);
    view.defPosition("c6", 64, 204, 28, 28);
    view.defPosition("d6", 92, 204, 28, 28);
    view.defPosition("e6", 120, 204, 28, 28);
    view.defPosition("f6", 148, 204, 28, 28);
    view.defPosition("g6", 176, 204, 28, 28);
    view.defPosition("h6", 204, 204, 28, 28);
    view.defPosition("i6", 232, 204, 28, 28);
    view.defPosition("j6", 260, 204, 28, 28);
    view.defPosition("k6", 288, 204, 28, 28);
    view.defPosition("l6", 316, 204, 28, 28);
    view.defPosition("m6", 344, 204, 28, 28);
    view.defPosition("a5", 8, 232, 28, 28);
    view.defPosition("b5", 36, 232, 28, 28);
    view.defPosition("c5", 64, 232, 28, 28);
    view.defPosition("d5", 92, 232, 28, 28);
    view.defPosition("e5", 120, 232, 28, 28);
    view.defPosition("f5", 148, 232, 28, 28);
    view.defPosition("g5", 176, 232, 28, 28);
    view.defPosition("h5", 204, 232, 28, 28);
    view.defPosition("i5", 232, 232, 28, 28);
    view.defPosition("j5", 260, 232, 28, 28);
    view.defPosition("k5", 288, 232, 28, 28);
    view.defPosition("l5", 316, 232, 28, 28);
    view.defPosition("m5", 344, 232, 28, 28);
    view.defPosition("a4", 8, 260, 28, 28);
    view.defPosition("b4", 36, 260, 28, 28);
    view.defPosition("c4", 64, 260, 28, 28);
    view.defPosition("d4", 92, 260, 28, 28);
    view.defPosition("e4", 120, 260, 28, 28);
    view.defPosition("f4", 148, 260, 28, 28);
    view.defPosition("g4", 176, 260, 28, 28);
    view.defPosition("h4", 204, 260, 28, 28);
    view.defPosition("i4", 232, 260, 28, 28);
    view.defPosition("j4", 260, 260, 28, 28);
    view.defPosition("k4", 288, 260, 28, 28);
    view.defPosition("l4", 316, 260, 28, 28);
    view.defPosition("m4", 344, 260, 28, 28);
    view.defPosition("a3", 8, 288, 28, 28);
    view.defPosition("b3", 36, 288, 28, 28);
    view.defPosition("c3", 64, 288, 28, 28);
    view.defPosition("d3", 92, 288, 28, 28);
    view.defPosition("e3", 120, 288, 28, 28);
    view.defPosition("f3", 148, 288, 28, 28);
    view.defPosition("g3", 176, 288, 28, 28);
    view.defPosition("h3", 204, 288, 28, 28);
    view.defPosition("i3", 232, 288, 28, 28);
    view.defPosition("j3", 260, 288, 28, 28);
    view.defPosition("k3", 288, 288, 28, 28);
    view.defPosition("l3", 316, 288, 28, 28);
    view.defPosition("m3", 344, 288, 28, 28);
    view.defPosition("a2", 8, 316, 28, 28);
    view.defPosition("b2", 36, 316, 28, 28);
    view.defPosition("c2", 64, 316, 28, 28);
    view.defPosition("d2", 92, 316, 28, 28);
    view.defPosition("e2", 120, 316, 28, 28);
    view.defPosition("f2", 148, 316, 28, 28);
    view.defPosition("g2", 176, 316, 28, 28);
    view.defPosition("h2", 204, 316, 28, 28);
    view.defPosition("i2", 232, 316, 28, 28);
    view.defPosition("j2", 260, 316, 28, 28);
    view.defPosition("k2", 288, 316, 28, 28);
    view.defPosition("l2", 316, 316, 28, 28);
    view.defPosition("m2", 344, 316, 28, 28);
    view.defPosition("a1", 8, 344, 28, 28);
    view.defPosition("b1", 36, 344, 28, 28);
    view.defPosition("c1", 64, 344, 28, 28);
    view.defPosition("d1", 92, 344, 28, 28);
    view.defPosition("e1", 120, 344, 28, 28);
    view.defPosition("f1", 148, 344, 28, 28);
    view.defPosition("g1", 176, 344, 28, 28);
    view.defPosition("h1", 204, 344, 28, 28);
    view.defPosition("i1", 232, 344, 28, 28);
    view.defPosition("j1", 260, 344, 28, 28);
    view.defPosition("k1", 288, 344, 28, 28);
    view.defPosition("l1", 316, 344, 28, 28);
    view.defPosition("m1", 344, 344, 28, 28);
}
