Dagaz.Controller.noDropIndex = true;
Dagaz.Controller.cyclicDropIndex = true;

ZRF = {
    JUMP:          0,
    IF:            1,
    FORK:          2,
    FUNCTION:      3,
    IN_ZONE:       4,
    FLAG:          5,
    SET_FLAG:      6,
    POS_FLAG:      7,
    SET_POS_FLAG:  8,
    ATTR:          9,
    SET_ATTR:      10,
    PROMOTE:       11,
    MODE:          12,
    ON_BOARD_DIR:  13,
    ON_BOARD_POS:  14,
    PARAM:         15,
    LITERAL:       16,
    VERIFY:        20
};

Dagaz.Model.BuildDesign = function(design) {
    design.checkVersion("z2j", "2");
    design.checkVersion("animate-drops", "false");
    design.checkVersion("animate-captures", "false");
    design.checkVersion("show-captures", "false");
    design.checkVersion("show-blink", "false");
    design.checkVersion("show-hints", "false");
    design.checkVersion("show-drops", "true");

    design.addDirection("n");   // 0
    design.addDirection("e");   // 1
    design.addDirection("w");   // 2
    design.addDirection("s");   // 3
    design.addDirection("une"); // 4
    design.addDirection("dsw"); // 5
    design.addDirection("unw"); // 6
    design.addDirection("dse"); // 7
    design.addDirection("use"); // 8
    design.addDirection("dnw"); // 9
    design.addDirection("usw"); // 10
    design.addDirection("dne"); // 11

    design.addPlayer("You", [3, 2, 1, 0, 5, 4, 7, 6, 9, 8, 11, 10]);

    design.addPosition("aa9", [0, 9, 0, 1, 0, 0, 0, 0, 81, 0, 0, 0]);
    design.addPosition("aa8", [-1, 9, 0, 1, 80, 0, 0, 0, 81, 0, 0, 0]);
    design.addPosition("aa7", [-1, 9, 0, 1, 80, 0, 0, 0, 81, 0, 0, 0]);
    design.addPosition("aa6", [-1, 9, 0, 1, 80, 0, 0, 0, 81, 0, 0, 0]);
    design.addPosition("aa5", [-1, 9, 0, 1, 80, 0, 0, 0, 81, 0, 0, 0]);
    design.addPosition("aa4", [-1, 9, 0, 1, 80, 0, 0, 0, 81, 0, 0, 0]);
    design.addPosition("aa3", [-1, 9, 0, 1, 80, 0, 0, 0, 81, 0, 0, 0]);
    design.addPosition("aa2", [-1, 9, 0, 1, 80, 0, 0, 0, 81, 0, 0, 0]);
    design.addPosition("aa1", [-1, 9, 0, 0, 80, 0, 0, 0, 0, 0, 0, 0]);
    design.addPosition("ab9", [0, 9, -9, 1, 0, 0, 0, 0, 80, 0, 72, 0]);
    design.addPosition("ab8", [-1, 9, -9, 1, 79, 0, 71, 0, 80, 0, 72, 0]);
    design.addPosition("ab7", [-1, 9, -9, 1, 79, 0, 71, 0, 80, 0, 72, 0]);
    design.addPosition("ab6", [-1, 9, -9, 1, 79, 0, 71, 0, 80, 0, 72, 0]);
    design.addPosition("ab5", [-1, 9, -9, 1, 79, 0, 71, 0, 80, 0, 72, 0]);
    design.addPosition("ab4", [-1, 9, -9, 1, 79, 0, 71, 0, 80, 0, 72, 0]);
    design.addPosition("ab3", [-1, 9, -9, 1, 79, 0, 71, 0, 80, 0, 72, 0]);
    design.addPosition("ab2", [-1, 9, -9, 1, 79, 0, 71, 0, 80, 0, 72, 0]);
    design.addPosition("ab1", [-1, 9, -9, 0, 79, 0, 71, 0, 0, 0, 0, 0]);
    design.addPosition("ac9", [0, 9, -9, 1, 0, 0, 0, 0, 79, 0, 71, 0]);
    design.addPosition("ac8", [-1, 9, -9, 1, 78, 0, 70, 0, 79, 0, 71, 0]);
    design.addPosition("ac7", [-1, 9, -9, 1, 78, 0, 70, 0, 79, 0, 71, 0]);
    design.addPosition("ac6", [-1, 9, -9, 1, 78, 0, 70, 0, 79, 0, 71, 0]);
    design.addPosition("ac5", [-1, 9, -9, 1, 78, 0, 70, 0, 79, 0, 71, 0]);
    design.addPosition("ac4", [-1, 9, -9, 1, 78, 0, 70, 0, 79, 0, 71, 0]);
    design.addPosition("ac3", [-1, 9, -9, 1, 78, 0, 70, 0, 79, 0, 71, 0]);
    design.addPosition("ac2", [-1, 9, -9, 1, 78, 0, 70, 0, 79, 0, 71, 0]);
    design.addPosition("ac1", [-1, 9, -9, 0, 78, 0, 70, 0, 0, 0, 0, 0]);
    design.addPosition("ad9", [0, 9, -9, 1, 0, 0, 0, 0, 78, 0, 70, 0]);
    design.addPosition("ad8", [-1, 9, -9, 1, 77, 0, 69, 0, 78, 0, 70, 0]);
    design.addPosition("ad7", [-1, 9, -9, 1, 77, 0, 69, 0, 78, 0, 70, 0]);
    design.addPosition("ad6", [-1, 9, -9, 1, 77, 0, 69, 0, 78, 0, 70, 0]);
    design.addPosition("ad5", [-1, 9, -9, 1, 77, 0, 69, 0, 78, 0, 70, 0]);
    design.addPosition("ad4", [-1, 9, -9, 1, 77, 0, 69, 0, 78, 0, 70, 0]);
    design.addPosition("ad3", [-1, 9, -9, 1, 77, 0, 69, 0, 78, 0, 70, 0]);
    design.addPosition("ad2", [-1, 9, -9, 1, 77, 0, 69, 0, 78, 0, 70, 0]);
    design.addPosition("ad1", [-1, 9, -9, 0, 77, 0, 69, 0, 0, 0, 0, 0]);
    design.addPosition("ae9", [0, 9, -9, 1, 0, 0, 0, 0, 77, 0, 69, 0]);
    design.addPosition("ae8", [-1, 9, -9, 1, 76, 0, 68, 0, 77, 0, 69, 0]);
    design.addPosition("ae7", [-1, 9, -9, 1, 76, 0, 68, 0, 77, 0, 69, 0]);
    design.addPosition("ae6", [-1, 9, -9, 1, 76, 0, 68, 0, 77, 0, 69, 0]);
    design.addPosition("ae5", [-1, 9, -9, 1, 76, 0, 68, 0, 77, 0, 69, 0]);
    design.addPosition("ae4", [-1, 9, -9, 1, 76, 0, 68, 0, 77, 0, 69, 0]);
    design.addPosition("ae3", [-1, 9, -9, 1, 76, 0, 68, 0, 77, 0, 69, 0]);
    design.addPosition("ae2", [-1, 9, -9, 1, 76, 0, 68, 0, 77, 0, 69, 0]);
    design.addPosition("ae1", [-1, 9, -9, 0, 76, 0, 68, 0, 0, 0, 0, 0]);
    design.addPosition("af9", [0, 9, -9, 1, 0, 0, 0, 0, 76, 0, 68, 0]);
    design.addPosition("af8", [-1, 9, -9, 1, 75, 0, 67, 0, 76, 0, 68, 0]);
    design.addPosition("af7", [-1, 9, -9, 1, 75, 0, 67, 0, 76, 0, 68, 0]);
    design.addPosition("af6", [-1, 9, -9, 1, 75, 0, 67, 0, 76, 0, 68, 0]);
    design.addPosition("af5", [-1, 9, -9, 1, 75, 0, 67, 0, 76, 0, 68, 0]);
    design.addPosition("af4", [-1, 9, -9, 1, 75, 0, 67, 0, 76, 0, 68, 0]);
    design.addPosition("af3", [-1, 9, -9, 1, 75, 0, 67, 0, 76, 0, 68, 0]);
    design.addPosition("af2", [-1, 9, -9, 1, 75, 0, 67, 0, 76, 0, 68, 0]);
    design.addPosition("af1", [-1, 9, -9, 0, 75, 0, 67, 0, 0, 0, 0, 0]);
    design.addPosition("ag9", [0, 9, -9, 1, 0, 0, 0, 0, 75, 0, 67, 0]);
    design.addPosition("ag8", [-1, 9, -9, 1, 74, 0, 66, 0, 75, 0, 67, 0]);
    design.addPosition("ag7", [-1, 9, -9, 1, 74, 0, 66, 0, 75, 0, 67, 0]);
    design.addPosition("ag6", [-1, 9, -9, 1, 74, 0, 66, 0, 75, 0, 67, 0]);
    design.addPosition("ag5", [-1, 9, -9, 1, 74, 0, 66, 0, 75, 0, 67, 0]);
    design.addPosition("ag4", [-1, 9, -9, 1, 74, 0, 66, 0, 75, 0, 67, 0]);
    design.addPosition("ag3", [-1, 9, -9, 1, 74, 0, 66, 0, 75, 0, 67, 0]);
    design.addPosition("ag2", [-1, 9, -9, 1, 74, 0, 66, 0, 75, 0, 67, 0]);
    design.addPosition("ag1", [-1, 9, -9, 0, 74, 0, 66, 0, 0, 0, 0, 0]);
    design.addPosition("ah9", [0, 9, -9, 1, 0, 0, 0, 0, 74, 0, 66, 0]);
    design.addPosition("ah8", [-1, 9, -9, 1, 73, 0, 65, 0, 74, 0, 66, 0]);
    design.addPosition("ah7", [-1, 9, -9, 1, 73, 0, 65, 0, 74, 0, 66, 0]);
    design.addPosition("ah6", [-1, 9, -9, 1, 73, 0, 65, 0, 74, 0, 66, 0]);
    design.addPosition("ah5", [-1, 9, -9, 1, 73, 0, 65, 0, 74, 0, 66, 0]);
    design.addPosition("ah4", [-1, 9, -9, 1, 73, 0, 65, 0, 74, 0, 66, 0]);
    design.addPosition("ah3", [-1, 9, -9, 1, 73, 0, 65, 0, 74, 0, 66, 0]);
    design.addPosition("ah2", [-1, 9, -9, 1, 73, 0, 65, 0, 74, 0, 66, 0]);
    design.addPosition("ah1", [-1, 9, -9, 0, 73, 0, 65, 0, 0, 0, 0, 0]);
    design.addPosition("ai9", [0, 0, -9, 1, 0, 0, 0, 0, 0, 0, 65, 0]);
    design.addPosition("ai8", [-1, 0, -9, 1, 0, 0, 64, 0, 0, 0, 65, 0]);
    design.addPosition("ai7", [-1, 0, -9, 1, 0, 0, 64, 0, 0, 0, 65, 0]);
    design.addPosition("ai6", [-1, 0, -9, 1, 0, 0, 64, 0, 0, 0, 65, 0]);
    design.addPosition("ai5", [-1, 0, -9, 1, 0, 0, 64, 0, 0, 0, 65, 0]);
    design.addPosition("ai4", [-1, 0, -9, 1, 0, 0, 64, 0, 0, 0, 65, 0]);
    design.addPosition("ai3", [-1, 0, -9, 1, 0, 0, 64, 0, 0, 0, 65, 0]);
    design.addPosition("ai2", [-1, 0, -9, 1, 0, 0, 64, 0, 0, 0, 65, 0]);
    design.addPosition("ai1", [-1, 0, -9, 0, 0, 0, 64, 0, 0, 0, 0, 0]);
    design.addPosition("ba8", [0, 8, 0, 1, 0, -80, 0, -71, 64, -81, 0, -72]);
    design.addPosition("ba7", [-1, 8, 0, 1, 63, -80, 0, -71, 64, -81, 0, -72]);
    design.addPosition("ba6", [-1, 8, 0, 1, 63, -80, 0, -71, 64, -81, 0, -72]);
    design.addPosition("ba5", [-1, 8, 0, 1, 63, -80, 0, -71, 64, -81, 0, -72]);
    design.addPosition("ba4", [-1, 8, 0, 1, 63, -80, 0, -71, 64, -81, 0, -72]);
    design.addPosition("ba3", [-1, 8, 0, 1, 63, -80, 0, -71, 64, -81, 0, -72]);
    design.addPosition("ba2", [-1, 8, 0, 1, 63, -80, 0, -71, 64, -81, 0, -72]);
    design.addPosition("ba1", [-1, 8, 0, 0, 63, -80, 0, -71, 0, -81, 0, -72]);
    design.addPosition("bb8", [0, 8, -8, 1, 0, -79, 0, -70, 63, -80, 56, -71]);
    design.addPosition("bb7", [-1, 8, -8, 1, 62, -79, 55, -70, 63, -80, 56, -71]);
    design.addPosition("bb6", [-1, 8, -8, 1, 62, -79, 55, -70, 63, -80, 56, -71]);
    design.addPosition("bb5", [-1, 8, -8, 1, 62, -79, 55, -70, 63, -80, 56, -71]);
    design.addPosition("bb4", [-1, 8, -8, 1, 62, -79, 55, -70, 63, -80, 56, -71]);
    design.addPosition("bb3", [-1, 8, -8, 1, 62, -79, 55, -70, 63, -80, 56, -71]);
    design.addPosition("bb2", [-1, 8, -8, 1, 62, -79, 55, -70, 63, -80, 56, -71]);
    design.addPosition("bb1", [-1, 8, -8, 0, 62, -79, 55, -70, 0, -80, 0, -71]);
    design.addPosition("bc8", [0, 8, -8, 1, 0, -78, 0, -69, 62, -79, 55, -70]);
    design.addPosition("bc7", [-1, 8, -8, 1, 61, -78, 54, -69, 62, -79, 55, -70]);
    design.addPosition("bc6", [-1, 8, -8, 1, 61, -78, 54, -69, 62, -79, 55, -70]);
    design.addPosition("bc5", [-1, 8, -8, 1, 61, -78, 54, -69, 62, -79, 55, -70]);
    design.addPosition("bc4", [-1, 8, -8, 1, 61, -78, 54, -69, 62, -79, 55, -70]);
    design.addPosition("bc3", [-1, 8, -8, 1, 61, -78, 54, -69, 62, -79, 55, -70]);
    design.addPosition("bc2", [-1, 8, -8, 1, 61, -78, 54, -69, 62, -79, 55, -70]);
    design.addPosition("bc1", [-1, 8, -8, 0, 61, -78, 54, -69, 0, -79, 0, -70]);
    design.addPosition("bd8", [0, 8, -8, 1, 0, -77, 0, -68, 61, -78, 54, -69]);
    design.addPosition("bd7", [-1, 8, -8, 1, 60, -77, 53, -68, 61, -78, 54, -69]);
    design.addPosition("bd6", [-1, 8, -8, 1, 60, -77, 53, -68, 61, -78, 54, -69]);
    design.addPosition("bd5", [-1, 8, -8, 1, 60, -77, 53, -68, 61, -78, 54, -69]);
    design.addPosition("bd4", [-1, 8, -8, 1, 60, -77, 53, -68, 61, -78, 54, -69]);
    design.addPosition("bd3", [-1, 8, -8, 1, 60, -77, 53, -68, 61, -78, 54, -69]);
    design.addPosition("bd2", [-1, 8, -8, 1, 60, -77, 53, -68, 61, -78, 54, -69]);
    design.addPosition("bd1", [-1, 8, -8, 0, 60, -77, 53, -68, 0, -78, 0, -69]);
    design.addPosition("be8", [0, 8, -8, 1, 0, -76, 0, -67, 60, -77, 53, -68]);
    design.addPosition("be7", [-1, 8, -8, 1, 59, -76, 52, -67, 60, -77, 53, -68]);
    design.addPosition("be6", [-1, 8, -8, 1, 59, -76, 52, -67, 60, -77, 53, -68]);
    design.addPosition("be5", [-1, 8, -8, 1, 59, -76, 52, -67, 60, -77, 53, -68]);
    design.addPosition("be4", [-1, 8, -8, 1, 59, -76, 52, -67, 60, -77, 53, -68]);
    design.addPosition("be3", [-1, 8, -8, 1, 59, -76, 52, -67, 60, -77, 53, -68]);
    design.addPosition("be2", [-1, 8, -8, 1, 59, -76, 52, -67, 60, -77, 53, -68]);
    design.addPosition("be1", [-1, 8, -8, 0, 59, -76, 52, -67, 0, -77, 0, -68]);
    design.addPosition("bf8", [0, 8, -8, 1, 0, -75, 0, -66, 59, -76, 52, -67]);
    design.addPosition("bf7", [-1, 8, -8, 1, 58, -75, 51, -66, 59, -76, 52, -67]);
    design.addPosition("bf6", [-1, 8, -8, 1, 58, -75, 51, -66, 59, -76, 52, -67]);
    design.addPosition("bf5", [-1, 8, -8, 1, 58, -75, 51, -66, 59, -76, 52, -67]);
    design.addPosition("bf4", [-1, 8, -8, 1, 58, -75, 51, -66, 59, -76, 52, -67]);
    design.addPosition("bf3", [-1, 8, -8, 1, 58, -75, 51, -66, 59, -76, 52, -67]);
    design.addPosition("bf2", [-1, 8, -8, 1, 58, -75, 51, -66, 59, -76, 52, -67]);
    design.addPosition("bf1", [-1, 8, -8, 0, 58, -75, 51, -66, 0, -76, 0, -67]);
    design.addPosition("bg8", [0, 8, -8, 1, 0, -74, 0, -65, 58, -75, 51, -66]);
    design.addPosition("bg7", [-1, 8, -8, 1, 57, -74, 50, -65, 58, -75, 51, -66]);
    design.addPosition("bg6", [-1, 8, -8, 1, 57, -74, 50, -65, 58, -75, 51, -66]);
    design.addPosition("bg5", [-1, 8, -8, 1, 57, -74, 50, -65, 58, -75, 51, -66]);
    design.addPosition("bg4", [-1, 8, -8, 1, 57, -74, 50, -65, 58, -75, 51, -66]);
    design.addPosition("bg3", [-1, 8, -8, 1, 57, -74, 50, -65, 58, -75, 51, -66]);
    design.addPosition("bg2", [-1, 8, -8, 1, 57, -74, 50, -65, 58, -75, 51, -66]);
    design.addPosition("bg1", [-1, 8, -8, 0, 57, -74, 50, -65, 0, -75, 0, -66]);
    design.addPosition("bh8", [0, 0, -8, 1, 0, -73, 0, -64, 0, -74, 50, -65]);
    design.addPosition("bh7", [-1, 0, -8, 1, 0, -73, 49, -64, 0, -74, 50, -65]);
    design.addPosition("bh6", [-1, 0, -8, 1, 0, -73, 49, -64, 0, -74, 50, -65]);
    design.addPosition("bh5", [-1, 0, -8, 1, 0, -73, 49, -64, 0, -74, 50, -65]);
    design.addPosition("bh4", [-1, 0, -8, 1, 0, -73, 49, -64, 0, -74, 50, -65]);
    design.addPosition("bh3", [-1, 0, -8, 1, 0, -73, 49, -64, 0, -74, 50, -65]);
    design.addPosition("bh2", [-1, 0, -8, 1, 0, -73, 49, -64, 0, -74, 50, -65]);
    design.addPosition("bh1", [-1, 0, -8, 0, 0, -73, 49, -64, 0, -74, 0, -65]);
    design.addPosition("ca7", [0, 7, 0, 1, 0, -63, 0, -55, 49, -64, 0, -56]);
    design.addPosition("ca6", [-1, 7, 0, 1, 48, -63, 0, -55, 49, -64, 0, -56]);
    design.addPosition("ca5", [-1, 7, 0, 1, 48, -63, 0, -55, 49, -64, 0, -56]);
    design.addPosition("ca4", [-1, 7, 0, 1, 48, -63, 0, -55, 49, -64, 0, -56]);
    design.addPosition("ca3", [-1, 7, 0, 1, 48, -63, 0, -55, 49, -64, 0, -56]);
    design.addPosition("ca2", [-1, 7, 0, 1, 48, -63, 0, -55, 49, -64, 0, -56]);
    design.addPosition("ca1", [-1, 7, 0, 0, 48, -63, 0, -55, 0, -64, 0, -56]);
    design.addPosition("cb7", [0, 7, -7, 1, 0, -62, 0, -54, 48, -63, 42, -55]);
    design.addPosition("cb6", [-1, 7, -7, 1, 47, -62, 41, -54, 48, -63, 42, -55]);
    design.addPosition("cb5", [-1, 7, -7, 1, 47, -62, 41, -54, 48, -63, 42, -55]);
    design.addPosition("cb4", [-1, 7, -7, 1, 47, -62, 41, -54, 48, -63, 42, -55]);
    design.addPosition("cb3", [-1, 7, -7, 1, 47, -62, 41, -54, 48, -63, 42, -55]);
    design.addPosition("cb2", [-1, 7, -7, 1, 47, -62, 41, -54, 48, -63, 42, -55]);
    design.addPosition("cb1", [-1, 7, -7, 0, 47, -62, 41, -54, 0, -63, 0, -55]);
    design.addPosition("cc7", [0, 7, -7, 1, 0, -61, 0, -53, 47, -62, 41, -54]);
    design.addPosition("cc6", [-1, 7, -7, 1, 46, -61, 40, -53, 47, -62, 41, -54]);
    design.addPosition("cc5", [-1, 7, -7, 1, 46, -61, 40, -53, 47, -62, 41, -54]);
    design.addPosition("cc4", [-1, 7, -7, 1, 46, -61, 40, -53, 47, -62, 41, -54]);
    design.addPosition("cc3", [-1, 7, -7, 1, 46, -61, 40, -53, 47, -62, 41, -54]);
    design.addPosition("cc2", [-1, 7, -7, 1, 46, -61, 40, -53, 47, -62, 41, -54]);
    design.addPosition("cc1", [-1, 7, -7, 0, 46, -61, 40, -53, 0, -62, 0, -54]);
    design.addPosition("cd7", [0, 7, -7, 1, 0, -60, 0, -52, 46, -61, 40, -53]);
    design.addPosition("cd6", [-1, 7, -7, 1, 45, -60, 39, -52, 46, -61, 40, -53]);
    design.addPosition("cd5", [-1, 7, -7, 1, 45, -60, 39, -52, 46, -61, 40, -53]);
    design.addPosition("cd4", [-1, 7, -7, 1, 45, -60, 39, -52, 46, -61, 40, -53]);
    design.addPosition("cd3", [-1, 7, -7, 1, 45, -60, 39, -52, 46, -61, 40, -53]);
    design.addPosition("cd2", [-1, 7, -7, 1, 45, -60, 39, -52, 46, -61, 40, -53]);
    design.addPosition("cd1", [-1, 7, -7, 0, 45, -60, 39, -52, 0, -61, 0, -53]);
    design.addPosition("ce7", [0, 7, -7, 1, 0, -59, 0, -51, 45, -60, 39, -52]);
    design.addPosition("ce6", [-1, 7, -7, 1, 44, -59, 38, -51, 45, -60, 39, -52]);
    design.addPosition("ce5", [-1, 7, -7, 1, 44, -59, 38, -51, 45, -60, 39, -52]);
    design.addPosition("ce4", [-1, 7, -7, 1, 44, -59, 38, -51, 45, -60, 39, -52]);
    design.addPosition("ce3", [-1, 7, -7, 1, 44, -59, 38, -51, 45, -60, 39, -52]);
    design.addPosition("ce2", [-1, 7, -7, 1, 44, -59, 38, -51, 45, -60, 39, -52]);
    design.addPosition("ce1", [-1, 7, -7, 0, 44, -59, 38, -51, 0, -60, 0, -52]);
    design.addPosition("cf7", [0, 7, -7, 1, 0, -58, 0, -50, 44, -59, 38, -51]);
    design.addPosition("cf6", [-1, 7, -7, 1, 43, -58, 37, -50, 44, -59, 38, -51]);
    design.addPosition("cf5", [-1, 7, -7, 1, 43, -58, 37, -50, 44, -59, 38, -51]);
    design.addPosition("cf4", [-1, 7, -7, 1, 43, -58, 37, -50, 44, -59, 38, -51]);
    design.addPosition("cf3", [-1, 7, -7, 1, 43, -58, 37, -50, 44, -59, 38, -51]);
    design.addPosition("cf2", [-1, 7, -7, 1, 43, -58, 37, -50, 44, -59, 38, -51]);
    design.addPosition("cf1", [-1, 7, -7, 0, 43, -58, 37, -50, 0, -59, 0, -51]);
    design.addPosition("cg7", [0, 0, -7, 1, 0, -57, 0, -49, 0, -58, 37, -50]);
    design.addPosition("cg6", [-1, 0, -7, 1, 0, -57, 36, -49, 0, -58, 37, -50]);
    design.addPosition("cg5", [-1, 0, -7, 1, 0, -57, 36, -49, 0, -58, 37, -50]);
    design.addPosition("cg4", [-1, 0, -7, 1, 0, -57, 36, -49, 0, -58, 37, -50]);
    design.addPosition("cg3", [-1, 0, -7, 1, 0, -57, 36, -49, 0, -58, 37, -50]);
    design.addPosition("cg2", [-1, 0, -7, 1, 0, -57, 36, -49, 0, -58, 37, -50]);
    design.addPosition("cg1", [-1, 0, -7, 0, 0, -57, 36, -49, 0, -58, 0, -50]);
    design.addPosition("da6", [0, 6, 0, 1, 0, -48, 0, -41, 36, -49, 0, -42]);
    design.addPosition("da5", [-1, 6, 0, 1, 35, -48, 0, -41, 36, -49, 0, -42]);
    design.addPosition("da4", [-1, 6, 0, 1, 35, -48, 0, -41, 36, -49, 0, -42]);
    design.addPosition("da3", [-1, 6, 0, 1, 35, -48, 0, -41, 36, -49, 0, -42]);
    design.addPosition("da2", [-1, 6, 0, 1, 35, -48, 0, -41, 36, -49, 0, -42]);
    design.addPosition("da1", [-1, 6, 0, 0, 35, -48, 0, -41, 0, -49, 0, -42]);
    design.addPosition("db6", [0, 6, -6, 1, 0, -47, 0, -40, 35, -48, 30, -41]);
    design.addPosition("db5", [-1, 6, -6, 1, 34, -47, 29, -40, 35, -48, 30, -41]);
    design.addPosition("db4", [-1, 6, -6, 1, 34, -47, 29, -40, 35, -48, 30, -41]);
    design.addPosition("db3", [-1, 6, -6, 1, 34, -47, 29, -40, 35, -48, 30, -41]);
    design.addPosition("db2", [-1, 6, -6, 1, 34, -47, 29, -40, 35, -48, 30, -41]);
    design.addPosition("db1", [-1, 6, -6, 0, 34, -47, 29, -40, 0, -48, 0, -41]);
    design.addPosition("dc6", [0, 6, -6, 1, 0, -46, 0, -39, 34, -47, 29, -40]);
    design.addPosition("dc5", [-1, 6, -6, 1, 33, -46, 28, -39, 34, -47, 29, -40]);
    design.addPosition("dc4", [-1, 6, -6, 1, 33, -46, 28, -39, 34, -47, 29, -40]);
    design.addPosition("dc3", [-1, 6, -6, 1, 33, -46, 28, -39, 34, -47, 29, -40]);
    design.addPosition("dc2", [-1, 6, -6, 1, 33, -46, 28, -39, 34, -47, 29, -40]);
    design.addPosition("dc1", [-1, 6, -6, 0, 33, -46, 28, -39, 0, -47, 0, -40]);
    design.addPosition("dd6", [0, 6, -6, 1, 0, -45, 0, -38, 33, -46, 28, -39]);
    design.addPosition("dd5", [-1, 6, -6, 1, 32, -45, 27, -38, 33, -46, 28, -39]);
    design.addPosition("dd4", [-1, 6, -6, 1, 32, -45, 27, -38, 33, -46, 28, -39]);
    design.addPosition("dd3", [-1, 6, -6, 1, 32, -45, 27, -38, 33, -46, 28, -39]);
    design.addPosition("dd2", [-1, 6, -6, 1, 32, -45, 27, -38, 33, -46, 28, -39]);
    design.addPosition("dd1", [-1, 6, -6, 0, 32, -45, 27, -38, 0, -46, 0, -39]);
    design.addPosition("de6", [0, 6, -6, 1, 0, -44, 0, -37, 32, -45, 27, -38]);
    design.addPosition("de5", [-1, 6, -6, 1, 31, -44, 26, -37, 32, -45, 27, -38]);
    design.addPosition("de4", [-1, 6, -6, 1, 31, -44, 26, -37, 32, -45, 27, -38]);
    design.addPosition("de3", [-1, 6, -6, 1, 31, -44, 26, -37, 32, -45, 27, -38]);
    design.addPosition("de2", [-1, 6, -6, 1, 31, -44, 26, -37, 32, -45, 27, -38]);
    design.addPosition("de1", [-1, 6, -6, 0, 31, -44, 26, -37, 0, -45, 0, -38]);
    design.addPosition("df6", [0, 0, -6, 1, 0, -43, 0, -36, 0, -44, 26, -37]);
    design.addPosition("df5", [-1, 0, -6, 1, 0, -43, 25, -36, 0, -44, 26, -37]);
    design.addPosition("df4", [-1, 0, -6, 1, 0, -43, 25, -36, 0, -44, 26, -37]);
    design.addPosition("df3", [-1, 0, -6, 1, 0, -43, 25, -36, 0, -44, 26, -37]);
    design.addPosition("df2", [-1, 0, -6, 1, 0, -43, 25, -36, 0, -44, 26, -37]);
    design.addPosition("df1", [-1, 0, -6, 0, 0, -43, 25, -36, 0, -44, 0, -37]);
    design.addPosition("ea5", [0, 5, 0, 1, 0, -35, 0, -29, 25, -36, 0, -30]);
    design.addPosition("ea4", [-1, 5, 0, 1, 24, -35, 0, -29, 25, -36, 0, -30]);
    design.addPosition("ea3", [-1, 5, 0, 1, 24, -35, 0, -29, 25, -36, 0, -30]);
    design.addPosition("ea2", [-1, 5, 0, 1, 24, -35, 0, -29, 25, -36, 0, -30]);
    design.addPosition("ea1", [-1, 5, 0, 0, 24, -35, 0, -29, 0, -36, 0, -30]);
    design.addPosition("eb5", [0, 5, -5, 1, 0, -34, 0, -28, 24, -35, 20, -29]);
    design.addPosition("eb4", [-1, 5, -5, 1, 23, -34, 19, -28, 24, -35, 20, -29]);
    design.addPosition("eb3", [-1, 5, -5, 1, 23, -34, 19, -28, 24, -35, 20, -29]);
    design.addPosition("eb2", [-1, 5, -5, 1, 23, -34, 19, -28, 24, -35, 20, -29]);
    design.addPosition("eb1", [-1, 5, -5, 0, 23, -34, 19, -28, 0, -35, 0, -29]);
    design.addPosition("ec5", [0, 5, -5, 1, 0, -33, 0, -27, 23, -34, 19, -28]);
    design.addPosition("ec4", [-1, 5, -5, 1, 22, -33, 18, -27, 23, -34, 19, -28]);
    design.addPosition("ec3", [-1, 5, -5, 1, 22, -33, 18, -27, 23, -34, 19, -28]);
    design.addPosition("ec2", [-1, 5, -5, 1, 22, -33, 18, -27, 23, -34, 19, -28]);
    design.addPosition("ec1", [-1, 5, -5, 0, 22, -33, 18, -27, 0, -34, 0, -28]);
    design.addPosition("ed5", [0, 5, -5, 1, 0, -32, 0, -26, 22, -33, 18, -27]);
    design.addPosition("ed4", [-1, 5, -5, 1, 21, -32, 17, -26, 22, -33, 18, -27]);
    design.addPosition("ed3", [-1, 5, -5, 1, 21, -32, 17, -26, 22, -33, 18, -27]);
    design.addPosition("ed2", [-1, 5, -5, 1, 21, -32, 17, -26, 22, -33, 18, -27]);
    design.addPosition("ed1", [-1, 5, -5, 0, 21, -32, 17, -26, 0, -33, 0, -27]);
    design.addPosition("ee5", [0, 0, -5, 1, 0, -31, 0, -25, 0, -32, 17, -26]);
    design.addPosition("ee4", [-1, 0, -5, 1, 0, -31, 16, -25, 0, -32, 17, -26]);
    design.addPosition("ee3", [-1, 0, -5, 1, 0, -31, 16, -25, 0, -32, 17, -26]);
    design.addPosition("ee2", [-1, 0, -5, 1, 0, -31, 16, -25, 0, -32, 17, -26]);
    design.addPosition("ee1", [-1, 0, -5, 0, 0, -31, 16, -25, 0, -32, 0, -26]);
    design.addPosition("fa4", [0, 4, 0, 1, 0, -24, 0, -19, 16, -25, 0, -20]);
    design.addPosition("fa3", [-1, 4, 0, 1, 15, -24, 0, -19, 16, -25, 0, -20]);
    design.addPosition("fa2", [-1, 4, 0, 1, 15, -24, 0, -19, 16, -25, 0, -20]);
    design.addPosition("fa1", [-1, 4, 0, 0, 15, -24, 0, -19, 0, -25, 0, -20]);
    design.addPosition("fb4", [0, 4, -4, 1, 0, -23, 0, -18, 15, -24, 12, -19]);
    design.addPosition("fb3", [-1, 4, -4, 1, 14, -23, 11, -18, 15, -24, 12, -19]);
    design.addPosition("fb2", [-1, 4, -4, 1, 14, -23, 11, -18, 15, -24, 12, -19]);
    design.addPosition("fb1", [-1, 4, -4, 0, 14, -23, 11, -18, 0, -24, 0, -19]);
    design.addPosition("fc4", [0, 4, -4, 1, 0, -22, 0, -17, 14, -23, 11, -18]);
    design.addPosition("fc3", [-1, 4, -4, 1, 13, -22, 10, -17, 14, -23, 11, -18]);
    design.addPosition("fc2", [-1, 4, -4, 1, 13, -22, 10, -17, 14, -23, 11, -18]);
    design.addPosition("fc1", [-1, 4, -4, 0, 13, -22, 10, -17, 0, -23, 0, -18]);
    design.addPosition("fd4", [0, 0, -4, 1, 0, -21, 0, -16, 0, -22, 10, -17]);
    design.addPosition("fd3", [-1, 0, -4, 1, 0, -21, 9, -16, 0, -22, 10, -17]);
    design.addPosition("fd2", [-1, 0, -4, 1, 0, -21, 9, -16, 0, -22, 10, -17]);
    design.addPosition("fd1", [-1, 0, -4, 0, 0, -21, 9, -16, 0, -22, 0, -17]);
    design.addPosition("ga3", [0, 3, 0, 1, 0, -15, 0, -11, 9, -16, 0, -12]);
    design.addPosition("ga2", [-1, 3, 0, 1, 8, -15, 0, -11, 9, -16, 0, -12]);
    design.addPosition("ga1", [-1, 3, 0, 0, 8, -15, 0, -11, 0, -16, 0, -12]);
    design.addPosition("gb3", [0, 3, -3, 1, 0, -14, 0, -10, 8, -15, 6, -11]);
    design.addPosition("gb2", [-1, 3, -3, 1, 7, -14, 5, -10, 8, -15, 6, -11]);
    design.addPosition("gb1", [-1, 3, -3, 0, 7, -14, 5, -10, 0, -15, 0, -11]);
    design.addPosition("gc3", [0, 0, -3, 1, 0, -13, 0, -9, 0, -14, 5, -10]);
    design.addPosition("gc2", [-1, 0, -3, 1, 0, -13, 4, -9, 0, -14, 5, -10]);
    design.addPosition("gc1", [-1, 0, -3, 0, 0, -13, 4, -9, 0, -14, 0, -10]);
    design.addPosition("ha2", [0, 2, 0, 1, 0, -8, 0, -5, 4, -9, 0, -6]);
    design.addPosition("ha1", [-1, 2, 0, 0, 3, -8, 0, -5, 0, -9, 0, -6]);
    design.addPosition("hb2", [0, 0, -2, 1, 0, -7, 0, -4, 0, -8, 2, -5]);
    design.addPosition("hb1", [-1, 0, -2, 0, 0, -7, 1, -4, 0, -8, 0, -5]);
    design.addPosition("ia1", [0, 0, 0, 0, 0, -3, 0, -1, 0, -4, 0, -2]);

    design.addCommand(0, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(0, ZRF.FUNCTION,	20);	// verify
    design.addCommand(0, ZRF.FUNCTION,	25);	// to
    design.addCommand(0, ZRF.FUNCTION,	28);	// end

    design.addCommand(1, ZRF.FUNCTION,	24);	// from
    design.addCommand(1, ZRF.FUNCTION,	26);	// capture
    design.addCommand(1, ZRF.FUNCTION,	25);	// to
    design.addCommand(1, ZRF.FUNCTION,	28);	// end

    design.addPiece("White", 0);
    design.addDrop(0, 0, [], 0);
    design.addMove(0, 1, [], 0);

    design.addPiece("Black", 1);
    design.addDrop(1, 0, [], 0);
    design.addMove(1, 1, [], 0);
}

Dagaz.View.configure = function(view) {
    view.defBoard("Board");
    view.defPiece("BlackStone", "You Black");
    view.defPiece("WhiteStone", "You White");
 
    view.defPosition("aa9", 30, 30, 60, 60);
    view.defPosition("aa8", 30, 90, 60, 60);
    view.defPosition("aa7", 30, 150, 60, 60);
    view.defPosition("aa6", 30, 210, 60, 60);
    view.defPosition("aa5", 30, 270, 60, 60);
    view.defPosition("aa4", 30, 330, 60, 60);
    view.defPosition("aa3", 30, 390, 60, 60);
    view.defPosition("aa2", 30, 450, 60, 60);
    view.defPosition("aa1", 30, 510, 60, 60);
    view.defPosition("ab9", 90, 30, 60, 60);
    view.defPosition("ab8", 90, 90, 60, 60);
    view.defPosition("ab7", 90, 150, 60, 60);
    view.defPosition("ab6", 90, 210, 60, 60);
    view.defPosition("ab5", 90, 270, 60, 60);
    view.defPosition("ab4", 90, 330, 60, 60);
    view.defPosition("ab3", 90, 390, 60, 60);
    view.defPosition("ab2", 90, 450, 60, 60);
    view.defPosition("ab1", 90, 510, 60, 60);
    view.defPosition("ac9", 150, 30, 60, 60);
    view.defPosition("ac8", 150, 90, 60, 60);
    view.defPosition("ac7", 150, 150, 60, 60);
    view.defPosition("ac6", 150, 210, 60, 60);
    view.defPosition("ac5", 150, 270, 60, 60);
    view.defPosition("ac4", 150, 330, 60, 60);
    view.defPosition("ac3", 150, 390, 60, 60);
    view.defPosition("ac2", 150, 450, 60, 60);
    view.defPosition("ac1", 150, 510, 60, 60);
    view.defPosition("ad9", 210, 30, 60, 60);
    view.defPosition("ad8", 210, 90, 60, 60);
    view.defPosition("ad7", 210, 150, 60, 60);
    view.defPosition("ad6", 210, 210, 60, 60);
    view.defPosition("ad5", 210, 270, 60, 60);
    view.defPosition("ad4", 210, 330, 60, 60);
    view.defPosition("ad3", 210, 390, 60, 60);
    view.defPosition("ad2", 210, 450, 60, 60);
    view.defPosition("ad1", 210, 510, 60, 60);
    view.defPosition("ae9", 270, 30, 60, 60);
    view.defPosition("ae8", 270, 90, 60, 60);
    view.defPosition("ae7", 270, 150, 60, 60);
    view.defPosition("ae6", 270, 210, 60, 60);
    view.defPosition("ae5", 270, 270, 60, 60);
    view.defPosition("ae4", 270, 330, 60, 60);
    view.defPosition("ae3", 270, 390, 60, 60);
    view.defPosition("ae2", 270, 450, 60, 60);
    view.defPosition("ae1", 270, 510, 60, 60);
    view.defPosition("af9", 330, 30, 60, 60);
    view.defPosition("af8", 330, 90, 60, 60);
    view.defPosition("af7", 330, 150, 60, 60);
    view.defPosition("af6", 330, 210, 60, 60);
    view.defPosition("af5", 330, 270, 60, 60);
    view.defPosition("af4", 330, 330, 60, 60);
    view.defPosition("af3", 330, 390, 60, 60);
    view.defPosition("af2", 330, 450, 60, 60);
    view.defPosition("af1", 330, 510, 60, 60);
    view.defPosition("ag9", 390, 30, 60, 60);
    view.defPosition("ag8", 390, 90, 60, 60);
    view.defPosition("ag7", 390, 150, 60, 60);
    view.defPosition("ag6", 390, 210, 60, 60);
    view.defPosition("ag5", 390, 270, 60, 60);
    view.defPosition("ag4", 390, 330, 60, 60);
    view.defPosition("ag3", 390, 390, 60, 60);
    view.defPosition("ag2", 390, 450, 60, 60);
    view.defPosition("ag1", 390, 510, 60, 60);
    view.defPosition("ah9", 450, 30, 60, 60);
    view.defPosition("ah8", 450, 90, 60, 60);
    view.defPosition("ah7", 450, 150, 60, 60);
    view.defPosition("ah6", 450, 210, 60, 60);
    view.defPosition("ah5", 450, 270, 60, 60);
    view.defPosition("ah4", 450, 330, 60, 60);
    view.defPosition("ah3", 450, 390, 60, 60);
    view.defPosition("ah2", 450, 450, 60, 60);
    view.defPosition("ah1", 450, 510, 60, 60);
    view.defPosition("ai9", 510, 30, 60, 60);
    view.defPosition("ai8", 510, 90, 60, 60);
    view.defPosition("ai7", 510, 150, 60, 60);
    view.defPosition("ai6", 510, 210, 60, 60);
    view.defPosition("ai5", 510, 270, 60, 60);
    view.defPosition("ai4", 510, 330, 60, 60);
    view.defPosition("ai3", 510, 390, 60, 60);
    view.defPosition("ai2", 510, 450, 60, 60);
    view.defPosition("ai1", 510, 510, 60, 60);
    view.defPosition("ba8", 60, 60, 60, 60);
    view.defPosition("ba7", 60, 120, 60, 60);
    view.defPosition("ba6", 60, 180, 60, 60);
    view.defPosition("ba5", 60, 240, 60, 60);
    view.defPosition("ba4", 60, 300, 60, 60);
    view.defPosition("ba3", 60, 360, 60, 60);
    view.defPosition("ba2", 60, 420, 60, 60);
    view.defPosition("ba1", 60, 480, 60, 60);
    view.defPosition("bb8", 120, 60, 60, 60);
    view.defPosition("bb7", 120, 120, 60, 60);
    view.defPosition("bb6", 120, 180, 60, 60);
    view.defPosition("bb5", 120, 240, 60, 60);
    view.defPosition("bb4", 120, 300, 60, 60);
    view.defPosition("bb3", 120, 360, 60, 60);
    view.defPosition("bb2", 120, 420, 60, 60);
    view.defPosition("bb1", 120, 480, 60, 60);
    view.defPosition("bc8", 180, 60, 60, 60);
    view.defPosition("bc7", 180, 120, 60, 60);
    view.defPosition("bc6", 180, 180, 60, 60);
    view.defPosition("bc5", 180, 240, 60, 60);
    view.defPosition("bc4", 180, 300, 60, 60);
    view.defPosition("bc3", 180, 360, 60, 60);
    view.defPosition("bc2", 180, 420, 60, 60);
    view.defPosition("bc1", 180, 480, 60, 60);
    view.defPosition("bd8", 240, 60, 60, 60);
    view.defPosition("bd7", 240, 120, 60, 60);
    view.defPosition("bd6", 240, 180, 60, 60);
    view.defPosition("bd5", 240, 240, 60, 60);
    view.defPosition("bd4", 240, 300, 60, 60);
    view.defPosition("bd3", 240, 360, 60, 60);
    view.defPosition("bd2", 240, 420, 60, 60);
    view.defPosition("bd1", 240, 480, 60, 60);
    view.defPosition("be8", 300, 60, 60, 60);
    view.defPosition("be7", 300, 120, 60, 60);
    view.defPosition("be6", 300, 180, 60, 60);
    view.defPosition("be5", 300, 240, 60, 60);
    view.defPosition("be4", 300, 300, 60, 60);
    view.defPosition("be3", 300, 360, 60, 60);
    view.defPosition("be2", 300, 420, 60, 60);
    view.defPosition("be1", 300, 480, 60, 60);
    view.defPosition("bf8", 360, 60, 60, 60);
    view.defPosition("bf7", 360, 120, 60, 60);
    view.defPosition("bf6", 360, 180, 60, 60);
    view.defPosition("bf5", 360, 240, 60, 60);
    view.defPosition("bf4", 360, 300, 60, 60);
    view.defPosition("bf3", 360, 360, 60, 60);
    view.defPosition("bf2", 360, 420, 60, 60);
    view.defPosition("bf1", 360, 480, 60, 60);
    view.defPosition("bg8", 420, 60, 60, 60);
    view.defPosition("bg7", 420, 120, 60, 60);
    view.defPosition("bg6", 420, 180, 60, 60);
    view.defPosition("bg5", 420, 240, 60, 60);
    view.defPosition("bg4", 420, 300, 60, 60);
    view.defPosition("bg3", 420, 360, 60, 60);
    view.defPosition("bg2", 420, 420, 60, 60);
    view.defPosition("bg1", 420, 480, 60, 60);
    view.defPosition("bh8", 480, 60, 60, 60);
    view.defPosition("bh7", 480, 120, 60, 60);
    view.defPosition("bh6", 480, 180, 60, 60);
    view.defPosition("bh5", 480, 240, 60, 60);
    view.defPosition("bh4", 480, 300, 60, 60);
    view.defPosition("bh3", 480, 360, 60, 60);
    view.defPosition("bh2", 480, 420, 60, 60);
    view.defPosition("bh1", 480, 480, 60, 60);
    view.defPosition("ca7", 90, 90, 60, 60);
    view.defPosition("ca6", 90, 150, 60, 60);
    view.defPosition("ca5", 90, 210, 60, 60);
    view.defPosition("ca4", 90, 270, 60, 60);
    view.defPosition("ca3", 90, 330, 60, 60);
    view.defPosition("ca2", 90, 390, 60, 60);
    view.defPosition("ca1", 90, 450, 60, 60);
    view.defPosition("cb7", 150, 90, 60, 60);
    view.defPosition("cb6", 150, 150, 60, 60);
    view.defPosition("cb5", 150, 210, 60, 60);
    view.defPosition("cb4", 150, 270, 60, 60);
    view.defPosition("cb3", 150, 330, 60, 60);
    view.defPosition("cb2", 150, 390, 60, 60);
    view.defPosition("cb1", 150, 450, 60, 60);
    view.defPosition("cc7", 210, 90, 60, 60);
    view.defPosition("cc6", 210, 150, 60, 60);
    view.defPosition("cc5", 210, 210, 60, 60);
    view.defPosition("cc4", 210, 270, 60, 60);
    view.defPosition("cc3", 210, 330, 60, 60);
    view.defPosition("cc2", 210, 390, 60, 60);
    view.defPosition("cc1", 210, 450, 60, 60);
    view.defPosition("cd7", 270, 90, 60, 60);
    view.defPosition("cd6", 270, 150, 60, 60);
    view.defPosition("cd5", 270, 210, 60, 60);
    view.defPosition("cd4", 270, 270, 60, 60);
    view.defPosition("cd3", 270, 330, 60, 60);
    view.defPosition("cd2", 270, 390, 60, 60);
    view.defPosition("cd1", 270, 450, 60, 60);
    view.defPosition("ce7", 330, 90, 60, 60);
    view.defPosition("ce6", 330, 150, 60, 60);
    view.defPosition("ce5", 330, 210, 60, 60);
    view.defPosition("ce4", 330, 270, 60, 60);
    view.defPosition("ce3", 330, 330, 60, 60);
    view.defPosition("ce2", 330, 390, 60, 60);
    view.defPosition("ce1", 330, 450, 60, 60);
    view.defPosition("cf7", 390, 90, 60, 60);
    view.defPosition("cf6", 390, 150, 60, 60);
    view.defPosition("cf5", 390, 210, 60, 60);
    view.defPosition("cf4", 390, 270, 60, 60);
    view.defPosition("cf3", 390, 330, 60, 60);
    view.defPosition("cf2", 390, 390, 60, 60);
    view.defPosition("cf1", 390, 450, 60, 60);
    view.defPosition("cg7", 450, 90, 60, 60);
    view.defPosition("cg6", 450, 150, 60, 60);
    view.defPosition("cg5", 450, 210, 60, 60);
    view.defPosition("cg4", 450, 270, 60, 60);
    view.defPosition("cg3", 450, 330, 60, 60);
    view.defPosition("cg2", 450, 390, 60, 60);
    view.defPosition("cg1", 450, 450, 60, 60);
    view.defPosition("da6", 120, 120, 60, 60);
    view.defPosition("da5", 120, 180, 60, 60);
    view.defPosition("da4", 120, 240, 60, 60);
    view.defPosition("da3", 120, 300, 60, 60);
    view.defPosition("da2", 120, 360, 60, 60);
    view.defPosition("da1", 120, 420, 60, 60);
    view.defPosition("db6", 180, 120, 60, 60);
    view.defPosition("db5", 180, 180, 60, 60);
    view.defPosition("db4", 180, 240, 60, 60);
    view.defPosition("db3", 180, 300, 60, 60);
    view.defPosition("db2", 180, 360, 60, 60);
    view.defPosition("db1", 180, 420, 60, 60);
    view.defPosition("dc6", 240, 120, 60, 60);
    view.defPosition("dc5", 240, 180, 60, 60);
    view.defPosition("dc4", 240, 240, 60, 60);
    view.defPosition("dc3", 240, 300, 60, 60);
    view.defPosition("dc2", 240, 360, 60, 60);
    view.defPosition("dc1", 240, 420, 60, 60);
    view.defPosition("dd6", 300, 120, 60, 60);
    view.defPosition("dd5", 300, 180, 60, 60);
    view.defPosition("dd4", 300, 240, 60, 60);
    view.defPosition("dd3", 300, 300, 60, 60);
    view.defPosition("dd2", 300, 360, 60, 60);
    view.defPosition("dd1", 300, 420, 60, 60);
    view.defPosition("de6", 360, 120, 60, 60);
    view.defPosition("de5", 360, 180, 60, 60);
    view.defPosition("de4", 360, 240, 60, 60);
    view.defPosition("de3", 360, 300, 60, 60);
    view.defPosition("de2", 360, 360, 60, 60);
    view.defPosition("de1", 360, 420, 60, 60);
    view.defPosition("df6", 420, 120, 60, 60);
    view.defPosition("df5", 420, 180, 60, 60);
    view.defPosition("df4", 420, 240, 60, 60);
    view.defPosition("df3", 420, 300, 60, 60);
    view.defPosition("df2", 420, 360, 60, 60);
    view.defPosition("df1", 420, 420, 60, 60);
    view.defPosition("ea5", 150, 150, 60, 60);
    view.defPosition("ea4", 150, 210, 60, 60);
    view.defPosition("ea3", 150, 270, 60, 60);
    view.defPosition("ea2", 150, 330, 60, 60);
    view.defPosition("ea1", 150, 390, 60, 60);
    view.defPosition("eb5", 210, 150, 60, 60);
    view.defPosition("eb4", 210, 210, 60, 60);
    view.defPosition("eb3", 210, 270, 60, 60);
    view.defPosition("eb2", 210, 330, 60, 60);
    view.defPosition("eb1", 210, 390, 60, 60);
    view.defPosition("ec5", 270, 150, 60, 60);
    view.defPosition("ec4", 270, 210, 60, 60);
    view.defPosition("ec3", 270, 270, 60, 60);
    view.defPosition("ec2", 270, 330, 60, 60);
    view.defPosition("ec1", 270, 390, 60, 60);
    view.defPosition("ed5", 330, 150, 60, 60);
    view.defPosition("ed4", 330, 210, 60, 60);
    view.defPosition("ed3", 330, 270, 60, 60);
    view.defPosition("ed2", 330, 330, 60, 60);
    view.defPosition("ed1", 330, 390, 60, 60);
    view.defPosition("ee5", 390, 150, 60, 60);
    view.defPosition("ee4", 390, 210, 60, 60);
    view.defPosition("ee3", 390, 270, 60, 60);
    view.defPosition("ee2", 390, 330, 60, 60);
    view.defPosition("ee1", 390, 390, 60, 60);
    view.defPosition("fa4", 180, 180, 60, 60);
    view.defPosition("fa3", 180, 240, 60, 60);
    view.defPosition("fa2", 180, 300, 60, 60);
    view.defPosition("fa1", 180, 360, 60, 60);
    view.defPosition("fb4", 240, 180, 60, 60);
    view.defPosition("fb3", 240, 240, 60, 60);
    view.defPosition("fb2", 240, 300, 60, 60);
    view.defPosition("fb1", 240, 360, 60, 60);
    view.defPosition("fc4", 300, 180, 60, 60);
    view.defPosition("fc3", 300, 240, 60, 60);
    view.defPosition("fc2", 300, 300, 60, 60);
    view.defPosition("fc1", 300, 360, 60, 60);
    view.defPosition("fd4", 360, 180, 60, 60);
    view.defPosition("fd3", 360, 240, 60, 60);
    view.defPosition("fd2", 360, 300, 60, 60);
    view.defPosition("fd1", 360, 360, 60, 60);
    view.defPosition("ga3", 210, 210, 60, 60);
    view.defPosition("ga2", 210, 270, 60, 60);
    view.defPosition("ga1", 210, 330, 60, 60);
    view.defPosition("gb3", 270, 210, 60, 60);
    view.defPosition("gb2", 270, 270, 60, 60);
    view.defPosition("gb1", 270, 330, 60, 60);
    view.defPosition("gc3", 330, 210, 60, 60);
    view.defPosition("gc2", 330, 270, 60, 60);
    view.defPosition("gc1", 330, 330, 60, 60);
    view.defPosition("ha2", 240, 240, 60, 60);
    view.defPosition("ha1", 240, 300, 60, 60);
    view.defPosition("hb2", 300, 240, 60, 60);
    view.defPosition("hb1", 300, 300, 60, 60);
    view.defPosition("ia1", 270, 270, 60, 60);
}
