ZRF = {
    JUMP:          0,
    IF:            1,
    FORK:          2,
    FUNCTION:      3,
    IN_ZONE:       4,
    FLAG:          5,
    SET_FLAG:      6,
    POS_FLAG:      7,
    SET_POS_FLAG:  8,
    ATTR:          9,
    SET_ATTR:      10,
    PROMOTE:       11,
    MODE:          12,
    ON_BOARD_DIR:  13,
    ON_BOARD_POS:  14,
    PARAM:         15,
    LITERAL:       16,
    VERIFY:        20
};

Dagaz.Model.BuildDesign = function(design) {
    design.checkVersion("z2j", "2");
    design.checkVersion("animate-drops", "false");
    design.checkVersion("animate-captures", "false");
    design.checkVersion("show-blink", "false");
    design.checkVersion("show-hints", "false");
    design.checkVersion("show-captures", "false");
    design.checkVersion("animate-redo", "false");
    design.checkVersion("paper-go-extension", "true");

    design.addDirection("w");
    design.addDirection("e");
    design.addDirection("s");
    design.addDirection("n");

    design.addPlayer("Black", [1, 0, 3, 2]);
    design.addPlayer("White", [0, 1, 2, 3]);

    design.addPosition("a19", [0, 1, 19, 0]);
    design.addPosition("b19", [-1, 1, 19, 0]);
    design.addPosition("c19", [-1, 1, 19, 0]);
    design.addPosition("d19", [-1, 1, 19, 0]);
    design.addPosition("e19", [-1, 1, 19, 0]);
    design.addPosition("f19", [-1, 1, 19, 0]);
    design.addPosition("g19", [-1, 1, 19, 0]);
    design.addPosition("h19", [-1, 1, 19, 0]);
    design.addPosition("i19", [-1, 1, 19, 0]);
    design.addPosition("j19", [-1, 1, 19, 0]);
    design.addPosition("k19", [-1, 1, 19, 0]);
    design.addPosition("l19", [-1, 1, 19, 0]);
    design.addPosition("m19", [-1, 1, 19, 0]);
    design.addPosition("n19", [-1, 1, 19, 0]);
    design.addPosition("o19", [-1, 1, 19, 0]);
    design.addPosition("p19", [-1, 1, 19, 0]);
    design.addPosition("q19", [-1, 1, 19, 0]);
    design.addPosition("r19", [-1, 1, 19, 0]);
    design.addPosition("s19", [-1, 0, 19, 0]);
    design.addPosition("a18", [0, 1, 19, -19]);
    design.addPosition("b18", [-1, 1, 19, -19]);
    design.addPosition("c18", [-1, 1, 19, -19]);
    design.addPosition("d18", [-1, 1, 19, -19]);
    design.addPosition("e18", [-1, 1, 19, -19]);
    design.addPosition("f18", [-1, 1, 19, -19]);
    design.addPosition("g18", [-1, 1, 19, -19]);
    design.addPosition("h18", [-1, 1, 19, -19]);
    design.addPosition("i18", [-1, 1, 19, -19]);
    design.addPosition("j18", [-1, 1, 19, -19]);
    design.addPosition("k18", [-1, 1, 19, -19]);
    design.addPosition("l18", [-1, 1, 19, -19]);
    design.addPosition("m18", [-1, 1, 19, -19]);
    design.addPosition("n18", [-1, 1, 19, -19]);
    design.addPosition("o18", [-1, 1, 19, -19]);
    design.addPosition("p18", [-1, 1, 19, -19]);
    design.addPosition("q18", [-1, 1, 19, -19]);
    design.addPosition("r18", [-1, 1, 19, -19]);
    design.addPosition("s18", [-1, 0, 19, -19]);
    design.addPosition("a17", [0, 1, 19, -19]);
    design.addPosition("b17", [-1, 1, 19, -19]);
    design.addPosition("c17", [-1, 1, 19, -19]);
    design.addPosition("d17", [-1, 1, 19, -19]);
    design.addPosition("e17", [-1, 1, 19, -19]);
    design.addPosition("f17", [-1, 1, 19, -19]);
    design.addPosition("g17", [-1, 1, 19, -19]);
    design.addPosition("h17", [-1, 1, 19, -19]);
    design.addPosition("i17", [-1, 1, 19, -19]);
    design.addPosition("j17", [-1, 1, 19, -19]);
    design.addPosition("k17", [-1, 1, 19, -19]);
    design.addPosition("l17", [-1, 1, 19, -19]);
    design.addPosition("m17", [-1, 1, 19, -19]);
    design.addPosition("n17", [-1, 1, 19, -19]);
    design.addPosition("o17", [-1, 1, 19, -19]);
    design.addPosition("p17", [-1, 1, 19, -19]);
    design.addPosition("q17", [-1, 1, 19, -19]);
    design.addPosition("r17", [-1, 1, 19, -19]);
    design.addPosition("s17", [-1, 0, 19, -19]);
    design.addPosition("a16", [0, 1, 19, -19]);
    design.addPosition("b16", [-1, 1, 19, -19]);
    design.addPosition("c16", [-1, 1, 19, -19]);
    design.addPosition("d16", [-1, 1, 19, -19]);
    design.addPosition("e16", [-1, 1, 19, -19]);
    design.addPosition("f16", [-1, 1, 19, -19]);
    design.addPosition("g16", [-1, 1, 19, -19]);
    design.addPosition("h16", [-1, 1, 19, -19]);
    design.addPosition("i16", [-1, 1, 19, -19]);
    design.addPosition("j16", [-1, 1, 19, -19]);
    design.addPosition("k16", [-1, 1, 19, -19]);
    design.addPosition("l16", [-1, 1, 19, -19]);
    design.addPosition("m16", [-1, 1, 19, -19]);
    design.addPosition("n16", [-1, 1, 19, -19]);
    design.addPosition("o16", [-1, 1, 19, -19]);
    design.addPosition("p16", [-1, 1, 19, -19]);
    design.addPosition("q16", [-1, 1, 19, -19]);
    design.addPosition("r16", [-1, 1, 19, -19]);
    design.addPosition("s16", [-1, 0, 19, -19]);
    design.addPosition("a15", [0, 1, 19, -19]);
    design.addPosition("b15", [-1, 1, 19, -19]);
    design.addPosition("c15", [-1, 1, 19, -19]);
    design.addPosition("d15", [-1, 1, 19, -19]);
    design.addPosition("e15", [-1, 1, 19, -19]);
    design.addPosition("f15", [-1, 1, 19, -19]);
    design.addPosition("g15", [-1, 1, 19, -19]);
    design.addPosition("h15", [-1, 1, 19, -19]);
    design.addPosition("i15", [-1, 1, 19, -19]);
    design.addPosition("j15", [-1, 1, 19, -19]);
    design.addPosition("k15", [-1, 1, 19, -19]);
    design.addPosition("l15", [-1, 1, 19, -19]);
    design.addPosition("m15", [-1, 1, 19, -19]);
    design.addPosition("n15", [-1, 1, 19, -19]);
    design.addPosition("o15", [-1, 1, 19, -19]);
    design.addPosition("p15", [-1, 1, 19, -19]);
    design.addPosition("q15", [-1, 1, 19, -19]);
    design.addPosition("r15", [-1, 1, 19, -19]);
    design.addPosition("s15", [-1, 0, 19, -19]);
    design.addPosition("a14", [0, 1, 19, -19]);
    design.addPosition("b14", [-1, 1, 19, -19]);
    design.addPosition("c14", [-1, 1, 19, -19]);
    design.addPosition("d14", [-1, 1, 19, -19]);
    design.addPosition("e14", [-1, 1, 19, -19]);
    design.addPosition("f14", [-1, 1, 19, -19]);
    design.addPosition("g14", [-1, 1, 19, -19]);
    design.addPosition("h14", [-1, 1, 19, -19]);
    design.addPosition("i14", [-1, 1, 19, -19]);
    design.addPosition("j14", [-1, 1, 19, -19]);
    design.addPosition("k14", [-1, 1, 19, -19]);
    design.addPosition("l14", [-1, 1, 19, -19]);
    design.addPosition("m14", [-1, 1, 19, -19]);
    design.addPosition("n14", [-1, 1, 19, -19]);
    design.addPosition("o14", [-1, 1, 19, -19]);
    design.addPosition("p14", [-1, 1, 19, -19]);
    design.addPosition("q14", [-1, 1, 19, -19]);
    design.addPosition("r14", [-1, 1, 19, -19]);
    design.addPosition("s14", [-1, 0, 19, -19]);
    design.addPosition("a13", [0, 1, 19, -19]);
    design.addPosition("b13", [-1, 1, 19, -19]);
    design.addPosition("c13", [-1, 1, 19, -19]);
    design.addPosition("d13", [-1, 1, 19, -19]);
    design.addPosition("e13", [-1, 1, 19, -19]);
    design.addPosition("f13", [-1, 1, 19, -19]);
    design.addPosition("g13", [-1, 1, 19, -19]);
    design.addPosition("h13", [-1, 1, 19, -19]);
    design.addPosition("i13", [-1, 1, 19, -19]);
    design.addPosition("j13", [-1, 1, 19, -19]);
    design.addPosition("k13", [-1, 1, 19, -19]);
    design.addPosition("l13", [-1, 1, 19, -19]);
    design.addPosition("m13", [-1, 1, 19, -19]);
    design.addPosition("n13", [-1, 1, 19, -19]);
    design.addPosition("o13", [-1, 1, 19, -19]);
    design.addPosition("p13", [-1, 1, 19, -19]);
    design.addPosition("q13", [-1, 1, 19, -19]);
    design.addPosition("r13", [-1, 1, 19, -19]);
    design.addPosition("s13", [-1, 0, 19, -19]);
    design.addPosition("a12", [0, 1, 19, -19]);
    design.addPosition("b12", [-1, 1, 19, -19]);
    design.addPosition("c12", [-1, 1, 19, -19]);
    design.addPosition("d12", [-1, 1, 19, -19]);
    design.addPosition("e12", [-1, 1, 19, -19]);
    design.addPosition("f12", [-1, 1, 19, -19]);
    design.addPosition("g12", [-1, 1, 19, -19]);
    design.addPosition("h12", [-1, 1, 19, -19]);
    design.addPosition("i12", [-1, 1, 19, -19]);
    design.addPosition("j12", [-1, 1, 19, -19]);
    design.addPosition("k12", [-1, 1, 19, -19]);
    design.addPosition("l12", [-1, 1, 19, -19]);
    design.addPosition("m12", [-1, 1, 19, -19]);
    design.addPosition("n12", [-1, 1, 19, -19]);
    design.addPosition("o12", [-1, 1, 19, -19]);
    design.addPosition("p12", [-1, 1, 19, -19]);
    design.addPosition("q12", [-1, 1, 19, -19]);
    design.addPosition("r12", [-1, 1, 19, -19]);
    design.addPosition("s12", [-1, 0, 19, -19]);
    design.addPosition("a11", [0, 1, 19, -19]);
    design.addPosition("b11", [-1, 1, 19, -19]);
    design.addPosition("c11", [-1, 1, 19, -19]);
    design.addPosition("d11", [-1, 1, 19, -19]);
    design.addPosition("e11", [-1, 1, 19, -19]);
    design.addPosition("f11", [-1, 1, 19, -19]);
    design.addPosition("g11", [-1, 1, 19, -19]);
    design.addPosition("h11", [-1, 1, 19, -19]);
    design.addPosition("i11", [-1, 1, 19, -19]);
    design.addPosition("j11", [-1, 1, 19, -19]);
    design.addPosition("k11", [-1, 1, 19, -19]);
    design.addPosition("l11", [-1, 1, 19, -19]);
    design.addPosition("m11", [-1, 1, 19, -19]);
    design.addPosition("n11", [-1, 1, 19, -19]);
    design.addPosition("o11", [-1, 1, 19, -19]);
    design.addPosition("p11", [-1, 1, 19, -19]);
    design.addPosition("q11", [-1, 1, 19, -19]);
    design.addPosition("r11", [-1, 1, 19, -19]);
    design.addPosition("s11", [-1, 0, 19, -19]);
    design.addPosition("a10", [0, 1, 19, -19]);
    design.addPosition("b10", [-1, 1, 19, -19]);
    design.addPosition("c10", [-1, 1, 19, -19]);
    design.addPosition("d10", [-1, 1, 19, -19]);
    design.addPosition("e10", [-1, 1, 19, -19]);
    design.addPosition("f10", [-1, 1, 19, -19]);
    design.addPosition("g10", [-1, 1, 19, -19]);
    design.addPosition("h10", [-1, 1, 19, -19]);
    design.addPosition("i10", [-1, 1, 19, -19]);
    design.addPosition("j10", [-1, 1, 19, -19]);
    design.addPosition("k10", [-1, 1, 19, -19]);
    design.addPosition("l10", [-1, 1, 19, -19]);
    design.addPosition("m10", [-1, 1, 19, -19]);
    design.addPosition("n10", [-1, 1, 19, -19]);
    design.addPosition("o10", [-1, 1, 19, -19]);
    design.addPosition("p10", [-1, 1, 19, -19]);
    design.addPosition("q10", [-1, 1, 19, -19]);
    design.addPosition("r10", [-1, 1, 19, -19]);
    design.addPosition("s10", [-1, 0, 19, -19]);
    design.addPosition("a9", [0, 1, 19, -19]);
    design.addPosition("b9", [-1, 1, 19, -19]);
    design.addPosition("c9", [-1, 1, 19, -19]);
    design.addPosition("d9", [-1, 1, 19, -19]);
    design.addPosition("e9", [-1, 1, 19, -19]);
    design.addPosition("f9", [-1, 1, 19, -19]);
    design.addPosition("g9", [-1, 1, 19, -19]);
    design.addPosition("h9", [-1, 1, 19, -19]);
    design.addPosition("i9", [-1, 1, 19, -19]);
    design.addPosition("j9", [-1, 1, 19, -19]);
    design.addPosition("k9", [-1, 1, 19, -19]);
    design.addPosition("l9", [-1, 1, 19, -19]);
    design.addPosition("m9", [-1, 1, 19, -19]);
    design.addPosition("n9", [-1, 1, 19, -19]);
    design.addPosition("o9", [-1, 1, 19, -19]);
    design.addPosition("p9", [-1, 1, 19, -19]);
    design.addPosition("q9", [-1, 1, 19, -19]);
    design.addPosition("r9", [-1, 1, 19, -19]);
    design.addPosition("s9", [-1, 0, 19, -19]);
    design.addPosition("a8", [0, 1, 19, -19]);
    design.addPosition("b8", [-1, 1, 19, -19]);
    design.addPosition("c8", [-1, 1, 19, -19]);
    design.addPosition("d8", [-1, 1, 19, -19]);
    design.addPosition("e8", [-1, 1, 19, -19]);
    design.addPosition("f8", [-1, 1, 19, -19]);
    design.addPosition("g8", [-1, 1, 19, -19]);
    design.addPosition("h8", [-1, 1, 19, -19]);
    design.addPosition("i8", [-1, 1, 19, -19]);
    design.addPosition("j8", [-1, 1, 19, -19]);
    design.addPosition("k8", [-1, 1, 19, -19]);
    design.addPosition("l8", [-1, 1, 19, -19]);
    design.addPosition("m8", [-1, 1, 19, -19]);
    design.addPosition("n8", [-1, 1, 19, -19]);
    design.addPosition("o8", [-1, 1, 19, -19]);
    design.addPosition("p8", [-1, 1, 19, -19]);
    design.addPosition("q8", [-1, 1, 19, -19]);
    design.addPosition("r8", [-1, 1, 19, -19]);
    design.addPosition("s8", [-1, 0, 19, -19]);
    design.addPosition("a7", [0, 1, 19, -19]);
    design.addPosition("b7", [-1, 1, 19, -19]);
    design.addPosition("c7", [-1, 1, 19, -19]);
    design.addPosition("d7", [-1, 1, 19, -19]);
    design.addPosition("e7", [-1, 1, 19, -19]);
    design.addPosition("f7", [-1, 1, 19, -19]);
    design.addPosition("g7", [-1, 1, 19, -19]);
    design.addPosition("h7", [-1, 1, 19, -19]);
    design.addPosition("i7", [-1, 1, 19, -19]);
    design.addPosition("j7", [-1, 1, 19, -19]);
    design.addPosition("k7", [-1, 1, 19, -19]);
    design.addPosition("l7", [-1, 1, 19, -19]);
    design.addPosition("m7", [-1, 1, 19, -19]);
    design.addPosition("n7", [-1, 1, 19, -19]);
    design.addPosition("o7", [-1, 1, 19, -19]);
    design.addPosition("p7", [-1, 1, 19, -19]);
    design.addPosition("q7", [-1, 1, 19, -19]);
    design.addPosition("r7", [-1, 1, 19, -19]);
    design.addPosition("s7", [-1, 0, 19, -19]);
    design.addPosition("a6", [0, 1, 19, -19]);
    design.addPosition("b6", [-1, 1, 19, -19]);
    design.addPosition("c6", [-1, 1, 19, -19]);
    design.addPosition("d6", [-1, 1, 19, -19]);
    design.addPosition("e6", [-1, 1, 19, -19]);
    design.addPosition("f6", [-1, 1, 19, -19]);
    design.addPosition("g6", [-1, 1, 19, -19]);
    design.addPosition("h6", [-1, 1, 19, -19]);
    design.addPosition("i6", [-1, 1, 19, -19]);
    design.addPosition("j6", [-1, 1, 19, -19]);
    design.addPosition("k6", [-1, 1, 19, -19]);
    design.addPosition("l6", [-1, 1, 19, -19]);
    design.addPosition("m6", [-1, 1, 19, -19]);
    design.addPosition("n6", [-1, 1, 19, -19]);
    design.addPosition("o6", [-1, 1, 19, -19]);
    design.addPosition("p6", [-1, 1, 19, -19]);
    design.addPosition("q6", [-1, 1, 19, -19]);
    design.addPosition("r6", [-1, 1, 19, -19]);
    design.addPosition("s6", [-1, 0, 19, -19]);
    design.addPosition("a5", [0, 1, 19, -19]);
    design.addPosition("b5", [-1, 1, 19, -19]);
    design.addPosition("c5", [-1, 1, 19, -19]);
    design.addPosition("d5", [-1, 1, 19, -19]);
    design.addPosition("e5", [-1, 1, 19, -19]);
    design.addPosition("f5", [-1, 1, 19, -19]);
    design.addPosition("g5", [-1, 1, 19, -19]);
    design.addPosition("h5", [-1, 1, 19, -19]);
    design.addPosition("i5", [-1, 1, 19, -19]);
    design.addPosition("j5", [-1, 1, 19, -19]);
    design.addPosition("k5", [-1, 1, 19, -19]);
    design.addPosition("l5", [-1, 1, 19, -19]);
    design.addPosition("m5", [-1, 1, 19, -19]);
    design.addPosition("n5", [-1, 1, 19, -19]);
    design.addPosition("o5", [-1, 1, 19, -19]);
    design.addPosition("p5", [-1, 1, 19, -19]);
    design.addPosition("q5", [-1, 1, 19, -19]);
    design.addPosition("r5", [-1, 1, 19, -19]);
    design.addPosition("s5", [-1, 0, 19, -19]);
    design.addPosition("a4", [0, 1, 19, -19]);
    design.addPosition("b4", [-1, 1, 19, -19]);
    design.addPosition("c4", [-1, 1, 19, -19]);
    design.addPosition("d4", [-1, 1, 19, -19]);
    design.addPosition("e4", [-1, 1, 19, -19]);
    design.addPosition("f4", [-1, 1, 19, -19]);
    design.addPosition("g4", [-1, 1, 19, -19]);
    design.addPosition("h4", [-1, 1, 19, -19]);
    design.addPosition("i4", [-1, 1, 19, -19]);
    design.addPosition("j4", [-1, 1, 19, -19]);
    design.addPosition("k4", [-1, 1, 19, -19]);
    design.addPosition("l4", [-1, 1, 19, -19]);
    design.addPosition("m4", [-1, 1, 19, -19]);
    design.addPosition("n4", [-1, 1, 19, -19]);
    design.addPosition("o4", [-1, 1, 19, -19]);
    design.addPosition("p4", [-1, 1, 19, -19]);
    design.addPosition("q4", [-1, 1, 19, -19]);
    design.addPosition("r4", [-1, 1, 19, -19]);
    design.addPosition("s4", [-1, 0, 19, -19]);
    design.addPosition("a3", [0, 1, 19, -19]);
    design.addPosition("b3", [-1, 1, 19, -19]);
    design.addPosition("c3", [-1, 1, 19, -19]);
    design.addPosition("d3", [-1, 1, 19, -19]);
    design.addPosition("e3", [-1, 1, 19, -19]);
    design.addPosition("f3", [-1, 1, 19, -19]);
    design.addPosition("g3", [-1, 1, 19, -19]);
    design.addPosition("h3", [-1, 1, 19, -19]);
    design.addPosition("i3", [-1, 1, 19, -19]);
    design.addPosition("j3", [-1, 1, 19, -19]);
    design.addPosition("k3", [-1, 1, 19, -19]);
    design.addPosition("l3", [-1, 1, 19, -19]);
    design.addPosition("m3", [-1, 1, 19, -19]);
    design.addPosition("n3", [-1, 1, 19, -19]);
    design.addPosition("o3", [-1, 1, 19, -19]);
    design.addPosition("p3", [-1, 1, 19, -19]);
    design.addPosition("q3", [-1, 1, 19, -19]);
    design.addPosition("r3", [-1, 1, 19, -19]);
    design.addPosition("s3", [-1, 0, 19, -19]);
    design.addPosition("a2", [0, 1, 19, -19]);
    design.addPosition("b2", [-1, 1, 19, -19]);
    design.addPosition("c2", [-1, 1, 19, -19]);
    design.addPosition("d2", [-1, 1, 19, -19]);
    design.addPosition("e2", [-1, 1, 19, -19]);
    design.addPosition("f2", [-1, 1, 19, -19]);
    design.addPosition("g2", [-1, 1, 19, -19]);
    design.addPosition("h2", [-1, 1, 19, -19]);
    design.addPosition("i2", [-1, 1, 19, -19]);
    design.addPosition("j2", [-1, 1, 19, -19]);
    design.addPosition("k2", [-1, 1, 19, -19]);
    design.addPosition("l2", [-1, 1, 19, -19]);
    design.addPosition("m2", [-1, 1, 19, -19]);
    design.addPosition("n2", [-1, 1, 19, -19]);
    design.addPosition("o2", [-1, 1, 19, -19]);
    design.addPosition("p2", [-1, 1, 19, -19]);
    design.addPosition("q2", [-1, 1, 19, -19]);
    design.addPosition("r2", [-1, 1, 19, -19]);
    design.addPosition("s2", [-1, 0, 19, -19]);
    design.addPosition("a1", [0, 1, 0, -19]);
    design.addPosition("b1", [-1, 1, 0, -19]);
    design.addPosition("c1", [-1, 1, 0, -19]);
    design.addPosition("d1", [-1, 1, 0, -19]);
    design.addPosition("e1", [-1, 1, 0, -19]);
    design.addPosition("f1", [-1, 1, 0, -19]);
    design.addPosition("g1", [-1, 1, 0, -19]);
    design.addPosition("h1", [-1, 1, 0, -19]);
    design.addPosition("i1", [-1, 1, 0, -19]);
    design.addPosition("j1", [-1, 1, 0, -19]);
    design.addPosition("k1", [-1, 1, 0, -19]);
    design.addPosition("l1", [-1, 1, 0, -19]);
    design.addPosition("m1", [-1, 1, 0, -19]);
    design.addPosition("n1", [-1, 1, 0, -19]);
    design.addPosition("o1", [-1, 1, 0, -19]);
    design.addPosition("p1", [-1, 1, 0, -19]);
    design.addPosition("q1", [-1, 1, 0, -19]);
    design.addPosition("r1", [-1, 1, 0, -19]);
    design.addPosition("s1", [-1, 0, 0, -19]);

    design.addCommand(0, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(0, ZRF.FUNCTION,	20);	// verify
    design.addCommand(0, ZRF.FUNCTION,	25);	// to
    design.addCommand(0, ZRF.FUNCTION,	28);	// end

    design.addPiece("Stone", 0);
    design.addDrop(0, 0, [], 0);

    design.addPiece("Dead", 1);
}

Dagaz.View.configure = function(view) {
    view.defBoard("Board");
    view.defPiece("BlackStone", "Black Stone");
    view.defPiece("WhiteStone", "White Stone");
    view.defPiece("BlackDead", "Black Dead");
    view.defPiece("WhiteDead", "White Dead");
 
    view.defPosition("a19", 9, 9, 27, 26);
    view.defPosition("b19", 35, 9, 27, 26);
    view.defPosition("c19", 61, 9, 27, 26);
    view.defPosition("d19", 87, 9, 27, 26);
    view.defPosition("e19", 112, 9, 27, 26);
    view.defPosition("f19", 138, 9, 27, 26);
    view.defPosition("g19", 165, 9, 27, 26);
    view.defPosition("h19", 190, 9, 27, 26);
    view.defPosition("i19", 216, 9, 27, 26);
    view.defPosition("j19", 242, 9, 27, 26);
    view.defPosition("k19", 268, 9, 27, 26);
    view.defPosition("l19", 293, 9, 27, 26);
    view.defPosition("m19", 318, 9, 27, 26);
    view.defPosition("n19", 344, 9, 27, 26);
    view.defPosition("o19", 369, 9, 27, 26);
    view.defPosition("p19", 395, 9, 27, 26);
    view.defPosition("q19", 421, 9, 27, 26);
    view.defPosition("r19", 447, 9, 27, 26);
    view.defPosition("s19", 473, 9, 27, 26);
    view.defPosition("a18", 9, 35, 27, 26);
    view.defPosition("b18", 35, 35, 27, 26);
    view.defPosition("c18", 61, 35, 27, 26);
    view.defPosition("d18", 87, 35, 27, 26);
    view.defPosition("e18", 112, 35, 27, 26);
    view.defPosition("f18", 138, 35, 27, 26);
    view.defPosition("g18", 165, 35, 27, 26);
    view.defPosition("h18", 190, 35, 27, 26);
    view.defPosition("i18", 216, 35, 27, 26);
    view.defPosition("j18", 242, 35, 27, 26);
    view.defPosition("k18", 268, 35, 27, 26);
    view.defPosition("l18", 293, 35, 27, 26);
    view.defPosition("m18", 318, 35, 27, 26);
    view.defPosition("n18", 344, 35, 27, 26);
    view.defPosition("o18", 369, 35, 27, 26);
    view.defPosition("p18", 395, 35, 27, 26);
    view.defPosition("q18", 421, 35, 27, 26);
    view.defPosition("r18", 447, 35, 27, 26);
    view.defPosition("s18", 473, 35, 27, 26);
    view.defPosition("a17", 9, 61, 27, 26);
    view.defPosition("b17", 35, 61, 27, 26);
    view.defPosition("c17", 61, 61, 27, 26);
    view.defPosition("d17", 87, 61, 27, 26);
    view.defPosition("e17", 112, 61, 27, 26);
    view.defPosition("f17", 138, 61, 27, 26);
    view.defPosition("g17", 165, 61, 27, 26);
    view.defPosition("h17", 190, 61, 27, 26);
    view.defPosition("i17", 216, 61, 27, 26);
    view.defPosition("j17", 242, 61, 27, 26);
    view.defPosition("k17", 268, 61, 27, 26);
    view.defPosition("l17", 293, 61, 27, 26);
    view.defPosition("m17", 318, 61, 27, 26);
    view.defPosition("n17", 344, 61, 27, 26);
    view.defPosition("o17", 369, 61, 27, 26);
    view.defPosition("p17", 395, 61, 27, 26);
    view.defPosition("q17", 421, 61, 27, 26);
    view.defPosition("r17", 447, 61, 27, 26);
    view.defPosition("s17", 473, 61, 27, 26);
    view.defPosition("a16", 9, 87, 27, 26);
    view.defPosition("b16", 35, 87, 27, 26);
    view.defPosition("c16", 61, 87, 27, 26);
    view.defPosition("d16", 87, 87, 27, 26);
    view.defPosition("e16", 112, 87, 27, 26);
    view.defPosition("f16", 138, 87, 27, 26);
    view.defPosition("g16", 165, 87, 27, 26);
    view.defPosition("h16", 190, 87, 27, 26);
    view.defPosition("i16", 216, 87, 27, 26);
    view.defPosition("j16", 242, 87, 27, 26);
    view.defPosition("k16", 268, 87, 27, 26);
    view.defPosition("l16", 293, 87, 27, 26);
    view.defPosition("m16", 318, 87, 27, 26);
    view.defPosition("n16", 344, 87, 27, 26);
    view.defPosition("o16", 369, 87, 27, 26);
    view.defPosition("p16", 395, 87, 27, 26);
    view.defPosition("q16", 421, 87, 27, 26);
    view.defPosition("r16", 447, 87, 27, 26);
    view.defPosition("s16", 473, 87, 27, 26);
    view.defPosition("a15", 9, 113, 27, 26);
    view.defPosition("b15", 35, 113, 27, 26);
    view.defPosition("c15", 61, 113, 27, 26);
    view.defPosition("d15", 87, 113, 27, 26);
    view.defPosition("e15", 112, 113, 27, 26);
    view.defPosition("f15", 138, 113, 27, 26);
    view.defPosition("g15", 165, 113, 27, 26);
    view.defPosition("h15", 190, 113, 27, 26);
    view.defPosition("i15", 216, 113, 27, 26);
    view.defPosition("j15", 242, 113, 27, 26);
    view.defPosition("k15", 268, 113, 27, 26);
    view.defPosition("l15", 293, 113, 27, 26);
    view.defPosition("m15", 318, 113, 27, 26);
    view.defPosition("n15", 344, 113, 27, 26);
    view.defPosition("o15", 369, 113, 27, 26);
    view.defPosition("p15", 395, 113, 27, 26);
    view.defPosition("q15", 421, 113, 27, 26);
    view.defPosition("r15", 447, 113, 27, 26);
    view.defPosition("s15", 473, 113, 27, 26);
    view.defPosition("a14", 9, 139, 27, 26);
    view.defPosition("b14", 35, 139, 27, 26);
    view.defPosition("c14", 61, 139, 27, 26);
    view.defPosition("d14", 87, 139, 27, 26);
    view.defPosition("e14", 112, 139, 27, 26);
    view.defPosition("f14", 138, 139, 27, 26);
    view.defPosition("g14", 165, 139, 27, 26);
    view.defPosition("h14", 190, 139, 27, 26);
    view.defPosition("i14", 216, 139, 27, 26);
    view.defPosition("j14", 242, 139, 27, 26);
    view.defPosition("k14", 268, 139, 27, 26);
    view.defPosition("l14", 293, 139, 27, 26);
    view.defPosition("m14", 318, 139, 27, 26);
    view.defPosition("n14", 344, 139, 27, 26);
    view.defPosition("o14", 369, 139, 27, 26);
    view.defPosition("p14", 395, 139, 27, 26);
    view.defPosition("q14", 421, 139, 27, 26);
    view.defPosition("r14", 447, 139, 27, 26);
    view.defPosition("s14", 473, 139, 27, 26);
    view.defPosition("a13", 9, 165, 27, 26);
    view.defPosition("b13", 35, 165, 27, 26);
    view.defPosition("c13", 61, 165, 27, 26);
    view.defPosition("d13", 87, 165, 27, 26);
    view.defPosition("e13", 112, 165, 27, 26);
    view.defPosition("f13", 138, 165, 27, 26);
    view.defPosition("g13", 165, 165, 27, 26);
    view.defPosition("h13", 190, 165, 27, 26);
    view.defPosition("i13", 216, 165, 27, 26);
    view.defPosition("j13", 242, 165, 27, 26);
    view.defPosition("k13", 268, 165, 27, 26);
    view.defPosition("l13", 293, 165, 27, 26);
    view.defPosition("m13", 318, 165, 27, 26);
    view.defPosition("n13", 344, 165, 27, 26);
    view.defPosition("o13", 369, 165, 27, 26);
    view.defPosition("p13", 395, 165, 27, 26);
    view.defPosition("q13", 421, 165, 27, 26);
    view.defPosition("r13", 447, 165, 27, 26);
    view.defPosition("s13", 473, 165, 27, 26);
    view.defPosition("a12", 9, 191, 27, 26);
    view.defPosition("b12", 35, 191, 27, 26);
    view.defPosition("c12", 61, 191, 27, 26);
    view.defPosition("d12", 87, 191, 27, 26);
    view.defPosition("e12", 112, 191, 27, 26);
    view.defPosition("f12", 138, 191, 27, 26);
    view.defPosition("g12", 165, 191, 27, 26);
    view.defPosition("h12", 190, 191, 27, 26);
    view.defPosition("i12", 216, 191, 27, 26);
    view.defPosition("j12", 242, 191, 27, 26);
    view.defPosition("k12", 268, 191, 27, 26);
    view.defPosition("l12", 293, 191, 27, 26);
    view.defPosition("m12", 318, 191, 27, 26);
    view.defPosition("n12", 344, 191, 27, 26);
    view.defPosition("o12", 369, 191, 27, 26);
    view.defPosition("p12", 395, 191, 27, 26);
    view.defPosition("q12", 421, 191, 27, 26);
    view.defPosition("r12", 447, 191, 27, 26);
    view.defPosition("s12", 473, 191, 27, 26);
    view.defPosition("a11", 9, 217, 27, 26);
    view.defPosition("b11", 35, 217, 27, 26);
    view.defPosition("c11", 61, 217, 27, 26);
    view.defPosition("d11", 87, 217, 27, 26);
    view.defPosition("e11", 112, 217, 27, 26);
    view.defPosition("f11", 138, 217, 27, 26);
    view.defPosition("g11", 165, 217, 27, 26);
    view.defPosition("h11", 190, 217, 27, 26);
    view.defPosition("i11", 216, 217, 27, 26);
    view.defPosition("j11", 242, 217, 27, 26);
    view.defPosition("k11", 268, 217, 27, 26);
    view.defPosition("l11", 293, 217, 27, 26);
    view.defPosition("m11", 318, 217, 27, 26);
    view.defPosition("n11", 344, 217, 27, 26);
    view.defPosition("o11", 369, 217, 27, 26);
    view.defPosition("p11", 395, 217, 27, 26);
    view.defPosition("q11", 421, 217, 27, 26);
    view.defPosition("r11", 447, 217, 27, 26);
    view.defPosition("s11", 473, 217, 27, 26);
    view.defPosition("a10", 9, 243, 27, 26);
    view.defPosition("b10", 35, 243, 27, 26);
    view.defPosition("c10", 61, 243, 27, 26);
    view.defPosition("d10", 87, 243, 27, 26);
    view.defPosition("e10", 112, 243, 27, 26);
    view.defPosition("f10", 138, 243, 27, 26);
    view.defPosition("g10", 165, 243, 27, 26);
    view.defPosition("h10", 190, 243, 27, 26);
    view.defPosition("i10", 216, 243, 27, 26);
    view.defPosition("j10", 242, 243, 27, 26);
    view.defPosition("k10", 268, 243, 27, 26);
    view.defPosition("l10", 293, 243, 27, 26);
    view.defPosition("m10", 318, 243, 27, 26);
    view.defPosition("n10", 344, 243, 27, 26);
    view.defPosition("o10", 369, 243, 27, 26);
    view.defPosition("p10", 395, 243, 27, 26);
    view.defPosition("q10", 421, 243, 27, 26);
    view.defPosition("r10", 447, 243, 27, 26);
    view.defPosition("s10", 473, 243, 27, 26);
    view.defPosition("a9", 9, 269, 27, 26);
    view.defPosition("b9", 35, 269, 27, 26);
    view.defPosition("c9", 61, 269, 27, 26);
    view.defPosition("d9", 87, 269, 27, 26);
    view.defPosition("e9", 112, 269, 27, 26);
    view.defPosition("f9", 138, 269, 27, 26);
    view.defPosition("g9", 165, 269, 27, 26);
    view.defPosition("h9", 190, 269, 27, 26);
    view.defPosition("i9", 216, 269, 27, 26);
    view.defPosition("j9", 242, 269, 27, 26);
    view.defPosition("k9", 268, 269, 27, 26);
    view.defPosition("l9", 293, 269, 27, 26);
    view.defPosition("m9", 318, 269, 27, 26);
    view.defPosition("n9", 344, 269, 27, 26);
    view.defPosition("o9", 369, 269, 27, 26);
    view.defPosition("p9", 395, 269, 27, 26);
    view.defPosition("q9", 421, 269, 27, 26);
    view.defPosition("r9", 447, 269, 27, 26);
    view.defPosition("s9", 473, 269, 27, 26);
    view.defPosition("a8", 9, 295, 27, 26);
    view.defPosition("b8", 35, 295, 27, 26);
    view.defPosition("c8", 61, 295, 27, 26);
    view.defPosition("d8", 87, 295, 27, 26);
    view.defPosition("e8", 112, 295, 27, 26);
    view.defPosition("f8", 138, 295, 27, 26);
    view.defPosition("g8", 165, 295, 27, 26);
    view.defPosition("h8", 190, 295, 27, 26);
    view.defPosition("i8", 216, 295, 27, 26);
    view.defPosition("j8", 242, 295, 27, 26);
    view.defPosition("k8", 268, 295, 27, 26);
    view.defPosition("l8", 293, 295, 27, 26);
    view.defPosition("m8", 318, 295, 27, 26);
    view.defPosition("n8", 344, 295, 27, 26);
    view.defPosition("o8", 369, 295, 27, 26);
    view.defPosition("p8", 395, 295, 27, 26);
    view.defPosition("q8", 421, 295, 27, 26);
    view.defPosition("r8", 447, 295, 27, 26);
    view.defPosition("s8", 473, 295, 27, 26);
    view.defPosition("a7", 9, 321, 27, 26);
    view.defPosition("b7", 35, 321, 27, 26);
    view.defPosition("c7", 61, 321, 27, 26);
    view.defPosition("d7", 87, 321, 27, 26);
    view.defPosition("e7", 112, 321, 27, 26);
    view.defPosition("f7", 138, 321, 27, 26);
    view.defPosition("g7", 165, 321, 27, 26);
    view.defPosition("h7", 190, 321, 27, 26);
    view.defPosition("i7", 216, 321, 27, 26);
    view.defPosition("j7", 242, 321, 27, 26);
    view.defPosition("k7", 268, 321, 27, 26);
    view.defPosition("l7", 293, 321, 27, 26);
    view.defPosition("m7", 318, 321, 27, 26);
    view.defPosition("n7", 344, 321, 27, 26);
    view.defPosition("o7", 369, 321, 27, 26);
    view.defPosition("p7", 395, 321, 27, 26);
    view.defPosition("q7", 421, 321, 27, 26);
    view.defPosition("r7", 447, 321, 27, 26);
    view.defPosition("s7", 473, 321, 27, 26);
    view.defPosition("a6", 9, 347, 27, 26);
    view.defPosition("b6", 35, 347, 27, 26);
    view.defPosition("c6", 61, 347, 27, 26);
    view.defPosition("d6", 87, 347, 27, 26);
    view.defPosition("e6", 112, 347, 27, 26);
    view.defPosition("f6", 138, 347, 27, 26);
    view.defPosition("g6", 165, 347, 27, 26);
    view.defPosition("h6", 190, 347, 27, 26);
    view.defPosition("i6", 216, 347, 27, 26);
    view.defPosition("j6", 242, 347, 27, 26);
    view.defPosition("k6", 268, 347, 27, 26);
    view.defPosition("l6", 293, 347, 27, 26);
    view.defPosition("m6", 318, 347, 27, 26);
    view.defPosition("n6", 344, 347, 27, 26);
    view.defPosition("o6", 369, 347, 27, 26);
    view.defPosition("p6", 395, 347, 27, 26);
    view.defPosition("q6", 421, 347, 27, 26);
    view.defPosition("r6", 447, 347, 27, 26);
    view.defPosition("s6", 473, 347, 27, 26);
    view.defPosition("a5", 9, 373, 27, 26);
    view.defPosition("b5", 35, 373, 27, 26);
    view.defPosition("c5", 61, 373, 27, 26);
    view.defPosition("d5", 87, 373, 27, 26);
    view.defPosition("e5", 112, 373, 27, 26);
    view.defPosition("f5", 138, 373, 27, 26);
    view.defPosition("g5", 165, 373, 27, 26);
    view.defPosition("h5", 190, 373, 27, 26);
    view.defPosition("i5", 216, 373, 27, 26);
    view.defPosition("j5", 242, 373, 27, 26);
    view.defPosition("k5", 268, 373, 27, 26);
    view.defPosition("l5", 293, 373, 27, 26);
    view.defPosition("m5", 318, 373, 27, 26);
    view.defPosition("n5", 344, 373, 27, 26);
    view.defPosition("o5", 369, 373, 27, 26);
    view.defPosition("p5", 395, 373, 27, 26);
    view.defPosition("q5", 421, 373, 27, 26);
    view.defPosition("r5", 447, 373, 27, 26);
    view.defPosition("s5", 473, 373, 27, 26);
    view.defPosition("a4", 9, 399, 27, 26);
    view.defPosition("b4", 35, 399, 27, 26);
    view.defPosition("c4", 61, 399, 27, 26);
    view.defPosition("d4", 87, 399, 27, 26);
    view.defPosition("e4", 112, 399, 27, 26);
    view.defPosition("f4", 138, 399, 27, 26);
    view.defPosition("g4", 165, 399, 27, 26);
    view.defPosition("h4", 190, 399, 27, 26);
    view.defPosition("i4", 216, 399, 27, 26);
    view.defPosition("j4", 242, 399, 27, 26);
    view.defPosition("k4", 268, 399, 27, 26);
    view.defPosition("l4", 293, 399, 27, 26);
    view.defPosition("m4", 318, 399, 27, 26);
    view.defPosition("n4", 344, 399, 27, 26);
    view.defPosition("o4", 369, 399, 27, 26);
    view.defPosition("p4", 395, 399, 27, 26);
    view.defPosition("q4", 421, 399, 27, 26);
    view.defPosition("r4", 447, 399, 27, 26);
    view.defPosition("s4", 473, 399, 27, 26);
    view.defPosition("a3", 9, 425, 27, 26);
    view.defPosition("b3", 35, 425, 27, 26);
    view.defPosition("c3", 61, 425, 27, 26);
    view.defPosition("d3", 87, 425, 27, 26);
    view.defPosition("e3", 112, 425, 27, 26);
    view.defPosition("f3", 138, 425, 27, 26);
    view.defPosition("g3", 165, 425, 27, 26);
    view.defPosition("h3", 190, 425, 27, 26);
    view.defPosition("i3", 216, 425, 27, 26);
    view.defPosition("j3", 242, 425, 27, 26);
    view.defPosition("k3", 268, 425, 27, 26);
    view.defPosition("l3", 293, 425, 27, 26);
    view.defPosition("m3", 318, 425, 27, 26);
    view.defPosition("n3", 344, 425, 27, 26);
    view.defPosition("o3", 369, 425, 27, 26);
    view.defPosition("p3", 395, 425, 27, 26);
    view.defPosition("q3", 421, 425, 27, 26);
    view.defPosition("r3", 447, 425, 27, 26);
    view.defPosition("s3", 473, 425, 27, 26);
    view.defPosition("a2", 9, 451, 27, 26);
    view.defPosition("b2", 35, 451, 27, 26);
    view.defPosition("c2", 61, 451, 27, 26);
    view.defPosition("d2", 87, 451, 27, 26);
    view.defPosition("e2", 112, 451, 27, 26);
    view.defPosition("f2", 138, 451, 27, 26);
    view.defPosition("g2", 165, 451, 27, 26);
    view.defPosition("h2", 190, 451, 27, 26);
    view.defPosition("i2", 216, 451, 27, 26);
    view.defPosition("j2", 242, 451, 27, 26);
    view.defPosition("k2", 268, 451, 27, 26);
    view.defPosition("l2", 293, 451, 27, 26);
    view.defPosition("m2", 318, 451, 27, 26);
    view.defPosition("n2", 344, 451, 27, 26);
    view.defPosition("o2", 369, 451, 27, 26);
    view.defPosition("p2", 395, 451, 27, 26);
    view.defPosition("q2", 421, 451, 27, 26);
    view.defPosition("r2", 447, 451, 27, 26);
    view.defPosition("s2", 473, 451, 27, 26);
    view.defPosition("a1", 9, 477, 27, 26);
    view.defPosition("b1", 35, 477, 27, 26);
    view.defPosition("c1", 61, 477, 27, 26);
    view.defPosition("d1", 87, 477, 27, 26);
    view.defPosition("e1", 112, 477, 27, 26);
    view.defPosition("f1", 138, 477, 27, 26);
    view.defPosition("g1", 165, 477, 27, 26);
    view.defPosition("h1", 190, 477, 27, 26);
    view.defPosition("i1", 216, 477, 27, 26);
    view.defPosition("j1", 242, 477, 27, 26);
    view.defPosition("k1", 268, 477, 27, 26);
    view.defPosition("l1", 293, 477, 27, 26);
    view.defPosition("m1", 318, 477, 27, 26);
    view.defPosition("n1", 344, 477, 27, 26);
    view.defPosition("o1", 369, 477, 27, 26);
    view.defPosition("p1", 395, 477, 27, 26);
    view.defPosition("q1", 421, 477, 27, 26);
    view.defPosition("r1", 447, 477, 27, 26);
    view.defPosition("s1", 473, 477, 27, 26);
}
