(function() {

Dagaz.View.DX       = 0;
Dagaz.View.DY       = 0;
Dagaz.View.MX       = 25;

var size  = 5;

if (!_.isUndefined(Dagaz.Controller.addSound)) {
    Dagaz.Controller.addSound(2, "../sounds/win.wav");
}

var checkVersion = Dagaz.Model.checkVersion;

Dagaz.Model.checkVersion = function(design, name, value) {
  if (name == "tchuka-ruma-extension") {
      size = +value;
  } else {
      checkVersion(design, name, value);
  }
}

var CheckInvariants = Dagaz.Model.CheckInvariants;

Dagaz.Model.CheckInvariants = function(board) {
  var design = Dagaz.Model.design;
  _.each(board.moves, function(move) {
      if (move.isSimpleMove()) {
          var pos = move.actions[0][0][0];
          var piece = board.getPiece(pos);
          var cnt = Math.abs(+piece.getValue(0));
          var result = [];
          result.push(0);
          for (var ix = 1; cnt > 0; cnt--, ix++) {
               pos = design.navigate(board.player, pos, 0);
               if (pos === null) {
                   move.failed = true;
                   return;
               }
               if (ix >= size) {
                   ix = 0;
               }
               piece = board.getPiece(pos);
               if (ix < result.length) {
                   result[ix]++;
               } else {
                   if (piece === null) {
                       result.push(1);
                   } else {
                       result.push(Math.abs(+piece.getValue(0)) + 1);
                   }
               }
          }
          if ((result[ix - 1] > 1) || (ix < result.length - 1) || (pos == size - 1)) {
               result[ix - 1] = -result[ix - 1];
          }
          var pos = move.actions[0][0][0];
          for (var ix = 0; ix < result.length; ix++) {
               var player = board.player;
               var piece = Dagaz.Model.createPiece(0, player).setValue(0, result[ix]);
               if (result[ix] == 0) {
                   if (ix > 0) {
                       move.capturePiece(pos);
                       if (ix == 1) {
                           move.actions[0][2] = [ Dagaz.Model.createPiece(1, board.player) ];
                       }
                   }
               } else {
                   if (piece !== null) {
                       if (ix == 1) {
                           move.actions[0][2] = [ piece ];
                       } else {
                           if ((board.getPiece(pos) !== null) && (ix > 0)) {
                               move.movePiece(pos, pos, piece);
                           } else {
                               move.dropPiece(pos, piece);
                           }
                       }
                   }
               }
               pos = design.navigate(board.player, pos, 0);
          }
          var f = true;
          _.each(move.actions, function(a) {
              if ((a[1] !== null) && (a[1][0] == size - 1)) {
                  f = false;
              }
          });
          if (f) {
              var pos = size - 1;
              var piece = board.getPiece(pos);
              if (piece !== null) {
                  var value = +piece.getValue(0);
                  if (value < 0) {
                      piece = piece.setValue(0, -value);
                      move.movePiece(pos, pos, piece);
                  }
              }
          }
      }
  });
  var ko = [];
  _.each(design.allPositions(), function(pos) {
      if (design.inZone(0, 1, pos)) {
          var piece = board.getPiece(pos);
          if (piece !== null) {
              var value = +piece.getValue(0);
              if ((value !== null) && (value < 0)) {
                  ko.push(pos);
              }
          }
      }
  });
  if (ko.length > 0) {
      board.ko = ko;
  }
  CheckInvariants(board);
}

})();
