ZRF = {
    JUMP:          0,
    IF:            1,
    FORK:          2,
    FUNCTION:      3,
    IN_ZONE:       4,
    FLAG:          5,
    SET_FLAG:      6,
    POS_FLAG:      7,
    SET_POS_FLAG:  8,
    ATTR:          9,
    SET_ATTR:      10,
    PROMOTE:       11,
    MODE:          12,
    ON_BOARD_DIR:  13,
    ON_BOARD_POS:  14,
    PARAM:         15,
    LITERAL:       16,
    VERIFY:        20
};

Dagaz.Model.BuildDesign = function(design) {
    design.checkVersion("z2j", "2");
    design.checkVersion("pass-partial", "true");
    design.checkVersion("smart-moves", "false");
    design.checkVersion("show-hints", "false");
    design.checkVersion("show-blink", "true");
    design.checkVersion("show-captures", "false");
    design.checkVersion("promote-dialog", "remap");
    design.checkVersion("makadaidaishogi-promotion", "true");

    design.addDirection("sw");  // 0
    design.addDirection("e");   // 1
    design.addDirection("e2T"); // 2
    design.addDirection("w2B"); // 3
    design.addDirection("nw");  // 4
    design.addDirection("n2L"); // 5
    design.addDirection("s2L"); // 6
    design.addDirection("n");   // 7
    design.addDirection("n2R"); // 8
    design.addDirection("se");  // 9
    design.addDirection("s2R"); // 10
    design.addDirection("s");   // 11
    design.addDirection("e2B"); // 12
    design.addDirection("w");   // 13
    design.addDirection("ne");  // 14
    design.addDirection("w2T"); // 15

    design.addPlayer("Black", [14, 13, 3, 2, 9, 10, 8, 11, 6, 4, 5, 7, 15, 1, 0, 12]);
    design.addPlayer("White", [14, 13, 3, 2, 9, 10, 8, 11, 6, 4, 5, 7, 15, 1, 0, 12]);

    design.addPosition("a19", [0, 1, 0, 0, 0, 0, 0, 0, 0, 20, 39, 19, 21, 0, 0, 0]);
    design.addPosition("b19", [18, 1, 0, 0, 0, 0, 37, 0, 0, 20, 39, 19, 21, -1, 0, 0]);
    design.addPosition("c19", [18, 1, 0, 17, 0, 0, 37, 0, 0, 20, 39, 19, 21, -1, 0, 0]);
    design.addPosition("d19", [18, 1, 0, 17, 0, 0, 37, 0, 0, 20, 39, 19, 21, -1, 0, 0]);
    design.addPosition("e19", [18, 1, 0, 17, 0, 0, 37, 0, 0, 20, 39, 19, 21, -1, 0, 0]);
    design.addPosition("f19", [18, 1, 0, 17, 0, 0, 37, 0, 0, 20, 39, 19, 21, -1, 0, 0]);
    design.addPosition("g19", [18, 1, 0, 17, 0, 0, 37, 0, 0, 20, 39, 19, 21, -1, 0, 0]);
    design.addPosition("h19", [18, 1, 0, 17, 0, 0, 37, 0, 0, 20, 39, 19, 21, -1, 0, 0]);
    design.addPosition("i19", [18, 1, 0, 17, 0, 0, 37, 0, 0, 20, 39, 19, 21, -1, 0, 0]);
    design.addPosition("j19", [18, 1, 0, 17, 0, 0, 37, 0, 0, 20, 39, 19, 21, -1, 0, 0]);
    design.addPosition("k19", [18, 1, 0, 17, 0, 0, 37, 0, 0, 20, 39, 19, 21, -1, 0, 0]);
    design.addPosition("l19", [18, 1, 0, 17, 0, 0, 37, 0, 0, 20, 39, 19, 21, -1, 0, 0]);
    design.addPosition("m19", [18, 1, 0, 17, 0, 0, 37, 0, 0, 20, 39, 19, 21, -1, 0, 0]);
    design.addPosition("n19", [18, 1, 0, 17, 0, 0, 37, 0, 0, 20, 39, 19, 21, -1, 0, 0]);
    design.addPosition("o19", [18, 1, 0, 17, 0, 0, 37, 0, 0, 20, 39, 19, 21, -1, 0, 0]);
    design.addPosition("p19", [18, 1, 0, 17, 0, 0, 37, 0, 0, 20, 39, 19, 21, -1, 0, 0]);
    design.addPosition("q19", [18, 1, 0, 17, 0, 0, 37, 0, 0, 20, 39, 19, 21, -1, 0, 0]);
    design.addPosition("r19", [18, 1, 0, 17, 0, 0, 37, 0, 0, 20, 39, 19, 0, -1, 0, 0]);
    design.addPosition("s19", [18, 0, 0, 17, 0, 0, 37, 0, 0, 0, 0, 19, 0, -1, 0, 0]);
    design.addPosition("a18", [0, 1, -17, 0, 0, 0, 0, -19, 0, 20, 39, 19, 21, 0, -18, 0]);
    design.addPosition("b18", [18, 1, -17, 0, -20, 0, 37, -19, 0, 20, 39, 19, 21, -1, -18, 0]);
    design.addPosition("c18", [18, 1, -17, 17, -20, 0, 37, -19, 0, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("d18", [18, 1, -17, 17, -20, 0, 37, -19, 0, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("e18", [18, 1, -17, 17, -20, 0, 37, -19, 0, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("f18", [18, 1, -17, 17, -20, 0, 37, -19, 0, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("g18", [18, 1, -17, 17, -20, 0, 37, -19, 0, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("h18", [18, 1, -17, 17, -20, 0, 37, -19, 0, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("i18", [18, 1, -17, 17, -20, 0, 37, -19, 0, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("j18", [18, 1, -17, 17, -20, 0, 37, -19, 0, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("k18", [18, 1, -17, 17, -20, 0, 37, -19, 0, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("l18", [18, 1, -17, 17, -20, 0, 37, -19, 0, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("m18", [18, 1, -17, 17, -20, 0, 37, -19, 0, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("n18", [18, 1, -17, 17, -20, 0, 37, -19, 0, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("o18", [18, 1, -17, 17, -20, 0, 37, -19, 0, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("p18", [18, 1, -17, 17, -20, 0, 37, -19, 0, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("q18", [18, 1, -17, 17, -20, 0, 37, -19, 0, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("r18", [18, 1, 0, 17, -20, 0, 37, -19, 0, 20, 39, 19, 0, -1, -18, -21]);
    design.addPosition("s18", [18, 0, 0, 17, -20, 0, 37, -19, 0, 0, 0, 19, 0, -1, 0, -21]);
    design.addPosition("a17", [0, 1, -17, 0, 0, 0, 0, -19, -37, 20, 39, 19, 21, 0, -18, 0]);
    design.addPosition("b17", [18, 1, -17, 0, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, 0]);
    design.addPosition("c17", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("d17", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("e17", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("f17", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("g17", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("h17", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("i17", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("j17", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("k17", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("l17", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("m17", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("n17", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("o17", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("p17", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("q17", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("r17", [18, 1, 0, 17, -20, -39, 37, -19, -37, 20, 39, 19, 0, -1, -18, -21]);
    design.addPosition("s17", [18, 0, 0, 17, -20, -39, 37, -19, 0, 0, 0, 19, 0, -1, 0, -21]);
    design.addPosition("a16", [0, 1, -17, 0, 0, 0, 0, -19, -37, 20, 39, 19, 21, 0, -18, 0]);
    design.addPosition("b16", [18, 1, -17, 0, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, 0]);
    design.addPosition("c16", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("d16", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("e16", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("f16", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("g16", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("h16", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("i16", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("j16", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("k16", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("l16", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("m16", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("n16", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("o16", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("p16", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("q16", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("r16", [18, 1, 0, 17, -20, -39, 37, -19, -37, 20, 39, 19, 0, -1, -18, -21]);
    design.addPosition("s16", [18, 0, 0, 17, -20, -39, 37, -19, 0, 0, 0, 19, 0, -1, 0, -21]);
    design.addPosition("a15", [0, 1, -17, 0, 0, 0, 0, -19, -37, 20, 39, 19, 21, 0, -18, 0]);
    design.addPosition("b15", [18, 1, -17, 0, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, 0]);
    design.addPosition("c15", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("d15", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("e15", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("f15", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("g15", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("h15", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("i15", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("j15", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("k15", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("l15", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("m15", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("n15", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("o15", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("p15", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("q15", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("r15", [18, 1, 0, 17, -20, -39, 37, -19, -37, 20, 39, 19, 0, -1, -18, -21]);
    design.addPosition("s15", [18, 0, 0, 17, -20, -39, 37, -19, 0, 0, 0, 19, 0, -1, 0, -21]);
    design.addPosition("a14", [0, 1, -17, 0, 0, 0, 0, -19, -37, 20, 39, 19, 21, 0, -18, 0]);
    design.addPosition("b14", [18, 1, -17, 0, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, 0]);
    design.addPosition("c14", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("d14", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("e14", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("f14", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("g14", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("h14", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("i14", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("j14", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("k14", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("l14", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("m14", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("n14", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("o14", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("p14", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("q14", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("r14", [18, 1, 0, 17, -20, -39, 37, -19, -37, 20, 39, 19, 0, -1, -18, -21]);
    design.addPosition("s14", [18, 0, 0, 17, -20, -39, 37, -19, 0, 0, 0, 19, 0, -1, 0, -21]);
    design.addPosition("a13", [0, 1, -17, 0, 0, 0, 0, -19, -37, 20, 39, 19, 21, 0, -18, 0]);
    design.addPosition("b13", [18, 1, -17, 0, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, 0]);
    design.addPosition("c13", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("d13", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("e13", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("f13", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("g13", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("h13", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("i13", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("j13", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("k13", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("l13", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("m13", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("n13", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("o13", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("p13", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("q13", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("r13", [18, 1, 0, 17, -20, -39, 37, -19, -37, 20, 39, 19, 0, -1, -18, -21]);
    design.addPosition("s13", [18, 0, 0, 17, -20, -39, 37, -19, 0, 0, 0, 19, 0, -1, 0, -21]);
    design.addPosition("a12", [0, 1, -17, 0, 0, 0, 0, -19, -37, 20, 39, 19, 21, 0, -18, 0]);
    design.addPosition("b12", [18, 1, -17, 0, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, 0]);
    design.addPosition("c12", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("d12", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("e12", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("f12", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("g12", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("h12", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("i12", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("j12", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("k12", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("l12", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("m12", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("n12", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("o12", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("p12", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("q12", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("r12", [18, 1, 0, 17, -20, -39, 37, -19, -37, 20, 39, 19, 0, -1, -18, -21]);
    design.addPosition("s12", [18, 0, 0, 17, -20, -39, 37, -19, 0, 0, 0, 19, 0, -1, 0, -21]);
    design.addPosition("a11", [0, 1, -17, 0, 0, 0, 0, -19, -37, 20, 39, 19, 21, 0, -18, 0]);
    design.addPosition("b11", [18, 1, -17, 0, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, 0]);
    design.addPosition("c11", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("d11", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("e11", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("f11", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("g11", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("h11", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("i11", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("j11", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("k11", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("l11", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("m11", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("n11", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("o11", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("p11", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("q11", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("r11", [18, 1, 0, 17, -20, -39, 37, -19, -37, 20, 39, 19, 0, -1, -18, -21]);
    design.addPosition("s11", [18, 0, 0, 17, -20, -39, 37, -19, 0, 0, 0, 19, 0, -1, 0, -21]);
    design.addPosition("a10", [0, 1, -17, 0, 0, 0, 0, -19, -37, 20, 39, 19, 21, 0, -18, 0]);
    design.addPosition("b10", [18, 1, -17, 0, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, 0]);
    design.addPosition("c10", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("d10", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("e10", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("f10", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("g10", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("h10", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("i10", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("j10", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("k10", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("l10", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("m10", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("n10", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("o10", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("p10", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("q10", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("r10", [18, 1, 0, 17, -20, -39, 37, -19, -37, 20, 39, 19, 0, -1, -18, -21]);
    design.addPosition("s10", [18, 0, 0, 17, -20, -39, 37, -19, 0, 0, 0, 19, 0, -1, 0, -21]);
    design.addPosition("a9", [0, 1, -17, 0, 0, 0, 0, -19, -37, 20, 39, 19, 21, 0, -18, 0]);
    design.addPosition("b9", [18, 1, -17, 0, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, 0]);
    design.addPosition("c9", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("d9", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("e9", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("f9", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("g9", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("h9", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("i9", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("j9", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("k9", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("l9", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("m9", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("n9", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("o9", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("p9", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("q9", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("r9", [18, 1, 0, 17, -20, -39, 37, -19, -37, 20, 39, 19, 0, -1, -18, -21]);
    design.addPosition("s9", [18, 0, 0, 17, -20, -39, 37, -19, 0, 0, 0, 19, 0, -1, 0, -21]);
    design.addPosition("a8", [0, 1, -17, 0, 0, 0, 0, -19, -37, 20, 39, 19, 21, 0, -18, 0]);
    design.addPosition("b8", [18, 1, -17, 0, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, 0]);
    design.addPosition("c8", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("d8", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("e8", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("f8", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("g8", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("h8", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("i8", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("j8", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("k8", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("l8", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("m8", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("n8", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("o8", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("p8", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("q8", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("r8", [18, 1, 0, 17, -20, -39, 37, -19, -37, 20, 39, 19, 0, -1, -18, -21]);
    design.addPosition("s8", [18, 0, 0, 17, -20, -39, 37, -19, 0, 0, 0, 19, 0, -1, 0, -21]);
    design.addPosition("a7", [0, 1, -17, 0, 0, 0, 0, -19, -37, 20, 39, 19, 21, 0, -18, 0]);
    design.addPosition("b7", [18, 1, -17, 0, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, 0]);
    design.addPosition("c7", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("d7", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("e7", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("f7", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("g7", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("h7", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("i7", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("j7", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("k7", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("l7", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("m7", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("n7", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("o7", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("p7", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("q7", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("r7", [18, 1, 0, 17, -20, -39, 37, -19, -37, 20, 39, 19, 0, -1, -18, -21]);
    design.addPosition("s7", [18, 0, 0, 17, -20, -39, 37, -19, 0, 0, 0, 19, 0, -1, 0, -21]);
    design.addPosition("a6", [0, 1, -17, 0, 0, 0, 0, -19, -37, 20, 39, 19, 21, 0, -18, 0]);
    design.addPosition("b6", [18, 1, -17, 0, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, 0]);
    design.addPosition("c6", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("d6", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("e6", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("f6", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("g6", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("h6", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("i6", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("j6", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("k6", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("l6", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("m6", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("n6", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("o6", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("p6", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("q6", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("r6", [18, 1, 0, 17, -20, -39, 37, -19, -37, 20, 39, 19, 0, -1, -18, -21]);
    design.addPosition("s6", [18, 0, 0, 17, -20, -39, 37, -19, 0, 0, 0, 19, 0, -1, 0, -21]);
    design.addPosition("a5", [0, 1, -17, 0, 0, 0, 0, -19, -37, 20, 39, 19, 21, 0, -18, 0]);
    design.addPosition("b5", [18, 1, -17, 0, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, 0]);
    design.addPosition("c5", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("d5", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("e5", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("f5", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("g5", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("h5", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("i5", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("j5", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("k5", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("l5", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("m5", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("n5", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("o5", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("p5", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("q5", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("r5", [18, 1, 0, 17, -20, -39, 37, -19, -37, 20, 39, 19, 0, -1, -18, -21]);
    design.addPosition("s5", [18, 0, 0, 17, -20, -39, 37, -19, 0, 0, 0, 19, 0, -1, 0, -21]);
    design.addPosition("a4", [0, 1, -17, 0, 0, 0, 0, -19, -37, 20, 39, 19, 21, 0, -18, 0]);
    design.addPosition("b4", [18, 1, -17, 0, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, 0]);
    design.addPosition("c4", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("d4", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("e4", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("f4", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("g4", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("h4", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("i4", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("j4", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("k4", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("l4", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("m4", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("n4", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("o4", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("p4", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("q4", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("r4", [18, 1, 0, 17, -20, -39, 37, -19, -37, 20, 39, 19, 0, -1, -18, -21]);
    design.addPosition("s4", [18, 0, 0, 17, -20, -39, 37, -19, 0, 0, 0, 19, 0, -1, 0, -21]);
    design.addPosition("a3", [0, 1, -17, 0, 0, 0, 0, -19, -37, 20, 39, 19, 21, 0, -18, 0]);
    design.addPosition("b3", [18, 1, -17, 0, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, 0]);
    design.addPosition("c3", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("d3", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("e3", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("f3", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("g3", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("h3", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("i3", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("j3", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("k3", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("l3", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("m3", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("n3", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("o3", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("p3", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("q3", [18, 1, -17, 17, -20, -39, 37, -19, -37, 20, 39, 19, 21, -1, -18, -21]);
    design.addPosition("r3", [18, 1, 0, 17, -20, -39, 37, -19, -37, 20, 39, 19, 0, -1, -18, -21]);
    design.addPosition("s3", [18, 0, 0, 17, -20, -39, 37, -19, 0, 0, 0, 19, 0, -1, 0, -21]);
    design.addPosition("a2", [0, 1, -17, 0, 0, 0, 0, -19, -37, 20, 0, 19, 21, 0, -18, 0]);
    design.addPosition("b2", [18, 1, -17, 0, -20, -39, 0, -19, -37, 20, 0, 19, 21, -1, -18, 0]);
    design.addPosition("c2", [18, 1, -17, 17, -20, -39, 0, -19, -37, 20, 0, 19, 21, -1, -18, -21]);
    design.addPosition("d2", [18, 1, -17, 17, -20, -39, 0, -19, -37, 20, 0, 19, 21, -1, -18, -21]);
    design.addPosition("e2", [18, 1, -17, 17, -20, -39, 0, -19, -37, 20, 0, 19, 21, -1, -18, -21]);
    design.addPosition("f2", [18, 1, -17, 17, -20, -39, 0, -19, -37, 20, 0, 19, 21, -1, -18, -21]);
    design.addPosition("g2", [18, 1, -17, 17, -20, -39, 0, -19, -37, 20, 0, 19, 21, -1, -18, -21]);
    design.addPosition("h2", [18, 1, -17, 17, -20, -39, 0, -19, -37, 20, 0, 19, 21, -1, -18, -21]);
    design.addPosition("i2", [18, 1, -17, 17, -20, -39, 0, -19, -37, 20, 0, 19, 21, -1, -18, -21]);
    design.addPosition("j2", [18, 1, -17, 17, -20, -39, 0, -19, -37, 20, 0, 19, 21, -1, -18, -21]);
    design.addPosition("k2", [18, 1, -17, 17, -20, -39, 0, -19, -37, 20, 0, 19, 21, -1, -18, -21]);
    design.addPosition("l2", [18, 1, -17, 17, -20, -39, 0, -19, -37, 20, 0, 19, 21, -1, -18, -21]);
    design.addPosition("m2", [18, 1, -17, 17, -20, -39, 0, -19, -37, 20, 0, 19, 21, -1, -18, -21]);
    design.addPosition("n2", [18, 1, -17, 17, -20, -39, 0, -19, -37, 20, 0, 19, 21, -1, -18, -21]);
    design.addPosition("o2", [18, 1, -17, 17, -20, -39, 0, -19, -37, 20, 0, 19, 21, -1, -18, -21]);
    design.addPosition("p2", [18, 1, -17, 17, -20, -39, 0, -19, -37, 20, 0, 19, 21, -1, -18, -21]);
    design.addPosition("q2", [18, 1, -17, 17, -20, -39, 0, -19, -37, 20, 0, 19, 21, -1, -18, -21]);
    design.addPosition("r2", [18, 1, 0, 17, -20, -39, 0, -19, -37, 20, 0, 19, 0, -1, -18, -21]);
    design.addPosition("s2", [18, 0, 0, 17, -20, -39, 0, -19, 0, 0, 0, 19, 0, -1, 0, -21]);
    design.addPosition("a1", [0, 1, -17, 0, 0, 0, 0, -19, -37, 0, 0, 0, 0, 0, -18, 0]);
    design.addPosition("b1", [0, 1, -17, 0, -20, -39, 0, -19, -37, 0, 0, 0, 0, -1, -18, 0]);
    design.addPosition("c1", [0, 1, -17, 0, -20, -39, 0, -19, -37, 0, 0, 0, 0, -1, -18, -21]);
    design.addPosition("d1", [0, 1, -17, 0, -20, -39, 0, -19, -37, 0, 0, 0, 0, -1, -18, -21]);
    design.addPosition("e1", [0, 1, -17, 0, -20, -39, 0, -19, -37, 0, 0, 0, 0, -1, -18, -21]);
    design.addPosition("f1", [0, 1, -17, 0, -20, -39, 0, -19, -37, 0, 0, 0, 0, -1, -18, -21]);
    design.addPosition("g1", [0, 1, -17, 0, -20, -39, 0, -19, -37, 0, 0, 0, 0, -1, -18, -21]);
    design.addPosition("h1", [0, 1, -17, 0, -20, -39, 0, -19, -37, 0, 0, 0, 0, -1, -18, -21]);
    design.addPosition("i1", [0, 1, -17, 0, -20, -39, 0, -19, -37, 0, 0, 0, 0, -1, -18, -21]);
    design.addPosition("j1", [0, 1, -17, 0, -20, -39, 0, -19, -37, 0, 0, 0, 0, -1, -18, -21]);
    design.addPosition("k1", [0, 1, -17, 0, -20, -39, 0, -19, -37, 0, 0, 0, 0, -1, -18, -21]);
    design.addPosition("l1", [0, 1, -17, 0, -20, -39, 0, -19, -37, 0, 0, 0, 0, -1, -18, -21]);
    design.addPosition("m1", [0, 1, -17, 0, -20, -39, 0, -19, -37, 0, 0, 0, 0, -1, -18, -21]);
    design.addPosition("n1", [0, 1, -17, 0, -20, -39, 0, -19, -37, 0, 0, 0, 0, -1, -18, -21]);
    design.addPosition("o1", [0, 1, -17, 0, -20, -39, 0, -19, -37, 0, 0, 0, 0, -1, -18, -21]);
    design.addPosition("p1", [0, 1, -17, 0, -20, -39, 0, -19, -37, 0, 0, 0, 0, -1, -18, -21]);
    design.addPosition("q1", [0, 1, -17, 0, -20, -39, 0, -19, -37, 0, 0, 0, 0, -1, -18, -21]);
    design.addPosition("r1", [0, 1, 0, 0, -20, -39, 0, -19, -37, 0, 0, 0, 0, -1, -18, -21]);
    design.addPosition("s1", [0, 0, 0, 0, -20, -39, 0, -19, 0, 0, 0, 0, 0, -1, 0, -21]);
    design.addPosition("T1", [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]);
    design.addPosition("T2", [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]);

    design.addCommand(0, ZRF.FUNCTION,	24);	// from
    design.addCommand(0, ZRF.PARAM,	0);	// $1
    design.addCommand(0, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(0, ZRF.FUNCTION,	3);	// friend?
    design.addCommand(0, ZRF.FUNCTION,	0);	// not
    design.addCommand(0, ZRF.FUNCTION,	20);	// verify
    design.addCommand(0, ZRF.FUNCTION,	25);	// to
    design.addCommand(0, ZRF.FUNCTION,	28);	// end

    design.addCommand(1, ZRF.FUNCTION,	24);	// from
    design.addCommand(1, ZRF.PARAM,	0);	// $1
    design.addCommand(1, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(1, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(1, ZRF.FUNCTION,	0);	// not
    design.addCommand(1, ZRF.IF,	7);
    design.addCommand(1, ZRF.FORK,	3);
    design.addCommand(1, ZRF.FUNCTION,	25);	// to
    design.addCommand(1, ZRF.FUNCTION,	28);	// end
    design.addCommand(1, ZRF.PARAM,	1);	// $2
    design.addCommand(1, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(1, ZRF.JUMP,	-8);
    design.addCommand(1, ZRF.FUNCTION,	2);	// enemy?
    design.addCommand(1, ZRF.FUNCTION,	20);	// verify
    design.addCommand(1, ZRF.FUNCTION,	25);	// to
    design.addCommand(1, ZRF.FUNCTION,	28);	// end

    design.addCommand(2, ZRF.FUNCTION,	24);	// from
    design.addCommand(2, ZRF.PARAM,	0);	// $1
    design.addCommand(2, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(2, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(2, ZRF.FUNCTION,	0);	// not
    design.addCommand(2, ZRF.IF,	8);
    design.addCommand(2, ZRF.FORK,	4);
    design.addCommand(2, ZRF.MODE,	1);	// move-twice-v
    design.addCommand(2, ZRF.FUNCTION,	25);	// to
    design.addCommand(2, ZRF.FUNCTION,	28);	// end
    design.addCommand(2, ZRF.PARAM,	1);	// $2
    design.addCommand(2, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(2, ZRF.JUMP,	-9);
    design.addCommand(2, ZRF.FUNCTION,	2);	// enemy?
    design.addCommand(2, ZRF.FUNCTION,	20);	// verify
    design.addCommand(2, ZRF.FUNCTION,	25);	// to
    design.addCommand(2, ZRF.FUNCTION,	28);	// end

    design.addCommand(3, ZRF.FUNCTION,	24);	// from
    design.addCommand(3, ZRF.PARAM,	0);	// $1
    design.addCommand(3, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(3, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(3, ZRF.FUNCTION,	0);	// not
    design.addCommand(3, ZRF.IF,	8);
    design.addCommand(3, ZRF.FORK,	4);
    design.addCommand(3, ZRF.MODE,	2);	// move-twice-h
    design.addCommand(3, ZRF.FUNCTION,	25);	// to
    design.addCommand(3, ZRF.FUNCTION,	28);	// end
    design.addCommand(3, ZRF.PARAM,	1);	// $2
    design.addCommand(3, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(3, ZRF.JUMP,	-9);
    design.addCommand(3, ZRF.FUNCTION,	2);	// enemy?
    design.addCommand(3, ZRF.FUNCTION,	20);	// verify
    design.addCommand(3, ZRF.FUNCTION,	25);	// to
    design.addCommand(3, ZRF.FUNCTION,	28);	// end

    design.addCommand(4, ZRF.FUNCTION,	24);	// from
    design.addCommand(4, ZRF.PARAM,	0);	// $1
    design.addCommand(4, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(4, ZRF.PARAM,	1);	// $2
    design.addCommand(4, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(4, ZRF.FUNCTION,	3);	// friend?
    design.addCommand(4, ZRF.FUNCTION,	0);	// not
    design.addCommand(4, ZRF.FUNCTION,	20);	// verify
    design.addCommand(4, ZRF.FUNCTION,	25);	// to
    design.addCommand(4, ZRF.FUNCTION,	28);	// end

    design.addCommand(5, ZRF.FUNCTION,	24);	// from
    design.addCommand(5, ZRF.PARAM,	0);	// $1
    design.addCommand(5, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(5, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(5, ZRF.FUNCTION,	20);	// verify
    design.addCommand(5, ZRF.PARAM,	1);	// $2
    design.addCommand(5, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(5, ZRF.FUNCTION,	3);	// friend?
    design.addCommand(5, ZRF.FUNCTION,	0);	// not
    design.addCommand(5, ZRF.FUNCTION,	20);	// verify
    design.addCommand(5, ZRF.FUNCTION,	25);	// to
    design.addCommand(5, ZRF.FUNCTION,	28);	// end

    design.addCommand(6, ZRF.FUNCTION,	24);	// from
    design.addCommand(6, ZRF.PARAM,	0);	// $1
    design.addCommand(6, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(6, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(6, ZRF.FUNCTION,	20);	// verify
    design.addCommand(6, ZRF.PARAM,	1);	// $2
    design.addCommand(6, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(6, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(6, ZRF.FUNCTION,	20);	// verify
    design.addCommand(6, ZRF.PARAM,	2);	// $3
    design.addCommand(6, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(6, ZRF.FUNCTION,	3);	// friend?
    design.addCommand(6, ZRF.FUNCTION,	0);	// not
    design.addCommand(6, ZRF.FUNCTION,	20);	// verify
    design.addCommand(6, ZRF.FUNCTION,	25);	// to
    design.addCommand(6, ZRF.FUNCTION,	28);	// end

    design.addCommand(7, ZRF.FUNCTION,	24);	// from
    design.addCommand(7, ZRF.PARAM,	0);	// $1
    design.addCommand(7, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(7, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(7, ZRF.FUNCTION,	20);	// verify
    design.addCommand(7, ZRF.PARAM,	1);	// $2
    design.addCommand(7, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(7, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(7, ZRF.FUNCTION,	20);	// verify
    design.addCommand(7, ZRF.PARAM,	2);	// $3
    design.addCommand(7, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(7, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(7, ZRF.FUNCTION,	20);	// verify
    design.addCommand(7, ZRF.PARAM,	3);	// $4
    design.addCommand(7, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(7, ZRF.FUNCTION,	3);	// friend?
    design.addCommand(7, ZRF.FUNCTION,	0);	// not
    design.addCommand(7, ZRF.FUNCTION,	20);	// verify
    design.addCommand(7, ZRF.FUNCTION,	25);	// to
    design.addCommand(7, ZRF.FUNCTION,	28);	// end

    design.addCommand(8, ZRF.FUNCTION,	24);	// from
    design.addCommand(8, ZRF.PARAM,	0);	// $1
    design.addCommand(8, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(8, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(8, ZRF.FUNCTION,	20);	// verify
    design.addCommand(8, ZRF.PARAM,	1);	// $2
    design.addCommand(8, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(8, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(8, ZRF.FUNCTION,	20);	// verify
    design.addCommand(8, ZRF.PARAM,	2);	// $3
    design.addCommand(8, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(8, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(8, ZRF.FUNCTION,	20);	// verify
    design.addCommand(8, ZRF.PARAM,	3);	// $4
    design.addCommand(8, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(8, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(8, ZRF.FUNCTION,	20);	// verify
    design.addCommand(8, ZRF.PARAM,	4);	// $5
    design.addCommand(8, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(8, ZRF.FUNCTION,	3);	// friend?
    design.addCommand(8, ZRF.FUNCTION,	0);	// not
    design.addCommand(8, ZRF.FUNCTION,	20);	// verify
    design.addCommand(8, ZRF.FUNCTION,	25);	// to
    design.addCommand(8, ZRF.FUNCTION,	28);	// end

    design.addCommand(9, ZRF.FUNCTION,	24);	// from
    design.addCommand(9, ZRF.PARAM,	0);	// $1
    design.addCommand(9, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(9, ZRF.FUNCTION,	3);	// friend?
    design.addCommand(9, ZRF.FUNCTION,	0);	// not
    design.addCommand(9, ZRF.FUNCTION,	20);	// verify
    design.addCommand(9, ZRF.MODE,	1);	// move-twice-v
    design.addCommand(9, ZRF.FUNCTION,	25);	// to
    design.addCommand(9, ZRF.FUNCTION,	28);	// end

    design.addCommand(10, ZRF.FUNCTION,	24);	// from
    design.addCommand(10, ZRF.PARAM,	0);	// $1
    design.addCommand(10, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(10, ZRF.FUNCTION,	3);	// friend?
    design.addCommand(10, ZRF.FUNCTION,	0);	// not
    design.addCommand(10, ZRF.FUNCTION,	20);	// verify
    design.addCommand(10, ZRF.MODE,	2);	// move-twice-h
    design.addCommand(10, ZRF.FUNCTION,	25);	// to
    design.addCommand(10, ZRF.FUNCTION,	28);	// end

    design.addCommand(11, ZRF.FUNCTION,	24);	// from
    design.addCommand(11, ZRF.PARAM,	0);	// $1
    design.addCommand(11, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(11, ZRF.FUNCTION,	3);	// friend?
    design.addCommand(11, ZRF.FUNCTION,	0);	// not
    design.addCommand(11, ZRF.FUNCTION,	20);	// verify
    design.addCommand(11, ZRF.MODE,	3);	// move-twice-l
    design.addCommand(11, ZRF.FUNCTION,	25);	// to
    design.addCommand(11, ZRF.FUNCTION,	28);	// end

    design.addCommand(12, ZRF.FUNCTION,	24);	// from
    design.addCommand(12, ZRF.PARAM,	0);	// $1
    design.addCommand(12, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(12, ZRF.FUNCTION,	3);	// friend?
    design.addCommand(12, ZRF.FUNCTION,	0);	// not
    design.addCommand(12, ZRF.FUNCTION,	20);	// verify
    design.addCommand(12, ZRF.MODE,	4);	// move-twice-r
    design.addCommand(12, ZRF.FUNCTION,	25);	// to
    design.addCommand(12, ZRF.FUNCTION,	28);	// end

    design.addCommand(13, ZRF.FUNCTION,	24);	// from
    design.addCommand(13, ZRF.PARAM,	0);	// $1
    design.addCommand(13, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(13, ZRF.FUNCTION,	3);	// friend?
    design.addCommand(13, ZRF.FUNCTION,	0);	// not
    design.addCommand(13, ZRF.FUNCTION,	20);	// verify
    design.addCommand(13, ZRF.MODE,	5);	// move-trice-v
    design.addCommand(13, ZRF.FUNCTION,	25);	// to
    design.addCommand(13, ZRF.FUNCTION,	28);	// end

    design.addCommand(14, ZRF.FUNCTION,	24);	// from
    design.addCommand(14, ZRF.PARAM,	0);	// $1
    design.addCommand(14, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(14, ZRF.FUNCTION,	3);	// friend?
    design.addCommand(14, ZRF.FUNCTION,	0);	// not
    design.addCommand(14, ZRF.FUNCTION,	20);	// verify
    design.addCommand(14, ZRF.MODE,	6);	// move-trice-h
    design.addCommand(14, ZRF.FUNCTION,	25);	// to
    design.addCommand(14, ZRF.FUNCTION,	28);	// end

    design.addCommand(15, ZRF.FUNCTION,	24);	// from
    design.addCommand(15, ZRF.PARAM,	0);	// $1
    design.addCommand(15, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(15, ZRF.FUNCTION,	3);	// friend?
    design.addCommand(15, ZRF.FUNCTION,	0);	// not
    design.addCommand(15, ZRF.FUNCTION,	20);	// verify
    design.addCommand(15, ZRF.MODE,	7);	// move-trice-l
    design.addCommand(15, ZRF.FUNCTION,	25);	// to
    design.addCommand(15, ZRF.FUNCTION,	28);	// end

    design.addCommand(16, ZRF.FUNCTION,	24);	// from
    design.addCommand(16, ZRF.PARAM,	0);	// $1
    design.addCommand(16, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(16, ZRF.FUNCTION,	3);	// friend?
    design.addCommand(16, ZRF.FUNCTION,	0);	// not
    design.addCommand(16, ZRF.FUNCTION,	20);	// verify
    design.addCommand(16, ZRF.MODE,	8);	// move-trice-r
    design.addCommand(16, ZRF.FUNCTION,	25);	// to
    design.addCommand(16, ZRF.FUNCTION,	28);	// end

    design.addCommand(17, ZRF.FUNCTION,	24);	// from
    design.addCommand(17, ZRF.PARAM,	0);	// $1
    design.addCommand(17, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(17, ZRF.FUNCTION,	3);	// friend?
    design.addCommand(17, ZRF.FUNCTION,	0);	// not
    design.addCommand(17, ZRF.FUNCTION,	20);	// verify
    design.addCommand(17, ZRF.MODE,	9);	// move-twice
    design.addCommand(17, ZRF.FUNCTION,	25);	// to
    design.addCommand(17, ZRF.FUNCTION,	28);	// end

    design.addPriority(0);			// normal

    design.addPiece("Go-Between", 0, 12);
    design.addMove(0, 0, [7], 0);
    design.addMove(0, 0, [11], 0);

    design.addPiece("Free-Goer", 1, 108);
    design.addMove(1, 1, [7, 7], 0);
    design.addMove(1, 1, [11, 11], 0);

    design.addPiece("Pawn", 2, 24);
    design.addMove(2, 0, [7], 0);

    design.addPiece("Tokin", 3, 108);
    design.addMove(3, 0, [11], 0);
    design.addMove(3, 0, [7], 0);
    design.addMove(3, 0, [14], 0);
    design.addMove(3, 0, [4], 0);
    design.addMove(3, 0, [1], 0);
    design.addMove(3, 0, [13], 0);

    design.addPiece("Rook", 4, 296);
    design.addMove(4, 1, [7, 7], 0);
    design.addMove(4, 1, [1, 1], 0);
    design.addMove(4, 1, [11, 11], 0);
    design.addMove(4, 1, [13, 13], 0);

    design.addPiece("Gold-Promoted", 5, 108);
    design.addMove(5, 0, [11], 0);
    design.addMove(5, 0, [7], 0);
    design.addMove(5, 0, [14], 0);
    design.addMove(5, 0, [4], 0);
    design.addMove(5, 0, [1], 0);
    design.addMove(5, 0, [13], 0);

    design.addPiece("Left-Chariot", 6, 208);
    design.addMove(6, 1, [4, 4], 0);
    design.addMove(6, 1, [9, 9], 0);
    design.addMove(6, 1, [7, 7], 0);
    design.addMove(6, 0, [11], 0);

    design.addPiece("Right-Chariot", 7, 208);
    design.addMove(7, 1, [14, 14], 0);
    design.addMove(7, 1, [0, 0], 0);
    design.addMove(7, 1, [7, 7], 0);
    design.addMove(7, 0, [11], 0);

    design.addPiece("Side-Mover", 8, 184);
    design.addMove(8, 1, [1, 1], 0);
    design.addMove(8, 1, [13, 13], 0);
    design.addMove(8, 0, [7], 0);
    design.addMove(8, 0, [11], 0);

    design.addPiece("Side-Flyer", 9, 206);
    design.addMove(9, 1, [1, 1], 0);
    design.addMove(9, 1, [13, 13], 0);
    design.addMove(9, 0, [4], 0);
    design.addMove(9, 0, [14], 0);
    design.addMove(9, 0, [0], 0);
    design.addMove(9, 0, [9], 0);

    design.addPiece("Vertical-Mover", 10, 176);
    design.addMove(10, 1, [11, 11], 0);
    design.addMove(10, 1, [7, 7], 0);
    design.addMove(10, 0, [1], 0);
    design.addMove(10, 0, [13], 0);

    design.addPiece("Bishop", 11, 228);
    design.addMove(11, 1, [14, 14], 0);
    design.addMove(11, 1, [4, 4], 0);
    design.addMove(11, 1, [9, 9], 0);
    design.addMove(11, 1, [0, 0], 0);

    design.addPiece("Dragon-Horse", 12, 310);
    design.addMove(12, 0, [7], 0);
    design.addMove(12, 0, [1], 0);
    design.addMove(12, 0, [11], 0);
    design.addMove(12, 0, [13], 0);
    design.addMove(12, 1, [4, 4], 0);
    design.addMove(12, 1, [14, 14], 0);
    design.addMove(12, 1, [9, 9], 0);
    design.addMove(12, 1, [0, 0], 0);

    design.addPiece("Dragon-King", 13, 376);
    design.addMove(13, 1, [7, 7], 0);
    design.addMove(13, 1, [1, 1], 0);
    design.addMove(13, 1, [11, 11], 0);
    design.addMove(13, 1, [13, 13], 0);
    design.addMove(13, 0, [4], 0);
    design.addMove(13, 0, [14], 0);
    design.addMove(13, 0, [9], 0);
    design.addMove(13, 0, [0], 0);

    design.addPiece("Capricorn", 14, 490);
    design.addMove(14, 2, [14, 14], 0);
    design.addMove(14, 2, [0, 0], 0);
    design.addMove(14, 3, [4, 4], 0);
    design.addMove(14, 3, [9, 9], 0);
    design.addMove(14, 1, [4, 4], 1);
    design.addMove(14, 1, [9, 9], 1);
    design.addMove(14, 1, [14, 14], 2);
    design.addMove(14, 1, [0, 0], 2);

    design.addPiece("Hook-Mover", 15, 660);
    design.addMove(15, 2, [7, 7], 0);
    design.addMove(15, 2, [11, 11], 0);
    design.addMove(15, 3, [1, 1], 0);
    design.addMove(15, 3, [13, 13], 0);
    design.addMove(15, 1, [1, 1], 1);
    design.addMove(15, 1, [13, 13], 1);
    design.addMove(15, 1, [7, 7], 2);
    design.addMove(15, 1, [11, 11], 2);

    design.addPiece("Free-King", 16, 520);
    design.addMove(16, 1, [7, 7], 0);
    design.addMove(16, 1, [1, 1], 0);
    design.addMove(16, 1, [11, 11], 0);
    design.addMove(16, 1, [13, 13], 0);
    design.addMove(16, 1, [4, 4], 0);
    design.addMove(16, 1, [14, 14], 0);
    design.addMove(16, 1, [9, 9], 0);
    design.addMove(16, 1, [0, 0], 0);

    design.addPiece("Donkey", 17, 86);
    design.addMove(17, 4, [7, 7], 0);
    design.addMove(17, 4, [11, 11], 0);
    design.addMove(17, 0, [7], 0);
    design.addMove(17, 0, [11], 0);
    design.addMove(17, 0, [13], 0);
    design.addMove(17, 0, [1], 0);

    design.addPiece("Knight", 18, 36);
    design.addMove(18, 0, [5], 0);
    design.addMove(18, 0, [8], 0);

    design.addPiece("Violent-Ox", 19, 104);
    design.addMove(19, 0, [7], 0);
    design.addMove(19, 0, [11], 0);
    design.addMove(19, 0, [13], 0);
    design.addMove(19, 0, [1], 0);
    design.addMove(19, 5, [7, 7], 0);
    design.addMove(19, 5, [11, 11], 0);
    design.addMove(19, 5, [13, 13], 0);
    design.addMove(19, 5, [1, 1], 0);

    design.addPiece("Flying-Dragon", 20, 100);
    design.addMove(20, 0, [4], 0);
    design.addMove(20, 0, [9], 0);
    design.addMove(20, 0, [0], 0);
    design.addMove(20, 0, [14], 0);
    design.addMove(20, 5, [4, 4], 0);
    design.addMove(20, 5, [9, 9], 0);
    design.addMove(20, 5, [0, 0], 0);
    design.addMove(20, 5, [14, 14], 0);

    design.addPiece("Buddhist-Devil", 21, 114);
    design.addMove(21, 0, [14], 0);
    design.addMove(21, 5, [14, 14], 0);
    design.addMove(21, 6, [14, 14, 14], 0);
    design.addMove(21, 0, [1], 0);
    design.addMove(21, 0, [11], 0);
    design.addMove(21, 0, [13], 0);
    design.addMove(21, 0, [4], 0);
    design.addMove(21, 5, [4, 4], 0);
    design.addMove(21, 6, [4, 4, 4], 0);

    design.addPiece("She-Devil", 22, 236);
    design.addMove(22, 0, [7], 0);
    design.addMove(22, 5, [7, 7], 0);
    design.addMove(22, 6, [7, 7, 7], 0);
    design.addMove(22, 7, [7, 7, 7, 7], 0);
    design.addMove(22, 8, [7, 7, 7, 7, 7], 0);
    design.addMove(22, 0, [14], 0);
    design.addMove(22, 5, [14, 14], 0);
    design.addMove(22, 0, [1], 0);
    design.addMove(22, 5, [1, 1], 0);
    design.addMove(22, 6, [1, 1, 1], 0);
    design.addMove(22, 7, [1, 1, 1, 1], 0);
    design.addMove(22, 8, [1, 1, 1, 1, 1], 0);
    design.addMove(22, 0, [9], 0);
    design.addMove(22, 5, [9, 9], 0);
    design.addMove(22, 0, [11], 0);
    design.addMove(22, 5, [11, 11], 0);
    design.addMove(22, 6, [11, 11, 11], 0);
    design.addMove(22, 7, [11, 11, 11, 11], 0);
    design.addMove(22, 8, [11, 11, 11, 11, 11], 0);
    design.addMove(22, 0, [0], 0);
    design.addMove(22, 5, [0, 0], 0);
    design.addMove(22, 0, [13], 0);
    design.addMove(22, 5, [13, 13], 0);
    design.addMove(22, 6, [13, 13, 13], 0);
    design.addMove(22, 7, [13, 13, 13, 13], 0);
    design.addMove(22, 8, [13, 13, 13, 13, 13], 0);
    design.addMove(22, 0, [4], 0);
    design.addMove(22, 5, [4, 4], 0);

    design.addPiece("Wrestler", 23, 150);
    design.addMove(23, 0, [14], 0);
    design.addMove(23, 5, [14, 14], 0);
    design.addMove(23, 6, [14, 14, 14], 0);
    design.addMove(23, 0, [1], 0);
    design.addMove(23, 0, [9], 0);
    design.addMove(23, 5, [9, 9], 0);
    design.addMove(23, 6, [9, 9, 9], 0);
    design.addMove(23, 0, [0], 0);
    design.addMove(23, 5, [0, 0], 0);
    design.addMove(23, 6, [0, 0, 0], 0);
    design.addMove(23, 0, [13], 0);
    design.addMove(23, 0, [4], 0);
    design.addMove(23, 5, [4, 4], 0);
    design.addMove(23, 6, [4, 4, 4], 0);

    design.addPiece("Guardian-of-the-Gods", 24, 156);
    design.addMove(24, 0, [7], 0);
    design.addMove(24, 5, [7, 7], 0);
    design.addMove(24, 6, [7, 7, 7], 0);
    design.addMove(24, 0, [14], 0);
    design.addMove(24, 0, [1], 0);
    design.addMove(24, 5, [1, 1], 0);
    design.addMove(24, 6, [1, 1, 1], 0);
    design.addMove(24, 0, [11], 0);
    design.addMove(24, 5, [11, 11], 0);
    design.addMove(24, 6, [11, 11, 11], 0);
    design.addMove(24, 0, [4], 0);
    design.addMove(24, 0, [13], 0);
    design.addMove(24, 5, [13, 13], 0);
    design.addMove(24, 6, [13, 13, 13], 0);

    design.addPiece("Lion-Dog", 25, 860);
    design.addMove(25, 9, [7], 0);
    design.addMove(25, 9, [11], 0);
    design.addMove(25, 10, [13], 0);
    design.addMove(25, 10, [1], 0);
    design.addMove(25, 11, [9], 0);
    design.addMove(25, 11, [4], 0);
    design.addMove(25, 12, [14], 0);
    design.addMove(25, 12, [0], 0);
    design.addMove(25, 13, [7], 1);
    design.addMove(25, 13, [11], 1);
    design.addMove(25, 14, [13], 2);
    design.addMove(25, 14, [1], 2);
    design.addMove(25, 15, [9], 3);
    design.addMove(25, 15, [4], 3);
    design.addMove(25, 16, [14], 4);
    design.addMove(25, 16, [0], 4);
    design.addMove(25, 0, [7], 5);
    design.addMove(25, 0, [11], 5);
    design.addMove(25, 0, [13], 6);
    design.addMove(25, 0, [1], 6);
    design.addMove(25, 0, [9], 7);
    design.addMove(25, 0, [4], 7);
    design.addMove(25, 0, [14], 8);
    design.addMove(25, 0, [0], 8);

    design.addPiece("Old-Rat", 26, 60);
    design.addMove(26, 0, [7], 0);
    design.addMove(26, 0, [0], 0);
    design.addMove(26, 0, [9], 0);

    design.addPiece("Bat", 27, 184);
    design.addMove(27, 1, [7, 7], 0);
    design.addMove(27, 1, [0, 0], 0);
    design.addMove(27, 1, [9, 9], 0);

    design.addPiece("Angry-Boar", 28, 74);
    design.addMove(28, 0, [7], 0);
    design.addMove(28, 0, [1], 0);
    design.addMove(28, 0, [13], 0);
    design.addMove(28, 0, [11], 0);

    design.addPiece("Free-Boar", 29, 366);
    design.addMove(29, 1, [1, 1], 0);
    design.addMove(29, 1, [13, 13], 0);
    design.addMove(29, 1, [4, 4], 0);
    design.addMove(29, 1, [14, 14], 0);
    design.addMove(29, 1, [9, 9], 0);
    design.addMove(29, 1, [0, 0], 0);

    design.addPiece("Blind-Bear", 30, 128);
    design.addMove(30, 0, [4], 0);
    design.addMove(30, 0, [14], 0);
    design.addMove(30, 0, [0], 0);
    design.addMove(30, 0, [9], 0);
    design.addMove(30, 1, [11, 11], 0);

    design.addPiece("Free-Bear", 31, 376);
    design.addMove(31, 4, [4, 4], 0);
    design.addMove(31, 4, [14, 14], 0);
    design.addMove(31, 1, [4, 4], 0);
    design.addMove(31, 1, [14, 14], 0);
    design.addMove(31, 1, [13, 13], 0);
    design.addMove(31, 1, [0, 0], 0);
    design.addMove(31, 1, [9, 9], 0);
    design.addMove(31, 1, [1, 1], 0);

    design.addPiece("Evil-Wolf", 32, 96);
    design.addMove(32, 0, [13], 0);
    design.addMove(32, 0, [4], 0);
    design.addMove(32, 0, [7], 0);
    design.addMove(32, 0, [14], 0);
    design.addMove(32, 0, [1], 0);

    design.addPiece("Free-Wolf", 33, 390);
    design.addMove(33, 1, [4, 4], 0);
    design.addMove(33, 1, [14, 14], 0);
    design.addMove(33, 1, [11, 11], 0);
    design.addMove(33, 1, [1, 1], 0);
    design.addMove(33, 1, [13, 13], 0);

    design.addPiece("Kylin", 34, 130);
    design.addMove(34, 4, [7, 7], 0);
    design.addMove(34, 4, [1, 1], 0);
    design.addMove(34, 4, [11, 11], 0);
    design.addMove(34, 4, [13, 13], 0);
    design.addMove(34, 0, [4], 0);
    design.addMove(34, 0, [14], 0);
    design.addMove(34, 0, [9], 0);
    design.addMove(34, 0, [0], 0);

    design.addPiece("Great-Dragon", 35, 316);
    design.addMove(35, 0, [7], 0);
    design.addMove(35, 5, [7, 7], 0);
    design.addMove(35, 0, [11], 0);
    design.addMove(35, 5, [11, 11], 0);
    design.addMove(35, 0, [14], 0);
    design.addMove(35, 5, [14, 14], 0);
    design.addMove(35, 6, [14, 14, 14], 0);
    design.addMove(35, 1, [1, 1], 0);
    design.addMove(35, 0, [9], 0);
    design.addMove(35, 5, [9, 9], 0);
    design.addMove(35, 6, [9, 9, 9], 0);
    design.addMove(35, 0, [0], 0);
    design.addMove(35, 5, [0, 0], 0);
    design.addMove(35, 6, [0, 0, 0], 0);
    design.addMove(35, 1, [13, 13], 0);
    design.addMove(35, 0, [4], 0);
    design.addMove(35, 5, [4, 4], 0);
    design.addMove(35, 6, [4, 4, 4], 0);

    design.addPiece("Phoenix", 36, 128);
    design.addMove(36, 4, [4, 4], 0);
    design.addMove(36, 4, [14, 14], 0);
    design.addMove(36, 4, [9, 9], 0);
    design.addMove(36, 4, [0, 0], 0);
    design.addMove(36, 0, [7], 0);
    design.addMove(36, 0, [1], 0);
    design.addMove(36, 0, [11], 0);
    design.addMove(36, 0, [13], 0);

    design.addPiece("Golden-Bird", 37, 318);
    design.addMove(37, 1, [7, 7], 0);
    design.addMove(37, 1, [11, 11], 0);
    design.addMove(37, 0, [14], 0);
    design.addMove(37, 5, [14, 14], 0);
    design.addMove(37, 6, [14, 14, 14], 0);
    design.addMove(37, 0, [1], 0);
    design.addMove(37, 5, [1, 1], 0);
    design.addMove(37, 0, [9], 0);
    design.addMove(37, 5, [9, 9], 0);
    design.addMove(37, 6, [9, 9, 9], 0);
    design.addMove(37, 0, [0], 0);
    design.addMove(37, 5, [0, 0], 0);
    design.addMove(37, 6, [0, 0, 0], 0);
    design.addMove(37, 0, [13], 0);
    design.addMove(37, 5, [13, 13], 0);
    design.addMove(37, 0, [4], 0);
    design.addMove(37, 5, [4, 4], 0);
    design.addMove(37, 6, [4, 4, 4], 0);

    design.addPiece("Lion", 38, 732);
    design.addMove(38, 17, [7], 0);
    design.addMove(38, 17, [11], 0);
    design.addMove(38, 17, [13], 0);
    design.addMove(38, 17, [1], 0);
    design.addMove(38, 17, [9], 0);
    design.addMove(38, 17, [4], 0);
    design.addMove(38, 17, [14], 0);
    design.addMove(38, 17, [0], 0);
    design.addMove(38, 0, [7], 9);
    design.addMove(38, 0, [1], 9);
    design.addMove(38, 0, [11], 9);
    design.addMove(38, 0, [13], 9);
    design.addMove(38, 0, [14], 9);
    design.addMove(38, 0, [4], 9);
    design.addMove(38, 0, [9], 9);
    design.addMove(38, 0, [0], 9);

    design.addPiece("Furious-Fiend", 39, 850);
    design.addMove(39, 6, [7, 7, 7], 0);
    design.addMove(39, 6, [11, 11, 11], 0);
    design.addMove(39, 6, [13, 13, 13], 0);
    design.addMove(39, 6, [1, 1, 1], 0);
    design.addMove(39, 6, [14, 14, 14], 0);
    design.addMove(39, 6, [4, 4, 4], 0);
    design.addMove(39, 6, [9, 9, 9], 0);
    design.addMove(39, 6, [0, 0, 0], 0);
    design.addMove(39, 17, [7], 0);
    design.addMove(39, 17, [11], 0);
    design.addMove(39, 17, [13], 0);
    design.addMove(39, 17, [1], 0);
    design.addMove(39, 17, [9], 0);
    design.addMove(39, 17, [4], 0);
    design.addMove(39, 17, [14], 0);
    design.addMove(39, 17, [0], 0);
    design.addMove(39, 0, [7], 9);
    design.addMove(39, 0, [1], 9);
    design.addMove(39, 0, [11], 9);
    design.addMove(39, 0, [13], 9);
    design.addMove(39, 0, [14], 9);
    design.addMove(39, 0, [4], 9);
    design.addMove(39, 0, [9], 9);
    design.addMove(39, 0, [0], 9);

    design.addPiece("Reverse-Chariot", 40, 150);
    design.addMove(40, 1, [7, 7], 0);
    design.addMove(40, 1, [11, 11], 0);

    design.addPiece("Cat-Sword", 41, 72);
    design.addMove(41, 0, [4], 0);
    design.addMove(41, 0, [14], 0);
    design.addMove(41, 0, [0], 0);
    design.addMove(41, 0, [9], 0);

    design.addPiece("Free-Cat", 42, 226);
    design.addMove(42, 1, [4, 4], 0);
    design.addMove(42, 1, [14, 14], 0);
    design.addMove(42, 1, [0, 0], 0);
    design.addMove(42, 1, [9, 9], 0);

    design.addPiece("Chinese-Cock", 43, 86);
    design.addMove(43, 0, [4], 0);
    design.addMove(43, 0, [14], 0);
    design.addMove(43, 0, [13], 0);
    design.addMove(43, 0, [11], 0);
    design.addMove(43, 0, [1], 0);

    design.addPiece("Wizard-Stork", 44, 338);
    design.addMove(44, 0, [11], 0);
    design.addMove(44, 1, [7, 7], 0);
    design.addMove(44, 1, [0, 0], 0);
    design.addMove(44, 1, [4, 4], 0);
    design.addMove(44, 1, [9, 9], 0);
    design.addMove(44, 1, [14, 14], 0);

    design.addPiece("Old-Monkey", 45, 84);
    design.addMove(45, 0, [4], 0);
    design.addMove(45, 0, [0], 0);
    design.addMove(45, 0, [11], 0);
    design.addMove(45, 0, [14], 0);
    design.addMove(45, 0, [9], 0);

    design.addPiece("Mountain-Witch", 46, 304);
    design.addMove(46, 0, [7], 0);
    design.addMove(46, 1, [11, 11], 0);
    design.addMove(46, 1, [0, 0], 0);
    design.addMove(46, 1, [4, 4], 0);
    design.addMove(46, 1, [9, 9], 0);
    design.addMove(46, 1, [14, 14], 0);

    design.addPiece("Coiled-Serpent", 47, 62);
    design.addMove(47, 0, [0], 0);
    design.addMove(47, 0, [9], 0);
    design.addMove(47, 0, [7], 0);
    design.addMove(47, 0, [11], 0);

    design.addPiece("Free-Serpent", 48, 238);
    design.addMove(48, 1, [7, 7], 0);
    design.addMove(48, 1, [0, 0], 0);
    design.addMove(48, 1, [9, 9], 0);
    design.addMove(48, 1, [11, 11], 0);

    design.addPiece("Reclining-Dragon", 49, 98);
    design.addMove(49, 0, [7], 0);
    design.addMove(49, 0, [9], 0);
    design.addMove(49, 0, [0], 0);
    design.addMove(49, 0, [13], 0);
    design.addMove(49, 0, [11], 0);
    design.addMove(49, 0, [1], 0);

    design.addPiece("Free-Dragon", 50, 276);
    design.addMove(50, 0, [11], 0);
    design.addMove(50, 1, [7, 7], 0);
    design.addMove(50, 0, [0], 0);
    design.addMove(50, 1, [4, 4], 0);
    design.addMove(50, 0, [9], 0);
    design.addMove(50, 1, [14, 14], 0);

    design.addPiece("Ferocious-Leopard", 51, 106);
    design.addMove(51, 0, [11], 0);
    design.addMove(51, 0, [7], 0);
    design.addMove(51, 0, [14], 0);
    design.addMove(51, 0, [4], 0);
    design.addMove(51, 0, [9], 0);
    design.addMove(51, 0, [0], 0);

    design.addPiece("Free-Leopard", 52, 366);
    design.addMove(52, 1, [11, 11], 0);
    design.addMove(52, 1, [7, 7], 0);
    design.addMove(52, 1, [14, 14], 0);
    design.addMove(52, 1, [4, 4], 0);
    design.addMove(52, 1, [9, 9], 0);
    design.addMove(52, 1, [0, 0], 0);

    design.addPiece("Blind-Tiger", 53, 120);
    design.addMove(53, 0, [1], 0);
    design.addMove(53, 0, [11], 0);
    design.addMove(53, 0, [13], 0);
    design.addMove(53, 0, [14], 0);
    design.addMove(53, 0, [4], 0);
    design.addMove(53, 0, [9], 0);
    design.addMove(53, 0, [0], 0);

    design.addPiece("Free-Tiger", 54, 430);
    design.addMove(54, 1, [11, 11], 0);
    design.addMove(54, 1, [1, 1], 0);
    design.addMove(54, 1, [13, 13], 0);
    design.addMove(54, 1, [9, 9], 0);
    design.addMove(54, 1, [0, 0], 0);
    design.addMove(54, 1, [14, 14], 0);
    design.addMove(54, 1, [4, 4], 0);

    design.addPiece("Drunk-Elephant", 55, 122);
    design.addMove(55, 0, [1], 0);
    design.addMove(55, 0, [7], 0);
    design.addMove(55, 0, [13], 0);
    design.addMove(55, 0, [14], 0);
    design.addMove(55, 0, [4], 0);
    design.addMove(55, 0, [9], 0);
    design.addMove(55, 0, [0], 0);

    design.addPiece("Crown-Prince", 56, 3500);
    design.addMove(56, 0, [7], 0);
    design.addMove(56, 0, [1], 0);
    design.addMove(56, 0, [11], 0);
    design.addMove(56, 0, [13], 0);
    design.addMove(56, 0, [14], 0);
    design.addMove(56, 0, [4], 0);
    design.addMove(56, 0, [9], 0);
    design.addMove(56, 0, [0], 0);

    design.addPiece("Lance", 57, 94);
    design.addMove(57, 1, [7, 7], 0);

    design.addPiece("Earth-General", 58, 38);
    design.addMove(58, 0, [11], 0);
    design.addMove(58, 0, [7], 0);

    design.addPiece("Free-Earth", 59, 142);
    design.addMove(59, 1, [11, 11], 0);
    design.addMove(59, 1, [7, 7], 0);

    design.addPiece("Stone-General", 60, 36);
    design.addMove(60, 0, [4], 0);
    design.addMove(60, 0, [14], 0);

    design.addPiece("Free-Stone", 61, 132);
    design.addMove(61, 1, [4, 4], 0);
    design.addMove(61, 1, [14, 14], 0);

    design.addPiece("Tile-General", 62, 48);
    design.addMove(62, 0, [4], 0);
    design.addMove(62, 0, [14], 0);
    design.addMove(62, 0, [11], 0);

    design.addPiece("Free-Tile", 63, 152);
    design.addMove(63, 1, [4, 4], 0);
    design.addMove(63, 1, [14, 14], 0);
    design.addMove(63, 1, [11, 11], 0);

    design.addPiece("Iron-General", 64, 60);
    design.addMove(64, 0, [4], 0);
    design.addMove(64, 0, [7], 0);
    design.addMove(64, 0, [14], 0);

    design.addPiece("Free-Iron", 65, 166);
    design.addMove(65, 1, [4, 4], 0);
    design.addMove(65, 1, [7, 7], 0);
    design.addMove(65, 1, [14, 14], 0);

    design.addPiece("Copper-General", 66, 72);
    design.addMove(66, 0, [11], 0);
    design.addMove(66, 0, [7], 0);
    design.addMove(66, 0, [14], 0);
    design.addMove(66, 0, [4], 0);

    design.addPiece("Free-Copper", 67, 284);
    design.addMove(67, 1, [11, 11], 0);
    design.addMove(67, 1, [7, 7], 0);
    design.addMove(67, 1, [14, 14], 0);
    design.addMove(67, 1, [4, 4], 0);

    design.addPiece("Silver-General", 68, 84);
    design.addMove(68, 0, [9], 0);
    design.addMove(68, 0, [0], 0);
    design.addMove(68, 0, [14], 0);
    design.addMove(68, 0, [4], 0);
    design.addMove(68, 0, [7], 0);

    design.addPiece("Free-Silver", 69, 314);
    design.addMove(69, 1, [9, 9], 0);
    design.addMove(69, 1, [0, 0], 0);
    design.addMove(69, 1, [14, 14], 0);
    design.addMove(69, 1, [4, 4], 0);
    design.addMove(69, 1, [7, 7], 0);

    design.addPiece("Gold-General", 70, 108);
    design.addMove(70, 0, [11], 0);
    design.addMove(70, 0, [7], 0);
    design.addMove(70, 0, [14], 0);
    design.addMove(70, 0, [4], 0);
    design.addMove(70, 0, [1], 0);
    design.addMove(70, 0, [13], 0);

    design.addPiece("Free-Gold", 71, 400);
    design.addMove(71, 1, [11, 11], 0);
    design.addMove(71, 1, [7, 7], 0);
    design.addMove(71, 1, [14, 14], 0);
    design.addMove(71, 1, [4, 4], 0);
    design.addMove(71, 1, [1, 1], 0);
    design.addMove(71, 1, [13, 13], 0);

    design.addPiece("Deva", 72, 70);
    design.addMove(72, 0, [4], 0);
    design.addMove(72, 0, [14], 0);
    design.addMove(72, 0, [13], 0);
    design.addMove(72, 0, [9], 0);

    design.addPiece("Teaching-King", 73, 1090);
    design.addMove(73, 1, [7, 7], 0);
    design.addMove(73, 1, [1, 1], 0);
    design.addMove(73, 1, [11, 11], 0);
    design.addMove(73, 1, [13, 13], 0);
    design.addMove(73, 1, [4, 4], 0);
    design.addMove(73, 1, [14, 14], 0);
    design.addMove(73, 1, [9, 9], 0);
    design.addMove(73, 1, [0, 0], 0);
    design.addMove(73, 9, [7], 0);
    design.addMove(73, 9, [11], 0);
    design.addMove(73, 10, [13], 0);
    design.addMove(73, 10, [1], 0);
    design.addMove(73, 11, [9], 0);
    design.addMove(73, 11, [4], 0);
    design.addMove(73, 12, [14], 0);
    design.addMove(73, 12, [0], 0);
    design.addMove(73, 13, [7], 1);
    design.addMove(73, 13, [11], 1);
    design.addMove(73, 14, [13], 2);
    design.addMove(73, 14, [1], 2);
    design.addMove(73, 15, [9], 3);
    design.addMove(73, 15, [4], 3);
    design.addMove(73, 16, [14], 4);
    design.addMove(73, 16, [0], 4);
    design.addMove(73, 0, [7], 5);
    design.addMove(73, 0, [11], 5);
    design.addMove(73, 0, [13], 6);
    design.addMove(73, 0, [1], 6);
    design.addMove(73, 0, [9], 7);
    design.addMove(73, 0, [4], 7);
    design.addMove(73, 0, [14], 8);
    design.addMove(73, 0, [0], 8);

    design.addPiece("Dark-Spirit", 74, 70);
    design.addMove(74, 0, [4], 0);
    design.addMove(74, 0, [14], 0);
    design.addMove(74, 0, [0], 0);
    design.addMove(74, 0, [1], 0);

    design.addPiece("Buddhist-Spirit", 75, 984);
    design.addMove(75, 1, [7, 7], 0);
    design.addMove(75, 1, [11, 11], 0);
    design.addMove(75, 1, [13, 13], 0);
    design.addMove(75, 1, [1, 1], 0);
    design.addMove(75, 1, [14, 14], 0);
    design.addMove(75, 1, [4, 4], 0);
    design.addMove(75, 1, [9, 9], 0);
    design.addMove(75, 1, [0, 0], 0);
    design.addMove(75, 17, [7], 0);
    design.addMove(75, 17, [11], 0);
    design.addMove(75, 17, [13], 0);
    design.addMove(75, 17, [1], 0);
    design.addMove(75, 17, [9], 0);
    design.addMove(75, 17, [4], 0);
    design.addMove(75, 17, [14], 0);
    design.addMove(75, 17, [0], 0);
    design.addMove(75, 0, [7], 9);
    design.addMove(75, 0, [1], 9);
    design.addMove(75, 0, [11], 9);
    design.addMove(75, 0, [13], 9);
    design.addMove(75, 0, [14], 9);
    design.addMove(75, 0, [4], 9);
    design.addMove(75, 0, [9], 9);
    design.addMove(75, 0, [0], 9);

    design.addPiece("King", 76, 3500);
    design.addMove(76, 0, [7], 0);
    design.addMove(76, 0, [1], 0);
    design.addMove(76, 0, [11], 0);
    design.addMove(76, 0, [13], 0);
    design.addMove(76, 0, [14], 0);
    design.addMove(76, 0, [4], 0);
    design.addMove(76, 0, [9], 0);
    design.addMove(76, 0, [0], 0);

    design.addPiece("Emperor", 77, 3520);

    design.setup("White", "Free-King", 9);
    design.setup("White", "Deva", 10);
    design.setup("White", "Dark-Spirit", 8);
    design.setup("White", "Bishop", 26);
    design.setup("White", "Bishop", 30);
    design.setup("White", "Capricorn", 28);
    design.setup("White", "Wrestler", 85);
    design.setup("White", "Drunk-Elephant", 104);
    design.setup("White", "Blind-Tiger", 103);
    design.setup("White", "Blind-Tiger", 105);
    design.setup("White", "King", 123);
    design.setup("White", "Kylin", 124);
    design.setup("White", "Phoenix", 122);
    design.setup("White", "Gold-General", 121);
    design.setup("White", "Gold-General", 125);
    design.setup("White", "Hook-Mover", 142);
    design.setup("White", "Evil-Wolf", 141);
    design.setup("White", "Evil-Wolf", 143);
    design.setup("White", "Knight", 140);
    design.setup("White", "Knight", 144);
    design.setup("White", "Silver-General", 139);
    design.setup("White", "Silver-General", 145);
    design.setup("White", "Coiled-Serpent", 161);
    design.setup("White", "Iron-General", 160);
    design.setup("White", "Iron-General", 162);
    design.setup("White", "Angry-Boar", 159);
    design.setup("White", "Angry-Boar", 163);
    design.setup("White", "Left-Chariot", 164);
    design.setup("White", "Right-Chariot", 158);
    design.setup("White", "Side-Mover", 157);
    design.setup("White", "Side-Mover", 165);
    design.setup("Black", "Free-King", 351);
    design.setup("Black", "Deva", 350);
    design.setup("Black", "Dark-Spirit", 352);
    design.setup("Black", "Bishop", 330);
    design.setup("Black", "Bishop", 334);
    design.setup("Black", "Capricorn", 332);
    design.setup("Black", "Wrestler", 275);
    design.setup("Black", "Drunk-Elephant", 256);
    design.setup("Black", "Blind-Tiger", 255);
    design.setup("Black", "Blind-Tiger", 257);
    design.setup("Black", "King", 237);
    design.setup("Black", "Kylin", 236);
    design.setup("Black", "Phoenix", 238);
    design.setup("Black", "Gold-General", 235);
    design.setup("Black", "Gold-General", 239);
    design.setup("Black", "Hook-Mover", 218);
    design.setup("Black", "Evil-Wolf", 217);
    design.setup("Black", "Evil-Wolf", 219);
    design.setup("Black", "Knight", 216);
    design.setup("Black", "Knight", 220);
    design.setup("Black", "Silver-General", 215);
    design.setup("Black", "Silver-General", 221);
    design.setup("Black", "Coiled-Serpent", 199);
    design.setup("Black", "Iron-General", 198);
    design.setup("Black", "Iron-General", 200);
    design.setup("Black", "Angry-Boar", 197);
    design.setup("Black", "Angry-Boar", 201);
    design.setup("Black", "Left-Chariot", 196);
    design.setup("Black", "Right-Chariot", 202);
    design.setup("Black", "Side-Mover", 195);
    design.setup("Black", "Side-Mover", 203);
}

Dagaz.View.configure = function(view) {
    view.defBoard("Board");
    view.defPiece("WhiteGo-Between", "White Go-Between");
    view.defPiece("BlackGo-Between", "Black Go-Between");
    view.defPiece("WhiteFree-Goer", "White Free-Goer");
    view.defPiece("BlackFree-Goer", "Black Free-Goer");
    view.defPiece("WhitePawn", "White Pawn");
    view.defPiece("BlackPawn", "Black Pawn");
    view.defPiece("WhiteTokin", "White Tokin");
    view.defPiece("BlackTokin", "Black Tokin");
    view.defPiece("WhiteRook", "White Rook");
    view.defPiece("BlackRook", "Black Rook");
    view.defPiece("WhiteGold-Promoted", "White Gold-Promoted");
    view.defPiece("BlackGold-Promoted", "Black Gold-Promoted");
    view.defPiece("WhiteLeft-Chariot", "White Left-Chariot");
    view.defPiece("BlackLeft-Chariot", "Black Left-Chariot");
    view.defPiece("WhiteRight-Chariot", "White Right-Chariot");
    view.defPiece("BlackRight-Chariot", "Black Right-Chariot");
    view.defPiece("WhiteSide-Mover", "White Side-Mover");
    view.defPiece("BlackSide-Mover", "Black Side-Mover");
    view.defPiece("WhiteSide-Flyer", "White Side-Flyer");
    view.defPiece("BlackSide-Flyer", "Black Side-Flyer");
    view.defPiece("WhiteVertical-Mover", "White Vertical-Mover");
    view.defPiece("BlackVertical-Mover", "Black Vertical-Mover");
    view.defPiece("WhiteBishop", "White Bishop");
    view.defPiece("BlackBishop", "Black Bishop");
    view.defPiece("WhiteDragon-Horse", "White Dragon-Horse");
    view.defPiece("BlackDragon-Horse", "Black Dragon-Horse");
    view.defPiece("WhiteDragon-King", "White Dragon-King");
    view.defPiece("BlackDragon-King", "Black Dragon-King");
    view.defPiece("WhiteCapricorn", "White Capricorn");
    view.defPiece("BlackCapricorn", "Black Capricorn");
    view.defPiece("WhiteHook-Mover", "White Hook-Mover");
    view.defPiece("BlackHook-Mover", "Black Hook-Mover");
    view.defPiece("WhiteFree-King", "White Free-King");
    view.defPiece("BlackFree-King", "Black Free-King");
    view.defPiece("WhiteDonkey", "White Donkey");
    view.defPiece("BlackDonkey", "Black Donkey");
    view.defPiece("WhiteKnight", "White Knight");
    view.defPiece("BlackKnight", "Black Knight");
    view.defPiece("WhiteViolent-Ox", "White Violent-Ox");
    view.defPiece("BlackViolent-Ox", "Black Violent-Ox");
    view.defPiece("WhiteFlying-Dragon", "White Flying-Dragon");
    view.defPiece("BlackFlying-Dragon", "Black Flying-Dragon");
    view.defPiece("WhiteBuddhist-Devil", "White Buddhist-Devil");
    view.defPiece("BlackBuddhist-Devil", "Black Buddhist-Devil");
    view.defPiece("WhiteShe-Devil", "White She-Devil");
    view.defPiece("BlackShe-Devil", "Black She-Devil");
    view.defPiece("WhiteWrestler", "White Wrestler");
    view.defPiece("BlackWrestler", "Black Wrestler");
    view.defPiece("WhiteGuardian-of-the-Gods", "White Guardian-of-the-Gods");
    view.defPiece("BlackGuardian-of-the-Gods", "Black Guardian-of-the-Gods");
    view.defPiece("WhiteLion-Dog", "White Lion-Dog");
    view.defPiece("BlackLion-Dog", "Black Lion-Dog");
    view.defPiece("WhiteOld-Rat", "White Old-Rat");
    view.defPiece("BlackOld-Rat", "Black Old-Rat");
    view.defPiece("WhiteBat", "White Bat");
    view.defPiece("BlackBat", "Black Bat");
    view.defPiece("WhiteAngry-Boar", "White Angry-Boar");
    view.defPiece("BlackAngry-Boar", "Black Angry-Boar");
    view.defPiece("WhiteFree-Boar", "White Free-Boar");
    view.defPiece("BlackFree-Boar", "Black Free-Boar");
    view.defPiece("WhiteBlind-Bear", "White Blind-Bear");
    view.defPiece("BlackBlind-Bear", "Black Blind-Bear");
    view.defPiece("WhiteFree-Bear", "White Free-Bear");
    view.defPiece("BlackFree-Bear", "Black Free-Bear");
    view.defPiece("WhiteEvil-Wolf", "White Evil-Wolf");
    view.defPiece("BlackEvil-Wolf", "Black Evil-Wolf");
    view.defPiece("WhiteFree-Wolf", "White Free-Wolf");
    view.defPiece("BlackFree-Wolf", "Black Free-Wolf");
    view.defPiece("WhiteKylin", "White Kylin");
    view.defPiece("BlackKylin", "Black Kylin");
    view.defPiece("WhiteGreat-Dragon", "White Great-Dragon");
    view.defPiece("BlackGreat-Dragon", "Black Great-Dragon");
    view.defPiece("WhitePhoenix", "White Phoenix");
    view.defPiece("BlackPhoenix", "Black Phoenix");
    view.defPiece("WhiteGolden-Bird", "White Golden-Bird");
    view.defPiece("BlackGolden-Bird", "Black Golden-Bird");
    view.defPiece("WhiteLion", "White Lion");
    view.defPiece("BlackLion", "Black Lion");
    view.defPiece("WhiteFurious-Fiend", "White Furious-Fiend");
    view.defPiece("BlackFurious-Fiend", "Black Furious-Fiend");
    view.defPiece("WhiteReverse-Chariot", "White Reverse-Chariot");
    view.defPiece("BlackReverse-Chariot", "Black Reverse-Chariot");
    view.defPiece("WhiteCat-Sword", "White Cat-Sword");
    view.defPiece("BlackCat-Sword", "Black Cat-Sword");
    view.defPiece("WhiteFree-Cat", "White Free-Cat");
    view.defPiece("BlackFree-Cat", "Black Free-Cat");
    view.defPiece("WhiteChinese-Cock", "White Chinese-Cock");
    view.defPiece("BlackChinese-Cock", "Black Chinese-Cock");
    view.defPiece("WhiteWizard-Stork", "White Wizard-Stork");
    view.defPiece("BlackWizard-Stork", "Black Wizard-Stork");
    view.defPiece("WhiteOld-Monkey", "White Old-Monkey");
    view.defPiece("BlackOld-Monkey", "Black Old-Monkey");
    view.defPiece("WhiteMountain-Witch", "White Mountain-Witch");
    view.defPiece("BlackMountain-Witch", "Black Mountain-Witch");
    view.defPiece("WhiteCoiled-Serpent", "White Coiled-Serpent");
    view.defPiece("BlackCoiled-Serpent", "Black Coiled-Serpent");
    view.defPiece("WhiteFree-Serpent", "White Free-Serpent");
    view.defPiece("BlackFree-Serpent", "Black Free-Serpent");
    view.defPiece("WhiteReclining-Dragon", "White Reclining-Dragon");
    view.defPiece("BlackReclining-Dragon", "Black Reclining-Dragon");
    view.defPiece("WhiteFree-Dragon", "White Free-Dragon");
    view.defPiece("BlackFree-Dragon", "Black Free-Dragon");
    view.defPiece("WhiteFerocious-Leopard", "White Ferocious-Leopard");
    view.defPiece("BlackFerocious-Leopard", "Black Ferocious-Leopard");
    view.defPiece("WhiteFree-Leopard", "White Free-Leopard");
    view.defPiece("BlackFree-Leopard", "Black Free-Leopard");
    view.defPiece("WhiteBlind-Tiger", "White Blind-Tiger");
    view.defPiece("BlackBlind-Tiger", "Black Blind-Tiger");
    view.defPiece("WhiteFree-Tiger", "White Free-Tiger");
    view.defPiece("BlackFree-Tiger", "Black Free-Tiger");
    view.defPiece("WhiteDrunk-Elephant", "White Drunk-Elephant");
    view.defPiece("BlackDrunk-Elephant", "Black Drunk-Elephant");
    view.defPiece("WhiteCrown-Prince", "White Crown-Prince");
    view.defPiece("BlackCrown-Prince", "Black Crown-Prince");
    view.defPiece("WhiteLance", "White Lance");
    view.defPiece("BlackLance", "Black Lance");
    view.defPiece("WhiteEarth-General", "White Earth-General");
    view.defPiece("BlackEarth-General", "Black Earth-General");
    view.defPiece("WhiteFree-Earth", "White Free-Earth");
    view.defPiece("BlackFree-Earth", "Black Free-Earth");
    view.defPiece("WhiteStone-General", "White Stone-General");
    view.defPiece("BlackStone-General", "Black Stone-General");
    view.defPiece("WhiteFree-Stone", "White Free-Stone");
    view.defPiece("BlackFree-Stone", "Black Free-Stone");
    view.defPiece("WhiteTile-General", "White Tile-General");
    view.defPiece("BlackTile-General", "Black Tile-General");
    view.defPiece("WhiteFree-Tile", "White Free-Tile");
    view.defPiece("BlackFree-Tile", "Black Free-Tile");
    view.defPiece("WhiteIron-General", "White Iron-General");
    view.defPiece("BlackIron-General", "Black Iron-General");
    view.defPiece("WhiteFree-Iron", "White Free-Iron");
    view.defPiece("BlackFree-Iron", "Black Free-Iron");
    view.defPiece("WhiteCopper-General", "White Copper-General");
    view.defPiece("BlackCopper-General", "Black Copper-General");
    view.defPiece("WhiteFree-Copper", "White Free-Copper");
    view.defPiece("BlackFree-Copper", "Black Free-Copper");
    view.defPiece("WhiteSilver-General", "White Silver-General");
    view.defPiece("BlackSilver-General", "Black Silver-General");
    view.defPiece("WhiteFree-Silver", "White Free-Silver");
    view.defPiece("BlackFree-Silver", "Black Free-Silver");
    view.defPiece("WhiteGold-General", "White Gold-General");
    view.defPiece("BlackGold-General", "Black Gold-General");
    view.defPiece("WhiteFree-Gold", "White Free-Gold");
    view.defPiece("BlackFree-Gold", "Black Free-Gold");
    view.defPiece("WhiteDeva", "White Deva");
    view.defPiece("BlackDeva", "Black Deva");
    view.defPiece("WhiteTeaching-King", "White Teaching-King");
    view.defPiece("BlackTeaching-King", "Black Teaching-King");
    view.defPiece("WhiteDark-Spirit", "White Dark-Spirit");
    view.defPiece("BlackDark-Spirit", "Black Dark-Spirit");
    view.defPiece("WhiteBuddhist-Spirit", "White Buddhist-Spirit");
    view.defPiece("BlackBuddhist-Spirit", "Black Buddhist-Spirit");
    view.defPiece("WhiteKing", "White King");
    view.defPiece("BlackKing", "Black King");
    view.defPiece("WhiteEmperor", "White Emperor");
    view.defPiece("BlackEmperor", "Black Emperor");
 
    view.defPosition("a19", 25, 25, 38, 38);
    view.defPosition("b19", 68, 25, 38, 38);
    view.defPosition("c19", 111, 25, 38, 38);
    view.defPosition("d19", 154, 25, 38, 38);
    view.defPosition("e19", 197, 25, 38, 38);
    view.defPosition("f19", 240, 25, 38, 38);
    view.defPosition("g19", 283, 25, 38, 38);
    view.defPosition("h19", 326, 25, 38, 38);
    view.defPosition("i19", 369, 25, 38, 38);
    view.defPosition("j19", 412, 25, 38, 38);
    view.defPosition("k19", 455, 25, 38, 38);
    view.defPosition("l19", 498, 25, 38, 38);
    view.defPosition("m19", 541, 25, 38, 38);
    view.defPosition("n19", 584, 25, 38, 38);
    view.defPosition("o19", 627, 25, 38, 38);
    view.defPosition("p19", 670, 25, 38, 38);
    view.defPosition("q19", 713, 25, 38, 38);
    view.defPosition("r19", 756, 25, 38, 38);
    view.defPosition("s19", 799, 25, 38, 38);
    view.defPosition("a18", 25, 68, 38, 38);
    view.defPosition("b18", 68, 68, 38, 38);
    view.defPosition("c18", 111, 68, 38, 38);
    view.defPosition("d18", 154, 68, 38, 38);
    view.defPosition("e18", 197, 68, 38, 38);
    view.defPosition("f18", 240, 68, 38, 38);
    view.defPosition("g18", 283, 68, 38, 38);
    view.defPosition("h18", 326, 68, 38, 38);
    view.defPosition("i18", 369, 68, 38, 38);
    view.defPosition("j18", 412, 68, 38, 38);
    view.defPosition("k18", 455, 68, 38, 38);
    view.defPosition("l18", 498, 68, 38, 38);
    view.defPosition("m18", 541, 68, 38, 38);
    view.defPosition("n18", 584, 68, 38, 38);
    view.defPosition("o18", 627, 68, 38, 38);
    view.defPosition("p18", 670, 68, 38, 38);
    view.defPosition("q18", 713, 68, 38, 38);
    view.defPosition("r18", 756, 68, 38, 38);
    view.defPosition("s18", 799, 68, 38, 38);
    view.defPosition("a17", 25, 111, 38, 38);
    view.defPosition("b17", 68, 111, 38, 38);
    view.defPosition("c17", 111, 111, 38, 38);
    view.defPosition("d17", 154, 111, 38, 38);
    view.defPosition("e17", 197, 111, 38, 38);
    view.defPosition("f17", 240, 111, 38, 38);
    view.defPosition("g17", 283, 111, 38, 38);
    view.defPosition("h17", 326, 111, 38, 38);
    view.defPosition("i17", 369, 111, 38, 38);
    view.defPosition("j17", 412, 111, 38, 38);
    view.defPosition("k17", 455, 111, 38, 38);
    view.defPosition("l17", 498, 111, 38, 38);
    view.defPosition("m17", 541, 111, 38, 38);
    view.defPosition("n17", 584, 111, 38, 38);
    view.defPosition("o17", 627, 111, 38, 38);
    view.defPosition("p17", 670, 111, 38, 38);
    view.defPosition("q17", 713, 111, 38, 38);
    view.defPosition("r17", 756, 111, 38, 38);
    view.defPosition("s17", 799, 111, 38, 38);
    view.defPosition("a16", 25, 154, 38, 38);
    view.defPosition("b16", 68, 154, 38, 38);
    view.defPosition("c16", 111, 154, 38, 38);
    view.defPosition("d16", 154, 154, 38, 38);
    view.defPosition("e16", 197, 154, 38, 38);
    view.defPosition("f16", 240, 154, 38, 38);
    view.defPosition("g16", 283, 154, 38, 38);
    view.defPosition("h16", 326, 154, 38, 38);
    view.defPosition("i16", 369, 154, 38, 38);
    view.defPosition("j16", 412, 154, 38, 38);
    view.defPosition("k16", 455, 154, 38, 38);
    view.defPosition("l16", 498, 154, 38, 38);
    view.defPosition("m16", 541, 154, 38, 38);
    view.defPosition("n16", 584, 154, 38, 38);
    view.defPosition("o16", 627, 154, 38, 38);
    view.defPosition("p16", 670, 154, 38, 38);
    view.defPosition("q16", 713, 154, 38, 38);
    view.defPosition("r16", 756, 154, 38, 38);
    view.defPosition("s16", 799, 154, 38, 38);
    view.defPosition("a15", 25, 197, 38, 38);
    view.defPosition("b15", 68, 197, 38, 38);
    view.defPosition("c15", 111, 197, 38, 38);
    view.defPosition("d15", 154, 197, 38, 38);
    view.defPosition("e15", 197, 197, 38, 38);
    view.defPosition("f15", 240, 197, 38, 38);
    view.defPosition("g15", 283, 197, 38, 38);
    view.defPosition("h15", 326, 197, 38, 38);
    view.defPosition("i15", 369, 197, 38, 38);
    view.defPosition("j15", 412, 197, 38, 38);
    view.defPosition("k15", 455, 197, 38, 38);
    view.defPosition("l15", 498, 197, 38, 38);
    view.defPosition("m15", 541, 197, 38, 38);
    view.defPosition("n15", 584, 197, 38, 38);
    view.defPosition("o15", 627, 197, 38, 38);
    view.defPosition("p15", 670, 197, 38, 38);
    view.defPosition("q15", 713, 197, 38, 38);
    view.defPosition("r15", 756, 197, 38, 38);
    view.defPosition("s15", 799, 197, 38, 38);
    view.defPosition("a14", 25, 240, 38, 38);
    view.defPosition("b14", 68, 240, 38, 38);
    view.defPosition("c14", 111, 240, 38, 38);
    view.defPosition("d14", 154, 240, 38, 38);
    view.defPosition("e14", 197, 240, 38, 38);
    view.defPosition("f14", 240, 240, 38, 38);
    view.defPosition("g14", 283, 240, 38, 38);
    view.defPosition("h14", 326, 240, 38, 38);
    view.defPosition("i14", 369, 240, 38, 38);
    view.defPosition("j14", 412, 240, 38, 38);
    view.defPosition("k14", 455, 240, 38, 38);
    view.defPosition("l14", 498, 240, 38, 38);
    view.defPosition("m14", 541, 240, 38, 38);
    view.defPosition("n14", 584, 240, 38, 38);
    view.defPosition("o14", 627, 240, 38, 38);
    view.defPosition("p14", 670, 240, 38, 38);
    view.defPosition("q14", 713, 240, 38, 38);
    view.defPosition("r14", 756, 240, 38, 38);
    view.defPosition("s14", 799, 240, 38, 38);
    view.defPosition("a13", 25, 283, 38, 38);
    view.defPosition("b13", 68, 283, 38, 38);
    view.defPosition("c13", 111, 283, 38, 38);
    view.defPosition("d13", 154, 283, 38, 38);
    view.defPosition("e13", 197, 283, 38, 38);
    view.defPosition("f13", 240, 283, 38, 38);
    view.defPosition("g13", 283, 283, 38, 38);
    view.defPosition("h13", 326, 283, 38, 38);
    view.defPosition("i13", 369, 283, 38, 38);
    view.defPosition("j13", 412, 283, 38, 38);
    view.defPosition("k13", 455, 283, 38, 38);
    view.defPosition("l13", 498, 283, 38, 38);
    view.defPosition("m13", 541, 283, 38, 38);
    view.defPosition("n13", 584, 283, 38, 38);
    view.defPosition("o13", 627, 283, 38, 38);
    view.defPosition("p13", 670, 283, 38, 38);
    view.defPosition("q13", 713, 283, 38, 38);
    view.defPosition("r13", 756, 283, 38, 38);
    view.defPosition("s13", 799, 283, 38, 38);
    view.defPosition("a12", 25, 326, 38, 38);
    view.defPosition("b12", 68, 326, 38, 38);
    view.defPosition("c12", 111, 326, 38, 38);
    view.defPosition("d12", 154, 326, 38, 38);
    view.defPosition("e12", 197, 326, 38, 38);
    view.defPosition("f12", 240, 326, 38, 38);
    view.defPosition("g12", 283, 326, 38, 38);
    view.defPosition("h12", 326, 326, 38, 38);
    view.defPosition("i12", 369, 326, 38, 38);
    view.defPosition("j12", 412, 326, 38, 38);
    view.defPosition("k12", 455, 326, 38, 38);
    view.defPosition("l12", 498, 326, 38, 38);
    view.defPosition("m12", 541, 326, 38, 38);
    view.defPosition("n12", 584, 326, 38, 38);
    view.defPosition("o12", 627, 326, 38, 38);
    view.defPosition("p12", 670, 326, 38, 38);
    view.defPosition("q12", 713, 326, 38, 38);
    view.defPosition("r12", 756, 326, 38, 38);
    view.defPosition("s12", 799, 326, 38, 38);
    view.defPosition("a11", 25, 369, 38, 38);
    view.defPosition("b11", 68, 369, 38, 38);
    view.defPosition("c11", 111, 369, 38, 38);
    view.defPosition("d11", 154, 369, 38, 38);
    view.defPosition("e11", 197, 369, 38, 38);
    view.defPosition("f11", 240, 369, 38, 38);
    view.defPosition("g11", 283, 369, 38, 38);
    view.defPosition("h11", 326, 369, 38, 38);
    view.defPosition("i11", 369, 369, 38, 38);
    view.defPosition("j11", 412, 369, 38, 38);
    view.defPosition("k11", 455, 369, 38, 38);
    view.defPosition("l11", 498, 369, 38, 38);
    view.defPosition("m11", 541, 369, 38, 38);
    view.defPosition("n11", 584, 369, 38, 38);
    view.defPosition("o11", 627, 369, 38, 38);
    view.defPosition("p11", 670, 369, 38, 38);
    view.defPosition("q11", 713, 369, 38, 38);
    view.defPosition("r11", 756, 369, 38, 38);
    view.defPosition("s11", 799, 369, 38, 38);
    view.defPosition("a10", 25, 412, 38, 38);
    view.defPosition("b10", 68, 412, 38, 38);
    view.defPosition("c10", 111, 412, 38, 38);
    view.defPosition("d10", 154, 412, 38, 38);
    view.defPosition("e10", 197, 412, 38, 38);
    view.defPosition("f10", 240, 412, 38, 38);
    view.defPosition("g10", 283, 412, 38, 38);
    view.defPosition("h10", 326, 412, 38, 38);
    view.defPosition("i10", 369, 412, 38, 38);
    view.defPosition("j10", 412, 412, 38, 38);
    view.defPosition("k10", 455, 412, 38, 38);
    view.defPosition("l10", 498, 412, 38, 38);
    view.defPosition("m10", 541, 412, 38, 38);
    view.defPosition("n10", 584, 412, 38, 38);
    view.defPosition("o10", 627, 412, 38, 38);
    view.defPosition("p10", 670, 412, 38, 38);
    view.defPosition("q10", 713, 412, 38, 38);
    view.defPosition("r10", 756, 412, 38, 38);
    view.defPosition("s10", 799, 412, 38, 38);
    view.defPosition("a9", 25, 455, 38, 38);
    view.defPosition("b9", 68, 455, 38, 38);
    view.defPosition("c9", 111, 455, 38, 38);
    view.defPosition("d9", 154, 455, 38, 38);
    view.defPosition("e9", 197, 455, 38, 38);
    view.defPosition("f9", 240, 455, 38, 38);
    view.defPosition("g9", 283, 455, 38, 38);
    view.defPosition("h9", 326, 455, 38, 38);
    view.defPosition("i9", 369, 455, 38, 38);
    view.defPosition("j9", 412, 455, 38, 38);
    view.defPosition("k9", 455, 455, 38, 38);
    view.defPosition("l9", 498, 455, 38, 38);
    view.defPosition("m9", 541, 455, 38, 38);
    view.defPosition("n9", 584, 455, 38, 38);
    view.defPosition("o9", 627, 455, 38, 38);
    view.defPosition("p9", 670, 455, 38, 38);
    view.defPosition("q9", 713, 455, 38, 38);
    view.defPosition("r9", 756, 455, 38, 38);
    view.defPosition("s9", 799, 455, 38, 38);
    view.defPosition("a8", 25, 498, 38, 38);
    view.defPosition("b8", 68, 498, 38, 38);
    view.defPosition("c8", 111, 498, 38, 38);
    view.defPosition("d8", 154, 498, 38, 38);
    view.defPosition("e8", 197, 498, 38, 38);
    view.defPosition("f8", 240, 498, 38, 38);
    view.defPosition("g8", 283, 498, 38, 38);
    view.defPosition("h8", 326, 498, 38, 38);
    view.defPosition("i8", 369, 498, 38, 38);
    view.defPosition("j8", 412, 498, 38, 38);
    view.defPosition("k8", 455, 498, 38, 38);
    view.defPosition("l8", 498, 498, 38, 38);
    view.defPosition("m8", 541, 498, 38, 38);
    view.defPosition("n8", 584, 498, 38, 38);
    view.defPosition("o8", 627, 498, 38, 38);
    view.defPosition("p8", 670, 498, 38, 38);
    view.defPosition("q8", 713, 498, 38, 38);
    view.defPosition("r8", 756, 498, 38, 38);
    view.defPosition("s8", 799, 498, 38, 38);
    view.defPosition("a7", 25, 541, 38, 38);
    view.defPosition("b7", 68, 541, 38, 38);
    view.defPosition("c7", 111, 541, 38, 38);
    view.defPosition("d7", 154, 541, 38, 38);
    view.defPosition("e7", 197, 541, 38, 38);
    view.defPosition("f7", 240, 541, 38, 38);
    view.defPosition("g7", 283, 541, 38, 38);
    view.defPosition("h7", 326, 541, 38, 38);
    view.defPosition("i7", 369, 541, 38, 38);
    view.defPosition("j7", 412, 541, 38, 38);
    view.defPosition("k7", 455, 541, 38, 38);
    view.defPosition("l7", 498, 541, 38, 38);
    view.defPosition("m7", 541, 541, 38, 38);
    view.defPosition("n7", 584, 541, 38, 38);
    view.defPosition("o7", 627, 541, 38, 38);
    view.defPosition("p7", 670, 541, 38, 38);
    view.defPosition("q7", 713, 541, 38, 38);
    view.defPosition("r7", 756, 541, 38, 38);
    view.defPosition("s7", 799, 541, 38, 38);
    view.defPosition("a6", 25, 584, 38, 38);
    view.defPosition("b6", 68, 584, 38, 38);
    view.defPosition("c6", 111, 584, 38, 38);
    view.defPosition("d6", 154, 584, 38, 38);
    view.defPosition("e6", 197, 584, 38, 38);
    view.defPosition("f6", 240, 584, 38, 38);
    view.defPosition("g6", 283, 584, 38, 38);
    view.defPosition("h6", 326, 584, 38, 38);
    view.defPosition("i6", 369, 584, 38, 38);
    view.defPosition("j6", 412, 584, 38, 38);
    view.defPosition("k6", 455, 584, 38, 38);
    view.defPosition("l6", 498, 584, 38, 38);
    view.defPosition("m6", 541, 584, 38, 38);
    view.defPosition("n6", 584, 584, 38, 38);
    view.defPosition("o6", 627, 584, 38, 38);
    view.defPosition("p6", 670, 584, 38, 38);
    view.defPosition("q6", 713, 584, 38, 38);
    view.defPosition("r6", 756, 584, 38, 38);
    view.defPosition("s6", 799, 584, 38, 38);
    view.defPosition("a5", 25, 627, 38, 38);
    view.defPosition("b5", 68, 627, 38, 38);
    view.defPosition("c5", 111, 627, 38, 38);
    view.defPosition("d5", 154, 627, 38, 38);
    view.defPosition("e5", 197, 627, 38, 38);
    view.defPosition("f5", 240, 627, 38, 38);
    view.defPosition("g5", 283, 627, 38, 38);
    view.defPosition("h5", 326, 627, 38, 38);
    view.defPosition("i5", 369, 627, 38, 38);
    view.defPosition("j5", 412, 627, 38, 38);
    view.defPosition("k5", 455, 627, 38, 38);
    view.defPosition("l5", 498, 627, 38, 38);
    view.defPosition("m5", 541, 627, 38, 38);
    view.defPosition("n5", 584, 627, 38, 38);
    view.defPosition("o5", 627, 627, 38, 38);
    view.defPosition("p5", 670, 627, 38, 38);
    view.defPosition("q5", 713, 627, 38, 38);
    view.defPosition("r5", 756, 627, 38, 38);
    view.defPosition("s5", 799, 627, 38, 38);
    view.defPosition("a4", 25, 670, 38, 38);
    view.defPosition("b4", 68, 670, 38, 38);
    view.defPosition("c4", 111, 670, 38, 38);
    view.defPosition("d4", 154, 670, 38, 38);
    view.defPosition("e4", 197, 670, 38, 38);
    view.defPosition("f4", 240, 670, 38, 38);
    view.defPosition("g4", 283, 670, 38, 38);
    view.defPosition("h4", 326, 670, 38, 38);
    view.defPosition("i4", 369, 670, 38, 38);
    view.defPosition("j4", 412, 670, 38, 38);
    view.defPosition("k4", 455, 670, 38, 38);
    view.defPosition("l4", 498, 670, 38, 38);
    view.defPosition("m4", 541, 670, 38, 38);
    view.defPosition("n4", 584, 670, 38, 38);
    view.defPosition("o4", 627, 670, 38, 38);
    view.defPosition("p4", 670, 670, 38, 38);
    view.defPosition("q4", 713, 670, 38, 38);
    view.defPosition("r4", 756, 670, 38, 38);
    view.defPosition("s4", 799, 670, 38, 38);
    view.defPosition("a3", 25, 713, 38, 38);
    view.defPosition("b3", 68, 713, 38, 38);
    view.defPosition("c3", 111, 713, 38, 38);
    view.defPosition("d3", 154, 713, 38, 38);
    view.defPosition("e3", 197, 713, 38, 38);
    view.defPosition("f3", 240, 713, 38, 38);
    view.defPosition("g3", 283, 713, 38, 38);
    view.defPosition("h3", 326, 713, 38, 38);
    view.defPosition("i3", 369, 713, 38, 38);
    view.defPosition("j3", 412, 713, 38, 38);
    view.defPosition("k3", 455, 713, 38, 38);
    view.defPosition("l3", 498, 713, 38, 38);
    view.defPosition("m3", 541, 713, 38, 38);
    view.defPosition("n3", 584, 713, 38, 38);
    view.defPosition("o3", 627, 713, 38, 38);
    view.defPosition("p3", 670, 713, 38, 38);
    view.defPosition("q3", 713, 713, 38, 38);
    view.defPosition("r3", 756, 713, 38, 38);
    view.defPosition("s3", 799, 713, 38, 38);
    view.defPosition("a2", 25, 756, 38, 38);
    view.defPosition("b2", 68, 756, 38, 38);
    view.defPosition("c2", 111, 756, 38, 38);
    view.defPosition("d2", 154, 756, 38, 38);
    view.defPosition("e2", 197, 756, 38, 38);
    view.defPosition("f2", 240, 756, 38, 38);
    view.defPosition("g2", 283, 756, 38, 38);
    view.defPosition("h2", 326, 756, 38, 38);
    view.defPosition("i2", 369, 756, 38, 38);
    view.defPosition("j2", 412, 756, 38, 38);
    view.defPosition("k2", 455, 756, 38, 38);
    view.defPosition("l2", 498, 756, 38, 38);
    view.defPosition("m2", 541, 756, 38, 38);
    view.defPosition("n2", 584, 756, 38, 38);
    view.defPosition("o2", 627, 756, 38, 38);
    view.defPosition("p2", 670, 756, 38, 38);
    view.defPosition("q2", 713, 756, 38, 38);
    view.defPosition("r2", 756, 756, 38, 38);
    view.defPosition("s2", 799, 756, 38, 38);
    view.defPosition("a1", 25, 799, 38, 38);
    view.defPosition("b1", 68, 799, 38, 38);
    view.defPosition("c1", 111, 799, 38, 38);
    view.defPosition("d1", 154, 799, 38, 38);
    view.defPosition("e1", 197, 799, 38, 38);
    view.defPosition("f1", 240, 799, 38, 38);
    view.defPosition("g1", 283, 799, 38, 38);
    view.defPosition("h1", 326, 799, 38, 38);
    view.defPosition("i1", 369, 799, 38, 38);
    view.defPosition("j1", 412, 799, 38, 38);
    view.defPosition("k1", 455, 799, 38, 38);
    view.defPosition("l1", 498, 799, 38, 38);
    view.defPosition("m1", 541, 799, 38, 38);
    view.defPosition("n1", 584, 799, 38, 38);
    view.defPosition("o1", 627, 799, 38, 38);
    view.defPosition("p1", 670, 799, 38, 38);
    view.defPosition("q1", 713, 799, 38, 38);
    view.defPosition("r1", 756, 799, 38, 38);
    view.defPosition("s1", 799, 799, 38, 38);

    view.defPopup("Promote", 377, 2);
    view.defPopupPosition("T1", 36, 120, 39, 39);
    view.defPopupPosition("T2", 36, 165, 39, 39);
}
