ZRF = {
    JUMP:          0,
    IF:            1,
    FORK:          2,
    FUNCTION:      3,
    IN_ZONE:       4,
    FLAG:          5,
    SET_FLAG:      6,
    POS_FLAG:      7,
    SET_POS_FLAG:  8,
    ATTR:          9,
    SET_ATTR:      10,
    PROMOTE:       11,
    MODE:          12,
    ON_BOARD_DIR:  13,
    ON_BOARD_POS:  14,
    PARAM:         15,
    LITERAL:       16,
    VERIFY:        20
};

Dagaz.Model.BuildDesign = function(design) {
    design.checkVersion("z2j", "2");
    design.checkVersion("animate-drops", "false");
    design.checkVersion("animate-captures", "false");
    design.checkVersion("show-blink", "false");
    design.checkVersion("show-hints", "false");
    design.checkVersion("animate-redo", "false");
    design.checkVersion("show-captures", "false");

    design.addDirection("w");
    design.addDirection("e");
    design.addDirection("s");
    design.addDirection("ne");
    design.addDirection("n");
    design.addDirection("se");
    design.addDirection("sw");
    design.addDirection("nw");

    design.addPlayer("White", [1, 0, 4, 6, 2, 7, 3, 5]);
    design.addPlayer("Black", [0, 1, 2, 3, 4, 5, 6, 7]);
    design.addTurn(1);
    design.addTurn(1);
    design.addTurn(2);

    design.addPosition("a19", [0, 1, 19, 0, 0, 20, 0, 0]);
    design.addPosition("b19", [-1, 1, 19, 0, 0, 20, 18, 0]);
    design.addPosition("c19", [-1, 1, 19, 0, 0, 20, 18, 0]);
    design.addPosition("d19", [-1, 1, 19, 0, 0, 20, 18, 0]);
    design.addPosition("e19", [-1, 1, 19, 0, 0, 20, 18, 0]);
    design.addPosition("f19", [-1, 1, 19, 0, 0, 20, 18, 0]);
    design.addPosition("g19", [-1, 1, 19, 0, 0, 20, 18, 0]);
    design.addPosition("h19", [-1, 1, 19, 0, 0, 20, 18, 0]);
    design.addPosition("i19", [-1, 1, 19, 0, 0, 20, 18, 0]);
    design.addPosition("j19", [-1, 1, 19, 0, 0, 20, 18, 0]);
    design.addPosition("k19", [-1, 1, 19, 0, 0, 20, 18, 0]);
    design.addPosition("l19", [-1, 1, 19, 0, 0, 20, 18, 0]);
    design.addPosition("m19", [-1, 1, 19, 0, 0, 20, 18, 0]);
    design.addPosition("n19", [-1, 1, 19, 0, 0, 20, 18, 0]);
    design.addPosition("o19", [-1, 1, 19, 0, 0, 20, 18, 0]);
    design.addPosition("p19", [-1, 1, 19, 0, 0, 20, 18, 0]);
    design.addPosition("q19", [-1, 1, 19, 0, 0, 20, 18, 0]);
    design.addPosition("r19", [-1, 1, 19, 0, 0, 20, 18, 0]);
    design.addPosition("s19", [-1, 0, 19, 0, 0, 0, 18, 0]);
    design.addPosition("a18", [0, 1, 19, -18, -19, 20, 0, 0]);
    design.addPosition("b18", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("c18", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("d18", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("e18", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("f18", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("g18", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("h18", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("i18", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("j18", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("k18", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("l18", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("m18", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("n18", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("o18", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("p18", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("q18", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("r18", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("s18", [-1, 0, 19, 0, -19, 0, 18, -20]);
    design.addPosition("a17", [0, 1, 19, -18, -19, 20, 0, 0]);
    design.addPosition("b17", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("c17", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("d17", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("e17", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("f17", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("g17", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("h17", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("i17", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("j17", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("k17", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("l17", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("m17", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("n17", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("o17", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("p17", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("q17", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("r17", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("s17", [-1, 0, 19, 0, -19, 0, 18, -20]);
    design.addPosition("a16", [0, 1, 19, -18, -19, 20, 0, 0]);
    design.addPosition("b16", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("c16", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("d16", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("e16", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("f16", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("g16", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("h16", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("i16", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("j16", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("k16", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("l16", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("m16", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("n16", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("o16", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("p16", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("q16", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("r16", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("s16", [-1, 0, 19, 0, -19, 0, 18, -20]);
    design.addPosition("a15", [0, 1, 19, -18, -19, 20, 0, 0]);
    design.addPosition("b15", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("c15", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("d15", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("e15", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("f15", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("g15", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("h15", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("i15", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("j15", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("k15", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("l15", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("m15", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("n15", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("o15", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("p15", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("q15", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("r15", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("s15", [-1, 0, 19, 0, -19, 0, 18, -20]);
    design.addPosition("a14", [0, 1, 19, -18, -19, 20, 0, 0]);
    design.addPosition("b14", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("c14", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("d14", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("e14", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("f14", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("g14", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("h14", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("i14", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("j14", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("k14", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("l14", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("m14", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("n14", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("o14", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("p14", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("q14", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("r14", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("s14", [-1, 0, 19, 0, -19, 0, 18, -20]);
    design.addPosition("a13", [0, 1, 19, -18, -19, 20, 0, 0]);
    design.addPosition("b13", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("c13", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("d13", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("e13", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("f13", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("g13", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("h13", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("i13", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("j13", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("k13", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("l13", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("m13", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("n13", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("o13", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("p13", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("q13", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("r13", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("s13", [-1, 0, 19, 0, -19, 0, 18, -20]);
    design.addPosition("a12", [0, 1, 19, -18, -19, 20, 0, 0]);
    design.addPosition("b12", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("c12", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("d12", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("e12", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("f12", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("g12", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("h12", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("i12", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("j12", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("k12", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("l12", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("m12", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("n12", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("o12", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("p12", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("q12", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("r12", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("s12", [-1, 0, 19, 0, -19, 0, 18, -20]);
    design.addPosition("a11", [0, 1, 19, -18, -19, 20, 0, 0]);
    design.addPosition("b11", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("c11", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("d11", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("e11", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("f11", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("g11", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("h11", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("i11", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("j11", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("k11", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("l11", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("m11", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("n11", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("o11", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("p11", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("q11", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("r11", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("s11", [-1, 0, 19, 0, -19, 0, 18, -20]);
    design.addPosition("a10", [0, 1, 19, -18, -19, 20, 0, 0]);
    design.addPosition("b10", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("c10", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("d10", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("e10", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("f10", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("g10", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("h10", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("i10", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("j10", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("k10", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("l10", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("m10", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("n10", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("o10", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("p10", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("q10", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("r10", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("s10", [-1, 0, 19, 0, -19, 0, 18, -20]);
    design.addPosition("a9", [0, 1, 19, -18, -19, 20, 0, 0]);
    design.addPosition("b9", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("c9", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("d9", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("e9", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("f9", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("g9", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("h9", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("i9", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("j9", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("k9", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("l9", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("m9", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("n9", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("o9", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("p9", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("q9", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("r9", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("s9", [-1, 0, 19, 0, -19, 0, 18, -20]);
    design.addPosition("a8", [0, 1, 19, -18, -19, 20, 0, 0]);
    design.addPosition("b8", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("c8", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("d8", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("e8", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("f8", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("g8", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("h8", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("i8", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("j8", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("k8", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("l8", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("m8", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("n8", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("o8", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("p8", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("q8", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("r8", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("s8", [-1, 0, 19, 0, -19, 0, 18, -20]);
    design.addPosition("a7", [0, 1, 19, -18, -19, 20, 0, 0]);
    design.addPosition("b7", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("c7", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("d7", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("e7", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("f7", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("g7", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("h7", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("i7", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("j7", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("k7", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("l7", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("m7", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("n7", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("o7", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("p7", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("q7", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("r7", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("s7", [-1, 0, 19, 0, -19, 0, 18, -20]);
    design.addPosition("a6", [0, 1, 19, -18, -19, 20, 0, 0]);
    design.addPosition("b6", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("c6", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("d6", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("e6", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("f6", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("g6", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("h6", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("i6", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("j6", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("k6", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("l6", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("m6", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("n6", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("o6", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("p6", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("q6", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("r6", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("s6", [-1, 0, 19, 0, -19, 0, 18, -20]);
    design.addPosition("a5", [0, 1, 19, -18, -19, 20, 0, 0]);
    design.addPosition("b5", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("c5", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("d5", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("e5", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("f5", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("g5", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("h5", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("i5", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("j5", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("k5", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("l5", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("m5", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("n5", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("o5", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("p5", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("q5", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("r5", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("s5", [-1, 0, 19, 0, -19, 0, 18, -20]);
    design.addPosition("a4", [0, 1, 19, -18, -19, 20, 0, 0]);
    design.addPosition("b4", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("c4", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("d4", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("e4", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("f4", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("g4", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("h4", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("i4", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("j4", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("k4", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("l4", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("m4", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("n4", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("o4", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("p4", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("q4", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("r4", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("s4", [-1, 0, 19, 0, -19, 0, 18, -20]);
    design.addPosition("a3", [0, 1, 19, -18, -19, 20, 0, 0]);
    design.addPosition("b3", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("c3", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("d3", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("e3", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("f3", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("g3", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("h3", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("i3", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("j3", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("k3", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("l3", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("m3", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("n3", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("o3", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("p3", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("q3", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("r3", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("s3", [-1, 0, 19, 0, -19, 0, 18, -20]);
    design.addPosition("a2", [0, 1, 19, -18, -19, 20, 0, 0]);
    design.addPosition("b2", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("c2", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("d2", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("e2", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("f2", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("g2", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("h2", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("i2", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("j2", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("k2", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("l2", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("m2", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("n2", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("o2", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("p2", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("q2", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("r2", [-1, 1, 19, -18, -19, 20, 18, -20]);
    design.addPosition("s2", [-1, 0, 19, 0, -19, 0, 18, -20]);
    design.addPosition("a1", [0, 1, 0, -18, -19, 0, 0, 0]);
    design.addPosition("b1", [-1, 1, 0, -18, -19, 0, 0, -20]);
    design.addPosition("c1", [-1, 1, 0, -18, -19, 0, 0, -20]);
    design.addPosition("d1", [-1, 1, 0, -18, -19, 0, 0, -20]);
    design.addPosition("e1", [-1, 1, 0, -18, -19, 0, 0, -20]);
    design.addPosition("f1", [-1, 1, 0, -18, -19, 0, 0, -20]);
    design.addPosition("g1", [-1, 1, 0, -18, -19, 0, 0, -20]);
    design.addPosition("h1", [-1, 1, 0, -18, -19, 0, 0, -20]);
    design.addPosition("i1", [-1, 1, 0, -18, -19, 0, 0, -20]);
    design.addPosition("j1", [-1, 1, 0, -18, -19, 0, 0, -20]);
    design.addPosition("k1", [-1, 1, 0, -18, -19, 0, 0, -20]);
    design.addPosition("l1", [-1, 1, 0, -18, -19, 0, 0, -20]);
    design.addPosition("m1", [-1, 1, 0, -18, -19, 0, 0, -20]);
    design.addPosition("n1", [-1, 1, 0, -18, -19, 0, 0, -20]);
    design.addPosition("o1", [-1, 1, 0, -18, -19, 0, 0, -20]);
    design.addPosition("p1", [-1, 1, 0, -18, -19, 0, 0, -20]);
    design.addPosition("q1", [-1, 1, 0, -18, -19, 0, 0, -20]);
    design.addPosition("r1", [-1, 1, 0, -18, -19, 0, 0, -20]);
    design.addPosition("s1", [-1, 0, 0, 0, -19, 0, 0, -20]);

    design.addZone("outer", 2, [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 342, 343, 344, 345, 346, 347, 348, 349, 350, 351, 352, 353, 354, 355, 356, 357, 358, 359, 360, 19, 38, 57, 76, 95, 114, 133, 152, 171, 190, 209, 228, 247, 266, 285, 304, 323, 37, 56, 75, 94, 113, 132, 151, 170, 189, 208, 227, 246, 265, 284, 303, 322, 341]);

    design.addCommand(0, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(0, ZRF.FUNCTION,	20);	// verify
    design.addCommand(0, ZRF.FUNCTION,	25);	// to
    design.addCommand(0, ZRF.FUNCTION,	28);	// end

    design.addPiece("Stone", 0);
    design.addDrop(0, 0, [], 0);

    design.setup("Black", "Stone", 180);
}

Dagaz.View.configure = function(view) {
    view.defBoard("Board");
    view.defPiece("BlackStone", "Black Stone");
    view.defPiece("WhiteStone", "White Stone");
 
    view.defPosition("a19", 7, 9, 27, 26);
    view.defPosition("b19", 33, 9, 27, 26);
    view.defPosition("c19", 59, 9, 27, 26);
    view.defPosition("d19", 85, 9, 27, 26);
    view.defPosition("e19", 111, 9, 27, 26);
    view.defPosition("f19", 137, 9, 27, 26);
    view.defPosition("g19", 163, 9, 27, 26);
    view.defPosition("h19", 189, 9, 27, 26);
    view.defPosition("i19", 215, 9, 27, 26);
    view.defPosition("j19", 241, 9, 27, 26);
    view.defPosition("k19", 267, 9, 27, 26);
    view.defPosition("l19", 293, 9, 27, 26);
    view.defPosition("m19", 319, 9, 27, 26);
    view.defPosition("n19", 345, 9, 27, 26);
    view.defPosition("o19", 371, 9, 27, 26);
    view.defPosition("p19", 397, 9, 27, 26);
    view.defPosition("q19", 423, 9, 27, 26);
    view.defPosition("r19", 449, 9, 27, 26);
    view.defPosition("s19", 475, 9, 27, 26);
    view.defPosition("a18", 7, 35, 27, 26);
    view.defPosition("b18", 33, 35, 27, 26);
    view.defPosition("c18", 59, 35, 27, 26);
    view.defPosition("d18", 85, 35, 27, 26);
    view.defPosition("e18", 111, 35, 27, 26);
    view.defPosition("f18", 137, 35, 27, 26);
    view.defPosition("g18", 163, 35, 27, 26);
    view.defPosition("h18", 189, 35, 27, 26);
    view.defPosition("i18", 215, 35, 27, 26);
    view.defPosition("j18", 241, 35, 27, 26);
    view.defPosition("k18", 267, 35, 27, 26);
    view.defPosition("l18", 293, 35, 27, 26);
    view.defPosition("m18", 319, 35, 27, 26);
    view.defPosition("n18", 345, 35, 27, 26);
    view.defPosition("o18", 371, 35, 27, 26);
    view.defPosition("p18", 397, 35, 27, 26);
    view.defPosition("q18", 423, 35, 27, 26);
    view.defPosition("r18", 449, 35, 27, 26);
    view.defPosition("s18", 475, 35, 27, 26);
    view.defPosition("a17", 7, 61, 27, 26);
    view.defPosition("b17", 33, 61, 27, 26);
    view.defPosition("c17", 59, 61, 27, 26);
    view.defPosition("d17", 85, 61, 27, 26);
    view.defPosition("e17", 111, 61, 27, 26);
    view.defPosition("f17", 137, 61, 27, 26);
    view.defPosition("g17", 163, 61, 27, 26);
    view.defPosition("h17", 189, 61, 27, 26);
    view.defPosition("i17", 215, 61, 27, 26);
    view.defPosition("j17", 241, 61, 27, 26);
    view.defPosition("k17", 267, 61, 27, 26);
    view.defPosition("l17", 293, 61, 27, 26);
    view.defPosition("m17", 319, 61, 27, 26);
    view.defPosition("n17", 345, 61, 27, 26);
    view.defPosition("o17", 371, 61, 27, 26);
    view.defPosition("p17", 397, 61, 27, 26);
    view.defPosition("q17", 423, 61, 27, 26);
    view.defPosition("r17", 449, 61, 27, 26);
    view.defPosition("s17", 475, 61, 27, 26);
    view.defPosition("a16", 7, 87, 27, 26);
    view.defPosition("b16", 33, 87, 27, 26);
    view.defPosition("c16", 59, 87, 27, 26);
    view.defPosition("d16", 85, 87, 27, 26);
    view.defPosition("e16", 111, 87, 27, 26);
    view.defPosition("f16", 137, 87, 27, 26);
    view.defPosition("g16", 163, 87, 27, 26);
    view.defPosition("h16", 189, 87, 27, 26);
    view.defPosition("i16", 215, 87, 27, 26);
    view.defPosition("j16", 241, 87, 27, 26);
    view.defPosition("k16", 267, 87, 27, 26);
    view.defPosition("l16", 293, 87, 27, 26);
    view.defPosition("m16", 319, 87, 27, 26);
    view.defPosition("n16", 345, 87, 27, 26);
    view.defPosition("o16", 371, 87, 27, 26);
    view.defPosition("p16", 397, 87, 27, 26);
    view.defPosition("q16", 423, 87, 27, 26);
    view.defPosition("r16", 449, 87, 27, 26);
    view.defPosition("s16", 475, 87, 27, 26);
    view.defPosition("a15", 7, 113, 27, 26);
    view.defPosition("b15", 33, 113, 27, 26);
    view.defPosition("c15", 59, 113, 27, 26);
    view.defPosition("d15", 85, 113, 27, 26);
    view.defPosition("e15", 111, 113, 27, 26);
    view.defPosition("f15", 137, 113, 27, 26);
    view.defPosition("g15", 163, 113, 27, 26);
    view.defPosition("h15", 189, 113, 27, 26);
    view.defPosition("i15", 215, 113, 27, 26);
    view.defPosition("j15", 241, 113, 27, 26);
    view.defPosition("k15", 267, 113, 27, 26);
    view.defPosition("l15", 293, 113, 27, 26);
    view.defPosition("m15", 319, 113, 27, 26);
    view.defPosition("n15", 345, 113, 27, 26);
    view.defPosition("o15", 371, 113, 27, 26);
    view.defPosition("p15", 397, 113, 27, 26);
    view.defPosition("q15", 423, 113, 27, 26);
    view.defPosition("r15", 449, 113, 27, 26);
    view.defPosition("s15", 475, 113, 27, 26);
    view.defPosition("a14", 7, 139, 27, 26);
    view.defPosition("b14", 33, 139, 27, 26);
    view.defPosition("c14", 59, 139, 27, 26);
    view.defPosition("d14", 85, 139, 27, 26);
    view.defPosition("e14", 111, 139, 27, 26);
    view.defPosition("f14", 137, 139, 27, 26);
    view.defPosition("g14", 163, 139, 27, 26);
    view.defPosition("h14", 189, 139, 27, 26);
    view.defPosition("i14", 215, 139, 27, 26);
    view.defPosition("j14", 241, 139, 27, 26);
    view.defPosition("k14", 267, 139, 27, 26);
    view.defPosition("l14", 293, 139, 27, 26);
    view.defPosition("m14", 319, 139, 27, 26);
    view.defPosition("n14", 345, 139, 27, 26);
    view.defPosition("o14", 371, 139, 27, 26);
    view.defPosition("p14", 397, 139, 27, 26);
    view.defPosition("q14", 423, 139, 27, 26);
    view.defPosition("r14", 449, 139, 27, 26);
    view.defPosition("s14", 475, 139, 27, 26);
    view.defPosition("a13", 7, 165, 27, 26);
    view.defPosition("b13", 33, 165, 27, 26);
    view.defPosition("c13", 59, 165, 27, 26);
    view.defPosition("d13", 85, 165, 27, 26);
    view.defPosition("e13", 111, 165, 27, 26);
    view.defPosition("f13", 137, 165, 27, 26);
    view.defPosition("g13", 163, 165, 27, 26);
    view.defPosition("h13", 189, 165, 27, 26);
    view.defPosition("i13", 215, 165, 27, 26);
    view.defPosition("j13", 241, 165, 27, 26);
    view.defPosition("k13", 267, 165, 27, 26);
    view.defPosition("l13", 293, 165, 27, 26);
    view.defPosition("m13", 319, 165, 27, 26);
    view.defPosition("n13", 345, 165, 27, 26);
    view.defPosition("o13", 371, 165, 27, 26);
    view.defPosition("p13", 397, 165, 27, 26);
    view.defPosition("q13", 423, 165, 27, 26);
    view.defPosition("r13", 449, 165, 27, 26);
    view.defPosition("s13", 475, 165, 27, 26);
    view.defPosition("a12", 7, 191, 27, 26);
    view.defPosition("b12", 33, 191, 27, 26);
    view.defPosition("c12", 59, 191, 27, 26);
    view.defPosition("d12", 85, 191, 27, 26);
    view.defPosition("e12", 111, 191, 27, 26);
    view.defPosition("f12", 137, 191, 27, 26);
    view.defPosition("g12", 163, 191, 27, 26);
    view.defPosition("h12", 189, 191, 27, 26);
    view.defPosition("i12", 215, 191, 27, 26);
    view.defPosition("j12", 241, 191, 27, 26);
    view.defPosition("k12", 267, 191, 27, 26);
    view.defPosition("l12", 293, 191, 27, 26);
    view.defPosition("m12", 319, 191, 27, 26);
    view.defPosition("n12", 345, 191, 27, 26);
    view.defPosition("o12", 371, 191, 27, 26);
    view.defPosition("p12", 397, 191, 27, 26);
    view.defPosition("q12", 423, 191, 27, 26);
    view.defPosition("r12", 449, 191, 27, 26);
    view.defPosition("s12", 475, 191, 27, 26);
    view.defPosition("a11", 7, 217, 27, 26);
    view.defPosition("b11", 33, 217, 27, 26);
    view.defPosition("c11", 59, 217, 27, 26);
    view.defPosition("d11", 85, 217, 27, 26);
    view.defPosition("e11", 111, 217, 27, 26);
    view.defPosition("f11", 137, 217, 27, 26);
    view.defPosition("g11", 163, 217, 27, 26);
    view.defPosition("h11", 189, 217, 27, 26);
    view.defPosition("i11", 215, 217, 27, 26);
    view.defPosition("j11", 241, 217, 27, 26);
    view.defPosition("k11", 267, 217, 27, 26);
    view.defPosition("l11", 293, 217, 27, 26);
    view.defPosition("m11", 319, 217, 27, 26);
    view.defPosition("n11", 345, 217, 27, 26);
    view.defPosition("o11", 371, 217, 27, 26);
    view.defPosition("p11", 397, 217, 27, 26);
    view.defPosition("q11", 423, 217, 27, 26);
    view.defPosition("r11", 449, 217, 27, 26);
    view.defPosition("s11", 475, 217, 27, 26);
    view.defPosition("a10", 7, 243, 27, 26);
    view.defPosition("b10", 33, 243, 27, 26);
    view.defPosition("c10", 59, 243, 27, 26);
    view.defPosition("d10", 85, 243, 27, 26);
    view.defPosition("e10", 111, 243, 27, 26);
    view.defPosition("f10", 137, 243, 27, 26);
    view.defPosition("g10", 163, 243, 27, 26);
    view.defPosition("h10", 189, 243, 27, 26);
    view.defPosition("i10", 215, 243, 27, 26);
    view.defPosition("j10", 241, 243, 27, 26);
    view.defPosition("k10", 267, 243, 27, 26);
    view.defPosition("l10", 293, 243, 27, 26);
    view.defPosition("m10", 319, 243, 27, 26);
    view.defPosition("n10", 345, 243, 27, 26);
    view.defPosition("o10", 371, 243, 27, 26);
    view.defPosition("p10", 397, 243, 27, 26);
    view.defPosition("q10", 423, 243, 27, 26);
    view.defPosition("r10", 449, 243, 27, 26);
    view.defPosition("s10", 475, 243, 27, 26);
    view.defPosition("a9", 7, 269, 27, 26);
    view.defPosition("b9", 33, 269, 27, 26);
    view.defPosition("c9", 59, 269, 27, 26);
    view.defPosition("d9", 85, 269, 27, 26);
    view.defPosition("e9", 111, 269, 27, 26);
    view.defPosition("f9", 137, 269, 27, 26);
    view.defPosition("g9", 163, 269, 27, 26);
    view.defPosition("h9", 189, 269, 27, 26);
    view.defPosition("i9", 215, 269, 27, 26);
    view.defPosition("j9", 241, 269, 27, 26);
    view.defPosition("k9", 267, 269, 27, 26);
    view.defPosition("l9", 293, 269, 27, 26);
    view.defPosition("m9", 319, 269, 27, 26);
    view.defPosition("n9", 345, 269, 27, 26);
    view.defPosition("o9", 371, 269, 27, 26);
    view.defPosition("p9", 397, 269, 27, 26);
    view.defPosition("q9", 423, 269, 27, 26);
    view.defPosition("r9", 449, 269, 27, 26);
    view.defPosition("s9", 475, 269, 27, 26);
    view.defPosition("a8", 7, 295, 27, 26);
    view.defPosition("b8", 33, 295, 27, 26);
    view.defPosition("c8", 59, 295, 27, 26);
    view.defPosition("d8", 85, 295, 27, 26);
    view.defPosition("e8", 111, 295, 27, 26);
    view.defPosition("f8", 137, 295, 27, 26);
    view.defPosition("g8", 163, 295, 27, 26);
    view.defPosition("h8", 189, 295, 27, 26);
    view.defPosition("i8", 215, 295, 27, 26);
    view.defPosition("j8", 241, 295, 27, 26);
    view.defPosition("k8", 267, 295, 27, 26);
    view.defPosition("l8", 293, 295, 27, 26);
    view.defPosition("m8", 319, 295, 27, 26);
    view.defPosition("n8", 345, 295, 27, 26);
    view.defPosition("o8", 371, 295, 27, 26);
    view.defPosition("p8", 397, 295, 27, 26);
    view.defPosition("q8", 423, 295, 27, 26);
    view.defPosition("r8", 449, 295, 27, 26);
    view.defPosition("s8", 475, 295, 27, 26);
    view.defPosition("a7", 7, 321, 27, 26);
    view.defPosition("b7", 33, 321, 27, 26);
    view.defPosition("c7", 59, 321, 27, 26);
    view.defPosition("d7", 85, 321, 27, 26);
    view.defPosition("e7", 111, 321, 27, 26);
    view.defPosition("f7", 137, 321, 27, 26);
    view.defPosition("g7", 163, 321, 27, 26);
    view.defPosition("h7", 189, 321, 27, 26);
    view.defPosition("i7", 215, 321, 27, 26);
    view.defPosition("j7", 241, 321, 27, 26);
    view.defPosition("k7", 267, 321, 27, 26);
    view.defPosition("l7", 293, 321, 27, 26);
    view.defPosition("m7", 319, 321, 27, 26);
    view.defPosition("n7", 345, 321, 27, 26);
    view.defPosition("o7", 371, 321, 27, 26);
    view.defPosition("p7", 397, 321, 27, 26);
    view.defPosition("q7", 423, 321, 27, 26);
    view.defPosition("r7", 449, 321, 27, 26);
    view.defPosition("s7", 475, 321, 27, 26);
    view.defPosition("a6", 7, 347, 27, 26);
    view.defPosition("b6", 33, 347, 27, 26);
    view.defPosition("c6", 59, 347, 27, 26);
    view.defPosition("d6", 85, 347, 27, 26);
    view.defPosition("e6", 111, 347, 27, 26);
    view.defPosition("f6", 137, 347, 27, 26);
    view.defPosition("g6", 163, 347, 27, 26);
    view.defPosition("h6", 189, 347, 27, 26);
    view.defPosition("i6", 215, 347, 27, 26);
    view.defPosition("j6", 241, 347, 27, 26);
    view.defPosition("k6", 267, 347, 27, 26);
    view.defPosition("l6", 293, 347, 27, 26);
    view.defPosition("m6", 319, 347, 27, 26);
    view.defPosition("n6", 345, 347, 27, 26);
    view.defPosition("o6", 371, 347, 27, 26);
    view.defPosition("p6", 397, 347, 27, 26);
    view.defPosition("q6", 423, 347, 27, 26);
    view.defPosition("r6", 449, 347, 27, 26);
    view.defPosition("s6", 475, 347, 27, 26);
    view.defPosition("a5", 7, 373, 27, 26);
    view.defPosition("b5", 33, 373, 27, 26);
    view.defPosition("c5", 59, 373, 27, 26);
    view.defPosition("d5", 85, 373, 27, 26);
    view.defPosition("e5", 111, 373, 27, 26);
    view.defPosition("f5", 137, 373, 27, 26);
    view.defPosition("g5", 163, 373, 27, 26);
    view.defPosition("h5", 189, 373, 27, 26);
    view.defPosition("i5", 215, 373, 27, 26);
    view.defPosition("j5", 241, 373, 27, 26);
    view.defPosition("k5", 267, 373, 27, 26);
    view.defPosition("l5", 293, 373, 27, 26);
    view.defPosition("m5", 319, 373, 27, 26);
    view.defPosition("n5", 345, 373, 27, 26);
    view.defPosition("o5", 371, 373, 27, 26);
    view.defPosition("p5", 397, 373, 27, 26);
    view.defPosition("q5", 423, 373, 27, 26);
    view.defPosition("r5", 449, 373, 27, 26);
    view.defPosition("s5", 475, 373, 27, 26);
    view.defPosition("a4", 7, 399, 27, 26);
    view.defPosition("b4", 33, 399, 27, 26);
    view.defPosition("c4", 59, 399, 27, 26);
    view.defPosition("d4", 85, 399, 27, 26);
    view.defPosition("e4", 111, 399, 27, 26);
    view.defPosition("f4", 137, 399, 27, 26);
    view.defPosition("g4", 163, 399, 27, 26);
    view.defPosition("h4", 189, 399, 27, 26);
    view.defPosition("i4", 215, 399, 27, 26);
    view.defPosition("j4", 241, 399, 27, 26);
    view.defPosition("k4", 267, 399, 27, 26);
    view.defPosition("l4", 293, 399, 27, 26);
    view.defPosition("m4", 319, 399, 27, 26);
    view.defPosition("n4", 345, 399, 27, 26);
    view.defPosition("o4", 371, 399, 27, 26);
    view.defPosition("p4", 397, 399, 27, 26);
    view.defPosition("q4", 423, 399, 27, 26);
    view.defPosition("r4", 449, 399, 27, 26);
    view.defPosition("s4", 475, 399, 27, 26);
    view.defPosition("a3", 7, 425, 27, 26);
    view.defPosition("b3", 33, 425, 27, 26);
    view.defPosition("c3", 59, 425, 27, 26);
    view.defPosition("d3", 85, 425, 27, 26);
    view.defPosition("e3", 111, 425, 27, 26);
    view.defPosition("f3", 137, 425, 27, 26);
    view.defPosition("g3", 163, 425, 27, 26);
    view.defPosition("h3", 189, 425, 27, 26);
    view.defPosition("i3", 215, 425, 27, 26);
    view.defPosition("j3", 241, 425, 27, 26);
    view.defPosition("k3", 267, 425, 27, 26);
    view.defPosition("l3", 293, 425, 27, 26);
    view.defPosition("m3", 319, 425, 27, 26);
    view.defPosition("n3", 345, 425, 27, 26);
    view.defPosition("o3", 371, 425, 27, 26);
    view.defPosition("p3", 397, 425, 27, 26);
    view.defPosition("q3", 423, 425, 27, 26);
    view.defPosition("r3", 449, 425, 27, 26);
    view.defPosition("s3", 475, 425, 27, 26);
    view.defPosition("a2", 7, 451, 27, 26);
    view.defPosition("b2", 33, 451, 27, 26);
    view.defPosition("c2", 59, 451, 27, 26);
    view.defPosition("d2", 85, 451, 27, 26);
    view.defPosition("e2", 111, 451, 27, 26);
    view.defPosition("f2", 137, 451, 27, 26);
    view.defPosition("g2", 163, 451, 27, 26);
    view.defPosition("h2", 189, 451, 27, 26);
    view.defPosition("i2", 215, 451, 27, 26);
    view.defPosition("j2", 241, 451, 27, 26);
    view.defPosition("k2", 267, 451, 27, 26);
    view.defPosition("l2", 293, 451, 27, 26);
    view.defPosition("m2", 319, 451, 27, 26);
    view.defPosition("n2", 345, 451, 27, 26);
    view.defPosition("o2", 371, 451, 27, 26);
    view.defPosition("p2", 397, 451, 27, 26);
    view.defPosition("q2", 423, 451, 27, 26);
    view.defPosition("r2", 449, 451, 27, 26);
    view.defPosition("s2", 475, 451, 27, 26);
    view.defPosition("a1", 7, 477, 27, 26);
    view.defPosition("b1", 33, 477, 27, 26);
    view.defPosition("c1", 59, 477, 27, 26);
    view.defPosition("d1", 85, 477, 27, 26);
    view.defPosition("e1", 111, 477, 27, 26);
    view.defPosition("f1", 137, 477, 27, 26);
    view.defPosition("g1", 163, 477, 27, 26);
    view.defPosition("h1", 189, 477, 27, 26);
    view.defPosition("i1", 215, 477, 27, 26);
    view.defPosition("j1", 241, 477, 27, 26);
    view.defPosition("k1", 267, 477, 27, 26);
    view.defPosition("l1", 293, 477, 27, 26);
    view.defPosition("m1", 319, 477, 27, 26);
    view.defPosition("n1", 345, 477, 27, 26);
    view.defPosition("o1", 371, 477, 27, 26);
    view.defPosition("p1", 397, 477, 27, 26);
    view.defPosition("q1", 423, 477, 27, 26);
    view.defPosition("r1", 449, 477, 27, 26);
    view.defPosition("s1", 475, 477, 27, 26);
}
