ZRF = {
    JUMP:          0,
    IF:            1,
    FORK:          2,
    FUNCTION:      3,
    IN_ZONE:       4,
    FLAG:          5,
    SET_FLAG:      6,
    POS_FLAG:      7,
    SET_POS_FLAG:  8,
    ATTR:          9,
    SET_ATTR:      10,
    PROMOTE:       11,
    MODE:          12,
    ON_BOARD_DIR:  13,
    ON_BOARD_POS:  14,
    PARAM:         15,
    LITERAL:       16,
    VERIFY:        20
};

Dagaz.Model.BuildDesign = function(design) {
    design.checkVersion("z2j", "2");
    design.checkVersion("smart-moves", "false");
    design.checkVersion("show-hints", "false");
    design.checkVersion("show-blink", "false");
    design.checkVersion("advisor-wait", "5");

    design.setupSelector(4);

    design.addDirection("se"); // 0
    design.addDirection("s");  // 1
    design.addDirection("sw"); // 2
    design.addDirection("e");  // 3
    design.addDirection("w");  // 4
    design.addDirection("ne"); // 5
    design.addDirection("nw"); // 6
    design.addDirection("n");  // 7

    design.addPlayer("White", [6, 7, 5, 4, 3, 2, 0, 1], 1);
    design.addPlayer("Black", [0, 1, 2, 3, 4, 5, 6, 7], 1);
    design.addPlayer("White", [6, 7, 5, 4, 3, 2, 0, 1], 2);
    design.addPlayer("Black", [0, 1, 2, 3, 4, 5, 6, 7], 2);
    design.addPlayer("Black", [6, 7, 5, 4, 3, 2, 0, 1], 3);
    design.addPlayer("White", [0, 1, 2, 3, 4, 5, 6, 7], 3);
    design.addPlayer("Black", [6, 7, 5, 4, 3, 2, 0, 1], 4);
    design.addPlayer("White", [0, 1, 2, 3, 4, 5, 6, 7], 4);

    design.addTurn(2, undefined, 3);
    design.addTurn(1, undefined, 3);
    design.addTurn(2, undefined, 4);
    design.addTurn(1, undefined, 4);

    design.addPosition("a16", [9, 8, 0, 1, 0, 0, 0, 0]);
    design.addPosition("b16", [9, 8, 7, 1, -1, 0, 0, 0]);
    design.addPosition("c16", [9, 8, 7, 1, -1, 0, 0, 0]);
    design.addPosition("d16", [9, 8, 7, 1, -1, 0, 0, 0]);
    design.addPosition("e16", [9, 8, 7, 1, -1, 0, 0, 0]);
    design.addPosition("f16", [9, 8, 7, 1, -1, 0, 0, 0]);
    design.addPosition("g16", [9, 8, 7, 1, -1, 0, 0, 0]);
    design.addPosition("h16", [0, 8, 7, 0, -1, 0, 0, 0]);
    design.addPosition("a15", [9, 8, 0, 1, 0, -7, 0, -8]);
    design.addPosition("b15", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("c15", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("d15", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("e15", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("f15", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("g15", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("h15", [0, 8, 7, 0, -1, 0, -9, -8]);
    design.addPosition("a14", [9, 8, 0, 1, 0, -7, 0, -8]);
    design.addPosition("b14", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("c14", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("d14", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("e14", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("f14", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("g14", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("h14", [0, 8, 7, 0, -1, 0, -9, -8]);
    design.addPosition("a13", [9, 8, 0, 1, 0, -7, 0, -8]);
    design.addPosition("b13", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("c13", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("d13", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("e13", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("f13", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("g13", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("h13", [0, 8, 7, 0, -1, 0, -9, -8]);
    design.addPosition("a12", [9, 8, 0, 1, 0, -7, 0, -8]);
    design.addPosition("b12", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("c12", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("d12", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("e12", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("f12", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("g12", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("h12", [0, 8, 7, 0, -1, 0, -9, -8]);
    design.addPosition("a11", [9, 8, 0, 1, 0, -7, 0, -8]);
    design.addPosition("b11", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("c11", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("d11", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("e11", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("f11", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("g11", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("h11", [0, 8, 7, 0, -1, 0, -9, -8]);
    design.addPosition("a10", [9, 8, 0, 1, 0, -7, 0, -8]);
    design.addPosition("b10", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("c10", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("d10", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("e10", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("f10", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("g10", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("h10", [0, 8, 7, 0, -1, 0, -9, -8]);
    design.addPosition("a9", [9, 8, 0, 1, 0, -7, 0, -8]);
    design.addPosition("b9", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("c9", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("d9", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("e9", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("f9", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("g9", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("h9", [0, 8, 7, 0, -1, 0, -9, -8]);
    design.addPosition("a8", [9, 8, 0, 1, 0, -7, 0, -8]);
    design.addPosition("b8", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("c8", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("d8", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("e8", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("f8", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("g8", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("h8", [0, 8, 7, 0, -1, 0, -9, -8]);
    design.addPosition("a7", [9, 8, 0, 1, 0, -7, 0, -8]);
    design.addPosition("b7", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("c7", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("d7", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("e7", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("f7", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("g7", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("h7", [0, 8, 7, 0, -1, 0, -9, -8]);
    design.addPosition("a6", [9, 8, 0, 1, 0, -7, 0, -8]);
    design.addPosition("b6", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("c6", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("d6", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("e6", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("f6", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("g6", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("h6", [0, 8, 7, 0, -1, 0, -9, -8]);
    design.addPosition("a5", [9, 8, 0, 1, 0, -7, 0, -8]);
    design.addPosition("b5", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("c5", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("d5", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("e5", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("f5", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("g5", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("h5", [0, 8, 7, 0, -1, 0, -9, -8]);
    design.addPosition("a4", [9, 8, 0, 1, 0, -7, 0, -8]);
    design.addPosition("b4", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("c4", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("d4", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("e4", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("f4", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("g4", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("h4", [0, 8, 7, 0, -1, 0, -9, -8]);
    design.addPosition("a3", [9, 8, 0, 1, 0, -7, 0, -8]);
    design.addPosition("b3", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("c3", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("d3", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("e3", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("f3", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("g3", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("h3", [0, 8, 7, 0, -1, 0, -9, -8]);
    design.addPosition("a2", [9, 8, 0, 1, 0, -7, 0, -8]);
    design.addPosition("b2", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("c2", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("d2", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("e2", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("f2", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("g2", [9, 8, 7, 1, -1, -7, -9, -8]);
    design.addPosition("h2", [0, 8, 7, 0, -1, 0, -9, -8]);
    design.addPosition("a1", [0, 0, 0, 1, 0, -7, 0, -8]);
    design.addPosition("b1", [0, 0, 0, 1, -1, -7, -9, -8]);
    design.addPosition("c1", [0, 0, 0, 1, -1, -7, -9, -8]);
    design.addPosition("d1", [0, 0, 0, 1, -1, -7, -9, -8]);
    design.addPosition("e1", [0, 0, 0, 1, -1, -7, -9, -8]);
    design.addPosition("f1", [0, 0, 0, 1, -1, -7, -9, -8]);
    design.addPosition("g1", [0, 0, 0, 1, -1, -7, -9, -8]);
    design.addPosition("h1", [0, 0, 0, 0, -1, 0, -9, -8]);
    design.addPosition("y1", [0, 0, 0, 0, 0, 0, 0, 0]);
    design.addPosition("y2", [0, 0, 0, 0, 0, 0, 0, 0]);
    design.addPosition("y3", [0, 0, 0, 0, 0, 0, 0, 0]);
    design.addPosition("y4", [0, 0, 0, 0, 0, 0, 0, 0]);
    design.addPosition("y5", [0, 0, 0, 0, 0, 0, 0, 0]);
    design.addPosition("y6", [0, 0, 0, 0, 0, 0, 0, 0]);
    design.addPosition("x1", [0, 0, 0, 0, 0, 0, 0, 0]);
    design.addPosition("x2", [0, 0, 0, 0, 0, 0, 0, 0]);
    design.addPosition("x3", [0, 0, 0, 0, 0, 0, 0, 0]);
    design.addPosition("x4", [0, 0, 0, 0, 0, 0, 0, 0]);
    design.addPosition("x5", [0, 0, 0, 0, 0, 0, 0, 0]);
    design.addPosition("x6", [0, 0, 0, 0, 0, 0, 0, 0]);

    design.addZone("off-board", 1, [134, 135, 136, 137, 138, 139]);
    design.addZone("off-board", 2, [128, 129, 130, 131, 132, 133]);

    design.addCommand(0, ZRF.FUNCTION,	24);	// from
    design.addCommand(0, ZRF.PARAM,	0);	// $1
    design.addCommand(0, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(0, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(0, ZRF.FUNCTION,	20);	// verify
    design.addCommand(0, ZRF.FUNCTION,	25);	// to
    design.addCommand(0, ZRF.FUNCTION,	28);	// end

    design.addCommand(1, ZRF.FUNCTION,	24);	// from
    design.addCommand(1, ZRF.PARAM,	0);	// $1
    design.addCommand(1, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(1, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(1, ZRF.FUNCTION,	20);	// verify
    design.addCommand(1, ZRF.PARAM,	1);	// $2
    design.addCommand(1, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(1, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(1, ZRF.FUNCTION,	20);	// verify
    design.addCommand(1, ZRF.FUNCTION,	25);	// to
    design.addCommand(1, ZRF.FUNCTION,	28);	// end

    design.addCommand(2, ZRF.FUNCTION,	24);	// from
    design.addCommand(2, ZRF.PARAM,	0);	// $1
    design.addCommand(2, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(2, ZRF.PARAM,	1);	// $2
    design.addCommand(2, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(2, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(2, ZRF.FUNCTION,	20);	// verify
    design.addCommand(2, ZRF.FUNCTION,	25);	// to
    design.addCommand(2, ZRF.FUNCTION,	28);	// end

    design.addCommand(3, ZRF.FUNCTION,	24);	// from
    design.addCommand(3, ZRF.PARAM,	0);	// $1
    design.addCommand(3, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(3, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(3, ZRF.FUNCTION,	20);	// verify
    design.addCommand(3, ZRF.PARAM,	1);	// $2
    design.addCommand(3, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(3, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(3, ZRF.FUNCTION,	20);	// verify
    design.addCommand(3, ZRF.PARAM,	2);	// $3
    design.addCommand(3, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(3, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(3, ZRF.FUNCTION,	20);	// verify
    design.addCommand(3, ZRF.FUNCTION,	25);	// to
    design.addCommand(3, ZRF.FUNCTION,	28);	// end

    design.addCommand(4, ZRF.FUNCTION,	24);	// from
    design.addCommand(4, ZRF.PARAM,	0);	// $1
    design.addCommand(4, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(4, ZRF.PARAM,	1);	// $2
    design.addCommand(4, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(4, ZRF.PARAM,	2);	// $3
    design.addCommand(4, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(4, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(4, ZRF.FUNCTION,	20);	// verify
    design.addCommand(4, ZRF.FUNCTION,	25);	// to
    design.addCommand(4, ZRF.FUNCTION,	28);	// end

    design.addPiece("C1", 0, 1);
    design.addMove(0, 0, [6], 0);
    design.addMove(0, 0, [5], 0);
    design.addMove(0, 0, [2], 0);
    design.addMove(0, 0, [0], 0);

    design.addPiece("C2", 1, 2);
    design.addMove(1, 0, [6], 0);
    design.addMove(1, 0, [5], 0);
    design.addMove(1, 0, [2], 0);
    design.addMove(1, 0, [0], 0);

    design.addPiece("C4", 2, 4);
    design.addMove(2, 0, [6], 0);
    design.addMove(2, 0, [5], 0);
    design.addMove(2, 0, [2], 0);
    design.addMove(2, 0, [0], 0);

    design.addPiece("C6", 3, 6);
    design.addMove(3, 0, [6], 0);
    design.addMove(3, 0, [5], 0);
    design.addMove(3, 0, [2], 0);
    design.addMove(3, 0, [0], 0);

    design.addPiece("C8", 4, 8);
    design.addMove(4, 0, [6], 0);
    design.addMove(4, 0, [5], 0);
    design.addMove(4, 0, [2], 0);
    design.addMove(4, 0, [0], 0);

    design.addPiece("C16", 5, 16);
    design.addMove(5, 0, [6], 0);
    design.addMove(5, 0, [5], 0);
    design.addMove(5, 0, [2], 0);
    design.addMove(5, 0, [0], 0);

    design.addPiece("C36", 6, 36);
    design.addMove(6, 0, [6], 0);
    design.addMove(6, 0, [5], 0);
    design.addMove(6, 0, [2], 0);
    design.addMove(6, 0, [0], 0);

    design.addPiece("C64", 7, 64);
    design.addMove(7, 0, [6], 0);
    design.addMove(7, 0, [5], 0);
    design.addMove(7, 0, [2], 0);
    design.addMove(7, 0, [0], 0);

    design.addPiece("C3", 8, 3);
    design.addMove(8, 0, [6], 0);
    design.addMove(8, 0, [5], 0);
    design.addMove(8, 0, [2], 0);
    design.addMove(8, 0, [0], 0);

    design.addPiece("C5", 9, 5);
    design.addMove(9, 0, [6], 0);
    design.addMove(9, 0, [5], 0);
    design.addMove(9, 0, [2], 0);
    design.addMove(9, 0, [0], 0);

    design.addPiece("C7", 10, 7);
    design.addMove(10, 0, [6], 0);
    design.addMove(10, 0, [5], 0);
    design.addMove(10, 0, [2], 0);
    design.addMove(10, 0, [0], 0);

    design.addPiece("C9", 11, 9);
    design.addMove(11, 0, [6], 0);
    design.addMove(11, 0, [5], 0);
    design.addMove(11, 0, [2], 0);
    design.addMove(11, 0, [0], 0);

    design.addPiece("C25", 12, 25);
    design.addMove(12, 0, [6], 0);
    design.addMove(12, 0, [5], 0);
    design.addMove(12, 0, [2], 0);
    design.addMove(12, 0, [0], 0);

    design.addPiece("C49", 13, 49);
    design.addMove(13, 0, [6], 0);
    design.addMove(13, 0, [5], 0);
    design.addMove(13, 0, [2], 0);
    design.addMove(13, 0, [0], 0);

    design.addPiece("C81", 14, 81);
    design.addMove(14, 0, [6], 0);
    design.addMove(14, 0, [5], 0);
    design.addMove(14, 0, [2], 0);
    design.addMove(14, 0, [0], 0);

    design.addPiece("T6", 15, 6);
    design.addMove(15, 1, [7, 7], 1);
    design.addMove(15, 1, [3, 3], 1);
    design.addMove(15, 1, [4, 4], 1);
    design.addMove(15, 1, [1, 1], 1);
    design.addMove(15, 2, [7, 6], 1);
    design.addMove(15, 2, [7, 5], 1);
    design.addMove(15, 2, [1, 2], 1);
    design.addMove(15, 2, [1, 0], 1);
    design.addMove(15, 2, [4, 6], 1);
    design.addMove(15, 2, [4, 2], 1);
    design.addMove(15, 2, [3, 5], 1);
    design.addMove(15, 2, [3, 0], 1);

    design.addPiece("T9", 16, 9);
    design.addMove(16, 1, [7, 7], 1);
    design.addMove(16, 1, [3, 3], 1);
    design.addMove(16, 1, [4, 4], 1);
    design.addMove(16, 1, [1, 1], 1);
    design.addMove(16, 2, [7, 6], 1);
    design.addMove(16, 2, [7, 5], 1);
    design.addMove(16, 2, [1, 2], 1);
    design.addMove(16, 2, [1, 0], 1);
    design.addMove(16, 2, [4, 6], 1);
    design.addMove(16, 2, [4, 2], 1);
    design.addMove(16, 2, [3, 5], 1);
    design.addMove(16, 2, [3, 0], 1);

    design.addPiece("T16", 17, 16);
    design.addMove(17, 1, [7, 7], 1);
    design.addMove(17, 1, [3, 3], 1);
    design.addMove(17, 1, [4, 4], 1);
    design.addMove(17, 1, [1, 1], 1);
    design.addMove(17, 2, [7, 6], 1);
    design.addMove(17, 2, [7, 5], 1);
    design.addMove(17, 2, [1, 2], 1);
    design.addMove(17, 2, [1, 0], 1);
    design.addMove(17, 2, [4, 6], 1);
    design.addMove(17, 2, [4, 2], 1);
    design.addMove(17, 2, [3, 5], 1);
    design.addMove(17, 2, [3, 0], 1);

    design.addPiece("T20", 18, 20);
    design.addMove(18, 1, [7, 7], 1);
    design.addMove(18, 1, [3, 3], 1);
    design.addMove(18, 1, [4, 4], 1);
    design.addMove(18, 1, [1, 1], 1);
    design.addMove(18, 2, [7, 6], 1);
    design.addMove(18, 2, [7, 5], 1);
    design.addMove(18, 2, [1, 2], 1);
    design.addMove(18, 2, [1, 0], 1);
    design.addMove(18, 2, [4, 6], 1);
    design.addMove(18, 2, [4, 2], 1);
    design.addMove(18, 2, [3, 5], 1);
    design.addMove(18, 2, [3, 0], 1);

    design.addPiece("T25", 19, 25);
    design.addMove(19, 1, [7, 7], 1);
    design.addMove(19, 1, [3, 3], 1);
    design.addMove(19, 1, [4, 4], 1);
    design.addMove(19, 1, [1, 1], 1);
    design.addMove(19, 2, [7, 6], 1);
    design.addMove(19, 2, [7, 5], 1);
    design.addMove(19, 2, [1, 2], 1);
    design.addMove(19, 2, [1, 0], 1);
    design.addMove(19, 2, [4, 6], 1);
    design.addMove(19, 2, [4, 2], 1);
    design.addMove(19, 2, [3, 5], 1);
    design.addMove(19, 2, [3, 0], 1);

    design.addPiece("T42", 20, 42);
    design.addMove(20, 1, [7, 7], 1);
    design.addMove(20, 1, [3, 3], 1);
    design.addMove(20, 1, [4, 4], 1);
    design.addMove(20, 1, [1, 1], 1);
    design.addMove(20, 2, [7, 6], 1);
    design.addMove(20, 2, [7, 5], 1);
    design.addMove(20, 2, [1, 2], 1);
    design.addMove(20, 2, [1, 0], 1);
    design.addMove(20, 2, [4, 6], 1);
    design.addMove(20, 2, [4, 2], 1);
    design.addMove(20, 2, [3, 5], 1);
    design.addMove(20, 2, [3, 0], 1);

    design.addPiece("T49", 21, 49);
    design.addMove(21, 1, [7, 7], 1);
    design.addMove(21, 1, [3, 3], 1);
    design.addMove(21, 1, [4, 4], 1);
    design.addMove(21, 1, [1, 1], 1);
    design.addMove(21, 2, [7, 6], 1);
    design.addMove(21, 2, [7, 5], 1);
    design.addMove(21, 2, [1, 2], 1);
    design.addMove(21, 2, [1, 0], 1);
    design.addMove(21, 2, [4, 6], 1);
    design.addMove(21, 2, [4, 2], 1);
    design.addMove(21, 2, [3, 5], 1);
    design.addMove(21, 2, [3, 0], 1);

    design.addPiece("T72", 22, 72);
    design.addMove(22, 1, [7, 7], 1);
    design.addMove(22, 1, [3, 3], 1);
    design.addMove(22, 1, [4, 4], 1);
    design.addMove(22, 1, [1, 1], 1);
    design.addMove(22, 2, [7, 6], 1);
    design.addMove(22, 2, [7, 5], 1);
    design.addMove(22, 2, [1, 2], 1);
    design.addMove(22, 2, [1, 0], 1);
    design.addMove(22, 2, [4, 6], 1);
    design.addMove(22, 2, [4, 2], 1);
    design.addMove(22, 2, [3, 5], 1);
    design.addMove(22, 2, [3, 0], 1);

    design.addPiece("T81", 23, 81);
    design.addMove(23, 1, [7, 7], 1);
    design.addMove(23, 1, [3, 3], 1);
    design.addMove(23, 1, [4, 4], 1);
    design.addMove(23, 1, [1, 1], 1);
    design.addMove(23, 2, [7, 6], 1);
    design.addMove(23, 2, [7, 5], 1);
    design.addMove(23, 2, [1, 2], 1);
    design.addMove(23, 2, [1, 0], 1);
    design.addMove(23, 2, [4, 6], 1);
    design.addMove(23, 2, [4, 2], 1);
    design.addMove(23, 2, [3, 5], 1);
    design.addMove(23, 2, [3, 0], 1);

    design.addPiece("T12", 24, 12);
    design.addMove(24, 1, [7, 7], 1);
    design.addMove(24, 1, [3, 3], 1);
    design.addMove(24, 1, [4, 4], 1);
    design.addMove(24, 1, [1, 1], 1);
    design.addMove(24, 2, [7, 6], 1);
    design.addMove(24, 2, [7, 5], 1);
    design.addMove(24, 2, [1, 2], 1);
    design.addMove(24, 2, [1, 0], 1);
    design.addMove(24, 2, [4, 6], 1);
    design.addMove(24, 2, [4, 2], 1);
    design.addMove(24, 2, [3, 5], 1);
    design.addMove(24, 2, [3, 0], 1);

    design.addPiece("T16", 25, 16);
    design.addMove(25, 1, [7, 7], 1);
    design.addMove(25, 1, [3, 3], 1);
    design.addMove(25, 1, [4, 4], 1);
    design.addMove(25, 1, [1, 1], 1);
    design.addMove(25, 2, [7, 6], 1);
    design.addMove(25, 2, [7, 5], 1);
    design.addMove(25, 2, [1, 2], 1);
    design.addMove(25, 2, [1, 0], 1);
    design.addMove(25, 2, [4, 6], 1);
    design.addMove(25, 2, [4, 2], 1);
    design.addMove(25, 2, [3, 5], 1);
    design.addMove(25, 2, [3, 0], 1);

    design.addPiece("T30", 26, 30);
    design.addMove(26, 1, [7, 7], 1);
    design.addMove(26, 1, [3, 3], 1);
    design.addMove(26, 1, [4, 4], 1);
    design.addMove(26, 1, [1, 1], 1);
    design.addMove(26, 2, [7, 6], 1);
    design.addMove(26, 2, [7, 5], 1);
    design.addMove(26, 2, [1, 2], 1);
    design.addMove(26, 2, [1, 0], 1);
    design.addMove(26, 2, [4, 6], 1);
    design.addMove(26, 2, [4, 2], 1);
    design.addMove(26, 2, [3, 5], 1);
    design.addMove(26, 2, [3, 0], 1);

    design.addPiece("T36", 27, 36);
    design.addMove(27, 1, [7, 7], 1);
    design.addMove(27, 1, [3, 3], 1);
    design.addMove(27, 1, [4, 4], 1);
    design.addMove(27, 1, [1, 1], 1);
    design.addMove(27, 2, [7, 6], 1);
    design.addMove(27, 2, [7, 5], 1);
    design.addMove(27, 2, [1, 2], 1);
    design.addMove(27, 2, [1, 0], 1);
    design.addMove(27, 2, [4, 6], 1);
    design.addMove(27, 2, [4, 2], 1);
    design.addMove(27, 2, [3, 5], 1);
    design.addMove(27, 2, [3, 0], 1);

    design.addPiece("T56", 28, 56);
    design.addMove(28, 1, [7, 7], 1);
    design.addMove(28, 1, [3, 3], 1);
    design.addMove(28, 1, [4, 4], 1);
    design.addMove(28, 1, [1, 1], 1);
    design.addMove(28, 2, [7, 6], 1);
    design.addMove(28, 2, [7, 5], 1);
    design.addMove(28, 2, [1, 2], 1);
    design.addMove(28, 2, [1, 0], 1);
    design.addMove(28, 2, [4, 6], 1);
    design.addMove(28, 2, [4, 2], 1);
    design.addMove(28, 2, [3, 5], 1);
    design.addMove(28, 2, [3, 0], 1);

    design.addPiece("T64", 29, 64);
    design.addMove(29, 1, [7, 7], 1);
    design.addMove(29, 1, [3, 3], 1);
    design.addMove(29, 1, [4, 4], 1);
    design.addMove(29, 1, [1, 1], 1);
    design.addMove(29, 2, [7, 6], 1);
    design.addMove(29, 2, [7, 5], 1);
    design.addMove(29, 2, [1, 2], 1);
    design.addMove(29, 2, [1, 0], 1);
    design.addMove(29, 2, [4, 6], 1);
    design.addMove(29, 2, [4, 2], 1);
    design.addMove(29, 2, [3, 5], 1);
    design.addMove(29, 2, [3, 0], 1);

    design.addPiece("T90", 30, 90);
    design.addMove(30, 1, [7, 7], 1);
    design.addMove(30, 1, [3, 3], 1);
    design.addMove(30, 1, [4, 4], 1);
    design.addMove(30, 1, [1, 1], 1);
    design.addMove(30, 2, [7, 6], 1);
    design.addMove(30, 2, [7, 5], 1);
    design.addMove(30, 2, [1, 2], 1);
    design.addMove(30, 2, [1, 0], 1);
    design.addMove(30, 2, [4, 6], 1);
    design.addMove(30, 2, [4, 2], 1);
    design.addMove(30, 2, [3, 5], 1);
    design.addMove(30, 2, [3, 0], 1);

    design.addPiece("T100", 31, 100);
    design.addMove(31, 1, [7, 7], 1);
    design.addMove(31, 1, [3, 3], 1);
    design.addMove(31, 1, [4, 4], 1);
    design.addMove(31, 1, [1, 1], 1);
    design.addMove(31, 2, [7, 6], 1);
    design.addMove(31, 2, [7, 5], 1);
    design.addMove(31, 2, [1, 2], 1);
    design.addMove(31, 2, [1, 0], 1);
    design.addMove(31, 2, [4, 6], 1);
    design.addMove(31, 2, [4, 2], 1);
    design.addMove(31, 2, [3, 5], 1);
    design.addMove(31, 2, [3, 0], 1);

    design.addPiece("S15", 32, 15);
    design.addMove(32, 3, [7, 7, 7], 2);
    design.addMove(32, 3, [3, 3, 3], 2);
    design.addMove(32, 3, [4, 4, 4], 2);
    design.addMove(32, 3, [1, 1, 1], 2);
    design.addMove(32, 4, [7, 7, 6], 2);
    design.addMove(32, 4, [7, 7, 5], 2);
    design.addMove(32, 4, [1, 1, 2], 2);
    design.addMove(32, 4, [1, 1, 0], 2);
    design.addMove(32, 4, [4, 4, 6], 2);
    design.addMove(32, 4, [4, 4, 2], 2);
    design.addMove(32, 4, [3, 3, 5], 2);
    design.addMove(32, 4, [3, 3, 0], 2);

    design.addPiece("S25", 33, 25);
    design.addMove(33, 3, [7, 7, 7], 2);
    design.addMove(33, 3, [3, 3, 3], 2);
    design.addMove(33, 3, [4, 4, 4], 2);
    design.addMove(33, 3, [1, 1, 1], 2);
    design.addMove(33, 4, [7, 7, 6], 2);
    design.addMove(33, 4, [7, 7, 5], 2);
    design.addMove(33, 4, [1, 1, 2], 2);
    design.addMove(33, 4, [1, 1, 0], 2);
    design.addMove(33, 4, [4, 4, 6], 2);
    design.addMove(33, 4, [4, 4, 2], 2);
    design.addMove(33, 4, [3, 3, 5], 2);
    design.addMove(33, 4, [3, 3, 0], 2);

    design.addPiece("S36", 34, 36);
    design.addMove(34, 3, [7, 7, 7], 2);
    design.addMove(34, 3, [3, 3, 3], 2);
    design.addMove(34, 3, [4, 4, 4], 2);
    design.addMove(34, 3, [1, 1, 1], 2);
    design.addMove(34, 4, [7, 7, 6], 2);
    design.addMove(34, 4, [7, 7, 5], 2);
    design.addMove(34, 4, [1, 1, 2], 2);
    design.addMove(34, 4, [1, 1, 0], 2);
    design.addMove(34, 4, [4, 4, 6], 2);
    design.addMove(34, 4, [4, 4, 2], 2);
    design.addMove(34, 4, [3, 3, 5], 2);
    design.addMove(34, 4, [3, 3, 0], 2);

    design.addPiece("S45", 35, 45);
    design.addMove(35, 3, [7, 7, 7], 2);
    design.addMove(35, 3, [3, 3, 3], 2);
    design.addMove(35, 3, [4, 4, 4], 2);
    design.addMove(35, 3, [1, 1, 1], 2);
    design.addMove(35, 4, [7, 7, 6], 2);
    design.addMove(35, 4, [7, 7, 5], 2);
    design.addMove(35, 4, [1, 1, 2], 2);
    design.addMove(35, 4, [1, 1, 0], 2);
    design.addMove(35, 4, [4, 4, 6], 2);
    design.addMove(35, 4, [4, 4, 2], 2);
    design.addMove(35, 4, [3, 3, 5], 2);
    design.addMove(35, 4, [3, 3, 0], 2);

    design.addPiece("S81", 36, 81);
    design.addMove(36, 3, [7, 7, 7], 2);
    design.addMove(36, 3, [3, 3, 3], 2);
    design.addMove(36, 3, [4, 4, 4], 2);
    design.addMove(36, 3, [1, 1, 1], 2);
    design.addMove(36, 4, [7, 7, 6], 2);
    design.addMove(36, 4, [7, 7, 5], 2);
    design.addMove(36, 4, [1, 1, 2], 2);
    design.addMove(36, 4, [1, 1, 0], 2);
    design.addMove(36, 4, [4, 4, 6], 2);
    design.addMove(36, 4, [4, 4, 2], 2);
    design.addMove(36, 4, [3, 3, 5], 2);
    design.addMove(36, 4, [3, 3, 0], 2);

    design.addPiece("S153", 37, 153);
    design.addMove(37, 3, [7, 7, 7], 2);
    design.addMove(37, 3, [3, 3, 3], 2);
    design.addMove(37, 3, [4, 4, 4], 2);
    design.addMove(37, 3, [1, 1, 1], 2);
    design.addMove(37, 4, [7, 7, 6], 2);
    design.addMove(37, 4, [7, 7, 5], 2);
    design.addMove(37, 4, [1, 1, 2], 2);
    design.addMove(37, 4, [1, 1, 0], 2);
    design.addMove(37, 4, [4, 4, 6], 2);
    design.addMove(37, 4, [4, 4, 2], 2);
    design.addMove(37, 4, [3, 3, 5], 2);
    design.addMove(37, 4, [3, 3, 0], 2);

    design.addPiece("S169", 38, 169);
    design.addMove(38, 3, [7, 7, 7], 2);
    design.addMove(38, 3, [3, 3, 3], 2);
    design.addMove(38, 3, [4, 4, 4], 2);
    design.addMove(38, 3, [1, 1, 1], 2);
    design.addMove(38, 4, [7, 7, 6], 2);
    design.addMove(38, 4, [7, 7, 5], 2);
    design.addMove(38, 4, [1, 1, 2], 2);
    design.addMove(38, 4, [1, 1, 0], 2);
    design.addMove(38, 4, [4, 4, 6], 2);
    design.addMove(38, 4, [4, 4, 2], 2);
    design.addMove(38, 4, [3, 3, 5], 2);
    design.addMove(38, 4, [3, 3, 0], 2);

    design.addPiece("S289", 39, 289);
    design.addMove(39, 3, [7, 7, 7], 2);
    design.addMove(39, 3, [3, 3, 3], 2);
    design.addMove(39, 3, [4, 4, 4], 2);
    design.addMove(39, 3, [1, 1, 1], 2);
    design.addMove(39, 4, [7, 7, 6], 2);
    design.addMove(39, 4, [7, 7, 5], 2);
    design.addMove(39, 4, [1, 1, 2], 2);
    design.addMove(39, 4, [1, 1, 0], 2);
    design.addMove(39, 4, [4, 4, 6], 2);
    design.addMove(39, 4, [4, 4, 2], 2);
    design.addMove(39, 4, [3, 3, 5], 2);
    design.addMove(39, 4, [3, 3, 0], 2);

    design.addPiece("S28", 40, 28);
    design.addMove(40, 3, [7, 7, 7], 2);
    design.addMove(40, 3, [3, 3, 3], 2);
    design.addMove(40, 3, [4, 4, 4], 2);
    design.addMove(40, 3, [1, 1, 1], 2);
    design.addMove(40, 4, [7, 7, 6], 2);
    design.addMove(40, 4, [7, 7, 5], 2);
    design.addMove(40, 4, [1, 1, 2], 2);
    design.addMove(40, 4, [1, 1, 0], 2);
    design.addMove(40, 4, [4, 4, 6], 2);
    design.addMove(40, 4, [4, 4, 2], 2);
    design.addMove(40, 4, [3, 3, 5], 2);
    design.addMove(40, 4, [3, 3, 0], 2);

    design.addPiece("S49", 41, 49);
    design.addMove(41, 3, [7, 7, 7], 2);
    design.addMove(41, 3, [3, 3, 3], 2);
    design.addMove(41, 3, [4, 4, 4], 2);
    design.addMove(41, 3, [1, 1, 1], 2);
    design.addMove(41, 4, [7, 7, 6], 2);
    design.addMove(41, 4, [7, 7, 5], 2);
    design.addMove(41, 4, [1, 1, 2], 2);
    design.addMove(41, 4, [1, 1, 0], 2);
    design.addMove(41, 4, [4, 4, 6], 2);
    design.addMove(41, 4, [4, 4, 2], 2);
    design.addMove(41, 4, [3, 3, 5], 2);
    design.addMove(41, 4, [3, 3, 0], 2);

    design.addPiece("S64", 42, 64);
    design.addMove(42, 3, [7, 7, 7], 2);
    design.addMove(42, 3, [3, 3, 3], 2);
    design.addMove(42, 3, [4, 4, 4], 2);
    design.addMove(42, 3, [1, 1, 1], 2);
    design.addMove(42, 4, [7, 7, 6], 2);
    design.addMove(42, 4, [7, 7, 5], 2);
    design.addMove(42, 4, [1, 1, 2], 2);
    design.addMove(42, 4, [1, 1, 0], 2);
    design.addMove(42, 4, [4, 4, 6], 2);
    design.addMove(42, 4, [4, 4, 2], 2);
    design.addMove(42, 4, [3, 3, 5], 2);
    design.addMove(42, 4, [3, 3, 0], 2);

    design.addPiece("S66", 43, 66);
    design.addMove(43, 3, [7, 7, 7], 2);
    design.addMove(43, 3, [3, 3, 3], 2);
    design.addMove(43, 3, [4, 4, 4], 2);
    design.addMove(43, 3, [1, 1, 1], 2);
    design.addMove(43, 4, [7, 7, 6], 2);
    design.addMove(43, 4, [7, 7, 5], 2);
    design.addMove(43, 4, [1, 1, 2], 2);
    design.addMove(43, 4, [1, 1, 0], 2);
    design.addMove(43, 4, [4, 4, 6], 2);
    design.addMove(43, 4, [4, 4, 2], 2);
    design.addMove(43, 4, [3, 3, 5], 2);
    design.addMove(43, 4, [3, 3, 0], 2);

    design.addPiece("S120", 44, 120);
    design.addMove(44, 3, [7, 7, 7], 2);
    design.addMove(44, 3, [3, 3, 3], 2);
    design.addMove(44, 3, [4, 4, 4], 2);
    design.addMove(44, 3, [1, 1, 1], 2);
    design.addMove(44, 4, [7, 7, 6], 2);
    design.addMove(44, 4, [7, 7, 5], 2);
    design.addMove(44, 4, [1, 1, 2], 2);
    design.addMove(44, 4, [1, 1, 0], 2);
    design.addMove(44, 4, [4, 4, 6], 2);
    design.addMove(44, 4, [4, 4, 2], 2);
    design.addMove(44, 4, [3, 3, 5], 2);
    design.addMove(44, 4, [3, 3, 0], 2);

    design.addPiece("S121", 45, 121);
    design.addMove(45, 3, [7, 7, 7], 2);
    design.addMove(45, 3, [3, 3, 3], 2);
    design.addMove(45, 3, [4, 4, 4], 2);
    design.addMove(45, 3, [1, 1, 1], 2);
    design.addMove(45, 4, [7, 7, 6], 2);
    design.addMove(45, 4, [7, 7, 5], 2);
    design.addMove(45, 4, [1, 1, 2], 2);
    design.addMove(45, 4, [1, 1, 0], 2);
    design.addMove(45, 4, [4, 4, 6], 2);
    design.addMove(45, 4, [4, 4, 2], 2);
    design.addMove(45, 4, [3, 3, 5], 2);
    design.addMove(45, 4, [3, 3, 0], 2);

    design.addPiece("S225", 46, 225);
    design.addMove(46, 3, [7, 7, 7], 2);
    design.addMove(46, 3, [3, 3, 3], 2);
    design.addMove(46, 3, [4, 4, 4], 2);
    design.addMove(46, 3, [1, 1, 1], 2);
    design.addMove(46, 4, [7, 7, 6], 2);
    design.addMove(46, 4, [7, 7, 5], 2);
    design.addMove(46, 4, [1, 1, 2], 2);
    design.addMove(46, 4, [1, 1, 0], 2);
    design.addMove(46, 4, [4, 4, 6], 2);
    design.addMove(46, 4, [4, 4, 2], 2);
    design.addMove(46, 4, [3, 3, 5], 2);
    design.addMove(46, 4, [3, 3, 0], 2);

    design.addPiece("S361", 47, 361);
    design.addMove(47, 3, [7, 7, 7], 2);
    design.addMove(47, 3, [3, 3, 3], 2);
    design.addMove(47, 3, [4, 4, 4], 2);
    design.addMove(47, 3, [1, 1, 1], 2);
    design.addMove(47, 4, [7, 7, 6], 2);
    design.addMove(47, 4, [7, 7, 5], 2);
    design.addMove(47, 4, [1, 1, 2], 2);
    design.addMove(47, 4, [1, 1, 0], 2);
    design.addMove(47, 4, [4, 4, 6], 2);
    design.addMove(47, 4, [4, 4, 2], 2);
    design.addMove(47, 4, [3, 3, 5], 2);
    design.addMove(47, 4, [3, 3, 0], 2);

    design.addPiece("P5", 48, 5);
    design.addMove(48, 0, [6], 0);
    design.addMove(48, 0, [5], 0);
    design.addMove(48, 0, [2], 0);
    design.addMove(48, 0, [0], 0);
    design.addMove(48, 1, [7, 7], 1);
    design.addMove(48, 1, [3, 3], 1);
    design.addMove(48, 1, [4, 4], 1);
    design.addMove(48, 1, [1, 1], 1);
    design.addMove(48, 2, [7, 6], 1);
    design.addMove(48, 2, [7, 5], 1);
    design.addMove(48, 2, [1, 2], 1);
    design.addMove(48, 2, [1, 0], 1);
    design.addMove(48, 2, [4, 6], 1);
    design.addMove(48, 2, [4, 2], 1);
    design.addMove(48, 2, [3, 5], 1);
    design.addMove(48, 2, [3, 0], 1);
    design.addMove(48, 3, [7, 7, 7], 2);
    design.addMove(48, 3, [3, 3, 3], 2);
    design.addMove(48, 3, [4, 4, 4], 2);
    design.addMove(48, 3, [1, 1, 1], 2);
    design.addMove(48, 4, [7, 7, 6], 2);
    design.addMove(48, 4, [7, 7, 5], 2);
    design.addMove(48, 4, [1, 1, 2], 2);
    design.addMove(48, 4, [1, 1, 0], 2);
    design.addMove(48, 4, [4, 4, 6], 2);
    design.addMove(48, 4, [4, 4, 2], 2);
    design.addMove(48, 4, [3, 3, 5], 2);
    design.addMove(48, 4, [3, 3, 0], 2);

    design.addPiece("P10", 49, 10);
    design.addMove(49, 0, [6], 0);
    design.addMove(49, 0, [5], 0);
    design.addMove(49, 0, [2], 0);
    design.addMove(49, 0, [0], 0);
    design.addMove(49, 1, [7, 7], 1);
    design.addMove(49, 1, [3, 3], 1);
    design.addMove(49, 1, [4, 4], 1);
    design.addMove(49, 1, [1, 1], 1);
    design.addMove(49, 2, [7, 6], 1);
    design.addMove(49, 2, [7, 5], 1);
    design.addMove(49, 2, [1, 2], 1);
    design.addMove(49, 2, [1, 0], 1);
    design.addMove(49, 2, [4, 6], 1);
    design.addMove(49, 2, [4, 2], 1);
    design.addMove(49, 2, [3, 5], 1);
    design.addMove(49, 2, [3, 0], 1);
    design.addMove(49, 3, [7, 7, 7], 2);
    design.addMove(49, 3, [3, 3, 3], 2);
    design.addMove(49, 3, [4, 4, 4], 2);
    design.addMove(49, 3, [1, 1, 1], 2);
    design.addMove(49, 4, [7, 7, 6], 2);
    design.addMove(49, 4, [7, 7, 5], 2);
    design.addMove(49, 4, [1, 1, 2], 2);
    design.addMove(49, 4, [1, 1, 0], 2);
    design.addMove(49, 4, [4, 4, 6], 2);
    design.addMove(49, 4, [4, 4, 2], 2);
    design.addMove(49, 4, [3, 3, 5], 2);
    design.addMove(49, 4, [3, 3, 0], 2);

    design.addPiece("P13", 50, 13);
    design.addMove(50, 0, [6], 0);
    design.addMove(50, 0, [5], 0);
    design.addMove(50, 0, [2], 0);
    design.addMove(50, 0, [0], 0);
    design.addMove(50, 1, [7, 7], 1);
    design.addMove(50, 1, [3, 3], 1);
    design.addMove(50, 1, [4, 4], 1);
    design.addMove(50, 1, [1, 1], 1);
    design.addMove(50, 2, [7, 6], 1);
    design.addMove(50, 2, [7, 5], 1);
    design.addMove(50, 2, [1, 2], 1);
    design.addMove(50, 2, [1, 0], 1);
    design.addMove(50, 2, [4, 6], 1);
    design.addMove(50, 2, [4, 2], 1);
    design.addMove(50, 2, [3, 5], 1);
    design.addMove(50, 2, [3, 0], 1);
    design.addMove(50, 3, [7, 7, 7], 2);
    design.addMove(50, 3, [3, 3, 3], 2);
    design.addMove(50, 3, [4, 4, 4], 2);
    design.addMove(50, 3, [1, 1, 1], 2);
    design.addMove(50, 4, [7, 7, 6], 2);
    design.addMove(50, 4, [7, 7, 5], 2);
    design.addMove(50, 4, [1, 1, 2], 2);
    design.addMove(50, 4, [1, 1, 0], 2);
    design.addMove(50, 4, [4, 4, 6], 2);
    design.addMove(50, 4, [4, 4, 2], 2);
    design.addMove(50, 4, [3, 3, 5], 2);
    design.addMove(50, 4, [3, 3, 0], 2);

    design.addPiece("P14", 51, 14);
    design.addMove(51, 0, [6], 0);
    design.addMove(51, 0, [5], 0);
    design.addMove(51, 0, [2], 0);
    design.addMove(51, 0, [0], 0);
    design.addMove(51, 1, [7, 7], 1);
    design.addMove(51, 1, [3, 3], 1);
    design.addMove(51, 1, [4, 4], 1);
    design.addMove(51, 1, [1, 1], 1);
    design.addMove(51, 2, [7, 6], 1);
    design.addMove(51, 2, [7, 5], 1);
    design.addMove(51, 2, [1, 2], 1);
    design.addMove(51, 2, [1, 0], 1);
    design.addMove(51, 2, [4, 6], 1);
    design.addMove(51, 2, [4, 2], 1);
    design.addMove(51, 2, [3, 5], 1);
    design.addMove(51, 2, [3, 0], 1);
    design.addMove(51, 3, [7, 7, 7], 2);
    design.addMove(51, 3, [3, 3, 3], 2);
    design.addMove(51, 3, [4, 4, 4], 2);
    design.addMove(51, 3, [1, 1, 1], 2);
    design.addMove(51, 4, [7, 7, 6], 2);
    design.addMove(51, 4, [7, 7, 5], 2);
    design.addMove(51, 4, [1, 1, 2], 2);
    design.addMove(51, 4, [1, 1, 0], 2);
    design.addMove(51, 4, [4, 4, 6], 2);
    design.addMove(51, 4, [4, 4, 2], 2);
    design.addMove(51, 4, [3, 3, 5], 2);
    design.addMove(51, 4, [3, 3, 0], 2);

    design.addPiece("P17", 52, 17);
    design.addMove(52, 0, [6], 0);
    design.addMove(52, 0, [5], 0);
    design.addMove(52, 0, [2], 0);
    design.addMove(52, 0, [0], 0);
    design.addMove(52, 1, [7, 7], 1);
    design.addMove(52, 1, [3, 3], 1);
    design.addMove(52, 1, [4, 4], 1);
    design.addMove(52, 1, [1, 1], 1);
    design.addMove(52, 2, [7, 6], 1);
    design.addMove(52, 2, [7, 5], 1);
    design.addMove(52, 2, [1, 2], 1);
    design.addMove(52, 2, [1, 0], 1);
    design.addMove(52, 2, [4, 6], 1);
    design.addMove(52, 2, [4, 2], 1);
    design.addMove(52, 2, [3, 5], 1);
    design.addMove(52, 2, [3, 0], 1);
    design.addMove(52, 3, [7, 7, 7], 2);
    design.addMove(52, 3, [3, 3, 3], 2);
    design.addMove(52, 3, [4, 4, 4], 2);
    design.addMove(52, 3, [1, 1, 1], 2);
    design.addMove(52, 4, [7, 7, 6], 2);
    design.addMove(52, 4, [7, 7, 5], 2);
    design.addMove(52, 4, [1, 1, 2], 2);
    design.addMove(52, 4, [1, 1, 0], 2);
    design.addMove(52, 4, [4, 4, 6], 2);
    design.addMove(52, 4, [4, 4, 2], 2);
    design.addMove(52, 4, [3, 3, 5], 2);
    design.addMove(52, 4, [3, 3, 0], 2);

    design.addPiece("P20", 53, 20);
    design.addMove(53, 0, [6], 0);
    design.addMove(53, 0, [5], 0);
    design.addMove(53, 0, [2], 0);
    design.addMove(53, 0, [0], 0);
    design.addMove(53, 1, [7, 7], 1);
    design.addMove(53, 1, [3, 3], 1);
    design.addMove(53, 1, [4, 4], 1);
    design.addMove(53, 1, [1, 1], 1);
    design.addMove(53, 2, [7, 6], 1);
    design.addMove(53, 2, [7, 5], 1);
    design.addMove(53, 2, [1, 2], 1);
    design.addMove(53, 2, [1, 0], 1);
    design.addMove(53, 2, [4, 6], 1);
    design.addMove(53, 2, [4, 2], 1);
    design.addMove(53, 2, [3, 5], 1);
    design.addMove(53, 2, [3, 0], 1);
    design.addMove(53, 3, [7, 7, 7], 2);
    design.addMove(53, 3, [3, 3, 3], 2);
    design.addMove(53, 3, [4, 4, 4], 2);
    design.addMove(53, 3, [1, 1, 1], 2);
    design.addMove(53, 4, [7, 7, 6], 2);
    design.addMove(53, 4, [7, 7, 5], 2);
    design.addMove(53, 4, [1, 1, 2], 2);
    design.addMove(53, 4, [1, 1, 0], 2);
    design.addMove(53, 4, [4, 4, 6], 2);
    design.addMove(53, 4, [4, 4, 2], 2);
    design.addMove(53, 4, [3, 3, 5], 2);
    design.addMove(53, 4, [3, 3, 0], 2);

    design.addPiece("P21", 54, 21);
    design.addMove(54, 0, [6], 0);
    design.addMove(54, 0, [5], 0);
    design.addMove(54, 0, [2], 0);
    design.addMove(54, 0, [0], 0);
    design.addMove(54, 1, [7, 7], 1);
    design.addMove(54, 1, [3, 3], 1);
    design.addMove(54, 1, [4, 4], 1);
    design.addMove(54, 1, [1, 1], 1);
    design.addMove(54, 2, [7, 6], 1);
    design.addMove(54, 2, [7, 5], 1);
    design.addMove(54, 2, [1, 2], 1);
    design.addMove(54, 2, [1, 0], 1);
    design.addMove(54, 2, [4, 6], 1);
    design.addMove(54, 2, [4, 2], 1);
    design.addMove(54, 2, [3, 5], 1);
    design.addMove(54, 2, [3, 0], 1);
    design.addMove(54, 3, [7, 7, 7], 2);
    design.addMove(54, 3, [3, 3, 3], 2);
    design.addMove(54, 3, [4, 4, 4], 2);
    design.addMove(54, 3, [1, 1, 1], 2);
    design.addMove(54, 4, [7, 7, 6], 2);
    design.addMove(54, 4, [7, 7, 5], 2);
    design.addMove(54, 4, [1, 1, 2], 2);
    design.addMove(54, 4, [1, 1, 0], 2);
    design.addMove(54, 4, [4, 4, 6], 2);
    design.addMove(54, 4, [4, 4, 2], 2);
    design.addMove(54, 4, [3, 3, 5], 2);
    design.addMove(54, 4, [3, 3, 0], 2);

    design.addPiece("P25", 55, 25);
    design.addMove(55, 0, [6], 0);
    design.addMove(55, 0, [5], 0);
    design.addMove(55, 0, [2], 0);
    design.addMove(55, 0, [0], 0);
    design.addMove(55, 1, [7, 7], 1);
    design.addMove(55, 1, [3, 3], 1);
    design.addMove(55, 1, [4, 4], 1);
    design.addMove(55, 1, [1, 1], 1);
    design.addMove(55, 2, [7, 6], 1);
    design.addMove(55, 2, [7, 5], 1);
    design.addMove(55, 2, [1, 2], 1);
    design.addMove(55, 2, [1, 0], 1);
    design.addMove(55, 2, [4, 6], 1);
    design.addMove(55, 2, [4, 2], 1);
    design.addMove(55, 2, [3, 5], 1);
    design.addMove(55, 2, [3, 0], 1);
    design.addMove(55, 3, [7, 7, 7], 2);
    design.addMove(55, 3, [3, 3, 3], 2);
    design.addMove(55, 3, [4, 4, 4], 2);
    design.addMove(55, 3, [1, 1, 1], 2);
    design.addMove(55, 4, [7, 7, 6], 2);
    design.addMove(55, 4, [7, 7, 5], 2);
    design.addMove(55, 4, [1, 1, 2], 2);
    design.addMove(55, 4, [1, 1, 0], 2);
    design.addMove(55, 4, [4, 4, 6], 2);
    design.addMove(55, 4, [4, 4, 2], 2);
    design.addMove(55, 4, [3, 3, 5], 2);
    design.addMove(55, 4, [3, 3, 0], 2);

    design.addPiece("P26", 56, 26);
    design.addMove(56, 0, [6], 0);
    design.addMove(56, 0, [5], 0);
    design.addMove(56, 0, [2], 0);
    design.addMove(56, 0, [0], 0);
    design.addMove(56, 1, [7, 7], 1);
    design.addMove(56, 1, [3, 3], 1);
    design.addMove(56, 1, [4, 4], 1);
    design.addMove(56, 1, [1, 1], 1);
    design.addMove(56, 2, [7, 6], 1);
    design.addMove(56, 2, [7, 5], 1);
    design.addMove(56, 2, [1, 2], 1);
    design.addMove(56, 2, [1, 0], 1);
    design.addMove(56, 2, [4, 6], 1);
    design.addMove(56, 2, [4, 2], 1);
    design.addMove(56, 2, [3, 5], 1);
    design.addMove(56, 2, [3, 0], 1);
    design.addMove(56, 3, [7, 7, 7], 2);
    design.addMove(56, 3, [3, 3, 3], 2);
    design.addMove(56, 3, [4, 4, 4], 2);
    design.addMove(56, 3, [1, 1, 1], 2);
    design.addMove(56, 4, [7, 7, 6], 2);
    design.addMove(56, 4, [7, 7, 5], 2);
    design.addMove(56, 4, [1, 1, 2], 2);
    design.addMove(56, 4, [1, 1, 0], 2);
    design.addMove(56, 4, [4, 4, 6], 2);
    design.addMove(56, 4, [4, 4, 2], 2);
    design.addMove(56, 4, [3, 3, 5], 2);
    design.addMove(56, 4, [3, 3, 0], 2);

    design.addPiece("P29", 57, 29);
    design.addMove(57, 0, [6], 0);
    design.addMove(57, 0, [5], 0);
    design.addMove(57, 0, [2], 0);
    design.addMove(57, 0, [0], 0);
    design.addMove(57, 1, [7, 7], 1);
    design.addMove(57, 1, [3, 3], 1);
    design.addMove(57, 1, [4, 4], 1);
    design.addMove(57, 1, [1, 1], 1);
    design.addMove(57, 2, [7, 6], 1);
    design.addMove(57, 2, [7, 5], 1);
    design.addMove(57, 2, [1, 2], 1);
    design.addMove(57, 2, [1, 0], 1);
    design.addMove(57, 2, [4, 6], 1);
    design.addMove(57, 2, [4, 2], 1);
    design.addMove(57, 2, [3, 5], 1);
    design.addMove(57, 2, [3, 0], 1);
    design.addMove(57, 3, [7, 7, 7], 2);
    design.addMove(57, 3, [3, 3, 3], 2);
    design.addMove(57, 3, [4, 4, 4], 2);
    design.addMove(57, 3, [1, 1, 1], 2);
    design.addMove(57, 4, [7, 7, 6], 2);
    design.addMove(57, 4, [7, 7, 5], 2);
    design.addMove(57, 4, [1, 1, 2], 2);
    design.addMove(57, 4, [1, 1, 0], 2);
    design.addMove(57, 4, [4, 4, 6], 2);
    design.addMove(57, 4, [4, 4, 2], 2);
    design.addMove(57, 4, [3, 3, 5], 2);
    design.addMove(57, 4, [3, 3, 0], 2);

    design.addPiece("P30", 58, 30);
    design.addMove(58, 0, [6], 0);
    design.addMove(58, 0, [5], 0);
    design.addMove(58, 0, [2], 0);
    design.addMove(58, 0, [0], 0);
    design.addMove(58, 1, [7, 7], 1);
    design.addMove(58, 1, [3, 3], 1);
    design.addMove(58, 1, [4, 4], 1);
    design.addMove(58, 1, [1, 1], 1);
    design.addMove(58, 2, [7, 6], 1);
    design.addMove(58, 2, [7, 5], 1);
    design.addMove(58, 2, [1, 2], 1);
    design.addMove(58, 2, [1, 0], 1);
    design.addMove(58, 2, [4, 6], 1);
    design.addMove(58, 2, [4, 2], 1);
    design.addMove(58, 2, [3, 5], 1);
    design.addMove(58, 2, [3, 0], 1);
    design.addMove(58, 3, [7, 7, 7], 2);
    design.addMove(58, 3, [3, 3, 3], 2);
    design.addMove(58, 3, [4, 4, 4], 2);
    design.addMove(58, 3, [1, 1, 1], 2);
    design.addMove(58, 4, [7, 7, 6], 2);
    design.addMove(58, 4, [7, 7, 5], 2);
    design.addMove(58, 4, [1, 1, 2], 2);
    design.addMove(58, 4, [1, 1, 0], 2);
    design.addMove(58, 4, [4, 4, 6], 2);
    design.addMove(58, 4, [4, 4, 2], 2);
    design.addMove(58, 4, [3, 3, 5], 2);
    design.addMove(58, 4, [3, 3, 0], 2);

    design.addPiece("P34", 59, 34);
    design.addMove(59, 0, [6], 0);
    design.addMove(59, 0, [5], 0);
    design.addMove(59, 0, [2], 0);
    design.addMove(59, 0, [0], 0);
    design.addMove(59, 1, [7, 7], 1);
    design.addMove(59, 1, [3, 3], 1);
    design.addMove(59, 1, [4, 4], 1);
    design.addMove(59, 1, [1, 1], 1);
    design.addMove(59, 2, [7, 6], 1);
    design.addMove(59, 2, [7, 5], 1);
    design.addMove(59, 2, [1, 2], 1);
    design.addMove(59, 2, [1, 0], 1);
    design.addMove(59, 2, [4, 6], 1);
    design.addMove(59, 2, [4, 2], 1);
    design.addMove(59, 2, [3, 5], 1);
    design.addMove(59, 2, [3, 0], 1);
    design.addMove(59, 3, [7, 7, 7], 2);
    design.addMove(59, 3, [3, 3, 3], 2);
    design.addMove(59, 3, [4, 4, 4], 2);
    design.addMove(59, 3, [1, 1, 1], 2);
    design.addMove(59, 4, [7, 7, 6], 2);
    design.addMove(59, 4, [7, 7, 5], 2);
    design.addMove(59, 4, [1, 1, 2], 2);
    design.addMove(59, 4, [1, 1, 0], 2);
    design.addMove(59, 4, [4, 4, 6], 2);
    design.addMove(59, 4, [4, 4, 2], 2);
    design.addMove(59, 4, [3, 3, 5], 2);
    design.addMove(59, 4, [3, 3, 0], 2);

    design.addPiece("P35", 60, 35);
    design.addMove(60, 0, [6], 0);
    design.addMove(60, 0, [5], 0);
    design.addMove(60, 0, [2], 0);
    design.addMove(60, 0, [0], 0);
    design.addMove(60, 1, [7, 7], 1);
    design.addMove(60, 1, [3, 3], 1);
    design.addMove(60, 1, [4, 4], 1);
    design.addMove(60, 1, [1, 1], 1);
    design.addMove(60, 2, [7, 6], 1);
    design.addMove(60, 2, [7, 5], 1);
    design.addMove(60, 2, [1, 2], 1);
    design.addMove(60, 2, [1, 0], 1);
    design.addMove(60, 2, [4, 6], 1);
    design.addMove(60, 2, [4, 2], 1);
    design.addMove(60, 2, [3, 5], 1);
    design.addMove(60, 2, [3, 0], 1);
    design.addMove(60, 3, [7, 7, 7], 2);
    design.addMove(60, 3, [3, 3, 3], 2);
    design.addMove(60, 3, [4, 4, 4], 2);
    design.addMove(60, 3, [1, 1, 1], 2);
    design.addMove(60, 4, [7, 7, 6], 2);
    design.addMove(60, 4, [7, 7, 5], 2);
    design.addMove(60, 4, [1, 1, 2], 2);
    design.addMove(60, 4, [1, 1, 0], 2);
    design.addMove(60, 4, [4, 4, 6], 2);
    design.addMove(60, 4, [4, 4, 2], 2);
    design.addMove(60, 4, [3, 3, 5], 2);
    design.addMove(60, 4, [3, 3, 0], 2);

    design.addPiece("P37", 61, 37);
    design.addMove(61, 0, [6], 0);
    design.addMove(61, 0, [5], 0);
    design.addMove(61, 0, [2], 0);
    design.addMove(61, 0, [0], 0);
    design.addMove(61, 1, [7, 7], 1);
    design.addMove(61, 1, [3, 3], 1);
    design.addMove(61, 1, [4, 4], 1);
    design.addMove(61, 1, [1, 1], 1);
    design.addMove(61, 2, [7, 6], 1);
    design.addMove(61, 2, [7, 5], 1);
    design.addMove(61, 2, [1, 2], 1);
    design.addMove(61, 2, [1, 0], 1);
    design.addMove(61, 2, [4, 6], 1);
    design.addMove(61, 2, [4, 2], 1);
    design.addMove(61, 2, [3, 5], 1);
    design.addMove(61, 2, [3, 0], 1);
    design.addMove(61, 3, [7, 7, 7], 2);
    design.addMove(61, 3, [3, 3, 3], 2);
    design.addMove(61, 3, [4, 4, 4], 2);
    design.addMove(61, 3, [1, 1, 1], 2);
    design.addMove(61, 4, [7, 7, 6], 2);
    design.addMove(61, 4, [7, 7, 5], 2);
    design.addMove(61, 4, [1, 1, 2], 2);
    design.addMove(61, 4, [1, 1, 0], 2);
    design.addMove(61, 4, [4, 4, 6], 2);
    design.addMove(61, 4, [4, 4, 2], 2);
    design.addMove(61, 4, [3, 3, 5], 2);
    design.addMove(61, 4, [3, 3, 0], 2);

    design.addPiece("P38", 62, 38);
    design.addMove(62, 0, [6], 0);
    design.addMove(62, 0, [5], 0);
    design.addMove(62, 0, [2], 0);
    design.addMove(62, 0, [0], 0);
    design.addMove(62, 1, [7, 7], 1);
    design.addMove(62, 1, [3, 3], 1);
    design.addMove(62, 1, [4, 4], 1);
    design.addMove(62, 1, [1, 1], 1);
    design.addMove(62, 2, [7, 6], 1);
    design.addMove(62, 2, [7, 5], 1);
    design.addMove(62, 2, [1, 2], 1);
    design.addMove(62, 2, [1, 0], 1);
    design.addMove(62, 2, [4, 6], 1);
    design.addMove(62, 2, [4, 2], 1);
    design.addMove(62, 2, [3, 5], 1);
    design.addMove(62, 2, [3, 0], 1);
    design.addMove(62, 3, [7, 7, 7], 2);
    design.addMove(62, 3, [3, 3, 3], 2);
    design.addMove(62, 3, [4, 4, 4], 2);
    design.addMove(62, 3, [1, 1, 1], 2);
    design.addMove(62, 4, [7, 7, 6], 2);
    design.addMove(62, 4, [7, 7, 5], 2);
    design.addMove(62, 4, [1, 1, 2], 2);
    design.addMove(62, 4, [1, 1, 0], 2);
    design.addMove(62, 4, [4, 4, 6], 2);
    design.addMove(62, 4, [4, 4, 2], 2);
    design.addMove(62, 4, [3, 3, 5], 2);
    design.addMove(62, 4, [3, 3, 0], 2);

    design.addPiece("P39", 63, 39);
    design.addMove(63, 0, [6], 0);
    design.addMove(63, 0, [5], 0);
    design.addMove(63, 0, [2], 0);
    design.addMove(63, 0, [0], 0);
    design.addMove(63, 1, [7, 7], 1);
    design.addMove(63, 1, [3, 3], 1);
    design.addMove(63, 1, [4, 4], 1);
    design.addMove(63, 1, [1, 1], 1);
    design.addMove(63, 2, [7, 6], 1);
    design.addMove(63, 2, [7, 5], 1);
    design.addMove(63, 2, [1, 2], 1);
    design.addMove(63, 2, [1, 0], 1);
    design.addMove(63, 2, [4, 6], 1);
    design.addMove(63, 2, [4, 2], 1);
    design.addMove(63, 2, [3, 5], 1);
    design.addMove(63, 2, [3, 0], 1);
    design.addMove(63, 3, [7, 7, 7], 2);
    design.addMove(63, 3, [3, 3, 3], 2);
    design.addMove(63, 3, [4, 4, 4], 2);
    design.addMove(63, 3, [1, 1, 1], 2);
    design.addMove(63, 4, [7, 7, 6], 2);
    design.addMove(63, 4, [7, 7, 5], 2);
    design.addMove(63, 4, [1, 1, 2], 2);
    design.addMove(63, 4, [1, 1, 0], 2);
    design.addMove(63, 4, [4, 4, 6], 2);
    design.addMove(63, 4, [4, 4, 2], 2);
    design.addMove(63, 4, [3, 3, 5], 2);
    design.addMove(63, 4, [3, 3, 0], 2);

    design.addPiece("P40", 64, 40);
    design.addMove(64, 0, [6], 0);
    design.addMove(64, 0, [5], 0);
    design.addMove(64, 0, [2], 0);
    design.addMove(64, 0, [0], 0);
    design.addMove(64, 1, [7, 7], 1);
    design.addMove(64, 1, [3, 3], 1);
    design.addMove(64, 1, [4, 4], 1);
    design.addMove(64, 1, [1, 1], 1);
    design.addMove(64, 2, [7, 6], 1);
    design.addMove(64, 2, [7, 5], 1);
    design.addMove(64, 2, [1, 2], 1);
    design.addMove(64, 2, [1, 0], 1);
    design.addMove(64, 2, [4, 6], 1);
    design.addMove(64, 2, [4, 2], 1);
    design.addMove(64, 2, [3, 5], 1);
    design.addMove(64, 2, [3, 0], 1);
    design.addMove(64, 3, [7, 7, 7], 2);
    design.addMove(64, 3, [3, 3, 3], 2);
    design.addMove(64, 3, [4, 4, 4], 2);
    design.addMove(64, 3, [1, 1, 1], 2);
    design.addMove(64, 4, [7, 7, 6], 2);
    design.addMove(64, 4, [7, 7, 5], 2);
    design.addMove(64, 4, [1, 1, 2], 2);
    design.addMove(64, 4, [1, 1, 0], 2);
    design.addMove(64, 4, [4, 4, 6], 2);
    design.addMove(64, 4, [4, 4, 2], 2);
    design.addMove(64, 4, [3, 3, 5], 2);
    design.addMove(64, 4, [3, 3, 0], 2);

    design.addPiece("P41", 65, 41);
    design.addMove(65, 0, [6], 0);
    design.addMove(65, 0, [5], 0);
    design.addMove(65, 0, [2], 0);
    design.addMove(65, 0, [0], 0);
    design.addMove(65, 1, [7, 7], 1);
    design.addMove(65, 1, [3, 3], 1);
    design.addMove(65, 1, [4, 4], 1);
    design.addMove(65, 1, [1, 1], 1);
    design.addMove(65, 2, [7, 6], 1);
    design.addMove(65, 2, [7, 5], 1);
    design.addMove(65, 2, [1, 2], 1);
    design.addMove(65, 2, [1, 0], 1);
    design.addMove(65, 2, [4, 6], 1);
    design.addMove(65, 2, [4, 2], 1);
    design.addMove(65, 2, [3, 5], 1);
    design.addMove(65, 2, [3, 0], 1);
    design.addMove(65, 3, [7, 7, 7], 2);
    design.addMove(65, 3, [3, 3, 3], 2);
    design.addMove(65, 3, [4, 4, 4], 2);
    design.addMove(65, 3, [1, 1, 1], 2);
    design.addMove(65, 4, [7, 7, 6], 2);
    design.addMove(65, 4, [7, 7, 5], 2);
    design.addMove(65, 4, [1, 1, 2], 2);
    design.addMove(65, 4, [1, 1, 0], 2);
    design.addMove(65, 4, [4, 4, 6], 2);
    design.addMove(65, 4, [4, 4, 2], 2);
    design.addMove(65, 4, [3, 3, 5], 2);
    design.addMove(65, 4, [3, 3, 0], 2);

    design.addPiece("P42", 66, 42);
    design.addMove(66, 0, [6], 0);
    design.addMove(66, 0, [5], 0);
    design.addMove(66, 0, [2], 0);
    design.addMove(66, 0, [0], 0);
    design.addMove(66, 1, [7, 7], 1);
    design.addMove(66, 1, [3, 3], 1);
    design.addMove(66, 1, [4, 4], 1);
    design.addMove(66, 1, [1, 1], 1);
    design.addMove(66, 2, [7, 6], 1);
    design.addMove(66, 2, [7, 5], 1);
    design.addMove(66, 2, [1, 2], 1);
    design.addMove(66, 2, [1, 0], 1);
    design.addMove(66, 2, [4, 6], 1);
    design.addMove(66, 2, [4, 2], 1);
    design.addMove(66, 2, [3, 5], 1);
    design.addMove(66, 2, [3, 0], 1);
    design.addMove(66, 3, [7, 7, 7], 2);
    design.addMove(66, 3, [3, 3, 3], 2);
    design.addMove(66, 3, [4, 4, 4], 2);
    design.addMove(66, 3, [1, 1, 1], 2);
    design.addMove(66, 4, [7, 7, 6], 2);
    design.addMove(66, 4, [7, 7, 5], 2);
    design.addMove(66, 4, [1, 1, 2], 2);
    design.addMove(66, 4, [1, 1, 0], 2);
    design.addMove(66, 4, [4, 4, 6], 2);
    design.addMove(66, 4, [4, 4, 2], 2);
    design.addMove(66, 4, [3, 3, 5], 2);
    design.addMove(66, 4, [3, 3, 0], 2);

    design.addPiece("P45", 67, 45);
    design.addMove(67, 0, [6], 0);
    design.addMove(67, 0, [5], 0);
    design.addMove(67, 0, [2], 0);
    design.addMove(67, 0, [0], 0);
    design.addMove(67, 1, [7, 7], 1);
    design.addMove(67, 1, [3, 3], 1);
    design.addMove(67, 1, [4, 4], 1);
    design.addMove(67, 1, [1, 1], 1);
    design.addMove(67, 2, [7, 6], 1);
    design.addMove(67, 2, [7, 5], 1);
    design.addMove(67, 2, [1, 2], 1);
    design.addMove(67, 2, [1, 0], 1);
    design.addMove(67, 2, [4, 6], 1);
    design.addMove(67, 2, [4, 2], 1);
    design.addMove(67, 2, [3, 5], 1);
    design.addMove(67, 2, [3, 0], 1);
    design.addMove(67, 3, [7, 7, 7], 2);
    design.addMove(67, 3, [3, 3, 3], 2);
    design.addMove(67, 3, [4, 4, 4], 2);
    design.addMove(67, 3, [1, 1, 1], 2);
    design.addMove(67, 4, [7, 7, 6], 2);
    design.addMove(67, 4, [7, 7, 5], 2);
    design.addMove(67, 4, [1, 1, 2], 2);
    design.addMove(67, 4, [1, 1, 0], 2);
    design.addMove(67, 4, [4, 4, 6], 2);
    design.addMove(67, 4, [4, 4, 2], 2);
    design.addMove(67, 4, [3, 3, 5], 2);
    design.addMove(67, 4, [3, 3, 0], 2);

    design.addPiece("P46", 68, 46);
    design.addMove(68, 0, [6], 0);
    design.addMove(68, 0, [5], 0);
    design.addMove(68, 0, [2], 0);
    design.addMove(68, 0, [0], 0);
    design.addMove(68, 1, [7, 7], 1);
    design.addMove(68, 1, [3, 3], 1);
    design.addMove(68, 1, [4, 4], 1);
    design.addMove(68, 1, [1, 1], 1);
    design.addMove(68, 2, [7, 6], 1);
    design.addMove(68, 2, [7, 5], 1);
    design.addMove(68, 2, [1, 2], 1);
    design.addMove(68, 2, [1, 0], 1);
    design.addMove(68, 2, [4, 6], 1);
    design.addMove(68, 2, [4, 2], 1);
    design.addMove(68, 2, [3, 5], 1);
    design.addMove(68, 2, [3, 0], 1);
    design.addMove(68, 3, [7, 7, 7], 2);
    design.addMove(68, 3, [3, 3, 3], 2);
    design.addMove(68, 3, [4, 4, 4], 2);
    design.addMove(68, 3, [1, 1, 1], 2);
    design.addMove(68, 4, [7, 7, 6], 2);
    design.addMove(68, 4, [7, 7, 5], 2);
    design.addMove(68, 4, [1, 1, 2], 2);
    design.addMove(68, 4, [1, 1, 0], 2);
    design.addMove(68, 4, [4, 4, 6], 2);
    design.addMove(68, 4, [4, 4, 2], 2);
    design.addMove(68, 4, [3, 3, 5], 2);
    design.addMove(68, 4, [3, 3, 0], 2);

    design.addPiece("P49", 69, 49);
    design.addMove(69, 0, [6], 0);
    design.addMove(69, 0, [5], 0);
    design.addMove(69, 0, [2], 0);
    design.addMove(69, 0, [0], 0);
    design.addMove(69, 1, [7, 7], 1);
    design.addMove(69, 1, [3, 3], 1);
    design.addMove(69, 1, [4, 4], 1);
    design.addMove(69, 1, [1, 1], 1);
    design.addMove(69, 2, [7, 6], 1);
    design.addMove(69, 2, [7, 5], 1);
    design.addMove(69, 2, [1, 2], 1);
    design.addMove(69, 2, [1, 0], 1);
    design.addMove(69, 2, [4, 6], 1);
    design.addMove(69, 2, [4, 2], 1);
    design.addMove(69, 2, [3, 5], 1);
    design.addMove(69, 2, [3, 0], 1);
    design.addMove(69, 3, [7, 7, 7], 2);
    design.addMove(69, 3, [3, 3, 3], 2);
    design.addMove(69, 3, [4, 4, 4], 2);
    design.addMove(69, 3, [1, 1, 1], 2);
    design.addMove(69, 4, [7, 7, 6], 2);
    design.addMove(69, 4, [7, 7, 5], 2);
    design.addMove(69, 4, [1, 1, 2], 2);
    design.addMove(69, 4, [1, 1, 0], 2);
    design.addMove(69, 4, [4, 4, 6], 2);
    design.addMove(69, 4, [4, 4, 2], 2);
    design.addMove(69, 4, [3, 3, 5], 2);
    design.addMove(69, 4, [3, 3, 0], 2);

    design.addPiece("P50", 70, 50);
    design.addMove(70, 0, [6], 0);
    design.addMove(70, 0, [5], 0);
    design.addMove(70, 0, [2], 0);
    design.addMove(70, 0, [0], 0);
    design.addMove(70, 1, [7, 7], 1);
    design.addMove(70, 1, [3, 3], 1);
    design.addMove(70, 1, [4, 4], 1);
    design.addMove(70, 1, [1, 1], 1);
    design.addMove(70, 2, [7, 6], 1);
    design.addMove(70, 2, [7, 5], 1);
    design.addMove(70, 2, [1, 2], 1);
    design.addMove(70, 2, [1, 0], 1);
    design.addMove(70, 2, [4, 6], 1);
    design.addMove(70, 2, [4, 2], 1);
    design.addMove(70, 2, [3, 5], 1);
    design.addMove(70, 2, [3, 0], 1);
    design.addMove(70, 3, [7, 7, 7], 2);
    design.addMove(70, 3, [3, 3, 3], 2);
    design.addMove(70, 3, [4, 4, 4], 2);
    design.addMove(70, 3, [1, 1, 1], 2);
    design.addMove(70, 4, [7, 7, 6], 2);
    design.addMove(70, 4, [7, 7, 5], 2);
    design.addMove(70, 4, [1, 1, 2], 2);
    design.addMove(70, 4, [1, 1, 0], 2);
    design.addMove(70, 4, [4, 4, 6], 2);
    design.addMove(70, 4, [4, 4, 2], 2);
    design.addMove(70, 4, [3, 3, 5], 2);
    design.addMove(70, 4, [3, 3, 0], 2);

    design.addPiece("P51", 71, 51);
    design.addMove(71, 0, [6], 0);
    design.addMove(71, 0, [5], 0);
    design.addMove(71, 0, [2], 0);
    design.addMove(71, 0, [0], 0);
    design.addMove(71, 1, [7, 7], 1);
    design.addMove(71, 1, [3, 3], 1);
    design.addMove(71, 1, [4, 4], 1);
    design.addMove(71, 1, [1, 1], 1);
    design.addMove(71, 2, [7, 6], 1);
    design.addMove(71, 2, [7, 5], 1);
    design.addMove(71, 2, [1, 2], 1);
    design.addMove(71, 2, [1, 0], 1);
    design.addMove(71, 2, [4, 6], 1);
    design.addMove(71, 2, [4, 2], 1);
    design.addMove(71, 2, [3, 5], 1);
    design.addMove(71, 2, [3, 0], 1);
    design.addMove(71, 3, [7, 7, 7], 2);
    design.addMove(71, 3, [3, 3, 3], 2);
    design.addMove(71, 3, [4, 4, 4], 2);
    design.addMove(71, 3, [1, 1, 1], 2);
    design.addMove(71, 4, [7, 7, 6], 2);
    design.addMove(71, 4, [7, 7, 5], 2);
    design.addMove(71, 4, [1, 1, 2], 2);
    design.addMove(71, 4, [1, 1, 0], 2);
    design.addMove(71, 4, [4, 4, 6], 2);
    design.addMove(71, 4, [4, 4, 2], 2);
    design.addMove(71, 4, [3, 3, 5], 2);
    design.addMove(71, 4, [3, 3, 0], 2);

    design.addPiece("P52", 72, 52);
    design.addMove(72, 0, [6], 0);
    design.addMove(72, 0, [5], 0);
    design.addMove(72, 0, [2], 0);
    design.addMove(72, 0, [0], 0);
    design.addMove(72, 1, [7, 7], 1);
    design.addMove(72, 1, [3, 3], 1);
    design.addMove(72, 1, [4, 4], 1);
    design.addMove(72, 1, [1, 1], 1);
    design.addMove(72, 2, [7, 6], 1);
    design.addMove(72, 2, [7, 5], 1);
    design.addMove(72, 2, [1, 2], 1);
    design.addMove(72, 2, [1, 0], 1);
    design.addMove(72, 2, [4, 6], 1);
    design.addMove(72, 2, [4, 2], 1);
    design.addMove(72, 2, [3, 5], 1);
    design.addMove(72, 2, [3, 0], 1);
    design.addMove(72, 3, [7, 7, 7], 2);
    design.addMove(72, 3, [3, 3, 3], 2);
    design.addMove(72, 3, [4, 4, 4], 2);
    design.addMove(72, 3, [1, 1, 1], 2);
    design.addMove(72, 4, [7, 7, 6], 2);
    design.addMove(72, 4, [7, 7, 5], 2);
    design.addMove(72, 4, [1, 1, 2], 2);
    design.addMove(72, 4, [1, 1, 0], 2);
    design.addMove(72, 4, [4, 4, 6], 2);
    design.addMove(72, 4, [4, 4, 2], 2);
    design.addMove(72, 4, [3, 3, 5], 2);
    design.addMove(72, 4, [3, 3, 0], 2);

    design.addPiece("P53", 73, 53);
    design.addMove(73, 0, [6], 0);
    design.addMove(73, 0, [5], 0);
    design.addMove(73, 0, [2], 0);
    design.addMove(73, 0, [0], 0);
    design.addMove(73, 1, [7, 7], 1);
    design.addMove(73, 1, [3, 3], 1);
    design.addMove(73, 1, [4, 4], 1);
    design.addMove(73, 1, [1, 1], 1);
    design.addMove(73, 2, [7, 6], 1);
    design.addMove(73, 2, [7, 5], 1);
    design.addMove(73, 2, [1, 2], 1);
    design.addMove(73, 2, [1, 0], 1);
    design.addMove(73, 2, [4, 6], 1);
    design.addMove(73, 2, [4, 2], 1);
    design.addMove(73, 2, [3, 5], 1);
    design.addMove(73, 2, [3, 0], 1);
    design.addMove(73, 3, [7, 7, 7], 2);
    design.addMove(73, 3, [3, 3, 3], 2);
    design.addMove(73, 3, [4, 4, 4], 2);
    design.addMove(73, 3, [1, 1, 1], 2);
    design.addMove(73, 4, [7, 7, 6], 2);
    design.addMove(73, 4, [7, 7, 5], 2);
    design.addMove(73, 4, [1, 1, 2], 2);
    design.addMove(73, 4, [1, 1, 0], 2);
    design.addMove(73, 4, [4, 4, 6], 2);
    design.addMove(73, 4, [4, 4, 2], 2);
    design.addMove(73, 4, [3, 3, 5], 2);
    design.addMove(73, 4, [3, 3, 0], 2);

    design.addPiece("P54", 74, 54);
    design.addMove(74, 0, [6], 0);
    design.addMove(74, 0, [5], 0);
    design.addMove(74, 0, [2], 0);
    design.addMove(74, 0, [0], 0);
    design.addMove(74, 1, [7, 7], 1);
    design.addMove(74, 1, [3, 3], 1);
    design.addMove(74, 1, [4, 4], 1);
    design.addMove(74, 1, [1, 1], 1);
    design.addMove(74, 2, [7, 6], 1);
    design.addMove(74, 2, [7, 5], 1);
    design.addMove(74, 2, [1, 2], 1);
    design.addMove(74, 2, [1, 0], 1);
    design.addMove(74, 2, [4, 6], 1);
    design.addMove(74, 2, [4, 2], 1);
    design.addMove(74, 2, [3, 5], 1);
    design.addMove(74, 2, [3, 0], 1);
    design.addMove(74, 3, [7, 7, 7], 2);
    design.addMove(74, 3, [3, 3, 3], 2);
    design.addMove(74, 3, [4, 4, 4], 2);
    design.addMove(74, 3, [1, 1, 1], 2);
    design.addMove(74, 4, [7, 7, 6], 2);
    design.addMove(74, 4, [7, 7, 5], 2);
    design.addMove(74, 4, [1, 1, 2], 2);
    design.addMove(74, 4, [1, 1, 0], 2);
    design.addMove(74, 4, [4, 4, 6], 2);
    design.addMove(74, 4, [4, 4, 2], 2);
    design.addMove(74, 4, [3, 3, 5], 2);
    design.addMove(74, 4, [3, 3, 0], 2);

    design.addPiece("P55", 75, 55);
    design.addMove(75, 0, [6], 0);
    design.addMove(75, 0, [5], 0);
    design.addMove(75, 0, [2], 0);
    design.addMove(75, 0, [0], 0);
    design.addMove(75, 1, [7, 7], 1);
    design.addMove(75, 1, [3, 3], 1);
    design.addMove(75, 1, [4, 4], 1);
    design.addMove(75, 1, [1, 1], 1);
    design.addMove(75, 2, [7, 6], 1);
    design.addMove(75, 2, [7, 5], 1);
    design.addMove(75, 2, [1, 2], 1);
    design.addMove(75, 2, [1, 0], 1);
    design.addMove(75, 2, [4, 6], 1);
    design.addMove(75, 2, [4, 2], 1);
    design.addMove(75, 2, [3, 5], 1);
    design.addMove(75, 2, [3, 0], 1);
    design.addMove(75, 3, [7, 7, 7], 2);
    design.addMove(75, 3, [3, 3, 3], 2);
    design.addMove(75, 3, [4, 4, 4], 2);
    design.addMove(75, 3, [1, 1, 1], 2);
    design.addMove(75, 4, [7, 7, 6], 2);
    design.addMove(75, 4, [7, 7, 5], 2);
    design.addMove(75, 4, [1, 1, 2], 2);
    design.addMove(75, 4, [1, 1, 0], 2);
    design.addMove(75, 4, [4, 4, 6], 2);
    design.addMove(75, 4, [4, 4, 2], 2);
    design.addMove(75, 4, [3, 3, 5], 2);
    design.addMove(75, 4, [3, 3, 0], 2);

    design.addPiece("P56", 76, 56);
    design.addMove(76, 0, [6], 0);
    design.addMove(76, 0, [5], 0);
    design.addMove(76, 0, [2], 0);
    design.addMove(76, 0, [0], 0);
    design.addMove(76, 1, [7, 7], 1);
    design.addMove(76, 1, [3, 3], 1);
    design.addMove(76, 1, [4, 4], 1);
    design.addMove(76, 1, [1, 1], 1);
    design.addMove(76, 2, [7, 6], 1);
    design.addMove(76, 2, [7, 5], 1);
    design.addMove(76, 2, [1, 2], 1);
    design.addMove(76, 2, [1, 0], 1);
    design.addMove(76, 2, [4, 6], 1);
    design.addMove(76, 2, [4, 2], 1);
    design.addMove(76, 2, [3, 5], 1);
    design.addMove(76, 2, [3, 0], 1);
    design.addMove(76, 3, [7, 7, 7], 2);
    design.addMove(76, 3, [3, 3, 3], 2);
    design.addMove(76, 3, [4, 4, 4], 2);
    design.addMove(76, 3, [1, 1, 1], 2);
    design.addMove(76, 4, [7, 7, 6], 2);
    design.addMove(76, 4, [7, 7, 5], 2);
    design.addMove(76, 4, [1, 1, 2], 2);
    design.addMove(76, 4, [1, 1, 0], 2);
    design.addMove(76, 4, [4, 4, 6], 2);
    design.addMove(76, 4, [4, 4, 2], 2);
    design.addMove(76, 4, [3, 3, 5], 2);
    design.addMove(76, 4, [3, 3, 0], 2);

    design.addPiece("P57", 77, 57);
    design.addMove(77, 0, [6], 0);
    design.addMove(77, 0, [5], 0);
    design.addMove(77, 0, [2], 0);
    design.addMove(77, 0, [0], 0);
    design.addMove(77, 1, [7, 7], 1);
    design.addMove(77, 1, [3, 3], 1);
    design.addMove(77, 1, [4, 4], 1);
    design.addMove(77, 1, [1, 1], 1);
    design.addMove(77, 2, [7, 6], 1);
    design.addMove(77, 2, [7, 5], 1);
    design.addMove(77, 2, [1, 2], 1);
    design.addMove(77, 2, [1, 0], 1);
    design.addMove(77, 2, [4, 6], 1);
    design.addMove(77, 2, [4, 2], 1);
    design.addMove(77, 2, [3, 5], 1);
    design.addMove(77, 2, [3, 0], 1);
    design.addMove(77, 3, [7, 7, 7], 2);
    design.addMove(77, 3, [3, 3, 3], 2);
    design.addMove(77, 3, [4, 4, 4], 2);
    design.addMove(77, 3, [1, 1, 1], 2);
    design.addMove(77, 4, [7, 7, 6], 2);
    design.addMove(77, 4, [7, 7, 5], 2);
    design.addMove(77, 4, [1, 1, 2], 2);
    design.addMove(77, 4, [1, 1, 0], 2);
    design.addMove(77, 4, [4, 4, 6], 2);
    design.addMove(77, 4, [4, 4, 2], 2);
    design.addMove(77, 4, [3, 3, 5], 2);
    design.addMove(77, 4, [3, 3, 0], 2);

    design.addPiece("P61", 78, 61);
    design.addMove(78, 0, [6], 0);
    design.addMove(78, 0, [5], 0);
    design.addMove(78, 0, [2], 0);
    design.addMove(78, 0, [0], 0);
    design.addMove(78, 1, [7, 7], 1);
    design.addMove(78, 1, [3, 3], 1);
    design.addMove(78, 1, [4, 4], 1);
    design.addMove(78, 1, [1, 1], 1);
    design.addMove(78, 2, [7, 6], 1);
    design.addMove(78, 2, [7, 5], 1);
    design.addMove(78, 2, [1, 2], 1);
    design.addMove(78, 2, [1, 0], 1);
    design.addMove(78, 2, [4, 6], 1);
    design.addMove(78, 2, [4, 2], 1);
    design.addMove(78, 2, [3, 5], 1);
    design.addMove(78, 2, [3, 0], 1);
    design.addMove(78, 3, [7, 7, 7], 2);
    design.addMove(78, 3, [3, 3, 3], 2);
    design.addMove(78, 3, [4, 4, 4], 2);
    design.addMove(78, 3, [1, 1, 1], 2);
    design.addMove(78, 4, [7, 7, 6], 2);
    design.addMove(78, 4, [7, 7, 5], 2);
    design.addMove(78, 4, [1, 1, 2], 2);
    design.addMove(78, 4, [1, 1, 0], 2);
    design.addMove(78, 4, [4, 4, 6], 2);
    design.addMove(78, 4, [4, 4, 2], 2);
    design.addMove(78, 4, [3, 3, 5], 2);
    design.addMove(78, 4, [3, 3, 0], 2);

    design.addPiece("P62", 79, 62);
    design.addMove(79, 0, [6], 0);
    design.addMove(79, 0, [5], 0);
    design.addMove(79, 0, [2], 0);
    design.addMove(79, 0, [0], 0);
    design.addMove(79, 1, [7, 7], 1);
    design.addMove(79, 1, [3, 3], 1);
    design.addMove(79, 1, [4, 4], 1);
    design.addMove(79, 1, [1, 1], 1);
    design.addMove(79, 2, [7, 6], 1);
    design.addMove(79, 2, [7, 5], 1);
    design.addMove(79, 2, [1, 2], 1);
    design.addMove(79, 2, [1, 0], 1);
    design.addMove(79, 2, [4, 6], 1);
    design.addMove(79, 2, [4, 2], 1);
    design.addMove(79, 2, [3, 5], 1);
    design.addMove(79, 2, [3, 0], 1);
    design.addMove(79, 3, [7, 7, 7], 2);
    design.addMove(79, 3, [3, 3, 3], 2);
    design.addMove(79, 3, [4, 4, 4], 2);
    design.addMove(79, 3, [1, 1, 1], 2);
    design.addMove(79, 4, [7, 7, 6], 2);
    design.addMove(79, 4, [7, 7, 5], 2);
    design.addMove(79, 4, [1, 1, 2], 2);
    design.addMove(79, 4, [1, 1, 0], 2);
    design.addMove(79, 4, [4, 4, 6], 2);
    design.addMove(79, 4, [4, 4, 2], 2);
    design.addMove(79, 4, [3, 3, 5], 2);
    design.addMove(79, 4, [3, 3, 0], 2);

    design.addPiece("P65", 80, 65);
    design.addMove(80, 0, [6], 0);
    design.addMove(80, 0, [5], 0);
    design.addMove(80, 0, [2], 0);
    design.addMove(80, 0, [0], 0);
    design.addMove(80, 1, [7, 7], 1);
    design.addMove(80, 1, [3, 3], 1);
    design.addMove(80, 1, [4, 4], 1);
    design.addMove(80, 1, [1, 1], 1);
    design.addMove(80, 2, [7, 6], 1);
    design.addMove(80, 2, [7, 5], 1);
    design.addMove(80, 2, [1, 2], 1);
    design.addMove(80, 2, [1, 0], 1);
    design.addMove(80, 2, [4, 6], 1);
    design.addMove(80, 2, [4, 2], 1);
    design.addMove(80, 2, [3, 5], 1);
    design.addMove(80, 2, [3, 0], 1);
    design.addMove(80, 3, [7, 7, 7], 2);
    design.addMove(80, 3, [3, 3, 3], 2);
    design.addMove(80, 3, [4, 4, 4], 2);
    design.addMove(80, 3, [1, 1, 1], 2);
    design.addMove(80, 4, [7, 7, 6], 2);
    design.addMove(80, 4, [7, 7, 5], 2);
    design.addMove(80, 4, [1, 1, 2], 2);
    design.addMove(80, 4, [1, 1, 0], 2);
    design.addMove(80, 4, [4, 4, 6], 2);
    design.addMove(80, 4, [4, 4, 2], 2);
    design.addMove(80, 4, [3, 3, 5], 2);
    design.addMove(80, 4, [3, 3, 0], 2);

    design.addPiece("P66", 81, 66);
    design.addMove(81, 0, [6], 0);
    design.addMove(81, 0, [5], 0);
    design.addMove(81, 0, [2], 0);
    design.addMove(81, 0, [0], 0);
    design.addMove(81, 1, [7, 7], 1);
    design.addMove(81, 1, [3, 3], 1);
    design.addMove(81, 1, [4, 4], 1);
    design.addMove(81, 1, [1, 1], 1);
    design.addMove(81, 2, [7, 6], 1);
    design.addMove(81, 2, [7, 5], 1);
    design.addMove(81, 2, [1, 2], 1);
    design.addMove(81, 2, [1, 0], 1);
    design.addMove(81, 2, [4, 6], 1);
    design.addMove(81, 2, [4, 2], 1);
    design.addMove(81, 2, [3, 5], 1);
    design.addMove(81, 2, [3, 0], 1);
    design.addMove(81, 3, [7, 7, 7], 2);
    design.addMove(81, 3, [3, 3, 3], 2);
    design.addMove(81, 3, [4, 4, 4], 2);
    design.addMove(81, 3, [1, 1, 1], 2);
    design.addMove(81, 4, [7, 7, 6], 2);
    design.addMove(81, 4, [7, 7, 5], 2);
    design.addMove(81, 4, [1, 1, 2], 2);
    design.addMove(81, 4, [1, 1, 0], 2);
    design.addMove(81, 4, [4, 4, 6], 2);
    design.addMove(81, 4, [4, 4, 2], 2);
    design.addMove(81, 4, [3, 3, 5], 2);
    design.addMove(81, 4, [3, 3, 0], 2);

    design.addPiece("P70", 82, 70);
    design.addMove(82, 0, [6], 0);
    design.addMove(82, 0, [5], 0);
    design.addMove(82, 0, [2], 0);
    design.addMove(82, 0, [0], 0);
    design.addMove(82, 1, [7, 7], 1);
    design.addMove(82, 1, [3, 3], 1);
    design.addMove(82, 1, [4, 4], 1);
    design.addMove(82, 1, [1, 1], 1);
    design.addMove(82, 2, [7, 6], 1);
    design.addMove(82, 2, [7, 5], 1);
    design.addMove(82, 2, [1, 2], 1);
    design.addMove(82, 2, [1, 0], 1);
    design.addMove(82, 2, [4, 6], 1);
    design.addMove(82, 2, [4, 2], 1);
    design.addMove(82, 2, [3, 5], 1);
    design.addMove(82, 2, [3, 0], 1);
    design.addMove(82, 3, [7, 7, 7], 2);
    design.addMove(82, 3, [3, 3, 3], 2);
    design.addMove(82, 3, [4, 4, 4], 2);
    design.addMove(82, 3, [1, 1, 1], 2);
    design.addMove(82, 4, [7, 7, 6], 2);
    design.addMove(82, 4, [7, 7, 5], 2);
    design.addMove(82, 4, [1, 1, 2], 2);
    design.addMove(82, 4, [1, 1, 0], 2);
    design.addMove(82, 4, [4, 4, 6], 2);
    design.addMove(82, 4, [4, 4, 2], 2);
    design.addMove(82, 4, [3, 3, 5], 2);
    design.addMove(82, 4, [3, 3, 0], 2);

    design.addPiece("P71", 83, 71);
    design.addMove(83, 0, [6], 0);
    design.addMove(83, 0, [5], 0);
    design.addMove(83, 0, [2], 0);
    design.addMove(83, 0, [0], 0);
    design.addMove(83, 1, [7, 7], 1);
    design.addMove(83, 1, [3, 3], 1);
    design.addMove(83, 1, [4, 4], 1);
    design.addMove(83, 1, [1, 1], 1);
    design.addMove(83, 2, [7, 6], 1);
    design.addMove(83, 2, [7, 5], 1);
    design.addMove(83, 2, [1, 2], 1);
    design.addMove(83, 2, [1, 0], 1);
    design.addMove(83, 2, [4, 6], 1);
    design.addMove(83, 2, [4, 2], 1);
    design.addMove(83, 2, [3, 5], 1);
    design.addMove(83, 2, [3, 0], 1);
    design.addMove(83, 3, [7, 7, 7], 2);
    design.addMove(83, 3, [3, 3, 3], 2);
    design.addMove(83, 3, [4, 4, 4], 2);
    design.addMove(83, 3, [1, 1, 1], 2);
    design.addMove(83, 4, [7, 7, 6], 2);
    design.addMove(83, 4, [7, 7, 5], 2);
    design.addMove(83, 4, [1, 1, 2], 2);
    design.addMove(83, 4, [1, 1, 0], 2);
    design.addMove(83, 4, [4, 4, 6], 2);
    design.addMove(83, 4, [4, 4, 2], 2);
    design.addMove(83, 4, [3, 3, 5], 2);
    design.addMove(83, 4, [3, 3, 0], 2);

    design.addPiece("P74", 84, 74);
    design.addMove(84, 0, [6], 0);
    design.addMove(84, 0, [5], 0);
    design.addMove(84, 0, [2], 0);
    design.addMove(84, 0, [0], 0);
    design.addMove(84, 1, [7, 7], 1);
    design.addMove(84, 1, [3, 3], 1);
    design.addMove(84, 1, [4, 4], 1);
    design.addMove(84, 1, [1, 1], 1);
    design.addMove(84, 2, [7, 6], 1);
    design.addMove(84, 2, [7, 5], 1);
    design.addMove(84, 2, [1, 2], 1);
    design.addMove(84, 2, [1, 0], 1);
    design.addMove(84, 2, [4, 6], 1);
    design.addMove(84, 2, [4, 2], 1);
    design.addMove(84, 2, [3, 5], 1);
    design.addMove(84, 2, [3, 0], 1);
    design.addMove(84, 3, [7, 7, 7], 2);
    design.addMove(84, 3, [3, 3, 3], 2);
    design.addMove(84, 3, [4, 4, 4], 2);
    design.addMove(84, 3, [1, 1, 1], 2);
    design.addMove(84, 4, [7, 7, 6], 2);
    design.addMove(84, 4, [7, 7, 5], 2);
    design.addMove(84, 4, [1, 1, 2], 2);
    design.addMove(84, 4, [1, 1, 0], 2);
    design.addMove(84, 4, [4, 4, 6], 2);
    design.addMove(84, 4, [4, 4, 2], 2);
    design.addMove(84, 4, [3, 3, 5], 2);
    design.addMove(84, 4, [3, 3, 0], 2);

    design.addPiece("P75", 85, 75);
    design.addMove(85, 0, [6], 0);
    design.addMove(85, 0, [5], 0);
    design.addMove(85, 0, [2], 0);
    design.addMove(85, 0, [0], 0);
    design.addMove(85, 1, [7, 7], 1);
    design.addMove(85, 1, [3, 3], 1);
    design.addMove(85, 1, [4, 4], 1);
    design.addMove(85, 1, [1, 1], 1);
    design.addMove(85, 2, [7, 6], 1);
    design.addMove(85, 2, [7, 5], 1);
    design.addMove(85, 2, [1, 2], 1);
    design.addMove(85, 2, [1, 0], 1);
    design.addMove(85, 2, [4, 6], 1);
    design.addMove(85, 2, [4, 2], 1);
    design.addMove(85, 2, [3, 5], 1);
    design.addMove(85, 2, [3, 0], 1);
    design.addMove(85, 3, [7, 7, 7], 2);
    design.addMove(85, 3, [3, 3, 3], 2);
    design.addMove(85, 3, [4, 4, 4], 2);
    design.addMove(85, 3, [1, 1, 1], 2);
    design.addMove(85, 4, [7, 7, 6], 2);
    design.addMove(85, 4, [7, 7, 5], 2);
    design.addMove(85, 4, [1, 1, 2], 2);
    design.addMove(85, 4, [1, 1, 0], 2);
    design.addMove(85, 4, [4, 4, 6], 2);
    design.addMove(85, 4, [4, 4, 2], 2);
    design.addMove(85, 4, [3, 3, 5], 2);
    design.addMove(85, 4, [3, 3, 0], 2);

    design.addPiece("P77", 86, 77);
    design.addMove(86, 0, [6], 0);
    design.addMove(86, 0, [5], 0);
    design.addMove(86, 0, [2], 0);
    design.addMove(86, 0, [0], 0);
    design.addMove(86, 1, [7, 7], 1);
    design.addMove(86, 1, [3, 3], 1);
    design.addMove(86, 1, [4, 4], 1);
    design.addMove(86, 1, [1, 1], 1);
    design.addMove(86, 2, [7, 6], 1);
    design.addMove(86, 2, [7, 5], 1);
    design.addMove(86, 2, [1, 2], 1);
    design.addMove(86, 2, [1, 0], 1);
    design.addMove(86, 2, [4, 6], 1);
    design.addMove(86, 2, [4, 2], 1);
    design.addMove(86, 2, [3, 5], 1);
    design.addMove(86, 2, [3, 0], 1);
    design.addMove(86, 3, [7, 7, 7], 2);
    design.addMove(86, 3, [3, 3, 3], 2);
    design.addMove(86, 3, [4, 4, 4], 2);
    design.addMove(86, 3, [1, 1, 1], 2);
    design.addMove(86, 4, [7, 7, 6], 2);
    design.addMove(86, 4, [7, 7, 5], 2);
    design.addMove(86, 4, [1, 1, 2], 2);
    design.addMove(86, 4, [1, 1, 0], 2);
    design.addMove(86, 4, [4, 4, 6], 2);
    design.addMove(86, 4, [4, 4, 2], 2);
    design.addMove(86, 4, [3, 3, 5], 2);
    design.addMove(86, 4, [3, 3, 0], 2);

    design.addPiece("P78", 87, 78);
    design.addMove(87, 0, [6], 0);
    design.addMove(87, 0, [5], 0);
    design.addMove(87, 0, [2], 0);
    design.addMove(87, 0, [0], 0);
    design.addMove(87, 1, [7, 7], 1);
    design.addMove(87, 1, [3, 3], 1);
    design.addMove(87, 1, [4, 4], 1);
    design.addMove(87, 1, [1, 1], 1);
    design.addMove(87, 2, [7, 6], 1);
    design.addMove(87, 2, [7, 5], 1);
    design.addMove(87, 2, [1, 2], 1);
    design.addMove(87, 2, [1, 0], 1);
    design.addMove(87, 2, [4, 6], 1);
    design.addMove(87, 2, [4, 2], 1);
    design.addMove(87, 2, [3, 5], 1);
    design.addMove(87, 2, [3, 0], 1);
    design.addMove(87, 3, [7, 7, 7], 2);
    design.addMove(87, 3, [3, 3, 3], 2);
    design.addMove(87, 3, [4, 4, 4], 2);
    design.addMove(87, 3, [1, 1, 1], 2);
    design.addMove(87, 4, [7, 7, 6], 2);
    design.addMove(87, 4, [7, 7, 5], 2);
    design.addMove(87, 4, [1, 1, 2], 2);
    design.addMove(87, 4, [1, 1, 0], 2);
    design.addMove(87, 4, [4, 4, 6], 2);
    design.addMove(87, 4, [4, 4, 2], 2);
    design.addMove(87, 4, [3, 3, 5], 2);
    design.addMove(87, 4, [3, 3, 0], 2);

    design.addPiece("P81", 88, 81);
    design.addMove(88, 0, [6], 0);
    design.addMove(88, 0, [5], 0);
    design.addMove(88, 0, [2], 0);
    design.addMove(88, 0, [0], 0);
    design.addMove(88, 1, [7, 7], 1);
    design.addMove(88, 1, [3, 3], 1);
    design.addMove(88, 1, [4, 4], 1);
    design.addMove(88, 1, [1, 1], 1);
    design.addMove(88, 2, [7, 6], 1);
    design.addMove(88, 2, [7, 5], 1);
    design.addMove(88, 2, [1, 2], 1);
    design.addMove(88, 2, [1, 0], 1);
    design.addMove(88, 2, [4, 6], 1);
    design.addMove(88, 2, [4, 2], 1);
    design.addMove(88, 2, [3, 5], 1);
    design.addMove(88, 2, [3, 0], 1);
    design.addMove(88, 3, [7, 7, 7], 2);
    design.addMove(88, 3, [3, 3, 3], 2);
    design.addMove(88, 3, [4, 4, 4], 2);
    design.addMove(88, 3, [1, 1, 1], 2);
    design.addMove(88, 4, [7, 7, 6], 2);
    design.addMove(88, 4, [7, 7, 5], 2);
    design.addMove(88, 4, [1, 1, 2], 2);
    design.addMove(88, 4, [1, 1, 0], 2);
    design.addMove(88, 4, [4, 4, 6], 2);
    design.addMove(88, 4, [4, 4, 2], 2);
    design.addMove(88, 4, [3, 3, 5], 2);
    design.addMove(88, 4, [3, 3, 0], 2);

    design.addPiece("P82", 89, 82);
    design.addMove(89, 0, [6], 0);
    design.addMove(89, 0, [5], 0);
    design.addMove(89, 0, [2], 0);
    design.addMove(89, 0, [0], 0);
    design.addMove(89, 1, [7, 7], 1);
    design.addMove(89, 1, [3, 3], 1);
    design.addMove(89, 1, [4, 4], 1);
    design.addMove(89, 1, [1, 1], 1);
    design.addMove(89, 2, [7, 6], 1);
    design.addMove(89, 2, [7, 5], 1);
    design.addMove(89, 2, [1, 2], 1);
    design.addMove(89, 2, [1, 0], 1);
    design.addMove(89, 2, [4, 6], 1);
    design.addMove(89, 2, [4, 2], 1);
    design.addMove(89, 2, [3, 5], 1);
    design.addMove(89, 2, [3, 0], 1);
    design.addMove(89, 3, [7, 7, 7], 2);
    design.addMove(89, 3, [3, 3, 3], 2);
    design.addMove(89, 3, [4, 4, 4], 2);
    design.addMove(89, 3, [1, 1, 1], 2);
    design.addMove(89, 4, [7, 7, 6], 2);
    design.addMove(89, 4, [7, 7, 5], 2);
    design.addMove(89, 4, [1, 1, 2], 2);
    design.addMove(89, 4, [1, 1, 0], 2);
    design.addMove(89, 4, [4, 4, 6], 2);
    design.addMove(89, 4, [4, 4, 2], 2);
    design.addMove(89, 4, [3, 3, 5], 2);
    design.addMove(89, 4, [3, 3, 0], 2);

    design.addPiece("P86", 90, 86);
    design.addMove(90, 0, [6], 0);
    design.addMove(90, 0, [5], 0);
    design.addMove(90, 0, [2], 0);
    design.addMove(90, 0, [0], 0);
    design.addMove(90, 1, [7, 7], 1);
    design.addMove(90, 1, [3, 3], 1);
    design.addMove(90, 1, [4, 4], 1);
    design.addMove(90, 1, [1, 1], 1);
    design.addMove(90, 2, [7, 6], 1);
    design.addMove(90, 2, [7, 5], 1);
    design.addMove(90, 2, [1, 2], 1);
    design.addMove(90, 2, [1, 0], 1);
    design.addMove(90, 2, [4, 6], 1);
    design.addMove(90, 2, [4, 2], 1);
    design.addMove(90, 2, [3, 5], 1);
    design.addMove(90, 2, [3, 0], 1);
    design.addMove(90, 3, [7, 7, 7], 2);
    design.addMove(90, 3, [3, 3, 3], 2);
    design.addMove(90, 3, [4, 4, 4], 2);
    design.addMove(90, 3, [1, 1, 1], 2);
    design.addMove(90, 4, [7, 7, 6], 2);
    design.addMove(90, 4, [7, 7, 5], 2);
    design.addMove(90, 4, [1, 1, 2], 2);
    design.addMove(90, 4, [1, 1, 0], 2);
    design.addMove(90, 4, [4, 4, 6], 2);
    design.addMove(90, 4, [4, 4, 2], 2);
    design.addMove(90, 4, [3, 3, 5], 2);
    design.addMove(90, 4, [3, 3, 0], 2);

    design.addPiece("P87", 91, 87);
    design.addMove(91, 0, [6], 0);
    design.addMove(91, 0, [5], 0);
    design.addMove(91, 0, [2], 0);
    design.addMove(91, 0, [0], 0);
    design.addMove(91, 1, [7, 7], 1);
    design.addMove(91, 1, [3, 3], 1);
    design.addMove(91, 1, [4, 4], 1);
    design.addMove(91, 1, [1, 1], 1);
    design.addMove(91, 2, [7, 6], 1);
    design.addMove(91, 2, [7, 5], 1);
    design.addMove(91, 2, [1, 2], 1);
    design.addMove(91, 2, [1, 0], 1);
    design.addMove(91, 2, [4, 6], 1);
    design.addMove(91, 2, [4, 2], 1);
    design.addMove(91, 2, [3, 5], 1);
    design.addMove(91, 2, [3, 0], 1);
    design.addMove(91, 3, [7, 7, 7], 2);
    design.addMove(91, 3, [3, 3, 3], 2);
    design.addMove(91, 3, [4, 4, 4], 2);
    design.addMove(91, 3, [1, 1, 1], 2);
    design.addMove(91, 4, [7, 7, 6], 2);
    design.addMove(91, 4, [7, 7, 5], 2);
    design.addMove(91, 4, [1, 1, 2], 2);
    design.addMove(91, 4, [1, 1, 0], 2);
    design.addMove(91, 4, [4, 4, 6], 2);
    design.addMove(91, 4, [4, 4, 2], 2);
    design.addMove(91, 4, [3, 3, 5], 2);
    design.addMove(91, 4, [3, 3, 0], 2);

    design.addPiece("P90", 92, 90);
    design.addMove(92, 0, [6], 0);
    design.addMove(92, 0, [5], 0);
    design.addMove(92, 0, [2], 0);
    design.addMove(92, 0, [0], 0);
    design.addMove(92, 1, [7, 7], 1);
    design.addMove(92, 1, [3, 3], 1);
    design.addMove(92, 1, [4, 4], 1);
    design.addMove(92, 1, [1, 1], 1);
    design.addMove(92, 2, [7, 6], 1);
    design.addMove(92, 2, [7, 5], 1);
    design.addMove(92, 2, [1, 2], 1);
    design.addMove(92, 2, [1, 0], 1);
    design.addMove(92, 2, [4, 6], 1);
    design.addMove(92, 2, [4, 2], 1);
    design.addMove(92, 2, [3, 5], 1);
    design.addMove(92, 2, [3, 0], 1);
    design.addMove(92, 3, [7, 7, 7], 2);
    design.addMove(92, 3, [3, 3, 3], 2);
    design.addMove(92, 3, [4, 4, 4], 2);
    design.addMove(92, 3, [1, 1, 1], 2);
    design.addMove(92, 4, [7, 7, 6], 2);
    design.addMove(92, 4, [7, 7, 5], 2);
    design.addMove(92, 4, [1, 1, 2], 2);
    design.addMove(92, 4, [1, 1, 0], 2);
    design.addMove(92, 4, [4, 4, 6], 2);
    design.addMove(92, 4, [4, 4, 2], 2);
    design.addMove(92, 4, [3, 3, 5], 2);
    design.addMove(92, 4, [3, 3, 0], 2);

    design.addPiece("P91", 93, 91);
    design.addMove(93, 0, [6], 0);
    design.addMove(93, 0, [5], 0);
    design.addMove(93, 0, [2], 0);
    design.addMove(93, 0, [0], 0);
    design.addMove(93, 1, [7, 7], 1);
    design.addMove(93, 1, [3, 3], 1);
    design.addMove(93, 1, [4, 4], 1);
    design.addMove(93, 1, [1, 1], 1);
    design.addMove(93, 2, [7, 6], 1);
    design.addMove(93, 2, [7, 5], 1);
    design.addMove(93, 2, [1, 2], 1);
    design.addMove(93, 2, [1, 0], 1);
    design.addMove(93, 2, [4, 6], 1);
    design.addMove(93, 2, [4, 2], 1);
    design.addMove(93, 2, [3, 5], 1);
    design.addMove(93, 2, [3, 0], 1);
    design.addMove(93, 3, [7, 7, 7], 2);
    design.addMove(93, 3, [3, 3, 3], 2);
    design.addMove(93, 3, [4, 4, 4], 2);
    design.addMove(93, 3, [1, 1, 1], 2);
    design.addMove(93, 4, [7, 7, 6], 2);
    design.addMove(93, 4, [7, 7, 5], 2);
    design.addMove(93, 4, [1, 1, 2], 2);
    design.addMove(93, 4, [1, 1, 0], 2);
    design.addMove(93, 4, [4, 4, 6], 2);
    design.addMove(93, 4, [4, 4, 2], 2);
    design.addMove(93, 4, [3, 3, 5], 2);
    design.addMove(93, 4, [3, 3, 0], 2);

    design.addPiece("P73", 94, 73);
    design.addMove(94, 0, [6], 0);
    design.addMove(94, 0, [5], 0);
    design.addMove(94, 0, [2], 0);
    design.addMove(94, 0, [0], 0);
    design.addMove(94, 1, [7, 7], 1);
    design.addMove(94, 1, [3, 3], 1);
    design.addMove(94, 1, [4, 4], 1);
    design.addMove(94, 1, [1, 1], 1);
    design.addMove(94, 2, [7, 6], 1);
    design.addMove(94, 2, [7, 5], 1);
    design.addMove(94, 2, [1, 2], 1);
    design.addMove(94, 2, [1, 0], 1);
    design.addMove(94, 2, [4, 6], 1);
    design.addMove(94, 2, [4, 2], 1);
    design.addMove(94, 2, [3, 5], 1);
    design.addMove(94, 2, [3, 0], 1);
    design.addMove(94, 3, [7, 7, 7], 2);
    design.addMove(94, 3, [3, 3, 3], 2);
    design.addMove(94, 3, [4, 4, 4], 2);
    design.addMove(94, 3, [1, 1, 1], 2);
    design.addMove(94, 4, [7, 7, 6], 2);
    design.addMove(94, 4, [7, 7, 5], 2);
    design.addMove(94, 4, [1, 1, 2], 2);
    design.addMove(94, 4, [1, 1, 0], 2);
    design.addMove(94, 4, [4, 4, 6], 2);
    design.addMove(94, 4, [4, 4, 2], 2);
    design.addMove(94, 4, [3, 3, 5], 2);
    design.addMove(94, 4, [3, 3, 0], 2);

    design.addPiece("P80", 95, 80);
    design.addMove(95, 0, [6], 0);
    design.addMove(95, 0, [5], 0);
    design.addMove(95, 0, [2], 0);
    design.addMove(95, 0, [0], 0);
    design.addMove(95, 1, [7, 7], 1);
    design.addMove(95, 1, [3, 3], 1);
    design.addMove(95, 1, [4, 4], 1);
    design.addMove(95, 1, [1, 1], 1);
    design.addMove(95, 2, [7, 6], 1);
    design.addMove(95, 2, [7, 5], 1);
    design.addMove(95, 2, [1, 2], 1);
    design.addMove(95, 2, [1, 0], 1);
    design.addMove(95, 2, [4, 6], 1);
    design.addMove(95, 2, [4, 2], 1);
    design.addMove(95, 2, [3, 5], 1);
    design.addMove(95, 2, [3, 0], 1);
    design.addMove(95, 3, [7, 7, 7], 2);
    design.addMove(95, 3, [3, 3, 3], 2);
    design.addMove(95, 3, [4, 4, 4], 2);
    design.addMove(95, 3, [1, 1, 1], 2);
    design.addMove(95, 4, [7, 7, 6], 2);
    design.addMove(95, 4, [7, 7, 5], 2);
    design.addMove(95, 4, [1, 1, 2], 2);
    design.addMove(95, 4, [1, 1, 0], 2);
    design.addMove(95, 4, [4, 4, 6], 2);
    design.addMove(95, 4, [4, 4, 2], 2);
    design.addMove(95, 4, [3, 3, 5], 2);
    design.addMove(95, 4, [3, 3, 0], 2);

    design.addPiece("P85", 96, 85);
    design.addMove(96, 0, [6], 0);
    design.addMove(96, 0, [5], 0);
    design.addMove(96, 0, [2], 0);
    design.addMove(96, 0, [0], 0);
    design.addMove(96, 1, [7, 7], 1);
    design.addMove(96, 1, [3, 3], 1);
    design.addMove(96, 1, [4, 4], 1);
    design.addMove(96, 1, [1, 1], 1);
    design.addMove(96, 2, [7, 6], 1);
    design.addMove(96, 2, [7, 5], 1);
    design.addMove(96, 2, [1, 2], 1);
    design.addMove(96, 2, [1, 0], 1);
    design.addMove(96, 2, [4, 6], 1);
    design.addMove(96, 2, [4, 2], 1);
    design.addMove(96, 2, [3, 5], 1);
    design.addMove(96, 2, [3, 0], 1);
    design.addMove(96, 3, [7, 7, 7], 2);
    design.addMove(96, 3, [3, 3, 3], 2);
    design.addMove(96, 3, [4, 4, 4], 2);
    design.addMove(96, 3, [1, 1, 1], 2);
    design.addMove(96, 4, [7, 7, 6], 2);
    design.addMove(96, 4, [7, 7, 5], 2);
    design.addMove(96, 4, [1, 1, 2], 2);
    design.addMove(96, 4, [1, 1, 0], 2);
    design.addMove(96, 4, [4, 4, 6], 2);
    design.addMove(96, 4, [4, 4, 2], 2);
    design.addMove(96, 4, [3, 3, 5], 2);
    design.addMove(96, 4, [3, 3, 0], 2);

    design.addPiece("P89", 97, 89);
    design.addMove(97, 0, [6], 0);
    design.addMove(97, 0, [5], 0);
    design.addMove(97, 0, [2], 0);
    design.addMove(97, 0, [0], 0);
    design.addMove(97, 1, [7, 7], 1);
    design.addMove(97, 1, [3, 3], 1);
    design.addMove(97, 1, [4, 4], 1);
    design.addMove(97, 1, [1, 1], 1);
    design.addMove(97, 2, [7, 6], 1);
    design.addMove(97, 2, [7, 5], 1);
    design.addMove(97, 2, [1, 2], 1);
    design.addMove(97, 2, [1, 0], 1);
    design.addMove(97, 2, [4, 6], 1);
    design.addMove(97, 2, [4, 2], 1);
    design.addMove(97, 2, [3, 5], 1);
    design.addMove(97, 2, [3, 0], 1);
    design.addMove(97, 3, [7, 7, 7], 2);
    design.addMove(97, 3, [3, 3, 3], 2);
    design.addMove(97, 3, [4, 4, 4], 2);
    design.addMove(97, 3, [1, 1, 1], 2);
    design.addMove(97, 4, [7, 7, 6], 2);
    design.addMove(97, 4, [7, 7, 5], 2);
    design.addMove(97, 4, [1, 1, 2], 2);
    design.addMove(97, 4, [1, 1, 0], 2);
    design.addMove(97, 4, [4, 4, 6], 2);
    design.addMove(97, 4, [4, 4, 2], 2);
    design.addMove(97, 4, [3, 3, 5], 2);
    design.addMove(97, 4, [3, 3, 0], 2);

    design.addPiece("P98", 98, 98);
    design.addMove(98, 0, [6], 0);
    design.addMove(98, 0, [5], 0);
    design.addMove(98, 0, [2], 0);
    design.addMove(98, 0, [0], 0);
    design.addMove(98, 1, [7, 7], 1);
    design.addMove(98, 1, [3, 3], 1);
    design.addMove(98, 1, [4, 4], 1);
    design.addMove(98, 1, [1, 1], 1);
    design.addMove(98, 2, [7, 6], 1);
    design.addMove(98, 2, [7, 5], 1);
    design.addMove(98, 2, [1, 2], 1);
    design.addMove(98, 2, [1, 0], 1);
    design.addMove(98, 2, [4, 6], 1);
    design.addMove(98, 2, [4, 2], 1);
    design.addMove(98, 2, [3, 5], 1);
    design.addMove(98, 2, [3, 0], 1);
    design.addMove(98, 3, [7, 7, 7], 2);
    design.addMove(98, 3, [3, 3, 3], 2);
    design.addMove(98, 3, [4, 4, 4], 2);
    design.addMove(98, 3, [1, 1, 1], 2);
    design.addMove(98, 4, [7, 7, 6], 2);
    design.addMove(98, 4, [7, 7, 5], 2);
    design.addMove(98, 4, [1, 1, 2], 2);
    design.addMove(98, 4, [1, 1, 0], 2);
    design.addMove(98, 4, [4, 4, 6], 2);
    design.addMove(98, 4, [4, 4, 2], 2);
    design.addMove(98, 4, [3, 3, 5], 2);
    design.addMove(98, 4, [3, 3, 0], 2);

    design.addPiece("P100", 99, 100);
    design.addMove(99, 0, [6], 0);
    design.addMove(99, 0, [5], 0);
    design.addMove(99, 0, [2], 0);
    design.addMove(99, 0, [0], 0);
    design.addMove(99, 1, [7, 7], 1);
    design.addMove(99, 1, [3, 3], 1);
    design.addMove(99, 1, [4, 4], 1);
    design.addMove(99, 1, [1, 1], 1);
    design.addMove(99, 2, [7, 6], 1);
    design.addMove(99, 2, [7, 5], 1);
    design.addMove(99, 2, [1, 2], 1);
    design.addMove(99, 2, [1, 0], 1);
    design.addMove(99, 2, [4, 6], 1);
    design.addMove(99, 2, [4, 2], 1);
    design.addMove(99, 2, [3, 5], 1);
    design.addMove(99, 2, [3, 0], 1);
    design.addMove(99, 3, [7, 7, 7], 2);
    design.addMove(99, 3, [3, 3, 3], 2);
    design.addMove(99, 3, [4, 4, 4], 2);
    design.addMove(99, 3, [1, 1, 1], 2);
    design.addMove(99, 4, [7, 7, 6], 2);
    design.addMove(99, 4, [7, 7, 5], 2);
    design.addMove(99, 4, [1, 1, 2], 2);
    design.addMove(99, 4, [1, 1, 0], 2);
    design.addMove(99, 4, [4, 4, 6], 2);
    design.addMove(99, 4, [4, 4, 2], 2);
    design.addMove(99, 4, [3, 3, 5], 2);
    design.addMove(99, 4, [3, 3, 0], 2);

    design.addPiece("P101", 100, 101);
    design.addMove(100, 0, [6], 0);
    design.addMove(100, 0, [5], 0);
    design.addMove(100, 0, [2], 0);
    design.addMove(100, 0, [0], 0);
    design.addMove(100, 1, [7, 7], 1);
    design.addMove(100, 1, [3, 3], 1);
    design.addMove(100, 1, [4, 4], 1);
    design.addMove(100, 1, [1, 1], 1);
    design.addMove(100, 2, [7, 6], 1);
    design.addMove(100, 2, [7, 5], 1);
    design.addMove(100, 2, [1, 2], 1);
    design.addMove(100, 2, [1, 0], 1);
    design.addMove(100, 2, [4, 6], 1);
    design.addMove(100, 2, [4, 2], 1);
    design.addMove(100, 2, [3, 5], 1);
    design.addMove(100, 2, [3, 0], 1);
    design.addMove(100, 3, [7, 7, 7], 2);
    design.addMove(100, 3, [3, 3, 3], 2);
    design.addMove(100, 3, [4, 4, 4], 2);
    design.addMove(100, 3, [1, 1, 1], 2);
    design.addMove(100, 4, [7, 7, 6], 2);
    design.addMove(100, 4, [7, 7, 5], 2);
    design.addMove(100, 4, [1, 1, 2], 2);
    design.addMove(100, 4, [1, 1, 0], 2);
    design.addMove(100, 4, [4, 4, 6], 2);
    design.addMove(100, 4, [4, 4, 2], 2);
    design.addMove(100, 4, [3, 3, 5], 2);
    design.addMove(100, 4, [3, 3, 0], 2);

    design.addPiece("P105", 101, 105);
    design.addMove(101, 0, [6], 0);
    design.addMove(101, 0, [5], 0);
    design.addMove(101, 0, [2], 0);
    design.addMove(101, 0, [0], 0);
    design.addMove(101, 1, [7, 7], 1);
    design.addMove(101, 1, [3, 3], 1);
    design.addMove(101, 1, [4, 4], 1);
    design.addMove(101, 1, [1, 1], 1);
    design.addMove(101, 2, [7, 6], 1);
    design.addMove(101, 2, [7, 5], 1);
    design.addMove(101, 2, [1, 2], 1);
    design.addMove(101, 2, [1, 0], 1);
    design.addMove(101, 2, [4, 6], 1);
    design.addMove(101, 2, [4, 2], 1);
    design.addMove(101, 2, [3, 5], 1);
    design.addMove(101, 2, [3, 0], 1);
    design.addMove(101, 3, [7, 7, 7], 2);
    design.addMove(101, 3, [3, 3, 3], 2);
    design.addMove(101, 3, [4, 4, 4], 2);
    design.addMove(101, 3, [1, 1, 1], 2);
    design.addMove(101, 4, [7, 7, 6], 2);
    design.addMove(101, 4, [7, 7, 5], 2);
    design.addMove(101, 4, [1, 1, 2], 2);
    design.addMove(101, 4, [1, 1, 0], 2);
    design.addMove(101, 4, [4, 4, 6], 2);
    design.addMove(101, 4, [4, 4, 2], 2);
    design.addMove(101, 4, [3, 3, 5], 2);
    design.addMove(101, 4, [3, 3, 0], 2);

    design.addPiece("P110", 102, 110);
    design.addMove(102, 0, [6], 0);
    design.addMove(102, 0, [5], 0);
    design.addMove(102, 0, [2], 0);
    design.addMove(102, 0, [0], 0);
    design.addMove(102, 1, [7, 7], 1);
    design.addMove(102, 1, [3, 3], 1);
    design.addMove(102, 1, [4, 4], 1);
    design.addMove(102, 1, [1, 1], 1);
    design.addMove(102, 2, [7, 6], 1);
    design.addMove(102, 2, [7, 5], 1);
    design.addMove(102, 2, [1, 2], 1);
    design.addMove(102, 2, [1, 0], 1);
    design.addMove(102, 2, [4, 6], 1);
    design.addMove(102, 2, [4, 2], 1);
    design.addMove(102, 2, [3, 5], 1);
    design.addMove(102, 2, [3, 0], 1);
    design.addMove(102, 3, [7, 7, 7], 2);
    design.addMove(102, 3, [3, 3, 3], 2);
    design.addMove(102, 3, [4, 4, 4], 2);
    design.addMove(102, 3, [1, 1, 1], 2);
    design.addMove(102, 4, [7, 7, 6], 2);
    design.addMove(102, 4, [7, 7, 5], 2);
    design.addMove(102, 4, [1, 1, 2], 2);
    design.addMove(102, 4, [1, 1, 0], 2);
    design.addMove(102, 4, [4, 4, 6], 2);
    design.addMove(102, 4, [4, 4, 2], 2);
    design.addMove(102, 4, [3, 3, 5], 2);
    design.addMove(102, 4, [3, 3, 0], 2);

    design.addPiece("P114", 103, 114);
    design.addMove(103, 0, [6], 0);
    design.addMove(103, 0, [5], 0);
    design.addMove(103, 0, [2], 0);
    design.addMove(103, 0, [0], 0);
    design.addMove(103, 1, [7, 7], 1);
    design.addMove(103, 1, [3, 3], 1);
    design.addMove(103, 1, [4, 4], 1);
    design.addMove(103, 1, [1, 1], 1);
    design.addMove(103, 2, [7, 6], 1);
    design.addMove(103, 2, [7, 5], 1);
    design.addMove(103, 2, [1, 2], 1);
    design.addMove(103, 2, [1, 0], 1);
    design.addMove(103, 2, [4, 6], 1);
    design.addMove(103, 2, [4, 2], 1);
    design.addMove(103, 2, [3, 5], 1);
    design.addMove(103, 2, [3, 0], 1);
    design.addMove(103, 3, [7, 7, 7], 2);
    design.addMove(103, 3, [3, 3, 3], 2);
    design.addMove(103, 3, [4, 4, 4], 2);
    design.addMove(103, 3, [1, 1, 1], 2);
    design.addMove(103, 4, [7, 7, 6], 2);
    design.addMove(103, 4, [7, 7, 5], 2);
    design.addMove(103, 4, [1, 1, 2], 2);
    design.addMove(103, 4, [1, 1, 0], 2);
    design.addMove(103, 4, [4, 4, 6], 2);
    design.addMove(103, 4, [4, 4, 2], 2);
    design.addMove(103, 4, [3, 3, 5], 2);
    design.addMove(103, 4, [3, 3, 0], 2);

    design.addPiece("P116", 104, 116);
    design.addMove(104, 0, [6], 0);
    design.addMove(104, 0, [5], 0);
    design.addMove(104, 0, [2], 0);
    design.addMove(104, 0, [0], 0);
    design.addMove(104, 1, [7, 7], 1);
    design.addMove(104, 1, [3, 3], 1);
    design.addMove(104, 1, [4, 4], 1);
    design.addMove(104, 1, [1, 1], 1);
    design.addMove(104, 2, [7, 6], 1);
    design.addMove(104, 2, [7, 5], 1);
    design.addMove(104, 2, [1, 2], 1);
    design.addMove(104, 2, [1, 0], 1);
    design.addMove(104, 2, [4, 6], 1);
    design.addMove(104, 2, [4, 2], 1);
    design.addMove(104, 2, [3, 5], 1);
    design.addMove(104, 2, [3, 0], 1);
    design.addMove(104, 3, [7, 7, 7], 2);
    design.addMove(104, 3, [3, 3, 3], 2);
    design.addMove(104, 3, [4, 4, 4], 2);
    design.addMove(104, 3, [1, 1, 1], 2);
    design.addMove(104, 4, [7, 7, 6], 2);
    design.addMove(104, 4, [7, 7, 5], 2);
    design.addMove(104, 4, [1, 1, 2], 2);
    design.addMove(104, 4, [1, 1, 0], 2);
    design.addMove(104, 4, [4, 4, 6], 2);
    design.addMove(104, 4, [4, 4, 2], 2);
    design.addMove(104, 4, [3, 3, 5], 2);
    design.addMove(104, 4, [3, 3, 0], 2);

    design.addPiece("P125", 105, 125);
    design.addMove(105, 0, [6], 0);
    design.addMove(105, 0, [5], 0);
    design.addMove(105, 0, [2], 0);
    design.addMove(105, 0, [0], 0);
    design.addMove(105, 1, [7, 7], 1);
    design.addMove(105, 1, [3, 3], 1);
    design.addMove(105, 1, [4, 4], 1);
    design.addMove(105, 1, [1, 1], 1);
    design.addMove(105, 2, [7, 6], 1);
    design.addMove(105, 2, [7, 5], 1);
    design.addMove(105, 2, [1, 2], 1);
    design.addMove(105, 2, [1, 0], 1);
    design.addMove(105, 2, [4, 6], 1);
    design.addMove(105, 2, [4, 2], 1);
    design.addMove(105, 2, [3, 5], 1);
    design.addMove(105, 2, [3, 0], 1);
    design.addMove(105, 3, [7, 7, 7], 2);
    design.addMove(105, 3, [3, 3, 3], 2);
    design.addMove(105, 3, [4, 4, 4], 2);
    design.addMove(105, 3, [1, 1, 1], 2);
    design.addMove(105, 4, [7, 7, 6], 2);
    design.addMove(105, 4, [7, 7, 5], 2);
    design.addMove(105, 4, [1, 1, 2], 2);
    design.addMove(105, 4, [1, 1, 0], 2);
    design.addMove(105, 4, [4, 4, 6], 2);
    design.addMove(105, 4, [4, 4, 2], 2);
    design.addMove(105, 4, [3, 3, 5], 2);
    design.addMove(105, 4, [3, 3, 0], 2);

    design.addPiece("P126", 106, 126);
    design.addMove(106, 0, [6], 0);
    design.addMove(106, 0, [5], 0);
    design.addMove(106, 0, [2], 0);
    design.addMove(106, 0, [0], 0);
    design.addMove(106, 1, [7, 7], 1);
    design.addMove(106, 1, [3, 3], 1);
    design.addMove(106, 1, [4, 4], 1);
    design.addMove(106, 1, [1, 1], 1);
    design.addMove(106, 2, [7, 6], 1);
    design.addMove(106, 2, [7, 5], 1);
    design.addMove(106, 2, [1, 2], 1);
    design.addMove(106, 2, [1, 0], 1);
    design.addMove(106, 2, [4, 6], 1);
    design.addMove(106, 2, [4, 2], 1);
    design.addMove(106, 2, [3, 5], 1);
    design.addMove(106, 2, [3, 0], 1);
    design.addMove(106, 3, [7, 7, 7], 2);
    design.addMove(106, 3, [3, 3, 3], 2);
    design.addMove(106, 3, [4, 4, 4], 2);
    design.addMove(106, 3, [1, 1, 1], 2);
    design.addMove(106, 4, [7, 7, 6], 2);
    design.addMove(106, 4, [7, 7, 5], 2);
    design.addMove(106, 4, [1, 1, 2], 2);
    design.addMove(106, 4, [1, 1, 0], 2);
    design.addMove(106, 4, [4, 4, 6], 2);
    design.addMove(106, 4, [4, 4, 2], 2);
    design.addMove(106, 4, [3, 3, 5], 2);
    design.addMove(106, 4, [3, 3, 0], 2);

    design.addPiece("P141", 107, 141);
    design.addMove(107, 0, [6], 0);
    design.addMove(107, 0, [5], 0);
    design.addMove(107, 0, [2], 0);
    design.addMove(107, 0, [0], 0);
    design.addMove(107, 1, [7, 7], 1);
    design.addMove(107, 1, [3, 3], 1);
    design.addMove(107, 1, [4, 4], 1);
    design.addMove(107, 1, [1, 1], 1);
    design.addMove(107, 2, [7, 6], 1);
    design.addMove(107, 2, [7, 5], 1);
    design.addMove(107, 2, [1, 2], 1);
    design.addMove(107, 2, [1, 0], 1);
    design.addMove(107, 2, [4, 6], 1);
    design.addMove(107, 2, [4, 2], 1);
    design.addMove(107, 2, [3, 5], 1);
    design.addMove(107, 2, [3, 0], 1);
    design.addMove(107, 3, [7, 7, 7], 2);
    design.addMove(107, 3, [3, 3, 3], 2);
    design.addMove(107, 3, [4, 4, 4], 2);
    design.addMove(107, 3, [1, 1, 1], 2);
    design.addMove(107, 4, [7, 7, 6], 2);
    design.addMove(107, 4, [7, 7, 5], 2);
    design.addMove(107, 4, [1, 1, 2], 2);
    design.addMove(107, 4, [1, 1, 0], 2);
    design.addMove(107, 4, [4, 4, 6], 2);
    design.addMove(107, 4, [4, 4, 2], 2);
    design.addMove(107, 4, [3, 3, 5], 2);
    design.addMove(107, 4, [3, 3, 0], 2);

    design.addPiece("P149", 108, 149);
    design.addMove(108, 0, [6], 0);
    design.addMove(108, 0, [5], 0);
    design.addMove(108, 0, [2], 0);
    design.addMove(108, 0, [0], 0);
    design.addMove(108, 1, [7, 7], 1);
    design.addMove(108, 1, [3, 3], 1);
    design.addMove(108, 1, [4, 4], 1);
    design.addMove(108, 1, [1, 1], 1);
    design.addMove(108, 2, [7, 6], 1);
    design.addMove(108, 2, [7, 5], 1);
    design.addMove(108, 2, [1, 2], 1);
    design.addMove(108, 2, [1, 0], 1);
    design.addMove(108, 2, [4, 6], 1);
    design.addMove(108, 2, [4, 2], 1);
    design.addMove(108, 2, [3, 5], 1);
    design.addMove(108, 2, [3, 0], 1);
    design.addMove(108, 3, [7, 7, 7], 2);
    design.addMove(108, 3, [3, 3, 3], 2);
    design.addMove(108, 3, [4, 4, 4], 2);
    design.addMove(108, 3, [1, 1, 1], 2);
    design.addMove(108, 4, [7, 7, 6], 2);
    design.addMove(108, 4, [7, 7, 5], 2);
    design.addMove(108, 4, [1, 1, 2], 2);
    design.addMove(108, 4, [1, 1, 0], 2);
    design.addMove(108, 4, [4, 4, 6], 2);
    design.addMove(108, 4, [4, 4, 2], 2);
    design.addMove(108, 4, [3, 3, 5], 2);
    design.addMove(108, 4, [3, 3, 0], 2);

    design.addPiece("P165", 109, 165);
    design.addMove(109, 0, [6], 0);
    design.addMove(109, 0, [5], 0);
    design.addMove(109, 0, [2], 0);
    design.addMove(109, 0, [0], 0);
    design.addMove(109, 1, [7, 7], 1);
    design.addMove(109, 1, [3, 3], 1);
    design.addMove(109, 1, [4, 4], 1);
    design.addMove(109, 1, [1, 1], 1);
    design.addMove(109, 2, [7, 6], 1);
    design.addMove(109, 2, [7, 5], 1);
    design.addMove(109, 2, [1, 2], 1);
    design.addMove(109, 2, [1, 0], 1);
    design.addMove(109, 2, [4, 6], 1);
    design.addMove(109, 2, [4, 2], 1);
    design.addMove(109, 2, [3, 5], 1);
    design.addMove(109, 2, [3, 0], 1);
    design.addMove(109, 3, [7, 7, 7], 2);
    design.addMove(109, 3, [3, 3, 3], 2);
    design.addMove(109, 3, [4, 4, 4], 2);
    design.addMove(109, 3, [1, 1, 1], 2);
    design.addMove(109, 4, [7, 7, 6], 2);
    design.addMove(109, 4, [7, 7, 5], 2);
    design.addMove(109, 4, [1, 1, 2], 2);
    design.addMove(109, 4, [1, 1, 0], 2);
    design.addMove(109, 4, [4, 4, 6], 2);
    design.addMove(109, 4, [4, 4, 2], 2);
    design.addMove(109, 4, [3, 3, 5], 2);
    design.addMove(109, 4, [3, 3, 0], 2);

    design.addPiece("P174", 110, 174);
    design.addMove(110, 0, [6], 0);
    design.addMove(110, 0, [5], 0);
    design.addMove(110, 0, [2], 0);
    design.addMove(110, 0, [0], 0);
    design.addMove(110, 1, [7, 7], 1);
    design.addMove(110, 1, [3, 3], 1);
    design.addMove(110, 1, [4, 4], 1);
    design.addMove(110, 1, [1, 1], 1);
    design.addMove(110, 2, [7, 6], 1);
    design.addMove(110, 2, [7, 5], 1);
    design.addMove(110, 2, [1, 2], 1);
    design.addMove(110, 2, [1, 0], 1);
    design.addMove(110, 2, [4, 6], 1);
    design.addMove(110, 2, [4, 2], 1);
    design.addMove(110, 2, [3, 5], 1);
    design.addMove(110, 2, [3, 0], 1);
    design.addMove(110, 3, [7, 7, 7], 2);
    design.addMove(110, 3, [3, 3, 3], 2);
    design.addMove(110, 3, [4, 4, 4], 2);
    design.addMove(110, 3, [1, 1, 1], 2);
    design.addMove(110, 4, [7, 7, 6], 2);
    design.addMove(110, 4, [7, 7, 5], 2);
    design.addMove(110, 4, [1, 1, 2], 2);
    design.addMove(110, 4, [1, 1, 0], 2);
    design.addMove(110, 4, [4, 4, 6], 2);
    design.addMove(110, 4, [4, 4, 2], 2);
    design.addMove(110, 4, [3, 3, 5], 2);
    design.addMove(110, 4, [3, 3, 0], 2);

    design.addPiece("P190", 111, 190);
    design.addMove(111, 0, [6], 0);
    design.addMove(111, 0, [5], 0);
    design.addMove(111, 0, [2], 0);
    design.addMove(111, 0, [0], 0);
    design.addMove(111, 1, [7, 7], 1);
    design.addMove(111, 1, [3, 3], 1);
    design.addMove(111, 1, [4, 4], 1);
    design.addMove(111, 1, [1, 1], 1);
    design.addMove(111, 2, [7, 6], 1);
    design.addMove(111, 2, [7, 5], 1);
    design.addMove(111, 2, [1, 2], 1);
    design.addMove(111, 2, [1, 0], 1);
    design.addMove(111, 2, [4, 6], 1);
    design.addMove(111, 2, [4, 2], 1);
    design.addMove(111, 2, [3, 5], 1);
    design.addMove(111, 2, [3, 0], 1);
    design.addMove(111, 3, [7, 7, 7], 2);
    design.addMove(111, 3, [3, 3, 3], 2);
    design.addMove(111, 3, [4, 4, 4], 2);
    design.addMove(111, 3, [1, 1, 1], 2);
    design.addMove(111, 4, [7, 7, 6], 2);
    design.addMove(111, 4, [7, 7, 5], 2);
    design.addMove(111, 4, [1, 1, 2], 2);
    design.addMove(111, 4, [1, 1, 0], 2);
    design.addMove(111, 4, [4, 4, 6], 2);
    design.addMove(111, 4, [4, 4, 2], 2);
    design.addMove(111, 4, [3, 3, 5], 2);
    design.addMove(111, 4, [3, 3, 0], 2);

    design.addPiece("P113", 112, 113);
    design.addMove(112, 0, [6], 0);
    design.addMove(112, 0, [5], 0);
    design.addMove(112, 0, [2], 0);
    design.addMove(112, 0, [0], 0);
    design.addMove(112, 1, [7, 7], 1);
    design.addMove(112, 1, [3, 3], 1);
    design.addMove(112, 1, [4, 4], 1);
    design.addMove(112, 1, [1, 1], 1);
    design.addMove(112, 2, [7, 6], 1);
    design.addMove(112, 2, [7, 5], 1);
    design.addMove(112, 2, [1, 2], 1);
    design.addMove(112, 2, [1, 0], 1);
    design.addMove(112, 2, [4, 6], 1);
    design.addMove(112, 2, [4, 2], 1);
    design.addMove(112, 2, [3, 5], 1);
    design.addMove(112, 2, [3, 0], 1);
    design.addMove(112, 3, [7, 7, 7], 2);
    design.addMove(112, 3, [3, 3, 3], 2);
    design.addMove(112, 3, [4, 4, 4], 2);
    design.addMove(112, 3, [1, 1, 1], 2);
    design.addMove(112, 4, [7, 7, 6], 2);
    design.addMove(112, 4, [7, 7, 5], 2);
    design.addMove(112, 4, [1, 1, 2], 2);
    design.addMove(112, 4, [1, 1, 0], 2);
    design.addMove(112, 4, [4, 4, 6], 2);
    design.addMove(112, 4, [4, 4, 2], 2);
    design.addMove(112, 4, [3, 3, 5], 2);
    design.addMove(112, 4, [3, 3, 0], 2);

    design.addPiece("P154", 113, 154);
    design.addMove(113, 0, [6], 0);
    design.addMove(113, 0, [5], 0);
    design.addMove(113, 0, [2], 0);
    design.addMove(113, 0, [0], 0);
    design.addMove(113, 1, [7, 7], 1);
    design.addMove(113, 1, [3, 3], 1);
    design.addMove(113, 1, [4, 4], 1);
    design.addMove(113, 1, [1, 1], 1);
    design.addMove(113, 2, [7, 6], 1);
    design.addMove(113, 2, [7, 5], 1);
    design.addMove(113, 2, [1, 2], 1);
    design.addMove(113, 2, [1, 0], 1);
    design.addMove(113, 2, [4, 6], 1);
    design.addMove(113, 2, [4, 2], 1);
    design.addMove(113, 2, [3, 5], 1);
    design.addMove(113, 2, [3, 0], 1);
    design.addMove(113, 3, [7, 7, 7], 2);
    design.addMove(113, 3, [3, 3, 3], 2);
    design.addMove(113, 3, [4, 4, 4], 2);
    design.addMove(113, 3, [1, 1, 1], 2);
    design.addMove(113, 4, [7, 7, 6], 2);
    design.addMove(113, 4, [7, 7, 5], 2);
    design.addMove(113, 4, [1, 1, 2], 2);
    design.addMove(113, 4, [1, 1, 0], 2);
    design.addMove(113, 4, [4, 4, 6], 2);
    design.addMove(113, 4, [4, 4, 2], 2);
    design.addMove(113, 4, [3, 3, 5], 2);
    design.addMove(113, 4, [3, 3, 0], 2);

    design.addPiece("P129", 114, 129);
    design.addMove(114, 0, [6], 0);
    design.addMove(114, 0, [5], 0);
    design.addMove(114, 0, [2], 0);
    design.addMove(114, 0, [0], 0);
    design.addMove(114, 1, [7, 7], 1);
    design.addMove(114, 1, [3, 3], 1);
    design.addMove(114, 1, [4, 4], 1);
    design.addMove(114, 1, [1, 1], 1);
    design.addMove(114, 2, [7, 6], 1);
    design.addMove(114, 2, [7, 5], 1);
    design.addMove(114, 2, [1, 2], 1);
    design.addMove(114, 2, [1, 0], 1);
    design.addMove(114, 2, [4, 6], 1);
    design.addMove(114, 2, [4, 2], 1);
    design.addMove(114, 2, [3, 5], 1);
    design.addMove(114, 2, [3, 0], 1);
    design.addMove(114, 3, [7, 7, 7], 2);
    design.addMove(114, 3, [3, 3, 3], 2);
    design.addMove(114, 3, [4, 4, 4], 2);
    design.addMove(114, 3, [1, 1, 1], 2);
    design.addMove(114, 4, [7, 7, 6], 2);
    design.addMove(114, 4, [7, 7, 5], 2);
    design.addMove(114, 4, [1, 1, 2], 2);
    design.addMove(114, 4, [1, 1, 0], 2);
    design.addMove(114, 4, [4, 4, 6], 2);
    design.addMove(114, 4, [4, 4, 2], 2);
    design.addMove(114, 4, [3, 3, 5], 2);
    design.addMove(114, 4, [3, 3, 0], 2);

    design.addPiece("P138", 115, 138);
    design.addMove(115, 0, [6], 0);
    design.addMove(115, 0, [5], 0);
    design.addMove(115, 0, [2], 0);
    design.addMove(115, 0, [0], 0);
    design.addMove(115, 1, [7, 7], 1);
    design.addMove(115, 1, [3, 3], 1);
    design.addMove(115, 1, [4, 4], 1);
    design.addMove(115, 1, [1, 1], 1);
    design.addMove(115, 2, [7, 6], 1);
    design.addMove(115, 2, [7, 5], 1);
    design.addMove(115, 2, [1, 2], 1);
    design.addMove(115, 2, [1, 0], 1);
    design.addMove(115, 2, [4, 6], 1);
    design.addMove(115, 2, [4, 2], 1);
    design.addMove(115, 2, [3, 5], 1);
    design.addMove(115, 2, [3, 0], 1);
    design.addMove(115, 3, [7, 7, 7], 2);
    design.addMove(115, 3, [3, 3, 3], 2);
    design.addMove(115, 3, [4, 4, 4], 2);
    design.addMove(115, 3, [1, 1, 1], 2);
    design.addMove(115, 4, [7, 7, 6], 2);
    design.addMove(115, 4, [7, 7, 5], 2);
    design.addMove(115, 4, [1, 1, 2], 2);
    design.addMove(115, 4, [1, 1, 0], 2);
    design.addMove(115, 4, [4, 4, 6], 2);
    design.addMove(115, 4, [4, 4, 2], 2);
    design.addMove(115, 4, [3, 3, 5], 2);
    design.addMove(115, 4, [3, 3, 0], 2);

    design.setup("White", "C2", 82, 1);
    design.setup("White", "C4", 90, 1);
    design.setup("White", "C4", 83, 1);
    design.setup("White", "C4", 138, 1);
    design.setup("White", "C6", 84, 1);
    design.setup("White", "C8", 85, 1);
    design.setup("White", "C16", 91, 1);
    design.setup("White", "C36", 92, 1);
    design.setup("White", "C64", 93, 1);
    design.setup("White", "C1", 139, 1);
    design.setup("White", "T6", 89, 1);
    design.setup("White", "T9", 88, 1);
    design.setup("White", "T9", 137, 1);
    design.setup("White", "T20", 99, 1);
    design.setup("White", "T25", 98, 1);
    design.setup("White", "T42", 100, 1);
    design.setup("White", "T49", 101, 1);
    design.setup("White", "T72", 94, 1);
    design.setup("White", "T81", 95, 1);
    design.setup("White", "T16", 136, 1);
    design.setup("White", "S15", 96, 1);
    design.setup("White", "S25", 104, 1);
    design.setup("White", "S25", 135, 1);
    design.setup("White", "S45", 97, 1);
    design.setup("White", "S81", 105, 1);
    design.setup("White", "S153", 103, 1);
    design.setup("White", "S169", 110, 1);
    design.setup("White", "S289", 111, 1);
    design.setup("White", "S36", 134, 1);
    design.setup("White", "P91", 102, 1);
    design.setup("Black", "C3", 45, 1);
    design.setup("Black", "C5", 44, 1);
    design.setup("Black", "C7", 43, 1);
    design.setup("Black", "C9", 42, 1);
    design.setup("Black", "C9", 37, 1);
    design.setup("Black", "C25", 36, 1);
    design.setup("Black", "C49", 35, 1);
    design.setup("Black", "C81", 34, 1);
    design.setup("Black", "C16", 132, 1);
    design.setup("Black", "T12", 38, 1);
    design.setup("Black", "T16", 39, 1);
    design.setup("Black", "T30", 28, 1);
    design.setup("Black", "T36", 29, 1);
    design.setup("Black", "T36", 130, 1);
    design.setup("Black", "T56", 27, 1);
    design.setup("Black", "T64", 26, 1);
    design.setup("Black", "T90", 33, 1);
    design.setup("Black", "T100", 32, 1);
    design.setup("Black", "T25", 131, 1);
    design.setup("Black", "S28", 31, 1);
    design.setup("Black", "S49", 23, 1);
    design.setup("Black", "S49", 129, 1);
    design.setup("Black", "S66", 30, 1);
    design.setup("Black", "S120", 25, 1);
    design.setup("Black", "S121", 22, 1);
    design.setup("Black", "S225", 17, 1);
    design.setup("Black", "S361", 16, 1);
    design.setup("Black", "S64", 128, 1);
    design.setup("Black", "P190", 24, 1);

    design.setup("White", "C4", 138, 2);
    design.setup("White", "C1", 139, 2);
    design.setup("White", "C2", 82, 2);
    design.setup("White", "C4", 83, 2);
    design.setup("White", "C4", 90, 2);
    design.setup("White", "C6", 84, 2);
    design.setup("White", "C8", 85, 2);
    design.setup("White", "C16", 91, 2);
    design.setup("White", "C36", 92, 2);
    design.setup("White", "C64", 93, 2);
    design.setup("White", "T9", 137, 2);
    design.setup("White", "T16", 136, 2);
    design.setup("White", "T6", 98, 2);
    design.setup("White", "T20", 99, 2);
    design.setup("White", "T42", 100, 2);
    design.setup("White", "T72", 101, 2);
    design.setup("White", "T9", 106, 2);
    design.setup("White", "T25", 107, 2);
    design.setup("White", "T49", 108, 2);
    design.setup("White", "T81", 109, 2);
    design.setup("White", "S25", 135, 2);
    design.setup("White", "S25", 122, 2);
    design.setup("White", "S36", 134, 2);
    design.setup("White", "S15", 114, 2);
    design.setup("White", "S45", 115, 2);
    design.setup("White", "S153", 117, 2);
    design.setup("White", "S81", 123, 2);
    design.setup("White", "S169", 124, 2);
    design.setup("White", "S289", 125, 2);
    design.setup("White", "P91", 116, 2);
    design.setup("Black", "C16", 132, 2);
    design.setup("Black", "C9", 42, 2);
    design.setup("Black", "C9", 37, 2);
    design.setup("Black", "C7", 43, 2);
    design.setup("Black", "C5", 44, 2);
    design.setup("Black", "C3", 45, 2);
    design.setup("Black", "C81", 34, 2);
    design.setup("Black", "C49", 35, 2);
    design.setup("Black", "C25", 36, 2);
    design.setup("Black", "T36", 130, 2);
    design.setup("Black", "T36", 20, 2);
    design.setup("Black", "T25", 131, 2);
    design.setup("Black", "T90", 26, 2);
    design.setup("Black", "T56", 27, 2);
    design.setup("Black", "T30", 28, 2);
    design.setup("Black", "T12", 29, 2);
    design.setup("Black", "T100", 18, 2);
    design.setup("Black", "T64", 19, 2);
    design.setup("Black", "T16", 21, 2);
    design.setup("Black", "S49", 129, 2);
    design.setup("Black", "S64", 128, 2);
    design.setup("Black", "S120", 11, 2);
    design.setup("Black", "S66", 12, 2);
    design.setup("Black", "S28", 13, 2);
    design.setup("Black", "S361", 2, 2);
    design.setup("Black", "S225", 3, 2);
    design.setup("Black", "S121", 4, 2);
    design.setup("Black", "S49", 5, 2);
    design.setup("Black", "P190", 10, 2);

    design.setup("White", "C2", 42, 3);
    design.setup("White", "C4", 34, 3);
    design.setup("White", "C4", 43, 3);
    design.setup("White", "C4", 132, 3);
    design.setup("White", "C6", 44, 3);
    design.setup("White", "C8", 45, 3);
    design.setup("White", "C16", 35, 3);
    design.setup("White", "C36", 36, 3);
    design.setup("White", "C64", 37, 3);
    design.setup("White", "C1", 133, 3);
    design.setup("White", "T6", 33, 3);
    design.setup("White", "T9", 32, 3);
    design.setup("White", "T9", 131, 3);
    design.setup("White", "T20", 27, 3);
    design.setup("White", "T25", 26, 3);
    design.setup("White", "T42", 28, 3);
    design.setup("White", "T49", 29, 3);
    design.setup("White", "T72", 38, 3);
    design.setup("White", "T81", 39, 3);
    design.setup("White", "T16", 130, 3);
    design.setup("White", "S15", 24, 3);
    design.setup("White", "S25", 16, 3);
    design.setup("White", "S25", 129, 3);
    design.setup("White", "S45", 25, 3);
    design.setup("White", "S81", 17, 3);
    design.setup("White", "S153", 31, 3);
    design.setup("White", "S169", 22, 3);
    design.setup("White", "S289", 23, 3);
    design.setup("White", "S36", 128, 3);
    design.setup("White", "P91", 30, 3);
    design.setup("Black", "C3", 85, 3);
    design.setup("Black", "C5", 84, 3);
    design.setup("Black", "C7", 83, 3);
    design.setup("Black", "C9", 82, 3);
    design.setup("Black", "C9", 93, 3);
    design.setup("Black", "C25", 92, 3);
    design.setup("Black", "C49", 91, 3);
    design.setup("Black", "C81", 90, 3);
    design.setup("Black", "C16", 138, 3);
    design.setup("Black", "T12", 94, 3);
    design.setup("Black", "T16", 95, 3);
    design.setup("Black", "T30", 100, 3);
    design.setup("Black", "T36", 101, 3);
    design.setup("Black", "T36", 136, 3);
    design.setup("Black", "T56", 99, 3);
    design.setup("Black", "T64", 98, 3);
    design.setup("Black", "T90", 89, 3);
    design.setup("Black", "T100", 88, 3);
    design.setup("Black", "T25", 137, 3);
    design.setup("Black", "S28", 103, 3);
    design.setup("Black", "S49", 111, 3);
    design.setup("Black", "S49", 135, 3);
    design.setup("Black", "S66", 102, 3);
    design.setup("Black", "S120", 97, 3);
    design.setup("Black", "S121", 110, 3);
    design.setup("Black", "S225", 105, 3);
    design.setup("Black", "S361", 104, 3);
    design.setup("Black", "S64", 134, 3);
    design.setup("Black", "P190", 96, 3);

    design.setup("White", "C4", 132, 4);
    design.setup("White", "C1", 133, 4);
    design.setup("White", "C2", 42, 4);
    design.setup("White", "C4", 43, 4);
    design.setup("White", "C4", 34, 4);
    design.setup("White", "C6", 44, 4);
    design.setup("White", "C8", 45, 4);
    design.setup("White", "C16", 35, 4);
    design.setup("White", "C36", 36, 4);
    design.setup("White", "C64", 37, 4);
    design.setup("White", "T9", 131, 4);
    design.setup("White", "T16", 130, 4);
    design.setup("White", "T6", 26, 4);
    design.setup("White", "T20", 27, 4);
    design.setup("White", "T42", 28, 4);
    design.setup("White", "T72", 29, 4);
    design.setup("White", "T9", 18, 4);
    design.setup("White", "T25", 19, 4);
    design.setup("White", "T49", 20, 4);
    design.setup("White", "T81", 21, 4);
    design.setup("White", "S25", 129, 4);
    design.setup("White", "S25", 2, 4);
    design.setup("White", "S36", 128, 4);
    design.setup("White", "S15", 10, 4);
    design.setup("White", "S45", 11, 4);
    design.setup("White", "S153", 13, 4);
    design.setup("White", "S81", 3, 4);
    design.setup("White", "S169", 4, 4);
    design.setup("White", "S289", 5, 4);
    design.setup("White", "P91", 12, 4);
    design.setup("Black", "C16", 138, 4);
    design.setup("Black", "C9", 82, 4);
    design.setup("Black", "C9", 93, 4);
    design.setup("Black", "C7", 83, 4);
    design.setup("Black", "C5", 84, 4);
    design.setup("Black", "C3", 85, 4);
    design.setup("Black", "C81", 90, 4);
    design.setup("Black", "C49", 91, 4);
    design.setup("Black", "C25", 92, 4);
    design.setup("Black", "T36", 136, 4);
    design.setup("Black", "T36", 108, 4);
    design.setup("Black", "T25", 137, 4);
    design.setup("Black", "T90", 98, 4);
    design.setup("Black", "T56", 99, 4);
    design.setup("Black", "T30", 100, 4);
    design.setup("Black", "T12", 101, 4);
    design.setup("Black", "T100", 106, 4);
    design.setup("Black", "T64", 107, 4);
    design.setup("Black", "T16", 109, 4);
    design.setup("Black", "S49", 135, 4);
    design.setup("Black", "S64", 134, 4);
    design.setup("Black", "S120", 115, 4);
    design.setup("Black", "S66", 116, 4);
    design.setup("Black", "S28", 117, 4);
    design.setup("Black", "S361", 122, 4);
    design.setup("Black", "S225", 123, 4);
    design.setup("Black", "S121", 124, 4);
    design.setup("Black", "S49", 125, 4);
    design.setup("Black", "P190", 114, 4);
}

Dagaz.View.configure = function(view) {
    view.defBoard("Board");
    view.defPiece("WhiteC1", "White C1");
    view.defPiece("WhiteC2", "White C2");
    view.defPiece("WhiteC4", "White C4");
    view.defPiece("WhiteC6", "White C6");
    view.defPiece("WhiteC8", "White C8");
    view.defPiece("WhiteC16", "White C16");
    view.defPiece("BlackC16", "Black C16");
    view.defPiece("WhiteC36", "White C36");
    view.defPiece("WhiteC64", "White C64");
    view.defPiece("BlackC3", "Black C3");
    view.defPiece("BlackC5", "Black C5");
    view.defPiece("BlackC7", "Black C7");
    view.defPiece("BlackC9", "Black C9");
    view.defPiece("BlackC25", "Black C25");
    view.defPiece("BlackC49", "Black C49");
    view.defPiece("BlackC81", "Black C81");
    view.defPiece("WhiteT6", "White T6");
    view.defPiece("WhiteT9", "White T9");
    view.defPiece("WhiteT16", "White T16");
    view.defPiece("BlackT16", "Black T16");
    view.defPiece("WhiteT20", "White T20");
    view.defPiece("WhiteT25", "White T25");
    view.defPiece("BlackT25", "Black T25");
    view.defPiece("WhiteT42", "White T42");
    view.defPiece("WhiteT49", "White T49");
    view.defPiece("WhiteT72", "White T72");
    view.defPiece("WhiteT81", "White T81");
    view.defPiece("BlackT12", "Black T12");
    view.defPiece("BlackT16", "Black T16");
    view.defPiece("BlackT30", "Black T30");
    view.defPiece("BlackT36", "Black T36");
    view.defPiece("BlackT56", "Black T56");
    view.defPiece("BlackT64", "Black T64");
    view.defPiece("BlackT90", "Black T90");
    view.defPiece("BlackT100", "Black T100");
    view.defPiece("WhiteS15", "White S15");
    view.defPiece("WhiteS25", "White S25");
    view.defPiece("WhiteS36", "White S36");
    view.defPiece("WhiteS45", "White S45");
    view.defPiece("WhiteS81", "White S81");
    view.defPiece("WhiteS153", "White S153");
    view.defPiece("WhiteS169", "White S169");
    view.defPiece("WhiteS289", "White S289");
    view.defPiece("BlackS28", "Black S28");
    view.defPiece("BlackS49", "Black S49");
    view.defPiece("BlackS64", "Black S64");
    view.defPiece("BlackS66", "Black S66");
    view.defPiece("BlackS120", "Black S120");
    view.defPiece("BlackS121", "Black S121");
    view.defPiece("BlackS225", "Black S225");
    view.defPiece("BlackS361", "Black S361");
    view.defPiece("WhiteP5", "White P5");
    view.defPiece("WhiteP10", "White P10");
    view.defPiece("WhiteP13", "White P13");
    view.defPiece("WhiteP14", "White P14");
    view.defPiece("WhiteP17", "White P17");
    view.defPiece("WhiteP20", "White P20");
    view.defPiece("WhiteP21", "White P21");
    view.defPiece("WhiteP25", "White P25");
    view.defPiece("WhiteP26", "White P26");
    view.defPiece("WhiteP29", "White P29");
    view.defPiece("WhiteP30", "White P30");
    view.defPiece("WhiteP34", "White P34");
    view.defPiece("WhiteP35", "White P35");
    view.defPiece("WhiteP37", "White P37");
    view.defPiece("WhiteP38", "White P38");
    view.defPiece("WhiteP39", "White P39");
    view.defPiece("WhiteP40", "White P40");
    view.defPiece("WhiteP41", "White P41");
    view.defPiece("BlackP41", "Black P41");
    view.defPiece("WhiteP42", "White P42");
    view.defPiece("WhiteP45", "White P45");
    view.defPiece("WhiteP46", "White P46");
    view.defPiece("WhiteP49", "White P49");
    view.defPiece("WhiteP50", "White P50");
    view.defPiece("WhiteP51", "White P51");
    view.defPiece("WhiteP52", "White P52");
    view.defPiece("BlackP52", "Black P52");
    view.defPiece("WhiteP53", "White P53");
    view.defPiece("WhiteP54", "White P54");
    view.defPiece("WhiteP55", "White P55");
    view.defPiece("WhiteP56", "White P56");
    view.defPiece("WhiteP57", "White P57");
    view.defPiece("WhiteP61", "White P61");
    view.defPiece("BlackP61", "Black P61");
    view.defPiece("WhiteP62", "White P62");
    view.defPiece("WhiteP65", "White P65");
    view.defPiece("BlackP65", "Black P65");
    view.defPiece("WhiteP66", "White P66");
    view.defPiece("WhiteP70", "White P70");
    view.defPiece("WhiteP71", "White P71");
    view.defPiece("WhiteP74", "White P74");
    view.defPiece("BlackP74", "Black P74");
    view.defPiece("WhiteP75", "White P75");
    view.defPiece("WhiteP77", "White P77");
    view.defPiece("BlackP77", "Black P77");
    view.defPiece("WhiteP78", "White P78");
    view.defPiece("WhiteP81", "White P81");
    view.defPiece("WhiteP82", "White P82");
    view.defPiece("WhiteP86", "White P86");
    view.defPiece("WhiteP87", "White P87");
    view.defPiece("WhiteP90", "White P90");
    view.defPiece("BlackP90", "Black P90");
    view.defPiece("WhiteP91", "White P91");
    view.defPiece("BlackP73", "Black P73");
    view.defPiece("BlackP80", "Black P80");
    view.defPiece("BlackP85", "Black P85");
    view.defPiece("BlackP89", "Black P89");
    view.defPiece("BlackP98", "Black P98");
    view.defPiece("BlackP100", "Black P100");
    view.defPiece("BlackP101", "Black P101");
    view.defPiece("BlackP105", "Black P105");
    view.defPiece("BlackP110", "Black P110");
    view.defPiece("BlackP113", "Black P113");
    view.defPiece("BlackP114", "Black P114");
    view.defPiece("BlackP116", "Black P116");
    view.defPiece("BlackP125", "Black P125");
    view.defPiece("BlackP126", "Black P126");
    view.defPiece("BlackP141", "Black P141");
    view.defPiece("BlackP149", "Black P149");
    view.defPiece("BlackP165", "Black P165");
    view.defPiece("BlackP174", "Black P174");
    view.defPiece("BlackP190", "Black P190");
    view.defPiece("BlackP154", "Black P154");
    view.defPiece("BlackP129", "Black P129");
    view.defPiece("BlackP138", "Black P138");
 
    view.defPosition("a16", 44, 4, 32, 32);
    view.defPosition("b16", 79, 4, 32, 32);
    view.defPosition("c16", 114, 4, 32, 32);
    view.defPosition("d16", 149, 4, 32, 32);
    view.defPosition("e16", 184, 4, 32, 32);
    view.defPosition("f16", 219, 4, 32, 32);
    view.defPosition("g16", 254, 4, 32, 32);
    view.defPosition("h16", 289, 4, 32, 32);
    view.defPosition("a15", 44, 39, 32, 32);
    view.defPosition("b15", 79, 39, 32, 32);
    view.defPosition("c15", 114, 39, 32, 32);
    view.defPosition("d15", 149, 39, 32, 32);
    view.defPosition("e15", 184, 39, 32, 32);
    view.defPosition("f15", 219, 39, 32, 32);
    view.defPosition("g15", 254, 39, 32, 32);
    view.defPosition("h15", 289, 39, 32, 32);
    view.defPosition("a14", 44, 74, 32, 32);
    view.defPosition("b14", 79, 74, 32, 32);
    view.defPosition("c14", 114, 74, 32, 32);
    view.defPosition("d14", 149, 74, 32, 32);
    view.defPosition("e14", 184, 74, 32, 32);
    view.defPosition("f14", 219, 74, 32, 32);
    view.defPosition("g14", 254, 74, 32, 32);
    view.defPosition("h14", 289, 74, 32, 32);
    view.defPosition("a13", 44, 109, 32, 32);
    view.defPosition("b13", 79, 109, 32, 32);
    view.defPosition("c13", 114, 109, 32, 32);
    view.defPosition("d13", 149, 109, 32, 32);
    view.defPosition("e13", 184, 109, 32, 32);
    view.defPosition("f13", 219, 109, 32, 32);
    view.defPosition("g13", 254, 109, 32, 32);
    view.defPosition("h13", 289, 109, 32, 32);
    view.defPosition("a12", 44, 144, 32, 32);
    view.defPosition("b12", 79, 144, 32, 32);
    view.defPosition("c12", 114, 144, 32, 32);
    view.defPosition("d12", 149, 144, 32, 32);
    view.defPosition("e12", 184, 144, 32, 32);
    view.defPosition("f12", 219, 144, 32, 32);
    view.defPosition("g12", 254, 144, 32, 32);
    view.defPosition("h12", 289, 144, 32, 32);
    view.defPosition("a11", 44, 179, 32, 32);
    view.defPosition("b11", 79, 179, 32, 32);
    view.defPosition("c11", 114, 179, 32, 32);
    view.defPosition("d11", 149, 179, 32, 32);
    view.defPosition("e11", 184, 179, 32, 32);
    view.defPosition("f11", 219, 179, 32, 32);
    view.defPosition("g11", 254, 179, 32, 32);
    view.defPosition("h11", 289, 179, 32, 32);
    view.defPosition("a10", 44, 214, 32, 32);
    view.defPosition("b10", 79, 214, 32, 32);
    view.defPosition("c10", 114, 214, 32, 32);
    view.defPosition("d10", 149, 214, 32, 32);
    view.defPosition("e10", 184, 214, 32, 32);
    view.defPosition("f10", 219, 214, 32, 32);
    view.defPosition("g10", 254, 214, 32, 32);
    view.defPosition("h10", 289, 214, 32, 32);
    view.defPosition("a9", 44, 249, 32, 32);
    view.defPosition("b9", 79, 249, 32, 32);
    view.defPosition("c9", 114, 249, 32, 32);
    view.defPosition("d9", 149, 249, 32, 32);
    view.defPosition("e9", 184, 249, 32, 32);
    view.defPosition("f9", 219, 249, 32, 32);
    view.defPosition("g9", 254, 249, 32, 32);
    view.defPosition("h9", 289, 249, 32, 32);
    view.defPosition("a8", 44, 284, 32, 32);
    view.defPosition("b8", 79, 284, 32, 32);
    view.defPosition("c8", 114, 284, 32, 32);
    view.defPosition("d8", 149, 284, 32, 32);
    view.defPosition("e8", 184, 284, 32, 32);
    view.defPosition("f8", 219, 284, 32, 32);
    view.defPosition("g8", 254, 284, 32, 32);
    view.defPosition("h8", 289, 284, 32, 32);
    view.defPosition("a7", 44, 319, 32, 32);
    view.defPosition("b7", 79, 319, 32, 32);
    view.defPosition("c7", 114, 319, 32, 32);
    view.defPosition("d7", 149, 319, 32, 32);
    view.defPosition("e7", 184, 319, 32, 32);
    view.defPosition("f7", 219, 319, 32, 32);
    view.defPosition("g7", 254, 319, 32, 32);
    view.defPosition("h7", 289, 319, 32, 32);
    view.defPosition("a6", 44, 354, 32, 32);
    view.defPosition("b6", 79, 354, 32, 32);
    view.defPosition("c6", 114, 354, 32, 32);
    view.defPosition("d6", 149, 354, 32, 32);
    view.defPosition("e6", 184, 354, 32, 32);
    view.defPosition("f6", 219, 354, 32, 32);
    view.defPosition("g6", 254, 354, 32, 32);
    view.defPosition("h6", 289, 354, 32, 32);
    view.defPosition("a5", 44, 389, 32, 32);
    view.defPosition("b5", 79, 389, 32, 32);
    view.defPosition("c5", 114, 389, 32, 32);
    view.defPosition("d5", 149, 389, 32, 32);
    view.defPosition("e5", 184, 389, 32, 32);
    view.defPosition("f5", 219, 389, 32, 32);
    view.defPosition("g5", 254, 389, 32, 32);
    view.defPosition("h5", 289, 389, 32, 32);
    view.defPosition("a4", 44, 424, 32, 32);
    view.defPosition("b4", 79, 424, 32, 32);
    view.defPosition("c4", 114, 424, 32, 32);
    view.defPosition("d4", 149, 424, 32, 32);
    view.defPosition("e4", 184, 424, 32, 32);
    view.defPosition("f4", 219, 424, 32, 32);
    view.defPosition("g4", 254, 424, 32, 32);
    view.defPosition("h4", 289, 424, 32, 32);
    view.defPosition("a3", 44, 459, 32, 32);
    view.defPosition("b3", 79, 459, 32, 32);
    view.defPosition("c3", 114, 459, 32, 32);
    view.defPosition("d3", 149, 459, 32, 32);
    view.defPosition("e3", 184, 459, 32, 32);
    view.defPosition("f3", 219, 459, 32, 32);
    view.defPosition("g3", 254, 459, 32, 32);
    view.defPosition("h3", 289, 459, 32, 32);
    view.defPosition("a2", 44, 494, 32, 32);
    view.defPosition("b2", 79, 494, 32, 32);
    view.defPosition("c2", 114, 494, 32, 32);
    view.defPosition("d2", 149, 494, 32, 32);
    view.defPosition("e2", 184, 494, 32, 32);
    view.defPosition("f2", 219, 494, 32, 32);
    view.defPosition("g2", 254, 494, 32, 32);
    view.defPosition("h2", 289, 494, 32, 32);
    view.defPosition("a1", 44, 529, 32, 32);
    view.defPosition("b1", 79, 529, 32, 32);
    view.defPosition("c1", 114, 529, 32, 32);
    view.defPosition("d1", 149, 529, 32, 32);
    view.defPosition("e1", 184, 529, 32, 32);
    view.defPosition("f1", 219, 529, 32, 32);
    view.defPosition("g1", 254, 529, 32, 32);
    view.defPosition("h1", 289, 529, 32, 32);
    view.defPosition("y1", 3, 4, 32, 32);
    view.defPosition("y2", 3, 39, 32, 32);
    view.defPosition("y3", 3, 74, 32, 32);
    view.defPosition("y4", 3, 109, 32, 32);
    view.defPosition("y5", 3, 144, 32, 32);
    view.defPosition("y6", 3, 179, 32, 32);
    view.defPosition("x1", 330, 529, 32, 32);
    view.defPosition("x2", 330, 494, 32, 32);
    view.defPosition("x3", 330, 459, 32, 32);
    view.defPosition("x4", 330, 424, 32, 32);
    view.defPosition("x5", 330, 389, 32, 32);
    view.defPosition("x6", 330, 354, 32, 32);
}
