ZRF = {
    JUMP:          0,
    IF:            1,
    FORK:          2,
    FUNCTION:      3,
    IN_ZONE:       4,
    FLAG:          5,
    SET_FLAG:      6,
    POS_FLAG:      7,
    SET_POS_FLAG:  8,
    ATTR:          9,
    SET_ATTR:      10,
    PROMOTE:       11,
    MODE:          12,
    ON_BOARD_DIR:  13,
    ON_BOARD_POS:  14,
    PARAM:         15,
    LITERAL:       16,
    VERIFY:        20
};

Dagaz.Model.BuildDesign = function(design) {
    design.checkVersion("z2j", "2");
    design.checkVersion("animate-captures", "false");
    design.checkVersion("smart-moves", "false");
    design.checkVersion("show-blink", "false");
    design.checkVersion("shared-pieces", "true");
    design.checkVersion("pasang-extension", "true");

    design.addDirection("w");
    design.addDirection("e");
    design.addDirection("s");
    design.addDirection("n");
    design.addDirection("gr");
    design.addDirection("sd");

    design.addPlayer("Blue", [1, 0, 3, 2, 4, 5]);
    design.addPlayer("Red", [0, 1, 2, 3, 4, 5]);
    design.addPlayer("N", [0, 1, 2, 3, 4, 5]);
    design.addTurn(1);
    design.addTurn(2);

    design.addPosition("a11", [0, 1, 11, 0, 44, 110]);
    design.addPosition("b11", [-1, 1, 11, 0, 44, 109]);
    design.addPosition("c11", [-1, 1, 11, 0, 44, 108]);
    design.addPosition("d11", [-1, 1, 11, 0, 44, 107]);
    design.addPosition("e11", [-1, 1, 11, 0, 44, 106]);
    design.addPosition("f11", [-1, 1, 11, 0, 44, 110]);
    design.addPosition("g11", [-1, 1, 11, 0, 44, 110]);
    design.addPosition("h11", [-1, 1, 11, 0, 44, 109]);
    design.addPosition("i11", [-1, 1, 11, 0, 44, 108]);
    design.addPosition("j11", [-1, 1, 11, 0, 44, 107]);
    design.addPosition("k11", [-1, 0, 11, 0, 44, 106]);
    design.addPosition("a10", [0, 1, 11, -11, -11, 99]);
    design.addPosition("b10", [-1, 1, 11, -11, -11, 98]);
    design.addPosition("c10", [-1, 1, 11, -11, -11, 97]);
    design.addPosition("d10", [-1, 1, 11, -11, -11, 96]);
    design.addPosition("e10", [-1, 1, 11, -11, -11, 95]);
    design.addPosition("f10", [-1, 1, 11, -11, -11, 99]);
    design.addPosition("g10", [-1, 1, 11, -11, -11, 99]);
    design.addPosition("h10", [-1, 1, 11, -11, -11, 98]);
    design.addPosition("i10", [-1, 1, 11, -11, -11, 97]);
    design.addPosition("j10", [-1, 1, 11, -11, -11, 96]);
    design.addPosition("k10", [-1, 0, 11, -11, -11, 95]);
    design.addPosition("a9", [0, 1, 11, -11, -11, 88]);
    design.addPosition("b9", [-1, 1, 11, -11, -11, 87]);
    design.addPosition("c9", [-1, 1, 11, -11, -11, 86]);
    design.addPosition("d9", [-1, 1, 11, -11, -11, 85]);
    design.addPosition("e9", [-1, 1, 11, -11, -11, 84]);
    design.addPosition("f9", [-1, 1, 11, -11, -11, 88]);
    design.addPosition("g9", [-1, 1, 11, -11, -11, 88]);
    design.addPosition("h9", [-1, 1, 11, -11, -11, 87]);
    design.addPosition("i9", [-1, 1, 11, -11, -11, 86]);
    design.addPosition("j9", [-1, 1, 11, -11, -11, 85]);
    design.addPosition("k9", [-1, 0, 11, -11, -11, 84]);
    design.addPosition("a8", [0, 1, 11, -11, -11, 77]);
    design.addPosition("b8", [-1, 1, 11, -11, -11, 76]);
    design.addPosition("c8", [-1, 1, 11, -11, -11, 75]);
    design.addPosition("d8", [-1, 1, 11, -11, -11, 74]);
    design.addPosition("e8", [-1, 1, 11, -11, -11, 73]);
    design.addPosition("f8", [-1, 1, 11, -11, -11, 77]);
    design.addPosition("g8", [-1, 1, 11, -11, -11, 77]);
    design.addPosition("h8", [-1, 1, 11, -11, -11, 76]);
    design.addPosition("i8", [-1, 1, 11, -11, -11, 75]);
    design.addPosition("j8", [-1, 1, 11, -11, -11, 74]);
    design.addPosition("k8", [-1, 0, 11, -11, -11, 73]);
    design.addPosition("a7", [0, 1, 11, -11, -11, 66]);
    design.addPosition("b7", [-1, 1, 11, -11, -11, 65]);
    design.addPosition("c7", [-1, 1, 11, -11, -11, 64]);
    design.addPosition("d7", [-1, 1, 11, -11, -11, 63]);
    design.addPosition("e7", [-1, 1, 11, -11, -11, 62]);
    design.addPosition("f7", [-1, 1, 0, -11, -11, 66]);
    design.addPosition("g7", [-1, 1, 11, -11, -11, 66]);
    design.addPosition("h7", [-1, 1, 11, -11, -11, 65]);
    design.addPosition("i7", [-1, 1, 11, -11, -11, 64]);
    design.addPosition("j7", [-1, 1, 11, -11, -11, 63]);
    design.addPosition("k7", [-1, 0, 11, -11, -11, 62]);
    design.addPosition("a6", [0, 1, 11, -11, 0, 0]);
    design.addPosition("b6", [-1, 1, 11, -11, 0, 0]);
    design.addPosition("c6", [-1, 1, 11, -11, 0, 0]);
    design.addPosition("d6", [-1, 1, 11, -11, 0, 0]);
    design.addPosition("e6", [-1, 0, 11, -11, 0, 0]);
    design.addPosition("f6", [0, 0, 0, 0, 0, 0]);
    design.addPosition("g6", [0, 1, 11, -11, 0, 0]);
    design.addPosition("h6", [-1, 1, 11, -11, 0, 0]);
    design.addPosition("i6", [-1, 1, 11, -11, 0, 0]);
    design.addPosition("j6", [-1, 1, 11, -11, 0, 0]);
    design.addPosition("k6", [-1, 0, 11, -11, 0, 0]);
    design.addPosition("a5", [0, 1, 11, -11, 44, 45]);
    design.addPosition("b5", [-1, 1, 11, -11, 44, 45]);
    design.addPosition("c5", [-1, 1, 11, -11, 44, 45]);
    design.addPosition("d5", [-1, 1, 11, -11, 44, 45]);
    design.addPosition("e5", [-1, 1, 11, -11, 44, 0]);
    design.addPosition("f5", [-1, 1, 11, 0, 44, 0]);
    design.addPosition("g5", [-1, 1, 11, -11, 44, 45]);
    design.addPosition("h5", [-1, 1, 11, -11, 44, 45]);
    design.addPosition("i5", [-1, 1, 11, -11, 44, 45]);
    design.addPosition("j5", [-1, 1, 11, -11, 44, 45]);
    design.addPosition("k5", [-1, 0, 11, -11, 44, 0]);
    design.addPosition("a4", [0, 1, 11, -11, -11, -11]);
    design.addPosition("b4", [-1, 1, 11, -11, -11, -11]);
    design.addPosition("c4", [-1, 1, 11, -11, -11, -11]);
    design.addPosition("d4", [-1, 1, 11, -11, -11, -11]);
    design.addPosition("e4", [-1, 1, 11, -11, -11, -11]);
    design.addPosition("f4", [-1, 1, 11, -11, -11, -11]);
    design.addPosition("g4", [-1, 1, 11, -11, -11, -11]);
    design.addPosition("h4", [-1, 1, 11, -11, -11, -11]);
    design.addPosition("i4", [-1, 1, 11, -11, -11, -11]);
    design.addPosition("j4", [-1, 1, 11, -11, -11, -11]);
    design.addPosition("k4", [-1, 0, 11, -11, -11, -11]);
    design.addPosition("a3", [0, 1, 11, -11, -11, -11]);
    design.addPosition("b3", [-1, 1, 11, -11, -11, -11]);
    design.addPosition("c3", [-1, 1, 11, -11, -11, -11]);
    design.addPosition("d3", [-1, 1, 11, -11, -11, -11]);
    design.addPosition("e3", [-1, 1, 11, -11, -11, -11]);
    design.addPosition("f3", [-1, 1, 11, -11, -11, -11]);
    design.addPosition("g3", [-1, 1, 11, -11, -11, -11]);
    design.addPosition("h3", [-1, 1, 11, -11, -11, -11]);
    design.addPosition("i3", [-1, 1, 11, -11, -11, -11]);
    design.addPosition("j3", [-1, 1, 11, -11, -11, -11]);
    design.addPosition("k3", [-1, 0, 11, -11, -11, -11]);
    design.addPosition("a2", [0, 1, 11, -11, -11, -11]);
    design.addPosition("b2", [-1, 1, 11, -11, -11, -11]);
    design.addPosition("c2", [-1, 1, 11, -11, -11, -11]);
    design.addPosition("d2", [-1, 1, 11, -11, -11, -11]);
    design.addPosition("e2", [-1, 1, 11, -11, -11, -11]);
    design.addPosition("f2", [-1, 1, 11, -11, -11, -11]);
    design.addPosition("g2", [-1, 1, 11, -11, -11, -11]);
    design.addPosition("h2", [-1, 1, 11, -11, -11, -11]);
    design.addPosition("i2", [-1, 1, 11, -11, -11, -11]);
    design.addPosition("j2", [-1, 1, 11, -11, -11, -11]);
    design.addPosition("k2", [-1, 0, 11, -11, -11, -11]);
    design.addPosition("a1", [0, 1, 0, -11, -11, -11]);
    design.addPosition("b1", [-1, 1, 0, -11, -11, -11]);
    design.addPosition("c1", [-1, 1, 0, -11, -11, -11]);
    design.addPosition("d1", [-1, 1, 0, -11, -11, -11]);
    design.addPosition("e1", [-1, 1, 0, -11, -11, -11]);
    design.addPosition("f1", [-1, 1, 0, -11, -11, -11]);
    design.addPosition("g1", [-1, 1, 0, -11, -11, -11]);
    design.addPosition("h1", [-1, 1, 0, -11, -11, -11]);
    design.addPosition("i1", [-1, 1, 0, -11, -11, -11]);
    design.addPosition("j1", [-1, 1, 0, -11, -11, -11]);
    design.addPosition("k1", [-1, 0, 0, -11, -11, -11]);

    design.addZone("home-zone", 1, [110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76]);
    design.addZone("home-zone", 2, [44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10]);

    design.addCommand(0, ZRF.FUNCTION,	24);	// from
    design.addCommand(0, ZRF.FUNCTION,	3);	// friend?
    design.addCommand(0, ZRF.FUNCTION,	20);	// verify
    design.addCommand(0, ZRF.PARAM,	0);	// $1
    design.addCommand(0, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(0, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(0, ZRF.FUNCTION,	0);	// not
    design.addCommand(0, ZRF.IF,	7);
    design.addCommand(0, ZRF.FORK,	3);
    design.addCommand(0, ZRF.FUNCTION,	25);	// to
    design.addCommand(0, ZRF.FUNCTION,	28);	// end
    design.addCommand(0, ZRF.PARAM,	1);	// $2
    design.addCommand(0, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(0, ZRF.JUMP,	-8);
    design.addCommand(0, ZRF.FUNCTION,	28);	// end

    design.addCommand(1, ZRF.FUNCTION,	24);	// from
    design.addCommand(1, ZRF.IN_ZONE,	0);	// home-zone
    design.addCommand(1, ZRF.FUNCTION,	20);	// verify
    design.addCommand(1, ZRF.FUNCTION,	26);	// capture
    design.addCommand(1, ZRF.FUNCTION,	25);	// to
    design.addCommand(1, ZRF.FUNCTION,	28);	// end

    design.addCommand(2, ZRF.FUNCTION,	24);	// from
    design.addCommand(2, ZRF.IN_ZONE,	0);	// home-zone
    design.addCommand(2, ZRF.FUNCTION,	20);	// verify
    design.addCommand(2, ZRF.PARAM,	0);	// $1
    design.addCommand(2, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(2, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(2, ZRF.FUNCTION,	20);	// verify
    design.addCommand(2, ZRF.PROMOTE,	0);	// Ka
    design.addCommand(2, ZRF.FUNCTION,	25);	// to
    design.addCommand(2, ZRF.FUNCTION,	28);	// end

    design.addCommand(3, ZRF.FUNCTION,	24);	// from
    design.addCommand(3, ZRF.IN_ZONE,	0);	// home-zone
    design.addCommand(3, ZRF.FUNCTION,	20);	// verify
    design.addCommand(3, ZRF.PARAM,	0);	// $1
    design.addCommand(3, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(3, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(3, ZRF.FUNCTION,	0);	// not
    design.addCommand(3, ZRF.FUNCTION,	20);	// verify
    design.addCommand(3, ZRF.PARAM,	1);	// $2
    design.addCommand(3, ZRF.FUNCTION,	22);	// navigate
    design.addCommand(3, ZRF.FUNCTION,	1);	// empty?
    design.addCommand(3, ZRF.FUNCTION,	20);	// verify
    design.addCommand(3, ZRF.PROMOTE,	0);	// Ka
    design.addCommand(3, ZRF.FUNCTION,	25);	// to
    design.addCommand(3, ZRF.FUNCTION,	28);	// end

    design.addPriority(0);			// priority-type
    design.addPriority(1);			// normal-type

    design.addPiece("Ka", 0);
    design.addMove(0, 0, [3, 3], 0);
    design.addMove(0, 0, [2, 2], 0);
    design.addMove(0, 0, [0, 0], 0);
    design.addMove(0, 0, [1, 1], 0);

    design.addPiece("Black", 1);
    design.addMove(1, 1, [], 1);
    design.addMove(1, 2, [3], 1);
    design.addMove(1, 2, [2], 1);
    design.addMove(1, 2, [0], 1);
    design.addMove(1, 2, [1], 1);
    design.addMove(1, 3, [3, 3], 1);
    design.addMove(1, 3, [2, 2], 1);
    design.addMove(1, 3, [0, 0], 1);
    design.addMove(1, 3, [1, 1], 1);

    design.addPiece("White", 2);
    design.addMove(2, 1, [], 1);
    design.addMove(2, 2, [3], 1);
    design.addMove(2, 2, [2], 1);
    design.addMove(2, 2, [0], 1);
    design.addMove(2, 2, [1], 1);
    design.addMove(2, 3, [3, 3], 1);
    design.addMove(2, 3, [2, 2], 1);
    design.addMove(2, 3, [0, 0], 1);
    design.addMove(2, 3, [1, 1], 1);

    design.setupSelector(39);

    design.setup("N", "Black", 11, 1);
    design.setup("N", "Black", 55, 1);
    design.setup("N", "Black", 44, 1);
    design.setup("N", "Black", 33, 1);
    design.setup("N", "Black", 22, 1);
    design.setup("N", "Black", 111, 1);
    design.setup("N", "Black", 56, 1);
    design.setup("N", "Black", 45, 1);
    design.setup("N", "Black", 34, 1);
    design.setup("N", "Black", 23, 1);
    design.setup("N", "Black", 112, 1);
    design.setup("N", "Black", 101, 1);
    design.setup("N", "Black", 57, 1);
    design.setup("N", "Black", 46, 1);
    design.setup("N", "Black", 35, 1);
    design.setup("N", "Black", 113, 1);
    design.setup("N", "Black", 102, 1);
    design.setup("N", "Black", 91, 1);
    design.setup("N", "Black", 58, 1);
    design.setup("N", "Black", 47, 1);
    design.setup("N", "Black", 114, 1);
    design.setup("N", "Black", 103, 1);
    design.setup("N", "Black", 92, 1);
    design.setup("N", "Black", 81, 1);
    design.setup("N", "Black", 59, 1);
    design.setup("N", "Black", 115, 1);
    design.setup("N", "Black", 16, 1);
    design.setup("N", "Black", 5, 1);
    design.setup("N", "Black", 104, 1);
    design.setup("N", "Black", 93, 1);
    design.setup("N", "Black", 82, 1);
    design.setup("N", "Black", 71, 1);
    design.setup("N", "Black", 49, 1);
    design.setup("N", "Black", 38, 1);
    design.setup("N", "Black", 27, 1);
    design.setup("N", "Black", 17, 1);
    design.setup("N", "Black", 6, 1);
    design.setup("N", "Black", 61, 1);
    design.setup("N", "Black", 39, 1);
    design.setup("N", "Black", 28, 1);
    design.setup("N", "Black", 18, 1);
    design.setup("N", "Black", 7, 1);
    design.setup("N", "Black", 73, 1);
    design.setup("N", "Black", 62, 1);
    design.setup("N", "Black", 29, 1);
    design.setup("N", "Black", 19, 1);
    design.setup("N", "Black", 8, 1);
    design.setup("N", "Black", 85, 1);
    design.setup("N", "Black", 74, 1);
    design.setup("N", "Black", 63, 1);
    design.setup("N", "Black", 9, 1);
    design.setup("N", "Black", 97, 1);
    design.setup("N", "Black", 86, 1);
    design.setup("N", "Black", 75, 1);
    design.setup("N", "Black", 64, 1);
    design.setup("N", "Black", 109, 1);
    design.setup("N", "Black", 98, 1);
    design.setup("N", "Black", 87, 1);
    design.setup("N", "Black", 76, 1);
    design.setup("N", "Black", 65, 1);
    design.setup("N", "White", 110, 1);
    design.setup("N", "White", 0, 1);
    design.setup("N", "White", 99, 1);
    design.setup("N", "White", 88, 1);
    design.setup("N", "White", 77, 1);
    design.setup("N", "White", 66, 1);
    design.setup("N", "White", 12, 1);
    design.setup("N", "White", 1, 1);
    design.setup("N", "White", 100, 1);
    design.setup("N", "White", 89, 1);
    design.setup("N", "White", 78, 1);
    design.setup("N", "White", 67, 1);
    design.setup("N", "White", 13, 1);
    design.setup("N", "White", 2, 1);
    design.setup("N", "White", 90, 1);
    design.setup("N", "White", 79, 1);
    design.setup("N", "White", 68, 1);
    design.setup("N", "White", 24, 1);
    design.setup("N", "White", 14, 1);
    design.setup("N", "White", 3, 1);
    design.setup("N", "White", 80, 1);
    design.setup("N", "White", 69, 1);
    design.setup("N", "White", 36, 1);
    design.setup("N", "White", 25, 1);
    design.setup("N", "White", 15, 1);
    design.setup("N", "White", 4, 1);
    design.setup("N", "White", 70, 1);
    design.setup("N", "White", 48, 1);
    design.setup("N", "White", 37, 1);
    design.setup("N", "White", 26, 1);
    design.setup("N", "White", 116, 1);
    design.setup("N", "White", 105, 1);
    design.setup("N", "White", 94, 1);
    design.setup("N", "White", 83, 1);
    design.setup("N", "White", 72, 1);
    design.setup("N", "White", 50, 1);
    design.setup("N", "White", 117, 1);
    design.setup("N", "White", 106, 1);
    design.setup("N", "White", 95, 1);
    design.setup("N", "White", 84, 1);
    design.setup("N", "White", 51, 1);
    design.setup("N", "White", 40, 1);
    design.setup("N", "White", 118, 1);
    design.setup("N", "White", 107, 1);
    design.setup("N", "White", 96, 1);
    design.setup("N", "White", 52, 1);
    design.setup("N", "White", 41, 1);
    design.setup("N", "White", 30, 1);
    design.setup("N", "White", 119, 1);
    design.setup("N", "White", 20, 1);
    design.setup("N", "White", 108, 1);
    design.setup("N", "White", 53, 1);
    design.setup("N", "White", 42, 1);
    design.setup("N", "White", 31, 1);
    design.setup("N", "White", 120, 1);
    design.setup("N", "White", 21, 1);
    design.setup("N", "White", 10, 1);
    design.setup("N", "White", 54, 1);
    design.setup("N", "White", 43, 1);
    design.setup("N", "White", 32, 1);

    design.setup("N", "Black", 11, 2);
    design.setup("N", "Black", 99, 2);
    design.setup("N", "Black", 66, 2);
    design.setup("N", "Black", 44, 2);
    design.setup("N", "Black", 111, 2);
    design.setup("N", "Black", 12, 2);
    design.setup("N", "Black", 1, 2);
    design.setup("N", "Black", 100, 2);
    design.setup("N", "Black", 89, 2);
    design.setup("N", "Black", 56, 2);
    design.setup("N", "Black", 23, 2);
    design.setup("N", "Black", 13, 2);
    design.setup("N", "Black", 101, 2);
    design.setup("N", "Black", 79, 2);
    design.setup("N", "Black", 57, 2);
    design.setup("N", "Black", 35, 2);
    design.setup("N", "Black", 91, 2);
    design.setup("N", "Black", 80, 2);
    design.setup("N", "Black", 69, 2);
    design.setup("N", "Black", 47, 2);
    design.setup("N", "Black", 36, 2);
    design.setup("N", "Black", 25, 2);
    design.setup("N", "Black", 114, 2);
    design.setup("N", "Black", 4, 2);
    design.setup("N", "Black", 81, 2);
    design.setup("N", "Black", 59, 2);
    design.setup("N", "Black", 37, 2);
    design.setup("N", "Black", 16, 2);
    design.setup("N", "Black", 104, 2);
    design.setup("N", "Black", 93, 2);
    design.setup("N", "Black", 71, 2);
    design.setup("N", "Black", 49, 2);
    design.setup("N", "Black", 27, 2);
    design.setup("N", "Black", 116, 2);
    design.setup("N", "Black", 6, 2);
    design.setup("N", "Black", 83, 2);
    design.setup("N", "Black", 61, 2);
    design.setup("N", "Black", 39, 2);
    design.setup("N", "Black", 95, 2);
    design.setup("N", "Black", 84, 2);
    design.setup("N", "Black", 73, 2);
    design.setup("N", "Black", 51, 2);
    design.setup("N", "Black", 40, 2);
    design.setup("N", "Black", 29, 2);
    design.setup("N", "Black", 19, 2);
    design.setup("N", "Black", 107, 2);
    design.setup("N", "Black", 85, 2);
    design.setup("N", "Black", 63, 2);
    design.setup("N", "Black", 41, 2);
    design.setup("N", "Black", 119, 2);
    design.setup("N", "Black", 20, 2);
    design.setup("N", "Black", 9, 2);
    design.setup("N", "Black", 108, 2);
    design.setup("N", "Black", 97, 2);
    design.setup("N", "Black", 64, 2);
    design.setup("N", "Black", 31, 2);
    design.setup("N", "Black", 21, 2);
    design.setup("N", "Black", 109, 2);
    design.setup("N", "Black", 76, 2);
    design.setup("N", "Black", 54, 2);
    design.setup("N", "White", 110, 2);
    design.setup("N", "White", 0, 2);
    design.setup("N", "White", 88, 2);
    design.setup("N", "White", 77, 2);
    design.setup("N", "White", 55, 2);
    design.setup("N", "White", 33, 2);
    design.setup("N", "White", 22, 2);
    design.setup("N", "White", 78, 2);
    design.setup("N", "White", 67, 2);
    design.setup("N", "White", 45, 2);
    design.setup("N", "White", 34, 2);
    design.setup("N", "White", 112, 2);
    design.setup("N", "White", 2, 2);
    design.setup("N", "White", 90, 2);
    design.setup("N", "White", 68, 2);
    design.setup("N", "White", 46, 2);
    design.setup("N", "White", 24, 2);
    design.setup("N", "White", 113, 2);
    design.setup("N", "White", 14, 2);
    design.setup("N", "White", 3, 2);
    design.setup("N", "White", 102, 2);
    design.setup("N", "White", 58, 2);
    design.setup("N", "White", 15, 2);
    design.setup("N", "White", 103, 2);
    design.setup("N", "White", 92, 2);
    design.setup("N", "White", 70, 2);
    design.setup("N", "White", 48, 2);
    design.setup("N", "White", 26, 2);
    design.setup("N", "White", 115, 2);
    design.setup("N", "White", 5, 2);
    design.setup("N", "White", 82, 2);
    design.setup("N", "White", 38, 2);
    design.setup("N", "White", 17, 2);
    design.setup("N", "White", 105, 2);
    design.setup("N", "White", 94, 2);
    design.setup("N", "White", 72, 2);
    design.setup("N", "White", 50, 2);
    design.setup("N", "White", 28, 2);
    design.setup("N", "White", 117, 2);
    design.setup("N", "White", 18, 2);
    design.setup("N", "White", 7, 2);
    design.setup("N", "White", 106, 2);
    design.setup("N", "White", 62, 2);
    design.setup("N", "White", 118, 2);
    design.setup("N", "White", 8, 2);
    design.setup("N", "White", 96, 2);
    design.setup("N", "White", 74, 2);
    design.setup("N", "White", 52, 2);
    design.setup("N", "White", 30, 2);
    design.setup("N", "White", 86, 2);
    design.setup("N", "White", 75, 2);
    design.setup("N", "White", 53, 2);
    design.setup("N", "White", 42, 2);
    design.setup("N", "White", 120, 2);
    design.setup("N", "White", 10, 2);
    design.setup("N", "White", 98, 2);
    design.setup("N", "White", 87, 2);
    design.setup("N", "White", 65, 2);
    design.setup("N", "White", 43, 2);
    design.setup("N", "White", 32, 2);

    design.setup("N", "Black", 61, 3);
    design.setup("N", "Black", 88, 3);
    design.setup("N", "Black", 77, 3);
    design.setup("N", "Black", 66, 3);
    design.setup("N", "Black", 44, 3);
    design.setup("N", "Black", 33, 3);
    design.setup("N", "Black", 22, 3);
    design.setup("N", "Black", 78, 3);
    design.setup("N", "Black", 67, 3);
    design.setup("N", "Black", 45, 3);
    design.setup("N", "Black", 34, 3);
    design.setup("N", "Black", 112, 3);
    design.setup("N", "Black", 2, 3);
    design.setup("N", "Black", 68, 3);
    design.setup("N", "Black", 57, 3);
    design.setup("N", "Black", 46, 3);
    design.setup("N", "Black", 113, 3);
    design.setup("N", "Black", 14, 3);
    design.setup("N", "Black", 3, 3);
    design.setup("N", "Black", 102, 3);
    design.setup("N", "Black", 58, 3);
    design.setup("N", "Black", 114, 3);
    design.setup("N", "Black", 15, 3);
    design.setup("N", "Black", 4, 3);
    design.setup("N", "Black", 103, 3);
    design.setup("N", "Black", 92, 3);
    design.setup("N", "Black", 59, 3);
    design.setup("N", "Black", 26, 3);
    design.setup("N", "Black", 93, 3);
    design.setup("N", "Black", 82, 3);
    design.setup("N", "Black", 71, 3);
    design.setup("N", "Black", 49, 3);
    design.setup("N", "Black", 38, 3);
    design.setup("N", "Black", 27, 3);
    design.setup("N", "Black", 116, 3);
    design.setup("N", "Black", 17, 3);
    design.setup("N", "Black", 6, 3);
    design.setup("N", "Black", 105, 3);
    design.setup("N", "Black", 94, 3);
    design.setup("N", "Black", 28, 3);
    design.setup("N", "Black", 117, 3);
    design.setup("N", "Black", 18, 3);
    design.setup("N", "Black", 7, 3);
    design.setup("N", "Black", 106, 3);
    design.setup("N", "Black", 62, 3);
    design.setup("N", "Black", 118, 3);
    design.setup("N", "Black", 8, 3);
    design.setup("N", "Black", 74, 3);
    design.setup("N", "Black", 63, 3);
    design.setup("N", "Black", 52, 3);
    design.setup("N", "Black", 86, 3);
    design.setup("N", "Black", 75, 3);
    design.setup("N", "Black", 53, 3);
    design.setup("N", "Black", 42, 3);
    design.setup("N", "Black", 98, 3);
    design.setup("N", "Black", 87, 3);
    design.setup("N", "Black", 76, 3);
    design.setup("N", "Black", 54, 3);
    design.setup("N", "Black", 43, 3);
    design.setup("N", "Black", 32, 3);
    design.setup("N", "White", 110, 3);
    design.setup("N", "White", 11, 3);
    design.setup("N", "White", 0, 3);
    design.setup("N", "White", 99, 3);
    design.setup("N", "White", 55, 3);
    design.setup("N", "White", 111, 3);
    design.setup("N", "White", 12, 3);
    design.setup("N", "White", 1, 3);
    design.setup("N", "White", 100, 3);
    design.setup("N", "White", 89, 3);
    design.setup("N", "White", 56, 3);
    design.setup("N", "White", 23, 3);
    design.setup("N", "White", 13, 3);
    design.setup("N", "White", 101, 3);
    design.setup("N", "White", 90, 3);
    design.setup("N", "White", 79, 3);
    design.setup("N", "White", 35, 3);
    design.setup("N", "White", 24, 3);
    design.setup("N", "White", 91, 3);
    design.setup("N", "White", 80, 3);
    design.setup("N", "White", 69, 3);
    design.setup("N", "White", 47, 3);
    design.setup("N", "White", 36, 3);
    design.setup("N", "White", 25, 3);
    design.setup("N", "White", 81, 3);
    design.setup("N", "White", 70, 3);
    design.setup("N", "White", 48, 3);
    design.setup("N", "White", 37, 3);
    design.setup("N", "White", 115, 3);
    design.setup("N", "White", 16, 3);
    design.setup("N", "White", 5, 3);
    design.setup("N", "White", 104, 3);
    design.setup("N", "White", 83, 3);
    design.setup("N", "White", 72, 3);
    design.setup("N", "White", 50, 3);
    design.setup("N", "White", 39, 3);
    design.setup("N", "White", 95, 3);
    design.setup("N", "White", 84, 3);
    design.setup("N", "White", 73, 3);
    design.setup("N", "White", 51, 3);
    design.setup("N", "White", 40, 3);
    design.setup("N", "White", 29, 3);
    design.setup("N", "White", 19, 3);
    design.setup("N", "White", 107, 3);
    design.setup("N", "White", 96, 3);
    design.setup("N", "White", 85, 3);
    design.setup("N", "White", 41, 3);
    design.setup("N", "White", 30, 3);
    design.setup("N", "White", 119, 3);
    design.setup("N", "White", 20, 3);
    design.setup("N", "White", 9, 3);
    design.setup("N", "White", 108, 3);
    design.setup("N", "White", 97, 3);
    design.setup("N", "White", 64, 3);
    design.setup("N", "White", 31, 3);
    design.setup("N", "White", 120, 3);
    design.setup("N", "White", 21, 3);
    design.setup("N", "White", 10, 3);
    design.setup("N", "White", 109, 3);
    design.setup("N", "White", 65, 3);

    design.setup("N", "Black", 11, 4);
    design.setup("N", "Black", 99, 4);
    design.setup("N", "Black", 66, 4);
    design.setup("N", "Black", 55, 4);
    design.setup("N", "Black", 22, 4);
    design.setup("N", "Black", 111, 4);
    design.setup("N", "Black", 12, 4);
    design.setup("N", "Black", 1, 4);
    design.setup("N", "Black", 100, 4);
    design.setup("N", "Black", 89, 4);
    design.setup("N", "Black", 56, 4);
    design.setup("N", "Black", 45, 4);
    design.setup("N", "Black", 2, 4);
    design.setup("N", "Black", 101, 4);
    design.setup("N", "Black", 79, 4);
    design.setup("N", "Black", 46, 4);
    design.setup("N", "Black", 35, 4);
    design.setup("N", "Black", 91, 4);
    design.setup("N", "Black", 80, 4);
    design.setup("N", "Black", 69, 4);
    design.setup("N", "Black", 36, 4);
    design.setup("N", "Black", 25, 4);
    design.setup("N", "Black", 114, 4);
    design.setup("N", "Black", 15, 4);
    design.setup("N", "Black", 81, 4);
    design.setup("N", "Black", 59, 4);
    design.setup("N", "Black", 26, 4);
    design.setup("N", "Black", 115, 4);
    design.setup("N", "Black", 16, 4);
    design.setup("N", "Black", 5, 4);
    design.setup("N", "Black", 104, 4);
    design.setup("N", "Black", 71, 4);
    design.setup("N", "Black", 49, 4);
    design.setup("N", "Black", 6, 4);
    design.setup("N", "Black", 105, 4);
    design.setup("N", "Black", 94, 4);
    design.setup("N", "Black", 61, 4);
    design.setup("N", "Black", 39, 4);
    design.setup("N", "Black", 95, 4);
    design.setup("N", "Black", 84, 4);
    design.setup("N", "Black", 51, 4);
    design.setup("N", "Black", 40, 4);
    design.setup("N", "Black", 29, 4);
    design.setup("N", "Black", 118, 4);
    design.setup("N", "Black", 19, 4);
    design.setup("N", "Black", 85, 4);
    design.setup("N", "Black", 74, 4);
    design.setup("N", "Black", 41, 4);
    design.setup("N", "Black", 119, 4);
    design.setup("N", "Black", 20, 4);
    design.setup("N", "Black", 9, 4);
    design.setup("N", "Black", 108, 4);
    design.setup("N", "Black", 75, 4);
    design.setup("N", "Black", 64, 4);
    design.setup("N", "Black", 31, 4);
    design.setup("N", "Black", 21, 4);
    design.setup("N", "Black", 109, 4);
    design.setup("N", "Black", 98, 4);
    design.setup("N", "Black", 65, 4);
    design.setup("N", "Black", 54, 4);
    design.setup("N", "White", 110, 4);
    design.setup("N", "White", 0, 4);
    design.setup("N", "White", 88, 4);
    design.setup("N", "White", 77, 4);
    design.setup("N", "White", 44, 4);
    design.setup("N", "White", 33, 4);
    design.setup("N", "White", 78, 4);
    design.setup("N", "White", 67, 4);
    design.setup("N", "White", 34, 4);
    design.setup("N", "White", 23, 4);
    design.setup("N", "White", 112, 4);
    design.setup("N", "White", 13, 4);
    design.setup("N", "White", 90, 4);
    design.setup("N", "White", 68, 4);
    design.setup("N", "White", 57, 4);
    design.setup("N", "White", 24, 4);
    design.setup("N", "White", 113, 4);
    design.setup("N", "White", 14, 4);
    design.setup("N", "White", 3, 4);
    design.setup("N", "White", 102, 4);
    design.setup("N", "White", 58, 4);
    design.setup("N", "White", 47, 4);
    design.setup("N", "White", 4, 4);
    design.setup("N", "White", 103, 4);
    design.setup("N", "White", 92, 4);
    design.setup("N", "White", 70, 4);
    design.setup("N", "White", 48, 4);
    design.setup("N", "White", 37, 4);
    design.setup("N", "White", 93, 4);
    design.setup("N", "White", 82, 4);
    design.setup("N", "White", 38, 4);
    design.setup("N", "White", 27, 4);
    design.setup("N", "White", 116, 4);
    design.setup("N", "White", 17, 4);
    design.setup("N", "White", 83, 4);
    design.setup("N", "White", 72, 4);
    design.setup("N", "White", 50, 4);
    design.setup("N", "White", 28, 4);
    design.setup("N", "White", 117, 4);
    design.setup("N", "White", 18, 4);
    design.setup("N", "White", 7, 4);
    design.setup("N", "White", 106, 4);
    design.setup("N", "White", 73, 4);
    design.setup("N", "White", 62, 4);
    design.setup("N", "White", 8, 4);
    design.setup("N", "White", 107, 4);
    design.setup("N", "White", 96, 4);
    design.setup("N", "White", 63, 4);
    design.setup("N", "White", 52, 4);
    design.setup("N", "White", 30, 4);
    design.setup("N", "White", 97, 4);
    design.setup("N", "White", 86, 4);
    design.setup("N", "White", 53, 4);
    design.setup("N", "White", 42, 4);
    design.setup("N", "White", 120, 4);
    design.setup("N", "White", 10, 4);
    design.setup("N", "White", 87, 4);
    design.setup("N", "White", 76, 4);
    design.setup("N", "White", 43, 4);
    design.setup("N", "White", 32, 4);

    design.setup("N", "Black", 110, 5);
    design.setup("N", "Black", 0, 5);
    design.setup("N", "Black", 88, 5);
    design.setup("N", "Black", 77, 5);
    design.setup("N", "Black", 33, 5);
    design.setup("N", "Black", 22, 5);
    design.setup("N", "Black", 89, 5);
    design.setup("N", "Black", 56, 5);
    design.setup("N", "Black", 23, 5);
    design.setup("N", "Black", 112, 5);
    design.setup("N", "Black", 13, 5);
    design.setup("N", "Black", 2, 5);
    design.setup("N", "Black", 101, 5);
    design.setup("N", "Black", 79, 5);
    design.setup("N", "Black", 68, 5);
    design.setup("N", "Black", 46, 5);
    design.setup("N", "Black", 35, 5);
    design.setup("N", "Black", 113, 5);
    design.setup("N", "Black", 3, 5);
    design.setup("N", "Black", 91, 5);
    design.setup("N", "Black", 69, 5);
    design.setup("N", "Black", 47, 5);
    design.setup("N", "Black", 25, 5);
    design.setup("N", "Black", 92, 5);
    design.setup("N", "Black", 81, 5);
    design.setup("N", "Black", 59, 5);
    design.setup("N", "Black", 37, 5);
    design.setup("N", "Black", 26, 5);
    design.setup("N", "Black", 16, 5);
    design.setup("N", "Black", 104, 5);
    design.setup("N", "Black", 71, 5);
    design.setup("N", "Black", 49, 5);
    design.setup("N", "Black", 94, 5);
    design.setup("N", "Black", 83, 5);
    design.setup("N", "Black", 61, 5);
    design.setup("N", "Black", 39, 5);
    design.setup("N", "Black", 28, 5);
    design.setup("N", "Black", 117, 5);
    design.setup("N", "Black", 7, 5);
    design.setup("N", "Black", 95, 5);
    design.setup("N", "Black", 73, 5);
    design.setup("N", "Black", 51, 5);
    design.setup("N", "Black", 29, 5);
    design.setup("N", "Black", 118, 5);
    design.setup("N", "Black", 19, 5);
    design.setup("N", "Black", 8, 5);
    design.setup("N", "Black", 107, 5);
    design.setup("N", "Black", 85, 5);
    design.setup("N", "Black", 74, 5);
    design.setup("N", "Black", 52, 5);
    design.setup("N", "Black", 41, 5);
    design.setup("N", "Black", 97, 5);
    design.setup("N", "Black", 64, 5);
    design.setup("N", "Black", 31, 5);
    design.setup("N", "Black", 120, 5);
    design.setup("N", "Black", 10, 5);
    design.setup("N", "Black", 98, 5);
    design.setup("N", "Black", 87, 5);
    design.setup("N", "Black", 43, 5);
    design.setup("N", "Black", 32, 5);
    design.setup("N", "White", 11, 5);
    design.setup("N", "White", 99, 5);
    design.setup("N", "White", 66, 5);
    design.setup("N", "White", 55, 5);
    design.setup("N", "White", 44, 5);
    design.setup("N", "White", 111, 5);
    design.setup("N", "White", 12, 5);
    design.setup("N", "White", 1, 5);
    design.setup("N", "White", 100, 5);
    design.setup("N", "White", 78, 5);
    design.setup("N", "White", 67, 5);
    design.setup("N", "White", 45, 5);
    design.setup("N", "White", 34, 5);
    design.setup("N", "White", 90, 5);
    design.setup("N", "White", 57, 5);
    design.setup("N", "White", 24, 5);
    design.setup("N", "White", 14, 5);
    design.setup("N", "White", 102, 5);
    design.setup("N", "White", 80, 5);
    design.setup("N", "White", 58, 5);
    design.setup("N", "White", 36, 5);
    design.setup("N", "White", 114, 5);
    design.setup("N", "White", 15, 5);
    design.setup("N", "White", 4, 5);
    design.setup("N", "White", 103, 5);
    design.setup("N", "White", 70, 5);
    design.setup("N", "White", 48, 5);
    design.setup("N", "White", 115, 5);
    design.setup("N", "White", 5, 5);
    design.setup("N", "White", 93, 5);
    design.setup("N", "White", 82, 5);
    design.setup("N", "White", 38, 5);
    design.setup("N", "White", 27, 5);
    design.setup("N", "White", 116, 5);
    design.setup("N", "White", 17, 5);
    design.setup("N", "White", 6, 5);
    design.setup("N", "White", 105, 5);
    design.setup("N", "White", 72, 5);
    design.setup("N", "White", 50, 5);
    design.setup("N", "White", 18, 5);
    design.setup("N", "White", 106, 5);
    design.setup("N", "White", 84, 5);
    design.setup("N", "White", 62, 5);
    design.setup("N", "White", 40, 5);
    design.setup("N", "White", 96, 5);
    design.setup("N", "White", 63, 5);
    design.setup("N", "White", 30, 5);
    design.setup("N", "White", 119, 5);
    design.setup("N", "White", 20, 5);
    design.setup("N", "White", 9, 5);
    design.setup("N", "White", 108, 5);
    design.setup("N", "White", 86, 5);
    design.setup("N", "White", 75, 5);
    design.setup("N", "White", 53, 5);
    design.setup("N", "White", 42, 5);
    design.setup("N", "White", 21, 5);
    design.setup("N", "White", 109, 5);
    design.setup("N", "White", 76, 5);
    design.setup("N", "White", 65, 5);
    design.setup("N", "White", 54, 5);

    design.setup("N", "Black", 11, 6);
    design.setup("N", "Black", 99, 6);
    design.setup("N", "Black", 66, 6);
    design.setup("N", "Black", 55, 6);
    design.setup("N", "Black", 44, 6);
    design.setup("N", "Black", 111, 6);
    design.setup("N", "Black", 1, 6);
    design.setup("N", "Black", 89, 6);
    design.setup("N", "Black", 23, 6);
    design.setup("N", "Black", 13, 6);
    design.setup("N", "Black", 101, 6);
    design.setup("N", "Black", 79, 6);
    design.setup("N", "Black", 68, 6);
    design.setup("N", "Black", 46, 6);
    design.setup("N", "Black", 35, 6);
    design.setup("N", "Black", 91, 6);
    design.setup("N", "Black", 69, 6);
    design.setup("N", "Black", 58, 6);
    design.setup("N", "Black", 47, 6);
    design.setup("N", "Black", 25, 6);
    design.setup("N", "Black", 114, 6);
    design.setup("N", "Black", 4, 6);
    design.setup("N", "Black", 92, 6);
    design.setup("N", "Black", 81, 6);
    design.setup("N", "Black", 59, 6);
    design.setup("N", "Black", 37, 6);
    design.setup("N", "Black", 26, 6);
    design.setup("N", "Black", 115, 6);
    design.setup("N", "Black", 5, 6);
    design.setup("N", "Black", 82, 6);
    design.setup("N", "Black", 71, 6);
    design.setup("N", "Black", 49, 6);
    design.setup("N", "Black", 38, 6);
    design.setup("N", "Black", 116, 6);
    design.setup("N", "Black", 6, 6);
    design.setup("N", "Black", 94, 6);
    design.setup("N", "Black", 83, 6);
    design.setup("N", "Black", 61, 6);
    design.setup("N", "Black", 39, 6);
    design.setup("N", "Black", 28, 6);
    design.setup("N", "Black", 95, 6);
    design.setup("N", "Black", 73, 6);
    design.setup("N", "Black", 62, 6);
    design.setup("N", "Black", 51, 6);
    design.setup("N", "Black", 29, 6);
    design.setup("N", "Black", 19, 6);
    design.setup("N", "Black", 107, 6);
    design.setup("N", "Black", 85, 6);
    design.setup("N", "Black", 74, 6);
    design.setup("N", "Black", 52, 6);
    design.setup("N", "Black", 41, 6);
    design.setup("N", "Black", 119, 6);
    design.setup("N", "Black", 9, 6);
    design.setup("N", "Black", 97, 6);
    design.setup("N", "Black", 31, 6);
    design.setup("N", "Black", 21, 6);
    design.setup("N", "Black", 109, 6);
    design.setup("N", "Black", 76, 6);
    design.setup("N", "Black", 65, 6);
    design.setup("N", "Black", 54, 6);
    design.setup("N", "White", 110, 6);
    design.setup("N", "White", 0, 6);
    design.setup("N", "White", 88, 6);
    design.setup("N", "White", 77, 6);
    design.setup("N", "White", 33, 6);
    design.setup("N", "White", 22, 6);
    design.setup("N", "White", 12, 6);
    design.setup("N", "White", 100, 6);
    design.setup("N", "White", 78, 6);
    design.setup("N", "White", 67, 6);
    design.setup("N", "White", 56, 6);
    design.setup("N", "White", 45, 6);
    design.setup("N", "White", 34, 6);
    design.setup("N", "White", 112, 6);
    design.setup("N", "White", 2, 6);
    design.setup("N", "White", 90, 6);
    design.setup("N", "White", 57, 6);
    design.setup("N", "White", 24, 6);
    design.setup("N", "White", 113, 6);
    design.setup("N", "White", 14, 6);
    design.setup("N", "White", 3, 6);
    design.setup("N", "White", 102, 6);
    design.setup("N", "White", 80, 6);
    design.setup("N", "White", 36, 6);
    design.setup("N", "White", 15, 6);
    design.setup("N", "White", 103, 6);
    design.setup("N", "White", 70, 6);
    design.setup("N", "White", 48, 6);
    design.setup("N", "White", 16, 6);
    design.setup("N", "White", 104, 6);
    design.setup("N", "White", 93, 6);
    design.setup("N", "White", 27, 6);
    design.setup("N", "White", 17, 6);
    design.setup("N", "White", 105, 6);
    design.setup("N", "White", 72, 6);
    design.setup("N", "White", 50, 6);
    design.setup("N", "White", 117, 6);
    design.setup("N", "White", 18, 6);
    design.setup("N", "White", 7, 6);
    design.setup("N", "White", 106, 6);
    design.setup("N", "White", 84, 6);
    design.setup("N", "White", 40, 6);
    design.setup("N", "White", 118, 6);
    design.setup("N", "White", 8, 6);
    design.setup("N", "White", 96, 6);
    design.setup("N", "White", 63, 6);
    design.setup("N", "White", 30, 6);
    design.setup("N", "White", 20, 6);
    design.setup("N", "White", 108, 6);
    design.setup("N", "White", 86, 6);
    design.setup("N", "White", 75, 6);
    design.setup("N", "White", 64, 6);
    design.setup("N", "White", 53, 6);
    design.setup("N", "White", 42, 6);
    design.setup("N", "White", 120, 6);
    design.setup("N", "White", 10, 6);
    design.setup("N", "White", 98, 6);
    design.setup("N", "White", 87, 6);
    design.setup("N", "White", 43, 6);
    design.setup("N", "White", 32, 6);

    design.setup("N", "Black", 110, 7);
    design.setup("N", "Black", 0, 7);
    design.setup("N", "Black", 88, 7);
    design.setup("N", "Black", 77, 7);
    design.setup("N", "Black", 55, 7);
    design.setup("N", "Black", 33, 7);
    design.setup("N", "Black", 22, 7);
    design.setup("N", "Black", 89, 7);
    design.setup("N", "Black", 56, 7);
    design.setup("N", "Black", 23, 7);
    design.setup("N", "Black", 112, 7);
    design.setup("N", "Black", 13, 7);
    design.setup("N", "Black", 2, 7);
    design.setup("N", "Black", 101, 7);
    design.setup("N", "Black", 79, 7);
    design.setup("N", "Black", 68, 7);
    design.setup("N", "Black", 46, 7);
    design.setup("N", "Black", 35, 7);
    design.setup("N", "Black", 113, 7);
    design.setup("N", "Black", 3, 7);
    design.setup("N", "Black", 91, 7);
    design.setup("N", "Black", 58, 7);
    design.setup("N", "Black", 25, 7);
    design.setup("N", "Black", 92, 7);
    design.setup("N", "Black", 70, 7);
    design.setup("N", "Black", 48, 7);
    design.setup("N", "Black", 26, 7);
    design.setup("N", "Black", 115, 7);
    design.setup("N", "Black", 16, 7);
    design.setup("N", "Black", 5, 7);
    design.setup("N", "Black", 104, 7);
    design.setup("N", "Black", 82, 7);
    design.setup("N", "Black", 38, 7);
    design.setup("N", "Black", 94, 7);
    design.setup("N", "Black", 72, 7);
    design.setup("N", "Black", 50, 7);
    design.setup("N", "Black", 28, 7);
    design.setup("N", "Black", 117, 7);
    design.setup("N", "Black", 7, 7);
    design.setup("N", "Black", 95, 7);
    design.setup("N", "Black", 62, 7);
    design.setup("N", "Black", 29, 7);
    design.setup("N", "Black", 118, 7);
    design.setup("N", "Black", 19, 7);
    design.setup("N", "Black", 8, 7);
    design.setup("N", "Black", 107, 7);
    design.setup("N", "Black", 85, 7);
    design.setup("N", "Black", 74, 7);
    design.setup("N", "Black", 52, 7);
    design.setup("N", "Black", 41, 7);
    design.setup("N", "Black", 97, 7);
    design.setup("N", "Black", 64, 7);
    design.setup("N", "Black", 31, 7);
    design.setup("N", "Black", 120, 7);
    design.setup("N", "Black", 10, 7);
    design.setup("N", "Black", 98, 7);
    design.setup("N", "Black", 87, 7);
    design.setup("N", "Black", 65, 7);
    design.setup("N", "Black", 43, 7);
    design.setup("N", "Black", 32, 7);
    design.setup("N", "White", 11, 7);
    design.setup("N", "White", 99, 7);
    design.setup("N", "White", 66, 7);
    design.setup("N", "White", 44, 7);
    design.setup("N", "White", 111, 7);
    design.setup("N", "White", 12, 7);
    design.setup("N", "White", 1, 7);
    design.setup("N", "White", 100, 7);
    design.setup("N", "White", 78, 7);
    design.setup("N", "White", 67, 7);
    design.setup("N", "White", 45, 7);
    design.setup("N", "White", 34, 7);
    design.setup("N", "White", 90, 7);
    design.setup("N", "White", 57, 7);
    design.setup("N", "White", 24, 7);
    design.setup("N", "White", 14, 7);
    design.setup("N", "White", 102, 7);
    design.setup("N", "White", 80, 7);
    design.setup("N", "White", 69, 7);
    design.setup("N", "White", 47, 7);
    design.setup("N", "White", 36, 7);
    design.setup("N", "White", 114, 7);
    design.setup("N", "White", 15, 7);
    design.setup("N", "White", 4, 7);
    design.setup("N", "White", 103, 7);
    design.setup("N", "White", 81, 7);
    design.setup("N", "White", 59, 7);
    design.setup("N", "White", 37, 7);
    design.setup("N", "White", 93, 7);
    design.setup("N", "White", 71, 7);
    design.setup("N", "White", 49, 7);
    design.setup("N", "White", 27, 7);
    design.setup("N", "White", 116, 7);
    design.setup("N", "White", 17, 7);
    design.setup("N", "White", 6, 7);
    design.setup("N", "White", 105, 7);
    design.setup("N", "White", 83, 7);
    design.setup("N", "White", 61, 7);
    design.setup("N", "White", 39, 7);
    design.setup("N", "White", 18, 7);
    design.setup("N", "White", 106, 7);
    design.setup("N", "White", 84, 7);
    design.setup("N", "White", 73, 7);
    design.setup("N", "White", 51, 7);
    design.setup("N", "White", 40, 7);
    design.setup("N", "White", 96, 7);
    design.setup("N", "White", 63, 7);
    design.setup("N", "White", 30, 7);
    design.setup("N", "White", 119, 7);
    design.setup("N", "White", 20, 7);
    design.setup("N", "White", 9, 7);
    design.setup("N", "White", 108, 7);
    design.setup("N", "White", 86, 7);
    design.setup("N", "White", 75, 7);
    design.setup("N", "White", 53, 7);
    design.setup("N", "White", 42, 7);
    design.setup("N", "White", 21, 7);
    design.setup("N", "White", 109, 7);
    design.setup("N", "White", 76, 7);
    design.setup("N", "White", 54, 7);

    design.setup("N", "Black", 11, 8);
    design.setup("N", "Black", 99, 8);
    design.setup("N", "Black", 66, 8);
    design.setup("N", "Black", 44, 8);
    design.setup("N", "Black", 111, 8);
    design.setup("N", "Black", 1, 8);
    design.setup("N", "Black", 89, 8);
    design.setup("N", "Black", 67, 8);
    design.setup("N", "Black", 45, 8);
    design.setup("N", "Black", 23, 8);
    design.setup("N", "Black", 13, 8);
    design.setup("N", "Black", 101, 8);
    design.setup("N", "Black", 79, 8);
    design.setup("N", "Black", 57, 8);
    design.setup("N", "Black", 35, 8);
    design.setup("N", "Black", 91, 8);
    design.setup("N", "Black", 69, 8);
    design.setup("N", "Black", 58, 8);
    design.setup("N", "Black", 47, 8);
    design.setup("N", "Black", 25, 8);
    design.setup("N", "Black", 114, 8);
    design.setup("N", "Black", 15, 8);
    design.setup("N", "Black", 4, 8);
    design.setup("N", "Black", 103, 8);
    design.setup("N", "Black", 81, 8);
    design.setup("N", "Black", 59, 8);
    design.setup("N", "Black", 37, 8);
    design.setup("N", "Black", 93, 8);
    design.setup("N", "Black", 82, 8);
    design.setup("N", "Black", 71, 8);
    design.setup("N", "Black", 49, 8);
    design.setup("N", "Black", 38, 8);
    design.setup("N", "Black", 27, 8);
    design.setup("N", "Black", 116, 8);
    design.setup("N", "Black", 17, 8);
    design.setup("N", "Black", 6, 8);
    design.setup("N", "Black", 105, 8);
    design.setup("N", "Black", 83, 8);
    design.setup("N", "Black", 61, 8);
    design.setup("N", "Black", 39, 8);
    design.setup("N", "Black", 95, 8);
    design.setup("N", "Black", 73, 8);
    design.setup("N", "Black", 62, 8);
    design.setup("N", "Black", 51, 8);
    design.setup("N", "Black", 29, 8);
    design.setup("N", "Black", 19, 8);
    design.setup("N", "Black", 107, 8);
    design.setup("N", "Black", 85, 8);
    design.setup("N", "Black", 63, 8);
    design.setup("N", "Black", 41, 8);
    design.setup("N", "Black", 119, 8);
    design.setup("N", "Black", 9, 8);
    design.setup("N", "Black", 97, 8);
    design.setup("N", "Black", 75, 8);
    design.setup("N", "Black", 53, 8);
    design.setup("N", "Black", 31, 8);
    design.setup("N", "Black", 21, 8);
    design.setup("N", "Black", 109, 8);
    design.setup("N", "Black", 76, 8);
    design.setup("N", "Black", 54, 8);
    design.setup("N", "White", 110, 8);
    design.setup("N", "White", 0, 8);
    design.setup("N", "White", 88, 8);
    design.setup("N", "White", 77, 8);
    design.setup("N", "White", 55, 8);
    design.setup("N", "White", 33, 8);
    design.setup("N", "White", 22, 8);
    design.setup("N", "White", 12, 8);
    design.setup("N", "White", 100, 8);
    design.setup("N", "White", 78, 8);
    design.setup("N", "White", 56, 8);
    design.setup("N", "White", 34, 8);
    design.setup("N", "White", 112, 8);
    design.setup("N", "White", 2, 8);
    design.setup("N", "White", 90, 8);
    design.setup("N", "White", 68, 8);
    design.setup("N", "White", 46, 8);
    design.setup("N", "White", 24, 8);
    design.setup("N", "White", 113, 8);
    design.setup("N", "White", 14, 8);
    design.setup("N", "White", 3, 8);
    design.setup("N", "White", 102, 8);
    design.setup("N", "White", 80, 8);
    design.setup("N", "White", 36, 8);
    design.setup("N", "White", 92, 8);
    design.setup("N", "White", 70, 8);
    design.setup("N", "White", 48, 8);
    design.setup("N", "White", 26, 8);
    design.setup("N", "White", 115, 8);
    design.setup("N", "White", 16, 8);
    design.setup("N", "White", 5, 8);
    design.setup("N", "White", 104, 8);
    design.setup("N", "White", 94, 8);
    design.setup("N", "White", 72, 8);
    design.setup("N", "White", 50, 8);
    design.setup("N", "White", 28, 8);
    design.setup("N", "White", 117, 8);
    design.setup("N", "White", 18, 8);
    design.setup("N", "White", 7, 8);
    design.setup("N", "White", 106, 8);
    design.setup("N", "White", 84, 8);
    design.setup("N", "White", 40, 8);
    design.setup("N", "White", 118, 8);
    design.setup("N", "White", 8, 8);
    design.setup("N", "White", 96, 8);
    design.setup("N", "White", 74, 8);
    design.setup("N", "White", 52, 8);
    design.setup("N", "White", 30, 8);
    design.setup("N", "White", 20, 8);
    design.setup("N", "White", 108, 8);
    design.setup("N", "White", 86, 8);
    design.setup("N", "White", 64, 8);
    design.setup("N", "White", 42, 8);
    design.setup("N", "White", 120, 8);
    design.setup("N", "White", 10, 8);
    design.setup("N", "White", 98, 8);
    design.setup("N", "White", 87, 8);
    design.setup("N", "White", 65, 8);
    design.setup("N", "White", 43, 8);
    design.setup("N", "White", 32, 8);

    design.setup("N", "Black", 110, 9);
    design.setup("N", "Black", 0, 9);
    design.setup("N", "Black", 77, 9);
    design.setup("N", "Black", 55, 9);
    design.setup("N", "Black", 33, 9);
    design.setup("N", "Black", 89, 9);
    design.setup("N", "Black", 78, 9);
    design.setup("N", "Black", 67, 9);
    design.setup("N", "Black", 45, 9);
    design.setup("N", "Black", 34, 9);
    design.setup("N", "Black", 23, 9);
    design.setup("N", "Black", 13, 9);
    design.setup("N", "Black", 101, 9);
    design.setup("N", "Black", 90, 9);
    design.setup("N", "Black", 57, 9);
    design.setup("N", "Black", 24, 9);
    design.setup("N", "Black", 113, 9);
    design.setup("N", "Black", 14, 9);
    design.setup("N", "Black", 3, 9);
    design.setup("N", "Black", 102, 9);
    design.setup("N", "Black", 58, 9);
    design.setup("N", "Black", 15, 9);
    design.setup("N", "Black", 103, 9);
    design.setup("N", "Black", 70, 9);
    design.setup("N", "Black", 59, 9);
    design.setup("N", "Black", 48, 9);
    design.setup("N", "Black", 115, 9);
    design.setup("N", "Black", 5, 9);
    design.setup("N", "Black", 93, 9);
    design.setup("N", "Black", 82, 9);
    design.setup("N", "Black", 71, 9);
    design.setup("N", "Black", 49, 9);
    design.setup("N", "Black", 38, 9);
    design.setup("N", "Black", 27, 9);
    design.setup("N", "Black", 17, 9);
    design.setup("N", "Black", 105, 9);
    design.setup("N", "Black", 72, 9);
    design.setup("N", "Black", 61, 9);
    design.setup("N", "Black", 50, 9);
    design.setup("N", "Black", 117, 9);
    design.setup("N", "Black", 18, 9);
    design.setup("N", "Black", 7, 9);
    design.setup("N", "Black", 106, 9);
    design.setup("N", "Black", 62, 9);
    design.setup("N", "Black", 19, 9);
    design.setup("N", "Black", 107, 9);
    design.setup("N", "Black", 96, 9);
    design.setup("N", "Black", 63, 9);
    design.setup("N", "Black", 30, 9);
    design.setup("N", "Black", 97, 9);
    design.setup("N", "Black", 86, 9);
    design.setup("N", "Black", 75, 9);
    design.setup("N", "Black", 53, 9);
    design.setup("N", "Black", 42, 9);
    design.setup("N", "Black", 31, 9);
    design.setup("N", "Black", 120, 9);
    design.setup("N", "Black", 10, 9);
    design.setup("N", "Black", 87, 9);
    design.setup("N", "Black", 65, 9);
    design.setup("N", "Black", 43, 9);
    design.setup("N", "White", 11, 9);
    design.setup("N", "White", 99, 9);
    design.setup("N", "White", 88, 9);
    design.setup("N", "White", 66, 9);
    design.setup("N", "White", 44, 9);
    design.setup("N", "White", 22, 9);
    design.setup("N", "White", 111, 9);
    design.setup("N", "White", 12, 9);
    design.setup("N", "White", 1, 9);
    design.setup("N", "White", 100, 9);
    design.setup("N", "White", 56, 9);
    design.setup("N", "White", 112, 9);
    design.setup("N", "White", 2, 9);
    design.setup("N", "White", 79, 9);
    design.setup("N", "White", 68, 9);
    design.setup("N", "White", 46, 9);
    design.setup("N", "White", 35, 9);
    design.setup("N", "White", 91, 9);
    design.setup("N", "White", 80, 9);
    design.setup("N", "White", 69, 9);
    design.setup("N", "White", 47, 9);
    design.setup("N", "White", 36, 9);
    design.setup("N", "White", 25, 9);
    design.setup("N", "White", 114, 9);
    design.setup("N", "White", 4, 9);
    design.setup("N", "White", 92, 9);
    design.setup("N", "White", 81, 9);
    design.setup("N", "White", 37, 9);
    design.setup("N", "White", 26, 9);
    design.setup("N", "White", 16, 9);
    design.setup("N", "White", 104, 9);
    design.setup("N", "White", 116, 9);
    design.setup("N", "White", 6, 9);
    design.setup("N", "White", 94, 9);
    design.setup("N", "White", 83, 9);
    design.setup("N", "White", 39, 9);
    design.setup("N", "White", 28, 9);
    design.setup("N", "White", 95, 9);
    design.setup("N", "White", 84, 9);
    design.setup("N", "White", 73, 9);
    design.setup("N", "White", 51, 9);
    design.setup("N", "White", 40, 9);
    design.setup("N", "White", 29, 9);
    design.setup("N", "White", 118, 9);
    design.setup("N", "White", 8, 9);
    design.setup("N", "White", 85, 9);
    design.setup("N", "White", 74, 9);
    design.setup("N", "White", 52, 9);
    design.setup("N", "White", 41, 9);
    design.setup("N", "White", 119, 9);
    design.setup("N", "White", 20, 9);
    design.setup("N", "White", 9, 9);
    design.setup("N", "White", 108, 9);
    design.setup("N", "White", 64, 9);
    design.setup("N", "White", 21, 9);
    design.setup("N", "White", 109, 9);
    design.setup("N", "White", 98, 9);
    design.setup("N", "White", 76, 9);
    design.setup("N", "White", 54, 9);
    design.setup("N", "White", 32, 9);

    design.setup("N", "Black", 110, 10);
    design.setup("N", "Black", 0, 10);
    design.setup("N", "Black", 88, 10);
    design.setup("N", "Black", 55, 10);
    design.setup("N", "Black", 22, 10);
    design.setup("N", "Black", 89, 10);
    design.setup("N", "Black", 67, 10);
    design.setup("N", "Black", 56, 10);
    design.setup("N", "Black", 45, 10);
    design.setup("N", "Black", 23, 10);
    design.setup("N", "Black", 112, 10);
    design.setup("N", "Black", 13, 10);
    design.setup("N", "Black", 2, 10);
    design.setup("N", "Black", 101, 10);
    design.setup("N", "Black", 90, 10);
    design.setup("N", "Black", 68, 10);
    design.setup("N", "Black", 46, 10);
    design.setup("N", "Black", 24, 10);
    design.setup("N", "Black", 80, 10);
    design.setup("N", "Black", 58, 10);
    design.setup("N", "Black", 36, 10);
    design.setup("N", "Black", 15, 10);
    design.setup("N", "Black", 103, 10);
    design.setup("N", "Black", 92, 10);
    design.setup("N", "Black", 59, 10);
    design.setup("N", "Black", 26, 10);
    design.setup("N", "Black", 115, 10);
    design.setup("N", "Black", 16, 10);
    design.setup("N", "Black", 5, 10);
    design.setup("N", "Black", 104, 10);
    design.setup("N", "Black", 82, 10);
    design.setup("N", "Black", 71, 10);
    design.setup("N", "Black", 49, 10);
    design.setup("N", "Black", 38, 10);
    design.setup("N", "Black", 17, 10);
    design.setup("N", "Black", 105, 10);
    design.setup("N", "Black", 94, 10);
    design.setup("N", "Black", 61, 10);
    design.setup("N", "Black", 28, 10);
    design.setup("N", "Black", 84, 10);
    design.setup("N", "Black", 62, 10);
    design.setup("N", "Black", 40, 10);
    design.setup("N", "Black", 118, 10);
    design.setup("N", "Black", 19, 10);
    design.setup("N", "Black", 8, 10);
    design.setup("N", "Black", 107, 10);
    design.setup("N", "Black", 96, 10);
    design.setup("N", "Black", 74, 10);
    design.setup("N", "Black", 52, 10);
    design.setup("N", "Black", 30, 10);
    design.setup("N", "Black", 97, 10);
    design.setup("N", "Black", 75, 10);
    design.setup("N", "Black", 64, 10);
    design.setup("N", "Black", 53, 10);
    design.setup("N", "Black", 31, 10);
    design.setup("N", "Black", 120, 10);
    design.setup("N", "Black", 10, 10);
    design.setup("N", "Black", 98, 10);
    design.setup("N", "Black", 65, 10);
    design.setup("N", "Black", 32, 10);
    design.setup("N", "White", 11, 10);
    design.setup("N", "White", 99, 10);
    design.setup("N", "White", 77, 10);
    design.setup("N", "White", 66, 10);
    design.setup("N", "White", 44, 10);
    design.setup("N", "White", 33, 10);
    design.setup("N", "White", 111, 10);
    design.setup("N", "White", 12, 10);
    design.setup("N", "White", 1, 10);
    design.setup("N", "White", 100, 10);
    design.setup("N", "White", 78, 10);
    design.setup("N", "White", 34, 10);
    design.setup("N", "White", 79, 10);
    design.setup("N", "White", 57, 10);
    design.setup("N", "White", 35, 10);
    design.setup("N", "White", 113, 10);
    design.setup("N", "White", 14, 10);
    design.setup("N", "White", 3, 10);
    design.setup("N", "White", 102, 10);
    design.setup("N", "White", 91, 10);
    design.setup("N", "White", 69, 10);
    design.setup("N", "White", 47, 10);
    design.setup("N", "White", 25, 10);
    design.setup("N", "White", 114, 10);
    design.setup("N", "White", 4, 10);
    design.setup("N", "White", 81, 10);
    design.setup("N", "White", 70, 10);
    design.setup("N", "White", 48, 10);
    design.setup("N", "White", 37, 10);
    design.setup("N", "White", 93, 10);
    design.setup("N", "White", 27, 10);
    design.setup("N", "White", 116, 10);
    design.setup("N", "White", 6, 10);
    design.setup("N", "White", 83, 10);
    design.setup("N", "White", 72, 10);
    design.setup("N", "White", 50, 10);
    design.setup("N", "White", 39, 10);
    design.setup("N", "White", 117, 10);
    design.setup("N", "White", 18, 10);
    design.setup("N", "White", 7, 10);
    design.setup("N", "White", 106, 10);
    design.setup("N", "White", 95, 10);
    design.setup("N", "White", 73, 10);
    design.setup("N", "White", 51, 10);
    design.setup("N", "White", 29, 10);
    design.setup("N", "White", 85, 10);
    design.setup("N", "White", 63, 10);
    design.setup("N", "White", 41, 10);
    design.setup("N", "White", 119, 10);
    design.setup("N", "White", 20, 10);
    design.setup("N", "White", 9, 10);
    design.setup("N", "White", 108, 10);
    design.setup("N", "White", 86, 10);
    design.setup("N", "White", 42, 10);
    design.setup("N", "White", 21, 10);
    design.setup("N", "White", 109, 10);
    design.setup("N", "White", 87, 10);
    design.setup("N", "White", 76, 10);
    design.setup("N", "White", 54, 10);
    design.setup("N", "White", 43, 10);

    design.setup("N", "Black", 110, 11);
    design.setup("N", "Black", 0, 11);
    design.setup("N", "Black", 77, 11);
    design.setup("N", "Black", 55, 11);
    design.setup("N", "Black", 33, 11);
    design.setup("N", "Black", 89, 11);
    design.setup("N", "Black", 78, 11);
    design.setup("N", "Black", 67, 11);
    design.setup("N", "Black", 45, 11);
    design.setup("N", "Black", 34, 11);
    design.setup("N", "Black", 23, 11);
    design.setup("N", "Black", 13, 11);
    design.setup("N", "Black", 101, 11);
    design.setup("N", "Black", 68, 11);
    design.setup("N", "Black", 46, 11);
    design.setup("N", "Black", 113, 11);
    design.setup("N", "Black", 14, 11);
    design.setup("N", "Black", 3, 11);
    design.setup("N", "Black", 102, 11);
    design.setup("N", "Black", 80, 11);
    design.setup("N", "Black", 58, 11);
    design.setup("N", "Black", 36, 11);
    design.setup("N", "Black", 15, 11);
    design.setup("N", "Black", 103, 11);
    design.setup("N", "Black", 92, 11);
    design.setup("N", "Black", 59, 11);
    design.setup("N", "Black", 26, 11);
    design.setup("N", "Black", 115, 11);
    design.setup("N", "Black", 5, 11);
    design.setup("N", "Black", 82, 11);
    design.setup("N", "Black", 71, 11);
    design.setup("N", "Black", 49, 11);
    design.setup("N", "Black", 38, 11);
    design.setup("N", "Black", 17, 11);
    design.setup("N", "Black", 105, 11);
    design.setup("N", "Black", 94, 11);
    design.setup("N", "Black", 61, 11);
    design.setup("N", "Black", 28, 11);
    design.setup("N", "Black", 117, 11);
    design.setup("N", "Black", 18, 11);
    design.setup("N", "Black", 7, 11);
    design.setup("N", "Black", 106, 11);
    design.setup("N", "Black", 84, 11);
    design.setup("N", "Black", 62, 11);
    design.setup("N", "Black", 40, 11);
    design.setup("N", "Black", 19, 11);
    design.setup("N", "Black", 107, 11);
    design.setup("N", "Black", 74, 11);
    design.setup("N", "Black", 52, 11);
    design.setup("N", "Black", 97, 11);
    design.setup("N", "Black", 86, 11);
    design.setup("N", "Black", 75, 11);
    design.setup("N", "Black", 53, 11);
    design.setup("N", "Black", 42, 11);
    design.setup("N", "Black", 31, 11);
    design.setup("N", "Black", 120, 11);
    design.setup("N", "Black", 10, 11);
    design.setup("N", "Black", 87, 11);
    design.setup("N", "Black", 65, 11);
    design.setup("N", "Black", 43, 11);
    design.setup("N", "White", 11, 11);
    design.setup("N", "White", 99, 11);
    design.setup("N", "White", 88, 11);
    design.setup("N", "White", 66, 11);
    design.setup("N", "White", 44, 11);
    design.setup("N", "White", 22, 11);
    design.setup("N", "White", 111, 11);
    design.setup("N", "White", 12, 11);
    design.setup("N", "White", 1, 11);
    design.setup("N", "White", 100, 11);
    design.setup("N", "White", 56, 11);
    design.setup("N", "White", 112, 11);
    design.setup("N", "White", 2, 11);
    design.setup("N", "White", 90, 11);
    design.setup("N", "White", 79, 11);
    design.setup("N", "White", 57, 11);
    design.setup("N", "White", 35, 11);
    design.setup("N", "White", 24, 11);
    design.setup("N", "White", 91, 11);
    design.setup("N", "White", 69, 11);
    design.setup("N", "White", 47, 11);
    design.setup("N", "White", 25, 11);
    design.setup("N", "White", 114, 11);
    design.setup("N", "White", 4, 11);
    design.setup("N", "White", 81, 11);
    design.setup("N", "White", 70, 11);
    design.setup("N", "White", 48, 11);
    design.setup("N", "White", 37, 11);
    design.setup("N", "White", 16, 11);
    design.setup("N", "White", 104, 11);
    design.setup("N", "White", 93, 11);
    design.setup("N", "White", 27, 11);
    design.setup("N", "White", 116, 11);
    design.setup("N", "White", 6, 11);
    design.setup("N", "White", 83, 11);
    design.setup("N", "White", 72, 11);
    design.setup("N", "White", 50, 11);
    design.setup("N", "White", 39, 11);
    design.setup("N", "White", 95, 11);
    design.setup("N", "White", 73, 11);
    design.setup("N", "White", 51, 11);
    design.setup("N", "White", 29, 11);
    design.setup("N", "White", 118, 11);
    design.setup("N", "White", 8, 11);
    design.setup("N", "White", 96, 11);
    design.setup("N", "White", 85, 11);
    design.setup("N", "White", 63, 11);
    design.setup("N", "White", 41, 11);
    design.setup("N", "White", 30, 11);
    design.setup("N", "White", 119, 11);
    design.setup("N", "White", 20, 11);
    design.setup("N", "White", 9, 11);
    design.setup("N", "White", 108, 11);
    design.setup("N", "White", 64, 11);
    design.setup("N", "White", 21, 11);
    design.setup("N", "White", 109, 11);
    design.setup("N", "White", 98, 11);
    design.setup("N", "White", 76, 11);
    design.setup("N", "White", 54, 11);
    design.setup("N", "White", 32, 11);

    design.setup("N", "Black", 110, 12);
    design.setup("N", "Black", 0, 12);
    design.setup("N", "Black", 88, 12);
    design.setup("N", "Black", 55, 12);
    design.setup("N", "Black", 22, 12);
    design.setup("N", "Black", 12, 12);
    design.setup("N", "Black", 100, 12);
    design.setup("N", "Black", 78, 12);
    design.setup("N", "Black", 67, 12);
    design.setup("N", "Black", 45, 12);
    design.setup("N", "Black", 34, 12);
    design.setup("N", "Black", 112, 12);
    design.setup("N", "Black", 2, 12);
    design.setup("N", "Black", 90, 12);
    design.setup("N", "Black", 68, 12);
    design.setup("N", "Black", 46, 12);
    design.setup("N", "Black", 24, 12);
    design.setup("N", "Black", 14, 12);
    design.setup("N", "Black", 102, 12);
    design.setup("N", "Black", 80, 12);
    design.setup("N", "Black", 58, 12);
    design.setup("N", "Black", 36, 12);
    design.setup("N", "Black", 15, 12);
    design.setup("N", "Black", 103, 12);
    design.setup("N", "Black", 92, 12);
    design.setup("N", "Black", 59, 12);
    design.setup("N", "Black", 26, 12);
    design.setup("N", "Black", 115, 12);
    design.setup("N", "Black", 5, 12);
    design.setup("N", "Black", 82, 12);
    design.setup("N", "Black", 71, 12);
    design.setup("N", "Black", 49, 12);
    design.setup("N", "Black", 38, 12);
    design.setup("N", "Black", 17, 12);
    design.setup("N", "Black", 105, 12);
    design.setup("N", "Black", 94, 12);
    design.setup("N", "Black", 61, 12);
    design.setup("N", "Black", 28, 12);
    design.setup("N", "Black", 18, 12);
    design.setup("N", "Black", 106, 12);
    design.setup("N", "Black", 84, 12);
    design.setup("N", "Black", 62, 12);
    design.setup("N", "Black", 40, 12);
    design.setup("N", "Black", 118, 12);
    design.setup("N", "Black", 8, 12);
    design.setup("N", "Black", 96, 12);
    design.setup("N", "Black", 74, 12);
    design.setup("N", "Black", 52, 12);
    design.setup("N", "Black", 30, 12);
    design.setup("N", "Black", 20, 12);
    design.setup("N", "Black", 108, 12);
    design.setup("N", "Black", 86, 12);
    design.setup("N", "Black", 75, 12);
    design.setup("N", "Black", 53, 12);
    design.setup("N", "Black", 42, 12);
    design.setup("N", "Black", 120, 12);
    design.setup("N", "Black", 10, 12);
    design.setup("N", "Black", 98, 12);
    design.setup("N", "Black", 65, 12);
    design.setup("N", "Black", 32, 12);
    design.setup("N", "White", 11, 12);
    design.setup("N", "White", 99, 12);
    design.setup("N", "White", 77, 12);
    design.setup("N", "White", 66, 12);
    design.setup("N", "White", 44, 12);
    design.setup("N", "White", 33, 12);
    design.setup("N", "White", 111, 12);
    design.setup("N", "White", 1, 12);
    design.setup("N", "White", 89, 12);
    design.setup("N", "White", 56, 12);
    design.setup("N", "White", 23, 12);
    design.setup("N", "White", 13, 12);
    design.setup("N", "White", 101, 12);
    design.setup("N", "White", 79, 12);
    design.setup("N", "White", 57, 12);
    design.setup("N", "White", 35, 12);
    design.setup("N", "White", 113, 12);
    design.setup("N", "White", 3, 12);
    design.setup("N", "White", 91, 12);
    design.setup("N", "White", 69, 12);
    design.setup("N", "White", 47, 12);
    design.setup("N", "White", 25, 12);
    design.setup("N", "White", 114, 12);
    design.setup("N", "White", 4, 12);
    design.setup("N", "White", 81, 12);
    design.setup("N", "White", 70, 12);
    design.setup("N", "White", 48, 12);
    design.setup("N", "White", 37, 12);
    design.setup("N", "White", 16, 12);
    design.setup("N", "White", 104, 12);
    design.setup("N", "White", 93, 12);
    design.setup("N", "White", 27, 12);
    design.setup("N", "White", 116, 12);
    design.setup("N", "White", 6, 12);
    design.setup("N", "White", 83, 12);
    design.setup("N", "White", 72, 12);
    design.setup("N", "White", 50, 12);
    design.setup("N", "White", 39, 12);
    design.setup("N", "White", 117, 12);
    design.setup("N", "White", 7, 12);
    design.setup("N", "White", 95, 12);
    design.setup("N", "White", 73, 12);
    design.setup("N", "White", 51, 12);
    design.setup("N", "White", 29, 12);
    design.setup("N", "White", 19, 12);
    design.setup("N", "White", 107, 12);
    design.setup("N", "White", 85, 12);
    design.setup("N", "White", 63, 12);
    design.setup("N", "White", 41, 12);
    design.setup("N", "White", 119, 12);
    design.setup("N", "White", 9, 12);
    design.setup("N", "White", 97, 12);
    design.setup("N", "White", 64, 12);
    design.setup("N", "White", 31, 12);
    design.setup("N", "White", 21, 12);
    design.setup("N", "White", 109, 12);
    design.setup("N", "White", 87, 12);
    design.setup("N", "White", 76, 12);
    design.setup("N", "White", 54, 12);
    design.setup("N", "White", 43, 12);

    design.setup("N", "Black", 110, 13);
    design.setup("N", "Black", 0, 13);
    design.setup("N", "Black", 77, 13);
    design.setup("N", "Black", 55, 13);
    design.setup("N", "Black", 33, 13);
    design.setup("N", "Black", 89, 13);
    design.setup("N", "Black", 56, 13);
    design.setup("N", "Black", 23, 13);
    design.setup("N", "Black", 13, 13);
    design.setup("N", "Black", 101, 13);
    design.setup("N", "Black", 79, 13);
    design.setup("N", "Black", 68, 13);
    design.setup("N", "Black", 57, 13);
    design.setup("N", "Black", 46, 13);
    design.setup("N", "Black", 35, 13);
    design.setup("N", "Black", 113, 13);
    design.setup("N", "Black", 3, 13);
    design.setup("N", "Black", 91, 13);
    design.setup("N", "Black", 58, 13);
    design.setup("N", "Black", 25, 13);
    design.setup("N", "Black", 92, 13);
    design.setup("N", "Black", 70, 13);
    design.setup("N", "Black", 59, 13);
    design.setup("N", "Black", 48, 13);
    design.setup("N", "Black", 26, 13);
    design.setup("N", "Black", 115, 13);
    design.setup("N", "Black", 16, 13);
    design.setup("N", "Black", 5, 13);
    design.setup("N", "Black", 104, 13);
    design.setup("N", "Black", 93, 13);
    design.setup("N", "Black", 82, 13);
    design.setup("N", "Black", 71, 13);
    design.setup("N", "Black", 49, 13);
    design.setup("N", "Black", 38, 13);
    design.setup("N", "Black", 27, 13);
    design.setup("N", "Black", 94, 13);
    design.setup("N", "Black", 72, 13);
    design.setup("N", "Black", 61, 13);
    design.setup("N", "Black", 50, 13);
    design.setup("N", "Black", 28, 13);
    design.setup("N", "Black", 117, 13);
    design.setup("N", "Black", 7, 13);
    design.setup("N", "Black", 95, 13);
    design.setup("N", "Black", 62, 13);
    design.setup("N", "Black", 29, 13);
    design.setup("N", "Black", 19, 13);
    design.setup("N", "Black", 107, 13);
    design.setup("N", "Black", 85, 13);
    design.setup("N", "Black", 74, 13);
    design.setup("N", "Black", 63, 13);
    design.setup("N", "Black", 52, 13);
    design.setup("N", "Black", 41, 13);
    design.setup("N", "Black", 97, 13);
    design.setup("N", "Black", 64, 13);
    design.setup("N", "Black", 31, 13);
    design.setup("N", "Black", 120, 13);
    design.setup("N", "Black", 10, 13);
    design.setup("N", "Black", 87, 13);
    design.setup("N", "Black", 65, 13);
    design.setup("N", "Black", 43, 13);
    design.setup("N", "White", 11, 13);
    design.setup("N", "White", 99, 13);
    design.setup("N", "White", 88, 13);
    design.setup("N", "White", 66, 13);
    design.setup("N", "White", 44, 13);
    design.setup("N", "White", 22, 13);
    design.setup("N", "White", 111, 13);
    design.setup("N", "White", 12, 13);
    design.setup("N", "White", 1, 13);
    design.setup("N", "White", 100, 13);
    design.setup("N", "White", 78, 13);
    design.setup("N", "White", 67, 13);
    design.setup("N", "White", 45, 13);
    design.setup("N", "White", 34, 13);
    design.setup("N", "White", 112, 13);
    design.setup("N", "White", 2, 13);
    design.setup("N", "White", 90, 13);
    design.setup("N", "White", 24, 13);
    design.setup("N", "White", 14, 13);
    design.setup("N", "White", 102, 13);
    design.setup("N", "White", 80, 13);
    design.setup("N", "White", 69, 13);
    design.setup("N", "White", 47, 13);
    design.setup("N", "White", 36, 13);
    design.setup("N", "White", 114, 13);
    design.setup("N", "White", 15, 13);
    design.setup("N", "White", 4, 13);
    design.setup("N", "White", 103, 13);
    design.setup("N", "White", 81, 13);
    design.setup("N", "White", 37, 13);
    design.setup("N", "White", 116, 13);
    design.setup("N", "White", 17, 13);
    design.setup("N", "White", 6, 13);
    design.setup("N", "White", 105, 13);
    design.setup("N", "White", 83, 13);
    design.setup("N", "White", 39, 13);
    design.setup("N", "White", 18, 13);
    design.setup("N", "White", 106, 13);
    design.setup("N", "White", 84, 13);
    design.setup("N", "White", 73, 13);
    design.setup("N", "White", 51, 13);
    design.setup("N", "White", 40, 13);
    design.setup("N", "White", 118, 13);
    design.setup("N", "White", 8, 13);
    design.setup("N", "White", 96, 13);
    design.setup("N", "White", 30, 13);
    design.setup("N", "White", 119, 13);
    design.setup("N", "White", 20, 13);
    design.setup("N", "White", 9, 13);
    design.setup("N", "White", 108, 13);
    design.setup("N", "White", 86, 13);
    design.setup("N", "White", 75, 13);
    design.setup("N", "White", 53, 13);
    design.setup("N", "White", 42, 13);
    design.setup("N", "White", 21, 13);
    design.setup("N", "White", 109, 13);
    design.setup("N", "White", 98, 13);
    design.setup("N", "White", 76, 13);
    design.setup("N", "White", 54, 13);
    design.setup("N", "White", 32, 13);

    design.setup("N", "Black", 110, 14);
    design.setup("N", "Black", 0, 14);
    design.setup("N", "Black", 88, 14);
    design.setup("N", "Black", 77, 14);
    design.setup("N", "Black", 33, 14);
    design.setup("N", "Black", 22, 14);
    design.setup("N", "Black", 78, 14);
    design.setup("N", "Black", 56, 14);
    design.setup("N", "Black", 34, 14);
    design.setup("N", "Black", 112, 14);
    design.setup("N", "Black", 2, 14);
    design.setup("N", "Black", 79, 14);
    design.setup("N", "Black", 68, 14);
    design.setup("N", "Black", 46, 14);
    design.setup("N", "Black", 35, 14);
    design.setup("N", "Black", 113, 14);
    design.setup("N", "Black", 14, 14);
    design.setup("N", "Black", 3, 14);
    design.setup("N", "Black", 102, 14);
    design.setup("N", "Black", 91, 14);
    design.setup("N", "Black", 69, 14);
    design.setup("N", "Black", 47, 14);
    design.setup("N", "Black", 25, 14);
    design.setup("N", "Black", 92, 14);
    design.setup("N", "Black", 81, 14);
    design.setup("N", "Black", 59, 14);
    design.setup("N", "Black", 37, 14);
    design.setup("N", "Black", 26, 14);
    design.setup("N", "Black", 16, 14);
    design.setup("N", "Black", 104, 14);
    design.setup("N", "Black", 71, 14);
    design.setup("N", "Black", 49, 14);
    design.setup("N", "Black", 94, 14);
    design.setup("N", "Black", 83, 14);
    design.setup("N", "Black", 61, 14);
    design.setup("N", "Black", 39, 14);
    design.setup("N", "Black", 28, 14);
    design.setup("N", "Black", 117, 14);
    design.setup("N", "Black", 18, 14);
    design.setup("N", "Black", 7, 14);
    design.setup("N", "Black", 106, 14);
    design.setup("N", "Black", 95, 14);
    design.setup("N", "Black", 73, 14);
    design.setup("N", "Black", 51, 14);
    design.setup("N", "Black", 29, 14);
    design.setup("N", "Black", 118, 14);
    design.setup("N", "Black", 8, 14);
    design.setup("N", "Black", 85, 14);
    design.setup("N", "Black", 74, 14);
    design.setup("N", "Black", 52, 14);
    design.setup("N", "Black", 41, 14);
    design.setup("N", "Black", 86, 14);
    design.setup("N", "Black", 64, 14);
    design.setup("N", "Black", 42, 14);
    design.setup("N", "Black", 120, 14);
    design.setup("N", "Black", 10, 14);
    design.setup("N", "Black", 98, 14);
    design.setup("N", "Black", 87, 14);
    design.setup("N", "Black", 43, 14);
    design.setup("N", "Black", 32, 14);
    design.setup("N", "White", 11, 14);
    design.setup("N", "White", 99, 14);
    design.setup("N", "White", 66, 14);
    design.setup("N", "White", 55, 14);
    design.setup("N", "White", 44, 14);
    design.setup("N", "White", 111, 14);
    design.setup("N", "White", 12, 14);
    design.setup("N", "White", 1, 14);
    design.setup("N", "White", 100, 14);
    design.setup("N", "White", 89, 14);
    design.setup("N", "White", 67, 14);
    design.setup("N", "White", 45, 14);
    design.setup("N", "White", 23, 14);
    design.setup("N", "White", 13, 14);
    design.setup("N", "White", 101, 14);
    design.setup("N", "White", 90, 14);
    design.setup("N", "White", 57, 14);
    design.setup("N", "White", 24, 14);
    design.setup("N", "White", 80, 14);
    design.setup("N", "White", 58, 14);
    design.setup("N", "White", 36, 14);
    design.setup("N", "White", 114, 14);
    design.setup("N", "White", 15, 14);
    design.setup("N", "White", 4, 14);
    design.setup("N", "White", 103, 14);
    design.setup("N", "White", 70, 14);
    design.setup("N", "White", 48, 14);
    design.setup("N", "White", 115, 14);
    design.setup("N", "White", 5, 14);
    design.setup("N", "White", 93, 14);
    design.setup("N", "White", 82, 14);
    design.setup("N", "White", 38, 14);
    design.setup("N", "White", 27, 14);
    design.setup("N", "White", 116, 14);
    design.setup("N", "White", 17, 14);
    design.setup("N", "White", 6, 14);
    design.setup("N", "White", 105, 14);
    design.setup("N", "White", 72, 14);
    design.setup("N", "White", 50, 14);
    design.setup("N", "White", 84, 14);
    design.setup("N", "White", 62, 14);
    design.setup("N", "White", 40, 14);
    design.setup("N", "White", 19, 14);
    design.setup("N", "White", 107, 14);
    design.setup("N", "White", 96, 14);
    design.setup("N", "White", 63, 14);
    design.setup("N", "White", 30, 14);
    design.setup("N", "White", 119, 14);
    design.setup("N", "White", 20, 14);
    design.setup("N", "White", 9, 14);
    design.setup("N", "White", 108, 14);
    design.setup("N", "White", 97, 14);
    design.setup("N", "White", 75, 14);
    design.setup("N", "White", 53, 14);
    design.setup("N", "White", 31, 14);
    design.setup("N", "White", 21, 14);
    design.setup("N", "White", 109, 14);
    design.setup("N", "White", 76, 14);
    design.setup("N", "White", 65, 14);
    design.setup("N", "White", 54, 14);

    design.setup("N", "Black", 110, 15);
    design.setup("N", "Black", 0, 15);
    design.setup("N", "Black", 88, 15);
    design.setup("N", "Black", 77, 15);
    design.setup("N", "Black", 66, 15);
    design.setup("N", "Black", 44, 15);
    design.setup("N", "Black", 33, 15);
    design.setup("N", "Black", 22, 15);
    design.setup("N", "Black", 78, 15);
    design.setup("N", "Black", 56, 15);
    design.setup("N", "Black", 34, 15);
    design.setup("N", "Black", 112, 15);
    design.setup("N", "Black", 2, 15);
    design.setup("N", "Black", 90, 15);
    design.setup("N", "Black", 68, 15);
    design.setup("N", "Black", 46, 15);
    design.setup("N", "Black", 24, 15);
    design.setup("N", "Black", 113, 15);
    design.setup("N", "Black", 14, 15);
    design.setup("N", "Black", 3, 15);
    design.setup("N", "Black", 102, 15);
    design.setup("N", "Black", 80, 15);
    design.setup("N", "Black", 36, 15);
    design.setup("N", "Black", 114, 15);
    design.setup("N", "Black", 4, 15);
    design.setup("N", "Black", 92, 15);
    design.setup("N", "Black", 70, 15);
    design.setup("N", "Black", 48, 15);
    design.setup("N", "Black", 26, 15);
    design.setup("N", "Black", 16, 15);
    design.setup("N", "Black", 104, 15);
    design.setup("N", "Black", 116, 15);
    design.setup("N", "Black", 6, 15);
    design.setup("N", "Black", 94, 15);
    design.setup("N", "Black", 72, 15);
    design.setup("N", "Black", 50, 15);
    design.setup("N", "Black", 28, 15);
    design.setup("N", "Black", 117, 15);
    design.setup("N", "Black", 18, 15);
    design.setup("N", "Black", 7, 15);
    design.setup("N", "Black", 106, 15);
    design.setup("N", "Black", 84, 15);
    design.setup("N", "Black", 40, 15);
    design.setup("N", "Black", 118, 15);
    design.setup("N", "Black", 8, 15);
    design.setup("N", "Black", 96, 15);
    design.setup("N", "Black", 74, 15);
    design.setup("N", "Black", 52, 15);
    design.setup("N", "Black", 30, 15);
    design.setup("N", "Black", 86, 15);
    design.setup("N", "Black", 64, 15);
    design.setup("N", "Black", 42, 15);
    design.setup("N", "Black", 120, 15);
    design.setup("N", "Black", 10, 15);
    design.setup("N", "Black", 98, 15);
    design.setup("N", "Black", 87, 15);
    design.setup("N", "Black", 76, 15);
    design.setup("N", "Black", 54, 15);
    design.setup("N", "Black", 43, 15);
    design.setup("N", "Black", 32, 15);
    design.setup("N", "White", 11, 15);
    design.setup("N", "White", 99, 15);
    design.setup("N", "White", 55, 15);
    design.setup("N", "White", 111, 15);
    design.setup("N", "White", 12, 15);
    design.setup("N", "White", 1, 15);
    design.setup("N", "White", 100, 15);
    design.setup("N", "White", 89, 15);
    design.setup("N", "White", 67, 15);
    design.setup("N", "White", 45, 15);
    design.setup("N", "White", 23, 15);
    design.setup("N", "White", 13, 15);
    design.setup("N", "White", 101, 15);
    design.setup("N", "White", 79, 15);
    design.setup("N", "White", 57, 15);
    design.setup("N", "White", 35, 15);
    design.setup("N", "White", 91, 15);
    design.setup("N", "White", 69, 15);
    design.setup("N", "White", 58, 15);
    design.setup("N", "White", 47, 15);
    design.setup("N", "White", 25, 15);
    design.setup("N", "White", 15, 15);
    design.setup("N", "White", 103, 15);
    design.setup("N", "White", 81, 15);
    design.setup("N", "White", 59, 15);
    design.setup("N", "White", 37, 15);
    design.setup("N", "White", 115, 15);
    design.setup("N", "White", 5, 15);
    design.setup("N", "White", 93, 15);
    design.setup("N", "White", 82, 15);
    design.setup("N", "White", 71, 15);
    design.setup("N", "White", 49, 15);
    design.setup("N", "White", 38, 15);
    design.setup("N", "White", 27, 15);
    design.setup("N", "White", 17, 15);
    design.setup("N", "White", 105, 15);
    design.setup("N", "White", 83, 15);
    design.setup("N", "White", 61, 15);
    design.setup("N", "White", 39, 15);
    design.setup("N", "White", 95, 15);
    design.setup("N", "White", 73, 15);
    design.setup("N", "White", 62, 15);
    design.setup("N", "White", 51, 15);
    design.setup("N", "White", 29, 15);
    design.setup("N", "White", 19, 15);
    design.setup("N", "White", 107, 15);
    design.setup("N", "White", 85, 15);
    design.setup("N", "White", 63, 15);
    design.setup("N", "White", 41, 15);
    design.setup("N", "White", 119, 15);
    design.setup("N", "White", 20, 15);
    design.setup("N", "White", 9, 15);
    design.setup("N", "White", 108, 15);
    design.setup("N", "White", 97, 15);
    design.setup("N", "White", 75, 15);
    design.setup("N", "White", 53, 15);
    design.setup("N", "White", 31, 15);
    design.setup("N", "White", 21, 15);
    design.setup("N", "White", 109, 15);
    design.setup("N", "White", 65, 15);

    design.setup("N", "Black", 11, 16);
    design.setup("N", "Black", 99, 16);
    design.setup("N", "Black", 77, 16);
    design.setup("N", "Black", 55, 16);
    design.setup("N", "Black", 33, 16);
    design.setup("N", "Black", 111, 16);
    design.setup("N", "Black", 1, 16);
    design.setup("N", "Black", 89, 16);
    design.setup("N", "Black", 67, 16);
    design.setup("N", "Black", 45, 16);
    design.setup("N", "Black", 23, 16);
    design.setup("N", "Black", 13, 16);
    design.setup("N", "Black", 101, 16);
    design.setup("N", "Black", 79, 16);
    design.setup("N", "Black", 57, 16);
    design.setup("N", "Black", 35, 16);
    design.setup("N", "Black", 113, 16);
    design.setup("N", "Black", 3, 16);
    design.setup("N", "Black", 91, 16);
    design.setup("N", "Black", 58, 16);
    design.setup("N", "Black", 25, 16);
    design.setup("N", "Black", 15, 16);
    design.setup("N", "Black", 103, 16);
    design.setup("N", "Black", 70, 16);
    design.setup("N", "Black", 59, 16);
    design.setup("N", "Black", 48, 16);
    design.setup("N", "Black", 115, 16);
    design.setup("N", "Black", 5, 16);
    design.setup("N", "Black", 93, 16);
    design.setup("N", "Black", 82, 16);
    design.setup("N", "Black", 71, 16);
    design.setup("N", "Black", 49, 16);
    design.setup("N", "Black", 38, 16);
    design.setup("N", "Black", 27, 16);
    design.setup("N", "Black", 17, 16);
    design.setup("N", "Black", 105, 16);
    design.setup("N", "Black", 72, 16);
    design.setup("N", "Black", 61, 16);
    design.setup("N", "Black", 50, 16);
    design.setup("N", "Black", 117, 16);
    design.setup("N", "Black", 7, 16);
    design.setup("N", "Black", 95, 16);
    design.setup("N", "Black", 62, 16);
    design.setup("N", "Black", 29, 16);
    design.setup("N", "Black", 19, 16);
    design.setup("N", "Black", 107, 16);
    design.setup("N", "Black", 85, 16);
    design.setup("N", "Black", 63, 16);
    design.setup("N", "Black", 41, 16);
    design.setup("N", "Black", 119, 16);
    design.setup("N", "Black", 9, 16);
    design.setup("N", "Black", 97, 16);
    design.setup("N", "Black", 75, 16);
    design.setup("N", "Black", 53, 16);
    design.setup("N", "Black", 31, 16);
    design.setup("N", "Black", 21, 16);
    design.setup("N", "Black", 109, 16);
    design.setup("N", "Black", 87, 16);
    design.setup("N", "Black", 65, 16);
    design.setup("N", "Black", 43, 16);
    design.setup("N", "White", 110, 16);
    design.setup("N", "White", 0, 16);
    design.setup("N", "White", 88, 16);
    design.setup("N", "White", 66, 16);
    design.setup("N", "White", 44, 16);
    design.setup("N", "White", 22, 16);
    design.setup("N", "White", 12, 16);
    design.setup("N", "White", 100, 16);
    design.setup("N", "White", 78, 16);
    design.setup("N", "White", 56, 16);
    design.setup("N", "White", 34, 16);
    design.setup("N", "White", 112, 16);
    design.setup("N", "White", 2, 16);
    design.setup("N", "White", 90, 16);
    design.setup("N", "White", 68, 16);
    design.setup("N", "White", 46, 16);
    design.setup("N", "White", 24, 16);
    design.setup("N", "White", 14, 16);
    design.setup("N", "White", 102, 16);
    design.setup("N", "White", 80, 16);
    design.setup("N", "White", 69, 16);
    design.setup("N", "White", 47, 16);
    design.setup("N", "White", 36, 16);
    design.setup("N", "White", 114, 16);
    design.setup("N", "White", 4, 16);
    design.setup("N", "White", 92, 16);
    design.setup("N", "White", 81, 16);
    design.setup("N", "White", 37, 16);
    design.setup("N", "White", 26, 16);
    design.setup("N", "White", 16, 16);
    design.setup("N", "White", 104, 16);
    design.setup("N", "White", 116, 16);
    design.setup("N", "White", 6, 16);
    design.setup("N", "White", 94, 16);
    design.setup("N", "White", 83, 16);
    design.setup("N", "White", 39, 16);
    design.setup("N", "White", 28, 16);
    design.setup("N", "White", 18, 16);
    design.setup("N", "White", 106, 16);
    design.setup("N", "White", 84, 16);
    design.setup("N", "White", 73, 16);
    design.setup("N", "White", 51, 16);
    design.setup("N", "White", 40, 16);
    design.setup("N", "White", 118, 16);
    design.setup("N", "White", 8, 16);
    design.setup("N", "White", 96, 16);
    design.setup("N", "White", 74, 16);
    design.setup("N", "White", 52, 16);
    design.setup("N", "White", 30, 16);
    design.setup("N", "White", 20, 16);
    design.setup("N", "White", 108, 16);
    design.setup("N", "White", 86, 16);
    design.setup("N", "White", 64, 16);
    design.setup("N", "White", 42, 16);
    design.setup("N", "White", 120, 16);
    design.setup("N", "White", 10, 16);
    design.setup("N", "White", 98, 16);
    design.setup("N", "White", 76, 16);
    design.setup("N", "White", 54, 16);
    design.setup("N", "White", 32, 16);

    design.setup("N", "Black", 11, 17);
    design.setup("N", "Black", 99, 17);
    design.setup("N", "Black", 88, 17);
    design.setup("N", "Black", 55, 17);
    design.setup("N", "Black", 22, 17);
    design.setup("N", "Black", 111, 17);
    design.setup("N", "Black", 1, 17);
    design.setup("N", "Black", 78, 17);
    design.setup("N", "Black", 67, 17);
    design.setup("N", "Black", 45, 17);
    design.setup("N", "Black", 34, 17);
    design.setup("N", "Black", 112, 17);
    design.setup("N", "Black", 2, 17);
    design.setup("N", "Black", 79, 17);
    design.setup("N", "Black", 57, 17);
    design.setup("N", "Black", 35, 17);
    design.setup("N", "Black", 14, 17);
    design.setup("N", "Black", 102, 17);
    design.setup("N", "Black", 91, 17);
    design.setup("N", "Black", 69, 17);
    design.setup("N", "Black", 47, 17);
    design.setup("N", "Black", 25, 17);
    design.setup("N", "Black", 15, 17);
    design.setup("N", "Black", 103, 17);
    design.setup("N", "Black", 81, 17);
    design.setup("N", "Black", 59, 17);
    design.setup("N", "Black", 37, 17);
    design.setup("N", "Black", 115, 17);
    design.setup("N", "Black", 5, 17);
    design.setup("N", "Black", 93, 17);
    design.setup("N", "Black", 71, 17);
    design.setup("N", "Black", 49, 17);
    design.setup("N", "Black", 27, 17);
    design.setup("N", "Black", 17, 17);
    design.setup("N", "Black", 105, 17);
    design.setup("N", "Black", 83, 17);
    design.setup("N", "Black", 61, 17);
    design.setup("N", "Black", 39, 17);
    design.setup("N", "Black", 18, 17);
    design.setup("N", "Black", 106, 17);
    design.setup("N", "Black", 95, 17);
    design.setup("N", "Black", 73, 17);
    design.setup("N", "Black", 51, 17);
    design.setup("N", "Black", 29, 17);
    design.setup("N", "Black", 118, 17);
    design.setup("N", "Black", 8, 17);
    design.setup("N", "Black", 85, 17);
    design.setup("N", "Black", 63, 17);
    design.setup("N", "Black", 41, 17);
    design.setup("N", "Black", 119, 17);
    design.setup("N", "Black", 9, 17);
    design.setup("N", "Black", 86, 17);
    design.setup("N", "Black", 75, 17);
    design.setup("N", "Black", 53, 17);
    design.setup("N", "Black", 42, 17);
    design.setup("N", "Black", 21, 17);
    design.setup("N", "Black", 109, 17);
    design.setup("N", "Black", 98, 17);
    design.setup("N", "Black", 65, 17);
    design.setup("N", "Black", 32, 17);
    design.setup("N", "White", 110, 17);
    design.setup("N", "White", 0, 17);
    design.setup("N", "White", 77, 17);
    design.setup("N", "White", 66, 17);
    design.setup("N", "White", 44, 17);
    design.setup("N", "White", 33, 17);
    design.setup("N", "White", 12, 17);
    design.setup("N", "White", 100, 17);
    design.setup("N", "White", 89, 17);
    design.setup("N", "White", 56, 17);
    design.setup("N", "White", 23, 17);
    design.setup("N", "White", 13, 17);
    design.setup("N", "White", 101, 17);
    design.setup("N", "White", 90, 17);
    design.setup("N", "White", 68, 17);
    design.setup("N", "White", 46, 17);
    design.setup("N", "White", 24, 17);
    design.setup("N", "White", 113, 17);
    design.setup("N", "White", 3, 17);
    design.setup("N", "White", 80, 17);
    design.setup("N", "White", 58, 17);
    design.setup("N", "White", 36, 17);
    design.setup("N", "White", 114, 17);
    design.setup("N", "White", 4, 17);
    design.setup("N", "White", 92, 17);
    design.setup("N", "White", 70, 17);
    design.setup("N", "White", 48, 17);
    design.setup("N", "White", 26, 17);
    design.setup("N", "White", 16, 17);
    design.setup("N", "White", 104, 17);
    design.setup("N", "White", 82, 17);
    design.setup("N", "White", 38, 17);
    design.setup("N", "White", 116, 17);
    design.setup("N", "White", 6, 17);
    design.setup("N", "White", 94, 17);
    design.setup("N", "White", 72, 17);
    design.setup("N", "White", 50, 17);
    design.setup("N", "White", 28, 17);
    design.setup("N", "White", 117, 17);
    design.setup("N", "White", 7, 17);
    design.setup("N", "White", 84, 17);
    design.setup("N", "White", 62, 17);
    design.setup("N", "White", 40, 17);
    design.setup("N", "White", 19, 17);
    design.setup("N", "White", 107, 17);
    design.setup("N", "White", 96, 17);
    design.setup("N", "White", 74, 17);
    design.setup("N", "White", 52, 17);
    design.setup("N", "White", 30, 17);
    design.setup("N", "White", 20, 17);
    design.setup("N", "White", 108, 17);
    design.setup("N", "White", 97, 17);
    design.setup("N", "White", 64, 17);
    design.setup("N", "White", 31, 17);
    design.setup("N", "White", 120, 17);
    design.setup("N", "White", 10, 17);
    design.setup("N", "White", 87, 17);
    design.setup("N", "White", 76, 17);
    design.setup("N", "White", 54, 17);
    design.setup("N", "White", 43, 17);

    design.setup("N", "Black", 88, 18);
    design.setup("N", "Black", 66, 18);
    design.setup("N", "Black", 44, 18);
    design.setup("N", "Black", 22, 18);
    design.setup("N", "Black", 89, 18);
    design.setup("N", "Black", 78, 18);
    design.setup("N", "Black", 56, 18);
    design.setup("N", "Black", 34, 18);
    design.setup("N", "Black", 23, 18);
    design.setup("N", "Black", 112, 18);
    design.setup("N", "Black", 13, 18);
    design.setup("N", "Black", 2, 18);
    design.setup("N", "Black", 101, 18);
    design.setup("N", "Black", 79, 18);
    design.setup("N", "Black", 68, 18);
    design.setup("N", "Black", 46, 18);
    design.setup("N", "Black", 35, 18);
    design.setup("N", "Black", 14, 18);
    design.setup("N", "Black", 102, 18);
    design.setup("N", "Black", 91, 18);
    design.setup("N", "Black", 58, 18);
    design.setup("N", "Black", 25, 18);
    design.setup("N", "Black", 114, 18);
    design.setup("N", "Black", 4, 18);
    design.setup("N", "Black", 92, 18);
    design.setup("N", "Black", 70, 18);
    design.setup("N", "Black", 48, 18);
    design.setup("N", "Black", 26, 18);
    design.setup("N", "Black", 16, 18);
    design.setup("N", "Black", 104, 18);
    design.setup("N", "Black", 82, 18);
    design.setup("N", "Black", 38, 18);
    design.setup("N", "Black", 116, 18);
    design.setup("N", "Black", 6, 18);
    design.setup("N", "Black", 94, 18);
    design.setup("N", "Black", 72, 18);
    design.setup("N", "Black", 50, 18);
    design.setup("N", "Black", 28, 18);
    design.setup("N", "Black", 18, 18);
    design.setup("N", "Black", 106, 18);
    design.setup("N", "Black", 95, 18);
    design.setup("N", "Black", 62, 18);
    design.setup("N", "Black", 29, 18);
    design.setup("N", "Black", 118, 18);
    design.setup("N", "Black", 19, 18);
    design.setup("N", "Black", 8, 18);
    design.setup("N", "Black", 107, 18);
    design.setup("N", "Black", 85, 18);
    design.setup("N", "Black", 74, 18);
    design.setup("N", "Black", 52, 18);
    design.setup("N", "Black", 41, 18);
    design.setup("N", "Black", 97, 18);
    design.setup("N", "Black", 86, 18);
    design.setup("N", "Black", 64, 18);
    design.setup("N", "Black", 42, 18);
    design.setup("N", "Black", 31, 18);
    design.setup("N", "Black", 98, 18);
    design.setup("N", "Black", 76, 18);
    design.setup("N", "Black", 54, 18);
    design.setup("N", "Black", 32, 18);
    design.setup("N", "White", 110, 18);
    design.setup("N", "White", 11, 18);
    design.setup("N", "White", 0, 18);
    design.setup("N", "White", 99, 18);
    design.setup("N", "White", 77, 18);
    design.setup("N", "White", 55, 18);
    design.setup("N", "White", 33, 18);
    design.setup("N", "White", 111, 18);
    design.setup("N", "White", 12, 18);
    design.setup("N", "White", 1, 18);
    design.setup("N", "White", 100, 18);
    design.setup("N", "White", 67, 18);
    design.setup("N", "White", 45, 18);
    design.setup("N", "White", 90, 18);
    design.setup("N", "White", 57, 18);
    design.setup("N", "White", 24, 18);
    design.setup("N", "White", 113, 18);
    design.setup("N", "White", 3, 18);
    design.setup("N", "White", 80, 18);
    design.setup("N", "White", 69, 18);
    design.setup("N", "White", 47, 18);
    design.setup("N", "White", 36, 18);
    design.setup("N", "White", 15, 18);
    design.setup("N", "White", 103, 18);
    design.setup("N", "White", 81, 18);
    design.setup("N", "White", 59, 18);
    design.setup("N", "White", 37, 18);
    design.setup("N", "White", 115, 18);
    design.setup("N", "White", 5, 18);
    design.setup("N", "White", 93, 18);
    design.setup("N", "White", 71, 18);
    design.setup("N", "White", 49, 18);
    design.setup("N", "White", 27, 18);
    design.setup("N", "White", 17, 18);
    design.setup("N", "White", 105, 18);
    design.setup("N", "White", 83, 18);
    design.setup("N", "White", 61, 18);
    design.setup("N", "White", 39, 18);
    design.setup("N", "White", 117, 18);
    design.setup("N", "White", 7, 18);
    design.setup("N", "White", 84, 18);
    design.setup("N", "White", 73, 18);
    design.setup("N", "White", 51, 18);
    design.setup("N", "White", 40, 18);
    design.setup("N", "White", 96, 18);
    design.setup("N", "White", 63, 18);
    design.setup("N", "White", 30, 18);
    design.setup("N", "White", 119, 18);
    design.setup("N", "White", 20, 18);
    design.setup("N", "White", 9, 18);
    design.setup("N", "White", 108, 18);
    design.setup("N", "White", 75, 18);
    design.setup("N", "White", 53, 18);
    design.setup("N", "White", 120, 18);
    design.setup("N", "White", 21, 18);
    design.setup("N", "White", 10, 18);
    design.setup("N", "White", 109, 18);
    design.setup("N", "White", 87, 18);
    design.setup("N", "White", 65, 18);
    design.setup("N", "White", 43, 18);

    design.setup("N", "Black", 110, 19);
    design.setup("N", "Black", 0, 19);
    design.setup("N", "Black", 88, 19);
    design.setup("N", "Black", 77, 19);
    design.setup("N", "Black", 66, 19);
    design.setup("N", "Black", 44, 19);
    design.setup("N", "Black", 33, 19);
    design.setup("N", "Black", 22, 19);
    design.setup("N", "Black", 78, 19);
    design.setup("N", "Black", 34, 19);
    design.setup("N", "Black", 112, 19);
    design.setup("N", "Black", 2, 19);
    design.setup("N", "Black", 90, 19);
    design.setup("N", "Black", 68, 19);
    design.setup("N", "Black", 46, 19);
    design.setup("N", "Black", 24, 19);
    design.setup("N", "Black", 113, 19);
    design.setup("N", "Black", 14, 19);
    design.setup("N", "Black", 3, 19);
    design.setup("N", "Black", 102, 19);
    design.setup("N", "Black", 58, 19);
    design.setup("N", "Black", 114, 19);
    design.setup("N", "Black", 4, 19);
    design.setup("N", "Black", 92, 19);
    design.setup("N", "Black", 70, 19);
    design.setup("N", "Black", 59, 19);
    design.setup("N", "Black", 48, 19);
    design.setup("N", "Black", 26, 19);
    design.setup("N", "Black", 82, 19);
    design.setup("N", "Black", 71, 19);
    design.setup("N", "Black", 49, 19);
    design.setup("N", "Black", 38, 19);
    design.setup("N", "Black", 116, 19);
    design.setup("N", "Black", 6, 19);
    design.setup("N", "Black", 94, 19);
    design.setup("N", "Black", 72, 19);
    design.setup("N", "Black", 61, 19);
    design.setup("N", "Black", 50, 19);
    design.setup("N", "Black", 28, 19);
    design.setup("N", "Black", 117, 19);
    design.setup("N", "Black", 18, 19);
    design.setup("N", "Black", 7, 19);
    design.setup("N", "Black", 106, 19);
    design.setup("N", "Black", 62, 19);
    design.setup("N", "Black", 118, 19);
    design.setup("N", "Black", 8, 19);
    design.setup("N", "Black", 96, 19);
    design.setup("N", "Black", 74, 19);
    design.setup("N", "Black", 52, 19);
    design.setup("N", "Black", 30, 19);
    design.setup("N", "Black", 86, 19);
    design.setup("N", "Black", 42, 19);
    design.setup("N", "Black", 120, 19);
    design.setup("N", "Black", 10, 19);
    design.setup("N", "Black", 98, 19);
    design.setup("N", "Black", 87, 19);
    design.setup("N", "Black", 76, 19);
    design.setup("N", "Black", 54, 19);
    design.setup("N", "Black", 43, 19);
    design.setup("N", "Black", 32, 19);
    design.setup("N", "White", 11, 19);
    design.setup("N", "White", 99, 19);
    design.setup("N", "White", 55, 19);
    design.setup("N", "White", 111, 19);
    design.setup("N", "White", 12, 19);
    design.setup("N", "White", 1, 19);
    design.setup("N", "White", 100, 19);
    design.setup("N", "White", 89, 19);
    design.setup("N", "White", 67, 19);
    design.setup("N", "White", 56, 19);
    design.setup("N", "White", 45, 19);
    design.setup("N", "White", 23, 19);
    design.setup("N", "White", 13, 19);
    design.setup("N", "White", 101, 19);
    design.setup("N", "White", 79, 19);
    design.setup("N", "White", 57, 19);
    design.setup("N", "White", 35, 19);
    design.setup("N", "White", 91, 19);
    design.setup("N", "White", 80, 19);
    design.setup("N", "White", 69, 19);
    design.setup("N", "White", 47, 19);
    design.setup("N", "White", 36, 19);
    design.setup("N", "White", 25, 19);
    design.setup("N", "White", 15, 19);
    design.setup("N", "White", 103, 19);
    design.setup("N", "White", 81, 19);
    design.setup("N", "White", 37, 19);
    design.setup("N", "White", 115, 19);
    design.setup("N", "White", 16, 19);
    design.setup("N", "White", 5, 19);
    design.setup("N", "White", 104, 19);
    design.setup("N", "White", 93, 19);
    design.setup("N", "White", 27, 19);
    design.setup("N", "White", 17, 19);
    design.setup("N", "White", 105, 19);
    design.setup("N", "White", 83, 19);
    design.setup("N", "White", 39, 19);
    design.setup("N", "White", 95, 19);
    design.setup("N", "White", 84, 19);
    design.setup("N", "White", 73, 19);
    design.setup("N", "White", 51, 19);
    design.setup("N", "White", 40, 19);
    design.setup("N", "White", 29, 19);
    design.setup("N", "White", 19, 19);
    design.setup("N", "White", 107, 19);
    design.setup("N", "White", 85, 19);
    design.setup("N", "White", 63, 19);
    design.setup("N", "White", 41, 19);
    design.setup("N", "White", 119, 19);
    design.setup("N", "White", 20, 19);
    design.setup("N", "White", 9, 19);
    design.setup("N", "White", 108, 19);
    design.setup("N", "White", 97, 19);
    design.setup("N", "White", 75, 19);
    design.setup("N", "White", 64, 19);
    design.setup("N", "White", 53, 19);
    design.setup("N", "White", 31, 19);
    design.setup("N", "White", 21, 19);
    design.setup("N", "White", 109, 19);
    design.setup("N", "White", 65, 19);

    design.setup("N", "Black", 110, 20);
    design.setup("N", "Black", 11, 20);
    design.setup("N", "Black", 0, 20);
    design.setup("N", "Black", 99, 20);
    design.setup("N", "Black", 66, 20);
    design.setup("N", "Black", 44, 20);
    design.setup("N", "Black", 111, 20);
    design.setup("N", "Black", 1, 20);
    design.setup("N", "Black", 89, 20);
    design.setup("N", "Black", 78, 20);
    design.setup("N", "Black", 56, 20);
    design.setup("N", "Black", 34, 20);
    design.setup("N", "Black", 23, 20);
    design.setup("N", "Black", 13, 20);
    design.setup("N", "Black", 101, 20);
    design.setup("N", "Black", 68, 20);
    design.setup("N", "Black", 46, 20);
    design.setup("N", "Black", 14, 20);
    design.setup("N", "Black", 102, 20);
    design.setup("N", "Black", 69, 20);
    design.setup("N", "Black", 47, 20);
    design.setup("N", "Black", 114, 20);
    design.setup("N", "Black", 4, 20);
    design.setup("N", "Black", 92, 20);
    design.setup("N", "Black", 81, 20);
    design.setup("N", "Black", 59, 20);
    design.setup("N", "Black", 37, 20);
    design.setup("N", "Black", 26, 20);
    design.setup("N", "Black", 16, 20);
    design.setup("N", "Black", 104, 20);
    design.setup("N", "Black", 71, 20);
    design.setup("N", "Black", 49, 20);
    design.setup("N", "Black", 116, 20);
    design.setup("N", "Black", 6, 20);
    design.setup("N", "Black", 94, 20);
    design.setup("N", "Black", 83, 20);
    design.setup("N", "Black", 61, 20);
    design.setup("N", "Black", 39, 20);
    design.setup("N", "Black", 28, 20);
    design.setup("N", "Black", 18, 20);
    design.setup("N", "Black", 106, 20);
    design.setup("N", "Black", 73, 20);
    design.setup("N", "Black", 51, 20);
    design.setup("N", "Black", 19, 20);
    design.setup("N", "Black", 107, 20);
    design.setup("N", "Black", 74, 20);
    design.setup("N", "Black", 52, 20);
    design.setup("N", "Black", 119, 20);
    design.setup("N", "Black", 9, 20);
    design.setup("N", "Black", 97, 20);
    design.setup("N", "Black", 86, 20);
    design.setup("N", "Black", 64, 20);
    design.setup("N", "Black", 42, 20);
    design.setup("N", "Black", 31, 20);
    design.setup("N", "Black", 120, 20);
    design.setup("N", "Black", 21, 20);
    design.setup("N", "Black", 10, 20);
    design.setup("N", "Black", 109, 20);
    design.setup("N", "Black", 76, 20);
    design.setup("N", "Black", 54, 20);
    design.setup("N", "White", 88, 20);
    design.setup("N", "White", 77, 20);
    design.setup("N", "White", 55, 20);
    design.setup("N", "White", 33, 20);
    design.setup("N", "White", 22, 20);
    design.setup("N", "White", 12, 20);
    design.setup("N", "White", 100, 20);
    design.setup("N", "White", 67, 20);
    design.setup("N", "White", 45, 20);
    design.setup("N", "White", 112, 20);
    design.setup("N", "White", 2, 20);
    design.setup("N", "White", 90, 20);
    design.setup("N", "White", 79, 20);
    design.setup("N", "White", 57, 20);
    design.setup("N", "White", 35, 20);
    design.setup("N", "White", 24, 20);
    design.setup("N", "White", 113, 20);
    design.setup("N", "White", 3, 20);
    design.setup("N", "White", 91, 20);
    design.setup("N", "White", 80, 20);
    design.setup("N", "White", 58, 20);
    design.setup("N", "White", 36, 20);
    design.setup("N", "White", 25, 20);
    design.setup("N", "White", 15, 20);
    design.setup("N", "White", 103, 20);
    design.setup("N", "White", 70, 20);
    design.setup("N", "White", 48, 20);
    design.setup("N", "White", 115, 20);
    design.setup("N", "White", 5, 20);
    design.setup("N", "White", 93, 20);
    design.setup("N", "White", 82, 20);
    design.setup("N", "White", 38, 20);
    design.setup("N", "White", 27, 20);
    design.setup("N", "White", 17, 20);
    design.setup("N", "White", 105, 20);
    design.setup("N", "White", 72, 20);
    design.setup("N", "White", 50, 20);
    design.setup("N", "White", 117, 20);
    design.setup("N", "White", 7, 20);
    design.setup("N", "White", 95, 20);
    design.setup("N", "White", 84, 20);
    design.setup("N", "White", 62, 20);
    design.setup("N", "White", 40, 20);
    design.setup("N", "White", 29, 20);
    design.setup("N", "White", 118, 20);
    design.setup("N", "White", 8, 20);
    design.setup("N", "White", 96, 20);
    design.setup("N", "White", 85, 20);
    design.setup("N", "White", 63, 20);
    design.setup("N", "White", 41, 20);
    design.setup("N", "White", 30, 20);
    design.setup("N", "White", 20, 20);
    design.setup("N", "White", 108, 20);
    design.setup("N", "White", 75, 20);
    design.setup("N", "White", 53, 20);
    design.setup("N", "White", 98, 20);
    design.setup("N", "White", 87, 20);
    design.setup("N", "White", 65, 20);
    design.setup("N", "White", 43, 20);
    design.setup("N", "White", 32, 20);

    design.setup("N", "Black", 11, 21);
    design.setup("N", "Black", 99, 21);
    design.setup("N", "Black", 88, 21);
    design.setup("N", "Black", 77, 21);
    design.setup("N", "Black", 33, 21);
    design.setup("N", "Black", 22, 21);
    design.setup("N", "Black", 111, 21);
    design.setup("N", "Black", 1, 21);
    design.setup("N", "Black", 78, 21);
    design.setup("N", "Black", 67, 21);
    design.setup("N", "Black", 45, 21);
    design.setup("N", "Black", 34, 21);
    design.setup("N", "Black", 112, 21);
    design.setup("N", "Black", 2, 21);
    design.setup("N", "Black", 68, 21);
    design.setup("N", "Black", 46, 21);
    design.setup("N", "Black", 113, 21);
    design.setup("N", "Black", 14, 21);
    design.setup("N", "Black", 3, 21);
    design.setup("N", "Black", 102, 21);
    design.setup("N", "Black", 69, 21);
    design.setup("N", "Black", 47, 21);
    design.setup("N", "Black", 15, 21);
    design.setup("N", "Black", 103, 21);
    design.setup("N", "Black", 92, 21);
    design.setup("N", "Black", 81, 21);
    design.setup("N", "Black", 59, 21);
    design.setup("N", "Black", 37, 21);
    design.setup("N", "Black", 26, 21);
    design.setup("N", "Black", 71, 21);
    design.setup("N", "Black", 49, 21);
    design.setup("N", "Black", 17, 21);
    design.setup("N", "Black", 105, 21);
    design.setup("N", "Black", 94, 21);
    design.setup("N", "Black", 83, 21);
    design.setup("N", "Black", 61, 21);
    design.setup("N", "Black", 39, 21);
    design.setup("N", "Black", 28, 21);
    design.setup("N", "Black", 117, 21);
    design.setup("N", "Black", 18, 21);
    design.setup("N", "Black", 7, 21);
    design.setup("N", "Black", 106, 21);
    design.setup("N", "Black", 73, 21);
    design.setup("N", "Black", 51, 21);
    design.setup("N", "Black", 118, 21);
    design.setup("N", "Black", 8, 21);
    design.setup("N", "Black", 74, 21);
    design.setup("N", "Black", 52, 21);
    design.setup("N", "Black", 119, 21);
    design.setup("N", "Black", 9, 21);
    design.setup("N", "Black", 86, 21);
    design.setup("N", "Black", 75, 21);
    design.setup("N", "Black", 53, 21);
    design.setup("N", "Black", 42, 21);
    design.setup("N", "Black", 21, 21);
    design.setup("N", "Black", 109, 21);
    design.setup("N", "Black", 98, 21);
    design.setup("N", "Black", 87, 21);
    design.setup("N", "Black", 43, 21);
    design.setup("N", "Black", 32, 21);
    design.setup("N", "White", 110, 21);
    design.setup("N", "White", 0, 21);
    design.setup("N", "White", 66, 21);
    design.setup("N", "White", 55, 21);
    design.setup("N", "White", 44, 21);
    design.setup("N", "White", 12, 21);
    design.setup("N", "White", 100, 21);
    design.setup("N", "White", 89, 21);
    design.setup("N", "White", 56, 21);
    design.setup("N", "White", 23, 21);
    design.setup("N", "White", 13, 21);
    design.setup("N", "White", 101, 21);
    design.setup("N", "White", 90, 21);
    design.setup("N", "White", 79, 21);
    design.setup("N", "White", 57, 21);
    design.setup("N", "White", 35, 21);
    design.setup("N", "White", 24, 21);
    design.setup("N", "White", 91, 21);
    design.setup("N", "White", 80, 21);
    design.setup("N", "White", 58, 21);
    design.setup("N", "White", 36, 21);
    design.setup("N", "White", 25, 21);
    design.setup("N", "White", 114, 21);
    design.setup("N", "White", 4, 21);
    design.setup("N", "White", 70, 21);
    design.setup("N", "White", 48, 21);
    design.setup("N", "White", 115, 21);
    design.setup("N", "White", 16, 21);
    design.setup("N", "White", 5, 21);
    design.setup("N", "White", 104, 21);
    design.setup("N", "White", 93, 21);
    design.setup("N", "White", 82, 21);
    design.setup("N", "White", 38, 21);
    design.setup("N", "White", 27, 21);
    design.setup("N", "White", 116, 21);
    design.setup("N", "White", 6, 21);
    design.setup("N", "White", 72, 21);
    design.setup("N", "White", 50, 21);
    design.setup("N", "White", 95, 21);
    design.setup("N", "White", 84, 21);
    design.setup("N", "White", 62, 21);
    design.setup("N", "White", 40, 21);
    design.setup("N", "White", 29, 21);
    design.setup("N", "White", 19, 21);
    design.setup("N", "White", 107, 21);
    design.setup("N", "White", 96, 21);
    design.setup("N", "White", 85, 21);
    design.setup("N", "White", 63, 21);
    design.setup("N", "White", 41, 21);
    design.setup("N", "White", 30, 21);
    design.setup("N", "White", 20, 21);
    design.setup("N", "White", 108, 21);
    design.setup("N", "White", 97, 21);
    design.setup("N", "White", 64, 21);
    design.setup("N", "White", 31, 21);
    design.setup("N", "White", 120, 21);
    design.setup("N", "White", 10, 21);
    design.setup("N", "White", 76, 21);
    design.setup("N", "White", 65, 21);
    design.setup("N", "White", 54, 21);

    design.setup("N", "Black", 110, 22);
    design.setup("N", "Black", 0, 22);
    design.setup("N", "Black", 77, 22);
    design.setup("N", "Black", 55, 22);
    design.setup("N", "Black", 33, 22);
    design.setup("N", "Black", 12, 22);
    design.setup("N", "Black", 100, 22);
    design.setup("N", "Black", 78, 22);
    design.setup("N", "Black", 67, 22);
    design.setup("N", "Black", 45, 22);
    design.setup("N", "Black", 34, 22);
    design.setup("N", "Black", 90, 22);
    design.setup("N", "Black", 57, 22);
    design.setup("N", "Black", 24, 22);
    design.setup("N", "Black", 113, 22);
    design.setup("N", "Black", 14, 22);
    design.setup("N", "Black", 3, 22);
    design.setup("N", "Black", 102, 22);
    design.setup("N", "Black", 80, 22);
    design.setup("N", "Black", 58, 22);
    design.setup("N", "Black", 36, 22);
    design.setup("N", "Black", 15, 22);
    design.setup("N", "Black", 103, 22);
    design.setup("N", "Black", 70, 22);
    design.setup("N", "Black", 59, 22);
    design.setup("N", "Black", 48, 22);
    design.setup("N", "Black", 115, 22);
    design.setup("N", "Black", 5, 22);
    design.setup("N", "Black", 93, 22);
    design.setup("N", "Black", 82, 22);
    design.setup("N", "Black", 71, 22);
    design.setup("N", "Black", 49, 22);
    design.setup("N", "Black", 38, 22);
    design.setup("N", "Black", 27, 22);
    design.setup("N", "Black", 17, 22);
    design.setup("N", "Black", 105, 22);
    design.setup("N", "Black", 72, 22);
    design.setup("N", "Black", 61, 22);
    design.setup("N", "Black", 50, 22);
    design.setup("N", "Black", 117, 22);
    design.setup("N", "Black", 18, 22);
    design.setup("N", "Black", 7, 22);
    design.setup("N", "Black", 106, 22);
    design.setup("N", "Black", 84, 22);
    design.setup("N", "Black", 62, 22);
    design.setup("N", "Black", 40, 22);
    design.setup("N", "Black", 96, 22);
    design.setup("N", "Black", 63, 22);
    design.setup("N", "Black", 30, 22);
    design.setup("N", "Black", 20, 22);
    design.setup("N", "Black", 108, 22);
    design.setup("N", "Black", 86, 22);
    design.setup("N", "Black", 75, 22);
    design.setup("N", "Black", 53, 22);
    design.setup("N", "Black", 42, 22);
    design.setup("N", "Black", 120, 22);
    design.setup("N", "Black", 10, 22);
    design.setup("N", "Black", 87, 22);
    design.setup("N", "Black", 65, 22);
    design.setup("N", "Black", 43, 22);
    design.setup("N", "White", 11, 22);
    design.setup("N", "White", 99, 22);
    design.setup("N", "White", 88, 22);
    design.setup("N", "White", 66, 22);
    design.setup("N", "White", 44, 22);
    design.setup("N", "White", 22, 22);
    design.setup("N", "White", 111, 22);
    design.setup("N", "White", 1, 22);
    design.setup("N", "White", 89, 22);
    design.setup("N", "White", 56, 22);
    design.setup("N", "White", 23, 22);
    design.setup("N", "White", 112, 22);
    design.setup("N", "White", 13, 22);
    design.setup("N", "White", 2, 22);
    design.setup("N", "White", 101, 22);
    design.setup("N", "White", 79, 22);
    design.setup("N", "White", 68, 22);
    design.setup("N", "White", 46, 22);
    design.setup("N", "White", 35, 22);
    design.setup("N", "White", 91, 22);
    design.setup("N", "White", 69, 22);
    design.setup("N", "White", 47, 22);
    design.setup("N", "White", 25, 22);
    design.setup("N", "White", 114, 22);
    design.setup("N", "White", 4, 22);
    design.setup("N", "White", 92, 22);
    design.setup("N", "White", 81, 22);
    design.setup("N", "White", 37, 22);
    design.setup("N", "White", 26, 22);
    design.setup("N", "White", 16, 22);
    design.setup("N", "White", 104, 22);
    design.setup("N", "White", 116, 22);
    design.setup("N", "White", 6, 22);
    design.setup("N", "White", 94, 22);
    design.setup("N", "White", 83, 22);
    design.setup("N", "White", 39, 22);
    design.setup("N", "White", 28, 22);
    design.setup("N", "White", 95, 22);
    design.setup("N", "White", 73, 22);
    design.setup("N", "White", 51, 22);
    design.setup("N", "White", 29, 22);
    design.setup("N", "White", 118, 22);
    design.setup("N", "White", 19, 22);
    design.setup("N", "White", 8, 22);
    design.setup("N", "White", 107, 22);
    design.setup("N", "White", 85, 22);
    design.setup("N", "White", 74, 22);
    design.setup("N", "White", 52, 22);
    design.setup("N", "White", 41, 22);
    design.setup("N", "White", 119, 22);
    design.setup("N", "White", 9, 22);
    design.setup("N", "White", 97, 22);
    design.setup("N", "White", 64, 22);
    design.setup("N", "White", 31, 22);
    design.setup("N", "White", 21, 22);
    design.setup("N", "White", 109, 22);
    design.setup("N", "White", 98, 22);
    design.setup("N", "White", 76, 22);
    design.setup("N", "White", 54, 22);
    design.setup("N", "White", 32, 22);

    design.setup("N", "Black", 110, 23);
    design.setup("N", "Black", 0, 23);
    design.setup("N", "Black", 77, 23);
    design.setup("N", "Black", 66, 23);
    design.setup("N", "Black", 44, 23);
    design.setup("N", "Black", 33, 23);
    design.setup("N", "Black", 89, 23);
    design.setup("N", "Black", 67, 23);
    design.setup("N", "Black", 56, 23);
    design.setup("N", "Black", 45, 23);
    design.setup("N", "Black", 23, 23);
    design.setup("N", "Black", 13, 23);
    design.setup("N", "Black", 101, 23);
    design.setup("N", "Black", 79, 23);
    design.setup("N", "Black", 57, 23);
    design.setup("N", "Black", 35, 23);
    design.setup("N", "Black", 113, 23);
    design.setup("N", "Black", 3, 23);
    design.setup("N", "Black", 91, 23);
    design.setup("N", "Black", 58, 23);
    design.setup("N", "Black", 25, 23);
    design.setup("N", "Black", 114, 23);
    design.setup("N", "Black", 15, 23);
    design.setup("N", "Black", 4, 23);
    design.setup("N", "Black", 103, 23);
    design.setup("N", "Black", 70, 23);
    design.setup("N", "Black", 48, 23);
    design.setup("N", "Black", 16, 23);
    design.setup("N", "Black", 104, 23);
    design.setup("N", "Black", 93, 23);
    design.setup("N", "Black", 82, 23);
    design.setup("N", "Black", 38, 23);
    design.setup("N", "Black", 27, 23);
    design.setup("N", "Black", 116, 23);
    design.setup("N", "Black", 17, 23);
    design.setup("N", "Black", 6, 23);
    design.setup("N", "Black", 105, 23);
    design.setup("N", "Black", 72, 23);
    design.setup("N", "Black", 50, 23);
    design.setup("N", "Black", 117, 23);
    design.setup("N", "Black", 7, 23);
    design.setup("N", "Black", 95, 23);
    design.setup("N", "Black", 62, 23);
    design.setup("N", "Black", 29, 23);
    design.setup("N", "Black", 19, 23);
    design.setup("N", "Black", 107, 23);
    design.setup("N", "Black", 85, 23);
    design.setup("N", "Black", 63, 23);
    design.setup("N", "Black", 41, 23);
    design.setup("N", "Black", 97, 23);
    design.setup("N", "Black", 75, 23);
    design.setup("N", "Black", 64, 23);
    design.setup("N", "Black", 53, 23);
    design.setup("N", "Black", 31, 23);
    design.setup("N", "Black", 120, 23);
    design.setup("N", "Black", 10, 23);
    design.setup("N", "Black", 87, 23);
    design.setup("N", "Black", 76, 23);
    design.setup("N", "Black", 54, 23);
    design.setup("N", "Black", 43, 23);
    design.setup("N", "White", 11, 23);
    design.setup("N", "White", 99, 23);
    design.setup("N", "White", 88, 23);
    design.setup("N", "White", 55, 23);
    design.setup("N", "White", 22, 23);
    design.setup("N", "White", 111, 23);
    design.setup("N", "White", 12, 23);
    design.setup("N", "White", 1, 23);
    design.setup("N", "White", 100, 23);
    design.setup("N", "White", 78, 23);
    design.setup("N", "White", 34, 23);
    design.setup("N", "White", 112, 23);
    design.setup("N", "White", 2, 23);
    design.setup("N", "White", 90, 23);
    design.setup("N", "White", 68, 23);
    design.setup("N", "White", 46, 23);
    design.setup("N", "White", 24, 23);
    design.setup("N", "White", 14, 23);
    design.setup("N", "White", 102, 23);
    design.setup("N", "White", 80, 23);
    design.setup("N", "White", 69, 23);
    design.setup("N", "White", 47, 23);
    design.setup("N", "White", 36, 23);
    design.setup("N", "White", 92, 23);
    design.setup("N", "White", 81, 23);
    design.setup("N", "White", 59, 23);
    design.setup("N", "White", 37, 23);
    design.setup("N", "White", 26, 23);
    design.setup("N", "White", 115, 23);
    design.setup("N", "White", 5, 23);
    design.setup("N", "White", 71, 23);
    design.setup("N", "White", 49, 23);
    design.setup("N", "White", 94, 23);
    design.setup("N", "White", 83, 23);
    design.setup("N", "White", 61, 23);
    design.setup("N", "White", 39, 23);
    design.setup("N", "White", 28, 23);
    design.setup("N", "White", 18, 23);
    design.setup("N", "White", 106, 23);
    design.setup("N", "White", 84, 23);
    design.setup("N", "White", 73, 23);
    design.setup("N", "White", 51, 23);
    design.setup("N", "White", 40, 23);
    design.setup("N", "White", 118, 23);
    design.setup("N", "White", 8, 23);
    design.setup("N", "White", 96, 23);
    design.setup("N", "White", 74, 23);
    design.setup("N", "White", 52, 23);
    design.setup("N", "White", 30, 23);
    design.setup("N", "White", 119, 23);
    design.setup("N", "White", 20, 23);
    design.setup("N", "White", 9, 23);
    design.setup("N", "White", 108, 23);
    design.setup("N", "White", 86, 23);
    design.setup("N", "White", 42, 23);
    design.setup("N", "White", 21, 23);
    design.setup("N", "White", 109, 23);
    design.setup("N", "White", 98, 23);
    design.setup("N", "White", 65, 23);
    design.setup("N", "White", 32, 23);

    design.setup("N", "Black", 110, 24);
    design.setup("N", "Black", 0, 24);
    design.setup("N", "Black", 88, 24);
    design.setup("N", "Black", 66, 24);
    design.setup("N", "Black", 44, 24);
    design.setup("N", "Black", 22, 24);
    design.setup("N", "Black", 89, 24);
    design.setup("N", "Black", 56, 24);
    design.setup("N", "Black", 23, 24);
    design.setup("N", "Black", 112, 24);
    design.setup("N", "Black", 13, 24);
    design.setup("N", "Black", 2, 24);
    design.setup("N", "Black", 101, 24);
    design.setup("N", "Black", 79, 24);
    design.setup("N", "Black", 68, 24);
    design.setup("N", "Black", 46, 24);
    design.setup("N", "Black", 35, 24);
    design.setup("N", "Black", 91, 24);
    design.setup("N", "Black", 58, 24);
    design.setup("N", "Black", 25, 24);
    design.setup("N", "Black", 114, 24);
    design.setup("N", "Black", 4, 24);
    design.setup("N", "Black", 92, 24);
    design.setup("N", "Black", 70, 24);
    design.setup("N", "Black", 59, 24);
    design.setup("N", "Black", 48, 24);
    design.setup("N", "Black", 26, 24);
    design.setup("N", "Black", 16, 24);
    design.setup("N", "Black", 104, 24);
    design.setup("N", "Black", 82, 24);
    design.setup("N", "Black", 71, 24);
    design.setup("N", "Black", 49, 24);
    design.setup("N", "Black", 38, 24);
    design.setup("N", "Black", 116, 24);
    design.setup("N", "Black", 6, 24);
    design.setup("N", "Black", 94, 24);
    design.setup("N", "Black", 72, 24);
    design.setup("N", "Black", 61, 24);
    design.setup("N", "Black", 50, 24);
    design.setup("N", "Black", 28, 24);
    design.setup("N", "Black", 95, 24);
    design.setup("N", "Black", 62, 24);
    design.setup("N", "Black", 29, 24);
    design.setup("N", "Black", 118, 24);
    design.setup("N", "Black", 19, 24);
    design.setup("N", "Black", 8, 24);
    design.setup("N", "Black", 107, 24);
    design.setup("N", "Black", 85, 24);
    design.setup("N", "Black", 74, 24);
    design.setup("N", "Black", 52, 24);
    design.setup("N", "Black", 41, 24);
    design.setup("N", "Black", 97, 24);
    design.setup("N", "Black", 64, 24);
    design.setup("N", "Black", 31, 24);
    design.setup("N", "Black", 120, 24);
    design.setup("N", "Black", 10, 24);
    design.setup("N", "Black", 98, 24);
    design.setup("N", "Black", 76, 24);
    design.setup("N", "Black", 54, 24);
    design.setup("N", "Black", 32, 24);
    design.setup("N", "White", 11, 24);
    design.setup("N", "White", 99, 24);
    design.setup("N", "White", 77, 24);
    design.setup("N", "White", 55, 24);
    design.setup("N", "White", 33, 24);
    design.setup("N", "White", 111, 24);
    design.setup("N", "White", 12, 24);
    design.setup("N", "White", 1, 24);
    design.setup("N", "White", 100, 24);
    design.setup("N", "White", 78, 24);
    design.setup("N", "White", 67, 24);
    design.setup("N", "White", 45, 24);
    design.setup("N", "White", 34, 24);
    design.setup("N", "White", 90, 24);
    design.setup("N", "White", 57, 24);
    design.setup("N", "White", 24, 24);
    design.setup("N", "White", 113, 24);
    design.setup("N", "White", 14, 24);
    design.setup("N", "White", 3, 24);
    design.setup("N", "White", 102, 24);
    design.setup("N", "White", 80, 24);
    design.setup("N", "White", 69, 24);
    design.setup("N", "White", 47, 24);
    design.setup("N", "White", 36, 24);
    design.setup("N", "White", 15, 24);
    design.setup("N", "White", 103, 24);
    design.setup("N", "White", 81, 24);
    design.setup("N", "White", 37, 24);
    design.setup("N", "White", 115, 24);
    design.setup("N", "White", 5, 24);
    design.setup("N", "White", 93, 24);
    design.setup("N", "White", 27, 24);
    design.setup("N", "White", 17, 24);
    design.setup("N", "White", 105, 24);
    design.setup("N", "White", 83, 24);
    design.setup("N", "White", 39, 24);
    design.setup("N", "White", 117, 24);
    design.setup("N", "White", 18, 24);
    design.setup("N", "White", 7, 24);
    design.setup("N", "White", 106, 24);
    design.setup("N", "White", 84, 24);
    design.setup("N", "White", 73, 24);
    design.setup("N", "White", 51, 24);
    design.setup("N", "White", 40, 24);
    design.setup("N", "White", 96, 24);
    design.setup("N", "White", 30, 24);
    design.setup("N", "White", 119, 24);
    design.setup("N", "White", 20, 24);
    design.setup("N", "White", 63, 24);
    design.setup("N", "White", 9, 24);
    design.setup("N", "White", 108, 24);
    design.setup("N", "White", 86, 24);
    design.setup("N", "White", 75, 24);
    design.setup("N", "White", 53, 24);
    design.setup("N", "White", 42, 24);
    design.setup("N", "White", 21, 24);
    design.setup("N", "White", 109, 24);
    design.setup("N", "White", 87, 24);
    design.setup("N", "White", 65, 24);
    design.setup("N", "White", 43, 24);

    design.setup("N", "Black", 88, 25);
    design.setup("N", "Black", 55, 25);
    design.setup("N", "Black", 22, 25);
    design.setup("N", "Black", 12, 25);
    design.setup("N", "Black", 100, 25);
    design.setup("N", "Black", 89, 25);
    design.setup("N", "Black", 78, 25);
    design.setup("N", "Black", 56, 25);
    design.setup("N", "Black", 34, 25);
    design.setup("N", "Black", 23, 25);
    design.setup("N", "Black", 112, 25);
    design.setup("N", "Black", 13, 25);
    design.setup("N", "Black", 2, 25);
    design.setup("N", "Black", 101, 25);
    design.setup("N", "Black", 68, 25);
    design.setup("N", "Black", 57, 25);
    design.setup("N", "Black", 46, 25);
    design.setup("N", "Black", 14, 25);
    design.setup("N", "Black", 102, 25);
    design.setup("N", "Black", 80, 25);
    design.setup("N", "Black", 69, 25);
    design.setup("N", "Black", 36, 25);
    design.setup("N", "Black", 92, 25);
    design.setup("N", "Black", 59, 25);
    design.setup("N", "Black", 37, 25);
    design.setup("N", "Black", 26, 25);
    design.setup("N", "Black", 115, 25);
    design.setup("N", "Black", 16, 25);
    design.setup("N", "Black", 5, 25);
    design.setup("N", "Black", 104, 25);
    design.setup("N", "Black", 93, 25);
    design.setup("N", "Black", 71, 25);
    design.setup("N", "Black", 49, 25);
    design.setup("N", "Black", 27, 25);
    design.setup("N", "Black", 94, 25);
    design.setup("N", "Black", 83, 25);
    design.setup("N", "Black", 61, 25);
    design.setup("N", "Black", 28, 25);
    design.setup("N", "Black", 18, 25);
    design.setup("N", "Black", 106, 25);
    design.setup("N", "Black", 84, 25);
    design.setup("N", "Black", 51, 25);
    design.setup("N", "Black", 40, 25);
    design.setup("N", "Black", 118, 25);
    design.setup("N", "Black", 19, 25);
    design.setup("N", "Black", 8, 25);
    design.setup("N", "Black", 107, 25);
    design.setup("N", "Black", 74, 25);
    design.setup("N", "Black", 63, 25);
    design.setup("N", "Black", 52, 25);
    design.setup("N", "Black", 20, 25);
    design.setup("N", "Black", 108, 25);
    design.setup("N", "Black", 97, 25);
    design.setup("N", "Black", 86, 25);
    design.setup("N", "Black", 64, 25);
    design.setup("N", "Black", 42, 25);
    design.setup("N", "Black", 31, 25);
    design.setup("N", "Black", 98, 25);
    design.setup("N", "Black", 65, 25);
    design.setup("N", "Black", 32, 25);
    design.setup("N", "White", 110, 25);
    design.setup("N", "White", 11, 25);
    design.setup("N", "White", 0, 25);
    design.setup("N", "White", 99, 25);
    design.setup("N", "White", 77, 25);
    design.setup("N", "White", 66, 25);
    design.setup("N", "White", 44, 25);
    design.setup("N", "White", 33, 25);
    design.setup("N", "White", 111, 25);
    design.setup("N", "White", 1, 25);
    design.setup("N", "White", 67, 25);
    design.setup("N", "White", 45, 25);
    design.setup("N", "White", 90, 25);
    design.setup("N", "White", 79, 25);
    design.setup("N", "White", 35, 25);
    design.setup("N", "White", 24, 25);
    design.setup("N", "White", 113, 25);
    design.setup("N", "White", 3, 25);
    design.setup("N", "White", 91, 25);
    design.setup("N", "White", 58, 25);
    design.setup("N", "White", 47, 25);
    design.setup("N", "White", 25, 25);
    design.setup("N", "White", 114, 25);
    design.setup("N", "White", 15, 25);
    design.setup("N", "White", 4, 25);
    design.setup("N", "White", 103, 25);
    design.setup("N", "White", 81, 25);
    design.setup("N", "White", 70, 25);
    design.setup("N", "White", 48, 25);
    design.setup("N", "White", 82, 25);
    design.setup("N", "White", 38, 25);
    design.setup("N", "White", 116, 25);
    design.setup("N", "White", 17, 25);
    design.setup("N", "White", 6, 25);
    design.setup("N", "White", 105, 25);
    design.setup("N", "White", 72, 25);
    design.setup("N", "White", 50, 25);
    design.setup("N", "White", 39, 25);
    design.setup("N", "White", 117, 25);
    design.setup("N", "White", 7, 25);
    design.setup("N", "White", 95, 25);
    design.setup("N", "White", 73, 25);
    design.setup("N", "White", 62, 25);
    design.setup("N", "White", 29, 25);
    design.setup("N", "White", 96, 25);
    design.setup("N", "White", 85, 25);
    design.setup("N", "White", 41, 25);
    design.setup("N", "White", 30, 25);
    design.setup("N", "White", 119, 25);
    design.setup("N", "White", 9, 25);
    design.setup("N", "White", 75, 25);
    design.setup("N", "White", 53, 25);
    design.setup("N", "White", 120, 25);
    design.setup("N", "White", 21, 25);
    design.setup("N", "White", 10, 25);
    design.setup("N", "White", 109, 25);
    design.setup("N", "White", 87, 25);
    design.setup("N", "White", 76, 25);
    design.setup("N", "White", 54, 25);
    design.setup("N", "White", 43, 25);

    design.setup("N", "Black", 110, 26);
    design.setup("N", "Black", 0, 26);
    design.setup("N", "Black", 77, 26);
    design.setup("N", "Black", 66, 26);
    design.setup("N", "Black", 44, 26);
    design.setup("N", "Black", 33, 26);
    design.setup("N", "Black", 89, 26);
    design.setup("N", "Black", 78, 26);
    design.setup("N", "Black", 56, 26);
    design.setup("N", "Black", 34, 26);
    design.setup("N", "Black", 23, 26);
    design.setup("N", "Black", 13, 26);
    design.setup("N", "Black", 101, 26);
    design.setup("N", "Black", 68, 26);
    design.setup("N", "Black", 46, 26);
    design.setup("N", "Black", 113, 26);
    design.setup("N", "Black", 14, 26);
    design.setup("N", "Black", 3, 26);
    design.setup("N", "Black", 102, 26);
    design.setup("N", "Black", 80, 26);
    design.setup("N", "Black", 69, 26);
    design.setup("N", "Black", 36, 26);
    design.setup("N", "Black", 114, 26);
    design.setup("N", "Black", 4, 26);
    design.setup("N", "Black", 92, 26);
    design.setup("N", "Black", 59, 26);
    design.setup("N", "Black", 37, 26);
    design.setup("N", "Black", 26, 26);
    design.setup("N", "Black", 16, 26);
    design.setup("N", "Black", 104, 26);
    design.setup("N", "Black", 71, 26);
    design.setup("N", "Black", 49, 26);
    design.setup("N", "Black", 116, 26);
    design.setup("N", "Black", 6, 26);
    design.setup("N", "Black", 94, 26);
    design.setup("N", "Black", 83, 26);
    design.setup("N", "Black", 61, 26);
    design.setup("N", "Black", 28, 26);
    design.setup("N", "Black", 117, 26);
    design.setup("N", "Black", 18, 26);
    design.setup("N", "Black", 7, 26);
    design.setup("N", "Black", 106, 26);
    design.setup("N", "Black", 84, 26);
    design.setup("N", "Black", 51, 26);
    design.setup("N", "Black", 40, 26);
    design.setup("N", "Black", 19, 26);
    design.setup("N", "Black", 107, 26);
    design.setup("N", "Black", 74, 26);
    design.setup("N", "Black", 52, 26);
    design.setup("N", "Black", 97, 26);
    design.setup("N", "Black", 86, 26);
    design.setup("N", "Black", 64, 26);
    design.setup("N", "Black", 42, 26);
    design.setup("N", "Black", 31, 26);
    design.setup("N", "Black", 120, 26);
    design.setup("N", "Black", 10, 26);
    design.setup("N", "Black", 87, 26);
    design.setup("N", "Black", 76, 26);
    design.setup("N", "Black", 54, 26);
    design.setup("N", "Black", 43, 26);
    design.setup("N", "White", 11, 26);
    design.setup("N", "White", 99, 26);
    design.setup("N", "White", 88, 26);
    design.setup("N", "White", 55, 26);
    design.setup("N", "White", 22, 26);
    design.setup("N", "White", 111, 26);
    design.setup("N", "White", 12, 26);
    design.setup("N", "White", 1, 26);
    design.setup("N", "White", 100, 26);
    design.setup("N", "White", 67, 26);
    design.setup("N", "White", 45, 26);
    design.setup("N", "White", 112, 26);
    design.setup("N", "White", 2, 26);
    design.setup("N", "White", 90, 26);
    design.setup("N", "White", 79, 26);
    design.setup("N", "White", 57, 26);
    design.setup("N", "White", 35, 26);
    design.setup("N", "White", 24, 26);
    design.setup("N", "White", 91, 26);
    design.setup("N", "White", 58, 26);
    design.setup("N", "White", 47, 26);
    design.setup("N", "White", 25, 26);
    design.setup("N", "White", 15, 26);
    design.setup("N", "White", 103, 26);
    design.setup("N", "White", 81, 26);
    design.setup("N", "White", 70, 26);
    design.setup("N", "White", 48, 26);
    design.setup("N", "White", 115, 26);
    design.setup("N", "White", 5, 26);
    design.setup("N", "White", 93, 26);
    design.setup("N", "White", 82, 26);
    design.setup("N", "White", 38, 26);
    design.setup("N", "White", 27, 26);
    design.setup("N", "White", 17, 26);
    design.setup("N", "White", 105, 26);
    design.setup("N", "White", 72, 26);
    design.setup("N", "White", 50, 26);
    design.setup("N", "White", 39, 26);
    design.setup("N", "White", 95, 26);
    design.setup("N", "White", 73, 26);
    design.setup("N", "White", 62, 26);
    design.setup("N", "White", 29, 26);
    design.setup("N", "White", 118, 26);
    design.setup("N", "White", 8, 26);
    design.setup("N", "White", 96, 26);
    design.setup("N", "White", 85, 26);
    design.setup("N", "White", 63, 26);
    design.setup("N", "White", 41, 26);
    design.setup("N", "White", 30, 26);
    design.setup("N", "White", 119, 26);
    design.setup("N", "White", 20, 26);
    design.setup("N", "White", 9, 26);
    design.setup("N", "White", 108, 26);
    design.setup("N", "White", 75, 26);
    design.setup("N", "White", 53, 26);
    design.setup("N", "White", 21, 26);
    design.setup("N", "White", 109, 26);
    design.setup("N", "White", 98, 26);
    design.setup("N", "White", 65, 26);
    design.setup("N", "White", 32, 26);

    design.setup("N", "Black", 11, 27);
    design.setup("N", "Black", 88, 27);
    design.setup("N", "Black", 66, 27);
    design.setup("N", "Black", 33, 27);
    design.setup("N", "Black", 22, 27);
    design.setup("N", "Black", 111, 27);
    design.setup("N", "Black", 78, 27);
    design.setup("N", "Black", 56, 27);
    design.setup("N", "Black", 23, 27);
    design.setup("N", "Black", 112, 27);
    design.setup("N", "Black", 2, 27);
    design.setup("N", "Black", 101, 27);
    design.setup("N", "Black", 90, 27);
    design.setup("N", "Black", 68, 27);
    design.setup("N", "Black", 46, 27);
    design.setup("N", "Black", 35, 27);
    design.setup("N", "Black", 24, 27);
    design.setup("N", "Black", 113, 27);
    design.setup("N", "Black", 14, 27);
    design.setup("N", "Black", 91, 27);
    design.setup("N", "Black", 80, 27);
    design.setup("N", "Black", 69, 27);
    design.setup("N", "Black", 36, 27);
    design.setup("N", "Black", 4, 27);
    design.setup("N", "Black", 92, 27);
    design.setup("N", "Black", 59, 27);
    design.setup("N", "Black", 37, 27);
    design.setup("N", "Black", 26, 27);
    design.setup("N", "Black", 16, 27);
    design.setup("N", "Black", 104, 27);
    design.setup("N", "Black", 71, 27);
    design.setup("N", "Black", 49, 27);
    design.setup("N", "Black", 116, 27);
    design.setup("N", "Black", 94, 27);
    design.setup("N", "Black", 83, 27);
    design.setup("N", "Black", 61, 27);
    design.setup("N", "Black", 28, 27);
    design.setup("N", "Black", 7, 27);
    design.setup("N", "Black", 106, 27);
    design.setup("N", "Black", 84, 27);
    design.setup("N", "Black", 51, 27);
    design.setup("N", "Black", 40, 27);
    design.setup("N", "Black", 29, 27);
    design.setup("N", "Black", 118, 27);
    design.setup("N", "Black", 19, 27);
    design.setup("N", "Black", 8, 27);
    design.setup("N", "Black", 96, 27);
    design.setup("N", "Black", 85, 27);
    design.setup("N", "Black", 74, 27);
    design.setup("N", "Black", 52, 27);
    design.setup("N", "Black", 30, 27);
    design.setup("N", "Black", 9, 27);
    design.setup("N", "Black", 97, 27);
    design.setup("N", "Black", 64, 27);
    design.setup("N", "Black", 42, 27);
    design.setup("N", "Black", 109, 27);
    design.setup("N", "Black", 98, 27);
    design.setup("N", "Black", 87, 27);
    design.setup("N", "Black", 54, 27);
    design.setup("N", "Black", 32, 27);
    design.setup("N", "White", 110, 27);
    design.setup("N", "White", 0, 27);
    design.setup("N", "White", 99, 27);
    design.setup("N", "White", 77, 27);
    design.setup("N", "White", 55, 27);
    design.setup("N", "White", 44, 27);
    design.setup("N", "White", 12, 27);
    design.setup("N", "White", 1, 27);
    design.setup("N", "White", 100, 27);
    design.setup("N", "White", 89, 27);
    design.setup("N", "White", 67, 27);
    design.setup("N", "White", 45, 27);
    design.setup("N", "White", 34, 27);
    design.setup("N", "White", 13, 27);
    design.setup("N", "White", 79, 27);
    design.setup("N", "White", 57, 27);
    design.setup("N", "White", 3, 27);
    design.setup("N", "White", 102, 27);
    design.setup("N", "White", 58, 27);
    design.setup("N", "White", 47, 27);
    design.setup("N", "White", 25, 27);
    design.setup("N", "White", 114, 27);
    design.setup("N", "White", 15, 27);
    design.setup("N", "White", 103, 27);
    design.setup("N", "White", 81, 27);
    design.setup("N", "White", 70, 27);
    design.setup("N", "White", 48, 27);
    design.setup("N", "White", 115, 27);
    design.setup("N", "White", 5, 27);
    design.setup("N", "White", 93, 27);
    design.setup("N", "White", 82, 27);
    design.setup("N", "White", 38, 27);
    design.setup("N", "White", 27, 27);
    design.setup("N", "White", 17, 27);
    design.setup("N", "White", 6, 27);
    design.setup("N", "White", 105, 27);
    design.setup("N", "White", 72, 27);
    design.setup("N", "White", 50, 27);
    design.setup("N", "White", 39, 27);
    design.setup("N", "White", 117, 27);
    design.setup("N", "White", 18, 27);
    design.setup("N", "White", 95, 27);
    design.setup("N", "White", 73, 27);
    design.setup("N", "White", 62, 27);
    design.setup("N", "White", 107, 27);
    design.setup("N", "White", 63, 27);
    design.setup("N", "White", 41, 27);
    design.setup("N", "White", 119, 27);
    design.setup("N", "White", 20, 27);
    design.setup("N", "White", 108, 27);
    design.setup("N", "White", 86, 27);
    design.setup("N", "White", 75, 27);
    design.setup("N", "White", 53, 27);
    design.setup("N", "White", 31, 27);
    design.setup("N", "White", 120, 27);
    design.setup("N", "White", 21, 27);
    design.setup("N", "White", 10, 27);
    design.setup("N", "White", 76, 27);
    design.setup("N", "White", 65, 27);
    design.setup("N", "White", 43, 27);

    design.setup("N", "Black", 99, 28);
    design.setup("N", "Black", 88, 28);
    design.setup("N", "Black", 55, 28);
    design.setup("N", "Black", 22, 28);
    design.setup("N", "Black", 1, 28);
    design.setup("N", "Black", 89, 28);
    design.setup("N", "Black", 78, 28);
    design.setup("N", "Black", 56, 28);
    design.setup("N", "Black", 34, 28);
    design.setup("N", "Black", 112, 28);
    design.setup("N", "Black", 13, 28);
    design.setup("N", "Black", 2, 28);
    design.setup("N", "Black", 79, 28);
    design.setup("N", "Black", 68, 28);
    design.setup("N", "Black", 46, 28);
    design.setup("N", "Black", 35, 28);
    design.setup("N", "Black", 14, 28);
    design.setup("N", "Black", 102, 28);
    design.setup("N", "Black", 91, 28);
    design.setup("N", "Black", 80, 28);
    design.setup("N", "Black", 69, 28);
    design.setup("N", "Black", 36, 28);
    design.setup("N", "Black", 25, 28);
    design.setup("N", "Black", 92, 28);
    design.setup("N", "Black", 59, 28);
    design.setup("N", "Black", 37, 28);
    design.setup("N", "Black", 26, 28);
    design.setup("N", "Black", 115, 28);
    design.setup("N", "Black", 16, 28);
    design.setup("N", "Black", 5, 28);
    design.setup("N", "Black", 104, 28);
    design.setup("N", "Black", 71, 28);
    design.setup("N", "Black", 49, 28);
    design.setup("N", "Black", 94, 28);
    design.setup("N", "Black", 83, 28);
    design.setup("N", "Black", 61, 28);
    design.setup("N", "Black", 28, 28);
    design.setup("N", "Black", 18, 28);
    design.setup("N", "Black", 106, 28);
    design.setup("N", "Black", 95, 28);
    design.setup("N", "Black", 84, 28);
    design.setup("N", "Black", 51, 28);
    design.setup("N", "Black", 40, 28);
    design.setup("N", "Black", 29, 28);
    design.setup("N", "Black", 118, 28);
    design.setup("N", "Black", 8, 28);
    design.setup("N", "Black", 107, 28);
    design.setup("N", "Black", 85, 28);
    design.setup("N", "Black", 74, 28);
    design.setup("N", "Black", 52, 28);
    design.setup("N", "Black", 41, 28);
    design.setup("N", "Black", 119, 28);
    design.setup("N", "Black", 86, 28);
    design.setup("N", "Black", 64, 28);
    design.setup("N", "Black", 42, 28);
    design.setup("N", "Black", 31, 28);
    design.setup("N", "Black", 21, 28);
    design.setup("N", "Black", 98, 28);
    design.setup("N", "Black", 65, 28);
    design.setup("N", "Black", 32, 28);
    design.setup("N", "White", 110, 28);
    design.setup("N", "White", 11, 28);
    design.setup("N", "White", 0, 28);
    design.setup("N", "White", 77, 28);
    design.setup("N", "White", 66, 28);
    design.setup("N", "White", 44, 28);
    design.setup("N", "White", 33, 28);
    design.setup("N", "White", 111, 28);
    design.setup("N", "White", 12, 28);
    design.setup("N", "White", 100, 28);
    design.setup("N", "White", 67, 28);
    design.setup("N", "White", 45, 28);
    design.setup("N", "White", 23, 28);
    design.setup("N", "White", 101, 28);
    design.setup("N", "White", 90, 28);
    design.setup("N", "White", 57, 28);
    design.setup("N", "White", 24, 28);
    design.setup("N", "White", 113, 28);
    design.setup("N", "White", 3, 28);
    design.setup("N", "White", 58, 28);
    design.setup("N", "White", 47, 28);
    design.setup("N", "White", 114, 28);
    design.setup("N", "White", 15, 28);
    design.setup("N", "White", 4, 28);
    design.setup("N", "White", 103, 28);
    design.setup("N", "White", 81, 28);
    design.setup("N", "White", 70, 28);
    design.setup("N", "White", 48, 28);
    design.setup("N", "White", 93, 28);
    design.setup("N", "White", 82, 28);
    design.setup("N", "White", 38, 28);
    design.setup("N", "White", 27, 28);
    design.setup("N", "White", 116, 28);
    design.setup("N", "White", 17, 28);
    design.setup("N", "White", 6, 28);
    design.setup("N", "White", 105, 28);
    design.setup("N", "White", 72, 28);
    design.setup("N", "White", 50, 28);
    design.setup("N", "White", 39, 28);
    design.setup("N", "White", 117, 28);
    design.setup("N", "White", 7, 28);
    design.setup("N", "White", 73, 28);
    design.setup("N", "White", 62, 28);
    design.setup("N", "White", 19, 28);
    design.setup("N", "White", 96, 28);
    design.setup("N", "White", 63, 28);
    design.setup("N", "White", 30, 28);
    design.setup("N", "White", 20, 28);
    design.setup("N", "White", 9, 28);
    design.setup("N", "White", 108, 28);
    design.setup("N", "White", 97, 28);
    design.setup("N", "White", 75, 28);
    design.setup("N", "White", 53, 28);
    design.setup("N", "White", 120, 28);
    design.setup("N", "White", 10, 28);
    design.setup("N", "White", 109, 28);
    design.setup("N", "White", 87, 28);
    design.setup("N", "White", 76, 28);
    design.setup("N", "White", 54, 28);
    design.setup("N", "White", 43, 28);

    design.setup("N", "Black", 110, 29);
    design.setup("N", "Black", 0, 29);
    design.setup("N", "Black", 77, 29);
    design.setup("N", "Black", 66, 29);
    design.setup("N", "Black", 33, 29);
    design.setup("N", "Black", 89, 29);
    design.setup("N", "Black", 78, 29);
    design.setup("N", "Black", 45, 29);
    design.setup("N", "Black", 34, 29);
    design.setup("N", "Black", 23, 29);
    design.setup("N", "Black", 13, 29);
    design.setup("N", "Black", 101, 29);
    design.setup("N", "Black", 79, 29);
    design.setup("N", "Black", 57, 29);
    design.setup("N", "Black", 46, 29);
    design.setup("N", "Black", 113, 29);
    design.setup("N", "Black", 14, 29);
    design.setup("N", "Black", 3, 29);
    design.setup("N", "Black", 102, 29);
    design.setup("N", "Black", 69, 29);
    design.setup("N", "Black", 58, 29);
    design.setup("N", "Black", 25, 29);
    design.setup("N", "Black", 4, 29);
    design.setup("N", "Black", 103, 29);
    design.setup("N", "Black", 92, 29);
    design.setup("N", "Black", 59, 29);
    design.setup("N", "Black", 37, 29);
    design.setup("N", "Black", 93, 29);
    design.setup("N", "Black", 82, 29);
    design.setup("N", "Black", 71, 29);
    design.setup("N", "Black", 49, 29);
    design.setup("N", "Black", 38, 29);
    design.setup("N", "Black", 27, 29);
    design.setup("N", "Black", 116, 29);
    design.setup("N", "Black", 17, 29);
    design.setup("N", "Black", 83, 29);
    design.setup("N", "Black", 61, 29);
    design.setup("N", "Black", 28, 29);
    design.setup("N", "Black", 117, 29);
    design.setup("N", "Black", 18, 29);
    design.setup("N", "Black", 7, 29);
    design.setup("N", "Black", 106, 29);
    design.setup("N", "Black", 95, 29);
    design.setup("N", "Black", 62, 29);
    design.setup("N", "Black", 51, 29);
    design.setup("N", "Black", 19, 29);
    design.setup("N", "Black", 107, 29);
    design.setup("N", "Black", 74, 29);
    design.setup("N", "Black", 63, 29);
    design.setup("N", "Black", 41, 29);
    design.setup("N", "Black", 97, 29);
    design.setup("N", "Black", 86, 29);
    design.setup("N", "Black", 75, 29);
    design.setup("N", "Black", 42, 29);
    design.setup("N", "Black", 31, 29);
    design.setup("N", "Black", 120, 29);
    design.setup("N", "Black", 10, 29);
    design.setup("N", "Black", 87, 29);
    design.setup("N", "Black", 54, 29);
    design.setup("N", "Black", 43, 29);
    design.setup("N", "White", 11, 29);
    design.setup("N", "White", 99, 29);
    design.setup("N", "White", 88, 29);
    design.setup("N", "White", 55, 29);
    design.setup("N", "White", 44, 29);
    design.setup("N", "White", 22, 29);
    design.setup("N", "White", 111, 29);
    design.setup("N", "White", 12, 29);
    design.setup("N", "White", 1, 29);
    design.setup("N", "White", 100, 29);
    design.setup("N", "White", 67, 29);
    design.setup("N", "White", 56, 29);
    design.setup("N", "White", 112, 29);
    design.setup("N", "White", 2, 29);
    design.setup("N", "White", 90, 29);
    design.setup("N", "White", 68, 29);
    design.setup("N", "White", 35, 29);
    design.setup("N", "White", 24, 29);
    design.setup("N", "White", 91, 29);
    design.setup("N", "White", 80, 29);
    design.setup("N", "White", 47, 29);
    design.setup("N", "White", 36, 29);
    design.setup("N", "White", 114, 29);
    design.setup("N", "White", 15, 29);
    design.setup("N", "White", 81, 29);
    design.setup("N", "White", 70, 29);
    design.setup("N", "White", 48, 29);
    design.setup("N", "White", 26, 29);
    design.setup("N", "White", 115, 29);
    design.setup("N", "White", 16, 29);
    design.setup("N", "White", 5, 29);
    design.setup("N", "White", 104, 29);
    design.setup("N", "White", 6, 29);
    design.setup("N", "White", 105, 29);
    design.setup("N", "White", 94, 29);
    design.setup("N", "White", 72, 29);
    design.setup("N", "White", 50, 29);
    design.setup("N", "White", 39, 29);
    design.setup("N", "White", 84, 29);
    design.setup("N", "White", 73, 29);
    design.setup("N", "White", 40, 29);
    design.setup("N", "White", 29, 29);
    design.setup("N", "White", 118, 29);
    design.setup("N", "White", 8, 29);
    design.setup("N", "White", 96, 29);
    design.setup("N", "White", 85, 29);
    design.setup("N", "White", 52, 29);
    design.setup("N", "White", 30, 29);
    design.setup("N", "White", 119, 29);
    design.setup("N", "White", 20, 29);
    design.setup("N", "White", 9, 29);
    design.setup("N", "White", 108, 29);
    design.setup("N", "White", 64, 29);
    design.setup("N", "White", 53, 29);
    design.setup("N", "White", 21, 29);
    design.setup("N", "White", 109, 29);
    design.setup("N", "White", 98, 29);
    design.setup("N", "White", 76, 29);
    design.setup("N", "White", 65, 29);
    design.setup("N", "White", 32, 29);

    design.setup("N", "Black", 11, 30);
    design.setup("N", "Black", 88, 30);
    design.setup("N", "Black", 77, 30);
    design.setup("N", "Black", 44, 30);
    design.setup("N", "Black", 33, 30);
    design.setup("N", "Black", 22, 30);
    design.setup("N", "Black", 111, 30);
    design.setup("N", "Black", 78, 30);
    design.setup("N", "Black", 67, 30);
    design.setup("N", "Black", 34, 30);
    design.setup("N", "Black", 23, 30);
    design.setup("N", "Black", 112, 30);
    design.setup("N", "Black", 2, 30);
    design.setup("N", "Black", 101, 30);
    design.setup("N", "Black", 68, 30);
    design.setup("N", "Black", 57, 30);
    design.setup("N", "Black", 35, 30);
    design.setup("N", "Black", 113, 30);
    design.setup("N", "Black", 14, 30);
    design.setup("N", "Black", 3, 30);
    design.setup("N", "Black", 102, 30);
    design.setup("N", "Black", 91, 30);
    design.setup("N", "Black", 58, 30);
    design.setup("N", "Black", 47, 30);
    design.setup("N", "Black", 114, 30);
    design.setup("N", "Black", 15, 30);
    design.setup("N", "Black", 81, 30);
    design.setup("N", "Black", 26, 30);
    design.setup("N", "Black", 93, 30);
    design.setup("N", "Black", 82, 30);
    design.setup("N", "Black", 38, 30);
    design.setup("N", "Black", 27, 30);
    design.setup("N", "Black", 6, 30);
    design.setup("N", "Black", 105, 30);
    design.setup("N", "Black", 94, 30);
    design.setup("N", "Black", 39, 30);
    design.setup("N", "Black", 117, 30);
    design.setup("N", "Black", 18, 30);
    design.setup("N", "Black", 7, 30);
    design.setup("N", "Black", 106, 30);
    design.setup("N", "Black", 73, 30);
    design.setup("N", "Black", 62, 30);
    design.setup("N", "Black", 29, 30);
    design.setup("N", "Black", 118, 30);
    design.setup("N", "Black", 19, 30);
    design.setup("N", "Black", 8, 30);
    design.setup("N", "Black", 85, 30);
    design.setup("N", "Black", 63, 30);
    design.setup("N", "Black", 52, 30);
    design.setup("N", "Black", 9, 30);
    design.setup("N", "Black", 97, 30);
    design.setup("N", "Black", 86, 30);
    design.setup("N", "Black", 53, 30);
    design.setup("N", "Black", 42, 30);
    design.setup("N", "Black", 109, 30);
    design.setup("N", "Black", 98, 30);
    design.setup("N", "Black", 87, 30);
    design.setup("N", "Black", 76, 30);
    design.setup("N", "Black", 43, 30);
    design.setup("N", "Black", 32, 30);
    design.setup("N", "White", 110, 30);
    design.setup("N", "White", 0, 30);
    design.setup("N", "White", 99, 30);
    design.setup("N", "White", 66, 30);
    design.setup("N", "White", 55, 30);
    design.setup("N", "White", 12, 30);
    design.setup("N", "White", 1, 30);
    design.setup("N", "White", 100, 30);
    design.setup("N", "White", 89, 30);
    design.setup("N", "White", 56, 30);
    design.setup("N", "White", 45, 30);
    design.setup("N", "White", 13, 30);
    design.setup("N", "White", 90, 30);
    design.setup("N", "White", 79, 30);
    design.setup("N", "White", 46, 30);
    design.setup("N", "White", 24, 30);
    design.setup("N", "White", 80, 30);
    design.setup("N", "White", 69, 30);
    design.setup("N", "White", 36, 30);
    design.setup("N", "White", 25, 30);
    design.setup("N", "White", 4, 30);
    design.setup("N", "White", 103, 30);
    design.setup("N", "White", 92, 30);
    design.setup("N", "White", 70, 30);
    design.setup("N", "White", 59, 30);
    design.setup("N", "White", 48, 30);
    design.setup("N", "White", 37, 30);
    design.setup("N", "White", 115, 30);
    design.setup("N", "White", 16, 30);
    design.setup("N", "White", 5, 30);
    design.setup("N", "White", 104, 30);
    design.setup("N", "White", 71, 30);
    design.setup("N", "White", 49, 30);
    design.setup("N", "White", 116, 30);
    design.setup("N", "White", 17, 30);
    design.setup("N", "White", 83, 30);
    design.setup("N", "White", 72, 30);
    design.setup("N", "White", 61, 30);
    design.setup("N", "White", 50, 30);
    design.setup("N", "White", 28, 30);
    design.setup("N", "White", 95, 30);
    design.setup("N", "White", 84, 30);
    design.setup("N", "White", 51, 30);
    design.setup("N", "White", 40, 30);
    design.setup("N", "White", 107, 30);
    design.setup("N", "White", 96, 30);
    design.setup("N", "White", 74, 30);
    design.setup("N", "White", 41, 30);
    design.setup("N", "White", 30, 30);
    design.setup("N", "White", 119, 30);
    design.setup("N", "White", 20, 30);
    design.setup("N", "White", 108, 30);
    design.setup("N", "White", 75, 30);
    design.setup("N", "White", 64, 30);
    design.setup("N", "White", 31, 30);
    design.setup("N", "White", 120, 30);
    design.setup("N", "White", 21, 30);
    design.setup("N", "White", 10, 30);
    design.setup("N", "White", 65, 30);
    design.setup("N", "White", 54, 30);

    design.setup("N", "Black", 99, 31);
    design.setup("N", "Black", 88, 31);
    design.setup("N", "Black", 66, 31);
    design.setup("N", "Black", 33, 31);
    design.setup("N", "Black", 22, 31);
    design.setup("N", "Black", 1, 31);
    design.setup("N", "Black", 89, 31);
    design.setup("N", "Black", 78, 31);
    design.setup("N", "Black", 45, 31);
    design.setup("N", "Black", 34, 31);
    design.setup("N", "Black", 112, 31);
    design.setup("N", "Black", 13, 31);
    design.setup("N", "Black", 2, 31);
    design.setup("N", "Black", 79, 31);
    design.setup("N", "Black", 57, 31);
    design.setup("N", "Black", 46, 31);
    design.setup("N", "Black", 113, 31);
    design.setup("N", "Black", 14, 31);
    design.setup("N", "Black", 102, 31);
    design.setup("N", "Black", 69, 31);
    design.setup("N", "Black", 58, 31);
    design.setup("N", "Black", 25, 31);
    design.setup("N", "Black", 4, 31);
    design.setup("N", "Black", 103, 31);
    design.setup("N", "Black", 92, 31);
    design.setup("N", "Black", 59, 31);
    design.setup("N", "Black", 37, 31);
    design.setup("N", "Black", 93, 31);
    design.setup("N", "Black", 82, 31);
    design.setup("N", "Black", 71, 31);
    design.setup("N", "Black", 49, 31);
    design.setup("N", "Black", 38, 31);
    design.setup("N", "Black", 27, 31);
    design.setup("N", "Black", 116, 31);
    design.setup("N", "Black", 17, 31);
    design.setup("N", "Black", 83, 31);
    design.setup("N", "Black", 61, 31);
    design.setup("N", "Black", 28, 31);
    design.setup("N", "Black", 18, 31);
    design.setup("N", "Black", 7, 31);
    design.setup("N", "Black", 106, 31);
    design.setup("N", "Black", 95, 31);
    design.setup("N", "Black", 62, 31);
    design.setup("N", "Black", 51, 31);
    design.setup("N", "Black", 118, 31);
    design.setup("N", "Black", 8, 31);
    design.setup("N", "Black", 107, 31);
    design.setup("N", "Black", 74, 31);
    design.setup("N", "Black", 63, 31);
    design.setup("N", "Black", 41, 31);
    design.setup("N", "Black", 119, 31);
    design.setup("N", "Black", 86, 31);
    design.setup("N", "Black", 75, 31);
    design.setup("N", "Black", 42, 31);
    design.setup("N", "Black", 31, 31);
    design.setup("N", "Black", 21, 31);
    design.setup("N", "Black", 98, 31);
    design.setup("N", "Black", 87, 31);
    design.setup("N", "Black", 54, 31);
    design.setup("N", "Black", 32, 31);
    design.setup("N", "White", 110, 31);
    design.setup("N", "White", 11, 31);
    design.setup("N", "White", 0, 31);
    design.setup("N", "White", 77, 31);
    design.setup("N", "White", 55, 31);
    design.setup("N", "White", 44, 31);
    design.setup("N", "White", 111, 31);
    design.setup("N", "White", 12, 31);
    design.setup("N", "White", 100, 31);
    design.setup("N", "White", 67, 31);
    design.setup("N", "White", 56, 31);
    design.setup("N", "White", 23, 31);
    design.setup("N", "White", 101, 31);
    design.setup("N", "White", 90, 31);
    design.setup("N", "White", 68, 31);
    design.setup("N", "White", 35, 31);
    design.setup("N", "White", 24, 31);
    design.setup("N", "White", 3, 31);
    design.setup("N", "White", 91, 31);
    design.setup("N", "White", 80, 31);
    design.setup("N", "White", 47, 31);
    design.setup("N", "White", 36, 31);
    design.setup("N", "White", 114, 31);
    design.setup("N", "White", 15, 31);
    design.setup("N", "White", 81, 31);
    design.setup("N", "White", 70, 31);
    design.setup("N", "White", 48, 31);
    design.setup("N", "White", 26, 31);
    design.setup("N", "White", 115, 31);
    design.setup("N", "White", 16, 31);
    design.setup("N", "White", 5, 31);
    design.setup("N", "White", 104, 31);
    design.setup("N", "White", 6, 31);
    design.setup("N", "White", 105, 31);
    design.setup("N", "White", 94, 31);
    design.setup("N", "White", 72, 31);
    design.setup("N", "White", 50, 31);
    design.setup("N", "White", 39, 31);
    design.setup("N", "White", 117, 31);
    design.setup("N", "White", 84, 31);
    design.setup("N", "White", 73, 31);
    design.setup("N", "White", 40, 31);
    design.setup("N", "White", 29, 31);
    design.setup("N", "White", 19, 31);
    design.setup("N", "White", 96, 31);
    design.setup("N", "White", 85, 31);
    design.setup("N", "White", 52, 31);
    design.setup("N", "White", 30, 31);
    design.setup("N", "White", 20, 31);
    design.setup("N", "White", 9, 31);
    design.setup("N", "White", 108, 31);
    design.setup("N", "White", 97, 31);
    design.setup("N", "White", 64, 31);
    design.setup("N", "White", 53, 31);
    design.setup("N", "White", 120, 31);
    design.setup("N", "White", 10, 31);
    design.setup("N", "White", 109, 31);
    design.setup("N", "White", 76, 31);
    design.setup("N", "White", 65, 31);
    design.setup("N", "White", 43, 31);

    design.setup("N", "Black", 110, 32);
    design.setup("N", "Black", 11, 32);
    design.setup("N", "Black", 0, 32);
    design.setup("N", "Black", 77, 32);
    design.setup("N", "Black", 66, 32);
    design.setup("N", "Black", 33, 32);
    design.setup("N", "Black", 111, 32);
    design.setup("N", "Black", 12, 32);
    design.setup("N", "Black", 100, 32);
    design.setup("N", "Black", 67, 32);
    design.setup("N", "Black", 56, 32);
    design.setup("N", "Black", 23, 32);
    design.setup("N", "Black", 101, 32);
    design.setup("N", "Black", 90, 32);
    design.setup("N", "Black", 57, 32);
    design.setup("N", "Black", 46, 32);
    design.setup("N", "Black", 24, 32);
    design.setup("N", "Black", 113, 32);
    design.setup("N", "Black", 3, 32);
    design.setup("N", "Black", 80, 32);
    design.setup("N", "Black", 47, 32);
    design.setup("N", "Black", 36, 32);
    design.setup("N", "Black", 15, 32);
    design.setup("N", "Black", 4, 32);
    design.setup("N", "Black", 92, 32);
    design.setup("N", "Black", 81, 32);
    design.setup("N", "Black", 70, 32);
    design.setup("N", "Black", 48, 32);
    design.setup("N", "Black", 16, 32);
    design.setup("N", "Black", 104, 32);
    design.setup("N", "Black", 93, 32);
    design.setup("N", "Black", 27, 32);
    design.setup("N", "Black", 116, 32);
    design.setup("N", "Black", 105, 32);
    design.setup("N", "Black", 72, 32);
    design.setup("N", "Black", 50, 32);
    design.setup("N", "Black", 39, 32);
    design.setup("N", "Black", 28, 32);
    design.setup("N", "Black", 117, 32);
    design.setup("N", "Black", 7, 32);
    design.setup("N", "Black", 84, 32);
    design.setup("N", "Black", 73, 32);
    design.setup("N", "Black", 40, 32);
    design.setup("N", "Black", 19, 32);
    design.setup("N", "Black", 96, 32);
    design.setup("N", "Black", 74, 32);
    design.setup("N", "Black", 63, 32);
    design.setup("N", "Black", 30, 32);
    design.setup("N", "Black", 20, 32);
    design.setup("N", "Black", 9, 32);
    design.setup("N", "Black", 108, 32);
    design.setup("N", "Black", 97, 32);
    design.setup("N", "Black", 64, 32);
    design.setup("N", "Black", 53, 32);
    design.setup("N", "Black", 120, 32);
    design.setup("N", "Black", 10, 32);
    design.setup("N", "Black", 109, 32);
    design.setup("N", "Black", 87, 32);
    design.setup("N", "Black", 54, 32);
    design.setup("N", "Black", 43, 32);
    design.setup("N", "White", 99, 32);
    design.setup("N", "White", 88, 32);
    design.setup("N", "White", 55, 32);
    design.setup("N", "White", 44, 32);
    design.setup("N", "White", 22, 32);
    design.setup("N", "White", 1, 32);
    design.setup("N", "White", 89, 32);
    design.setup("N", "White", 78, 32);
    design.setup("N", "White", 45, 32);
    design.setup("N", "White", 34, 32);
    design.setup("N", "White", 112, 32);
    design.setup("N", "White", 13, 32);
    design.setup("N", "White", 2, 32);
    design.setup("N", "White", 79, 32);
    design.setup("N", "White", 68, 32);
    design.setup("N", "White", 35, 32);
    design.setup("N", "White", 14, 32);
    design.setup("N", "White", 102, 32);
    design.setup("N", "White", 91, 32);
    design.setup("N", "White", 69, 32);
    design.setup("N", "White", 58, 32);
    design.setup("N", "White", 25, 32);
    design.setup("N", "White", 114, 32);
    design.setup("N", "White", 103, 32);
    design.setup("N", "White", 59, 32);
    design.setup("N", "White", 37, 32);
    design.setup("N", "White", 26, 32);
    design.setup("N", "White", 115, 32);
    design.setup("N", "White", 5, 32);
    design.setup("N", "White", 82, 32);
    design.setup("N", "White", 71, 32);
    design.setup("N", "White", 49, 32);
    design.setup("N", "White", 38, 32);
    design.setup("N", "White", 17, 32);
    design.setup("N", "White", 6, 32);
    design.setup("N", "White", 94, 32);
    design.setup("N", "White", 83, 32);
    design.setup("N", "White", 61, 32);
    design.setup("N", "White", 18, 32);
    design.setup("N", "White", 106, 32);
    design.setup("N", "White", 95, 32);
    design.setup("N", "White", 62, 32);
    design.setup("N", "White", 51, 32);
    design.setup("N", "White", 29, 32);
    design.setup("N", "White", 118, 32);
    design.setup("N", "White", 8, 32);
    design.setup("N", "White", 107, 32);
    design.setup("N", "White", 85, 32);
    design.setup("N", "White", 52, 32);
    design.setup("N", "White", 41, 32);
    design.setup("N", "White", 119, 32);
    design.setup("N", "White", 86, 32);
    design.setup("N", "White", 75, 32);
    design.setup("N", "White", 42, 32);
    design.setup("N", "White", 31, 32);
    design.setup("N", "White", 21, 32);
    design.setup("N", "White", 98, 32);
    design.setup("N", "White", 76, 32);
    design.setup("N", "White", 65, 32);
    design.setup("N", "White", 32, 32);

    design.setup("N", "Black", 110, 33);
    design.setup("N", "Black", 0, 33);
    design.setup("N", "Black", 77, 33);
    design.setup("N", "Black", 66, 33);
    design.setup("N", "Black", 44, 33);
    design.setup("N", "Black", 33, 33);
    design.setup("N", "Black", 89, 33);
    design.setup("N", "Black", 78, 33);
    design.setup("N", "Black", 56, 33);
    design.setup("N", "Black", 34, 33);
    design.setup("N", "Black", 23, 33);
    design.setup("N", "Black", 13, 33);
    design.setup("N", "Black", 101, 33);
    design.setup("N", "Black", 68, 33);
    design.setup("N", "Black", 46, 33);
    design.setup("N", "Black", 113, 33);
    design.setup("N", "Black", 14, 33);
    design.setup("N", "Black", 3, 33);
    design.setup("N", "Black", 102, 33);
    design.setup("N", "Black", 80, 33);
    design.setup("N", "Black", 69, 33);
    design.setup("N", "Black", 36, 33);
    design.setup("N", "Black", 114, 33);
    design.setup("N", "Black", 4, 33);
    design.setup("N", "Black", 92, 33);
    design.setup("N", "Black", 59, 33);
    design.setup("N", "Black", 37, 33);
    design.setup("N", "Black", 26, 33);
    design.setup("N", "Black", 16, 33);
    design.setup("N", "Black", 104, 33);
    design.setup("N", "Black", 71, 33);
    design.setup("N", "Black", 49, 33);
    design.setup("N", "Black", 116, 33);
    design.setup("N", "Black", 6, 33);
    design.setup("N", "Black", 94, 33);
    design.setup("N", "Black", 83, 33);
    design.setup("N", "Black", 61, 33);
    design.setup("N", "Black", 28, 33);
    design.setup("N", "Black", 117, 33);
    design.setup("N", "Black", 18, 33);
    design.setup("N", "Black", 7, 33);
    design.setup("N", "Black", 106, 33);
    design.setup("N", "Black", 84, 33);
    design.setup("N", "Black", 51, 33);
    design.setup("N", "Black", 40, 33);
    design.setup("N", "Black", 19, 33);
    design.setup("N", "Black", 107, 33);
    design.setup("N", "Black", 74, 33);
    design.setup("N", "Black", 52, 33);
    design.setup("N", "Black", 97, 33);
    design.setup("N", "Black", 86, 33);
    design.setup("N", "Black", 64, 33);
    design.setup("N", "Black", 42, 33);
    design.setup("N", "Black", 31, 33);
    design.setup("N", "Black", 120, 33);
    design.setup("N", "Black", 10, 33);
    design.setup("N", "Black", 87, 33);
    design.setup("N", "Black", 76, 33);
    design.setup("N", "Black", 54, 33);
    design.setup("N", "Black", 43, 33);
    design.setup("N", "White", 11, 33);
    design.setup("N", "White", 99, 33);
    design.setup("N", "White", 88, 33);
    design.setup("N", "White", 55, 33);
    design.setup("N", "White", 22, 33);
    design.setup("N", "White", 111, 33);
    design.setup("N", "White", 12, 33);
    design.setup("N", "White", 1, 33);
    design.setup("N", "White", 100, 33);
    design.setup("N", "White", 67, 33);
    design.setup("N", "White", 45, 33);
    design.setup("N", "White", 112, 33);
    design.setup("N", "White", 2, 33);
    design.setup("N", "White", 90, 33);
    design.setup("N", "White", 79, 33);
    design.setup("N", "White", 57, 33);
    design.setup("N", "White", 35, 33);
    design.setup("N", "White", 24, 33);
    design.setup("N", "White", 91, 33);
    design.setup("N", "White", 58, 33);
    design.setup("N", "White", 47, 33);
    design.setup("N", "White", 25, 33);
    design.setup("N", "White", 15, 33);
    design.setup("N", "White", 103, 33);
    design.setup("N", "White", 81, 33);
    design.setup("N", "White", 70, 33);
    design.setup("N", "White", 48, 33);
    design.setup("N", "White", 115, 33);
    design.setup("N", "White", 5, 33);
    design.setup("N", "White", 93, 33);
    design.setup("N", "White", 82, 33);
    design.setup("N", "White", 38, 33);
    design.setup("N", "White", 27, 33);
    design.setup("N", "White", 17, 33);
    design.setup("N", "White", 105, 33);
    design.setup("N", "White", 72, 33);
    design.setup("N", "White", 50, 33);
    design.setup("N", "White", 39, 33);
    design.setup("N", "White", 95, 33);
    design.setup("N", "White", 73, 33);
    design.setup("N", "White", 62, 33);
    design.setup("N", "White", 29, 33);
    design.setup("N", "White", 118, 33);
    design.setup("N", "White", 8, 33);
    design.setup("N", "White", 96, 33);
    design.setup("N", "White", 85, 33);
    design.setup("N", "White", 63, 33);
    design.setup("N", "White", 41, 33);
    design.setup("N", "White", 30, 33);
    design.setup("N", "White", 119, 33);
    design.setup("N", "White", 20, 33);
    design.setup("N", "White", 9, 33);
    design.setup("N", "White", 108, 33);
    design.setup("N", "White", 75, 33);
    design.setup("N", "White", 53, 33);
    design.setup("N", "White", 21, 33);
    design.setup("N", "White", 109, 33);
    design.setup("N", "White", 98, 33);
    design.setup("N", "White", 65, 33);
    design.setup("N", "White", 32, 33);

    design.setup("N", "Black", 110, 34);
    design.setup("N", "Black", 0, 34);
    design.setup("N", "Black", 77, 34);
    design.setup("N", "Black", 33, 34);
    design.setup("N", "Black", 22, 34);
    design.setup("N", "Black", 78, 34);
    design.setup("N", "Black", 67, 34);
    design.setup("N", "Black", 56, 34);
    design.setup("N", "Black", 45, 34);
    design.setup("N", "Black", 34, 34);
    design.setup("N", "Black", 112, 34);
    design.setup("N", "Black", 90, 34);
    design.setup("N", "Black", 79, 34);
    design.setup("N", "Black", 68, 34);
    design.setup("N", "Black", 35, 34);
    design.setup("N", "Black", 24, 34);
    design.setup("N", "Black", 113, 34);
    design.setup("N", "Black", 14, 34);
    design.setup("N", "Black", 3, 34);
    design.setup("N", "Black", 102, 34);
    design.setup("N", "Black", 91, 34);
    design.setup("N", "Black", 69, 34);
    design.setup("N", "Black", 25, 34);
    design.setup("N", "Black", 15, 34);
    design.setup("N", "Black", 103, 34);
    design.setup("N", "Black", 59, 34);
    design.setup("N", "Black", 37, 34);
    design.setup("N", "Black", 26, 34);
    design.setup("N", "Black", 16, 34);
    design.setup("N", "Black", 104, 34);
    design.setup("N", "Black", 71, 34);
    design.setup("N", "Black", 49, 34);
    design.setup("N", "Black", 17, 34);
    design.setup("N", "Black", 105, 34);
    design.setup("N", "Black", 94, 34);
    design.setup("N", "Black", 83, 34);
    design.setup("N", "Black", 61, 34);
    design.setup("N", "Black", 117, 34);
    design.setup("N", "Black", 18, 34);
    design.setup("N", "Black", 7, 34);
    design.setup("N", "Black", 106, 34);
    design.setup("N", "Black", 95, 34);
    design.setup("N", "Black", 51, 34);
    design.setup("N", "Black", 29, 34);
    design.setup("N", "Black", 8, 34);
    design.setup("N", "Black", 96, 34);
    design.setup("N", "Black", 85, 34);
    design.setup("N", "Black", 52, 34);
    design.setup("N", "Black", 41, 34);
    design.setup("N", "Black", 30, 34);
    design.setup("N", "Black", 86, 34);
    design.setup("N", "Black", 75, 34);
    design.setup("N", "Black", 64, 34);
    design.setup("N", "Black", 53, 34);
    design.setup("N", "Black", 42, 34);
    design.setup("N", "Black", 120, 34);
    design.setup("N", "Black", 10, 34);
    design.setup("N", "Black", 98, 34);
    design.setup("N", "Black", 87, 34);
    design.setup("N", "Black", 43, 34);
    design.setup("N", "White", 11, 34);
    design.setup("N", "White", 99, 34);
    design.setup("N", "White", 88, 34);
    design.setup("N", "White", 66, 34);
    design.setup("N", "White", 55, 34);
    design.setup("N", "White", 44, 34);
    design.setup("N", "White", 111, 34);
    design.setup("N", "White", 12, 34);
    design.setup("N", "White", 1, 34);
    design.setup("N", "White", 100, 34);
    design.setup("N", "White", 89, 34);
    design.setup("N", "White", 23, 34);
    design.setup("N", "White", 13, 34);
    design.setup("N", "White", 2, 34);
    design.setup("N", "White", 101, 34);
    design.setup("N", "White", 57, 34);
    design.setup("N", "White", 46, 34);
    design.setup("N", "White", 80, 34);
    design.setup("N", "White", 58, 34);
    design.setup("N", "White", 47, 34);
    design.setup("N", "White", 36, 34);
    design.setup("N", "White", 114, 34);
    design.setup("N", "White", 4, 34);
    design.setup("N", "White", 92, 34);
    design.setup("N", "White", 81, 34);
    design.setup("N", "White", 70, 34);
    design.setup("N", "White", 48, 34);
    design.setup("N", "White", 115, 34);
    design.setup("N", "White", 5, 34);
    design.setup("N", "White", 93, 34);
    design.setup("N", "White", 82, 34);
    design.setup("N", "White", 38, 34);
    design.setup("N", "White", 27, 34);
    design.setup("N", "White", 116, 34);
    design.setup("N", "White", 6, 34);
    design.setup("N", "White", 72, 34);
    design.setup("N", "White", 50, 34);
    design.setup("N", "White", 39, 34);
    design.setup("N", "White", 28, 34);
    design.setup("N", "White", 84, 34);
    design.setup("N", "White", 73, 34);
    design.setup("N", "White", 62, 34);
    design.setup("N", "White", 40, 34);
    design.setup("N", "White", 118, 34);
    design.setup("N", "White", 19, 34);
    design.setup("N", "White", 107, 34);
    design.setup("N", "White", 74, 34);
    design.setup("N", "White", 63, 34);
    design.setup("N", "White", 119, 34);
    design.setup("N", "White", 20, 34);
    design.setup("N", "White", 9, 34);
    design.setup("N", "White", 108, 34);
    design.setup("N", "White", 97, 34);
    design.setup("N", "White", 31, 34);
    design.setup("N", "White", 21, 34);
    design.setup("N", "White", 109, 34);
    design.setup("N", "White", 76, 34);
    design.setup("N", "White", 65, 34);
    design.setup("N", "White", 54, 34);
    design.setup("N", "White", 32, 34);

    design.setup("N", "Black", 11, 35);
    design.setup("N", "Black", 88, 35);
    design.setup("N", "Black", 55, 35);
    design.setup("N", "Black", 22, 35);
    design.setup("N", "Black", 111, 35);
    design.setup("N", "Black", 89, 35);
    design.setup("N", "Black", 78, 35);
    design.setup("N", "Black", 56, 35);
    design.setup("N", "Black", 45, 35);
    design.setup("N", "Black", 23, 35);
    design.setup("N", "Black", 112, 35);
    design.setup("N", "Black", 13, 35);
    design.setup("N", "Black", 2, 35);
    design.setup("N", "Black", 101, 35);
    design.setup("N", "Black", 68, 35);
    design.setup("N", "Black", 57, 35);
    design.setup("N", "Black", 35, 35);
    design.setup("N", "Black", 14, 35);
    design.setup("N", "Black", 91, 35);
    design.setup("N", "Black", 80, 35);
    design.setup("N", "Black", 47, 35);
    design.setup("N", "Black", 36, 35);
    design.setup("N", "Black", 103, 35);
    design.setup("N", "Black", 81, 35);
    design.setup("N", "Black", 70, 35);
    design.setup("N", "Black", 48, 35);
    design.setup("N", "Black", 26, 35);
    design.setup("N", "Black", 115, 35);
    design.setup("N", "Black", 16, 35);
    design.setup("N", "Black", 5, 35);
    design.setup("N", "Black", 104, 35);
    design.setup("N", "Black", 93, 35);
    design.setup("N", "Black", 27, 35);
    design.setup("N", "Black", 17, 35);
    design.setup("N", "Black", 94, 35);
    design.setup("N", "Black", 72, 35);
    design.setup("N", "Black", 50, 35);
    design.setup("N", "Black", 39, 35);
    design.setup("N", "Black", 106, 35);
    design.setup("N", "Black", 84, 35);
    design.setup("N", "Black", 73, 35);
    design.setup("N", "Black", 40, 35);
    design.setup("N", "Black", 29, 35);
    design.setup("N", "Black", 118, 35);
    design.setup("N", "Black", 19, 35);
    design.setup("N", "Black", 8, 35);
    design.setup("N", "Black", 107, 35);
    design.setup("N", "Black", 85, 35);
    design.setup("N", "Black", 63, 35);
    design.setup("N", "Black", 52, 35);
    design.setup("N", "Black", 9, 35);
    design.setup("N", "Black", 97, 35);
    design.setup("N", "Black", 75, 35);
    design.setup("N", "Black", 64, 35);
    design.setup("N", "Black", 42, 35);
    design.setup("N", "Black", 31, 35);
    design.setup("N", "Black", 109, 35);
    design.setup("N", "Black", 98, 35);
    design.setup("N", "Black", 65, 35);
    design.setup("N", "Black", 32, 35);
    design.setup("N", "White", 110, 35);
    design.setup("N", "White", 0, 35);
    design.setup("N", "White", 99, 35);
    design.setup("N", "White", 77, 35);
    design.setup("N", "White", 66, 35);
    design.setup("N", "White", 44, 35);
    design.setup("N", "White", 33, 35);
    design.setup("N", "White", 12, 35);
    design.setup("N", "White", 1, 35);
    design.setup("N", "White", 100, 35);
    design.setup("N", "White", 67, 35);
    design.setup("N", "White", 34, 35);
    design.setup("N", "White", 90, 35);
    design.setup("N", "White", 79, 35);
    design.setup("N", "White", 46, 35);
    design.setup("N", "White", 24, 35);
    design.setup("N", "White", 113, 35);
    design.setup("N", "White", 3, 35);
    design.setup("N", "White", 102, 35);
    design.setup("N", "White", 69, 35);
    design.setup("N", "White", 58, 35);
    design.setup("N", "White", 25, 35);
    design.setup("N", "White", 114, 35);
    design.setup("N", "White", 15, 35);
    design.setup("N", "White", 4, 35);
    design.setup("N", "White", 92, 35);
    design.setup("N", "White", 59, 35);
    design.setup("N", "White", 37, 35);
    design.setup("N", "White", 82, 35);
    design.setup("N", "White", 71, 35);
    design.setup("N", "White", 49, 35);
    design.setup("N", "White", 38, 35);
    design.setup("N", "White", 116, 35);
    design.setup("N", "White", 6, 35);
    design.setup("N", "White", 105, 35);
    design.setup("N", "White", 83, 35);
    design.setup("N", "White", 61, 35);
    design.setup("N", "White", 28, 35);
    design.setup("N", "White", 117, 35);
    design.setup("N", "White", 18, 35);
    design.setup("N", "White", 7, 35);
    design.setup("N", "White", 95, 35);
    design.setup("N", "White", 62, 35);
    design.setup("N", "White", 51, 35);
    design.setup("N", "White", 96, 35);
    design.setup("N", "White", 74, 35);
    design.setup("N", "White", 41, 35);
    design.setup("N", "White", 30, 35);
    design.setup("N", "White", 119, 35);
    design.setup("N", "White", 20, 35);
    design.setup("N", "White", 108, 35);
    design.setup("N", "White", 86, 35);
    design.setup("N", "White", 53, 35);
    design.setup("N", "White", 120, 35);
    design.setup("N", "White", 21, 35);
    design.setup("N", "White", 10, 35);
    design.setup("N", "White", 87, 35);
    design.setup("N", "White", 76, 35);
    design.setup("N", "White", 54, 35);
    design.setup("N", "White", 43, 35);

    design.setup("N", "Black", 88, 36);
    design.setup("N", "Black", 55, 36);
    design.setup("N", "Black", 22, 36);
    design.setup("N", "Black", 12, 36);
    design.setup("N", "Black", 100, 36);
    design.setup("N", "Black", 89, 36);
    design.setup("N", "Black", 78, 36);
    design.setup("N", "Black", 56, 36);
    design.setup("N", "Black", 34, 36);
    design.setup("N", "Black", 23, 36);
    design.setup("N", "Black", 112, 36);
    design.setup("N", "Black", 13, 36);
    design.setup("N", "Black", 2, 36);
    design.setup("N", "Black", 101, 36);
    design.setup("N", "Black", 68, 36);
    design.setup("N", "Black", 57, 36);
    design.setup("N", "Black", 46, 36);
    design.setup("N", "Black", 14, 36);
    design.setup("N", "Black", 102, 36);
    design.setup("N", "Black", 80, 36);
    design.setup("N", "Black", 69, 36);
    design.setup("N", "Black", 36, 36);
    design.setup("N", "Black", 92, 36);
    design.setup("N", "Black", 59, 36);
    design.setup("N", "Black", 37, 36);
    design.setup("N", "Black", 26, 36);
    design.setup("N", "Black", 115, 36);
    design.setup("N", "Black", 16, 36);
    design.setup("N", "Black", 5, 36);
    design.setup("N", "Black", 104, 36);
    design.setup("N", "Black", 93, 36);
    design.setup("N", "Black", 71, 36);
    design.setup("N", "Black", 49, 36);
    design.setup("N", "Black", 27, 36);
    design.setup("N", "Black", 94, 36);
    design.setup("N", "Black", 83, 36);
    design.setup("N", "Black", 61, 36);
    design.setup("N", "Black", 28, 36);
    design.setup("N", "Black", 18, 36);
    design.setup("N", "Black", 106, 36);
    design.setup("N", "Black", 84, 36);
    design.setup("N", "Black", 51, 36);
    design.setup("N", "Black", 40, 36);
    design.setup("N", "Black", 118, 36);
    design.setup("N", "Black", 19, 36);
    design.setup("N", "Black", 8, 36);
    design.setup("N", "Black", 107, 36);
    design.setup("N", "Black", 74, 36);
    design.setup("N", "Black", 63, 36);
    design.setup("N", "Black", 52, 36);
    design.setup("N", "Black", 20, 36);
    design.setup("N", "Black", 108, 36);
    design.setup("N", "Black", 97, 36);
    design.setup("N", "Black", 86, 36);
    design.setup("N", "Black", 64, 36);
    design.setup("N", "Black", 42, 36);
    design.setup("N", "Black", 31, 36);
    design.setup("N", "Black", 98, 36);
    design.setup("N", "Black", 65, 36);
    design.setup("N", "Black", 32, 36);
    design.setup("N", "White", 110, 36);
    design.setup("N", "White", 11, 36);
    design.setup("N", "White", 0, 36);
    design.setup("N", "White", 99, 36);
    design.setup("N", "White", 77, 36);
    design.setup("N", "White", 66, 36);
    design.setup("N", "White", 44, 36);
    design.setup("N", "White", 33, 36);
    design.setup("N", "White", 111, 36);
    design.setup("N", "White", 1, 36);
    design.setup("N", "White", 67, 36);
    design.setup("N", "White", 45, 36);
    design.setup("N", "White", 90, 36);
    design.setup("N", "White", 79, 36);
    design.setup("N", "White", 35, 36);
    design.setup("N", "White", 24, 36);
    design.setup("N", "White", 113, 36);
    design.setup("N", "White", 3, 36);
    design.setup("N", "White", 91, 36);
    design.setup("N", "White", 58, 36);
    design.setup("N", "White", 47, 36);
    design.setup("N", "White", 25, 36);
    design.setup("N", "White", 114, 36);
    design.setup("N", "White", 15, 36);
    design.setup("N", "White", 4, 36);
    design.setup("N", "White", 103, 36);
    design.setup("N", "White", 81, 36);
    design.setup("N", "White", 70, 36);
    design.setup("N", "White", 48, 36);
    design.setup("N", "White", 82, 36);
    design.setup("N", "White", 38, 36);
    design.setup("N", "White", 116, 36);
    design.setup("N", "White", 17, 36);
    design.setup("N", "White", 6, 36);
    design.setup("N", "White", 105, 36);
    design.setup("N", "White", 72, 36);
    design.setup("N", "White", 50, 36);
    design.setup("N", "White", 39, 36);
    design.setup("N", "White", 117, 36);
    design.setup("N", "White", 7, 36);
    design.setup("N", "White", 95, 36);
    design.setup("N", "White", 73, 36);
    design.setup("N", "White", 62, 36);
    design.setup("N", "White", 29, 36);
    design.setup("N", "White", 96, 36);
    design.setup("N", "White", 85, 36);
    design.setup("N", "White", 41, 36);
    design.setup("N", "White", 30, 36);
    design.setup("N", "White", 119, 36);
    design.setup("N", "White", 9, 36);
    design.setup("N", "White", 75, 36);
    design.setup("N", "White", 53, 36);
    design.setup("N", "White", 120, 36);
    design.setup("N", "White", 21, 36);
    design.setup("N", "White", 10, 36);
    design.setup("N", "White", 109, 36);
    design.setup("N", "White", 87, 36);
    design.setup("N", "White", 76, 36);
    design.setup("N", "White", 54, 36);
    design.setup("N", "White", 43, 36);

    design.setup("N", "Black", 110, 37);
    design.setup("N", "Black", 0, 37);
    design.setup("N", "Black", 77, 37);
    design.setup("N", "Black", 66, 37);
    design.setup("N", "Black", 33, 37);
    design.setup("N", "Black", 89, 37);
    design.setup("N", "Black", 78, 37);
    design.setup("N", "Black", 45, 37);
    design.setup("N", "Black", 34, 37);
    design.setup("N", "Black", 23, 37);
    design.setup("N", "Black", 13, 37);
    design.setup("N", "Black", 101, 37);
    design.setup("N", "Black", 79, 37);
    design.setup("N", "Black", 57, 37);
    design.setup("N", "Black", 46, 37);
    design.setup("N", "Black", 113, 37);
    design.setup("N", "Black", 14, 37);
    design.setup("N", "Black", 3, 37);
    design.setup("N", "Black", 102, 37);
    design.setup("N", "Black", 69, 37);
    design.setup("N", "Black", 58, 37);
    design.setup("N", "Black", 25, 37);
    design.setup("N", "Black", 4, 37);
    design.setup("N", "Black", 103, 37);
    design.setup("N", "Black", 92, 37);
    design.setup("N", "Black", 59, 37);
    design.setup("N", "Black", 37, 37);
    design.setup("N", "Black", 93, 37);
    design.setup("N", "Black", 82, 37);
    design.setup("N", "Black", 71, 37);
    design.setup("N", "Black", 49, 37);
    design.setup("N", "Black", 38, 37);
    design.setup("N", "Black", 27, 37);
    design.setup("N", "Black", 116, 37);
    design.setup("N", "Black", 17, 37);
    design.setup("N", "Black", 83, 37);
    design.setup("N", "Black", 61, 37);
    design.setup("N", "Black", 28, 37);
    design.setup("N", "Black", 117, 37);
    design.setup("N", "Black", 18, 37);
    design.setup("N", "Black", 7, 37);
    design.setup("N", "Black", 106, 37);
    design.setup("N", "Black", 95, 37);
    design.setup("N", "Black", 62, 37);
    design.setup("N", "Black", 51, 37);
    design.setup("N", "Black", 19, 37);
    design.setup("N", "Black", 107, 37);
    design.setup("N", "Black", 74, 37);
    design.setup("N", "Black", 63, 37);
    design.setup("N", "Black", 41, 37);
    design.setup("N", "Black", 97, 37);
    design.setup("N", "Black", 86, 37);
    design.setup("N", "Black", 75, 37);
    design.setup("N", "Black", 42, 37);
    design.setup("N", "Black", 31, 37);
    design.setup("N", "Black", 120, 37);
    design.setup("N", "Black", 10, 37);
    design.setup("N", "Black", 87, 37);
    design.setup("N", "Black", 54, 37);
    design.setup("N", "Black", 43, 37);
    design.setup("N", "White", 11, 37);
    design.setup("N", "White", 99, 37);
    design.setup("N", "White", 88, 37);
    design.setup("N", "White", 55, 37);
    design.setup("N", "White", 44, 37);
    design.setup("N", "White", 22, 37);
    design.setup("N", "White", 111, 37);
    design.setup("N", "White", 12, 37);
    design.setup("N", "White", 1, 37);
    design.setup("N", "White", 100, 37);
    design.setup("N", "White", 67, 37);
    design.setup("N", "White", 56, 37);
    design.setup("N", "White", 112, 37);
    design.setup("N", "White", 2, 37);
    design.setup("N", "White", 90, 37);
    design.setup("N", "White", 68, 37);
    design.setup("N", "White", 35, 37);
    design.setup("N", "White", 24, 37);
    design.setup("N", "White", 91, 37);
    design.setup("N", "White", 80, 37);
    design.setup("N", "White", 47, 37);
    design.setup("N", "White", 36, 37);
    design.setup("N", "White", 114, 37);
    design.setup("N", "White", 15, 37);
    design.setup("N", "White", 81, 37);
    design.setup("N", "White", 70, 37);
    design.setup("N", "White", 48, 37);
    design.setup("N", "White", 26, 37);
    design.setup("N", "White", 115, 37);
    design.setup("N", "White", 16, 37);
    design.setup("N", "White", 5, 37);
    design.setup("N", "White", 104, 37);
    design.setup("N", "White", 6, 37);
    design.setup("N", "White", 105, 37);
    design.setup("N", "White", 94, 37);
    design.setup("N", "White", 72, 37);
    design.setup("N", "White", 50, 37);
    design.setup("N", "White", 39, 37);
    design.setup("N", "White", 84, 37);
    design.setup("N", "White", 73, 37);
    design.setup("N", "White", 40, 37);
    design.setup("N", "White", 29, 37);
    design.setup("N", "White", 118, 37);
    design.setup("N", "White", 8, 37);
    design.setup("N", "White", 96, 37);
    design.setup("N", "White", 85, 37);
    design.setup("N", "White", 52, 37);
    design.setup("N", "White", 30, 37);
    design.setup("N", "White", 119, 37);
    design.setup("N", "White", 20, 37);
    design.setup("N", "White", 9, 37);
    design.setup("N", "White", 108, 37);
    design.setup("N", "White", 64, 37);
    design.setup("N", "White", 53, 37);
    design.setup("N", "White", 21, 37);
    design.setup("N", "White", 109, 37);
    design.setup("N", "White", 98, 37);
    design.setup("N", "White", 76, 37);
    design.setup("N", "White", 65, 37);
    design.setup("N", "White", 32, 37);

    design.setup("N", "Black", 110, 38);
    design.setup("N", "Black", 0, 38);
    design.setup("N", "Black", 88, 38);
    design.setup("N", "Black", 77, 38);
    design.setup("N", "Black", 66, 38);
    design.setup("N", "Black", 44, 38);
    design.setup("N", "Black", 33, 38);
    design.setup("N", "Black", 22, 38);
    design.setup("N", "Black", 78, 38);
    design.setup("N", "Black", 34, 38);
    design.setup("N", "Black", 112, 38);
    design.setup("N", "Black", 2, 38);
    design.setup("N", "Black", 90, 38);
    design.setup("N", "Black", 68, 38);
    design.setup("N", "Black", 46, 38);
    design.setup("N", "Black", 24, 38);
    design.setup("N", "Black", 113, 38);
    design.setup("N", "Black", 14, 38);
    design.setup("N", "Black", 3, 38);
    design.setup("N", "Black", 102, 38);
    design.setup("N", "Black", 58, 38);
    design.setup("N", "Black", 114, 38);
    design.setup("N", "Black", 4, 38);
    design.setup("N", "Black", 92, 38);
    design.setup("N", "Black", 70, 38);
    design.setup("N", "Black", 59, 38);
    design.setup("N", "Black", 48, 38);
    design.setup("N", "Black", 26, 38);
    design.setup("N", "Black", 82, 38);
    design.setup("N", "Black", 71, 38);
    design.setup("N", "Black", 49, 38);
    design.setup("N", "Black", 38, 38);
    design.setup("N", "Black", 116, 38);
    design.setup("N", "Black", 6, 38);
    design.setup("N", "Black", 94, 38);
    design.setup("N", "Black", 72, 38);
    design.setup("N", "Black", 61, 38);
    design.setup("N", "Black", 50, 38);
    design.setup("N", "Black", 28, 38);
    design.setup("N", "Black", 117, 38);
    design.setup("N", "Black", 18, 38);
    design.setup("N", "Black", 7, 38);
    design.setup("N", "Black", 106, 38);
    design.setup("N", "Black", 62, 38);
    design.setup("N", "Black", 118, 38);
    design.setup("N", "Black", 8, 38);
    design.setup("N", "Black", 96, 38);
    design.setup("N", "Black", 74, 38);
    design.setup("N", "Black", 52, 38);
    design.setup("N", "Black", 30, 38);
    design.setup("N", "Black", 86, 38);
    design.setup("N", "Black", 42, 38);
    design.setup("N", "Black", 120, 38);
    design.setup("N", "Black", 10, 38);
    design.setup("N", "Black", 98, 38);
    design.setup("N", "Black", 87, 38);
    design.setup("N", "Black", 76, 38);
    design.setup("N", "Black", 54, 38);
    design.setup("N", "Black", 43, 38);
    design.setup("N", "Black", 32, 38);
    design.setup("N", "White", 11, 38);
    design.setup("N", "White", 99, 38);
    design.setup("N", "White", 55, 38);
    design.setup("N", "White", 111, 38);
    design.setup("N", "White", 12, 38);
    design.setup("N", "White", 1, 38);
    design.setup("N", "White", 100, 38);
    design.setup("N", "White", 89, 38);
    design.setup("N", "White", 67, 38);
    design.setup("N", "White", 56, 38);
    design.setup("N", "White", 45, 38);
    design.setup("N", "White", 23, 38);
    design.setup("N", "White", 13, 38);
    design.setup("N", "White", 101, 38);
    design.setup("N", "White", 79, 38);
    design.setup("N", "White", 57, 38);
    design.setup("N", "White", 35, 38);
    design.setup("N", "White", 91, 38);
    design.setup("N", "White", 80, 38);
    design.setup("N", "White", 69, 38);
    design.setup("N", "White", 47, 38);
    design.setup("N", "White", 36, 38);
    design.setup("N", "White", 25, 38);
    design.setup("N", "White", 15, 38);
    design.setup("N", "White", 103, 38);
    design.setup("N", "White", 81, 38);
    design.setup("N", "White", 37, 38);
    design.setup("N", "White", 115, 38);
    design.setup("N", "White", 16, 38);
    design.setup("N", "White", 5, 38);
    design.setup("N", "White", 104, 38);
    design.setup("N", "White", 93, 38);
    design.setup("N", "White", 27, 38);
    design.setup("N", "White", 17, 38);
    design.setup("N", "White", 105, 38);
    design.setup("N", "White", 83, 38);
    design.setup("N", "White", 39, 38);
    design.setup("N", "White", 95, 38);
    design.setup("N", "White", 84, 38);
    design.setup("N", "White", 73, 38);
    design.setup("N", "White", 51, 38);
    design.setup("N", "White", 40, 38);
    design.setup("N", "White", 29, 38);
    design.setup("N", "White", 19, 38);
    design.setup("N", "White", 107, 38);
    design.setup("N", "White", 85, 38);
    design.setup("N", "White", 63, 38);
    design.setup("N", "White", 41, 38);
    design.setup("N", "White", 119, 38);
    design.setup("N", "White", 20, 38);
    design.setup("N", "White", 9, 38);
    design.setup("N", "White", 108, 38);
    design.setup("N", "White", 97, 38);
    design.setup("N", "White", 75, 38);
    design.setup("N", "White", 64, 38);
    design.setup("N", "White", 53, 38);
    design.setup("N", "White", 31, 38);
    design.setup("N", "White", 21, 38);
    design.setup("N", "White", 109, 38);
    design.setup("N", "White", 65, 38);

    design.setup("N", "Black", 110, 39);
    design.setup("N", "Black", 0, 39);
    design.setup("N", "Black", 88, 39);
    design.setup("N", "Black", 66, 39);
    design.setup("N", "Black", 44, 39);
    design.setup("N", "Black", 22, 39);
    design.setup("N", "Black", 12, 39);
    design.setup("N", "Black", 100, 39);
    design.setup("N", "Black", 78, 39);
    design.setup("N", "Black", 56, 39);
    design.setup("N", "Black", 34, 39);
    design.setup("N", "Black", 112, 39);
    design.setup("N", "Black", 2, 39);
    design.setup("N", "Black", 90, 39);
    design.setup("N", "Black", 68, 39);
    design.setup("N", "Black", 46, 39);
    design.setup("N", "Black", 24, 39);
    design.setup("N", "Black", 14, 39);
    design.setup("N", "Black", 102, 39);
    design.setup("N", "Black", 80, 39);
    design.setup("N", "Black", 58, 39);
    design.setup("N", "Black", 36, 39);
    design.setup("N", "Black", 114, 39);
    design.setup("N", "Black", 4, 39);
    design.setup("N", "Black", 92, 39);
    design.setup("N", "Black", 70, 39);
    design.setup("N", "Black", 48, 39);
    design.setup("N", "Black", 26, 39);
    design.setup("N", "Black", 16, 39);
    design.setup("N", "Black", 104, 39);
    design.setup("N", "Black", 82, 39);
    design.setup("N", "Black", 38, 39);
    design.setup("N", "Black", 116, 39);
    design.setup("N", "Black", 6, 39);
    design.setup("N", "Black", 94, 39);
    design.setup("N", "Black", 72, 39);
    design.setup("N", "Black", 50, 39);
    design.setup("N", "Black", 28, 39);
    design.setup("N", "Black", 18, 39);
    design.setup("N", "Black", 106, 39);
    design.setup("N", "Black", 84, 39);
    design.setup("N", "Black", 62, 39);
    design.setup("N", "Black", 40, 39);
    design.setup("N", "Black", 118, 39);
    design.setup("N", "Black", 8, 39);
    design.setup("N", "Black", 96, 39);
    design.setup("N", "Black", 74, 39);
    design.setup("N", "Black", 52, 39);
    design.setup("N", "Black", 30, 39);
    design.setup("N", "Black", 20, 39);
    design.setup("N", "Black", 108, 39);
    design.setup("N", "Black", 86, 39);
    design.setup("N", "Black", 64, 39);
    design.setup("N", "Black", 42, 39);
    design.setup("N", "Black", 120, 39);
    design.setup("N", "Black", 10, 39);
    design.setup("N", "Black", 98, 39);
    design.setup("N", "Black", 76, 39);
    design.setup("N", "Black", 54, 39);
    design.setup("N", "Black", 32, 39);
    design.setup("N", "White", 11, 39);
    design.setup("N", "White", 99, 39);
    design.setup("N", "White", 77, 39);
    design.setup("N", "White", 55, 39);
    design.setup("N", "White", 33, 39);
    design.setup("N", "White", 111, 39);
    design.setup("N", "White", 1, 39);
    design.setup("N", "White", 89, 39);
    design.setup("N", "White", 67, 39);
    design.setup("N", "White", 45, 39);
    design.setup("N", "White", 23, 39);
    design.setup("N", "White", 13, 39);
    design.setup("N", "White", 101, 39);
    design.setup("N", "White", 79, 39);
    design.setup("N", "White", 57, 39);
    design.setup("N", "White", 35, 39);
    design.setup("N", "White", 113, 39);
    design.setup("N", "White", 3, 39);
    design.setup("N", "White", 91, 39);
    design.setup("N", "White", 69, 39);
    design.setup("N", "White", 47, 39);
    design.setup("N", "White", 25, 39);
    design.setup("N", "White", 15, 39);
    design.setup("N", "White", 103, 39);
    design.setup("N", "White", 81, 39);
    design.setup("N", "White", 59, 39);
    design.setup("N", "White", 37, 39);
    design.setup("N", "White", 115, 39);
    design.setup("N", "White", 5, 39);
    design.setup("N", "White", 93, 39);
    design.setup("N", "White", 71, 39);
    design.setup("N", "White", 49, 39);
    design.setup("N", "White", 27, 39);
    design.setup("N", "White", 17, 39);
    design.setup("N", "White", 105, 39);
    design.setup("N", "White", 83, 39);
    design.setup("N", "White", 61, 39);
    design.setup("N", "White", 39, 39);
    design.setup("N", "White", 117, 39);
    design.setup("N", "White", 7, 39);
    design.setup("N", "White", 95, 39);
    design.setup("N", "White", 73, 39);
    design.setup("N", "White", 51, 39);
    design.setup("N", "White", 29, 39);
    design.setup("N", "White", 19, 39);
    design.setup("N", "White", 107, 39);
    design.setup("N", "White", 85, 39);
    design.setup("N", "White", 63, 39);
    design.setup("N", "White", 41, 39);
    design.setup("N", "White", 119, 39);
    design.setup("N", "White", 9, 39);
    design.setup("N", "White", 97, 39);
    design.setup("N", "White", 75, 39);
    design.setup("N", "White", 53, 39);
    design.setup("N", "White", 31, 39);
    design.setup("N", "White", 21, 39);
    design.setup("N", "White", 109, 39);
    design.setup("N", "White", 87, 39);
    design.setup("N", "White", 65, 39);
    design.setup("N", "White", 43, 39);
}

Dagaz.View.configure = function(view) {
    view.defBoard("Board");
    view.defPiece("BlueKa", "Blue Ka");
    view.defPiece("RedKa", "Red Ka");
    view.defPiece("NBlack", "N Black");
    view.defPiece("NWhite", "N White");
    view.defPiece("Ko", "Ko");
 
    view.defPosition("a11", 5, 5, 32, 32);
    view.defPosition("b11", 37, 5, 32, 32);
    view.defPosition("c11", 69, 5, 32, 32);
    view.defPosition("d11", 101, 5, 32, 32);
    view.defPosition("e11", 133, 5, 32, 32);
    view.defPosition("f11", 165, 5, 32, 32);
    view.defPosition("g11", 197, 5, 32, 32);
    view.defPosition("h11", 229, 5, 32, 32);
    view.defPosition("i11", 261, 5, 32, 32);
    view.defPosition("j11", 293, 5, 32, 32);
    view.defPosition("k11", 325, 5, 32, 32);
    view.defPosition("a10", 5, 37, 32, 32);
    view.defPosition("b10", 37, 37, 32, 32);
    view.defPosition("c10", 69, 37, 32, 32);
    view.defPosition("d10", 101, 37, 32, 32);
    view.defPosition("e10", 133, 37, 32, 32);
    view.defPosition("f10", 165, 37, 32, 32);
    view.defPosition("g10", 197, 37, 32, 32);
    view.defPosition("h10", 229, 37, 32, 32);
    view.defPosition("i10", 261, 37, 32, 32);
    view.defPosition("j10", 293, 37, 32, 32);
    view.defPosition("k10", 325, 37, 32, 32);
    view.defPosition("a9", 5, 69, 32, 32);
    view.defPosition("b9", 37, 69, 32, 32);
    view.defPosition("c9", 69, 69, 32, 32);
    view.defPosition("d9", 101, 69, 32, 32);
    view.defPosition("e9", 133, 69, 32, 32);
    view.defPosition("f9", 165, 69, 32, 32);
    view.defPosition("g9", 197, 69, 32, 32);
    view.defPosition("h9", 229, 69, 32, 32);
    view.defPosition("i9", 261, 69, 32, 32);
    view.defPosition("j9", 293, 69, 32, 32);
    view.defPosition("k9", 325, 69, 32, 32);
    view.defPosition("a8", 5, 101, 32, 32);
    view.defPosition("b8", 37, 101, 32, 32);
    view.defPosition("c8", 69, 101, 32, 32);
    view.defPosition("d8", 101, 101, 32, 32);
    view.defPosition("e8", 133, 101, 32, 32);
    view.defPosition("f8", 165, 101, 32, 32);
    view.defPosition("g8", 197, 101, 32, 32);
    view.defPosition("h8", 229, 101, 32, 32);
    view.defPosition("i8", 261, 101, 32, 32);
    view.defPosition("j8", 293, 101, 32, 32);
    view.defPosition("k8", 325, 101, 32, 32);
    view.defPosition("a7", 5, 133, 32, 32);
    view.defPosition("b7", 37, 133, 32, 32);
    view.defPosition("c7", 69, 133, 32, 32);
    view.defPosition("d7", 101, 133, 32, 32);
    view.defPosition("e7", 133, 133, 32, 32);
    view.defPosition("f7", 165, 133, 32, 32);
    view.defPosition("g7", 197, 133, 32, 32);
    view.defPosition("h7", 229, 133, 32, 32);
    view.defPosition("i7", 261, 133, 32, 32);
    view.defPosition("j7", 293, 133, 32, 32);
    view.defPosition("k7", 325, 133, 32, 32);
    view.defPosition("a6", 5, 165, 32, 32);
    view.defPosition("b6", 37, 165, 32, 32);
    view.defPosition("c6", 69, 165, 32, 32);
    view.defPosition("d6", 101, 165, 32, 32);
    view.defPosition("e6", 133, 165, 32, 32);
    view.defPosition("f6", 165, 165, 32, 32);
    view.defPosition("g6", 197, 165, 32, 32);
    view.defPosition("h6", 229, 165, 32, 32);
    view.defPosition("i6", 261, 165, 32, 32);
    view.defPosition("j6", 293, 165, 32, 32);
    view.defPosition("k6", 325, 165, 32, 32);
    view.defPosition("a5", 5, 197, 32, 32);
    view.defPosition("b5", 37, 197, 32, 32);
    view.defPosition("c5", 69, 197, 32, 32);
    view.defPosition("d5", 101, 197, 32, 32);
    view.defPosition("e5", 133, 197, 32, 32);
    view.defPosition("f5", 165, 197, 32, 32);
    view.defPosition("g5", 197, 197, 32, 32);
    view.defPosition("h5", 229, 197, 32, 32);
    view.defPosition("i5", 261, 197, 32, 32);
    view.defPosition("j5", 293, 197, 32, 32);
    view.defPosition("k5", 325, 197, 32, 32);
    view.defPosition("a4", 5, 229, 32, 32);
    view.defPosition("b4", 37, 229, 32, 32);
    view.defPosition("c4", 69, 229, 32, 32);
    view.defPosition("d4", 101, 229, 32, 32);
    view.defPosition("e4", 133, 229, 32, 32);
    view.defPosition("f4", 165, 229, 32, 32);
    view.defPosition("g4", 197, 229, 32, 32);
    view.defPosition("h4", 229, 229, 32, 32);
    view.defPosition("i4", 261, 229, 32, 32);
    view.defPosition("j4", 293, 229, 32, 32);
    view.defPosition("k4", 325, 229, 32, 32);
    view.defPosition("a3", 5, 261, 32, 32);
    view.defPosition("b3", 37, 261, 32, 32);
    view.defPosition("c3", 69, 261, 32, 32);
    view.defPosition("d3", 101, 261, 32, 32);
    view.defPosition("e3", 133, 261, 32, 32);
    view.defPosition("f3", 165, 261, 32, 32);
    view.defPosition("g3", 197, 261, 32, 32);
    view.defPosition("h3", 229, 261, 32, 32);
    view.defPosition("i3", 261, 261, 32, 32);
    view.defPosition("j3", 293, 261, 32, 32);
    view.defPosition("k3", 325, 261, 32, 32);
    view.defPosition("a2", 5, 293, 32, 32);
    view.defPosition("b2", 37, 293, 32, 32);
    view.defPosition("c2", 69, 293, 32, 32);
    view.defPosition("d2", 101, 293, 32, 32);
    view.defPosition("e2", 133, 293, 32, 32);
    view.defPosition("f2", 165, 293, 32, 32);
    view.defPosition("g2", 197, 293, 32, 32);
    view.defPosition("h2", 229, 293, 32, 32);
    view.defPosition("i2", 261, 293, 32, 32);
    view.defPosition("j2", 293, 293, 32, 32);
    view.defPosition("k2", 325, 293, 32, 32);
    view.defPosition("a1", 5, 325, 32, 32);
    view.defPosition("b1", 37, 325, 32, 32);
    view.defPosition("c1", 69, 325, 32, 32);
    view.defPosition("d1", 101, 325, 32, 32);
    view.defPosition("e1", 133, 325, 32, 32);
    view.defPosition("f1", 165, 325, 32, 32);
    view.defPosition("g1", 197, 325, 32, 32);
    view.defPosition("h1", 229, 325, 32, 32);
    view.defPosition("i1", 261, 325, 32, 32);
    view.defPosition("j1", 293, 325, 32, 32);
    view.defPosition("k1", 325, 325, 32, 32);
}
